"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.List = exports.ListDictionaryModule = exports.ListDictionaryNode = exports.Async = exports.Async$2E$StartAsNamedFuture$2E$Static = exports.Async$2E$CreateNamedFuture$2E$Static = exports.Async$2E$StartAsFuture$2E$Static = exports.Async$2E$CreateFuture$2E$Static = exports.Async$2E$Future$2E$Static = exports.Async$2E$AwaitFuture$2E$Static = exports.Http = exports.Log = exports.enabledCategories = undefined;

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _map = require("babel-runtime/core-js/map");

var _map2 = _interopRequireDefault(_map);

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _getIterator2 = require("babel-runtime/core-js/get-iterator");

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

exports.niceNumber = niceNumber;
exports.isLocalHost = isLocalHost;

var _Util = require("fable-core/umd/Util");

var _Seq = require("fable-core/umd/Seq");

var _String = require("fable-core/umd/String");

var _Set = require("fable-core/umd/Set");

var _List = require("fable-core/umd/List");

var _List2 = _interopRequireDefault(_List);

var _GenericComparer = require("fable-core/umd/GenericComparer");

var _GenericComparer2 = _interopRequireDefault(_GenericComparer);

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _Date = require("fable-core/umd/Date");

var _Async = require("fable-core/umd/Async");

var _Choice = require("fable-core/umd/Choice");

var _Choice2 = _interopRequireDefault(_Choice);

var _AsyncBuilder = require("fable-core/umd/AsyncBuilder");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function niceNumber(num, decs) {
  var str = (0, _Util.toString)(num);
  var dot = str.indexOf(".");
  var patternInput = dot === -1 ? [str, ""] : [str.substr(0, dot), str.substr(dot + 1, decs < str.length - dot - 1 ? decs : str.length - dot - 1)];
  var after = patternInput[1].length < decs ? patternInput[1] + (0, _from2.default)((0, _Seq.delay)(function () {
    return (0, _Seq.map)(function (i) {
      return "0";
    }, (0, _Seq.range)(1, decs - patternInput[1].length));
  })).join('') : patternInput[1];
  var res = patternInput[0];

  if (patternInput[0].length > 5) {
    var inputSequence = (0, _Seq.rangeStep)(patternInput[0].length - 1, -1, 0);
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = (0, _getIterator3.default)(inputSequence), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var i_1 = _step.value;
        var j = patternInput[0].length - i_1;

        if (i_1 !== 0 ? j % 3 === 0 : false) {
          res = (0, _String.insert)(res, i_1, ",");
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  }

  if ((0, _Seq.forAll)(function () {
    var x = "0";
    return function (y) {
      return x === y;
    };
  }(), after)) {
    return res;
  } else {
    return res + "." + after;
  }
}

function isLocalHost() {
  if (typeof window == 'undefined' ? true : window.location.hostname === "localhost") {
    return true;
  } else {
    return window.location.hostname === "127.0.0.1";
  }
}

var enabledCategories = exports.enabledCategories = !isLocalHost() ? (0, _Set.create)(new _List2.default(), new _GenericComparer2.default(_Util.compare)) : (0, _Set.create)((0, _List.ofArray)(["*"]), new _GenericComparer2.default(_Util.compare));

var Log = exports.Log = function () {
  function Log() {
    (0, _classCallCheck3.default)(this, Log);
  }

  (0, _createClass3.default)(Log, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Common.Log",
        properties: {}
      };
    }
  }], [{
    key: "setEnabled",
    value: function (cats) {
      exports.enabledCategories = enabledCategories = cats;
    }
  }, {
    key: "event",
    value: function (category, evt, article, data) {
      if (typeof logEvent != 'undefined') logEvent(category, evt, article, data);
    }
  }, {
    key: "message",
    value: function (level, category, msg) {
      for (var _len = arguments.length, args = Array(_len > 3 ? _len - 3 : 0), _key = 3; _key < _len; _key++) {
        args[_key - 3] = arguments[_key];
      }

      var args_1 = args == null ? [] : args;
      var category_1 = category.toLocaleUpperCase();

      if (!isLocalHost() ? level === "EXCEPTION" : false) {
        if (typeof logEvent != 'undefined') logEvent("system", "exception", "", {
          category: category_1,
          msg: msg,
          args: args_1
        });
      }

      if (((level === "EXCEPTION" ? true : level === "ERROR") ? true : enabledCategories.has("*")) ? true : enabledCategories.has(category_1)) {
        var dt = (0, _Date.now)();

        var p2 = function p2(s) {
          return (0, _String.padLeft)(String(s), 2, "0");
        };

        var p4 = function p4(s_1) {
          return (0, _String.padLeft)(String(s_1), 4, "0");
        };

        var prefix = (0, _String.fsFormat)("[%s:%s:%s:%s] %s: ")(function (x) {
          return x;
        })(p2((0, _Date.hour)(dt)))(p2((0, _Date.minute)(dt)))(p2((0, _Date.second)(dt)))(p4((0, _Date.millisecond)(dt)))(category_1);
        var color = void 0;

        switch (level) {
          case "TRACE":
            color = "color:#808080";
            break;

          case "EXCEPTION":
            color = "color:#c00000";
            break;

          case "ERROR":
            color = "color:#900000";
            break;

          default:
            color = "";
        }

        console.log.apply(console, (0, _from2.default)((0, _Seq.append)(["%c" + prefix + msg, color], args_1)));
      }
    }
  }, {
    key: "trace",
    value: function (category, msg) {
      for (var _len2 = arguments.length, args = Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
        args[_key2 - 2] = arguments[_key2];
      }

      Log.message.apply(Log, ["TRACE", category, msg].concat(args));
    }
  }, {
    key: "exn",
    value: function (category, msg) {
      for (var _len3 = arguments.length, args = Array(_len3 > 2 ? _len3 - 2 : 0), _key3 = 2; _key3 < _len3; _key3++) {
        args[_key3 - 2] = arguments[_key3];
      }

      Log.message.apply(Log, ["EXCEPTION", category, msg].concat(args));
    }
  }, {
    key: "error",
    value: function (category, msg) {
      for (var _len4 = arguments.length, args = Array(_len4 > 2 ? _len4 - 2 : 0), _key4 = 2; _key4 < _len4; _key4++) {
        args[_key4 - 2] = arguments[_key4];
      }

      Log.message.apply(Log, ["ERROR", category, msg].concat(args));
    }
  }]);
  return Log;
}();

(0, _Symbol2.setType)("TheGamma.Common.Log", Log);

var Http = exports.Http = function () {
  function Http() {
    (0, _classCallCheck3.default)(this, Http);
  }

  (0, _createClass3.default)(Http, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Common.Http",
        properties: {}
      };
    }
  }], [{
    key: "Request",
    value: function (meth, url, data, cookies) {
      return (0, _Async.fromContinuations)(function (tupledArg) {
        var xhr = new XMLHttpRequest();
        xhr.open(meth, url, true);
        var $var1 = cookies != null ? cookies !== "" ? [0, cookies] : [1] : [1];

        switch ($var1[0]) {
          case 0:
            xhr.setRequestHeader("X-Cookie", $var1[1]);
            break;

          case 1:
            break;
        }

        xhr.onreadystatechange = function (_arg1) {
          if (xhr.readyState > 3 ? xhr.status === 200 : false) {
            tupledArg[0](xhr.responseText);
          }

          if (xhr.readyState > 3 ? xhr.status === 0 : false) {
            tupledArg[1](new Error(meth + " " + url + " failed: " + xhr.statusText));
          }

          return {};
        };

        xhr.send(data != null ? data : "");
      });
    }
  }]);
  return Http;
}();

(0, _Symbol2.setType)("TheGamma.Common.Http", Http);

function Async_AwaitFuture_Static(f) {
  return (0, _Async.fromContinuations)(function (tupledArg) {
    f.Then(tupledArg[0]);
  });
}

exports.Async$2E$AwaitFuture$2E$Static = Async_AwaitFuture_Static;

function Async_Future_Static(n, op, start) {
  var res = new _Choice2.default("Choice1Of3", [null]);
  var handlers = new _List2.default();
  var running = false;

  var trigger = function trigger(h) {
    if (res.Case === "Choice2Of3") {
      var v = res.Fields[0];
      h(v);
    } else if (res.Case === "Choice3Of3") {
      var e = res.Fields[0];
      throw e;
    } else {
      handlers = new _List2.default(h, handlers);
    }
  };

  var ensureStarted = function ensureStarted() {
    if (!running) {
      (0, _Seq.iterate)(function (n_1) {
        Log.trace("system", "Starting future '%s'....", n_1);
      }, (0, _Util.defaultArg)(n, [], function (x) {
        return [x];
      }));
      running = true;

      (function (arg00) {
        (0, _Async.startImmediate)(arg00);
      })(function (builder_) {
        return builder_.Delay(function () {
          return builder_.Combine(builder_.TryWith(builder_.Delay(function () {
            return builder_.Bind(op, function (_arg1) {
              (0, _Seq.iterate)(function (n_2) {
                Log.trace("system", "Future '%s' evaluated to: %O", n_2, _arg1);
              }, (0, _Util.defaultArg)(n, [], function (x) {
                return [x];
              }));
              res = new _Choice2.default("Choice2Of3", [_arg1]);
              return builder_.Zero();
            });
          }), function (_arg2) {
            Log.exn("system", "Evaluating future failed: %O", _arg2);
            res = new _Choice2.default("Choice3Of3", [_arg2]);
            return builder_.Zero();
          }), builder_.Delay(function () {
            return builder_.For(handlers, function (_arg3) {
              trigger(_arg3);
              return builder_.Zero();
            });
          }));
        });
      }(_AsyncBuilder.singleton));
    }
  };

  if (start === true) {
    ensureStarted(null);
  }

  return (0, _defineProperty3.default)({
    Then: function (f) {
      ensureStarted(null);
      trigger(f);
    }
  }, _Symbol3.default.reflection, function () {
    return {
      interfaces: ["TheGamma.Common.Future"]
    };
  });
}

exports.Async$2E$Future$2E$Static = Async_Future_Static;

function Async_CreateFuture_Static(op) {
  return function (arg00) {
    return function (arg10) {
      return function (arg20) {
        return Async_Future_Static(arg00, arg10, arg20);
      };
    };
  }(null)(op)(false);
}

exports.Async$2E$CreateFuture$2E$Static = Async_CreateFuture_Static;

function Async_StartAsFuture_Static(op) {
  return function (arg00) {
    return function (arg10) {
      return function (arg20) {
        return Async_Future_Static(arg00, arg10, arg20);
      };
    };
  }(null)(op)(true);
}

exports.Async$2E$StartAsFuture$2E$Static = Async_StartAsFuture_Static;

function Async_CreateNamedFuture_Static(name, op) {
  return function (arg00) {
    return function (arg10) {
      return function (arg20) {
        return Async_Future_Static(arg00, arg10, arg20);
      };
    };
  }(name)(op)(false);
}

exports.Async$2E$CreateNamedFuture$2E$Static = Async_CreateNamedFuture_Static;

function Async_StartAsNamedFuture_Static(name, op) {
  return function (arg00) {
    return function (arg10) {
      return function (arg20) {
        return Async_Future_Static(arg00, arg10, arg20);
      };
    };
  }(name)(op)(true);
}

exports.Async$2E$StartAsNamedFuture$2E$Static = Async_StartAsNamedFuture_Static;

var Async = exports.Async = function (__exports) {
  var _Array = __exports.Array = function (__exports) {
    var Parallel = __exports.Parallel = function (__exports) {
      var map = __exports.map = function (f, ar) {
        return function (builder_) {
          return builder_.Delay(function () {
            var res = new Array(ar.length).fill(null);
            var work = (0, _Async.parallel)((0, _Seq.toList)((0, _Seq.delay)(function () {
              return (0, _Seq.map)(function (i) {
                return function (builder__1) {
                  return builder__1.Delay(function () {
                    return builder__1.Bind(f(ar[i]), function (_arg1) {
                      res[i] = _arg1;
                      return builder__1.Zero();
                    });
                  });
                }(_AsyncBuilder.singleton);
              }, (0, _Seq.range)(0, ar.length - 1));
            })));
            return builder_.Bind(work, function (_arg2) {
              return builder_.Return(res);
            });
          });
        }(_AsyncBuilder.singleton);
      };

      return __exports;
    }({});

    var map = __exports.map = function (f, ar) {
      return function (builder_) {
        return builder_.Delay(function () {
          var res = new Array(ar.length).fill(null);
          return builder_.Combine(builder_.For((0, _Seq.range)(0, ar.length - 1), function (_arg1) {
            return builder_.Bind(f(ar[_arg1]), function (_arg2) {
              res[_arg1] = _arg2;
              return builder_.Zero();
            });
          }), builder_.Delay(function () {
            return builder_.Return(res);
          }));
        });
      }(_AsyncBuilder.singleton);
    };

    return __exports;
  }({});

  var collect = __exports.collect = function (f, l) {
    return function (builder_) {
      return builder_.Delay(function () {
        return l.tail == null ? builder_.Return(new _List2.default()) : builder_.Bind(f(l.head), function (_arg1) {
          return builder_.Bind(collect(f, l.tail), function (_arg2) {
            return builder_.Return((0, _List.append)(_arg1, _arg2));
          });
        });
      });
    }(_AsyncBuilder.singleton);
  };

  var choose = __exports.choose = function (f, l) {
    return function (builder_) {
      return builder_.Delay(function () {
        return l.tail == null ? builder_.Return(new _List2.default()) : builder_.Bind(f(l.head), function (_arg1) {
          return builder_.Bind(choose(f, l.tail), function (_arg2) {
            return builder_.Return(_arg1 != null ? new _List2.default(_arg1, _arg2) : _arg2);
          });
        });
      });
    }(_AsyncBuilder.singleton);
  };

  var map = __exports.map = function (f, l) {
    return function (builder_) {
      return builder_.Delay(function () {
        return l.tail == null ? builder_.Return(new _List2.default()) : builder_.Bind(f(l.head), function (_arg1) {
          return builder_.Bind(map(f, l.tail), function (_arg2) {
            return builder_.Return(new _List2.default(_arg1, _arg2));
          });
        });
      });
    }(_AsyncBuilder.singleton);
  };

  var foldMap = __exports.foldMap = function (f, st, l) {
    return function (builder_) {
      return builder_.Delay(function () {
        return l.tail == null ? builder_.Return([st, new _List2.default()]) : builder_.Bind(f(st)(l.head), function (_arg1) {
          return builder_.Bind(foldMap(f, _arg1[1], l.tail), function (_arg2) {
            return builder_.Return([_arg2[0], new _List2.default(_arg1[0], _arg2[1])]);
          });
        });
      });
    }(_AsyncBuilder.singleton);
  };

  var fold = __exports.fold = function (f, st, l) {
    return function (builder_) {
      return builder_.Delay(function () {
        return l.tail == null ? builder_.Return(st) : builder_.Bind(f(st)(l.head), function (_arg1) {
          return builder_.ReturnFrom(fold(f, _arg1, l.tail));
        });
      });
    }(_AsyncBuilder.singleton);
  };

  return __exports;
}({});

var ListDictionaryNode = exports.ListDictionaryNode = function () {
  function ListDictionaryNode(result, nested) {
    (0, _classCallCheck3.default)(this, ListDictionaryNode);
    this.Result = result;
    this.Nested = nested;
  }

  (0, _createClass3.default)(ListDictionaryNode, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Common.ListDictionaryNode",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          Result: (0, _Util.Option)((0, _Util.GenericParam)("T")),
          Nested: (0, _Util.makeGeneric)(_map2.default, {
            TKey: (0, _Util.GenericParam)("K"),
            TValue: (0, _Util.makeGeneric)(ListDictionaryNode, {
              K: (0, _Util.GenericParam)("K"),
              T: (0, _Util.GenericParam)("T")
            })
          })
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }]);
  return ListDictionaryNode;
}();

(0, _Symbol2.setType)("TheGamma.Common.ListDictionaryNode", ListDictionaryNode);

var ListDictionaryModule = exports.ListDictionaryModule = function (__exports) {
  var tryFind = __exports.tryFind = function (ks, dict) {
    var loop = function loop(ks_1) {
      return function (node) {
        var _loop = function _loop() {
          var matchValue = [ks_1, node];
          var $var2 = matchValue[0].tail != null ? function () {
            var ks_2 = matchValue[0].tail;
            var k = matchValue[0].head;
            var d = matchValue[1].Nested;
            return d.has(k);
          }() ? [1, matchValue[1].Nested, matchValue[0].head, matchValue[0].tail] : [2] : matchValue[1].Result != null ? [0, matchValue[1].Result] : [2];

          switch ($var2[0]) {
            case 0:
              return {
                v: $var2[1]
              };

            case 1:
              ks_1 = $var2[3];
              node = $var2[1].get($var2[2]);
              return "continue|loop";

            case 2:
              return {
                v: null
              };
          }
        };

        loop: while (true) {
          var _ret = _loop();

          switch (_ret) {
            case "continue|loop":
              continue loop;

            default:
              if ((typeof _ret === "undefined" ? "undefined" : (0, _typeof3.default)(_ret)) === "object") return _ret.v;
          }
        }
      };
    };

    return loop(ks)(new ListDictionaryNode(null, dict));
  };

  var set = __exports.set = function (ks, v, dict) {
    var loop = function loop(ks_1) {
      return function (dict_1) {
        if (ks_1.tail != null) {
          if (!dict_1.has(ks_1.head)) {
            dict_1.set(ks_1.head, function () {
              var Nested = new _map2.default();
              return new ListDictionaryNode(null, Nested);
            }());
          }

          if (ks_1.tail.tail == null) {
            dict_1.get(ks_1.head).Result = v;
          } else {
            loop(ks_1.tail)(dict_1.get(ks_1.head).Nested);
          }
        } else {
          throw new Error("Empty key not supported");
        }
      };
    };

    loop(ks)(dict);
  };

  var count = __exports.count = function (dict) {
    var loop = function loop(node) {
      var nest = (0, _Seq.sumBy)(function (kv) {
        return loop(kv[1]);
      }, node.Nested);

      if (function () {
        return node.Result != null;
      }(null)) {
        return 1 + nest;
      } else {
        return nest;
      }
    };

    return (0, _Seq.sumBy)(function (kv_1) {
      return loop(kv_1[1]);
    }, dict);
  };

  return __exports;
}({});

var List = exports.List = function (__exports) {
  var groupWith = __exports.groupWith = function (f, list) {
    var groups = [];
    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
      for (var _iterator2 = (0, _getIterator3.default)(list), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
        var e = _step2.value;
        var added = false;
        var i = 0;

        while (!added ? i < groups.length : false) {
          if (f(e)(groups[i][0])) {
            groups[i][1].push(e);
            added = true;
          }

          i = i + 1;
        }

        if (!added) {
          groups.push([e, (0, _from2.default)((0, _List.ofArray)([e]))]);
        }
      }
    } catch (err) {
      _didIteratorError2 = true;
      _iteratorError2 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion2 && _iterator2.return) {
          _iterator2.return();
        }
      } finally {
        if (_didIteratorError2) {
          throw _iteratorError2;
        }
      }
    }

    return (0, _Seq.toList)((0, _Seq.map)(function ($var3) {
      return (0, _Seq.toList)($var3[1]);
    }, groups));
  };

  var unreduce = __exports.unreduce = function (f, s) {
    return (0, _Seq.toList)((0, _Seq.unfold)(function (s_1) {
      return (0, _Util.defaultArg)(f(s_1), null, function (v) {
        return [v, v];
      });
    }, s));
  };

  return __exports;
}({});
//# sourceMappingURL=common.js.map