"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pair = exports.number = exports.dateformat = exports.date = exports.math = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _Util = require("fable-core/umd/Util");

var _Date = require("fable-core/umd/Date");

var _common = require("./common");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var math = exports.math = function () {
  function math() {
    (0, _classCallCheck3.default)(this, math);
  }

  (0, _createClass3.default)(math, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.General.math",
        properties: {}
      };
    }
  }], [{
    key: "sqrt",
    value: function (f) {
      return Math.sqrt(f);
    }
  }, {
    key: "pow",
    value: function (f, k) {
      return Math.pow(f, k);
    }
  }, {
    key: "log",
    value: function (f, b) {
      if (b != null) {
        return Math.log(f) / Math.log(b);
      } else {
        return Math.log(f);
      }
    }
  }, {
    key: "min",
    value: function (f1, f2) {
      if (f1 < f2) {
        return f1;
      } else {
        return f2;
      }
    }
  }, {
    key: "max",
    value: function (f1, f2) {
      if (f1 > f2) {
        return f1;
      } else {
        return f2;
      }
    }
  }, {
    key: "round",
    value: function (n, decimals) {
      return (0, _Util.round)(n, decimals);
    }
  }, {
    key: "ceil",
    value: function (n) {
      return Math.ceil(n);
    }
  }, {
    key: "floor",
    value: function (n) {
      return Math.floor(n);
    }
  }]);
  return math;
}();

(0, _Symbol2.setType)("TheGamma.General.math", math);

var date = exports.date = function () {
  function date() {
    (0, _classCallCheck3.default)(this, date);
  }

  (0, _createClass3.default)(date, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.General.date",
        properties: {}
      };
    }
  }], [{
    key: "now",
    value: function () {
      return (0, _Date.now)();
    }
  }, {
    key: "date",
    value: function (year, month, day) {
      return (0, _Date.create)(year, month, day);
    }
  }, {
    key: "time",
    value: function (year, month, day, hour, minute, second) {
      return (0, _Date.create)(year, month, day, hour, minute, second);
    }
  }]);
  return date;
}();

(0, _Symbol2.setType)("TheGamma.General.date", date);

var dateformat = exports.dateformat = function () {
  function dateformat() {
    (0, _classCallCheck3.default)(this, dateformat);
  }

  (0, _createClass3.default)(dateformat, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.General.dateformat",
        properties: {}
      };
    }
  }], [{
    key: "longDate",
    value: function (dt) {
      return dt.toLocaleString("en-GB", {
        day: "numeric",
        year: "numeric",
        month: "long"
      });
    }
  }]);
  return dateformat;
}();

(0, _Symbol2.setType)("TheGamma.General.dateformat", dateformat);

var number = exports.number = function () {
  function number() {
    (0, _classCallCheck3.default)(this, number);
  }

  (0, _createClass3.default)(number, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.General.number",
        properties: {}
      };
    }
  }], [{
    key: "format",
    value: function (n, decimals) {
      return (0, _common.niceNumber)(n, decimals != null ? decimals : 999);
    }
  }]);
  return number;
}();

(0, _Symbol2.setType)("TheGamma.General.number", number);

var pair = exports.pair = function () {
  (0, _createClass3.default)(pair, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.General.pair",
        properties: {
          first: (0, _Util.GenericParam)("t1"),
          second: (0, _Util.GenericParam)("t2")
        }
      };
    }
  }]);

  function pair(v1, v2) {
    (0, _classCallCheck3.default)(this, pair);
    this.v1 = v1;
    this.v2 = v2;
  }

  (0, _createClass3.default)(pair, [{
    key: "first",
    get: function () {
      return this.v1;
    }
  }, {
    key: "second",
    get: function () {
      return this.v2;
    }
  }]);
  return pair;
}();

(0, _Symbol2.setType)("TheGamma.General.pair", pair);
//# sourceMappingURL=general.js.map