"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ChartDataOperations = exports.Helpers = exports.LazyCharting = exports.ChartData = undefined;

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

var _getIterator2 = require("babel-runtime/core-js/get-iterator");

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _Async = require("fable-core/umd/Async");

var _Async2 = _interopRequireDefault(_Async);

var _common = require("../common");

var _AsyncBuilder = require("fable-core/umd/AsyncBuilder");

var _List = require("fable-core/umd/List");

var _List2 = _interopRequireDefault(_List);

var _Seq = require("fable-core/umd/Seq");

var _Util = require("fable-core/umd/Util");

var _Map = require("fable-core/umd/Map");

var _GenericComparer = require("fable-core/umd/GenericComparer");

var _GenericComparer2 = _interopRequireDefault(_GenericComparer);

var _series = require("../series");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ChartData = exports.ChartData = function () {
  function ChartData(data) {
    (0, _classCallCheck3.default)(this, ChartData);
    this.data = data;
  }

  (0, _createClass3.default)(ChartData, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.ChartData",
        interfaces: ["FSharpRecord"],
        properties: {
          data: _Async2.default
        }
      };
    }
  }]);
  return ChartData;
}();

(0, _Symbol2.setType)("TheGamma.GoogleCharts.ChartData", ChartData);

var LazyCharting = exports.LazyCharting = function (__exports) {
  var chartsToDraw = __exports.chartsToDraw = [];
  var googleLoaded = (Object.defineProperty(__exports, 'googleLoaded', {
    get: function get() {
      return googleLoaded;
    },
    set: function set(x) {
      return googleLoaded = x;
    }
  }), false);

  var drawChartOnLoad = __exports.drawChartOnLoad = function (f) {
    if (googleLoaded) {
      f(null);
    } else {
      chartsToDraw.push(f);
    }
  };

  if (typeof google != "undefined") google.load('visualization', '1', {
    'packages': ['corechart'],
    'callback': function () {
      (function () {
        googleLoaded = true;
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = (0, _getIterator3.default)(chartsToDraw), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var f = _step.value;
            f(null);
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      })();
    }
  });
  return __exports;
}({});

var Helpers = exports.Helpers = function (__exports) {
  var copy = __exports.copy = function (o, prop) {
    if (o == null) {
      return undefined;
    } else {
      return o[prop];
    }
  };

  var orDefault = __exports.orDefault = function (newValue) {
    if (newValue != null) {
      return newValue;
    } else {
      return undefined;
    }
  };

  var right = __exports.right = function (o, prop, newValue) {
    if (newValue != null) {
      return newValue;
    } else if (o == null) {
      return undefined;
    } else {
      return o[prop];
    }
  };

  var showChart = __exports.showChart = function (chart, outputId) {
    LazyCharting.drawChartOnLoad(function () {
      (function (arg00) {
        (0, _Async.startImmediate)(arg00);
      })(function (builder_) {
        return builder_.Delay(function () {
          return builder_.TryWith(builder_.Delay(function () {
            return builder_.Bind(chart["data"].data, function (_arg1) {
              var ctor = eval("(function(a) { return new google.visualization." + chart.typeName + " (a); })");
              var ch = ctor(document.getElementById(outputId));
              if (chart.options.height == undefined) chart.options.height = 400;
              ch.draw(_arg1, chart.options);
              return builder_.Zero();
            });
          }), function (_arg2) {
            _common.Log.error("google", "Error when getting data or rendering chart: %O", _arg2);

            return builder_.Zero();
          });
        });
      }(_AsyncBuilder.singleton));
    });
  };

  return __exports;
}({});

var ChartDataOperations = exports.ChartDataOperations = function (__exports) {
  var collect = __exports.collect = function (f, l) {
    return function (builder_) {
      return builder_.Delay(function () {
        return l.tail == null ? builder_.Return(new _List2.default()) : builder_.Bind(f(l.head), function (_arg1) {
          return builder_.Bind(collect(f, l.tail), function (_arg2) {
            return builder_.Return((0, _List.append)(_arg1, _arg2));
          });
        });
      });
    }(_AsyncBuilder.singleton);
  };

  var oneKeyValue = __exports.oneKeyValue = function (keyType, v) {
    return new ChartData(function (builder_) {
      return builder_.Delay(function () {
        var data = new google.visualization.DataTable();
        data.addColumn(keyType, v.keyName);
        data.addColumn("number", v.seriesName);
        return builder_.Bind((0, _common.Async$2E$AwaitFuture$2E$Static)(v.mapPairs(function (k) {
          return function (v_1) {
            return [k, v_1];
          };
        }).data), function (_arg1) {
          (function (arg00) {
            data.addRows(arg00);
          })(_arg1.map(function (tuple) {
            return tuple[1];
          }));

          return builder_.Return(data);
        });
      });
    }(_AsyncBuilder.singleton));
  };

  var oneKeyTwoValues = __exports.oneKeyTwoValues = function (keyType, v) {
    return new ChartData(function (builder_) {
      return builder_.Delay(function () {
        var data = new google.visualization.DataTable();
        data.addColumn(keyType, v.keyName);
        data.addColumn("number", v.seriesName);
        data.addColumn("number", v.seriesName);
        return builder_.Bind((0, _common.Async$2E$AwaitFuture$2E$Static)(v.mapPairs(function (k) {
          return function (tupledArg) {
            return [k, tupledArg[0], tupledArg[1]];
          };
        }).data), function (_arg1) {
          (function (arg00) {
            data.addRows(arg00);
          })(_arg1.map(function (tuple) {
            return tuple[1];
          }));

          return builder_.Return(data);
        });
      });
    }(_AsyncBuilder.singleton));
  };

  var oneKeyAppendValues = __exports.oneKeyAppendValues = function (keyType, vs, colors) {
    return new ChartData(function (builder_) {
      return builder_.Delay(function () {
        var data = new google.visualization.DataTable();
        data.addColumn(keyType, vs[0].keyName);
        data.addColumn("number", vs[0].valueName);
        data.addColumn({
          type: "string",
          role: "style"
        });
        return builder_.Bind(collect(function (tupledArg) {
          return function (builder__1) {
            return builder__1.Delay(function () {
              return builder__1.Bind((0, _common.Async$2E$AwaitFuture$2E$Static)(tupledArg[0].mapPairs(function (k) {
                return function (v) {
                  return [k, v, tupledArg[1]];
                };
              }).data), function (_arg1) {
                return builder__1.Return((0, _List.ofArray)(_arg1.map(function (tuple) {
                  return tuple[1];
                })));
              });
            });
          }(_AsyncBuilder.singleton);
        }, (0, _List.ofArray)((0, _from2.default)((0, _Seq.zip)(vs, colors)))), function (_arg2) {
          (function (arg00) {
            data.addRows(arg00);
          })((0, _from2.default)((0, _Seq.toList)((0, _Seq.sortWith)(function (x, y) {
            return -(0, _Util.compare)(function (tupledArg_2) {
              return tupledArg_2[1];
            }(x), function (tupledArg_2) {
              return tupledArg_2[1];
            }(y));
          }, _arg2))).map(function (tupledArg_1) {
            return [tupledArg_1[0], tupledArg_1[1], tupledArg_1[2]];
          }));

          return builder_.Return(data);
        });
      });
    }(_AsyncBuilder.singleton));
  };

  var oneKeyNValues = __exports.oneKeyNValues = function (keyType, v) {
    return new ChartData(function (builder_) {
      return builder_.Delay(function () {
        var data = new google.visualization.DataTable();
        return builder_.Bind((0, _common.Async$2E$AwaitFuture$2E$Static)(v.data), function (_arg1) {
          var v_1 = _arg1.map(function (tuple) {
            return tuple[1];
          });

          data.addColumn(keyType, v_1[0].keyName);
          return builder_.Combine(builder_.For((0, _Seq.range)(0, v_1.length - 1), function (_arg2) {
            data.addColumn("number", v_1[_arg2].seriesName);
            return builder_.Zero();
          }), builder_.Delay(function () {
            var head = v_1[0].map(function (v_2) {
              return (0, _Map.create)((0, _List.ofArray)([[0, v_2]]), new _GenericComparer2.default(_Util.compare));
            });
            var tail = (0, _from2.default)((0, _Seq.mapIndexed)(function (i, v_3) {
              return [i + 1, v_3];
            }, _series.SeriesInternals.slice(1, v_1.length - 1, v_1)));
            var all = (0, _Seq.fold)(function (s1, tupledArg) {
              return s1.joinOuter(tupledArg[1]).map(function (tupledArg_1) {
                var matchValue = [(0, _Util.defaultArg)(tupledArg_1[0], (0, _Map.create)(null, new _GenericComparer2.default(_Util.compare))), tupledArg_1[1]];

                if (matchValue[1] == null) {
                  return matchValue[0];
                } else {
                  var r = matchValue[1];
                  return (0, _Map.add)(tupledArg[0], r, matchValue[0]);
                }
              });
            }, head, tail);
            return builder_.Bind((0, _common.Async$2E$AwaitFuture$2E$Static)(all.mapPairs(function (k) {
              return function (vals) {
                var data_1 = (0, _from2.default)((0, _Seq.initialize)(v_1.length, function (i_1) {
                  return (0, _Util.defaultArg)((0, _Map.tryFind)(i_1, vals), undefined);
                }));
                return (0, _from2.default)((0, _Seq.append)([k], data_1));
              };
            }).data), function (_arg3) {
              (function (arg00) {
                data.addRows(arg00);
              })(_arg3.map(function (tuple_1) {
                return tuple_1[1];
              }));

              return builder_.Return(data);
            });
          }));
        });
      });
    }(_AsyncBuilder.singleton));
  };

  var twoValues = __exports.twoValues = function (v1, v2) {
    return new ChartData(function (builder_) {
      return builder_.Delay(function () {
        var data = new google.visualization.DataTable();
        data.addColumn("number", v1.seriesName);
        data.addColumn("number", v2.seriesName);
        return builder_.Bind((0, _common.Async$2E$AwaitFuture$2E$Static)(v1.joinInner(v2).map(function (v) {
          return [v.first, v.second];
        }).data), function (_arg1) {
          (function (arg00) {
            data.addRows(arg00);
          })(_arg1.map(function (tuple) {
            return tuple[1];
          }));

          return builder_.Return(data);
        });
      });
    }(_AsyncBuilder.singleton));
  };

  return __exports;
}({});
//# sourceMappingURL=core.js.map