"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.s = exports.h = exports.El = exports.counter = exports.DomNode = exports.DomAttribute = undefined;

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _getIterator2 = require("babel-runtime/core-js/get-iterator");

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

exports.createTree = createTree;
exports.renderVirtual = renderVirtual;
exports.render = render;
exports.renderTo = renderTo;
exports.createVirtualDomAsyncApp = createVirtualDomAsyncApp;
exports.createVirtualDomApp = createVirtualDomApp;
exports.text = text;
exports.op_EqualsGreater = op_EqualsGreater;
exports.op_EqualsBangGreater = op_EqualsBangGreater;

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _Util = require("fable-core/umd/Util");

var _List = require("fable-core/umd/List");

var _List2 = _interopRequireDefault(_List);

var _Seq = require("fable-core/umd/Seq");

var _virtualDom = require("virtual-dom");

var _String = require("fable-core/umd/String");

var _common = require("./common");

var _Event2 = require("fable-core/umd/Event");

var _Event3 = _interopRequireDefault(_Event2);

var _Async = require("fable-core/umd/Async");

var _AsyncBuilder = require("fable-core/umd/AsyncBuilder");

var _Observable = require("fable-core/umd/Observable");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DomAttribute = exports.DomAttribute = function () {
  function DomAttribute(caseName, fields) {
    (0, _classCallCheck3.default)(this, DomAttribute);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(DomAttribute, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Html.DomAttribute",
        interfaces: ["FSharpUnion"],
        cases: {
          Attribute: ["string"],
          Event: ["function"],
          Property: [_Util.Any]
        }
      };
    }
  }]);
  return DomAttribute;
}();

(0, _Symbol2.setType)("TheGamma.Html.DomAttribute", DomAttribute);

var DomNode = exports.DomNode = function () {
  function DomNode(caseName, fields) {
    (0, _classCallCheck3.default)(this, DomNode);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(DomNode, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Html.DomNode",
        interfaces: ["FSharpUnion"],
        cases: {
          Delayed: ["string", DomNode, "function"],
          Element: ["string", "string", (0, _Util.Array)((0, _Util.Tuple)(["string", DomAttribute])), (0, _Util.Array)(DomNode), (0, _Util.Option)("function")],
          Part: ["function"],
          Text: ["string"]
        }
      };
    }
  }]);
  return DomNode;
}();

(0, _Symbol2.setType)("TheGamma.Html.DomNode", DomNode);

function createTree(ns, tag, args, children) {
  var attrs = [];
  var props = [];
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = (0, _getIterator3.default)(args), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var forLoopVar = _step.value;
      var matchValue = [forLoopVar[0], forLoopVar[1]];

      if (matchValue[1].Case === "Property") {
        var o = matchValue[1].Fields[0];
        props.push([matchValue[0], o]);
      } else if (matchValue[1].Case === "Event") {
        (function () {
          var f = matchValue[1].Fields[0];
          props.push(["on" + matchValue[0], function (o_1) {
            f(o_1["target"])(o_1);
          }]);
        })();
      } else {
        var v = matchValue[1].Fields[0];
        attrs.push([matchValue[0], v]);
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  var attrs_1 = (0, _Util.createObj)(attrs);
  var ns_1 = (ns == null ? true : ns === "") ? new _List2.default() : (0, _List.ofArray)([["namespace", ns]]);
  var props_1 = (0, _Util.createObj)((0, _Seq.append)((0, _List.append)(ns_1, (0, _List.ofArray)([["attributes", attrs_1]])), props));
  var elem = (0, _virtualDom.h)(tag, props_1, children);
  return elem;
}

var counter = exports.counter = 0;

function renderVirtual(node) {
  if (node.Case === "Element") {
    if (node.Fields[4] == null) {
      return createTree(node.Fields[0], node.Fields[1], node.Fields[2], node.Fields[3].map(function (node_1) {
        return renderVirtual(node_1);
      }));
    } else {
      throw new Error("renderVirtual: Does not support elements with after-render handlers");
    }
  } else if (node.Case === "Delayed") {
    exports.counter = counter = counter + 1;
    var id = (0, _String.fsFormat)("delayed_%d")(function (x) {
      return x;
    })(counter);

    var waitForAdded = function waitForAdded(n) {
      return function (el) {
        if (el.parentElement != null) {
          el.dataset.renderedSymbol = node.Fields[0];
          el.id = id;
          node.Fields[2](id);
        } else if (n > 0) {
          window.setTimeout(function () {
            waitForAdded(n - 1)(el);
          }, 1);
        } else {
          _common.Log.error("html", "Delayed element was not created in time");
        }
      };
    };

    var Hook = function Hook() {};

    Hook.prototype.hook = function (node_2, propertyName, previousValue) {
      if (node_2.dataset.renderedSymbol !== node.Fields[0]) {
        waitForAdded(10)(node_2);
      }
    };

    var _h = new Hook();

    return createTree(null, "div", (0, _List.ofArray)([["renderhk", new DomAttribute("Property", [_h])]]), [renderVirtual(node.Fields[1])]);
  } else if (node.Case === "Part") {
    throw new Error("renderVirtual: Does not support parts");
  } else {
    return node.Fields[0];
  }
}

function render(node) {
  if (node.Case === "Delayed") {
    exports.counter = counter = counter + 1;
    var el = document.createElement("div");
    el.id = (0, _String.fsFormat)("delayed_%d")(function (x) {
      return x;
    })(counter);
    return [el, function () {
      node.Fields[2](el.id);
    }];
  } else if (node.Case === "Part") {
    var el_1 = document.createElement("div");
    return [el_1, function () {
      node.Fields[0](el_1);
    }];
  } else if (node.Case === "Element") {
    var _ret2 = function () {
      var el_2 = (node.Fields[0] == null ? true : node.Fields[0] === "") ? document.createElement(node.Fields[1]) : document.createElementNS(node.Fields[0], node.Fields[1]);
      var rc = node.Fields[3].map(function (node_1) {
        return render(node_1);
      });

      for (var idx = 0; idx <= rc.length - 1; idx++) {
        var forLoopVar = rc[idx];
        el_2.appendChild(forLoopVar[0]);
      }

      var _loop = function _loop(idx_1) {
        var forLoopVar_1 = node.Fields[2][idx_1];

        if (forLoopVar_1[1].Case === "Attribute") {
          el_2.setAttribute(forLoopVar_1[0], forLoopVar_1[1].Fields[0]);
        } else if (forLoopVar_1[1].Case === "Event") {
          el_2.addEventListener(forLoopVar_1[0], function (delegateArg0) {
            forLoopVar_1[1].Fields[0](el_2)(delegateArg0);
          });
        } else {
          el_2[forLoopVar_1[0]] = forLoopVar_1[1].Fields[0];
        }
      };

      for (var idx_1 = 0; idx_1 <= node.Fields[2].length - 1; idx_1++) {
        _loop(idx_1);
      }

      var onRender = function onRender() {
        for (var idx_2 = 0; idx_2 <= rc.length - 1; idx_2++) {
          var forLoopVar_2 = rc[idx_2];
          forLoopVar_2[1](null);
        }

        (0, _Seq.iterate)(function (f) {
          f(el_2);
        }, (0, _Util.defaultArg)(node.Fields[4], [], function (x) {
          return [x];
        }));
      };

      return {
        v: [el_2, onRender]
      };
    }();

    if ((typeof _ret2 === "undefined" ? "undefined" : (0, _typeof3.default)(_ret2)) === "object") return _ret2.v;
  } else {
    return [document.createTextNode(node.Fields[0]), function () {}];
  }
}

function renderTo(node, dom) {
  while (node.lastChild != null) {
    node.removeChild(node.lastChild);
  }

  var patternInput = render(dom);
  node.appendChild(patternInput[0]);
  patternInput[1](null);
}

function createVirtualDomAsyncApp(id, initial, r, u) {
  var event = new _Event3.default();

  var trigger = function trigger(e) {
    event.Trigger(e);
  };

  var container = document.createElement("div");
  document.getElementById(id).innerHTML = "";
  document.getElementById(id).appendChild(container);
  var tree = {};
  var state = initial;

  var handleEvent = function handleEvent(evt) {
    (function (arg00) {
      (0, _Async.startImmediate)(arg00);
    })(function (builder_) {
      return builder_.Delay(function () {
        return builder_.Combine(evt != null ? builder_.Bind(u(state)(evt), function (_arg1) {
          state = _arg1;
          return builder_.Zero();
        }) : function () {
          return builder_.Zero();
        }(), builder_.Delay(function () {
          var newTree = renderVirtual(r(trigger)(state));
          var patches = (0, _virtualDom.diff)(tree, newTree);
          container = (0, _virtualDom.patch)(container, patches);
          tree = newTree;
          return builder_.Zero();
        }));
      });
    }(_AsyncBuilder.singleton));
  };

  handleEvent(null);
  (0, _Observable.add)(function ($var26) {
    return handleEvent(function (arg0) {
      return arg0;
    }($var26));
  }, event.Publish);
}

function createVirtualDomApp(id, initial, r, u) {
  var event = new _Event3.default();

  var trigger = function trigger(e) {
    event.Trigger(e);
  };

  var container = document.createElement("div");
  document.getElementById(id).innerHTML = "";
  document.getElementById(id).appendChild(container);
  var tree = {};
  var state = initial;

  var handleEvent = function handleEvent(evt) {
    if (evt != null) {
      state = u(state)(evt);
    } else {
      state = state;
    }

    var newTree = renderVirtual(r(trigger)(state));
    var patches = (0, _virtualDom.diff)(tree, newTree);
    container = (0, _virtualDom.patch)(container, patches);
    tree = newTree;
  };

  handleEvent(null);
  (0, _Observable.add)(function ($var27) {
    return handleEvent(function (arg0) {
      return arg0;
    }($var27));
  }, event.Publish);
}

function text(s) {
  return new DomNode("Text", [s]);
}

function op_EqualsGreater(k, v) {
  return [k, new DomAttribute("Attribute", [v])];
}

function op_EqualsBangGreater(k, f) {
  return [k, new DomAttribute("Event", [f])];
}

var El = exports.El = function () {
  (0, _createClass3.default)(El, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Html.El",
        properties: {
          Namespace: "string"
        }
      };
    }
  }]);

  function El(ns) {
    (0, _classCallCheck3.default)(this, El);
    this.ns = ns;
  }

  (0, _createClass3.default)(El, [{
    key: "delayed",
    value: function (sym, body, f) {
      return new DomNode("Delayed", [sym, body, f]);
    }
  }, {
    key: "part",
    value: function (initial, fold) {
      var evt = new _Event3.default();
      var state = initial;
      var container = null;
      var renderer = null;

      var render_1 = function render_1() {
        var matchValue = [container, renderer];
        var $var28 = matchValue[0] != null ? matchValue[1] != null ? [0, matchValue[0], matchValue[1]] : [1] : [1];

        switch ($var28[0]) {
          case 0:
            (function (dom) {
              renderTo($var28[1], dom);
            })($var28[2](state));

            break;

          case 1:
            break;
        }
      };

      (0, _Observable.add)(function (e) {
        state = fold(state)(e);
        render_1(null);
      }, evt.Publish);
      return [function (arg00) {
        evt.Trigger(arg00);
      }, function (r) {
        renderer = r;
        return new DomNode("Part", [function (el) {
          container = el;
          render_1(null);
        }]);
      }];
    }
  }, {
    key: "Namespace",
    get: function () {
      return this.ns;
    }
  }], [{
    key: "op_Dynamic",
    value: function (el, n) {
      return function (a) {
        return function (b) {
          var patternInput = n !== "chosen" ? [n, null] : ["select", function (el_1) {
            jQuery(el_1).chosen();
            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {
              for (var _iterator2 = (0, _getIterator3.default)(a), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                var forLoopVar = _step2.value;

                if (forLoopVar[1].Case === "Event") {
                  jQuery(el_1).on(forLoopVar[0], function () {
                    forLoopVar[1].Fields[0](el_1)(event);
                  });
                }
              }
            } catch (err) {
              _didIteratorError2 = true;
              _iteratorError2 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }
              } finally {
                if (_didIteratorError2) {
                  throw _iteratorError2;
                }
              }
            }
          }];
          return new DomNode("Element", [el.Namespace, patternInput[0], (0, _from2.default)(a), (0, _from2.default)(b), patternInput[1]]);
        };
      };
    }
  }]);
  return El;
}();

(0, _Symbol2.setType)("TheGamma.Html.El", El);
var h = exports.h = new El(null);
var s = exports.s = new El("http://www.w3.org/2000/svg");
//# sourceMappingURL=html.js.map