"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BindingResult = exports.BindingContext = undefined;

var _symbol = require("babel-runtime/core-js/symbol");

var _symbol2 = _interopRequireDefault(_symbol);

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

var _getIterator2 = require("babel-runtime/core-js/get-iterator");

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _map = require("babel-runtime/core-js/map");

var _map2 = _interopRequireDefault(_map);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

exports.bindEntity = bindEntity;
exports.setEntity = setEntity;
exports.bindExpression = bindExpression;
exports.bindCommand = bindCommand;
exports.bindProgram = bindProgram;
exports.createContext = createContext;

var _Symbol3 = require("fable-core/umd/Symbol");

var _Symbol4 = _interopRequireDefault(_Symbol3);

var _Util = require("fable-core/umd/Util");

var _Map3 = require("fable-core/umd/Map");

var _Map4 = _interopRequireDefault(_Map3);

var _ast = require("../ast/ast");

var _common = require("../../libraries/common");

var _astops = require("../ast/astops");

var _List = require("fable-core/umd/List");

var _List2 = _interopRequireDefault(_List);

var _GenericComparer = require("fable-core/umd/GenericComparer");

var _GenericComparer2 = _interopRequireDefault(_GenericComparer);

var _Choice = require("fable-core/umd/Choice");

var _Choice2 = _interopRequireDefault(_Choice);

var _Seq = require("fable-core/umd/Seq");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BindingContext = exports.BindingContext = function () {
  function BindingContext(variables, globalValues, root, callSite, chain, table, bound) {
    (0, _classCallCheck3.default)(this, BindingContext);
    this.Variables = variables;
    this.GlobalValues = globalValues;
    this.Root = root;
    this.CallSite = callSite;
    this.Chain = chain;
    this.Table = table;
    this.Bound = bound;
  }

  (0, _createClass3.default)(BindingContext, [{
    key: _Symbol4.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Binder.BindingContext",
        interfaces: ["FSharpRecord"],
        properties: {
          Variables: (0, _Util.makeGeneric)(_Map4.default, {
            Key: _ast.Name,
            Value: _ast.Entity
          }),
          GlobalValues: (0, _Util.makeGeneric)(_Map4.default, {
            Key: _ast.Name,
            Value: _ast.Entity
          }),
          Root: _ast.Entity,
          CallSite: (0, _Util.Option)(_ast.Entity),
          Chain: (0, _Util.Option)(_ast.Entity),
          Table: (0, _Util.makeGeneric)(_map2.default, {
            TKey: (0, _Util.Interface)("TheGamma.Common.Symbol"),
            TValue: (0, _Util.makeGeneric)(_common.ListDictionaryNode, {
              K: (0, _Util.Interface)("TheGamma.Common.Symbol"),
              T: (0, _Util.makeGeneric)(_Map4.default, {
                Key: (0, _Util.Tuple)(["number", "string"]),
                Value: _ast.Entity
              })
            })
          }),
          Bound: (0, _Util.Array)((0, _Util.Tuple)([_ast.Range, _ast.Entity]))
        }
      };
    }
  }]);
  return BindingContext;
}();

(0, _Symbol3.setType)("TheGamma.Binder.BindingContext", BindingContext);

var BindingResult = exports.BindingResult = function () {
  (0, _createClass3.default)(BindingResult, [{
    key: _Symbol4.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Binder.BindingResult",
        properties: {
          Entities: (0, _Util.Array)((0, _Util.Tuple)([_ast.Range, _ast.Entity]))
        }
      };
    }
  }]);

  function BindingResult(ents) {
    (0, _classCallCheck3.default)(this, BindingResult);
    this.ents = ents;
    var res = new _map2.default();

    var add = function add(a) {
      return function (e) {
        if (!res.has(a)) {
          res.set(a, []);
        }

        res.get(a).push(e);
      };
    };

    var arr = this.ents;

    for (var idx = 0; idx <= arr.length - 1; idx++) {
      var forLoopVar = arr[idx];

      var inputSequence = _astops.Entity$2E$get_Antecedents.bind(forLoopVar[1])();

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = (0, _getIterator3.default)(inputSequence), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var a_1 = _step.value;
          add(a_1.Symbol)(forLoopVar[1]);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }

    this.childrenLookup = res;
  }

  (0, _createClass3.default)(BindingResult, [{
    key: "GetChildren",
    value: function (ent) {
      var matchValue = (0, _Map3.tryGetValue)(this.childrenLookup, ent.Symbol, null);

      if (matchValue[0]) {
        return (0, _from2.default)(matchValue[1]);
      } else {
        return [];
      }
    }
  }, {
    key: "Entities",
    get: function () {
      return this.ents;
    }
  }]);
  return BindingResult;
}();

(0, _Symbol3.setType)("TheGamma.Binder.BindingResult", BindingResult);

function bindEntity(ctx, kind) {
  var patternInput = (0, _astops.entityCodeNameAndAntecedents)(kind);
  var symbols = (0, _List.map)(function (a) {
    return a.Symbol;
  }, new _List2.default(ctx.Root, patternInput[1]));
  var nestedDict = void 0;

  var matchValue = _common.ListDictionaryModule.tryFind(symbols, ctx.Table);

  if (matchValue != null) {
    nestedDict = matchValue;
  } else {
    nestedDict = (0, _Map3.create)(null, new _GenericComparer2.default(_Util.compare));
  }

  if (nestedDict.has([patternInput[0], patternInput[2]])) {
    _common.Log.trace("binder", "Cached: binding %s %s", (0, _astops.formatEntityKind)(kind), patternInput[2]);

    return nestedDict.get([patternInput[0], patternInput[2]]);
  } else {
    _common.Log.trace("binder", "New: binding %s %s", (0, _astops.formatEntityKind)(kind), patternInput[2]);

    var symbol = (0, _symbol2.default)();
    var entity = void 0;
    var Type = null;
    var Errors = new _List2.default();
    var Meta = new _List2.default();
    entity = new _ast.Entity(kind, symbol, null, Meta, Type, Errors);

    _common.ListDictionaryModule.set(symbols, (0, _Map3.add)([patternInput[0], patternInput[2]], entity, nestedDict), ctx.Table);

    return entity;
  }
}

function setEntity(ctx, node, entity) {
  ctx.Bound.push([node.Range, entity]);
  node.Entity = entity;
  return entity;
}

function bindExpression(ctx, node) {
  var bindCallArgExpression = function bindCallArgExpression(site) {
    return function (ctx_1) {
      var ctx_2 = void 0;
      var CallSite = site;
      var Chain = null;
      ctx_2 = new BindingContext(ctx_1.Variables, ctx_1.GlobalValues, ctx_1.Root, CallSite, Chain, ctx_1.Table, ctx_1.Bound);
      return function (node_1) {
        return bindExpression(ctx_2, node_1);
      };
    };
  };

  var bindMemberExpression = function bindMemberExpression(chain) {
    return function (ctx_3) {
      var ctx_4 = void 0;
      var CallSite_1 = null;
      var Chain_1 = chain;
      ctx_4 = new BindingContext(ctx_3.Variables, ctx_3.GlobalValues, ctx_3.Root, CallSite_1, Chain_1, ctx_3.Table, ctx_3.Bound);
      return function (node_2) {
        return bindExpression(ctx_4, node_2);
      };
    };
  };

  var bindPlaceExpression = function bindPlaceExpression(ctx_5) {
    var ctx_6 = void 0;
    var CallSite_2 = null;
    ctx_6 = new BindingContext(ctx_5.Variables, ctx_5.GlobalValues, ctx_5.Root, CallSite_2, ctx_5.Chain, ctx_5.Table, ctx_5.Bound);
    return function (node_3) {
      return bindExpression(ctx_6, node_3);
    };
  };

  var bindExpression_1 = function bindExpression_1(ctx_7) {
    var ctx_8 = void 0;
    var CallSite_3 = null;
    var Chain_2 = null;
    ctx_8 = new BindingContext(ctx_7.Variables, ctx_7.GlobalValues, ctx_7.Root, CallSite_3, Chain_2, ctx_7.Table, ctx_7.Bound);
    return function (node_4) {
      return bindExpression(ctx_8, node_4);
    };
  };

  if (node.Node.Case === "Variable") {
    if (ctx.Chain != null) {
      var memberName = function (entity) {
        return setEntity(ctx, node.Node.Fields[0], entity);
      }(bindEntity(ctx, new _ast.EntityKind("MemberName", [node.Node.Fields[0].Node])));

      return function (entity_1) {
        return setEntity(ctx, node, entity_1);
      }(bindEntity(ctx, new _ast.EntityKind("Member", [ctx.Chain, memberName])));
    } else {
      var matchValue = (0, _Map3.tryFind)(node.Node.Fields[0].Node, ctx.Variables);

      if (matchValue != null) {
        return function (entity_2) {
          return setEntity(ctx, node, entity_2);
        }(bindEntity(ctx, new _ast.EntityKind("Variable", [node.Node.Fields[0].Node, matchValue])));
      } else {
        var matchValue_1 = (0, _Map3.tryFind)(node.Node.Fields[0].Node, ctx.GlobalValues);

        if (matchValue_1 != null) {
          return function (entity_3) {
            return setEntity(ctx, node, entity_3);
          }(matchValue_1);
        } else {
          return function (entity_4) {
            return setEntity(ctx, node, entity_4);
          }(bindEntity(ctx, new _ast.EntityKind("GlobalValue", [node.Node.Fields[0].Node, null])));
        }
      }
    }
  } else if (node.Node.Case === "Call") {
    var inst = bindExpression_1(ctx)(node.Node.Fields[0]);

    var site_1 = function site_1(arg) {
      return bindEntity(ctx, new _ast.EntityKind("CallSite", [inst, arg]));
    };

    var args = (0, _List.mapIndexed)(function (idx, arg_1) {
      var site_2 = site_1(arg_1.Name != null ? new _Choice2.default("Choice1Of2", [arg_1.Name.Node.Name]) : new _Choice2.default("Choice2Of2", [idx]));
      var expr = bindCallArgExpression(site_2)(ctx)(arg_1.Value);

      if (arg_1.Name == null) {
        return expr;
      } else {
        return function (entity_5) {
          return setEntity(ctx, arg_1.Name, entity_5);
        }(bindEntity(ctx, new _ast.EntityKind("NamedParam", [arg_1.Name.Node, expr])));
      }
    }, node.Node.Fields[1].Node);

    var args_1 = function (entity_6) {
      return setEntity(ctx, node.Node.Fields[1], entity_6);
    }(bindEntity(ctx, new _ast.EntityKind("ArgumentList", [args])));

    return function (entity_7) {
      return setEntity(ctx, node, entity_7);
    }(bindEntity(ctx, new _ast.EntityKind("Call", [inst, args_1])));
  } else if (node.Node.Case === "Member") {
    var instEnt = bindExpression_1(ctx)(node.Node.Fields[0]);
    var memEnt = bindMemberExpression(instEnt)(ctx)(node.Node.Fields[1]);
    return function (entity_8) {
      return setEntity(ctx, node, entity_8);
    }(bindEntity(ctx, new _ast.EntityKind("MemberAccess", [memEnt])));
  } else if (node.Node.Case === "Binary") {
    var lEnt = bindExpression_1(ctx)(node.Node.Fields[0]);
    var rEnt = bindExpression_1(ctx)(node.Node.Fields[2]);
    return function (entity_9) {
      return setEntity(ctx, node, entity_9);
    }(bindEntity(ctx, new _ast.EntityKind("Operator", [lEnt, node.Node.Fields[1].Node, rEnt])));
  } else if (node.Node.Case === "List") {
    var elEnts = (0, _List.map)(bindExpression_1(ctx), node.Node.Fields[0]);
    return function (entity_10) {
      return setEntity(ctx, node, entity_10);
    }(bindEntity(ctx, new _ast.EntityKind("List", [elEnts])));
  } else if (node.Node.Case === "Function") {
    var callSite = void 0;

    if (ctx.CallSite == null) {
      throw new Error("bindExpression: Function missing call site");
    } else {
      callSite = ctx.CallSite;
    }

    var varEnt = function (entity_11) {
      return setEntity(ctx, node.Node.Fields[0], entity_11);
    }(bindEntity(ctx, new _ast.EntityKind("Binding", [node.Node.Fields[0].Node, callSite])));

    var bodyEnt = bindExpression_1(new BindingContext((0, _Map3.add)(node.Node.Fields[0].Node, varEnt, ctx.Variables), ctx.GlobalValues, ctx.Root, ctx.CallSite, ctx.Chain, ctx.Table, ctx.Bound))(node.Node.Fields[1]);
    return function (entity_12) {
      return setEntity(ctx, node, entity_12);
    }(bindEntity(ctx, new _ast.EntityKind("Function", [varEnt, bodyEnt])));
  } else if (node.Node.Case === "Boolean") {
    return function (entity_13) {
      return setEntity(ctx, node, entity_13);
    }(bindEntity(ctx, new _ast.EntityKind("Constant", [new _ast.Constant("Boolean", [node.Node.Fields[0]])])));
  } else if (node.Node.Case === "String") {
    return function (entity_14) {
      return setEntity(ctx, node, entity_14);
    }(bindEntity(ctx, new _ast.EntityKind("Constant", [new _ast.Constant("String", [node.Node.Fields[0]])])));
  } else if (node.Node.Case === "Number") {
    return function (entity_15) {
      return setEntity(ctx, node, entity_15);
    }(bindEntity(ctx, new _ast.EntityKind("Constant", [new _ast.Constant("Number", [node.Node.Fields[0]])])));
  } else if (node.Node.Case === "Empty") {
    return function (entity_16) {
      return setEntity(ctx, node, entity_16);
    }(bindEntity(ctx, new _ast.EntityKind("Constant", [new _ast.Constant("Empty", [])])));
  } else {
    var bodyEnt_1 = bindPlaceExpression(ctx)(node.Node.Fields[1]);

    (function (entity_17) {
      return setEntity(ctx, node, entity_17);
    })(bindEntity(ctx, new _ast.EntityKind("Placeholder", [node.Node.Fields[0].Node, bodyEnt_1])));

    return bodyEnt_1;
  }
}

function bindCommand(ctx, node) {
  if (node.Node.Case === "Expr") {
    var body = bindExpression(ctx, node.Node.Fields[0]);

    var node_1 = function (entity) {
      return setEntity(ctx, node, entity);
    }(bindEntity(ctx, new _ast.EntityKind("RunCommand", [body])));

    return [ctx, node_1];
  } else {
    var body_1 = bindExpression(ctx, node.Node.Fields[1]);

    var _var = function (entity_1) {
      return setEntity(ctx, node.Node.Fields[0], entity_1);
    }(bindEntity(ctx, new _ast.EntityKind("Variable", [node.Node.Fields[0].Node, body_1])));

    var node_2 = function (entity_2) {
      return setEntity(ctx, node, entity_2);
    }(bindEntity(ctx, new _ast.EntityKind("LetCommand", [_var, body_1])));

    return [new BindingContext((0, _Map3.add)(node.Node.Fields[0].Node, _var, ctx.Variables), ctx.GlobalValues, ctx.Root, ctx.CallSite, ctx.Chain, ctx.Table, ctx.Bound), node_2];
  }
}

function bindProgram(ctx, program) {
  ctx.Bound.splice(0);
  var patternInput_1 = (0, _Seq.fold)(function (tupledArg, cmd) {
    var patternInput = bindCommand(tupledArg[0], cmd);
    return [patternInput[0], new _List2.default(patternInput[1], tupledArg[1])];
  }, [ctx, new _List2.default()], program.Body.Node);
  return [function (entity) {
    return setEntity(ctx, program.Body, entity);
  }(bindEntity(ctx, new _ast.EntityKind("Program", [patternInput_1[1]]))), new BindingResult((0, _from2.default)(ctx.Bound))];
}

function createContext(globals, name) {
  var root = void 0;
  var Kind = new _ast.EntityKind("Root", []);
  var Errors = new _List2.default();

  var _Symbol = (0, _symbol2.default)();

  var Type = null;
  var Meta = new _List2.default();
  root = new _ast.Entity(Kind, _Symbol, null, Meta, Type, Errors);
  var Table = new _map2.default();
  var Bound = [];
  return new BindingContext((0, _Map3.create)(null, new _GenericComparer2.default(function (x, y) {
    return x.CompareTo(y);
  })), (0, _Map3.create)((0, _Seq.toList)((0, _Seq.delay)(function () {
    return (0, _Seq.map)(function (e) {
      return [new _ast.Name(_astops.Entity$2E$get_Name.bind(e)()), e];
    }, globals);
  })), new _GenericComparer2.default(function (x, y) {
    return x.CompareTo(y);
  })), root, null, null, Table, Bound);
}
//# sourceMappingURL=binder.js.map