"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Expr = exports.Command = exports.Program = exports.Argument = exports.Node = exports.EntityValue = exports.Entity = exports.EntityKind = exports.Constant = exports.Name = exports.Type = exports.MethodArgument = exports.PrimitiveType = exports.Member = exports.Documentation = exports.Metadata = exports.Emitter = exports.Token = exports.TokenKind = exports.Operator = exports.Error = exports.Range = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _Util = require("fable-core/umd/Util");

var _List = require("fable-core/umd/List");

var _List2 = _interopRequireDefault(_List);

var _Choice = require("fable-core/umd/Choice");

var _Choice2 = _interopRequireDefault(_Choice);

var _babel = require("../common/babel");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _Range = function () {
  function _Range(start, end) {
    (0, _classCallCheck3.default)(this, _Range);
    this.Start = start;
    this.End = end;
  }

  (0, _createClass3.default)(_Range, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Range",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          Start: "number",
          End: "number"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareRecords)(this, other);
    }
  }]);
  return _Range;
}();

exports.Range = _Range;
(0, _Symbol2.setType)("TheGamma.Range", _Range);

var _Error = function () {
  function _Error(number, message, range) {
    (0, _classCallCheck3.default)(this, _Error);
    this.Number = number;
    this.Message = message;
    this.Range = range;
  }

  (0, _createClass3.default)(_Error, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Error",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          Number: "number",
          Message: "string",
          Range: (0, _Util.GenericParam)("Range")
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareRecords)(this, other);
    }
  }]);
  return _Error;
}();

exports.Error = _Error;
(0, _Symbol2.setType)("TheGamma.Error", _Error);

var Operator = exports.Operator = function () {
  function Operator(caseName, fields) {
    (0, _classCallCheck3.default)(this, Operator);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(Operator, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Operator",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Divide: [],
          Equals: [],
          GreaterThan: [],
          GreaterThanOrEqual: [],
          LessThan: [],
          LessThanOrEqual: [],
          Minus: [],
          Modulo: [],
          Multiply: [],
          Plus: [],
          Power: []
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsUnions)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareUnions)(this, other);
    }
  }]);
  return Operator;
}();

(0, _Symbol2.setType)("TheGamma.Operator", Operator);

var TokenKind = exports.TokenKind = function () {
  function TokenKind(caseName, fields) {
    (0, _classCallCheck3.default)(this, TokenKind);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(TokenKind, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TokenKind",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Arrow: [],
          Boolean: ["boolean"],
          Colon: [],
          Comma: [],
          Dot: [],
          EndOfFile: [],
          Equals: [],
          Error: ["string"],
          Fun: [],
          Ident: ["string"],
          LParen: [],
          LSquare: [],
          Let: [],
          Newline: [],
          Number: ["string", "number"],
          Operator: [Operator],
          QIdent: ["string"],
          RParen: [],
          RSquare: [],
          String: ["string"],
          White: ["string"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsUnions)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareUnions)(this, other);
    }
  }]);
  return TokenKind;
}();

(0, _Symbol2.setType)("TheGamma.TokenKind", TokenKind);

var Token = exports.Token = function () {
  function Token(token, range) {
    (0, _classCallCheck3.default)(this, Token);
    this.Token = token;
    this.Range = range;
  }

  (0, _createClass3.default)(Token, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Token",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          Token: TokenKind,
          Range: _Range
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareRecords)(this, other);
    }
  }]);
  return Token;
}();

(0, _Symbol2.setType)("TheGamma.Token", Token);

var Emitter = exports.Emitter = function () {
  function Emitter(emit) {
    (0, _classCallCheck3.default)(this, Emitter);
    this.Emit = emit;
  }

  (0, _createClass3.default)(Emitter, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Emitter",
        interfaces: ["FSharpRecord"],
        properties: {
          Emit: "function"
        }
      };
    }
  }]);
  return Emitter;
}();

(0, _Symbol2.setType)("TheGamma.Emitter", Emitter);

var Metadata = exports.Metadata = function () {
  function Metadata(context, type, data) {
    (0, _classCallCheck3.default)(this, Metadata);
    this.Context = context;
    this.Type = type;
    this.Data = data;
  }

  (0, _createClass3.default)(Metadata, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Metadata",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          Context: "string",
          Type: "string",
          Data: _Util.Any
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }]);
  return Metadata;
}();

(0, _Symbol2.setType)("TheGamma.Metadata", Metadata);

var Documentation = exports.Documentation = function () {
  function Documentation(caseName, fields) {
    (0, _classCallCheck3.default)(this, Documentation);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(Documentation, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Documentation",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Details: ["string", "string"],
          None: [],
          Text: ["string"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsUnions)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareUnions)(this, other);
    }
  }]);
  return Documentation;
}();

(0, _Symbol2.setType)("TheGamma.Documentation", Documentation);

var Member = exports.Member = function () {
  function Member(name, type, metadata, emitter) {
    (0, _classCallCheck3.default)(this, Member);
    this.Name = name;
    this.Type = type;
    this.Metadata = metadata;
    this.Emitter = emitter;
  }

  (0, _createClass3.default)(Member, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Member",
        interfaces: ["FSharpRecord"],
        properties: {
          Name: "string",
          Type: Type,
          Metadata: (0, _Util.makeGeneric)(_List2.default, {
            T: Metadata
          }),
          Emitter: Emitter
        }
      };
    }
  }]);
  return Member;
}();

(0, _Symbol2.setType)("TheGamma.Member", Member);

var PrimitiveType = exports.PrimitiveType = function () {
  function PrimitiveType(caseName, fields) {
    (0, _classCallCheck3.default)(this, PrimitiveType);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(PrimitiveType, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.PrimitiveType",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Bool: [],
          Date: [],
          Number: [],
          String: [],
          Unit: []
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsUnions)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareUnions)(this, other);
    }
  }]);
  return PrimitiveType;
}();

(0, _Symbol2.setType)("TheGamma.PrimitiveType", PrimitiveType);

var MethodArgument = exports.MethodArgument = function () {
  function MethodArgument(name, optional, _static, type) {
    (0, _classCallCheck3.default)(this, MethodArgument);
    this.Name = name;
    this.Optional = optional;
    this.Static = _static;
    this.Type = type;
  }

  (0, _createClass3.default)(MethodArgument, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.MethodArgument",
        interfaces: ["FSharpRecord"],
        properties: {
          Name: "string",
          Optional: "boolean",
          Static: "boolean",
          Type: Type
        }
      };
    }
  }]);
  return MethodArgument;
}();

(0, _Symbol2.setType)("TheGamma.MethodArgument", MethodArgument);

var Type = exports.Type = function () {
  function Type(caseName, fields) {
    (0, _classCallCheck3.default)(this, Type);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(Type, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Type",
        interfaces: ["FSharpUnion"],
        cases: {
          Any: [],
          Delayed: [(0, _Util.Interface)("TheGamma.Common.Future")],
          List: [Type],
          Method: [(0, _Util.makeGeneric)(_List2.default, {
            T: MethodArgument
          }), "function"],
          Object: [(0, _Util.Interface)("TheGamma.ObjectType")],
          Primitive: [PrimitiveType]
        }
      };
    }
  }]);
  return Type;
}();

(0, _Symbol2.setType)("TheGamma.Type", Type);

var Name = exports.Name = function () {
  function Name(name) {
    (0, _classCallCheck3.default)(this, Name);
    this.Name = name;
  }

  (0, _createClass3.default)(Name, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Name",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          Name: "string"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareRecords)(this, other);
    }
  }]);
  return Name;
}();

(0, _Symbol2.setType)("TheGamma.Name", Name);

var Constant = exports.Constant = function () {
  function Constant(caseName, fields) {
    (0, _classCallCheck3.default)(this, Constant);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(Constant, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Constant",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Boolean: ["boolean"],
          Empty: [],
          Number: ["number"],
          String: ["string"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsUnions)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareUnions)(this, other);
    }
  }]);
  return Constant;
}();

(0, _Symbol2.setType)("TheGamma.Constant", Constant);

var EntityKind = exports.EntityKind = function () {
  function EntityKind(caseName, fields) {
    (0, _classCallCheck3.default)(this, EntityKind);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(EntityKind, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.EntityKind",
        interfaces: ["FSharpUnion"],
        cases: {
          ArgumentList: [(0, _Util.makeGeneric)(_List2.default, {
            T: Entity
          })],
          Binding: [Name, Entity],
          Call: [Entity, Entity],
          CallSite: [Entity, _Choice2.default],
          Constant: [Constant],
          Function: [Entity, Entity],
          GlobalValue: [Name, (0, _Util.Option)(_babel.Expression)],
          LetCommand: [Entity, Entity],
          List: [(0, _Util.makeGeneric)(_List2.default, {
            T: Entity
          })],
          Member: [Entity, Entity],
          MemberAccess: [Entity],
          MemberName: [Name],
          NamedParam: [Name, Entity],
          Operator: [Entity, Operator, Entity],
          Placeholder: [Name, Entity],
          Program: [(0, _Util.makeGeneric)(_List2.default, {
            T: Entity
          })],
          Root: [],
          RunCommand: [Entity],
          Variable: [Name, Entity]
        }
      };
    }
  }]);
  return EntityKind;
}();

(0, _Symbol2.setType)("TheGamma.EntityKind", EntityKind);

var Entity = exports.Entity = function () {
  function Entity(kind, symbol, value, meta, type, errors) {
    (0, _classCallCheck3.default)(this, Entity);
    this.Kind = kind;
    this.Symbol = symbol;
    this.Value = value;
    this.Meta = meta;
    this.Type = type;
    this.Errors = errors;
  }

  (0, _createClass3.default)(Entity, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Entity",
        interfaces: ["FSharpRecord"],
        properties: {
          Kind: EntityKind,
          Symbol: (0, _Util.Interface)("TheGamma.Common.Symbol"),
          Value: (0, _Util.Option)(EntityValue),
          Meta: (0, _Util.makeGeneric)(_List2.default, {
            T: Metadata
          }),
          Type: (0, _Util.Option)(Type),
          Errors: (0, _Util.makeGeneric)(_List2.default, {
            T: (0, _Util.makeGeneric)(_Error, {
              Range: _Range
            })
          })
        }
      };
    }
  }]);
  return Entity;
}();

(0, _Symbol2.setType)("TheGamma.Entity", Entity);

var EntityValue = exports.EntityValue = function () {
  function EntityValue(value, preview) {
    (0, _classCallCheck3.default)(this, EntityValue);
    this.Value = value;
    this.Preview = preview;
  }

  (0, _createClass3.default)(EntityValue, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.EntityValue",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          Value: _Util.Any,
          Preview: _Util.Any
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }]);
  return EntityValue;
}();

(0, _Symbol2.setType)("TheGamma.EntityValue", EntityValue);

var _Node = function () {
  function _Node(whiteBefore, whiteAfter, range, node, entity) {
    (0, _classCallCheck3.default)(this, _Node);
    this.WhiteBefore = whiteBefore;
    this.WhiteAfter = whiteAfter;
    this.Range = range;
    this.Node = node;
    this.Entity = entity;
  }

  (0, _createClass3.default)(_Node, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Node",
        interfaces: ["FSharpRecord"],
        properties: {
          WhiteBefore: (0, _Util.makeGeneric)(_List2.default, {
            T: Token
          }),
          WhiteAfter: (0, _Util.makeGeneric)(_List2.default, {
            T: Token
          }),
          Range: _Range,
          Node: (0, _Util.GenericParam)("T"),
          Entity: (0, _Util.Option)(Entity)
        }
      };
    }
  }]);
  return _Node;
}();

exports.Node = _Node;
(0, _Symbol2.setType)("TheGamma.Node", _Node);

var Argument = exports.Argument = function () {
  function Argument(name, value) {
    (0, _classCallCheck3.default)(this, Argument);
    this.Name = name;
    this.Value = value;
  }

  (0, _createClass3.default)(Argument, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Argument",
        interfaces: ["FSharpRecord"],
        properties: {
          Name: (0, _Util.Option)((0, _Util.makeGeneric)(_Node, {
            T: Name
          })),
          Value: (0, _Util.makeGeneric)(_Node, {
            T: Expr
          })
        }
      };
    }
  }]);
  return Argument;
}();

(0, _Symbol2.setType)("TheGamma.Argument", Argument);

var Program = exports.Program = function () {
  function Program(body) {
    (0, _classCallCheck3.default)(this, Program);
    this.Body = body;
  }

  (0, _createClass3.default)(Program, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Program",
        interfaces: ["FSharpRecord"],
        properties: {
          Body: (0, _Util.makeGeneric)(_Node, {
            T: (0, _Util.makeGeneric)(_List2.default, {
              T: (0, _Util.makeGeneric)(_Node, {
                T: Command
              })
            })
          })
        }
      };
    }
  }]);
  return Program;
}();

(0, _Symbol2.setType)("TheGamma.Program", Program);

var Command = exports.Command = function () {
  function Command(caseName, fields) {
    (0, _classCallCheck3.default)(this, Command);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(Command, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Command",
        interfaces: ["FSharpUnion"],
        cases: {
          Expr: [(0, _Util.makeGeneric)(_Node, {
            T: Expr
          })],
          Let: [(0, _Util.makeGeneric)(_Node, {
            T: Name
          }), (0, _Util.makeGeneric)(_Node, {
            T: Expr
          })]
        }
      };
    }
  }]);
  return Command;
}();

(0, _Symbol2.setType)("TheGamma.Command", Command);

var Expr = exports.Expr = function () {
  function Expr(caseName, fields) {
    (0, _classCallCheck3.default)(this, Expr);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(Expr, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Expr",
        interfaces: ["FSharpUnion"],
        cases: {
          Binary: [(0, _Util.makeGeneric)(_Node, {
            T: Expr
          }), (0, _Util.makeGeneric)(_Node, {
            T: Operator
          }), (0, _Util.makeGeneric)(_Node, {
            T: Expr
          })],
          Boolean: ["boolean"],
          Call: [(0, _Util.makeGeneric)(_Node, {
            T: Expr
          }), (0, _Util.makeGeneric)(_Node, {
            T: (0, _Util.makeGeneric)(_List2.default, {
              T: Argument
            })
          })],
          Empty: [],
          Function: [(0, _Util.makeGeneric)(_Node, {
            T: Name
          }), (0, _Util.makeGeneric)(_Node, {
            T: Expr
          })],
          List: [(0, _Util.makeGeneric)(_List2.default, {
            T: (0, _Util.makeGeneric)(_Node, {
              T: Expr
            })
          })],
          Member: [(0, _Util.makeGeneric)(_Node, {
            T: Expr
          }), (0, _Util.makeGeneric)(_Node, {
            T: Expr
          })],
          Number: ["number"],
          Placeholder: [(0, _Util.makeGeneric)(_Node, {
            T: Name
          }), (0, _Util.makeGeneric)(_Node, {
            T: Expr
          })],
          String: ["string"],
          Variable: [(0, _Util.makeGeneric)(_Node, {
            T: Name
          })]
        }
      };
    }
  }]);
  return Expr;
}();

(0, _Symbol2.setType)("TheGamma.Expr", Expr);
//# sourceMappingURL=ast.js.map