"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.State = exports.Event = undefined;

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

exports.getEntity = getEntity;
exports.getTypeName = getTypeName;
exports.formatChain = formatChain;
exports.updateCompletions = updateCompletions;
exports.update = update;
exports.tryGetPreview = tryGetPreview;
exports.render = render;
exports.createBlockEditor = createBlockEditor;

var _Seq = require("fable-core/umd/Seq");

var _typechecker = require("./analyzer/typechecker");

var _AsyncBuilder = require("fable-core/umd/AsyncBuilder");

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _Util = require("fable-core/umd/Util");

var _services = require("./services");

var _List = require("fable-core/umd/List");

var _List2 = _interopRequireDefault(_List);

var _ast = require("./ast/ast");

var _String = require("fable-core/umd/String");

var _astops = require("./ast/astops");

var _interpreter = require("./analyzer/interpreter");

var _html = require("../libraries/html");

var _Async = require("fable-core/umd/Async");

var _tables = require("../libraries/tables");

var _common = require("../libraries/common");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getEntity(svc, code) {
  return function (builder_) {
    return builder_.Delay(function () {
      return builder_.Bind(svc.TypeCheck("let it = " + code), function (_arg1) {
        var patternInput = (0, _Seq.find)(function (_arg2) {
          var $var567 = _arg2[1].Kind.Case === "Variable" ? _arg2[1].Kind.Fields[0].Name === "it" ? [0] : [1] : [1];

          switch ($var567[0]) {
            case 0:
              return true;

            case 1:
              return false;
          }
        }, _arg1[1].Entities);
        var patternInput_1 = (0, _Seq.find)(function (_arg3) {
          return _arg3[1].Kind.Case === "Program" ? true : false;
        }, _arg1[1].Entities);
        var errors = (0, _typechecker.collectTypeErrors)(patternInput_1[1]);
        var errors_1 = (0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.map)(function (e) {
            return [code.substr(e.Range.Start, e.Range.End - e.Range.Start + 1), e.Message];
          }, errors);
        }));
        return builder_.Return([errors_1, patternInput[1]]);
      });
    });
  }(_AsyncBuilder.singleton);
}

var _Event = function () {
  function _Event(caseName, fields) {
    (0, _classCallCheck3.default)(this, _Event);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(_Event, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Blocks.Event",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          AddElement: ["string"],
          RemoveLast: [],
          UpdateParameter: ["string", "string"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsUnions)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareUnions)(this, other);
    }
  }]);
  return _Event;
}();

exports.Event = _Event;
(0, _Symbol2.setType)("TheGamma.Blocks.Event", _Event);

var State = exports.State = function () {
  function State(checkingService, globals, chain, completions, entity) {
    (0, _classCallCheck3.default)(this, State);
    this.CheckingService = checkingService;
    this.Globals = globals;
    this.Chain = chain;
    this.Completions = completions;
    this.Entity = entity;
  }

  (0, _createClass3.default)(State, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Blocks.State",
        interfaces: ["FSharpRecord"],
        properties: {
          CheckingService: _services.CheckingService,
          Globals: (0, _Util.makeGeneric)(_List2.default, {
            T: _ast.Entity
          }),
          Chain: (0, _Util.makeGeneric)(_List2.default, {
            T: (0, _Util.Tuple)(["string", (0, _Util.Option)((0, _Util.makeGeneric)(_List2.default, {
              T: (0, _Util.Tuple)(["string", "string"])
            }))])
          }),
          Completions: (0, _Util.Array)("string"),
          Entity: (0, _Util.Option)(_ast.Entity)
        }
      };
    }
  }], [{
    key: "Create",
    value: function (svc, globals) {
      var Entity = null;
      return new State(svc, globals, new _List2.default(), [], Entity);
    }
  }]);
  return State;
}();

(0, _Symbol2.setType)("TheGamma.Blocks.State", State);

function getTypeName(state) {
  var $var568 = state.Entity != null ? state.Entity.Type != null ? state.Entity.Type.Case === "Object" ? (0, _Util.hasInterface)(state.Entity.Type.Fields[0], "TheGamma.TypeProviders.FSharpProvider.GenericType") ? [0, state.Entity.Type.Fields[0]] : [1] : [1] : [1] : [1];

  switch ($var568[0]) {
    case 0:
      return $var568[1].TypeDefinition.FullName;

    case 1:
      return "object";
  }
}

function formatChain(chain) {
  return (0, _String.join)(".", (0, _List.map)(function (tupledArg) {
    return (0, _astops.escapeIdent)(tupledArg[0]) + (tupledArg[1] == null ? "" : "(" + (0, _String.join)(", ", (0, _List.map)(function (tuple) {
      return tuple[1];
    }, tupledArg[1])) + ")");
  }, (0, _List.reverse)(chain)));
}

function updateCompletions(state) {
  return function (builder_) {
    return builder_.Delay(function () {
      return builder_.Bind(state, function (_arg1) {
        if (_arg1.Chain.tail == null) {
          return builder_.Return(function () {
            var Completions = (0, _from2.default)((0, _Seq.delay)(function () {
              return (0, _Seq.map)(function (g) {
                return _astops.Entity$2E$get_Name.bind(g)();
              }, _arg1.Globals);
            }));
            return new State(_arg1.CheckingService, _arg1.Globals, _arg1.Chain, Completions, _arg1.Entity);
          }());
        } else {
          var code = formatChain(_arg1.Chain);
          return builder_.Bind(getEntity(_arg1.CheckingService, code), function (_arg2) {
            var matchValue = [_arg2[0], _arg2[1]];
            var $var569 = matchValue[0].tail == null ? matchValue[1].Type != null ? matchValue[1].Type.Case === "Object" ? [0, matchValue[1].Type.Fields[0]] : [1] : [1] : [1];

            switch ($var569[0]) {
              case 0:
                var compls = (0, _from2.default)((0, _Seq.delay)(function () {
                  return (0, _Seq.collect)(function (m) {
                    return m.Name !== "preview" ? (0, _Seq.singleton)(m.Name) : (0, _Seq.empty)();
                  }, $var569[1].Members);
                }));
                return builder_.Return(function () {
                  var Entity = _arg2[1];
                  return new State(_arg1.CheckingService, _arg1.Globals, _arg1.Chain, compls, Entity);
                }());

              case 1:
                return builder_.Return(function () {
                  var Entity_1 = _arg2[1];
                  var Completions_1 = [];
                  return new State(_arg1.CheckingService, _arg1.Globals, _arg1.Chain, Completions_1, Entity_1);
                }());
            }
          });
        }
      });
    });
  }(_AsyncBuilder.singleton);
}

function update(state, evt) {
  return updateCompletions(function (builder_) {
    return builder_.Delay(function () {
      var matchValue = [evt, state];
      var $var570 = matchValue[0].Case === "AddElement" ? [2, matchValue[0].Fields[0]] : matchValue[0].Case === "UpdateParameter" ? matchValue[1].Chain.tail != null ? matchValue[1].Chain.head[1] != null ? [3, matchValue[1].Chain.head[0], matchValue[0].Fields[0], matchValue[1].Chain.head[1], matchValue[1].Chain.tail, matchValue[0].Fields[1]] : [4] : [4] : matchValue[1].Chain.tail != null ? matchValue[1].Chain.tail.tail == null ? [0] : [1, matchValue[1].Chain.tail] : [0];

      switch ($var570[0]) {
        case 0:
          return builder_.Return(function () {
            var Chain = new _List2.default();
            var Entity = null;
            return new State(state.CheckingService, state.Globals, Chain, state.Completions, Entity);
          }());

        case 1:
          return builder_.Return(new State(state.CheckingService, state.Globals, $var570[1], state.Completions, state.Entity));

        case 2:
          var code = formatChain(new _List2.default([$var570[1], null], state.Chain));
          return builder_.Bind(getEntity(state.CheckingService, code), function (_arg1) {
            var $var571 = _arg1[1].Type != null ? _arg1[1].Type.Case === "Method" ? [0, _arg1[1].Type.Fields[0]] : [1] : [1];

            switch ($var571[0]) {
              case 0:
                return builder_.Return(function () {
                  var Chain_1 = new _List2.default([$var570[1], (0, _Seq.toList)((0, _Seq.delay)(function () {
                    return (0, _Seq.map)(function (a) {
                      return [a.Name, ""];
                    }, $var571[1]);
                  }))], state.Chain);
                  return new State(state.CheckingService, state.Globals, Chain_1, state.Completions, state.Entity);
                }());

              case 1:
                return builder_.Return(function () {
                  var Chain_2 = new _List2.default([$var570[1], null], state.Chain);
                  return new State(state.CheckingService, state.Globals, Chain_2, state.Completions, state.Entity);
                }());
            }
          });

        case 3:
          var newPars = (0, _List.map)(function (tupledArg) {
            return $var570[2] === tupledArg[0] ? [$var570[2], $var570[5]] : [tupledArg[0], tupledArg[1]];
          }, $var570[3]);
          return builder_.Return(function () {
            var Chain_3 = new _List2.default([$var570[1], newPars], $var570[4]);
            return new State(state.CheckingService, state.Globals, Chain_3, state.Completions, state.Entity);
          }());

        case 4:
          return builder_.Return(state);
      }
    });
  }(_AsyncBuilder.singleton));
}

function tryGetPreview(state) {
  var _Evaluate_ = function _Evaluate_(l) {
    return l.value;
  };

  if (state.Entity != null) {
    (0, _interpreter.evaluate)(state.Globals, state.Entity);
    var matchValue = state.Entity.Value;
    var $var572 = void 0;

    if (matchValue != null) {
      var activePatternResult8773 = _Evaluate_(matchValue.Preview);

      if (activePatternResult8773 != null) {
        $var572 = [0, activePatternResult8773];
      } else {
        $var572 = [1];
      }
    } else {
      $var572 = [1];
    }

    switch ($var572[0]) {
      case 0:
        var node = function (arg0) {
          return function (arg1) {
            return _html.El.op_Dynamic(arg0, arg1);
          };
        }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("id", "blockspreview")]))((0, _List.ofArray)([(0, _html.text)("Loading preview...")]));

        var returned = false;

        (function (arg00) {
          (0, _Async.startImmediate)(arg00);
        })(function (builder_) {
          return builder_.Delay(function () {
            return builder_.Bind(_tables.table.create($var572[1]).render(), function (_arg4) {
              if (returned) {
                (0, _html.renderTo)(document.getElementById("blockspreview"), _arg4);
                return builder_.Zero();
              } else {
                node = _arg4;
                return builder_.Zero();
              }
            });
          });
        }(_AsyncBuilder.singleton));

        returned = true;
        return node;

      case 1:
        return function (arg0_1) {
          return function (arg1_1) {
            return _html.El.op_Dynamic(arg0_1, arg1_1);
          };
        }(_html.h)("div")(new _List2.default())((0, _List.ofArray)([(0, _html.text)("Preview has no value")]));
    }
  } else {
    return function (arg0_2) {
      return function (arg1_2) {
        return _html.El.op_Dynamic(arg0_2, arg1_2);
      };
    }(_html.h)("div")(new _List2.default())((0, _List.ofArray)([(0, _html.text)("No preview available")]));
  }
}

function render(trigger, state) {
  return function (arg0) {
    return function (arg1) {
      return _html.El.op_Dynamic(arg0, arg1);
    };
  }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "pilleditor")]))((0, _List.ofArray)([function (arg0_1) {
    return function (arg1_1) {
      return _html.El.op_Dynamic(arg0_1, arg1_1);
    };
  }(_html.h)("ul")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "pills")]))((0, _Seq.toList)((0, _Seq.delay)(function () {
    var renderCoreChain = function renderCoreChain(chain) {
      return (0, _Seq.toList)((0, _Seq.delay)(function () {
        return (0, _Seq.collect)(function (matchValue) {
          return (0, _Seq.singleton)(function (arg0_2) {
            return function (arg1_2) {
              return _html.El.op_Dynamic(arg0_2, arg1_2);
            };
          }(_html.h)("li")(new _List2.default())((0, _List.ofArray)([(0, _html.text)(matchValue[0] + (function () {
            return matchValue[1] != null;
          }(null) ? " (...)" : ""))])));
        }, (0, _List.reverse)(chain));
      }));
    };

    var renderChain = function renderChain(removeLast) {
      return function (chain_1) {
        var matchValue_1 = [removeLast, chain_1];
        var $var573 = matchValue_1[0] ? matchValue_1[1].tail != null ? [0] : [1, matchValue_1[1]] : [1, matchValue_1[1]];

        switch ($var573[0]) {
          case 0:
            var rest = matchValue_1[1].tail;
            var last = matchValue_1[1].head[0];
            return (0, _List.append)(renderCoreChain(rest), (0, _List.ofArray)([function (arg0_3) {
              return function (arg1_3) {
                return _html.El.op_Dynamic(arg0_3, arg1_3);
              };
            }(_html.h)("li")(new _List2.default())((0, _List.ofArray)([(0, _html.text)(last), function (arg0_4) {
              return function (arg1_4) {
                return _html.El.op_Dynamic(arg0_4, arg1_4);
              };
            }(_html.h)("a")((0, _List.ofArray)([(0, _html.op_EqualsBangGreater)("click", function (_arg2) {
              return function (_arg1) {
                trigger(new _Event("RemoveLast", []));
              };
            })]))((0, _List.ofArray)([function (arg0_5) {
              return function (arg1_5) {
                return _html.El.op_Dynamic(arg0_5, arg1_5);
              };
            }(_html.h)("i")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "gfa gfa-times")]))(new _List2.default())]))]))]));

          case 1:
            return renderCoreChain($var573[1]);
        }
      };
    };

    return (0, _Seq.append)(function () {
      var $var574 = state.Chain.tail != null ? state.Chain.head[1] != null ? [0, state.Chain.head[0], state.Chain.head[1], state.Chain.tail] : [1, state.Chain] : [1, state.Chain];

      switch ($var574[0]) {
        case 0:
          return renderChain(false)($var574[3]);

        case 1:
          return renderChain(true)($var574[1]);
      }
    }(), (0, _Seq.delay)(function () {
      return (0, _Seq.append)(function () {
        var $var575 = state.Chain.tail != null ? state.Chain.head[1] != null ? [0, state.Chain.head[0], state.Chain.head[1], state.Chain.tail] : [1] : [1];

        switch ($var575[0]) {
          case 0:
            return (0, _Seq.singleton)(function (arg0_6) {
              return function (arg1_6) {
                return _html.El.op_Dynamic(arg0_6, arg1_6);
              };
            }(_html.h)("li")(new _List2.default())((0, _Seq.toList)((0, _Seq.delay)(function () {
              return (0, _Seq.append)((0, _Seq.singleton)((0, _html.text)($var575[1] + "(")), (0, _Seq.delay)(function () {
                return (0, _Seq.append)((0, _Seq.collect)(function (matchValue_2) {
                  return (0, _Seq.append)((0, _Seq.singleton)((0, _html.text)(matchValue_2[0] + " = ")), (0, _Seq.delay)(function () {
                    return (0, _Seq.singleton)(function (arg0_7) {
                      return function (arg1_7) {
                        return _html.El.op_Dynamic(arg0_7, arg1_7);
                      };
                    }(_html.h)("input")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("type", "text"), (0, _html.op_EqualsGreater)("value", matchValue_2[1]), (0, _html.op_EqualsBangGreater)("input", function (el) {
                      return function (_arg3) {
                        trigger(new _Event("UpdateParameter", [matchValue_2[0], el.value]));
                      };
                    })]))(new _List2.default()));
                  }));
                }, $var575[2]), (0, _Seq.delay)(function () {
                  return (0, _Seq.append)((0, _Seq.singleton)((0, _html.text)(")")), (0, _Seq.delay)(function () {
                    return (0, _Seq.singleton)(function (arg0_8) {
                      return function (arg1_8) {
                        return _html.El.op_Dynamic(arg0_8, arg1_8);
                      };
                    }(_html.h)("a")((0, _List.ofArray)([(0, _html.op_EqualsBangGreater)("click", function (_arg5) {
                      return function (_arg4) {
                        trigger(new _Event("RemoveLast", []));
                      };
                    })]))((0, _List.ofArray)([function (arg0_9) {
                      return function (arg1_9) {
                        return _html.El.op_Dynamic(arg0_9, arg1_9);
                      };
                    }(_html.h)("i")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "gfa gfa-times")]))(new _List2.default())])));
                  }));
                }));
              }));
            }))));

          case 1:
            return (0, _Seq.empty)();
        }
      }(), (0, _Seq.delay)(function () {
        return state.Completions.length > 0 ? (0, _Seq.singleton)(function (arg0_10) {
          return function (arg1_10) {
            return _html.El.op_Dynamic(arg0_10, arg1_10);
          };
        }(_html.h)("li")(new _List2.default())((0, _List.ofArray)([function (arg0_11) {
          return function (arg1_11) {
            return _html.El.op_Dynamic(arg0_11, arg1_11);
          };
        }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "selectwrapper")]))((0, _List.ofArray)([function (arg0_12) {
          return function (arg1_12) {
            return _html.El.op_Dynamic(arg0_12, arg1_12);
          };
        }(_html.h)("select")((0, _List.ofArray)([(0, _html.op_EqualsBangGreater)("change", function (el_1) {
          return function (_arg6) {
            trigger(new _Event("AddElement", [el_1.value]));
          };
        })]))((0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.append)((0, _Seq.singleton)(function (arg0_13) {
            return function (arg1_13) {
              return _html.El.op_Dynamic(arg0_13, arg1_13);
            };
          }(_html.h)("option")(new _List2.default())((0, _List.ofArray)([(0, _html.text)("(choose an operation to add)")]))), (0, _Seq.delay)(function () {
            return (0, _Seq.map)(function (s) {
              return function (arg0_14) {
                return function (arg1_14) {
                  return _html.El.op_Dynamic(arg0_14, arg1_14);
                };
              }(_html.h)("option")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("value", s)]))((0, _List.ofArray)([(0, _html.text)(s)]));
            }, state.Completions);
          }));
        })))]))]))) : (0, _Seq.empty)();
      }));
    }));
  }))), tryGetPreview(state), function (arg0_15) {
    return function (arg1_15) {
      return _html.El.op_Dynamic(arg0_15, arg1_15);
    };
  }(_html.h)("p")(new _List2.default())((0, _List.ofArray)([(0, _html.text)(getTypeName(state))]))]));
}

function createBlockEditor(svc, globals, id) {
  (function (arg00) {
    (0, _Async.startImmediate)(arg00);
  })(function (builder_) {
    return builder_.Delay(function () {
      return builder_.TryWith(builder_.Delay(function () {
        return builder_.Bind((0, _common.Async$2E$AwaitFuture$2E$Static)(globals), function (_arg1) {
          var state = State.Create(svc, _arg1);
          return builder_.Bind((0, _Seq.fold)(function (st, s) {
            return function (builder__1) {
              return builder__1.Delay(function () {
                return builder__1.Bind(st, function (_arg2) {
                  return builder__1.ReturnFrom(update(_arg2, new _Event("AddElement", [s])));
                });
              });
            }(_AsyncBuilder.singleton);
          }, _AsyncBuilder.singleton.Return(state), (0, _List.ofArray)(["enigma"])), function (_arg3) {
            (0, _html.createVirtualDomAsyncApp)(id, _arg3, function (trigger) {
              return function (state_1) {
                return render(trigger, state_1);
              };
            }, function (state_2) {
              return function (evt) {
                return update(state_2, evt);
              };
            });
            return builder_.Zero();
          });
        });
      }), function (_arg4) {
        _common.Log.exn("system", "Something went wrong: %O", _arg4);

        return builder_.Zero();
      });
    });
  }(_AsyncBuilder.singleton));
}
//# sourceMappingURL=blocks.js.map