"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.CompilationContext = undefined;

var _map = require("babel-runtime/core-js/map");

var _map2 = _interopRequireDefault(_map);

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

exports.offsetToLocation = offsetToLocation;
exports.rangeToLoc = rangeToLoc;
exports.getMember = getMember;
exports.compileExpression = compileExpression;
exports.compileCommand = compileCommand;
exports.compileProgram = compileProgram;
exports.compile = compile;

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _Util = require("fable-core/umd/Util");

var _List = require("fable-core/umd/List");

var _List2 = _interopRequireDefault(_List);

var _Map3 = require("fable-core/umd/Map");

var _Map4 = _interopRequireDefault(_Map3);

var _babel = require("../common/babel");

var _Seq = require("fable-core/umd/Seq");

var _common = require("../../libraries/common");

var _GenericComparer = require("fable-core/umd/GenericComparer");

var _GenericComparer2 = _interopRequireDefault(_GenericComparer);

var _String = require("fable-core/umd/String");

var _babel2 = require("../../bindings/babel");

var _AsyncBuilder = require("fable-core/umd/AsyncBuilder");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CompilationContext = exports.CompilationContext = function () {
    function CompilationContext(lineLengths, globals) {
        (0, _classCallCheck3.default)(this, CompilationContext);
        this.LineLengths = lineLengths;
        this.Globals = globals;
    }

    (0, _createClass3.default)(CompilationContext, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.CodeGenerator.CompilationContext",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    LineLengths: (0, _Util.makeGeneric)(_List2.default, {
                        T: "number"
                    }),
                    Globals: (0, _Util.makeGeneric)(_Map4.default, {
                        Key: "string",
                        Value: _babel.Expression
                    })
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return CompilationContext;
}();

(0, _Symbol2.setType)("TheGamma.CodeGenerator.CompilationContext", CompilationContext);

function offsetToLocation(lines, offs, lengths) {
    offsetToLocation: while (true) {
        var $var364 = lengths.tail != null ? offs <= lengths.head ? [0, lengths.head, lengths.tail] : [1] : [1];

        switch ($var364[0]) {
            case 0:
                return new _babel.Position(lines, offs);

            case 1:
                if (lengths.tail == null) {
                    throw new Error("offsetToLocation: Out of range");
                } else {
                    lines = lines + 1;
                    offs = offs - lengths.head - 1;
                    lengths = lengths.tail;
                    continue offsetToLocation;
                }

        }
    }
}

function rangeToLoc(ctx, rng) {
    return new _babel.SourceLocation(offsetToLocation(1, rng.Start, ctx.LineLengths), offsetToLocation(1, rng.Start, ctx.LineLengths));
}

function getMember(name, typ) {
    if (typ.Case === "Object") {
        var matchValue = (0, _Seq.tryPick)(function (m) {
            return m.Name === name ? m : null;
        }, typ.Fields[0].Members);

        if (matchValue != null) {
            return matchValue;
        } else {
            _common.Log.exn("codegen", "getMember: Member %s not found in object %O", name, typ.Fields[0]);

            throw new Error("getMember: Member not found");
        }
    } else {
        _common.Log.exn("codegen", "getMember: Not an object %O", typ);

        throw new Error("getMember: Not an object");
    }
}

function compileExpression(ctx, expr) {
    var _loop = function _loop() {
        _common.Log.trace("codegen", "Compiling expression: %O", expr);

        var $var365 = expr.Node.Case === "Binary" ? expr.Node.Fields[1].Node.Case === "Power" ? [0, expr.Node.Fields[0], expr.Node.Fields[2]] : [1, expr.Node.Fields[0], expr.Node.Fields[1], expr.Node.Fields[2]] : expr.Node.Case === "Member" ? expr.Node.Fields[1].Node.Case === "Placeholder" ? expr.Node.Fields[1].Node.Fields[1].Node.Case === "Variable" ? [2, expr.Node.Fields[0], expr.Node.Fields[1].Node.Fields[1].Node.Fields[0]] : [3, expr.Node.Fields[0]] : expr.Node.Fields[1].Node.Case === "Variable" ? [2, expr.Node.Fields[0], expr.Node.Fields[1].Node.Fields[0]] : [3, expr.Node.Fields[0]] : expr.Node.Case === "Call" ? [4, expr.Node.Fields[1], expr.Node.Fields[0]] : expr.Node.Case === "Variable" ? ctx.Globals.has(expr.Node.Fields[0].Node.Name) ? [5, expr.Node.Fields[0]] : [6] : [6];

        switch ($var365[0]) {
            case 0:
                var l = compileExpression(ctx, $var365[1]);
                var r = compileExpression(ctx, $var365[2]);
                var rng = rangeToLoc(ctx, expr.Range);

                var pow = _babel.BabelOperators.op_Dynamic(_babel.BabelOperators.ident("Math"), "pow");

                return {
                    v: new _babel.Expression("CallExpression", [pow, (0, _List.ofArray)([l, r]), rangeToLoc(ctx, expr.Range)])
                };

            case 1:
                var l_1 = compileExpression(ctx, $var365[1]);
                var r_1 = compileExpression(ctx, $var365[3]);
                var op = void 0;

                if ($var365[2].Node.Case === "Equals") {
                    op = new _babel.BinaryOperator("BinaryEqualStrict", []);
                } else if ($var365[2].Node.Case === "Plus") {
                    op = new _babel.BinaryOperator("BinaryPlus", []);
                } else if ($var365[2].Node.Case === "Minus") {
                    op = new _babel.BinaryOperator("BinaryMinus", []);
                } else if ($var365[2].Node.Case === "Multiply") {
                    op = new _babel.BinaryOperator("BinaryMultiply", []);
                } else if ($var365[2].Node.Case === "Divide") {
                    op = new _babel.BinaryOperator("BinaryDivide", []);
                } else if ($var365[2].Node.Case === "GreaterThan") {
                    op = new _babel.BinaryOperator("BinaryGreater", []);
                } else if ($var365[2].Node.Case === "LessThan") {
                    op = new _babel.BinaryOperator("BinaryLess", []);
                } else if ($var365[2].Node.Case === "GreaterThanOrEqual") {
                    op = new _babel.BinaryOperator("BinaryGreaterOrEqual", []);
                } else if ($var365[2].Node.Case === "LessThanOrEqual") {
                    op = new _babel.BinaryOperator("BinaryLessOrEqual", []);
                } else if ($var365[2].Node.Case === "Power") {
                    throw new Error("compileExpression: Power is not a binary operator");
                } else {
                    op = new _babel.BinaryOperator("BinaryModulus", []);
                }

                return {
                    v: new _babel.Expression("BinaryExpression", [op, l_1, r_1, rangeToLoc(ctx, expr.Range)])
                };

            case 2:
                var mem = getMember($var365[2].Node.Name, $var365[1].Entity.Type);
                var inst = compileExpression(ctx, $var365[1]);
                return {
                    v: mem.Emitter.Emit(inst)
                };

            case 3:
                throw new Error("compileExpression: Member in member access is not a variable");

            case 4:
                var compiledArgs = (0, _List.map)(function (a) {
                    return [a.Name, compileExpression(ctx, a.Value)];
                }, $var365[1].Node);
                var positionArgs = (0, _from2.default)((0, _Seq.map)(function (tuple) {
                    return tuple[1];
                }, (0, _Seq.takeWhile)(function (tupledArg) {
                    return function () {
                        return tupledArg[0] == null;
                    }(null);
                }, compiledArgs)));
                var namedArgs = new _map2.default((0, _Seq.choose)(function (_arg1) {
                    if (_arg1[0] != null) {
                        var n = _arg1[0];
                        return [n.Node.Name, _arg1[1]];
                    } else {
                        return null;
                    }
                }, compiledArgs));
                var expectedArgs = void 0;
                var matchValue = $var365[2].Entity.Type;

                if (matchValue.Case === "Method") {
                    expectedArgs = matchValue.Fields[0];
                } else {
                    expectedArgs = new _List2.default();
                }

                var inst_1 = compileExpression(ctx, $var365[2]);
                var pars = (0, _List.mapIndexed)(function (i, ma) {
                    return i < positionArgs.length ? positionArgs[i] : namedArgs.has(ma.Name) ? namedArgs.get(ma.Name) : new _babel.Expression("NullLiteral", [rangeToLoc(ctx, $var365[1].Range)]);
                }, expectedArgs);
                return {
                    v: new _babel.Expression("CallExpression", [inst_1, pars, rangeToLoc(ctx, expr.Range)])
                };

            case 5:
                return {
                    v: ctx.Globals.get($var365[1].Node.Name)
                };

            case 6:
                if (expr.Node.Case === "Variable") {
                    return {
                        v: new _babel.Expression("IdentifierExpression", [expr.Node.Fields[0].Node.Name, rangeToLoc(ctx, expr.Node.Fields[0].Range)])
                    };
                } else if (expr.Node.Case === "Number") {
                    return {
                        v: new _babel.Expression("NumericLiteral", [expr.Node.Fields[0], rangeToLoc(ctx, expr.Range)])
                    };
                } else if (expr.Node.Case === "String") {
                    return {
                        v: new _babel.Expression("StringLiteral", [expr.Node.Fields[0], rangeToLoc(ctx, expr.Range)])
                    };
                } else if (expr.Node.Case === "Boolean") {
                    return {
                        v: new _babel.Expression("BooleanLiteral", [expr.Node.Fields[0], rangeToLoc(ctx, expr.Range)])
                    };
                } else if (expr.Node.Case === "Placeholder") {
                    ctx = ctx;
                    expr = expr.Node.Fields[1];
                    return "continue|compileExpression";
                } else if (expr.Node.Case === "List") {
                    var es = (0, _List.map)(function (expr_1) {
                        return compileExpression(ctx, expr_1);
                    }, expr.Node.Fields[0]);
                    return {
                        v: new _babel.Expression("ArrayExpression", [es, rangeToLoc(ctx, expr.Range)])
                    };
                } else if (expr.Node.Case === "Function") {
                    var _var = new _babel.Expression("IdentifierExpression", [expr.Node.Fields[0].Node.Name, rangeToLoc(ctx, expr.Node.Fields[0].Range)]);

                    var ce = compileExpression(function () {
                        var Globals = (0, _Map3.add)(expr.Node.Fields[0].Node.Name, _var, ctx.Globals);
                        return new CompilationContext(ctx.LineLengths, Globals);
                    }(), expr.Node.Fields[1]);
                    var body = new _babel.Statement("BlockStatement", [(0, _List.ofArray)([new _babel.Statement("ReturnStatement", [ce, rangeToLoc(ctx, expr.Node.Fields[1].Range)])]), rangeToLoc(ctx, expr.Node.Fields[1].Range)]);
                    return {
                        v: new _babel.Expression("FunctionExpression", [null, (0, _List.ofArray)([new _babel.Pattern("IdentifierPattern", [expr.Node.Fields[0].Node.Name, rangeToLoc(ctx, expr.Node.Fields[0].Range)])]), body, false, false, rangeToLoc(ctx, expr.Range)])
                    };
                } else if (expr.Node.Case === "Empty") {
                    _common.Log.error("codegen", "getEmitterAndParams: Empty expression in the AST");

                    return {
                        v: new _babel.Expression("NullLiteral", [rangeToLoc(ctx, expr.Range)])
                    };
                } else {
                    throw new Error("C:\\Tomas\\Public\\the-gamma\\thegamma-script\\src\\thegamma\\codegen/codegen.fs", 43, 8);
                }

        }
    };

    compileExpression: while (true) {
        var _ret = _loop();

        switch (_ret) {
            case "continue|compileExpression":
                continue compileExpression;

            default:
                if ((typeof _ret === "undefined" ? "undefined" : (0, _typeof3.default)(_ret)) === "object") return _ret.v;
        }
    }
}

function compileCommand(ctx, idx, cmd) {
    var loc = rangeToLoc(ctx, cmd.Range);
    var patternInput = void 0;

    if (cmd.Node.Case === "Expr") {
        patternInput = [new _List2.default(), _babel.BabelOperators.num(idx), compileExpression(ctx, cmd.Node.Fields[0])];
    } else {
        var e = compileExpression(ctx, cmd.Node.Fields[1]);
        var name = new _babel.Pattern("IdentifierPattern", [cmd.Node.Fields[0].Node.Name, rangeToLoc(ctx, cmd.Node.Fields[0].Range)]);
        var decl = new _babel.VariableDeclarator("VariableDeclarator", [name, e, loc]);
        patternInput = [(0, _List.ofArray)([new _babel.Statement("VariableDeclaration", [new _babel.VariableDeclarationKind("Var", []), (0, _List.ofArray)([decl]), rangeToLoc(ctx, cmd.Range)])]), _babel.BabelOperators.str(cmd.Node.Fields[0].Node.Name), _babel.BabelOperators.ident(cmd.Node.Fields[0].Node.Name)];
    }

    var res = new _babel.Expression("MemberExpression", [_babel.BabelOperators.ident("_results"), patternInput[1], true, loc]);
    return (0, _List.append)(patternInput[0], (0, _List.ofArray)([new _babel.Statement("ExpressionStatement", [new _babel.Expression("AssignmentExpression", [new _babel.AssignmentOperator("AssignEqual", []), res, patternInput[2], loc]), loc])]));
}

function compileProgram(ctx, prog) {
    var decl = new _babel.VariableDeclarator("VariableDeclarator", [new _babel.Pattern("IdentifierPattern", ["_results", null]), new _babel.Expression("ArrayExpression", [new _List2.default(), null]), null]);
    var res = new _babel.Statement("VariableDeclaration", [new _babel.VariableDeclarationKind("Var", []), (0, _List.ofArray)([decl]), null]);
    var body = (0, _List.concat)((0, _List.mapIndexed)(function (idx, cmd) {
        return compileCommand(ctx, idx, cmd);
    }, prog.Body.Node));
    var ret = new _babel.Statement("ReturnStatement", [_babel.BabelOperators.ident("_results"), null]);
    var body_1 = new _babel.Statement("BlockStatement", [(0, _List.append)(new _List2.default(res, body), (0, _List.ofArray)([ret])), null]);
    var body_2 = new _babel.Expression("CallExpression", [new _babel.Expression("FunctionExpression", [null, new _List2.default(), body_1, false, false, null]), new _List2.default(), null]);
    return new _babel.Program(rangeToLoc(ctx, prog.Body.Range), (0, _List.ofArray)([new _babel.Statement("ExpressionStatement", [body_2, null])]));
}

function compile(globals, text, prog) {
    return function (builder_) {
        return builder_.Delay(function () {
            return builder_.TryWith(builder_.Delay(function () {
                return builder_.Bind((0, _common.Async$2E$AwaitFuture$2E$Static)(globals), function (_arg1) {
                    var globals_1 = (0, _Map3.create)((0, _List.choose)(function (_arg2) {
                        var $var366 = _arg2.Kind.Case === "GlobalValue" ? _arg2.Kind.Fields[1] != null ? [0, _arg2.Kind.Fields[1], _arg2.Kind.Fields[0]] : [1] : [1];

                        switch ($var366[0]) {
                            case 0:
                                return [$var366[2].Name, $var366[1]];

                            case 1:
                                return null;
                        }
                    }, _arg1), new _GenericComparer2.default(_Util.compare));
                    var ctx = new CompilationContext((0, _Seq.toList)((0, _Seq.delay)(function () {
                        return (0, _Seq.map)(function (l) {
                            return l.length;
                        }, (0, _String.split)(text, "\n"));
                    })), globals_1);
                    var res = compileProgram(ctx, prog);
                    var code = Babel.transformFromAst(_babel.Serializer.serializeProgram(res), text, new _babel2.BabelOptions(["es2015"]));

                    _common.Log.trace("codegen", "Evaluating: %O", code);

                    return builder_.Return(code.code);
                });
            }), function (_arg3) {
                _common.Log.exn("codegen", "Evaluating code failed: %O", _arg3);

                return builder_.Return("");
            });
        });
    }(_AsyncBuilder.singleton);
}
//# sourceMappingURL=codegen.js.map