"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PivotContext = exports.RuntimeContext = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

exports.convertTupleSequence = convertTupleSequence;
exports.convertSequence = convertSequence;
exports.trimLeft = trimLeft;
exports.trimRight = trimRight;
exports.concatUrl = concatUrl;

var _AsyncBuilder = require("fable-core/umd/AsyncBuilder");

var _Seq = require("fable-core/umd/Seq");

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _String = require("fable-core/umd/String");

var _common = require("../../libraries/common");

var _Util = require("fable-core/umd/Util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function convertTupleSequence(f, g, data) {
  return function (builder_) {
    return builder_.Delay(function () {
      return builder_.Bind(data, function (_arg1) {
        return builder_.Return(_arg1.map(function (tupledArg) {
          return [f(tupledArg[0]), g(tupledArg[1])];
        }));
      });
    });
  }(_AsyncBuilder.singleton);
}

function convertSequence(f, data) {
  return function (builder_) {
    return builder_.Delay(function () {
      return builder_.Bind(data, function (_arg1) {
        return builder_.Return(function (array) {
          return (0, _from2.default)((0, _Seq.map)(f, array));
        }(_arg1));
      });
    });
  }(_AsyncBuilder.singleton);
}

function trimLeft(c, s) {
  return (0, _from2.default)((0, _Seq.skipWhile)(function (y) {
    return c === y;
  }, s.split(""))).join('');
}

function trimRight(c, s) {
  return (0, _from2.default)((0, _Seq.skipWhile)(function (y) {
    return c === y;
  }, s.split("").slice().reverse())).slice().reverse().join('');
}

function concatUrl(a, b) {
  return trimRight("/", a) + "/" + trimLeft("/", b);
}

var RuntimeContext = exports.RuntimeContext = function () {
  (0, _createClass3.default)(RuntimeContext, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProvidersRuntime.RuntimeContext",
        properties: {
          root: "string",
          trace: "string"
        }
      };
    }
  }]);

  function RuntimeContext(root, cookies, trace) {
    (0, _classCallCheck3.default)(this, RuntimeContext);
    this["root@19"] = root;
    this.cookies = cookies;
    this["trace@19"] = trace;
  }

  (0, _createClass3.default)(RuntimeContext, [{
    key: "addTrace",
    value: function (suffix) {
      var _this = this;

      var traces = (0, _Seq.toList)((0, _Seq.delay)(function () {
        return (0, _Seq.append)(!(0, _String.isNullOrEmpty)(_this["trace@19"]) ? (0, _Seq.singleton)(_this["trace@19"]) : (0, _Seq.empty)(), (0, _Seq.delay)(function () {
          return !(0, _String.isNullOrEmpty)(suffix) ? (0, _Seq.singleton)(suffix) : (0, _Seq.empty)();
        }));
      }));
      return new RuntimeContext(this["root@19"], this.cookies, (0, _String.join)("&", traces));
    }
  }, {
    key: "getValue",
    value: function (endpoint) {
      var _this2 = this;

      return function (builder_) {
        return builder_.Delay(function () {
          return builder_.Bind(_common.Http.Request("POST", concatUrl(_this2["root@19"], endpoint), _this2["trace@19"], _this2.cookies), function (_arg1) {
            return builder_.Return(JSON.parse(_arg1));
          });
        });
      }(_AsyncBuilder.singleton);
    }
  }, {
    key: "root",
    get: function () {
      return this["root@19"];
    }
  }, {
    key: "trace",
    get: function () {
      return this["trace@19"];
    }
  }]);
  return RuntimeContext;
}();

(0, _Symbol2.setType)("TheGamma.TypeProvidersRuntime.RuntimeContext", RuntimeContext);

var PivotContext = exports.PivotContext = function () {
  (0, _createClass3.default)(PivotContext, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProvidersRuntime.PivotContext",
        properties: {}
      };
    }
  }]);

  function PivotContext(root, calls) {
    (0, _classCallCheck3.default)(this, PivotContext);
    this.root = root;
    this.calls = calls;
  }

  (0, _createClass3.default)(PivotContext, [{
    key: "addCall",
    value: function (callid, values) {
      var values_1 = (0, _from2.default)((0, _Seq.map)(function (v) {
        return v instanceof Date ? v.toISOString() : v;
      }, values));
      return new PivotContext(this.root, [[callid, values_1]].concat(this.calls));
    }
  }, {
    key: "getData",
    value: function (conv, tfs, isPreview) {
      var _this3 = this;

      return function (builder_) {
        return builder_.Delay(function () {
          var url = function () {
            var folder = function folder(tfs_1) {
              return function (tupledArg) {
                var vals = (0, _String.join)(",", (0, _Seq.map)(function (value) {
                  return (0, _Util.toString)(value);
                }, tupledArg[1]));
                return (0, _String.replace)(tfs_1, tupledArg[0], vals);
              };
            };

            return function (array) {
              return (0, _Seq.fold)(function ($var354, $var355) {
                return folder($var354)($var355);
              }, tfs, array);
            };
          }()(_this3.calls);

          var url_1 = encodeURIComponent(url);
          var url_2 = _this3.root + "?" + url_1 + (isPreview ? "&preview" : "");

          _common.Log.trace("runtime", "Pivot: %s", url_2);

          return builder_.Bind(_common.Http.Request("GET", url_2), function (_arg1) {
            return builder_.Return((0, _from2.default)((0, _Seq.map)(conv, JSON.parse(_arg1))));
          });
        });
      }(_AsyncBuilder.singleton);
    }
  }]);
  return PivotContext;
}();

(0, _Symbol2.setType)("TheGamma.TypeProvidersRuntime.PivotContext", PivotContext);
//# sourceMappingURL=runtime.js.map