"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.BabelOperators = exports.Serializer = exports.Program = exports.Statement = exports.Expression = exports.ObjectMember = exports.VariableDeclarator = exports.VariableDeclarationKind = exports.Pattern = exports.BinaryOperator = exports.AssignmentOperator = exports.SourceLocation = exports.Position = undefined;

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _Util = require("fable-core/umd/Util");

var _List = require("fable-core/umd/List");

var _List2 = _interopRequireDefault(_List);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Position = exports.Position = function () {
    function Position(line, column) {
        (0, _classCallCheck3.default)(this, Position);
        this.line = line;
        this.column = column;
    }

    (0, _createClass3.default)(Position, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.Position",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    line: "number",
                    column: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return Position;
}();

(0, _Symbol2.setType)("TheGamma.Babel.Position", Position);

var SourceLocation = exports.SourceLocation = function () {
    function SourceLocation(start, end) {
        (0, _classCallCheck3.default)(this, SourceLocation);
        this.start = start;
        this.end = end;
    }

    (0, _createClass3.default)(SourceLocation, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.SourceLocation",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    start: Position,
                    end: Position
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return SourceLocation;
}();

(0, _Symbol2.setType)("TheGamma.Babel.SourceLocation", SourceLocation);

var AssignmentOperator = exports.AssignmentOperator = function () {
    function AssignmentOperator(caseName, fields) {
        (0, _classCallCheck3.default)(this, AssignmentOperator);
        this.Case = caseName;
        this.Fields = fields;
    }

    (0, _createClass3.default)(AssignmentOperator, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.AssignmentOperator",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    AssignAndBitwise: [],
                    AssignDivide: [],
                    AssignEqual: [],
                    AssignMinus: [],
                    AssignModulus: [],
                    AssignMultiply: [],
                    AssignOrBitwise: [],
                    AssignPlus: [],
                    AssignShiftLeft: [],
                    AssignShiftRightSignPropagating: [],
                    AssignShiftRightZeroFill: [],
                    AssignXorBitwise: []
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsUnions)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareUnions)(this, other);
        }
    }]);
    return AssignmentOperator;
}();

(0, _Symbol2.setType)("TheGamma.Babel.AssignmentOperator", AssignmentOperator);

var BinaryOperator = exports.BinaryOperator = function () {
    function BinaryOperator(caseName, fields) {
        (0, _classCallCheck3.default)(this, BinaryOperator);
        this.Case = caseName;
        this.Fields = fields;
    }

    (0, _createClass3.default)(BinaryOperator, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.BinaryOperator",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    BinaryAndBitwise: [],
                    BinaryDivide: [],
                    BinaryEqual: [],
                    BinaryEqualStrict: [],
                    BinaryExponent: [],
                    BinaryGreater: [],
                    BinaryGreaterOrEqual: [],
                    BinaryIn: [],
                    BinaryInstanceOf: [],
                    BinaryLess: [],
                    BinaryLessOrEqual: [],
                    BinaryMinus: [],
                    BinaryModulus: [],
                    BinaryMultiply: [],
                    BinaryOrBitwise: [],
                    BinaryPlus: [],
                    BinaryShiftLeft: [],
                    BinaryShiftRightSignPropagating: [],
                    BinaryShiftRightZeroFill: [],
                    BinaryUnequal: [],
                    BinaryUnequalStrict: [],
                    BinaryXorBitwise: []
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsUnions)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareUnions)(this, other);
        }
    }]);
    return BinaryOperator;
}();

(0, _Symbol2.setType)("TheGamma.Babel.BinaryOperator", BinaryOperator);

var Pattern = exports.Pattern = function () {
    function Pattern(caseName, fields) {
        (0, _classCallCheck3.default)(this, Pattern);
        this.Case = caseName;
        this.Fields = fields;
    }

    (0, _createClass3.default)(Pattern, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.Pattern",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    IdentifierPattern: ["string", (0, _Util.Option)(SourceLocation)]
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsUnions)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareUnions)(this, other);
        }
    }]);
    return Pattern;
}();

(0, _Symbol2.setType)("TheGamma.Babel.Pattern", Pattern);

var VariableDeclarationKind = exports.VariableDeclarationKind = function () {
    function VariableDeclarationKind(caseName, fields) {
        (0, _classCallCheck3.default)(this, VariableDeclarationKind);
        this.Case = caseName;
        this.Fields = fields;
    }

    (0, _createClass3.default)(VariableDeclarationKind, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.VariableDeclarationKind",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    Const: [],
                    Let: [],
                    Var: []
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsUnions)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareUnions)(this, other);
        }
    }]);
    return VariableDeclarationKind;
}();

(0, _Symbol2.setType)("TheGamma.Babel.VariableDeclarationKind", VariableDeclarationKind);

var VariableDeclarator = exports.VariableDeclarator = function () {
    function VariableDeclarator(caseName, fields) {
        (0, _classCallCheck3.default)(this, VariableDeclarator);
        this.Case = caseName;
        this.Fields = fields;
    }

    (0, _createClass3.default)(VariableDeclarator, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.VariableDeclarator",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    VariableDeclarator: [Pattern, (0, _Util.Option)(Expression), (0, _Util.Option)(SourceLocation)]
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsUnions)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareUnions)(this, other);
        }
    }]);
    return VariableDeclarator;
}();

(0, _Symbol2.setType)("TheGamma.Babel.VariableDeclarator", VariableDeclarator);

var ObjectMember = exports.ObjectMember = function () {
    function ObjectMember(caseName, fields) {
        (0, _classCallCheck3.default)(this, ObjectMember);
        this.Case = caseName;
        this.Fields = fields;
    }

    (0, _createClass3.default)(ObjectMember, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.ObjectMember",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    ObjectProperty: [Expression, Expression, "boolean", (0, _Util.Option)(SourceLocation)]
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsUnions)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareUnions)(this, other);
        }
    }]);
    return ObjectMember;
}();

(0, _Symbol2.setType)("TheGamma.Babel.ObjectMember", ObjectMember);

var Expression = exports.Expression = function () {
    function Expression(caseName, fields) {
        (0, _classCallCheck3.default)(this, Expression);
        this.Case = caseName;
        this.Fields = fields;
    }

    (0, _createClass3.default)(Expression, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.Expression",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    ArrayExpression: [(0, _Util.makeGeneric)(_List2.default, {
                        T: Expression
                    }), (0, _Util.Option)(SourceLocation)],
                    AssignmentExpression: [AssignmentOperator, Expression, Expression, (0, _Util.Option)(SourceLocation)],
                    BinaryExpression: [BinaryOperator, Expression, Expression, (0, _Util.Option)(SourceLocation)],
                    BooleanLiteral: ["boolean", (0, _Util.Option)(SourceLocation)],
                    CallExpression: [Expression, (0, _Util.makeGeneric)(_List2.default, {
                        T: Expression
                    }), (0, _Util.Option)(SourceLocation)],
                    FunctionExpression: [(0, _Util.Option)("string"), (0, _Util.makeGeneric)(_List2.default, {
                        T: Pattern
                    }), Statement, "boolean", "boolean", (0, _Util.Option)(SourceLocation)],
                    IdentifierExpression: ["string", (0, _Util.Option)(SourceLocation)],
                    MemberExpression: [Expression, Expression, "boolean", (0, _Util.Option)(SourceLocation)],
                    NewExpression: [Expression, (0, _Util.makeGeneric)(_List2.default, {
                        T: Expression
                    }), (0, _Util.Option)(SourceLocation)],
                    NullLiteral: [(0, _Util.Option)(SourceLocation)],
                    NumericLiteral: ["number", (0, _Util.Option)(SourceLocation)],
                    ObjectExpression: [(0, _Util.makeGeneric)(_List2.default, {
                        T: ObjectMember
                    }), (0, _Util.Option)(SourceLocation)],
                    StringLiteral: ["string", (0, _Util.Option)(SourceLocation)]
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsUnions)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareUnions)(this, other);
        }
    }]);
    return Expression;
}();

(0, _Symbol2.setType)("TheGamma.Babel.Expression", Expression);

var Statement = exports.Statement = function () {
    function Statement(caseName, fields) {
        (0, _classCallCheck3.default)(this, Statement);
        this.Case = caseName;
        this.Fields = fields;
    }

    (0, _createClass3.default)(Statement, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.Statement",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    BlockStatement: [(0, _Util.makeGeneric)(_List2.default, {
                        T: Statement
                    }), (0, _Util.Option)(SourceLocation)],
                    EmptyStatement: [(0, _Util.Option)(SourceLocation)],
                    ExpressionStatement: [Expression, (0, _Util.Option)(SourceLocation)],
                    ReturnStatement: [Expression, (0, _Util.Option)(SourceLocation)],
                    VariableDeclaration: [VariableDeclarationKind, (0, _Util.makeGeneric)(_List2.default, {
                        T: VariableDeclarator
                    }), (0, _Util.Option)(SourceLocation)]
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsUnions)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareUnions)(this, other);
        }
    }]);
    return Statement;
}();

(0, _Symbol2.setType)("TheGamma.Babel.Statement", Statement);

var Program = exports.Program = function () {
    function Program(location, body) {
        (0, _classCallCheck3.default)(this, Program);
        this.location = location;
        this.body = body;
    }

    (0, _createClass3.default)(Program, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.Program",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    location: (0, _Util.Option)(SourceLocation),
                    body: (0, _Util.makeGeneric)(_List2.default, {
                        T: Statement
                    })
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareRecords)(this, other);
        }
    }]);
    return Program;
}();

(0, _Symbol2.setType)("TheGamma.Babel.Program", Program);

var Serializer = exports.Serializer = function (__exports) {
    var createObj = __exports.createObj = function (props) {
        return (0, _Util.createObj)((0, _List.concat)(props));
    };

    var serializeBinaryOperator = __exports.serializeBinaryOperator = function (_arg1) {
        if (_arg1.Case === "BinaryUnequal") {
            return "!=";
        } else if (_arg1.Case === "BinaryEqualStrict") {
            return "===";
        } else if (_arg1.Case === "BinaryUnequalStrict") {
            return "!==";
        } else if (_arg1.Case === "BinaryLess") {
            return "<";
        } else if (_arg1.Case === "BinaryLessOrEqual") {
            return "<=";
        } else if (_arg1.Case === "BinaryGreater") {
            return ">";
        } else if (_arg1.Case === "BinaryGreaterOrEqual") {
            return ">=";
        } else if (_arg1.Case === "BinaryShiftLeft") {
            return "<<";
        } else if (_arg1.Case === "BinaryShiftRightSignPropagating") {
            return ">>";
        } else if (_arg1.Case === "BinaryShiftRightZeroFill") {
            return ">>>";
        } else if (_arg1.Case === "BinaryMinus") {
            return "-";
        } else if (_arg1.Case === "BinaryPlus") {
            return "+";
        } else if (_arg1.Case === "BinaryMultiply") {
            return "*";
        } else if (_arg1.Case === "BinaryDivide") {
            return "/";
        } else if (_arg1.Case === "BinaryModulus") {
            return "%";
        } else if (_arg1.Case === "BinaryExponent") {
            return "**";
        } else if (_arg1.Case === "BinaryOrBitwise") {
            return "|";
        } else if (_arg1.Case === "BinaryXorBitwise") {
            return "^";
        } else if (_arg1.Case === "BinaryAndBitwise") {
            return "&";
        } else if (_arg1.Case === "BinaryIn") {
            return "in";
        } else if (_arg1.Case === "BinaryInstanceOf") {
            return "instanceof";
        } else {
            return "==";
        }
    };

    var serializeAssignOperator = __exports.serializeAssignOperator = function (_arg1) {
        if (_arg1.Case === "AssignMinus") {
            return "-=";
        } else if (_arg1.Case === "AssignPlus") {
            return "+=";
        } else if (_arg1.Case === "AssignMultiply") {
            return "*=";
        } else if (_arg1.Case === "AssignDivide") {
            return "/=";
        } else if (_arg1.Case === "AssignModulus") {
            return "%=";
        } else if (_arg1.Case === "AssignShiftLeft") {
            return "<<=";
        } else if (_arg1.Case === "AssignShiftRightSignPropagating") {
            return ">>=";
        } else if (_arg1.Case === "AssignShiftRightZeroFill") {
            return ">>>=";
        } else if (_arg1.Case === "AssignOrBitwise") {
            return "|=";
        } else if (_arg1.Case === "AssignXorBitwise") {
            return "^=";
        } else if (_arg1.Case === "AssignAndBitwise") {
            return "&=";
        } else {
            return "=";
        }
    };

    var serializePattern = __exports.serializePattern = function (pat) {
        return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "Identifier"]]), (0, _List.ofArray)([["name", pat.Fields[0]]]), function () {
            var $var276 = pat.Fields[1];

            if ($var276 != null) {
                return (0, _List.ofArray)([["loc", $var276]]);
            } else {
                return new _List2.default();
            }
        }()]));
    };

    var serializeMember = __exports.serializeMember = function (mem) {
        return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "ObjectProperty"]]), (0, _List.ofArray)([["key", serializeExpression(mem.Fields[0])]]), (0, _List.ofArray)([["value", serializeExpression(mem.Fields[1])]]), (0, _List.ofArray)([["computed", mem.Fields[2]]]), function () {
            var $var277 = mem.Fields[3];

            if ($var277 != null) {
                return (0, _List.ofArray)([["loc", $var277]]);
            } else {
                return new _List2.default();
            }
        }()]));
    };

    var serializeDeclarator = __exports.serializeDeclarator = function (_arg1) {
        return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "VariableDeclarator"]]), (0, _List.ofArray)([["id", serializePattern(_arg1.Fields[0])]]), function () {
            var $var278 = (0, _Util.defaultArg)(_arg1.Fields[1], null, function (expr) {
                return serializeExpression(expr);
            });

            if ($var278 != null) {
                return (0, _List.ofArray)([["init", $var278]]);
            } else {
                return new _List2.default();
            }
        }(), function () {
            var $var279 = _arg1.Fields[2];

            if ($var279 != null) {
                return (0, _List.ofArray)([["loc", $var279]]);
            } else {
                return new _List2.default();
            }
        }()]));
    };

    var serializeExpression = __exports.serializeExpression = function (expr) {
        if (expr.Case === "NewExpression") {
            return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "NewExpression"]]), (0, _List.ofArray)([["callee", serializeExpression(expr.Fields[0])]]), (0, _List.ofArray)([["arguments", (0, _from2.default)((0, _List.map)(function (expr_1) {
                return serializeExpression(expr_1);
            }, expr.Fields[1]))]]), function () {
                var $var280 = expr.Fields[2];

                if ($var280 != null) {
                    return (0, _List.ofArray)([["loc", $var280]]);
                } else {
                    return new _List2.default();
                }
            }()]));
        } else if (expr.Case === "FunctionExpression") {
            return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "FunctionExpression"]]), function () {
                var $var281 = expr.Fields[0];

                if ($var281 != null) {
                    return (0, _List.ofArray)([["id", $var281]]);
                } else {
                    return new _List2.default();
                }
            }(), (0, _List.ofArray)([["params", (0, _from2.default)((0, _List.map)(function (pat) {
                return serializePattern(pat);
            }, expr.Fields[1]))]]), (0, _List.ofArray)([["body", serializeStatement(expr.Fields[2])]]), (0, _List.ofArray)([["generator", expr.Fields[3]]]), (0, _List.ofArray)([["async", expr.Fields[4]]]), function () {
                var $var282 = expr.Fields[5];

                if ($var282 != null) {
                    return (0, _List.ofArray)([["loc", $var282]]);
                } else {
                    return new _List2.default();
                }
            }()]));
        } else if (expr.Case === "AssignmentExpression") {
            return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "AssignmentExpression"]]), (0, _List.ofArray)([["left", serializeExpression(expr.Fields[1])]]), (0, _List.ofArray)([["right", serializeExpression(expr.Fields[2])]]), (0, _List.ofArray)([["operator", serializeAssignOperator(expr.Fields[0])]]), function () {
                var $var283 = expr.Fields[3];

                if ($var283 != null) {
                    return (0, _List.ofArray)([["loc", $var283]]);
                } else {
                    return new _List2.default();
                }
            }()]));
        } else if (expr.Case === "CallExpression") {
            return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "CallExpression"]]), (0, _List.ofArray)([["callee", serializeExpression(expr.Fields[0])]]), (0, _List.ofArray)([["arguments", (0, _from2.default)((0, _List.map)(function (expr_2) {
                return serializeExpression(expr_2);
            }, expr.Fields[1]))]]), function () {
                var $var284 = expr.Fields[2];

                if ($var284 != null) {
                    return (0, _List.ofArray)([["loc", $var284]]);
                } else {
                    return new _List2.default();
                }
            }()]));
        } else if (expr.Case === "MemberExpression") {
            return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "MemberExpression"]]), (0, _List.ofArray)([["object", serializeExpression(expr.Fields[0])]]), (0, _List.ofArray)([["property", serializeExpression(expr.Fields[1])]]), (0, _List.ofArray)([["computed", expr.Fields[2]]]), function () {
                var $var285 = expr.Fields[3];

                if ($var285 != null) {
                    return (0, _List.ofArray)([["loc", $var285]]);
                } else {
                    return new _List2.default();
                }
            }()]));
        } else if (expr.Case === "BinaryExpression") {
            return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "BinaryExpression"]]), (0, _List.ofArray)([["left", serializeExpression(expr.Fields[1])]]), (0, _List.ofArray)([["right", serializeExpression(expr.Fields[2])]]), (0, _List.ofArray)([["operator", serializeBinaryOperator(expr.Fields[0])]]), function () {
                var $var286 = expr.Fields[3];

                if ($var286 != null) {
                    return (0, _List.ofArray)([["loc", $var286]]);
                } else {
                    return new _List2.default();
                }
            }()]));
        } else if (expr.Case === "ObjectExpression") {
            return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "ObjectExpression"]]), (0, _List.ofArray)([["properties", (0, _from2.default)((0, _List.map)(function (mem) {
                return serializeMember(mem);
            }, expr.Fields[0]))]]), function () {
                var $var287 = expr.Fields[1];

                if ($var287 != null) {
                    return (0, _List.ofArray)([["loc", $var287]]);
                } else {
                    return new _List2.default();
                }
            }()]));
        } else if (expr.Case === "ArrayExpression") {
            return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "ArrayExpression"]]), (0, _List.ofArray)([["elements", (0, _from2.default)((0, _List.map)(function (expr_3) {
                return serializeExpression(expr_3);
            }, expr.Fields[0]))]]), function () {
                var $var288 = expr.Fields[1];

                if ($var288 != null) {
                    return (0, _List.ofArray)([["loc", $var288]]);
                } else {
                    return new _List2.default();
                }
            }()]));
        } else if (expr.Case === "NullLiteral") {
            return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "NullLiteral"]]), function () {
                var $var289 = expr.Fields[0];

                if ($var289 != null) {
                    return (0, _List.ofArray)([["loc", $var289]]);
                } else {
                    return new _List2.default();
                }
            }()]));
        } else if (expr.Case === "StringLiteral") {
            return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "StringLiteral"]]), (0, _List.ofArray)([["value", expr.Fields[0]]]), function () {
                var $var290 = expr.Fields[1];

                if ($var290 != null) {
                    return (0, _List.ofArray)([["loc", $var290]]);
                } else {
                    return new _List2.default();
                }
            }()]));
        } else if (expr.Case === "BooleanLiteral") {
            return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "BooleanLiteral"]]), (0, _List.ofArray)([["value", expr.Fields[0]]]), function () {
                var $var291 = expr.Fields[1];

                if ($var291 != null) {
                    return (0, _List.ofArray)([["loc", $var291]]);
                } else {
                    return new _List2.default();
                }
            }()]));
        } else if (expr.Case === "NumericLiteral") {
            return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "NumericLiteral"]]), (0, _List.ofArray)([["value", expr.Fields[0]]]), function () {
                var $var292 = expr.Fields[1];

                if ($var292 != null) {
                    return (0, _List.ofArray)([["loc", $var292]]);
                } else {
                    return new _List2.default();
                }
            }()]));
        } else {
            return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "Identifier"]]), (0, _List.ofArray)([["name", expr.Fields[0]]]), function () {
                var $var293 = expr.Fields[1];

                if ($var293 != null) {
                    return (0, _List.ofArray)([["loc", $var293]]);
                } else {
                    return new _List2.default();
                }
            }()]));
        }
    };

    var serializeStatement = __exports.serializeStatement = function (stm) {
        if (stm.Case === "BlockStatement") {
            return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "BlockStatement"]]), function () {
                var $var294 = stm.Fields[1];

                if ($var294 != null) {
                    return (0, _List.ofArray)([["loc", $var294]]);
                } else {
                    return new _List2.default();
                }
            }(), (0, _List.ofArray)([["body", (0, _from2.default)((0, _List.map)(function (stm_1) {
                return serializeStatement(stm_1);
            }, stm.Fields[0]))]])]));
        } else if (stm.Case === "EmptyStatement") {
            return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "EmptyStatement"]]), function () {
                var $var295 = stm.Fields[0];

                if ($var295 != null) {
                    return (0, _List.ofArray)([["loc", $var295]]);
                } else {
                    return new _List2.default();
                }
            }()]));
        } else if (stm.Case === "ReturnStatement") {
            return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "ReturnStatement"]]), function () {
                var $var296 = stm.Fields[1];

                if ($var296 != null) {
                    return (0, _List.ofArray)([["loc", $var296]]);
                } else {
                    return new _List2.default();
                }
            }(), (0, _List.ofArray)([["argument", serializeExpression(stm.Fields[0])]])]));
        } else if (stm.Case === "VariableDeclaration") {
            var kind = stm.Fields[0].Case === "Let" ? "let" : stm.Fields[0].Case === "Const" ? "const" : "var";
            return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "VariableDeclaration"]]), (0, _List.ofArray)([["kind", kind]]), (0, _List.ofArray)([["declarations", (0, _from2.default)((0, _List.map)(function (arg00_) {
                return serializeDeclarator(arg00_);
            }, stm.Fields[1]))]]), function () {
                var $var297 = stm.Fields[2];

                if ($var297 != null) {
                    return (0, _List.ofArray)([["loc", $var297]]);
                } else {
                    return new _List2.default();
                }
            }()]));
        } else {
            return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "ExpressionStatement"]]), function () {
                var $var298 = stm.Fields[1];

                if ($var298 != null) {
                    return (0, _List.ofArray)([["loc", $var298]]);
                } else {
                    return new _List2.default();
                }
            }(), (0, _List.ofArray)([["expression", serializeExpression(stm.Fields[0])]])]));
        }
    };

    var serializeProgram = __exports.serializeProgram = function (prog) {
        return createObj((0, _List.ofArray)([(0, _List.ofArray)([["type", "Program"]]), function () {
            var $var299 = prog.location;

            if ($var299 != null) {
                return (0, _List.ofArray)([["loc", $var299]]);
            } else {
                return new _List2.default();
            }
        }(), (0, _List.ofArray)([["sourceType", "module"]]), (0, _List.ofArray)([["body", (0, _from2.default)((0, _List.map)(function (stm) {
            return serializeStatement(stm);
        }, prog.body))]]), (0, _List.ofArray)([["directives", []]])]));
    };

    return __exports;
}({});

var BabelOperators = exports.BabelOperators = function (__exports) {
    var ident = __exports.ident = function (s) {
        return new Expression("IdentifierExpression", [s, null]);
    };

    var str = __exports.str = function (v) {
        return new Expression("StringLiteral", [v, null]);
    };

    var num = __exports.num = function (v) {
        return new Expression("NumericLiteral", [v, null]);
    };

    var bool = __exports.bool = function (v) {
        return new Expression("BooleanLiteral", [v, null]);
    };

    var arr = __exports.arr = function (l) {
        return new Expression("ArrayExpression", [l, null]);
    };

    var op_Dynamic = __exports.op_Dynamic = function (e, s) {
        return new Expression("MemberExpression", [e, new Expression("IdentifierExpression", [s, null]), false, null]);
    };

    var op_DivideQmarkDivide = __exports.op_DivideQmarkDivide = function (e, a) {
        return new Expression("MemberExpression", [e, a, true, null]);
    };

    var op_DivideAtDivide = __exports.op_DivideAtDivide = function (e, args) {
        return new Expression("CallExpression", [e, args, null]);
    };

    var func = __exports.func = function (v, f) {
        var body = new Statement("BlockStatement", [(0, _List.ofArray)([new Statement("ReturnStatement", [f(ident(v)), null])]), null]);
        return new Expression("FunctionExpression", [null, (0, _List.ofArray)([new Pattern("IdentifierPattern", [v, null])]), body, false, false, null]);
    };

    var funcN = __exports.funcN = function (n, f) {
        var args = (0, _List.initialize)(n, function (i) {
            return "_arg" + String(i);
        });
        var body = new Statement("BlockStatement", [(0, _List.ofArray)([new Statement("ReturnStatement", [f((0, _List.map)(function (s) {
            return ident(s);
        }, args)), null])]), null]);
        return new Expression("FunctionExpression", [null, (0, _List.map)(function (s_1) {
            return new Pattern("IdentifierPattern", [s_1, null]);
        }, args), body, false, false, null]);
    };

    return __exports;
}({});
//# sourceMappingURL=babel.js.map