"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LocationMapper = exports.LineColumnRange = undefined;

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _Util = require("fable-core/umd/Util");

var _Seq = require("fable-core/umd/Seq");

var _String = require("fable-core/umd/String");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LineColumnRange = exports.LineColumnRange = function () {
  function LineColumnRange(startLineNumber, startColumn, endLineNumber, endColumn) {
    (0, _classCallCheck3.default)(this, LineColumnRange);
    this.StartLineNumber = startLineNumber;
    this.StartColumn = startColumn;
    this.EndLineNumber = endLineNumber;
    this.EndColumn = endColumn;
  }

  (0, _createClass3.default)(LineColumnRange, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.LineColumnRange",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          StartLineNumber: "number",
          StartColumn: "number",
          EndLineNumber: "number",
          EndColumn: "number"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareRecords)(this, other);
    }
  }]);
  return LineColumnRange;
}();

(0, _Symbol2.setType)("TheGamma.LineColumnRange", LineColumnRange);

var LocationMapper = exports.LocationMapper = function () {
  (0, _createClass3.default)(LocationMapper, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.LocationMapper",
        properties: {}
      };
    }
  }]);

  function LocationMapper(code) {
    (0, _classCallCheck3.default)(this, LocationMapper);
    this.lengths = (0, _from2.default)((0, _Seq.map)(function (s) {
      return s.length;
    }, (0, _String.split)(code, "\n")));
  }

  (0, _createClass3.default)(LocationMapper, [{
    key: "AbsoluteToLineCol",
    value: function (offs) {
      var line = 0;
      var col = 0;
      var offs_1 = offs;

      while (line <= this.lengths.length ? offs_1 > this.lengths[line] : false) {
        offs_1 = offs_1 - this.lengths[line] - 1;
        line = line + 1;
      }

      return [line + 1, offs_1 + 1];
    }
  }, {
    key: "LineColToAbsolute",
    value: function (line, col) {
      var offs = 0;

      for (var l = 1; l <= line - 1; l++) {
        offs = offs + this.lengths[l - 1] + 1;
      }

      return offs + col - 1;
    }
  }]);
  return LocationMapper;
}();

(0, _Symbol2.setType)("TheGamma.LocationMapper", LocationMapper);
//# sourceMappingURL=locations.js.map