"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NestedChain = exports.LiveEvent = exports.LiveState = exports.LivePreview = exports.LiveEditorZone = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

exports.updateLiveState = updateLiveState;
exports.collectChain = collectChain;
exports.collectFirstChain = collectFirstChain;

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _html = require("../../libraries/html");

var _Util = require("fable-core/umd/Util");

var _ast = require("../ast/ast");

var _locations = require("../common/locations");

var _List = require("fable-core/umd/List");

var _List2 = _interopRequireDefault(_List);

var _astops = require("../ast/astops");

var _Seq = require("fable-core/umd/Seq");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LiveEditorZone = exports.LiveEditorZone = function () {
  function LiveEditorZone(line, preview) {
    (0, _classCallCheck3.default)(this, LiveEditorZone);
    this.Line = line;
    this.Preview = preview;
  }

  (0, _createClass3.default)(LiveEditorZone, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Live.Common.LiveEditorZone",
        interfaces: ["FSharpRecord"],
        properties: {
          Line: "number",
          Preview: _html.DomNode
        }
      };
    }
  }]);
  return LiveEditorZone;
}();

(0, _Symbol2.setType)("TheGamma.Live.Common.LiveEditorZone", LiveEditorZone);

var LivePreview = exports.LivePreview = function () {
  function LivePreview(iD, update, render, initialState) {
    (0, _classCallCheck3.default)(this, LivePreview);
    this.ID = iD;
    this.Update = update;
    this.Render = render;
    this.InitialState = initialState;
  }

  (0, _createClass3.default)(LivePreview, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Live.Common.LivePreview",
        interfaces: ["FSharpRecord"],
        properties: {
          ID: "string",
          Update: "function",
          Render: "function",
          InitialState: (0, _Util.GenericParam)("TState")
        }
      };
    }
  }]);
  return LivePreview;
}();

(0, _Symbol2.setType)("TheGamma.Live.Common.LivePreview", LivePreview);

var LiveState = exports.LiveState = function () {
  function LiveState(globals, code, program, mapper, location, selection, state, currentPreview) {
    (0, _classCallCheck3.default)(this, LiveState);
    this.Globals = globals;
    this.Code = code;
    this.Program = program;
    this.Mapper = mapper;
    this.Location = location;
    this.Selection = selection;
    this.State = state;
    this.CurrentPreview = currentPreview;
  }

  (0, _createClass3.default)(LiveState, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Live.Common.LiveState",
        interfaces: ["FSharpRecord"],
        properties: {
          Globals: (0, _Util.Interface)("System.Collections.Generic.IEnumerable"),
          Code: "string",
          Program: _ast.Program,
          Mapper: _locations.LocationMapper,
          Location: "number",
          Selection: (0, _Util.Option)(_locations.LineColumnRange),
          State: (0, _Util.GenericParam)("T"),
          CurrentPreview: (0, _Util.Option)((0, _Util.makeGeneric)(LivePreview, {
            TState: (0, _Util.Interface)("TheGamma.Live.Common.CustomLiveState"),
            TEvent: (0, _Util.Interface)("TheGamma.Live.Common.CustomLiveEvent")
          }))
        }
      };
    }
  }]);
  return LiveState;
}();

(0, _Symbol2.setType)("TheGamma.Live.Common.LiveState", LiveState);

var LiveEvent = exports.LiveEvent = function () {
  function LiveEvent(caseName, fields) {
    (0, _classCallCheck3.default)(this, LiveEvent);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(LiveEvent, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Live.Common.LiveEvent",
        interfaces: ["FSharpUnion"],
        cases: {
          CustomEvent: [(0, _Util.GenericParam)("T")],
          InitializeGlobals: [(0, _Util.Interface)("System.Collections.Generic.IEnumerable")],
          UpdateLocation: ["number"],
          UpdateSource: ["string", "number", _ast.Program, _locations.LocationMapper]
        }
      };
    }
  }]);
  return LiveEvent;
}();

(0, _Symbol2.setType)("TheGamma.Live.Common.LiveEvent", LiveEvent);

function updateLiveState(state, event) {
  if (event.Case === "UpdateLocation") {
    return new LiveState(state.Globals, state.Code, state.Program, state.Mapper, event.Fields[0], state.Selection, state.State, state.CurrentPreview);
  } else if (event.Case === "UpdateSource") {
    return new LiveState(state.Globals, event.Fields[0], event.Fields[2], event.Fields[3], event.Fields[1], state.Selection, state.State, state.CurrentPreview);
  } else if (event.Case === "CustomEvent") {
    return state;
  } else {
    return new LiveState(event.Fields[0], state.Code, state.Program, state.Mapper, state.Location, state.Selection, state.State, state.CurrentPreview);
  }
}

var NestedChain = exports.NestedChain = function () {
  function NestedChain(chain) {
    (0, _classCallCheck3.default)(this, NestedChain);
    this.Chain = chain;
  }

  (0, _createClass3.default)(NestedChain, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Live.Common.NestedChain",
        interfaces: ["FSharpRecord"],
        properties: {
          Chain: (0, _Util.makeGeneric)(_List2.default, {
            T: (0, _Util.Tuple)(["number", (0, _Util.makeGeneric)(_ast.Node, {
              T: _ast.Expr
            })])
          })
        }
      };
    }
  }]);
  return NestedChain;
}();

(0, _Symbol2.setType)("TheGamma.Live.Common.NestedChain", NestedChain);

function collectChain(acc, node) {
  collectChain: while (true) {
    if (node.Node.Case === "Call") {
      acc = new _List2.default([node.Node.Fields[1].Range.Start, node], acc);
      node = node.Node.Fields[0];
      continue collectChain;
    } else if (node.Node.Case === "Member") {
      acc = new _List2.default([node.Node.Fields[1].Range.Start, node], acc);
      node = node.Node.Fields[0];
      continue collectChain;
    } else if (node.Node.Case === "Variable") {
      return new _List2.default([node.Node.Fields[0].Range.Start, node], acc);
    } else {
      return null;
    }
  }
}

function collectFirstChain(expr) {
  var matchValue = collectChain(new _List2.default(), expr);
  var $var480 = matchValue != null ? matchValue.tail != null ? [0, matchValue] : [1] : [1];

  switch ($var480[0]) {
    case 0:
      return new NestedChain($var480[1]);

    case 1:
      var activePatternResult7975 = (0, _astops.$7C$ExprLeaf$7C$ExprNode$7C$)(expr.Node);

      if (activePatternResult7975.Case === "Choice2Of2") {
        return (0, _Seq.tryPick)(function (expr_1) {
          return collectFirstChain(expr_1);
        }, activePatternResult7975.Fields[0][0]);
      } else {
        return null;
      }

  }
}
//# sourceMappingURL=live.js.map