"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.preview = exports.$7C$HasShow$7C$_$7C$ = exports.ShowableEditorState = undefined;

var _symbol = require("babel-runtime/core-js/symbol");

var _symbol2 = _interopRequireDefault(_symbol);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

exports.commandAtLocation = commandAtLocation;
exports.updateBody = updateBody;
exports.updateShowableState = updateShowableState;
exports.renderShowable = renderShowable;

var _Seq = require("fable-core/umd/Seq");

var _Symbol3 = require("fable-core/umd/Symbol");

var _Symbol4 = _interopRequireDefault(_Symbol3);

var _html = require("../../libraries/html");

var _Util = require("fable-core/umd/Util");

var _common = require("../../libraries/common");

var _live = require("./live");

var _interpreter = require("../analyzer/interpreter");

var _List = require("fable-core/umd/List");

var _List2 = _interopRequireDefault(_List);

var _ast = require("../ast/ast");

var _astops = require("../ast/astops");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function commandAtLocation(loc, program) {
  return (0, _Seq.tryFind)(function (cmd) {
    return cmd.Range.Start <= loc ? cmd.Range.End + 1 >= loc : false;
  }, program.Body.Node);
}

var ShowableEditorState = exports.ShowableEditorState = function () {
  function ShowableEditorState(endLocation, preview, previewSymbol, previewID) {
    (0, _classCallCheck3.default)(this, ShowableEditorState);
    this.EndLocation = endLocation;
    this.Preview = preview;
    this.PreviewSymbol = previewSymbol;
    this.PreviewID = previewID;
  }

  (0, _createClass3.default)(ShowableEditorState, [{
    key: _Symbol4.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Live.Showable.ShowableEditorState",
        interfaces: ["FSharpRecord"],
        properties: {
          EndLocation: "number",
          Preview: _html.DomNode,
          PreviewSymbol: (0, _Util.Interface)("TheGamma.Common.Symbol"),
          PreviewID: "number"
        }
      };
    }
  }]);
  return ShowableEditorState;
}();

(0, _Symbol3.setType)("TheGamma.Live.Showable.ShowableEditorState", ShowableEditorState);

function _HasShow___(_arg1) {
  if (_arg1.Case === "Object") {
    var hasShow = _arg1.Fields[0].Members.some(function (_arg2) {
      var $var546 = _arg2.Name === "show" ? _arg2.Type.Case === "Method" ? _arg2.Type.Fields[0].tail != null ? _arg2.Type.Fields[0].head.Type.Case === "Primitive" ? _arg2.Type.Fields[0].head.Type.Fields[0].Case === "String" ? _arg2.Type.Fields[0].tail.tail == null ? [0] : [1] : [1] : [1] : [1] : [1] : [1];

      switch ($var546[0]) {
        case 0:
          return true;

        case 1:
          return false;
      }
    });

    if (hasShow) {
      return {};
    } else {
      return null;
    }
  } else {
    return null;
  }
}

exports.$7C$HasShow$7C$_$7C$ = _HasShow___;

function updateBody(trigger, state) {
  _common.Log.trace("live", "Showable - updating body");

  var matchValue = commandAtLocation(state.Location, state.Program);
  var $var547 = matchValue != null ? matchValue.Node.Case === "Expr" ? matchValue.Entity != null ? matchValue.Entity.Kind.Case === "RunCommand" ? [0, matchValue, matchValue.Node.Fields[0], matchValue.Entity.Kind.Fields[0]] : [1] : [1] : matchValue.Entity != null ? matchValue.Entity.Kind.Case === "LetCommand" ? [0, matchValue, matchValue.Node.Fields[1], matchValue.Entity.Kind.Fields[1]] : [1] : [1] : [1];

  switch ($var547[0]) {
    case 0:
      var chain = (0, _live.collectFirstChain)($var547[2]);
      var matchValue_1 = [$var547[3].Type, chain];

      var activePatternResult8378 = _HasShow___(matchValue_1[0]);

      if (activePatternResult8378 != null) {
        var matchValue_2 = (0, _interpreter.evaluate)(state.Globals, $var547[3]);

        if (matchValue_2 != null) {
          var id = !(0, _Util.equals)($var547[3].Symbol, state.State.PreviewSymbol) ? state.State.PreviewID + 1 : state.State.PreviewID;

          var placeholder = function (arg0) {
            return function (arg1) {
              return _html.El.op_Dynamic(arg0, arg1);
            };
          }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "placeholder")]))((0, _List.ofArray)([(0, _html.text)("Loading preview...")]));

          var dom = function (arg0_1) {
            return function (arg1_1) {
              return _html.El.op_Dynamic(arg0_1, arg1_1);
            };
          }(_html.h)("div")(new _List2.default())((0, _List.ofArray)([function (arg00) {
            return function (arg10) {
              return function (arg20) {
                return _html.h.delayed(arg00, arg10, arg20);
              };
            };
          }(String(id))(placeholder)(function (id_1) {
            _common.Log.trace("live", "Show: %O", matchValue_2.Value);

            matchValue_2.Value.show(id_1);
          })]));

          return function () {
            var State = new ShowableEditorState($var547[1].Range.End, dom, $var547[3].Symbol, id);
            return new _live.LiveState(state.Globals, state.Code, state.Program, state.Mapper, state.Location, state.Selection, State, state.CurrentPreview);
          }();
        } else {
          return null;
        }
      } else if (matchValue_1[1] != null) {
        var chain_1 = matchValue_1[1];
        return (0, _Seq.tryPick)(function (tupledArg) {
          var nm = new _ast.Name("preview");
          var matchValue_3 = tupledArg[1].Entity.Type;
          var $var548 = void 0;

          if (matchValue_3 != null) {
            if (matchValue_3.Case === "Object") {
              var activePatternResult8376 = function (obj) {
                return (0, _astops.$7C$FindMember$7C$_$7C$)(nm, obj);
              }(matchValue_3.Fields[0]);

              if (activePatternResult8376 != null) {
                $var548 = [0, activePatternResult8376];
              } else {
                $var548 = [1];
              }
            } else {
              $var548 = [1];
            }
          } else {
            $var548 = [1];
          }

          switch ($var548[0]) {
            case 0:
              var matchValue_4 = (0, _astops.pickMetaByType)("http://schema.org", "WebPage", $var548[1].Metadata);

              if (matchValue_4 != null) {
                var url = matchValue_4["url"];

                var dom_1 = function (arg0_2) {
                  return function (arg1_2) {
                    return _html.El.op_Dynamic(arg0_2, arg1_2);
                  };
                }(_html.h)("iframe")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("src", url)]))(new _List2.default());

                var id_2 = state.State.PreviewID + 1;
                return function () {
                  var State_1 = new ShowableEditorState($var547[1].Range.End, dom_1, $var547[3].Symbol, id_2);
                  return new _live.LiveState(state.Globals, state.Code, state.Program, state.Mapper, state.Location, state.Selection, State_1, state.CurrentPreview);
                }();
              } else {
                return null;
              }

            case 1:
              return null;
          }
        }, (0, _Seq.sortWith)(function (x, y) {
          return -(0, _Util.compare)(function (tuple) {
            return tuple[0];
          }(x), function (tuple) {
            return tuple[0];
          }(y));
        }, chain_1.Chain));
      } else {
        return null;
      }

    case 1:
      return null;
  }
}

function updateShowableState(trigger, state, event) {
  var $var549 = event.Case === "UpdateLocation" ? [0] : event.Case === "InitializeGlobals" ? [1] : event.Case === "CustomEvent" ? [1] : [0];

  switch ($var549[0]) {
    case 0:
      return function (state_1) {
        return updateBody(trigger, state_1);
      }(state);

    case 1:
      return state;
  }
}

function renderShowable(trigger, state) {
  var patternInput = state.Mapper.AbsoluteToLineCol(state.State.EndLocation);

  var dom = function (arg0) {
    return function (arg1) {
      return _html.El.op_Dynamic(arg0, arg1);
    };
  }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "pivot-preview")]))((0, _List.ofArray)([function (arg0_1) {
    return function (arg1_1) {
      return _html.El.op_Dynamic(arg0_1, arg1_1);
    };
  }(_html.h)("ul")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "tabs")]))((0, _List.ofArray)([function (arg0_2) {
    return function (arg1_2) {
      return _html.El.op_Dynamic(arg0_2, arg1_2);
    };
  }(_html.h)("li")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "selected")]))((0, _List.ofArray)([function (arg0_3) {
    return function (arg1_3) {
      return _html.El.op_Dynamic(arg0_3, arg1_3);
    };
  }(_html.h)("a")(new _List2.default())((0, _List.ofArray)([(0, _html.text)("preview")]))]))])), function (arg0_4) {
    return function (arg1_4) {
      return _html.El.op_Dynamic(arg0_4, arg1_4);
    };
  }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "preview-body")]))((0, _Seq.toList)((0, _Seq.delay)(function () {
    return (0, _Seq.singleton)(state.State.Preview);
  })))]));

  return new _live.LiveEditorZone(patternInput[0], dom);
}

var preview = exports.preview = new _live.LivePreview("Showable", function (trigger) {
  return function (state) {
    return function (event) {
      return updateShowableState(trigger, state, event);
    };
  };
}, function (trigger_1) {
  return function (state_1) {
    return renderShowable(trigger_1, state_1);
  };
}, function () {
  var PreviewID = 0;
  var PreviewSymbol = (0, _symbol2.default)();
  return new ShowableEditorState(0, (0, _html.text)("not created"), PreviewSymbol, PreviewID);
}());
//# sourceMappingURL=showable.js.map