"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.OpExpr = exports.Associativity = exports.$7C$Identifier$7C$_$7C$ = exports.Context = exports.ParsingContext = undefined;

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

exports.node = node;
exports.whiteAfter = whiteAfter;
exports.whiteBefore = whiteBefore;
exports.precedence = precedence;
exports.precClimb = precClimb;
exports.buildExpression = buildExpression;
exports.parseExpressionOrNamedParam = parseExpressionOrNamedParam;
exports.parseCallArgList = parseCallArgList;
exports.parsePlaceholderRecovery = parsePlaceholderRecovery;
exports.parsePlaceholder = parsePlaceholder;
exports.parseIdentAfterDot = parseIdentAfterDot;
exports.parseCallOrMember = parseCallOrMember;
exports.parseFunction = parseFunction;
exports.parseListElements = parseListElements;
exports.parseTerm = parseTerm;
exports.parseParenTermEnd = parseParenTermEnd;
exports.parseExpression = parseExpression;
exports.parseLetBindingBody = parseLetBindingBody;
exports.skipNestedTokens = skipNestedTokens;
exports.parseLetBinding = parseLetBinding;
exports.parseCommands = parseCommands;
exports.parseProgram = parseProgram;

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _Util = require("fable-core/umd/Util");

var _ast = require("../ast/ast");

var _Seq = require("fable-core/umd/Seq");

var _List = require("fable-core/umd/List");

var _List2 = _interopRequireDefault(_List);

var _astops = require("../ast/astops");

var _errors = require("../ast/errors");

var _Choice = require("fable-core/umd/Choice");

var _Choice2 = _interopRequireDefault(_Choice);

var _common = require("../../libraries/common");

var _tokenizer = require("./tokenizer");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ParsingContext = exports.ParsingContext = function () {
    function ParsingContext(tokens, whitespace, errors, silentMode, position) {
        (0, _classCallCheck3.default)(this, ParsingContext);
        this.Tokens = tokens;
        this.Whitespace = whitespace;
        this.Errors = errors;
        this.SilentMode = silentMode;
        this.Position = position;
    }

    (0, _createClass3.default)(ParsingContext, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.Parser.ParsingContext",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    Tokens: (0, _Util.Array)(_ast.Token),
                    Whitespace: (0, _Util.Array)(_ast.Token),
                    Errors: (0, _Util.Array)((0, _Util.makeGeneric)(_ast.Error, {
                        Range: _ast.Range
                    })),
                    SilentMode: "boolean",
                    Position: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsRecords)(this, other);
        }
    }]);
    return ParsingContext;
}();

(0, _Symbol2.setType)("TheGamma.Parser.ParsingContext", ParsingContext);

var Context = exports.Context = function (__exports) {
    var clone = __exports.clone = function (ctx) {
        var Whitespace = (0, _from2.default)(ctx.Whitespace);
        var Errors = (0, _from2.default)(ctx.Errors);
        var Position = ctx.Position;
        return new ParsingContext(ctx.Tokens, Whitespace, Errors, ctx.SilentMode, Position);
    };

    var next = __exports.next = function (ctx) {
        ctx.Position = ctx.Position + 1;
    };

    var error = __exports.error = function (ctx, e) {
        if (!ctx.SilentMode) {
            ctx.Errors.push(e);
        }
    };

    var silent = __exports.silent = function (ctx, f) {
        ctx.SilentMode = true;
        var res = f(ctx);
        ctx.SilentMode = false;
        return res;
    };

    var tokenIndent = __exports.tokenIndent = function (ctx) {
        tokenIndent: while (true) {
            var matchValue = ctx.Tokens[ctx.Position];
            var $var329 = matchValue.Token.Case === "Newline" ? [0] : matchValue.Token.Case === "Error" ? [1, matchValue] : matchValue.Token.Case === "White" ? [1, matchValue] : [2];

            switch ($var329[0]) {
                case 0:
                    var matchValue_1 = ctx.Tokens[ctx.Position + 1];

                    if (matchValue_1.Token.Case === "White") {
                        var s = matchValue_1.Token.Fields[0];
                        next(ctx);
                        next(ctx);
                        ctx.Whitespace.push(matchValue);
                        ctx.Whitespace.push(matchValue_1);
                        ctx = ctx;
                        continue tokenIndent;
                    } else {
                        return null;
                    }

                case 1:
                    ctx.Whitespace.push($var329[1]);
                    next(ctx);
                    ctx = ctx;
                    continue tokenIndent;

                case 2:
                    var white = (0, _Seq.toList)(ctx.Whitespace);
                    ctx.Whitespace.splice(0);
                    return [white, matchValue];
            }
        }
    };

    var tokenNonIndent = __exports.tokenNonIndent = function (ctx) {
        var matchValue = ctx.Tokens[ctx.Position];
        var $var330 = matchValue.Token.Case === "Newline" ? [0, matchValue] : matchValue.Token.Case === "White" ? ctx.Position === 0 ? [1] : [2] : [2];

        switch ($var330[0]) {
            case 0:
                var newNonEmptyLinePos = ctx.Position;
                var i = ctx.Position;

                while (i < ctx.Tokens.length) {
                    var matchValue_1 = ctx.Tokens[i].Token;

                    if (matchValue_1.Case === "Newline") {
                        newNonEmptyLinePos = i;
                        i = i + 1;
                    } else if (matchValue_1.Case === "White") {
                        i = i + 1;
                    } else {
                        i = ctx.Tokens.length;
                    }
                }

                ctx.Position = newNonEmptyLinePos;
                var matchValue_2 = ctx.Tokens[ctx.Position + 1];

                if (matchValue_2.Token.Case === "White") {
                    return null;
                } else {
                    next(ctx);
                    ctx.Whitespace.push($var330[1]);
                    var white = (0, _Seq.toList)(ctx.Whitespace);
                    ctx.Whitespace.splice(0);
                    return [white, matchValue_2];
                }

            case 1:
                return null;

            case 2:
                if (ctx.Position === 0 ? true : ctx.Position === ctx.Tokens.length - 1) {
                    return [new _List2.default(), matchValue];
                } else {
                    return null;
                }

        }
    };

    return __exports;
}({});

function node(rng, n) {
    return new _ast.Node(new _List2.default(), new _List2.default(), rng, n, null);
}

function whiteAfter(w, n) {
    var WhiteAfter = (0, _List.append)(n.WhiteAfter, w);
    return new _ast.Node(n.WhiteBefore, WhiteAfter, n.Range, n.Node, n.Entity);
}

function whiteBefore(w, n) {
    return new _ast.Node((0, _List.append)(w, n.WhiteBefore), n.WhiteAfter, n.Range, n.Node, n.Entity);
}

function _Identifier___(t_0, t_1) {
    var t = [t_0, t_1];
    var $var331 = t[1].Token.Case === "Ident" ? [0, t[1].Token.Fields[0], t[1].Range, t[0]] : t[1].Token.Case === "QIdent" ? [0, t[1].Token.Fields[0], t[1].Range, t[0]] : [1];

    switch ($var331[0]) {
        case 0:
            return function (n) {
                return whiteBefore($var331[3], n);
            }(node($var331[2], new _ast.Name($var331[1])));

        case 1:
            return null;
    }
}

exports.$7C$Identifier$7C$_$7C$ = _Identifier___;

var Associativity = exports.Associativity = function () {
    function Associativity(caseName, fields) {
        (0, _classCallCheck3.default)(this, Associativity);
        this.Case = caseName;
        this.Fields = fields;
    }

    (0, _createClass3.default)(Associativity, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.Parser.Associativity",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    Left: [],
                    Right: []
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return (0, _Util.equalsUnions)(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return (0, _Util.compareUnions)(this, other);
        }
    }]);
    return Associativity;
}();

(0, _Symbol2.setType)("TheGamma.Parser.Associativity", Associativity);

function precedence(_arg1) {
    var $var332 = _arg1.Case === "GreaterThan" ? [1] : _arg1.Case === "GreaterThanOrEqual" ? [1] : _arg1.Case === "LessThan" ? [1] : _arg1.Case === "LessThanOrEqual" ? [1] : _arg1.Case === "Plus" ? [2] : _arg1.Case === "Minus" ? [2] : _arg1.Case === "Modulo" ? [3] : _arg1.Case === "Multiply" ? [3] : _arg1.Case === "Divide" ? [3] : _arg1.Case === "Power" ? [4] : [0];

    switch ($var332[0]) {
        case 0:
            return [0, new Associativity("Left", [])];

        case 1:
            return [1, new Associativity("Left", [])];

        case 2:
            return [2, new Associativity("Left", [])];

        case 3:
            return [3, new Associativity("Left", [])];

        case 4:
            return [4, new Associativity("Right", [])];
    }
}

var OpExpr = exports.OpExpr = function () {
    function OpExpr(caseName, fields) {
        (0, _classCallCheck3.default)(this, OpExpr);
        this.Case = caseName;
        this.Fields = fields;
    }

    (0, _createClass3.default)(OpExpr, [{
        key: _Symbol3.default.reflection,
        value: function () {
            return {
                type: "TheGamma.Parser.OpExpr",
                interfaces: ["FSharpUnion"],
                cases: {
                    OpExpr: [(0, _Util.makeGeneric)(_ast.Node, {
                        T: _ast.Expr
                    }), (0, _Util.Option)((0, _Util.Tuple)([(0, _Util.makeGeneric)(_ast.Node, {
                        T: _ast.Operator
                    }), OpExpr]))]
                }
            };
        }
    }]);
    return OpExpr;
}();

(0, _Symbol2.setType)("TheGamma.Parser.OpExpr", OpExpr);

function precClimb(minPrec, _arg1) {
    var loop = function loop(result) {
        return function (next) {
            loop: while (true) {
                var $var333 = next != null ? function () {
                    var op = next[0];
                    var next_1 = next[1];
                    return precedence(op.Node)[0] >= minPrec;
                }() ? [0, next[1], next[0]] : [1] : [1];

                switch ($var333[0]) {
                    case 0:
                        var patternInput = precedence($var333[2].Node);
                        var nextMinPrec = patternInput[1].Equals(new Associativity("Left", [])) ? patternInput[0] + 1 : patternInput[0];
                        var patternInput_1 = precClimb(nextMinPrec, $var333[1]);
                        var result_1 = node((0, _astops.unionRanges)(result.Range, patternInput_1[0].Range), new _ast.Expr("Binary", [result, $var333[2], patternInput_1[0]]));
                        result = result_1;
                        next = patternInput_1[1];
                        continue loop;

                    case 1:
                        return [result, next];
                }
            }
        };
    };

    return loop(_arg1.Fields[0])(_arg1.Fields[1]);
}

function buildExpression(terms, term) {
    return precClimb(0, (0, _Seq.fold)(function (oe, tupledArg) {
        return new OpExpr("OpExpr", [tupledArg[0], [tupledArg[1], oe]]);
    }, new OpExpr("OpExpr", [term, null]), terms))[0];
}

function parseExpressionOrNamedParam(ctx) {
    var lookAheadCtx = Context.clone(ctx);
    var matchValue = Context.tokenIndent(lookAheadCtx);
    var $var334 = void 0;

    if (matchValue != null) {
        var activePatternResult6748 = _Identifier___(matchValue[0], matchValue[1]);

        if (activePatternResult6748 != null) {
            $var334 = [0, activePatternResult6748];
        } else {
            $var334 = [1];
        }
    } else {
        $var334 = [1];
    }

    switch ($var334[0]) {
        case 0:
            Context.next(lookAheadCtx);
            var matchValue_1 = Context.tokenIndent(lookAheadCtx);
            var $var335 = matchValue_1 != null ? matchValue_1[1].Token.Case === "Equals" ? [0, matchValue_1[1], matchValue_1[0]] : [1] : [1];

            switch ($var335[0]) {
                case 0:
                    Context.tokenIndent(ctx);
                    Context.next(ctx);
                    Context.tokenIndent(ctx);
                    Context.next(ctx);
                    var matchValue_2 = parseExpression(new _List2.default(), ctx);

                    if (matchValue_2 == null) {
                        (function (e) {
                            Context.error(ctx, e);
                        })(_errors.Parser.unexpectedTokenInArgList($var335[1].Range, $var335[1].Token));

                        return new _Choice2.default("Choice1Of2", [[whiteAfter($var335[2], $var334[1]), node(new _ast.Range($var334[1].Range.End, $var334[1].Range.End), new _ast.Expr("Empty", []))]]);
                    } else {
                        return new _Choice2.default("Choice1Of2", [[whiteAfter($var335[2], $var334[1]), matchValue_2]]);
                    }

                case 1:
                    return new _Choice2.default("Choice2Of2", [parseExpression(new _List2.default(), ctx)]);
            }

        case 1:
            return new _Choice2.default("Choice2Of2", [parseExpression(new _List2.default(), ctx)]);
    }
}

function parseCallArgList(afterComma, lastRng, acc, ctx) {
    var _loop = function _loop() {
        var patternInput = void 0;
        var matchValue = parseExpressionOrNamedParam(ctx);

        if (matchValue.Case === "Choice1Of2") {
            patternInput = [true, new _List2.default(new _ast.Argument(matchValue.Fields[0][0], matchValue.Fields[0][1]), acc)];
        } else if (matchValue.Fields[0] != null) {
            patternInput = [true, new _List2.default(new _ast.Argument(null, matchValue.Fields[0]), acc)];
        } else {
            patternInput = [false, acc];
        }

        var matchValue_1 = Context.tokenIndent(ctx);
        var $var336 = matchValue_1 != null ? matchValue_1[1].Token.Case === "RParen" ? [0, matchValue_1[1], matchValue_1[0]] : matchValue_1[1].Token.Case === "Comma" ? function () {
            var white = matchValue_1[0];
            var lastRng_1 = matchValue_1[1].Range;
            return patternInput[0];
        }() ? [1, matchValue_1[1].Range, matchValue_1[0]] : [2] : [2] : [2];

        switch ($var336[0]) {
            case 0:
                Context.next(ctx);

                if (afterComma ? !patternInput[0] : false) {
                    (function (e) {
                        Context.error(ctx, e);
                    })(_errors.Parser.unexpectedTokenInArgList(lastRng, new _ast.TokenKind("RParen", [])));
                }

                return {
                    v: [$var336[1].Range, $var336[2], (0, _List.reverse)(patternInput[1])]
                };

            case 1:
                Context.next(ctx);
                afterComma = true;
                lastRng = $var336[1];
                acc = patternInput[1];
                ctx = ctx;
                return "continue|parseCallArgList";

            case 2:
                var $var337 = matchValue_1 != null ? function () {
                    var t = matchValue_1[1];
                    return !t.Token.Equals(new _ast.TokenKind("EndOfFile", []));
                }() ? [0, matchValue_1[1]] : [1] : [1];

                switch ($var337[0]) {
                    case 0:
                        Context.next(ctx);

                        (function (e_1) {
                            Context.error(ctx, e_1);
                        })(_errors.Parser.unexpectedTokenInArgList($var337[1].Range, $var337[1].Token));

                        return {
                            v: Context.silent(ctx, function (ctx_1) {
                                return parseCallArgList(afterComma, $var337[1].Range, patternInput[1], ctx_1);
                            })
                        };

                    case 1:
                        (function (e_2) {
                            Context.error(ctx, e_2);
                        })(_errors.Parser.unexpectedScopeEndInArgList(lastRng));

                        return {
                            v: [lastRng, new _List2.default(), (0, _List.reverse)(patternInput[1])]
                        };
                }

        }
    };

    parseCallArgList: while (true) {
        var _ret = _loop();

        switch (_ret) {
            case "continue|parseCallArgList":
                continue parseCallArgList;

            default:
                if ((typeof _ret === "undefined" ? "undefined" : (0, _typeof3.default)(_ret)) === "object") return _ret.v;
        }
    }
}

function parsePlaceholderRecovery(silent, lastTokRng, lastTokOpt, whiteAcc, ctx) {
    var _loop2 = function _loop2() {
        var matchValue = Context.tokenIndent(ctx);
        var $var338 = matchValue != null ? matchValue[1].Token.Case === "RSquare" ? [0, matchValue[1].Range, matchValue[0]] : function () {
            var white = matchValue[0];
            var t = matchValue[1];
            return !t.Token.Equals(new _ast.TokenKind("EndOfFile", []));
        }() ? [1, matchValue[1], matchValue[0]] : [2] : [2];

        switch ($var338[0]) {
            case 0:
                Context.next(ctx);

                if (!silent) {
                    (function (e) {
                        Context.error(ctx, e);
                    })(_errors.Parser.unexpectedEndOfPlaceholder($var338[1]));
                }

                return {
                    v: [$var338[1], (0, _List.append)(whiteAcc, $var338[2])]
                };

            case 1:
                Context.next(ctx);

                if (!silent) {
                    (function (e_1) {
                        Context.error(ctx, e_1);
                    })(_errors.Parser.unexpectedTokenInPlaceholder($var338[1].Range, $var338[1].Token));
                }

                silent = true;
                lastTokRng = $var338[1].Range;
                lastTokOpt = $var338[1].Token;
                whiteAcc = (0, _List.append)(whiteAcc, (0, _List.append)($var338[2], (0, _List.ofArray)([$var338[1]])));
                ctx = ctx;
                return "continue|parsePlaceholderRecovery";

            case 2:
                if (!silent) {
                    (function (e_2) {
                        Context.error(ctx, e_2);
                    })(_errors.Parser.unexpectedScopeEndInPlaceholder(lastTokRng, lastTokOpt));
                }

                return {
                    v: [lastTokRng, whiteAcc]
                };
        }
    };

    parsePlaceholderRecovery: while (true) {
        var _ret2 = _loop2();

        switch (_ret2) {
            case "continue|parsePlaceholderRecovery":
                continue parsePlaceholderRecovery;

            default:
                if ((typeof _ret2 === "undefined" ? "undefined" : (0, _typeof3.default)(_ret2)) === "object") return _ret2.v;
        }
    }
}

function parsePlaceholder(rngLSQuare, ctx) {
    var matchValue = Context.tokenIndent(ctx);
    var $var339 = void 0;

    if (matchValue != null) {
        var activePatternResult6760 = _Identifier___(matchValue[0], matchValue[1]);

        if (activePatternResult6760 != null) {
            $var339 = [0, activePatternResult6760, matchValue[1]];
        } else {
            $var339 = [1];
        }
    } else {
        $var339 = [1];
    }

    switch ($var339[0]) {
        case 0:
            Context.next(ctx);

            var _matchValue_ = Context.tokenIndent(ctx);

            var $var340 = _matchValue_ != null ? _matchValue_[1].Token.Case === "Colon" ? [0, _matchValue_[1].Range, _matchValue_[0]] : [1] : [1];

            switch ($var340[0]) {
                case 0:
                    Context.next(ctx);
                    var matchValue_2 = parseExpression(new _List2.default(), ctx);

                    if (matchValue_2 != null) {
                        var matchValue_3 = Context.tokenIndent(ctx);
                        var $var341 = matchValue_3 != null ? matchValue_3[1].Token.Case === "RSquare" ? [0, matchValue_3[1].Range, matchValue_3[0]] : [1] : [1];

                        switch ($var341[0]) {
                            case 0:
                                Context.next(ctx);
                                return [$var341[1], new _ast.Expr("Placeholder", [whiteAfter($var340[2], $var339[1]), whiteAfter($var341[2], matchValue_2)])];

                            case 1:
                                var _patternInput = parsePlaceholderRecovery(false, matchValue_2.Range, null, new _List2.default(), ctx);

                                return [_patternInput[0], new _ast.Expr("Placeholder", [$var339[1], whiteAfter(_patternInput[1], matchValue_2)])];
                        }
                    } else {
                        var patternInput_1 = parsePlaceholderRecovery(false, $var340[1], new _ast.TokenKind("Colon", []), new _List2.default(), ctx);
                        return [patternInput_1[0], new _ast.Expr("Placeholder", [$var339[1], whiteAfter(patternInput_1[1], node(patternInput_1[0], new _ast.Expr("Empty", [])))])];
                    }

                case 1:
                    var patternInput_2 = parsePlaceholderRecovery(false, $var339[1].Range, $var339[2].Token, new _List2.default(), ctx);
                    return [patternInput_2[0], new _ast.Expr("Placeholder", [$var339[1], whiteAfter(patternInput_2[1], node(patternInput_2[0], new _ast.Expr("Empty", [])))])];
            }

        case 1:
            var patternInput_3 = parsePlaceholderRecovery(false, rngLSQuare, new _ast.TokenKind("LSquare", []), new _List2.default(), ctx);
            return [patternInput_3[0], new _ast.Expr("Placeholder", [node(rngLSQuare, new _ast.Name("")), whiteAfter(patternInput_3[1], node(patternInput_3[0], new _ast.Expr("Empty", [])))])];
    }
}

function parseIdentAfterDot(body, prevDotRng, prevDotTok, ctx) {
    var matchValue = Context.tokenIndent(ctx);
    var $var342 = void 0;

    if (matchValue != null) {
        var activePatternResult6763 = _Identifier___(matchValue[0], matchValue[1]);

        if (activePatternResult6763 != null) {
            $var342 = [0, activePatternResult6763];
        } else {
            $var342 = [1];
        }
    } else {
        $var342 = [1];
    }

    switch ($var342[0]) {
        case 0:
            Context.next(ctx);
            var body_1 = node((0, _astops.unionRanges)(body.Range, $var342[1].Range), new _ast.Expr("Member", [body, node($var342[1].Range, new _ast.Expr("Variable", [$var342[1]]))]));
            return parseCallOrMember(body_1, ctx);

        case 1:
            var $var343 = matchValue == null ? [1] : matchValue[1].Token.Case === "LSquare" ? [0, matchValue[1].Range, matchValue[0]] : matchValue[1].Token.Case === "EndOfFile" ? [1] : [2, matchValue[1], matchValue[0]];

            switch ($var343[0]) {
                case 0:
                    Context.next(ctx);

                    var _patternInput2 = parsePlaceholder($var343[1], ctx);

                    var body_2 = function (n) {
                        return whiteBefore($var343[2], n);
                    }(node((0, _astops.unionRanges)($var343[1], _patternInput2[0]), new _ast.Expr("Member", [body, node((0, _astops.unionRanges)(_patternInput2[0], $var343[1]), _patternInput2[1])])));

                    return parseCallOrMember(body_2, ctx);

                case 1:
                    (function (e) {
                        Context.error(ctx, e);
                    })(_errors.Parser.unexpectedScopeEndAfterDot(prevDotRng, prevDotTok));

                    var emptyRng = new _ast.Range(prevDotRng.End + 1, prevDotRng.End);
                    return node((0, _astops.unionRanges)(body.Range, emptyRng), new _ast.Expr("Member", [body, node(emptyRng, new _ast.Expr("Variable", [node(emptyRng, new _ast.Name(""))]))]));

                case 2:
                    Context.next(ctx);

                    (function (e_1) {
                        Context.error(ctx, e_1);
                    })(_errors.Parser.unexpectedTokenAfterDot($var343[1].Range, $var343[1].Token));

                    var emptyRng_1 = new _ast.Range(prevDotRng.End + 1, prevDotRng.End);
                    var body_3 = node((0, _astops.unionRanges)(body.Range, emptyRng_1), new _ast.Expr("Member", [body, node(emptyRng_1, new _ast.Expr("Variable", [node(emptyRng_1, new _ast.Name(""))]))]));
                    return Context.silent(ctx, function (ctx_1) {
                        return parseIdentAfterDot(body_3, prevDotRng, prevDotTok, ctx_1);
                    });
            }

    }
}

function parseCallOrMember(body, ctx) {
    var matchValue = Context.tokenIndent(ctx);
    var $var344 = matchValue != null ? matchValue[1].Token.Case === "LParen" ? [0, matchValue[1].Range, matchValue[0]] : matchValue[1].Token.Case === "Dot" ? [1, matchValue[1], matchValue[0]] : [2] : [2];

    switch ($var344[0]) {
        case 0:
            Context.next(ctx);

            var _patternInput3 = parseCallArgList(false, $var344[1], new _List2.default(), ctx);

            var body_1 = node((0, _astops.unionRanges)(body.Range, _patternInput3[0]), new _ast.Expr("Call", [body, whiteAfter(_patternInput3[1], node((0, _astops.unionRanges)($var344[1], _patternInput3[0]), _patternInput3[2]))]));

            var _matchValue_2 = Context.tokenIndent(ctx);

            var $var345 = _matchValue_2 != null ? _matchValue_2[1].Token.Case === "Dot" ? [0, _matchValue_2[1], _matchValue_2[0]] : [1] : [1];

            switch ($var345[0]) {
                case 0:
                    Context.next(ctx);
                    return parseIdentAfterDot(whiteAfter($var345[2], body_1), $var345[1].Range, $var345[1].Token, ctx);

                case 1:
                    return body_1;
            }

        case 1:
            Context.next(ctx);
            return parseIdentAfterDot(whiteAfter($var344[2], body), $var344[1].Range, $var344[1].Token, ctx);

        case 2:
            return body;
    }
}

function parseFunction(ctx, funRng) {
    var matchValue = Context.tokenIndent(ctx);
    var $var346 = void 0;

    if (matchValue != null) {
        var activePatternResult6774 = _Identifier___(matchValue[0], matchValue[1]);

        if (activePatternResult6774 != null) {
            $var346 = [0, activePatternResult6774];
        } else {
            $var346 = [1];
        }
    } else {
        $var346 = [1];
    }

    switch ($var346[0]) {
        case 0:
            Context.next(ctx);

            var _matchValue_3 = Context.tokenIndent(ctx);

            var $var347 = _matchValue_3 != null ? _matchValue_3[1].Token.Case === "Arrow" ? [0, _matchValue_3[1].Range, _matchValue_3[0]] : [1, _matchValue_3] : [1, _matchValue_3];

            switch ($var347[0]) {
                case 0:
                    Context.next(ctx);
                    var body = void 0;
                    var matchValue_2 = parseExpression(new _List2.default(), ctx);

                    if (matchValue_2 != null) {
                        body = matchValue_2;
                    } else {
                        (function (e) {
                            Context.error(ctx, e);
                        })(_errors.Parser.missingBodyOfFunc((0, _astops.unionRanges)(funRng, $var347[1])));

                        body = node(new _ast.Range($var347[1].End, $var347[1].End), new _ast.Expr("Empty", []));
                    }

                    var rng = (0, _astops.unionRanges)(funRng, body.Range);
                    return node(rng, new _ast.Expr("Function", [whiteAfter($var347[2], $var346[1]), body]));

                case 1:
                    var _patternInput4 = void 0;

                    if ($var347[1] != null) {
                        var whiteAfterId = $var347[1][0];
                        var t = $var347[1][1];
                        _patternInput4 = [t.Range, whiteAfterId];
                    } else {
                        _patternInput4 = [(0, _astops.unionRanges)(funRng, $var346[1].Range), new _List2.default()];
                    }

                    (function (e_1) {
                        Context.error(ctx, e_1);
                    })(_errors.Parser.missingArrowInFunc(_patternInput4[0]));

                    var body_1 = void 0;
                    var matchValue_3 = parseExpression(new _List2.default(), ctx);

                    if (matchValue_3 != null) {
                        body_1 = matchValue_3;
                    } else {
                        body_1 = node(new _ast.Range($var346[1].Range.End, $var346[1].Range.End), new _ast.Expr("Empty", []));
                    }

                    return node((0, _astops.unionRanges)(funRng, body_1.Range), new _ast.Expr("Function", [$var346[1], whiteBefore(_patternInput4[1], body_1)]));
            }

        case 1:
            if (matchValue == null) {
                (function (e_2) {
                    Context.error(ctx, e_2);
                })(_errors.Parser.unexpectedScopeEndInFunc(funRng));

                var rng_1 = new _ast.Range(funRng.End, funRng.End);
                return node(rng_1, new _ast.Expr("Function", [node(rng_1, new _ast.Name("")), node(rng_1, new _ast.Expr("Empty", []))]));
            } else {
                var white = matchValue[0];
                var t_1 = matchValue[1];

                (function (e_3) {
                    Context.error(ctx, e_3);
                })(_errors.Parser.unexpectedTokenAfterFun(t_1.Range, t_1.Token));

                var rng_2 = new _ast.Range(funRng.End, funRng.End);
                return function (n) {
                    return whiteBefore(white, n);
                }(node(rng_2, new _ast.Expr("Function", [node(rng_2, new _ast.Name("")), node(rng_2, new _ast.Expr("Empty", []))])));
            }

    }
}

function parseListElements(afterComma, lastRng, whiteStart, startRng, acc, ctx) {
    var _loop3 = function _loop3() {
        var patternInput = void 0;
        var matchValue = parseExpression(new _List2.default(), ctx);

        if (matchValue != null) {
            patternInput = [true, function (white) {
                return new _List2.default(whiteAfter(white, matchValue), acc);
            }];
        } else {
            patternInput = [false, function (_arg1) {
                return acc;
            }];
        }

        var matchValue_1 = Context.tokenIndent(ctx);
        var $var348 = matchValue_1 != null ? matchValue_1[1].Token.Case === "RSquare" ? [0, matchValue_1[1].Range, matchValue_1[0]] : matchValue_1[1].Token.Case === "Comma" ? [1, matchValue_1[1].Range, matchValue_1[0]] : function () {
            var t = matchValue_1[1];
            return !t.Token.Equals(new _ast.TokenKind("EndOfFile", []));
        }() ? [2, matchValue_1[1]] : [3] : [3];

        switch ($var348[0]) {
            case 0:
                Context.next(ctx);

                if (!patternInput[0] ? afterComma : false) {
                    (function (e) {
                        Context.error(ctx, e);
                    })(_errors.Parser.unexpectedTokenInList(lastRng, new _ast.TokenKind("Comma", [])));
                }

                return {
                    v: function (n) {
                        return whiteBefore($var348[2], n);
                    }(node((0, _astops.unionRanges)(startRng, $var348[1]), new _ast.Expr("List", [(0, _List.reverse)(patternInput[1](new _List2.default()))])))
                };

            case 1:
                Context.next(ctx);

                if (!patternInput[0] ? afterComma : false) {
                    (function (e_1) {
                        Context.error(ctx, e_1);
                    })(_errors.Parser.unexpectedTokenInList($var348[1], new _ast.TokenKind("Comma", [])));
                }

                afterComma = true;
                lastRng = $var348[1];
                whiteStart = whiteStart;
                startRng = startRng;
                acc = patternInput[1]($var348[2]);
                ctx = ctx;
                return "continue|parseListElements";

            case 2:
                Context.next(ctx);

                (function (e_2) {
                    Context.error(ctx, e_2);
                })(_errors.Parser.unexpectedTokenInList($var348[1].Range, $var348[1].Token));

                return {
                    v: Context.silent(ctx, function (ctx_1) {
                        return parseListElements(afterComma, $var348[1].Range, whiteStart, startRng, patternInput[1](new _List2.default()), ctx_1);
                    })
                };

            case 3:
                (function (e_3) {
                    Context.error(ctx, e_3);
                })(_errors.Parser.unexpectedScopeEndInList(lastRng));

                return {
                    v: node((0, _astops.unionRanges)(startRng, lastRng), new _ast.Expr("List", [(0, _List.reverse)(patternInput[1](new _List2.default()))]))
                };
        }
    };

    parseListElements: while (true) {
        var _ret3 = _loop3();

        switch (_ret3) {
            case "continue|parseListElements":
                continue parseListElements;

            default:
                if ((typeof _ret3 === "undefined" ? "undefined" : (0, _typeof3.default)(_ret3)) === "object") return _ret3.v;
        }
    }
}

function parseTerm(ctx) {
    var matchValue = Context.tokenIndent(ctx);
    var $var349 = void 0;

    if (matchValue != null) {
        var activePatternResult6792 = _Identifier___(matchValue[0], matchValue[1]);

        if (activePatternResult6792 != null) {
            $var349 = [0, activePatternResult6792];
        } else {
            $var349 = [1];
        }
    } else {
        $var349 = [1];
    }

    switch ($var349[0]) {
        case 0:
            Context.next(ctx);
            return parseCallOrMember(node($var349[1].Range, new _ast.Expr("Variable", [$var349[1]])), ctx);

        case 1:
            var $var350 = matchValue != null ? matchValue[1].Token.Case === "Number" ? [0, matchValue[1].Token.Fields[1], matchValue[1].Range, matchValue[0]] : matchValue[1].Token.Case === "String" ? [1, matchValue[1].Range, matchValue[1].Token.Fields[0], matchValue[0]] : matchValue[1].Token.Case === "Boolean" ? [2, matchValue[1].Token.Fields[0], matchValue[1].Range, matchValue[0]] : matchValue[1].Token.Case === "LParen" ? [3, matchValue[1], matchValue[0]] : matchValue[1].Token.Case === "LSquare" ? [4, matchValue[1], matchValue[0]] : matchValue[1].Token.Case === "Fun" ? [5, matchValue[1], matchValue[0]] : [6] : [6];

            switch ($var350[0]) {
                case 0:
                    Context.next(ctx);
                    return function (n) {
                        return whiteAfter($var350[3], n);
                    }(node($var350[2], new _ast.Expr("Number", [$var350[1]])));

                case 1:
                    Context.next(ctx);
                    return function (n_1) {
                        return whiteAfter($var350[3], n_1);
                    }(node($var350[1], new _ast.Expr("String", [$var350[2]])));

                case 2:
                    Context.next(ctx);
                    return function (n_2) {
                        return whiteAfter($var350[3], n_2);
                    }(node($var350[2], new _ast.Expr("Boolean", [$var350[1]])));

                case 3:
                    Context.next(ctx);
                    return parseParenTermEnd(new _List2.default($var350[1], (0, _List.reverse)($var350[2])), new _List2.default(), parseExpression(new _List2.default(), ctx), ctx);

                case 4:
                    Context.next(ctx);
                    return parseListElements(false, $var350[1].Range, $var350[2], $var350[1].Range, new _List2.default(), ctx);

                case 5:
                    Context.next(ctx);
                    return parseFunction(ctx, $var350[1].Range);

                case 6:
                    return null;
            }

    }
}

function parseParenTermEnd(wb, wa, bodyOpt, ctx) {
    var makeBody = function makeBody(wa_1) {
        var body = void 0;

        if (bodyOpt == null) {
            var rng = function (list) {
                return (0, _Seq.reduce)(function (r1, r2) {
                    return (0, _astops.unionRanges)(r1, r2);
                }, list);
            }((0, _List.map)(function (t) {
                return t.Range;
            }, (0, _List.append)((0, _List.ofArray)([wb.head]), wa_1)));

            (function (e) {
                Context.error(ctx, e);
            })(_errors.Parser.missingParenthesizedExpr(rng));

            body = node(rng, new _ast.Expr("Empty", []));
        } else {
            body = bodyOpt;
        }

        return whiteAfter((0, _List.reverse)(wa_1), whiteBefore((0, _List.reverse)(wb), body));
    };

    var matchValue = Context.tokenIndent(ctx);

    if (matchValue == null) {
        var rng_1 = bodyOpt != null ? bodyOpt.Range : wb.head.Range;

        (function (e_1) {
            Context.error(ctx, e_1);
        })(_errors.Parser.unexpectedScopeEndInParenthesizedExpr(rng_1));

        return makeBody(wa);
    } else if (matchValue[1].Token.Case === "RParen") {
        Context.next(ctx);
        return makeBody(new _List2.default(matchValue[1], (0, _List.append)((0, _List.reverse)(matchValue[0]), wa)));
    } else {
        Context.next(ctx);

        (function (e_2) {
            Context.error(ctx, e_2);
        })(_errors.Parser.unexpectedTokenInParenthesizedExpr(matchValue[1].Range, matchValue[1].Token));

        return Context.silent(ctx, function (ctx_1) {
            return parseParenTermEnd(wb, new _List2.default(matchValue[1], (0, _List.append)((0, _List.reverse)(matchValue[0]), wa)), bodyOpt, ctx_1);
        });
    }
}

function parseExpression(terms, ctx) {
    parseExpression: while (true) {
        var _matchValue = [terms, parseTerm(ctx)];

        if (_matchValue[1] == null) {
            if (_matchValue[0].tail != null) {
                var terms_1 = _matchValue[0].tail;
                var term = _matchValue[0].head[0];
                var op = _matchValue[0].head[1];

                (function (e) {
                    Context.error(ctx, e);
                })(_errors.Parser.unexpectedEndAfterOperator(op.Range, new _ast.TokenKind("Operator", [op.Node])));

                return buildExpression(terms_1, term);
            } else {
                return null;
            }
        } else {
            var _ret4 = function () {
                var term_1 = _matchValue[1];
                var matchValue_1 = Context.tokenIndent(ctx);

                if (matchValue_1 == null) {
                    return {
                        v: buildExpression(_matchValue[0], term_1)
                    };
                } else if (matchValue_1[1].Token.Case === "Equals") {
                    Context.next(ctx);
                    terms = new _List2.default([term_1, whiteBefore(matchValue_1[0], node(matchValue_1[1].Range, new _ast.Operator("Equals", [])))], _matchValue[0]);
                    ctx = ctx;
                    return "continue|parseExpression";
                } else if (matchValue_1[1].Token.Case === "Operator") {
                    Context.next(ctx);
                    terms = new _List2.default([term_1, whiteBefore(matchValue_1[0], node(matchValue_1[1].Range, matchValue_1[1].Token.Fields[0]))], _matchValue[0]);
                    ctx = ctx;
                    return "continue|parseExpression";
                } else {
                    return {
                        v: function (n) {
                            return whiteAfter(matchValue_1[0], n);
                        }(buildExpression(_matchValue[0], term_1))
                    };
                }
            }();

            switch (_ret4) {
                case "continue|parseExpression":
                    continue parseExpression;

                default:
                    if ((typeof _ret4 === "undefined" ? "undefined" : (0, _typeof3.default)(_ret4)) === "object") return _ret4.v;
            }
        }
    }
}

function parseLetBindingBody(lastRng, ctx) {
    var matchValue = parseExpression(new _List2.default(), ctx);

    if (matchValue == null) {
        var _matchValue_4 = Context.tokenIndent(ctx);

        if (_matchValue_4 != null) {
            var white = _matchValue_4[0];
            var t = _matchValue_4[1];

            (function (e) {
                Context.error(ctx, e);
            })(_errors.Parser.unexpectedTokenInLetBinding(t.Range, t.Token));

            return Context.silent(ctx, function (ctx_1) {
                return parseLetBindingBody(t.Range, ctx_1);
            });
        } else {
            (function (e_1) {
                Context.error(ctx, e_1);
            })(_errors.Parser.unexpectedScopeEndInLet(lastRng));

            return node(lastRng, new _ast.Expr("Empty", []));
        }
    } else {
        return matchValue;
    }
}

function skipNestedTokens(firstTok, white, ctx) {
    skipNestedTokens: while (true) {
        var _matchValue2 = Context.tokenIndent(ctx);

        if (_matchValue2 != null) {
            if (_matchValue2[1].Token.Case === "EndOfFile") {
                return [(0, _Util.equals)(firstTok, null) ? _matchValue2[1] : firstTok, (0, _List.append)(white, _matchValue2[0])];
            } else {
                Context.next(ctx);
                var firstTok_1 = (0, _Util.equals)(firstTok, null) ? _matchValue2[1] : firstTok;
                firstTok = firstTok_1;
                white = (0, _List.append)(white, (0, _List.append)(_matchValue2[0], (0, _List.ofArray)([_matchValue2[1]])));
                ctx = ctx;
                continue skipNestedTokens;
            }
        } else {
            return [firstTok, white];
        }
    }
}

function parseLetBinding(whiteBeforeLet, rngLet, ctx) {
    var matchValue = Context.tokenIndent(ctx);
    var $var351 = void 0;

    if (matchValue != null) {
        var activePatternResult6813 = _Identifier___(matchValue[0], matchValue[1]);

        if (activePatternResult6813 != null) {
            $var351 = [0, activePatternResult6813];
        } else {
            $var351 = [1];
        }
    } else {
        $var351 = [1];
    }

    switch ($var351[0]) {
        case 0:
            Context.next(ctx);

            var _matchValue_5 = Context.tokenIndent(ctx);

            if (_matchValue_5 == null) {
                (function (e) {
                    Context.error(ctx, e);
                })(_errors.Parser.missingBodyInLetBinding($var351[1].Range));

                var body = node(new _ast.Range($var351[1].Range.End, $var351[1].Range.End), new _ast.Expr("Empty", []));
                return function (n) {
                    return whiteBefore(whiteBeforeLet, n);
                }(node((0, _astops.unionRanges)(rngLet, $var351[1].Range), new _ast.Command("Let", [$var351[1], body])));
            } else if (_matchValue_5[1].Token.Case === "Equals") {
                Context.next(ctx);
                var body_1 = parseLetBindingBody(_matchValue_5[1].Range, ctx);
                return function (n_1) {
                    return whiteBefore(whiteBeforeLet, n_1);
                }(node((0, _astops.unionRanges)(rngLet, body_1.Range), new _ast.Command("Let", [whiteAfter(_matchValue_5[0], $var351[1]), body_1])));
            } else {
                (function (e_1) {
                    Context.error(ctx, e_1);
                })(_errors.Parser.unexpectedTokenInLetBinding(_matchValue_5[1].Range, _matchValue_5[1].Token));

                var body_2 = parseLetBindingBody(_matchValue_5[1].Range, ctx);
                return function (n_2) {
                    return whiteBefore(whiteBeforeLet, n_2);
                }(node((0, _astops.unionRanges)(rngLet, $var351[1].Range), new _ast.Command("Let", [whiteAfter(_matchValue_5[0], $var351[1]), body_2])));
            }

        case 1:
            if (matchValue == null) {
                (function (e_2) {
                    Context.error(ctx, e_2);
                })(_errors.Parser.missingBodyInLetBinding(rngLet));

                var rng = new _ast.Range(rngLet.End, rngLet.End);
                return function (n_3) {
                    return whiteBefore(whiteBeforeLet, n_3);
                }(function (n_4) {
                    return node(rng, n_4);
                }(new _ast.Command("Let", [node(rng, new _ast.Name("")), node(rng, new _ast.Expr("Empty", []))])));
            } else {
                var whiteAfterLet = matchValue[0];
                var t = matchValue[1];

                (function (e_3) {
                    Context.error(ctx, e_3);
                })(_errors.Parser.unexpectedTokenInLetBinding(t.Range, t.Token));

                var letEndRng = new _ast.Range(rngLet.End, rngLet.End);
                var body_3 = void 0;
                var matchValue_2 = parseExpression(new _List2.default(), ctx);

                if (matchValue_2 == null) {
                    var _patternInput5 = skipNestedTokens(null, new _List2.default(), ctx);

                    var skipRng = function (list) {
                        return (0, _Seq.reduce)(function (r1, r2) {
                            return (0, _astops.unionRanges)(r1, r2);
                        }, list);
                    }((0, _List.map)(function (t_1) {
                        return t_1.Range;
                    }, new _List2.default(t, _patternInput5[1])));

                    body_3 = whiteAfter(new _List2.default(t, _patternInput5[1]), node(skipRng, new _ast.Expr("Empty", [])));
                } else {
                    body_3 = matchValue_2;
                }

                return function (n_5) {
                    return whiteBefore(whiteBeforeLet, n_5);
                }(node((0, _astops.unionRanges)(rngLet, body_3.Range), new _ast.Command("Let", [whiteBefore(whiteAfterLet, node(letEndRng, new _ast.Name(""))), body_3])));
            }

    }
}

function parseCommands(acc, ctx) {
    var _loop4 = function _loop4() {
        var matchValue = Context.tokenNonIndent(ctx);

        if (matchValue == null) {
            var _patternInput6 = skipNestedTokens(null, new _List2.default(), ctx);

            var firstSkipped = _patternInput6[0];

            (function (e) {
                Context.error(ctx, e);
            })(_errors.Parser.unexpectedNestedTokenInCommand(firstSkipped.Range, firstSkipped.Token));

            var skipRng = function (list) {
                return (0, _Seq.reduce)(function (r1, r2) {
                    return (0, _astops.unionRanges)(r1, r2);
                }, list);
            }((0, _List.map)(function (t) {
                return t.Range;
            }, new _List2.default(firstSkipped, _patternInput6[1])));

            var cmd = function (n) {
                return whiteAfter(_patternInput6[1], n);
            }(node(skipRng, new _ast.Command("Expr", [node(skipRng, new _ast.Expr("Empty", []))])));

            acc = new _List2.default(cmd, acc);
            ctx = ctx;
            return "continue|parseCommands";
        } else if (matchValue[1].Token.Case === "EndOfFile") {
            if (acc.tail == null) {
                return {
                    v: new _List2.default()
                };
            } else {
                return {
                    v: (0, _List.reverse)(new _List2.default(new _ast.Node(acc.head.WhiteBefore, matchValue[0], acc.head.Range, acc.head.Node, acc.head.Entity), acc.tail))
                };
            }
        } else if (matchValue[1].Token.Case === "Let") {
            Context.next(ctx);
            var cmd_1 = parseLetBinding(matchValue[0], matchValue[1].Range, ctx);
            acc = new _List2.default(cmd_1, acc);
            ctx = ctx;
            return "continue|parseCommands";
        } else {
            var _matchValue_6 = parseExpression(new _List2.default(), ctx);

            if (_matchValue_6 == null) {
                var patternInput_1 = skipNestedTokens(null, new _List2.default(), ctx);

                (function (e_1) {
                    Context.error(ctx, e_1);
                })(_errors.Parser.unexpectedNestedTokenInCommand(matchValue[1].Range, matchValue[1].Token));

                var skipRng_1 = function (list_1) {
                    return (0, _Seq.reduce)(function (r1_1, r2_1) {
                        return (0, _astops.unionRanges)(r1_1, r2_1);
                    }, list_1);
                }((0, _List.map)(function (t_1) {
                    return t_1.Range;
                }, new _List2.default(matchValue[1], patternInput_1[1])));

                var cmd_2 = whiteAfter(new _List2.default(matchValue[1], patternInput_1[1]), node(skipRng_1, new _ast.Command("Expr", [node(skipRng_1, new _ast.Expr("Empty", []))])));
                acc = new _List2.default(cmd_2, acc);
                ctx = ctx;
                return "continue|parseCommands";
            } else {
                var cmd_3 = function (n_1) {
                    return whiteBefore(matchValue[0], n_1);
                }(node(_matchValue_6.Range, new _ast.Command("Expr", [_matchValue_6])));

                acc = new _List2.default(cmd_3, acc);
                ctx = ctx;
                return "continue|parseCommands";
            }
        }
    };

    parseCommands: while (true) {
        var _ret5 = _loop4();

        switch (_ret5) {
            case "continue|parseCommands":
                continue parseCommands;

            default:
                if ((typeof _ret5 === "undefined" ? "undefined" : (0, _typeof3.default)(_ret5)) === "object") return _ret5.v;
        }
    }
}

function parseProgram(input) {
    try {
        var _patternInput7 = (0, _tokenizer.tokenize)(input);

        var ctx = void 0;
        var Position = 0;
        var SilentMode = false;
        var Errors = [];
        ctx = new ParsingContext(_patternInput7[0], [], Errors, SilentMode, Position);
        var cmds = parseCommands(new _List2.default(), ctx);

        var errors = _patternInput7[1].concat((0, _from2.default)(ctx.Errors));

        var rng_1 = (0, _Seq.fold)(function (rng, cmd) {
            return (0, _astops.unionRanges)(rng, cmd.Range);
        }, new _ast.Range(0, 0), cmds);
        return [new _ast.Program(node(rng_1, cmds)), errors];
    } catch (e) {
        _common.Log.exn("parsing", "Exception while parsing program: %O", e);

        var rng_2 = new _ast.Range(0, 0);

        var error = _errors.Parser.exceptionWhileParsing(rng_2, (0, _Util.toString)(e));

        return [new _ast.Program(node(rng_2, new _List2.default())), [error]];
    }
}
//# sourceMappingURL=parser.js.map