"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Context = undefined;

var _parseFloat = require("babel-runtime/core-js/number/parse-float");

var _parseFloat2 = _interopRequireDefault(_parseFloat);

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

exports.startsWith = startsWith;
exports.letter = letter;
exports.number = number;
exports.addAndTokenize = addAndTokenize;
exports.tokenizeIdent = tokenizeIdent;
exports.tokenizeString = tokenizeString;
exports.tokenizeStringEnd = tokenizeStringEnd;
exports.tokenizeQuotedIdent = tokenizeQuotedIdent;
exports.tokenizeQuotedIdentEnd = tokenizeQuotedIdentEnd;
exports.tokenizeWhite = tokenizeWhite;
exports.tokenizeNumber = tokenizeNumber;
exports.tokenizeInput = tokenizeInput;
exports.tokenize = tokenize;

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _Util = require("fable-core/umd/Util");

var _ast = require("../ast/ast");

var _List = require("fable-core/umd/List");

var _List2 = _interopRequireDefault(_List);

var _errors = require("../ast/errors");

var _String = require("fable-core/umd/String");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Context = exports.Context = function () {
  function Context(tokens, errors, input) {
    (0, _classCallCheck3.default)(this, Context);
    this.Tokens = tokens;
    this.Errors = errors;
    this.Input = input;
  }

  (0, _createClass3.default)(Context, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Tokenizer.Context",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          Tokens: (0, _Util.Array)(_ast.Token),
          Errors: (0, _Util.Array)((0, _Util.makeGeneric)(_ast.Error, {
            Range: _ast.Range
          })),
          Input: "string"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }]);
  return Context;
}();

(0, _Symbol2.setType)("TheGamma.Tokenizer.Context", Context);

function startsWith(s, i, j, prefix) {
  startsWith: while (true) {
    if (j === prefix.length) {
      return true;
    } else if (i === s.length) {
      return false;
    } else if (s[i] !== prefix[j]) {
      return false;
    } else {
      s = s;
      i = i + 1;
      j = j + 1;
      prefix = prefix;
      continue startsWith;
    }
  }
}

function letter(c) {
  if (c >= "a" ? c <= "z" : false) {
    return true;
  } else if (c >= "A") {
    return c <= "Z";
  } else {
    return false;
  }
}

function number(c) {
  if (c >= "0") {
    return c <= "9";
  } else {
    return false;
  }
}

function addAndTokenize(ctx, tok, i, l) {
  (function (arg00) {
    ctx.Tokens.push(arg00);
  })(new _ast.Token(tok, new _ast.Range(i, i + l - 1)));

  return tokenizeInput(ctx, i + l);
}

function tokenizeIdent(ctx, start, l) {
  tokenizeIdent: while (true) {
    if (start + l < ctx.Input.length ? letter(ctx.Input[start + l]) ? true : number(ctx.Input[start + l]) : false) {
      ctx = ctx;
      start = start;
      l = l + 1;
      continue tokenizeIdent;
    } else {
      return addAndTokenize(ctx, new _ast.TokenKind("Ident", [ctx.Input.substr(start, l)]), start, l);
    }
  }
}

function tokenizeString(ctx, acc, start, l) {
  tokenizeString: while (true) {
    if (start + l >= ctx.Input.length) {
      return tokenizeStringEnd(true, ctx, acc, start, l);
    } else {
      var matchValue = ctx.Input[start + l];
      var $var321 = matchValue === "\\" ? start + l + 1 >= ctx.Input.length ? [0] : [1] : [1];

      switch ($var321[0]) {
        case 0:
          return tokenizeStringEnd(true, ctx, new _List2.default("\\", acc), start, l + 1);

        case 1:
          if (matchValue === "\"") {
            return tokenizeStringEnd(false, ctx, acc, start, l + 1);
          } else if (matchValue === "\\") {
            var matchValue_1 = ctx.Input[start + l + 1];

            if (matchValue_1 === "\"") {
              ctx = ctx;
              acc = new _List2.default("\"", acc);
              start = start;
              l = l + 2;
              continue tokenizeString;
            } else if (matchValue_1 === "\\") {
              ctx = ctx;
              acc = new _List2.default("\\", acc);
              start = start;
              l = l + 2;
              continue tokenizeString;
            } else if (matchValue_1 === "n") {
              ctx = ctx;
              acc = new _List2.default("\n", acc);
              start = start;
              l = l + 2;
              continue tokenizeString;
            } else if (matchValue_1 === "t") {
              ctx = ctx;
              acc = new _List2.default("\t", acc);
              start = start;
              l = l + 2;
              continue tokenizeString;
            } else {
              ctx = ctx;
              acc = (0, _List.ofArray)([matchValue_1, "\\"], acc);
              start = start;
              l = l + 2;
              continue tokenizeString;
            }
          } else {
            ctx = ctx;
            acc = new _List2.default(matchValue, acc);
            start = start;
            l = l + 1;
            continue tokenizeString;
          }

      }
    }
  }
}

function tokenizeStringEnd(error, ctx, acc, start, l) {
  var str = (0, _from2.default)(acc).slice().reverse().join('');
  var rng = new _ast.Range(start, start + l);

  if (error) {
    ctx.Errors.push(_errors.Tokenizer.inputEndInsideString(rng, str));
  }

  return addAndTokenize(ctx, new _ast.TokenKind("String", [str]), start, l);
}

function tokenizeQuotedIdent(ctx, start, l) {
  tokenizeQuotedIdent: while (true) {
    if (start + l >= ctx.Input.length) {
      return tokenizeQuotedIdentEnd(true, ctx, start, l);
    } else {
      var matchValue = ctx.Input[start + l];

      if (matchValue === "\n") {
        return tokenizeQuotedIdentEnd(true, ctx, start, l + 1);
      } else if (matchValue === "'") {
        return tokenizeQuotedIdentEnd(false, ctx, start, l + 1);
      } else {
        ctx = ctx;
        start = start;
        l = l + 1;
        continue tokenizeQuotedIdent;
      }
    }
  }
}

function tokenizeQuotedIdentEnd(error, ctx, start, l) {
  var rng = new _ast.Range(start, start + l);
  var qid = ctx.Input.substr(start + 1, l - (error ? 1 : 2));
  var qid_1 = (0, _String.endsWith)(qid, "\n") ? qid.substr(0, qid.length - 1) : qid;

  if (error) {
    ctx.Errors.push(_errors.Tokenizer.missingClosingQuote(rng, qid_1));
  }

  return addAndTokenize(ctx, new _ast.TokenKind("QIdent", [qid_1]), start, l);
}

function tokenizeWhite(ctx, start, l) {
  tokenizeWhite: while (true) {
    if (start + l < ctx.Input.length ? ctx.Input[start + l] === " " : false) {
      ctx = ctx;
      start = start;
      l = l + 1;
      continue tokenizeWhite;
    } else {
      return addAndTokenize(ctx, new _ast.TokenKind("White", [ctx.Input.substr(start, l)]), start, l);
    }
  }
}

function tokenizeNumber(ctx, decimal, start, l) {
  tokenizeNumber: while (true) {
    if (start + l < ctx.Input.length ? number(ctx.Input[start + l]) : false) {
      ctx = ctx;
      decimal = decimal;
      start = start;
      l = l + 1;
      continue tokenizeNumber;
    } else if ((start + l < ctx.Input.length ? !decimal : false) ? ctx.Input[start + l] === "." : false) {
      ctx = ctx;
      decimal = true;
      start = start;
      l = l + 1;
      continue tokenizeNumber;
    } else {
      var str = ctx.Input.substr(start, l);
      return addAndTokenize(ctx, new _ast.TokenKind("Number", [str, (0, _parseFloat2.default)(str)]), start, l);
    }
  }
}

function tokenizeInput(ctx, i) {
  if (i >= ctx.Input.length) {
    return ctx;
  } else {
    var matchValue = ctx.Input[i];
    var $var322 = matchValue === "-" ? startsWith(ctx.Input, i, 0, "->") ? [0] : [1] : [1];

    switch ($var322[0]) {
      case 0:
        return addAndTokenize(ctx, new _ast.TokenKind("Arrow", []), i, 2);

      case 1:
        var $var323 = matchValue === "f" ? startsWith(ctx.Input, i, 0, "fun") ? [0] : [1] : [1];

        switch ($var323[0]) {
          case 0:
            return addAndTokenize(ctx, new _ast.TokenKind("Fun", []), i, 3);

          case 1:
            var $var324 = matchValue === "l" ? startsWith(ctx.Input, i, 0, "let") ? [0] : [1] : [1];

            switch ($var324[0]) {
              case 0:
                return addAndTokenize(ctx, new _ast.TokenKind("Let", []), i, 3);

              case 1:
                var $var325 = matchValue === "t" ? startsWith(ctx.Input, i, 0, "true") ? [0] : [1] : [1];

                switch ($var325[0]) {
                  case 0:
                    return addAndTokenize(ctx, new _ast.TokenKind("Boolean", [true]), i, 4);

                  case 1:
                    var $var326 = matchValue === "f" ? startsWith(ctx.Input, i, 0, "false") ? [0] : [1] : [1];

                    switch ($var326[0]) {
                      case 0:
                        return addAndTokenize(ctx, new _ast.TokenKind("Boolean", [false]), i, 5);

                      case 1:
                        var $var327 = matchValue === "<" ? startsWith(ctx.Input, i, 0, "<=") ? [0] : [1] : [1];

                        switch ($var327[0]) {
                          case 0:
                            return addAndTokenize(ctx, new _ast.TokenKind("Operator", [new _ast.Operator("LessThanOrEqual", [])]), i, 2);

                          case 1:
                            var $var328 = matchValue === ">" ? startsWith(ctx.Input, i, 0, ">=") ? [0] : [1] : [1];

                            switch ($var328[0]) {
                              case 0:
                                return addAndTokenize(ctx, new _ast.TokenKind("Operator", [new _ast.Operator("GreaterThanOrEqual", [])]), i, 2);

                              case 1:
                                if (matchValue === "\n") {
                                  return addAndTokenize(ctx, new _ast.TokenKind("Newline", []), i, 1);
                                } else if (matchValue === " ") {
                                  return tokenizeWhite(ctx, i, 1);
                                } else if (matchValue === "\"") {
                                  return tokenizeString(ctx, new _List2.default(), i, 1);
                                } else if (matchValue === "%") {
                                  return addAndTokenize(ctx, new _ast.TokenKind("Operator", [new _ast.Operator("Modulo", [])]), i, 1);
                                } else if (matchValue === "'") {
                                  return tokenizeQuotedIdent(ctx, i, 1);
                                } else if (matchValue === "(") {
                                  return addAndTokenize(ctx, new _ast.TokenKind("LParen", []), i, 1);
                                } else if (matchValue === ")") {
                                  return addAndTokenize(ctx, new _ast.TokenKind("RParen", []), i, 1);
                                } else if (matchValue === "*") {
                                  return addAndTokenize(ctx, new _ast.TokenKind("Operator", [new _ast.Operator("Multiply", [])]), i, 1);
                                } else if (matchValue === "+") {
                                  return addAndTokenize(ctx, new _ast.TokenKind("Operator", [new _ast.Operator("Plus", [])]), i, 1);
                                } else if (matchValue === ",") {
                                  return addAndTokenize(ctx, new _ast.TokenKind("Comma", []), i, 1);
                                } else if (matchValue === "-") {
                                  return addAndTokenize(ctx, new _ast.TokenKind("Operator", [new _ast.Operator("Minus", [])]), i, 1);
                                } else if (matchValue === ".") {
                                  return addAndTokenize(ctx, new _ast.TokenKind("Dot", []), i, 1);
                                } else if (matchValue === "/") {
                                  return addAndTokenize(ctx, new _ast.TokenKind("Operator", [new _ast.Operator("Divide", [])]), i, 1);
                                } else if (matchValue === ":") {
                                  return addAndTokenize(ctx, new _ast.TokenKind("Colon", []), i, 1);
                                } else if (matchValue === "<") {
                                  return addAndTokenize(ctx, new _ast.TokenKind("Operator", [new _ast.Operator("LessThan", [])]), i, 1);
                                } else if (matchValue === "=") {
                                  return addAndTokenize(ctx, new _ast.TokenKind("Equals", []), i, 1);
                                } else if (matchValue === ">") {
                                  return addAndTokenize(ctx, new _ast.TokenKind("Operator", [new _ast.Operator("GreaterThan", [])]), i, 1);
                                } else if (matchValue === "[") {
                                  return addAndTokenize(ctx, new _ast.TokenKind("LSquare", []), i, 1);
                                } else if (matchValue === "]") {
                                  return addAndTokenize(ctx, new _ast.TokenKind("RSquare", []), i, 1);
                                } else if (matchValue === "^") {
                                  return addAndTokenize(ctx, new _ast.TokenKind("Operator", [new _ast.Operator("Power", [])]), i, 1);
                                } else if (letter(matchValue)) {
                                  return tokenizeIdent(ctx, i, 1);
                                } else if (number(matchValue)) {
                                  return tokenizeNumber(ctx, false, i, 1);
                                } else {
                                  ctx.Errors.push(_errors.Tokenizer.unexpectedCharacter(new _ast.Range(i, i), matchValue));
                                  return addAndTokenize(ctx, new _ast.TokenKind("Error", [matchValue]), i, 1);
                                }

                            }

                        }

                    }

                }

            }

        }

    }
  }
}

function tokenize(input) {
  var ctx = void 0;
  var Errors = [];
  ctx = new Context([], Errors, input);
  var ctx_1 = tokenizeInput(ctx, 0);
  ctx_1.Tokens.push(new _ast.Token(new _ast.TokenKind("EndOfFile", []), new _ast.Range(input.length, input.length)));
  return [(0, _from2.default)(ctx_1.Tokens), (0, _from2.default)(ctx_1.Errors)];
}
//# sourceMappingURL=tokenizer.js.map