"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TypeSchema = exports.ExportedType = exports.PropertyMember = exports.MethodMember = exports.Argument = exports.NamedType = exports.FunctionType = exports.PrimitiveType = exports.ArrayType = exports.GenericParameterType = undefined;

var _map = require("babel-runtime/core-js/map");

var _map2 = _interopRequireDefault(_map);

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

exports.mapGenericType = mapGenericType;
exports.applyTypes = applyTypes;
exports.unifyTypes = unifyTypes;
exports.substituteTypeParams = substituteTypeParams;
exports.partiallySubstituteTypeParams = partiallySubstituteTypeParams;
exports.importProvidedType = importProvidedType;
exports.provideFSharpTypes = provideFSharpTypes;

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _Util = require("fable-core/umd/Util");

var _List = require("fable-core/umd/List");

var _List2 = _interopRequireDefault(_List);

var _ast = require("../ast/ast");

var _common = require("../../libraries/common");

var _AsyncBuilder = require("fable-core/umd/AsyncBuilder");

var _Seq = require("fable-core/umd/Seq");

var _typeops = require("../ast/typeops");

var _babel = require("../common/babel");

var _Map2 = require("fable-core/umd/Map");

var _runtime = require("../codegen/runtime");

var _String = require("fable-core/umd/String");

var _Lazy = require("fable-core/umd/Lazy");

var _Lazy2 = _interopRequireDefault(_Lazy);

var _providers = require("./providers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var GenericParameterType = exports.GenericParameterType = function () {
  function GenericParameterType(kind, name) {
    (0, _classCallCheck3.default)(this, GenericParameterType);
    this.kind = kind;
    this.name = name;
  }

  (0, _createClass3.default)(GenericParameterType, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.GenericParameterType",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          kind: "string",
          name: "string"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareRecords)(this, other);
    }
  }]);
  return GenericParameterType;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.FSharpProvider.GenericParameterType", GenericParameterType);

var ArrayType = exports.ArrayType = function () {
  function ArrayType(kind, element) {
    (0, _classCallCheck3.default)(this, ArrayType);
    this.kind = kind;
    this.element = element;
  }

  (0, _createClass3.default)(ArrayType, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.ArrayType",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          kind: "string",
          element: _Util.Any
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }]);
  return ArrayType;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.FSharpProvider.ArrayType", ArrayType);

var PrimitiveType = exports.PrimitiveType = function () {
  function PrimitiveType(kind, name) {
    (0, _classCallCheck3.default)(this, PrimitiveType);
    this.kind = kind;
    this.name = name;
  }

  (0, _createClass3.default)(PrimitiveType, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.PrimitiveType",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          kind: "string",
          name: "string"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareRecords)(this, other);
    }
  }]);
  return PrimitiveType;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.FSharpProvider.PrimitiveType", PrimitiveType);

var FunctionType = exports.FunctionType = function () {
  function FunctionType(kind, _arguments, returns) {
    (0, _classCallCheck3.default)(this, FunctionType);
    this.kind = kind;
    this.arguments = _arguments;
    this.returns = returns;
  }

  (0, _createClass3.default)(FunctionType, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.FunctionType",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          kind: "string",
          arguments: (0, _Util.Array)(_Util.Any),
          returns: _Util.Any
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }]);
  return FunctionType;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.FSharpProvider.FunctionType", FunctionType);

var NamedType = exports.NamedType = function () {
  function NamedType(kind, name, typargs) {
    (0, _classCallCheck3.default)(this, NamedType);
    this.kind = kind;
    this.name = name;
    this.typargs = typargs;
  }

  (0, _createClass3.default)(NamedType, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.NamedType",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          kind: "string",
          name: "string",
          typargs: (0, _Util.Array)(_Util.Any)
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }]);
  return NamedType;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.FSharpProvider.NamedType", NamedType);

var Argument = exports.Argument = function () {
  function Argument(name, optional, type) {
    (0, _classCallCheck3.default)(this, Argument);
    this.name = name;
    this.optional = optional;
    this.type = type;
  }

  (0, _createClass3.default)(Argument, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.Argument",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          name: "string",
          optional: "boolean",
          type: _Util.Any
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }]);
  return Argument;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.FSharpProvider.Argument", Argument);

var MethodMember = exports.MethodMember = function () {
  function MethodMember(kind, name, typepars, _arguments, returns) {
    (0, _classCallCheck3.default)(this, MethodMember);
    this.kind = kind;
    this.name = name;
    this.typepars = typepars;
    this.arguments = _arguments;
    this.returns = returns;
  }

  (0, _createClass3.default)(MethodMember, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.MethodMember",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          kind: "string",
          name: "string",
          typepars: (0, _Util.Array)(_Util.Any),
          arguments: (0, _Util.Array)(Argument),
          returns: _Util.Any
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }]);
  return MethodMember;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.FSharpProvider.MethodMember", MethodMember);

var PropertyMember = exports.PropertyMember = function () {
  function PropertyMember(kind, name, returns) {
    (0, _classCallCheck3.default)(this, PropertyMember);
    this.kind = kind;
    this.name = name;
    this.returns = returns;
  }

  (0, _createClass3.default)(PropertyMember, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.PropertyMember",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          kind: "string",
          name: "string",
          returns: _Util.Any
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }]);
  return PropertyMember;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.FSharpProvider.PropertyMember", PropertyMember);

var ExportedType = exports.ExportedType = function () {
  function ExportedType(name, typepars, _static, instance, members) {
    (0, _classCallCheck3.default)(this, ExportedType);
    this.name = name;
    this.typepars = typepars;
    this.static = _static;
    this.instance = instance;
    this.members = members;
  }

  (0, _createClass3.default)(ExportedType, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.ExportedType",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          name: "string",
          typepars: (0, _Util.Array)(_Util.Any),
          static: "boolean",
          instance: (0, _Util.Array)("string"),
          members: (0, _Util.Array)(_Util.Any)
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }]);
  return ExportedType;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.FSharpProvider.ExportedType", ExportedType);

var TypeSchema = exports.TypeSchema = function () {
  function TypeSchema(caseName, fields) {
    (0, _classCallCheck3.default)(this, TypeSchema);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(TypeSchema, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.TypeSchema",
        interfaces: ["FSharpUnion"],
        cases: {
          Function: [(0, _Util.makeGeneric)(_List2.default, {
            T: TypeSchema
          }), TypeSchema],
          GenericType: [(0, _Util.Interface)("TheGamma.TypeProviders.FSharpProvider.GenericTypeSchema")],
          List: [TypeSchema],
          Parameter: ["string"],
          Primitive: [_ast.Type]
        }
      };
    }
  }]);
  return TypeSchema;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.FSharpProvider.TypeSchema", TypeSchema);

function mapGenericType(typ, g) {
  var $var398 = typ.Case === "Delayed" ? [0, typ.Fields[0]] : typ.Case === "Object" ? (0, _Util.hasInterface)(typ.Fields[0], "TheGamma.TypeProviders.FSharpProvider.GenericTypeDefinition") ? [1, typ.Fields[0]] : [2, typ] : [2, typ];

  switch ($var398[0]) {
    case 0:
      return new _ast.Type("Delayed", [function (arg00) {
        return function (arg10) {
          return (0, _common.Async$2E$CreateNamedFuture$2E$Static)(arg00, arg10);
        };
      }("applyTypes")(function (builder_) {
        return builder_.Delay(function () {
          return builder_.Bind((0, _common.Async$2E$AwaitFuture$2E$Static)($var398[1]), function (_arg1) {
            return builder_.Return(mapGenericType(_arg1, g));
          });
        });
      }(_AsyncBuilder.singleton))]);

    case 1:
      return new _ast.Type("Object", [$var398[1].Apply((0, _Seq.toList)((0, _Seq.delay)(function () {
        return (0, _Seq.map)(function (t) {
          return new TypeSchema("Primitive", [t]);
        }, g($var398[1]));
      }))).Substitute(function (_arg1_1) {
        return null;
      })]);

    case 2:
      return $var398[1];
  }
}

function applyTypes(typ, tyargs) {
  var $var399 = typ.Case === "Delayed" ? [0, typ.Fields[0]] : typ.Case === "Object" ? (0, _Util.hasInterface)(typ.Fields[0], "TheGamma.TypeProviders.FSharpProvider.GenericTypeDefinition") ? [1, typ.Fields[0]] : [2] : [2];

  switch ($var399[0]) {
    case 0:
      return new _ast.Type("Delayed", [function (arg00) {
        return function (arg10) {
          return (0, _common.Async$2E$CreateNamedFuture$2E$Static)(arg00, arg10);
        };
      }("applyTypes")(function (builder_) {
        return builder_.Delay(function () {
          return builder_.Bind((0, _common.Async$2E$AwaitFuture$2E$Static)($var399[1]), function (_arg1) {
            return builder_.Return(applyTypes(_arg1, tyargs));
          });
        });
      }(_AsyncBuilder.singleton))]);

    case 1:
      return new _ast.Type("Object", [$var399[1].Apply((0, _Seq.toList)((0, _Seq.delay)(function () {
        return (0, _Seq.map)(function (t) {
          return new TypeSchema("Primitive", [t]);
        }, tyargs);
      }))).Substitute(function (_arg1_1) {
        return null;
      })]);

    case 2:
      throw new Error("applyTypes: Expected generic type definition");
  }
}

function unifyTypes(ctx, schemas, tys) {
  var _loop = function _loop() {
    var matchValue = [schemas, tys];
    var $var400 = matchValue[0].tail != null ? matchValue[0].head.Case === "GenericType" ? matchValue[1].tail != null ? matchValue[1].head.Case === "Object" ? (0, _Util.hasInterface)(matchValue[1].head.Fields[0], "TheGamma.TypeProviders.FSharpProvider.GenericType") ? function () {
      var ts_2 = matchValue[1].tail;
      var ss_2 = matchValue[0].tail;
      var gt = matchValue[1].head.Fields[0];
      var gs = matchValue[0].head.Fields[0];

      if (gt.TypeDefinition.FullName === gs.TypeDefinition.FullName) {
        return gs.TypeArguments.length === gt.TypeArguments.length;
      } else {
        return false;
      }
    }() ? [1, matchValue[0].head.Fields[0], matchValue[1].head.Fields[0], matchValue[0].tail, matchValue[1].tail] : [2] : [2] : [2] : [2] : [2] : matchValue[1].tail == null ? [0] : [2];

    switch ($var400[0]) {
      case 0:
        return {
          v: ctx
        };

      case 1:
        ctx = ctx;
        schemas = (0, _List.append)($var400[1].TypeArguments, $var400[3]);
        tys = (0, _List.append)($var400[2].TypeArguments, $var400[4]);
        return "continue|unifyTypes";

      case 2:
        var $var401 = matchValue[0].tail != null ? matchValue[0].head.Case === "Primitive" ? matchValue[1].tail != null ? function () {
          var ts_1 = matchValue[1].tail;
          var t2 = matchValue[1].head;
          var t1 = matchValue[0].head.Fields[0];
          var ss_1 = matchValue[0].tail;
          return (0, _typeops.typesEqual)(t1, t2);
        }() ? [0, matchValue[0].tail, matchValue[0].head.Fields[0], matchValue[1].head, matchValue[1].tail] : [1] : [1] : [1] : [1];

        switch ($var401[0]) {
          case 0:
            ctx = ctx;
            schemas = $var401[1];
            tys = $var401[4];
            return "continue|unifyTypes";

          case 1:
            var $var402 = matchValue[0].tail != null ? matchValue[0].head.Case === "Parameter" ? matchValue[1].tail != null ? [0, matchValue[0].head.Fields[0], matchValue[0].tail, matchValue[1].head, matchValue[1].tail] : [3] : matchValue[0].head.Case === "List" ? matchValue[1].tail != null ? matchValue[1].head.Case === "List" ? [1, matchValue[0].head.Fields[0], matchValue[0].tail, matchValue[1].head.Fields[0], matchValue[1].tail] : [3] : [3] : matchValue[0].head.Case === "Function" ? matchValue[1].tail != null ? matchValue[1].head.Case === "Method" ? function () {
              var ts = matchValue[1].tail;
              var tr_1 = matchValue[1].head.Fields[1];
              var ta_1 = matchValue[1].head.Fields[0];
              var ss = matchValue[0].tail;
              var sr = matchValue[0].head.Fields[1];
              var sa = matchValue[0].head.Fields[0];
              return sa.length === ta_1.length;
            }() ? [2, matchValue[0].head.Fields[0], matchValue[0].head.Fields[1], matchValue[0].tail, matchValue[1].head.Fields[0], matchValue[1].head.Fields[1], matchValue[1].tail] : [3] : [3] : [3] : [3] : [3];

            switch ($var402[0]) {
              case 0:
                ctx = new _List2.default([$var402[1], $var402[3]], ctx);
                schemas = $var402[2];
                tys = $var402[4];
                return "continue|unifyTypes";

              case 1:
                ctx = ctx;
                schemas = new _List2.default($var402[1], $var402[2]);
                tys = new _List2.default($var402[3], $var402[4]);
                return "continue|unifyTypes";

              case 2:
                var ta = (0, _Seq.toList)((0, _Seq.delay)(function () {
                  return (0, _Seq.map)(function (ma) {
                    return [ma.Type, null];
                  }, $var402[4]);
                }));
                var tr = (0, _Util.defaultArg)($var402[5](ta), new _ast.Type("Any", []));
                ctx = ctx;
                schemas = new _List2.default($var402[2], (0, _List.append)($var402[1], $var402[3]));
                tys = new _List2.default(tr, (0, _List.append)((0, _List.map)(function (tuple) {
                  return tuple[0];
                }, ta), $var402[6]));
                return "continue|unifyTypes";

              case 3:
                var $var403 = matchValue[0].tail == null ? [0] : matchValue[0].head.Case === "GenericType" ? [0] : matchValue[0].head.Case === "Primitive" ? [0] : matchValue[0].head.Case === "List" ? [0] : matchValue[0].head.Case === "Function" ? [0] : matchValue[1].tail == null ? [0] : [1];

                switch ($var403[0]) {
                  case 0:
                    var matchValue_1 = [schemas, tys];
                    var $var404 = matchValue_1[0].tail != null ? matchValue_1[1].tail != null ? [0, matchValue_1[0].head, matchValue_1[1].head] : [1] : [1];

                    switch ($var404[0]) {
                      case 0:
                        _common.Log.trace("providers", "Failed to unify types %O and %O", $var404[1], $var404[2]);

                        break;

                      case 1:
                        _common.Log.trace("providers", "Failed to unify types %O and %O", schemas, tys);

                        break;
                    }

                    return {
                      v: null
                    };

                  case 1:
                    throw new Error("C:\\Tomas\\Public\\the-gamma\\thegamma-script\\src\\thegamma\\providers/fsharp.fs", 126, 8);
                }

            }

        }

    }
  };

  unifyTypes: while (true) {
    var _ret = _loop();

    switch (_ret) {
      case "continue|unifyTypes":
        continue unifyTypes;

      default:
        if ((typeof _ret === "undefined" ? "undefined" : (0, _typeof3.default)(_ret)) === "object") return _ret.v;
    }
  }
}

function substituteTypeParams(assigns, schema) {
  if (schema.Case === "Primitive") {
    return schema.Fields[0];
  } else if (schema.Case === "List") {
    return new _ast.Type("List", [substituteTypeParams(assigns, schema.Fields[0])]);
  } else if (schema.Case === "Parameter") {
    var _matchValue = assigns(schema.Fields[0]);

    if (_matchValue != null) {
      return _matchValue;
    } else {
      throw new Error("substituteTypeParams: unresolved type parameter");
    }
  } else if (schema.Case === "Function") {
    var args = (0, _List.map)(function (it) {
      return new _ast.MethodArgument("", false, false, substituteTypeParams(assigns, it));
    }, schema.Fields[0]);
    return new _ast.Type("Method", [args, function (_arg1) {
      return substituteTypeParams(assigns, schema.Fields[1]);
    }]);
  } else {
    return new _ast.Type("Object", [schema.Fields[0].Substitute(assigns)]);
  }
}

function partiallySubstituteTypeParams(assigns, schema) {
  var $var405 = schema.Case === "Primitive" ? [0, schema.Fields[0]] : schema.Case === "List" ? [1, schema.Fields[0]] : schema.Case === "Parameter" ? function () {
    return assigns(schema.Fields[0]) != null;
  }(null) ? [2, schema.Fields[0]] : [3] : [3];

  switch ($var405[0]) {
    case 0:
      return new TypeSchema("Primitive", [$var405[1]]);

    case 1:
      return new TypeSchema("List", [partiallySubstituteTypeParams(assigns, $var405[1])]);

    case 2:
      return new TypeSchema("Primitive", [assigns($var405[1])]);

    case 3:
      if (schema.Case === "Parameter") {
        return new TypeSchema("Parameter", [schema.Fields[0]]);
      } else if (schema.Case === "Function") {
        return new TypeSchema("Function", [(0, _List.map)(function (schema_1) {
          return partiallySubstituteTypeParams(assigns, schema_1);
        }, schema.Fields[0]), partiallySubstituteTypeParams(assigns, schema.Fields[1])]);
      } else if (schema.Case === "GenericType") {
        return new TypeSchema("GenericType", [(0, _defineProperty3.default)({
          get Members() {
            throw new Error("Uninstantiated generic type schema");
          },

          TypeEquals: function (_arg1) {
            throw new Error("Uninstantiated generic type schema");
          },

          get TypeArguments() {
            return (0, _List.map)(function (schema_1) {
              return partiallySubstituteTypeParams(assigns, schema_1);
            }, schema.Fields[0].TypeArguments);
          },

          get TypeDefinition() {
            return schema.Fields[0].TypeDefinition;
          },

          Substitute: function (assigns2) {
            return schema.Fields[0].Substitute(function (n) {
              var matchValue = [assigns2(n), assigns(n)];
              var $var406 = matchValue[0] != null ? [0, matchValue[0]] : matchValue[1] != null ? [0, matchValue[1]] : [1];

              switch ($var406[0]) {
                case 0:
                  return $var406[1];

                case 1:
                  return null;
              }
            });
          }
        }, _Symbol3.default.reflection, function () {
          return {
            interfaces: ["TheGamma.TypeProviders.FSharpProvider.GenericTypeSchema"]
          };
        })]);
      } else {
        throw new Error("C:\\Tomas\\Public\\the-gamma\\thegamma-script\\src\\thegamma\\providers/fsharp.fs", 161, 8);
      }

  }
}

function importProvidedType(url, lookupNamed, exp) {
  var mapType = function mapType(t) {
    var matchValue = t.kind;

    switch (matchValue) {
      case "primitive":
        return new TypeSchema("Primitive", [function () {
          var matchValue_1 = t.name;

          switch (matchValue_1) {
            case "object":
              return new _ast.Type("Any", []);

            case "int":
            case "float":
              return new _ast.Type("Primitive", [new _ast.PrimitiveType("Number", [])]);

            case "string":
              return new _ast.Type("Primitive", [new _ast.PrimitiveType("String", [])]);

            case "bool":
              return new _ast.Type("Primitive", [new _ast.PrimitiveType("Bool", [])]);

            case "unit":
              return new _ast.Type("Primitive", [new _ast.PrimitiveType("Unit", [])]);

            case "date":
              return new _ast.Type("Primitive", [new _ast.PrimitiveType("Date", [])]);

            default:
              throw new Error("provideFSharpType: Unsupported type: " + matchValue_1);
          }
        }()]);

      case "function":
        var t_1 = t;
        return new TypeSchema("Function", [(0, _Seq.toList)((0, _from2.default)((0, _Seq.map)(mapType, t_1.arguments))), mapType(t_1.returns)]);

      case "named":
        var t_2 = t;
        var tyargs = (0, _List.ofArray)((0, _from2.default)((0, _Seq.map)(mapType, t_2.typargs)));
        var matchValue_2 = lookupNamed(t_2.name);
        var $var407 = matchValue_2.Case === "Object" ? (0, _Util.hasInterface)(matchValue_2.Fields[0], "TheGamma.TypeProviders.FSharpProvider.GenericTypeDefinition") ? [0, matchValue_2.Fields[0]] : [1, matchValue_2] : [1, matchValue_2];

        switch ($var407[0]) {
          case 0:
            if ($var407[1].TypeParameterCount !== tyargs.length) {
              throw new Error("provideFSharpType: Named type has mismatching nuumber of arguments");
            }

            return new TypeSchema("GenericType", [$var407[1].Apply(tyargs)]);

          case 1:
            return new TypeSchema("Primitive", [$var407[1]]);
        }

      case "parameter":
        return new TypeSchema("Parameter", [t.name]);

      case "array":
        return new TypeSchema("List", [mapType(t.element)]);

      default:
        throw new Error("provideFSharpType: Unexpected type");
    }
  };

  var getTypeParameters = function getTypeParameters(typars) {
    return (0, _List.ofArray)((0, _from2.default)((0, _Seq.map)(function (t_3) {
      var matchValue_3 = function (arg00) {
        return mapType(arg00);
      }(t_3);

      if (matchValue_3.Case === "Parameter") {
        return matchValue_3.Fields[0];
      } else {
        throw new Error("importProvidedType: expected type parameter");
      }
    }, typars)));
  };

  var generateMembers = function generateMembers(assigns) {
    return (0, _from2.default)((0, _Seq.choose)(function (m) {
      if (m.kind === "property") {
        var m_1 = m;
        var retTyp = substituteTypeParams(assigns, mapType(m_1.returns));
        var emitter = new _ast.Emitter(function (inst) {
          return new _babel.Expression("MemberExpression", [inst, new _babel.Expression("IdentifierExpression", [m_1.name, null]), false, null]);
        });
        return new _ast.Member(m_1.name, retTyp, new _List2.default(), emitter);
      } else if (m.kind === "method") {
        var m_2 = m;
        var typars_1 = getTypeParameters(m_2.typepars);

        var assigns_1 = function assigns_1(n) {
          if ((0, _Seq.exists)(function (y) {
            return n === y;
          }, typars_1)) {
            return null;
          } else {
            return assigns(n);
          }
        };

        var args = (0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.map)(function (a) {
            return [a.name, a.optional, partiallySubstituteTypeParams(assigns_1, mapType(a.type))];
          }, m_2.arguments);
        }));
        var emitter_1 = new _ast.Emitter(function (inst_1) {
          return new _babel.Expression("MemberExpression", [inst_1, new _babel.Expression("IdentifierExpression", [m_2.name, null]), false, null]);
        });
        var retTyp_1 = partiallySubstituteTypeParams(assigns_1, mapType(m_2.returns));

        var retFunc = function retFunc(tys) {
          var tys_1 = (0, _List.map)(function (tuple) {
            return tuple[0];
          }, tys);

          _common.Log.trace("providers", "F# provider unifying: %O, %O", (0, _from2.default)((0, _Seq.delay)(function () {
            return (0, _Seq.collect)(function (matchValue_4) {
              return (0, _Seq.singleton)(matchValue_4[2]);
            }, args);
          })), (0, _from2.default)(tys_1));

          var matchValue_6 = unifyTypes(new _List2.default(), (0, _Seq.toList)((0, _Seq.delay)(function () {
            return (0, _Seq.collect)(function (matchValue_5) {
              return (0, _Seq.singleton)(matchValue_5[2]);
            }, args);
          })), tys_1);

          if (matchValue_6 != null) {
            var assigns_3 = (0, _Seq.fold)(function (assigns_2, assign) {
              var matchValue_7 = [assigns_2, assign];
              var $var408 = matchValue_7[0] != null ? matchValue_7[1][1] != null ? [0, matchValue_7[1][1], matchValue_7[0], matchValue_7[1][0]] : [1] : [1];

              switch ($var408[0]) {
                case 0:
                  return new _List2.default([$var408[3], $var408[1]], $var408[2]);

                case 1:
                  return null;
              }
            }, new _List2.default(), (0, _Seq.map)(function (tupledArg) {
              return [tupledArg[0], (0, _Seq.fold)(function (st, tupledArg_1) {
                return st == null ? null : (0, _typeops.typesEqual)(st, tupledArg_1[1]) ? tupledArg_1[1] : null;
              }, new _ast.Type("Any", []), tupledArg[1])];
            }, (0, _Map2.groupBy)(function (tuple_1) {
              return tuple_1[0];
            }, matchValue_6)));
            var $var409 = assigns_3 != null ? assigns_3.length === typars_1.length ? [0, assigns_3] : [1] : [1];

            switch ($var409[0]) {
              case 0:
                var assigns_4 = new _map2.default($var409[1]);

                var subst = function subst(n_1) {
                  if (assigns_4.has(n_1)) {
                    return assigns_4.get(n_1);
                  } else {
                    return null;
                  }
                };

                return substituteTypeParams(subst, retTyp_1);

              case 1:
                return null;
            }
          } else {
            return null;
          }
        };

        var args_1 = (0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.collect)(function (matchValue_8) {
            return (0, _Seq.singleton)(new _ast.MethodArgument(matchValue_8[0], matchValue_8[1], false, substituteTypeParams(function (_arg2) {
              return new _ast.Type("Any", []);
            }, matchValue_8[2])));
          }, args);
        }));
        return new _ast.Member(m_2.name, new _ast.Type("Method", [args_1, retFunc]), new _List2.default(), emitter_1);
      } else {
        return null;
      }
    }, exp.members));
  };

  var objectType = void 0;
  var matchValue_9 = getTypeParameters(exp.typepars);

  if (matchValue_9.tail == null) {
    objectType = (0, _defineProperty3.default)({
      get Members() {
        return generateMembers(function (_arg3) {
          return null;
        });
      },

      TypeEquals: function (_arg1) {
        return false;
      }
    }, _Symbol3.default.reflection, function () {
      return {
        interfaces: ["TheGamma.ObjectType"]
      };
    });
  } else {
    objectType = (0, _defineProperty3.default)({
      get TypeParameterCount() {
        return matchValue_9.length;
      },

      get FullName() {
        return (0, _runtime.concatUrl)(url, exp.name);
      },

      get Members() {
        return (0, _String.fsFormat)("Uninstantiated generic type definition (%s)")(function (x) {
          throw new Error(x);
        })(this.FullName);
      },

      TypeEquals: function (_arg2) {
        return (0, _String.fsFormat)("Uninstantiated generic type definition (%s)")(function (x) {
          throw new Error(x);
        })(this.FullName);
      },
      Apply: function (tyargs) {
        var $var410 = this;
        return (0, _defineProperty3.default)({
          get Members() {
            throw new Error("Uninstantiated generic type schema");
          },

          get TypeDefinition() {
            return $var410;
          },

          TypeEquals: function (_arg3) {
            throw new Error("Uninstantiated generic type schema");
          },
          Substitute: function (assigns) {
            var tyArgLookup = new _map2.default((0, _Seq.toList)((0, _Seq.zip)(matchValue_9, tyargs)));
            var members = new _Lazy2.default(function () {
              return generateMembers(function (n) {
                var matchValue = (0, _Map2.tryGetValue)(tyArgLookup, n, null);

                if (matchValue[0]) {
                  return substituteTypeParams(assigns, matchValue[1]);
                } else {
                  return null;
                }
              });
            });
            var $var411 = this;
            return (0, _defineProperty3.default)({
              get TypeArguments() {
                return (0, _List.map)(function (schema) {
                  return substituteTypeParams(assigns, schema);
                }, tyargs);
              },

              get TypeDefinition() {
                return $var410;
              },

              get Members() {
                return members.value;
              },

              TypeEquals: function (t2) {
                if ((0, _Util.hasInterface)(t2, "TheGamma.TypeProviders.FSharpProvider.GenericType")) {
                  if (t2.TypeDefinition.FullName === this.TypeDefinition.FullName) {
                    return (0, _typeops.listsEqual)(this.TypeArguments, t2.TypeArguments, function (t1) {
                      return function (t2_1) {
                        return (0, _typeops.typesEqual)(t1, t2_1);
                      };
                    });
                  } else {
                    return false;
                  }
                } else {
                  return false;
                }
              }
            }, _Symbol3.default.reflection, function () {
              return {
                interfaces: ["TheGamma.TypeProviders.FSharpProvider.GenericType"]
              };
            });
          },

          get TypeArguments() {
            return tyargs;
          }

        }, _Symbol3.default.reflection, function () {
          return {
            interfaces: ["TheGamma.TypeProviders.FSharpProvider.GenericTypeSchema"]
          };
        });
      }
    }, _Symbol3.default.reflection, function () {
      return {
        interfaces: ["TheGamma.TypeProviders.FSharpProvider.GenericTypeDefinition"]
      };
    });
  }

  return new _ast.Type("Object", [objectType]);
}

function provideFSharpTypes(lookupNamed, url) {
  return function (builder_) {
    return builder_.Delay(function () {
      return builder_.Bind(_common.Http.Request("GET", url), function (_arg1) {
        var expTys = JSON.parse(_arg1);
        return builder_.Return((0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.map)(function (exp) {
            var ty = importProvidedType(url, lookupNamed, exp);

            if (exp.static) {
              var e = (0, _Seq.fold)(function (chain, s) {
                return chain != null ? new _babel.Expression("MemberExpression", [chain, new _babel.Expression("IdentifierExpression", [s, null]), false, null]) : new _babel.Expression("IdentifierExpression", [s, null]);
              }, null, exp.instance);
              var ty_1 = mapGenericType(ty, function (gtd) {
                return (0, _Seq.toList)((0, _Seq.delay)(function () {
                  return (0, _Seq.map)(function (i) {
                    return new _ast.Type("Any", []);
                  }, (0, _Seq.range)(1, gtd.TypeParameterCount));
                }));
              });
              return new _providers.ProvidedType("GlobalValue", [exp.name, new _List2.default(), e, ty_1]);
            } else {
              return new _providers.ProvidedType("NamedType", [exp.name, ty]);
            }
          }, expTys);
        })));
      });
    });
  }(_AsyncBuilder.singleton);
}
//# sourceMappingURL=fsharp.js.map