"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Context = exports.propertyEmitter = exports.PivotObject = exports.Transform = exports.Field = exports.Transformation = exports.RelationalOperator = exports.FilterOperator = exports.Paging = exports.SortDirection = exports.WindowAggregation = exports.GroupAggregation = undefined;

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

var _map = require("babel-runtime/core-js/map");

var _map2 = _interopRequireDefault(_map);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

exports.trimLeft = trimLeft;
exports.trimRight = trimRight;
exports.concatUrl = concatUrl;
exports.makeObjectType = makeObjectType;
exports.isNumeric = isNumeric;
exports.isBool = isBool;
exports.isDate = isDate;
exports.isConcatenable = isConcatenable;
exports.getTypeAndEmitter = getTypeAndEmitter;
exports.makeMethodEmitter = makeMethodEmitter;
exports.makeDataEmitter = makeDataEmitter;
exports.makeProperty = makeProperty;
exports.makeMethod = makeMethod;
exports.makeDataMember = makeDataMember;
exports.handleGetSeriesRequest = handleGetSeriesRequest;
exports.handlePagingRequest = handlePagingRequest;
exports.handleDropRequest = handleDropRequest;
exports.handleSortRequest = handleSortRequest;
exports.handleWindowRequest = handleWindowRequest;
exports.handleWindowExpandAggRequest = handleWindowExpandAggRequest;
exports.aggregationMembers = aggregationMembers;
exports.handleGroupAggRequest = handleGroupAggRequest;
exports.handleGroupRequest = handleGroupRequest;
exports.handleFilterEqNeqRequest = handleFilterEqNeqRequest;
exports.handleFilterRequest = handleFilterRequest;
exports.makePivotTypeImmediate = makePivotTypeImmediate;
exports.adjustForPreview = adjustForPreview;
exports.withPreview = withPreview;
exports.makePivotType = makePivotType;
exports.makePivotExpression = makePivotExpression;
exports.makePivotGlobalValue = makePivotGlobalValue;
exports.providePivotType = providePivotType;

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _Util = require("fable-core/umd/Util");

var _List = require("fable-core/umd/List");

var _List2 = _interopRequireDefault(_List);

var _ast = require("../ast/ast");

var _astops = require("../ast/astops");

var _String = require("fable-core/umd/String");

var _Seq = require("fable-core/umd/Seq");

var _Set = require("fable-core/umd/Set");

var _GenericComparer = require("fable-core/umd/GenericComparer");

var _GenericComparer2 = _interopRequireDefault(_GenericComparer);

var _babel = require("../common/babel");

var _typeops = require("../ast/typeops");

var _common = require("../../libraries/common");

var _fsharp = require("./fsharp");

var _Array = require("fable-core/umd/Array");

var _providers = require("./providers");

var _AsyncBuilder = require("fable-core/umd/AsyncBuilder");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var GroupAggregation = exports.GroupAggregation = function () {
  function GroupAggregation(caseName, fields) {
    (0, _classCallCheck3.default)(this, GroupAggregation);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(GroupAggregation, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.GroupAggregation",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          ConcatValues: ["string"],
          CountAll: [],
          CountDistinct: ["string"],
          GroupKey: [],
          Mean: ["string"],
          Sum: ["string"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsUnions)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareUnions)(this, other);
    }
  }]);
  return GroupAggregation;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.Pivot.GroupAggregation", GroupAggregation);

var WindowAggregation = exports.WindowAggregation = function () {
  function WindowAggregation(caseName, fields) {
    (0, _classCallCheck3.default)(this, WindowAggregation);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(WindowAggregation, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.WindowAggregation",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          FirstKey: [],
          LastKey: [],
          Max: ["string"],
          Mean: ["string"],
          MiddleKey: [],
          Min: ["string"],
          Sum: ["string"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsUnions)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareUnions)(this, other);
    }
  }]);
  return WindowAggregation;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.Pivot.WindowAggregation", WindowAggregation);

var SortDirection = exports.SortDirection = function () {
  function SortDirection(caseName, fields) {
    (0, _classCallCheck3.default)(this, SortDirection);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(SortDirection, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.SortDirection",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Ascending: [],
          Descending: []
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsUnions)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareUnions)(this, other);
    }
  }]);
  return SortDirection;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.Pivot.SortDirection", SortDirection);

var Paging = exports.Paging = function () {
  function Paging(caseName, fields) {
    (0, _classCallCheck3.default)(this, Paging);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(Paging, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.Paging",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Skip: ["string"],
          Take: ["string"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsUnions)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareUnions)(this, other);
    }
  }]);
  return Paging;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.Pivot.Paging", Paging);

var FilterOperator = exports.FilterOperator = function () {
  function FilterOperator(caseName, fields) {
    (0, _classCallCheck3.default)(this, FilterOperator);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(FilterOperator, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.FilterOperator",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          And: [],
          Or: []
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsUnions)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareUnions)(this, other);
    }
  }]);
  return FilterOperator;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.Pivot.FilterOperator", FilterOperator);

var RelationalOperator = exports.RelationalOperator = function () {
  function RelationalOperator(caseName, fields) {
    (0, _classCallCheck3.default)(this, RelationalOperator);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(RelationalOperator, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.RelationalOperator",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Equals: [],
          GreaterThan: [],
          InRange: [],
          LessThan: [],
          Like: [],
          NotEquals: []
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsUnions)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareUnions)(this, other);
    }
  }]);
  return RelationalOperator;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.Pivot.RelationalOperator", RelationalOperator);

var Transformation = exports.Transformation = function () {
  function Transformation(caseName, fields) {
    (0, _classCallCheck3.default)(this, Transformation);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(Transformation, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.Transformation",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          DropColumns: [(0, _Util.makeGeneric)(_List2.default, {
            T: "string"
          })],
          Empty: [],
          ExpandBy: ["string", (0, _Util.makeGeneric)(_List2.default, {
            T: WindowAggregation
          })],
          FilterBy: [FilterOperator, (0, _Util.makeGeneric)(_List2.default, {
            T: (0, _Util.Tuple)([RelationalOperator, "string", "string"])
          })],
          GetRange: ["string"],
          GetSeries: ["string", "string"],
          GetTheData: [],
          GroupBy: [(0, _Util.makeGeneric)(_List2.default, {
            T: "string"
          }), (0, _Util.makeGeneric)(_List2.default, {
            T: GroupAggregation
          })],
          Metadata: [],
          Paging: [(0, _Util.makeGeneric)(_List2.default, {
            T: Paging
          })],
          SortBy: [(0, _Util.makeGeneric)(_List2.default, {
            T: (0, _Util.Tuple)(["string", SortDirection])
          })],
          WindowBy: ["string", "string", (0, _Util.makeGeneric)(_List2.default, {
            T: WindowAggregation
          })]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsUnions)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareUnions)(this, other);
    }
  }]);
  return Transformation;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.Pivot.Transformation", Transformation);

var Field = exports.Field = function () {
  function Field(name, type) {
    (0, _classCallCheck3.default)(this, Field);
    this.Name = name;
    this.Type = type;
  }

  (0, _createClass3.default)(Field, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.Field",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          Name: "string",
          Type: _ast.PrimitiveType
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareRecords)(this, other);
    }
  }]);
  return Field;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.Pivot.Field", Field);

var Transform = exports.Transform = function (__exports) {
  var formatGroupAgg = function formatGroupAgg(_arg1) {
    if (_arg1.Case === "CountAll") {
      return "count-all";
    } else if (_arg1.Case === "CountDistinct") {
      return "count-dist " + (0, _astops.escapeIdent)(_arg1.Fields[0]);
    } else if (_arg1.Case === "ConcatValues") {
      return "concat-vals " + (0, _astops.escapeIdent)(_arg1.Fields[0]);
    } else if (_arg1.Case === "Sum") {
      return "sum " + (0, _astops.escapeIdent)(_arg1.Fields[0]);
    } else if (_arg1.Case === "Mean") {
      return "mean " + (0, _astops.escapeIdent)(_arg1.Fields[0]);
    } else {
      return "key";
    }
  };

  var formatWinAgg = function formatWinAgg(_arg1) {
    if (_arg1.Case === "MiddleKey") {
      return "mid-key";
    } else if (_arg1.Case === "LastKey") {
      return "last-key";
    } else if (_arg1.Case === "Mean") {
      return "mean " + (0, _astops.escapeIdent)(_arg1.Fields[0]);
    } else if (_arg1.Case === "Min") {
      return "min " + (0, _astops.escapeIdent)(_arg1.Fields[0]);
    } else if (_arg1.Case === "Max") {
      return "max " + (0, _astops.escapeIdent)(_arg1.Fields[0]);
    } else if (_arg1.Case === "Sum") {
      return "sum " + (0, _astops.escapeIdent)(_arg1.Fields[0]);
    } else {
      return "first-key";
    }
  };

  var formatCondition = __exports.formatCondition = function (op, f, v) {
    var op_1 = op.Case === "NotEquals" ? "neq" : op.Case === "LessThan" ? "lte" : op.Case === "GreaterThan" ? "gte" : op.Case === "InRange" ? "in" : op.Case === "Like" ? "like" : "eq";
    return (0, _astops.escapeIdent)(f) + " " + op_1 + " " + (0, _astops.escapeIdent)(v);
  };

  var toUrl = __exports.toUrl = function (transforms) {
    return (0, _String.join)("$", (0, _List.map)(function (tupledArg) {
      return tupledArg[1].tail == null ? tupledArg[0] : tupledArg[0] + "(" + (0, _String.join)(",", tupledArg[1]) + ")";
    }, (0, _List.concat)((0, _Seq.toList)((0, _Seq.delay)(function () {
      return (0, _Seq.map)(function (t) {
        return t.Case === "Metadata" ? (0, _List.ofArray)([["metadata", new _List2.default()]]) : t.Case === "GetRange" ? (0, _List.ofArray)([["range", (0, _List.ofArray)([t.Fields[0]])]]) : t.Case === "FilterBy" ? (0, _List.ofArray)([["filter", new _List2.default(t.Fields[0].Case === "Or" ? "or" : "and", (0, _List.map)(function (tupledArg_1) {
          return formatCondition(tupledArg_1[0], tupledArg_1[1], tupledArg_1[2]);
        }, t.Fields[1]))]]) : t.Case === "DropColumns" ? (0, _List.ofArray)([["drop", t.Fields[0]]]) : t.Case === "SortBy" ? (0, _List.ofArray)([["sort", (0, _List.map)(function (tupledArg_2) {
          return tupledArg_2[0] + (tupledArg_2[1].Equals(new SortDirection("Ascending", [])) ? " asc" : " desc");
        }, t.Fields[0])]]) : t.Case === "GroupBy" ? (0, _List.ofArray)([["groupby", (0, _List.append)((0, _List.map)(function (fld) {
          return "by " + (0, _astops.escapeIdent)(fld);
        }, t.Fields[0]), (0, _List.map)(function (_arg1) {
          return formatGroupAgg(_arg1);
        }, t.Fields[1]))]]) : t.Case === "WindowBy" ? (0, _List.ofArray)([["windowby", (0, _List.ofArray)(["by " + (0, _astops.escapeIdent)(t.Fields[0]), t.Fields[1]], (0, _List.map)(function (_arg1_1) {
          return formatWinAgg(_arg1_1);
        }, t.Fields[2]))]]) : t.Case === "ExpandBy" ? (0, _List.ofArray)([["expandby", new _List2.default("by " + (0, _astops.escapeIdent)(t.Fields[0]), (0, _List.map)(function (_arg1_2) {
          return formatWinAgg(_arg1_2);
        }, t.Fields[1]))]]) : t.Case === "Paging" ? (0, _List.map)(function (_arg1_3) {
          return _arg1_3.Case === "Skip" ? ["skip", (0, _List.ofArray)([_arg1_3.Fields[0]])] : ["take", (0, _List.ofArray)([_arg1_3.Fields[0]])];
        }, t.Fields[0]) : t.Case === "GetSeries" ? (0, _List.ofArray)([["series", (0, _List.ofArray)([t.Fields[0], t.Fields[1]])]]) : t.Case === "Empty" ? new _List2.default() : new _List2.default();
      }, transforms);
    })))));
  };

  var singleTransformFields = __exports.singleTransformFields = function (fields, _arg1) {
    var $var446 = _arg1.Case === "Metadata" ? [1] : _arg1.Case === "GetRange" ? [2] : _arg1.Case === "GetTheData" ? [3] : _arg1.Case === "SortBy" ? [4] : _arg1.Case === "Paging" ? [5] : _arg1.Case === "FilterBy" ? [6] : _arg1.Case === "GetSeries" ? [7] : _arg1.Case === "DropColumns" ? [8] : _arg1.Case === "ExpandBy" ? [9, _arg1.Fields[1], _arg1.Fields[0]] : _arg1.Case === "WindowBy" ? [9, _arg1.Fields[2], _arg1.Fields[0]] : _arg1.Case === "GroupBy" ? [10] : [0];

    switch ($var446[0]) {
      case 0:
        return fields;

      case 1:
        throw new Error("Metadata should not appear in normal queries");

      case 2:
        throw new Error("GetRange should not appear in normal queries");

      case 3:
        return fields;

      case 4:
        return fields;

      case 5:
        return fields;

      case 6:
        return fields;

      case 7:
        return (0, _List.ofArray)([(0, _Seq.find)(function (f) {
          return f.Name === _arg1.Fields[0];
        }, fields), (0, _Seq.find)(function (f_1) {
          return f_1.Name === _arg1.Fields[1];
        }, fields)]);

      case 8:
        var dropped = (0, _Set.create)(_arg1.Fields[0], new _GenericComparer2.default(_Util.compare));
        return (0, _List.filter)(function (f_2) {
          return !dropped.has(f_2.Name);
        }, fields);

      case 9:
        var oldFields = new _map2.default((0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.map)(function (f_3) {
            return [f_3.Name, f_3];
          }, fields);
        })));
        return (0, _List.collect)(function (_arg2) {
          var $var447 = _arg2.Case === "MiddleKey" ? [1] : _arg2.Case === "LastKey" ? [2] : _arg2.Case === "Mean" ? [3, _arg2.Fields[0]] : _arg2.Case === "Min" ? [3, _arg2.Fields[0]] : _arg2.Case === "Sum" ? [3, _arg2.Fields[0]] : _arg2.Case === "Max" ? [3, _arg2.Fields[0]] : [0];

          switch ($var447[0]) {
            case 0:
              return (0, _List.ofArray)([new Field("first " + $var446[2], oldFields.get($var446[2]).Type)]);

            case 1:
              return (0, _List.ofArray)([new Field("middle " + $var446[2], oldFields.get($var446[2]).Type)]);

            case 2:
              return (0, _List.ofArray)([new Field("last " + $var446[2], oldFields.get($var446[2]).Type)]);

            case 3:
              return (0, _List.ofArray)([oldFields.get($var447[1])]);
          }
        }, $var446[1]);

      case 10:
        var oldFields_1 = new _map2.default((0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.map)(function (f_4) {
            return [f_4.Name, f_4];
          }, fields);
        })));
        return (0, _List.collect)(function (_arg3) {
          var $var448 = _arg3.Case === "ConcatValues" ? [1, _arg3.Fields[0]] : _arg3.Case === "Sum" ? [1, _arg3.Fields[0]] : _arg3.Case === "Mean" ? [2] : _arg3.Case === "CountAll" ? [3] : _arg3.Case === "CountDistinct" ? [4] : [0];

          switch ($var448[0]) {
            case 0:
              return (0, _List.map)(function (f_5) {
                return oldFields_1.get(f_5);
              }, _arg1.Fields[0]);

            case 1:
              return (0, _List.ofArray)([oldFields_1.get($var448[1])]);

            case 2:
              return (0, _List.ofArray)([oldFields_1.get(_arg3.Fields[0])]);

            case 3:
              return (0, _List.ofArray)([new Field("count", new _ast.PrimitiveType("Number", []))]);

            case 4:
              return (0, _List.ofArray)([new Field(oldFields_1.get(_arg3.Fields[0]).Name, new _ast.PrimitiveType("Number", []))]);
          }
        }, _arg1.Fields[1]);
    }
  };

  var transformFields = __exports.transformFields = function (fields, tfs) {
    return (0, _Seq.toList)(function () {
      var state = (0, _Seq.toList)(fields);
      return function (list) {
        return (0, _Seq.fold)(function (fields_1, _arg1) {
          return singleTransformFields(fields_1, _arg1);
        }, state, list);
      };
    }()(tfs));
  };

  return __exports;
}({});

function trimLeft(c, s) {
  return (0, _from2.default)((0, _Seq.skipWhile)(function (y) {
    return c === y;
  }, s.split(""))).join('');
}

function trimRight(c, s) {
  return (0, _from2.default)((0, _Seq.skipWhile)(function (y) {
    return c === y;
  }, s.split("").slice().reverse())).slice().reverse().join('');
}

function concatUrl(a, b) {
  return trimRight("/", a) + "/" + trimLeft("/", b);
}

var PivotObject = exports.PivotObject = function () {
  (0, _createClass3.default)(PivotObject, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.PivotObject",
        interfaces: ["TheGamma.ObjectType"],
        properties: {
          MemberNames: (0, _Util.makeGeneric)(_List2.default, {
            T: "string"
          })
        }
      };
    }
  }]);

  function PivotObject(members) {
    (0, _classCallCheck3.default)(this, PivotObject);
    this.members = members;
  }

  (0, _createClass3.default)(PivotObject, [{
    key: "TypeEquals",
    value: function (y) {
      if (y instanceof PivotObject) {
        return y.MemberNames.Equals(this.MemberNames);
      } else {
        return false;
      }
    }
  }, {
    key: "MemberNames",
    get: function () {
      var _this2 = this;

      return (0, _Seq.toList)((0, _Seq.delay)(function () {
        return (0, _Seq.map)(function (m) {
          return m.Name;
        }, _this2.members);
      }));
    }
  }, {
    key: "Members",
    get: function () {
      return (0, _from2.default)(this.members);
    }
  }]);
  return PivotObject;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.Pivot.PivotObject", PivotObject);

function makeObjectType(members) {
  return new _ast.Type("Object", [new PivotObject(members)]);
}

function isNumeric(fld) {
  return fld.Equals(new _ast.PrimitiveType("Number", []));
}

function isBool(fld) {
  return fld.Equals(new _ast.PrimitiveType("Bool", []));
}

function isDate(fld) {
  return fld.Equals(new _ast.PrimitiveType("Date", []));
}

function isConcatenable(fld) {
  return fld.Equals(new _ast.PrimitiveType("String", []));
}

function getTypeAndEmitter(_arg1) {
  if (_arg1.Case === "Date") {
    return [new _ast.Type("Primitive", [new _ast.PrimitiveType("String", [])]), function (e) {
      return new _babel.Expression("NewExpression", [_babel.BabelOperators.ident("Date"), (0, _List.ofArray)([_babel.BabelOperators.op_DivideAtDivide(_babel.BabelOperators.op_Dynamic(_babel.BabelOperators.ident("Date"), "parse"), (0, _List.ofArray)([e]))]), null]);
    }];
  } else if (_arg1.Case === "Number") {
    return [new _ast.Type("Primitive", [new _ast.PrimitiveType("Number", [])]), function (e_1) {
      return _babel.BabelOperators.op_DivideAtDivide(_babel.BabelOperators.ident("Number"), (0, _List.ofArray)([e_1]));
    }];
  } else if (_arg1.Case === "Bool") {
    return [new _ast.Type("Primitive", [new _ast.PrimitiveType("Number", [])]), function (e_2) {
      return _babel.BabelOperators.op_DivideAtDivide(_babel.BabelOperators.ident("Boolean"), (0, _List.ofArray)([e_2]));
    }];
  } else if (_arg1.Case === "Unit") {
    return [new _ast.Type("Primitive", [new _ast.PrimitiveType("Unit", [])]), function (e_3) {
      return new _babel.Expression("NullLiteral", [null]);
    }];
  } else {
    return [new _ast.Type("Primitive", [new _ast.PrimitiveType("String", [])]), function (x) {
      return x;
    }];
  }
}

var propertyEmitter = exports.propertyEmitter = new _ast.Emitter(function (_this) {
  return _this;
});

function makeMethodEmitter(callid, pars) {
  return new _ast.Emitter(function (_this) {
    return _babel.BabelOperators.funcN((0, _Seq.count)(pars), function (args) {
      var args_1 = _babel.BabelOperators.arr((0, _Seq.toList)((0, _Seq.delay)(function () {
        return (0, _Seq.map)(function (v) {
          return v;
        }, args);
      })));

      return _babel.BabelOperators.op_DivideAtDivide(_babel.BabelOperators.op_Dynamic(_this, "addCall"), (0, _List.ofArray)([_babel.BabelOperators.str(callid), args_1]));
    });
  });
}

function makeDataEmitter(isPreview, isSeries, convValues, tfs) {
  return new _ast.Emitter(function (_this) {
    return isSeries ? _babel.BabelOperators.op_DivideAtDivide(_babel.BabelOperators.op_Dynamic(_babel.BabelOperators.ident("series"), "create"), (0, _List.ofArray)([_babel.BabelOperators.op_DivideAtDivide(_babel.BabelOperators.op_Dynamic(_this, "getData"), (0, _List.ofArray)([convValues, _babel.BabelOperators.str(Transform.toUrl((0, _List.reverse)(tfs))), _babel.BabelOperators.bool(isPreview)])), _babel.BabelOperators.str("key"), _babel.BabelOperators.str("value"), _babel.BabelOperators.str("")])) : _babel.BabelOperators.op_DivideAtDivide(_babel.BabelOperators.op_Dynamic(_babel.BabelOperators.ident("series"), "ordinal"), (0, _List.ofArray)([_babel.BabelOperators.op_DivideAtDivide(_babel.BabelOperators.op_Dynamic(_this, "getData"), (0, _List.ofArray)([convValues, _babel.BabelOperators.str(Transform.toUrl((0, _List.reverse)(tfs))), _babel.BabelOperators.bool(isPreview)])), _babel.BabelOperators.str("key"), _babel.BabelOperators.str("value"), _babel.BabelOperators.str("")]));
  });
}

var Context = exports.Context = function () {
  function Context(root, ignoreFiltersInRange, lookupNamed, inputFields, fields) {
    (0, _classCallCheck3.default)(this, Context);
    this.Root = root;
    this.IgnoreFiltersInRange = ignoreFiltersInRange;
    this.LookupNamed = lookupNamed;
    this.InputFields = inputFields;
    this.Fields = fields;
  }

  (0, _createClass3.default)(Context, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.Context",
        interfaces: ["FSharpRecord"],
        properties: {
          Root: "string",
          IgnoreFiltersInRange: "boolean",
          LookupNamed: "function",
          InputFields: (0, _Util.makeGeneric)(_List2.default, {
            T: Field
          }),
          Fields: (0, _Util.makeGeneric)(_List2.default, {
            T: Field
          })
        }
      };
    }
  }]);
  return Context;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.Pivot.Context", Context);

function makeProperty(ctx, name, tfs) {
  var meta1 = new _ast.Metadata("http://schema.thegamma.net/pivot", "Transformations", tfs);
  var meta2 = new _ast.Metadata("http://schema.thegamma.net/pivot", "Fields", ctx.Fields);
  return new _ast.Member(name, makePivotType(ctx, tfs), (0, _List.ofArray)([meta1, meta2]), propertyEmitter);
}

function makeMethod(ctx, name, tfs, callid, args) {
  var meta1 = new _ast.Metadata("http://schema.thegamma.net/pivot", "Transformations", tfs);
  var meta2 = new _ast.Metadata("http://schema.thegamma.net/pivot", "Fields", ctx.Fields);
  var Metadata = (0, _List.ofArray)([meta1, meta2]);
  return new _ast.Member(name, new _ast.Type("Method", [(0, _Seq.toList)((0, _Seq.delay)(function () {
    return (0, _Seq.collect)(function (matchValue) {
      return (0, _Seq.singleton)(new _ast.MethodArgument(matchValue[0], false, false, new _ast.Type("Primitive", [matchValue[1]])));
    }, args);
  })), function (ts) {
    var ts_1 = (0, _List.map)(function (tuple) {
      return tuple[0];
    }, ts);

    if ((0, _typeops.listsEqual)(ts_1, args, function (t1) {
      return function (tupledArg) {
        return (0, _typeops.typesEqual)(t1, new _ast.Type("Primitive", [tupledArg[1]]));
      };
    })) {
      return makePivotType(ctx, tfs);
    } else {
      return null;
    }
  }]), Metadata, makeMethodEmitter(callid, args));
}

function makeDataMember(ctx, name, isPreview, tfs) {
  var fields = Transform.transformFields(ctx.InputFields, (0, _List.reverse)(tfs));

  _common.Log.trace("providers", "Make data member using transform %O. Got fields: %O", tfs, fields);

  var patternInput_2 = void 0;
  var $var449 = tfs.tail != null ? tfs.head.Case === "GetSeries" ? [0] : [1] : [1];

  switch ($var449[0]) {
    case 0:
      var $var450 = fields.tail != null ? fields.tail.tail != null ? fields.tail.tail.tail == null ? [0, fields.head, fields.tail.head] : [1] : [1] : [1];

      switch ($var450[0]) {
        case 0:
          patternInput_2 = [true, (0, _fsharp.applyTypes)(ctx.LookupNamed("series"), (0, _List.ofArray)([new _ast.Type("Primitive", [$var450[1].Type]), new _ast.Type("Primitive", [$var450[2].Type])])), _babel.BabelOperators.func("o", function (arg) {
            return _babel.BabelOperators.arr((0, _List.ofArray)([getTypeAndEmitter($var450[1].Type)[1](_babel.BabelOperators.op_DivideQmarkDivide(arg, _babel.BabelOperators.num(0))), getTypeAndEmitter($var450[2].Type)[1](_babel.BabelOperators.op_DivideQmarkDivide(arg, _babel.BabelOperators.num(1)))]));
          })];
          break;

        case 1:
          throw new Error("makeDataMember: Series should have key and value");
          break;
      }

      break;

    case 1:
      var patternInput_1 = (0, _Array.unzip)((0, _from2.default)(fields).map(function (fld) {
        var patternInput = getTypeAndEmitter(fld.Type);
        var emitter = new _ast.Emitter(function (inst) {
          return _babel.BabelOperators.op_DivideQmarkDivide(inst, _babel.BabelOperators.str(fld.Name));
        });
        return [[fld.Name, patternInput[1]], new _ast.Member(fld.Name, patternInput[0], (0, _List.ofArray)([_providers.ProviderHelpers.docMeta(new _ast.Documentation("Text", [""]))]), emitter)];
      }));
      var recTyp = makeObjectType(patternInput_1[1]);
      patternInput_2 = [false, (0, _fsharp.applyTypes)(ctx.LookupNamed("series"), (0, _List.ofArray)([new _ast.Type("Primitive", [new _ast.PrimitiveType("Number", [])]), recTyp])), _babel.BabelOperators.func("o", function (arg_1) {
        var mems = (0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.collect)(function (matchValue) {
            return (0, _Seq.singleton)(new _babel.ObjectMember("ObjectProperty", [_babel.BabelOperators.str(matchValue[0]), matchValue[1](_babel.BabelOperators.op_DivideQmarkDivide(arg_1, _babel.BabelOperators.str(matchValue[0]))), true, null]));
          }, patternInput_1[0]);
        }));
        return new _babel.Expression("ObjectExpression", [mems, null]);
      })];
      break;
  }

  var tfs_1 = patternInput_2[0] ? tfs : new _List2.default(new Transformation("GetTheData", []), tfs);
  var meta = (0, _Seq.toList)((0, _Seq.delay)(function () {
    return (0, _Seq.append)((0, _Seq.singleton)(new _ast.Metadata("http://schema.thegamma.net/pivot", "Transformations", tfs_1)), (0, _Seq.delay)(function () {
      return (0, _Seq.append)((0, _Seq.singleton)(new _ast.Metadata("http://schema.thegamma.net/pivot", "Fields", ctx.Fields)), (0, _Seq.delay)(function () {
        return isPreview ? (0, _Seq.singleton)(new _ast.Metadata("http://schema.thegamma.net", "CompletionItem", {
          hidden: true
        })) : (0, _Seq.empty)();
      }));
    }));
  }));
  return new _ast.Member(name, patternInput_2[1], meta, makeDataEmitter(isPreview, patternInput_2[0], patternInput_2[2], tfs_1));
}

function handleGetSeriesRequest(ctx, rest, k, v) {
  var matchValue = [k, v];
  var $var451 = matchValue[0] === "!" ? matchValue[1] === "!" ? [0] : [2] : matchValue[1] === "!" ? [1] : [2];

  switch ($var451[0]) {
    case 0:
      return makeObjectType((0, _Seq.toList)((0, _Seq.delay)(function () {
        return (0, _Seq.map)(function (field) {
          return makeProperty(ctx, "with key " + field.Name, new _List2.default(new Transformation("GetSeries", [field.Name, "!"]), rest));
        }, ctx.Fields);
      })));

    case 1:
      return makeObjectType((0, _Seq.toList)((0, _Seq.delay)(function () {
        return (0, _Seq.map)(function (field_1) {
          return makeDataMember(ctx, "and value " + field_1.Name, false, new _List2.default(new Transformation("GetSeries", [matchValue[0], field_1.Name]), rest));
        }, ctx.Fields);
      })));

    case 2:
      throw new Error("handleGetSeriesRequest: Should not happen");
  }
}

function handlePagingRequest(ctx, rest, pgid, ops) {
  var takeMemb = makeMethod(ctx, "take", (0, _List.ofArray)([new Transformation("Empty", []), new Transformation("Paging", [(0, _List.reverse)(new _List2.default(new Paging("Take", [pgid + "-take"]), ops))])], rest), pgid + "-take", (0, _List.ofArray)([["count", new _ast.PrimitiveType("Number", [])]]));
  var skipMemb = makeMethod(ctx, "skip", new _List2.default(new Transformation("Paging", [new _List2.default(new Paging("Skip", [pgid + "-skip"]), ops)]), rest), pgid + "-skip", (0, _List.ofArray)([["count", new _ast.PrimitiveType("Number", [])]]));
  var thenMemb = makeProperty(ctx, "then", (0, _List.ofArray)([new Transformation("Empty", []), new Transformation("Paging", [(0, _List.reverse)(ops)])], rest));
  return makeObjectType(function () {
    var $var452 = ops.tail != null ? ops.head.Case === "Skip" ? ops.tail.tail == null ? [1] : [2] : [2] : [0];

    switch ($var452[0]) {
      case 0:
        return (0, _List.ofArray)([skipMemb, takeMemb, thenMemb]);

      case 1:
        return (0, _List.ofArray)([takeMemb, thenMemb]);

      case 2:
        throw new Error("handlePagingRequest: Shold not happen");
    }
  }());
}

function handleDropRequest(ctx, rest, dropped) {
  var droppedFields = (0, _Set.create)(dropped, new _GenericComparer2.default(_Util.compare));
  return makeObjectType((0, _Seq.toList)((0, _Seq.delay)(function () {
    return (0, _Seq.append)((0, _Seq.singleton)(makeProperty(ctx, "then", (0, _List.ofArray)([new Transformation("Empty", []), new Transformation("DropColumns", [dropped])], rest))), (0, _Seq.delay)(function () {
      return (0, _Seq.collect)(function (field) {
        return !droppedFields.has(field.Name) ? (0, _Seq.singleton)(makeProperty(ctx, "drop " + field.Name, new _List2.default(new Transformation("DropColumns", [new _List2.default(field.Name, dropped)]), rest))) : (0, _Seq.empty)();
      }, ctx.Fields);
    }));
  })));
}

function handleSortRequest(ctx, rest, keys) {
  var usedKeys = (0, _Set.create)((0, _List.map)(function (tuple) {
    return tuple[0];
  }, keys), new _GenericComparer2.default(_Util.compare));
  return makeObjectType((0, _Seq.toList)((0, _Seq.delay)(function () {
    return (0, _Seq.append)((0, _Seq.singleton)(makeProperty(ctx, "then", (0, _List.ofArray)([new Transformation("Empty", []), new Transformation("SortBy", [keys])], rest))), (0, _Seq.delay)(function () {
      return (0, _Seq.collect)(function (field) {
        if (!usedKeys.has(field.Name)) {
          var doc = (0, _String.fsFormat)("Use the field '%s' as the next sorting keys")(function (x) {
            return x;
          })(field.Name);
          var prefix = keys.Equals(new _List2.default()) ? "by " : "and by ";
          return (0, _Seq.append)((0, _Seq.singleton)(makeProperty(ctx, prefix + field.Name, new _List2.default(new Transformation("SortBy", [new _List2.default([field.Name, new SortDirection("Ascending", [])], keys)]), rest))), (0, _Seq.delay)(function () {
            return (0, _Seq.singleton)(makeProperty(ctx, prefix + field.Name + " descending", new _List2.default(new Transformation("SortBy", [new _List2.default([field.Name, new SortDirection("Descending", [])], keys)]), rest)));
          }));
        } else {
          return (0, _Seq.empty)();
        }
      }, ctx.Fields);
    }));
  })));
}

function handleWindowRequest(ctx, rest, wndid) {
  return makeObjectType((0, _Seq.toList)((0, _Seq.delay)(function () {
    return (0, _Seq.collect)(function (field) {
      return (isDate(field.Type) ? true : isNumeric(field.Type)) ? (0, _Seq.append)((0, _Seq.singleton)(makeMethod(ctx, "window by " + field.Name, new _List2.default(new Transformation("WindowBy", [field.Name, wndid, new _List2.default()]), rest), wndid, (0, _List.ofArray)([["size", new _ast.PrimitiveType("Number", [])]]))), (0, _Seq.delay)(function () {
        return (0, _Seq.singleton)(makeProperty(ctx, "expanding by " + field.Name, new _List2.default(new Transformation("ExpandBy", [field.Name, (0, _List.ofArray)([new WindowAggregation("LastKey", [])])]), rest)));
      })) : (0, _Seq.empty)();
    }, ctx.Fields);
  })));
}

function handleWindowExpandAggRequest(ctx, rest, fld, make, aggs) {
  var containsKey = (0, _Seq.exists)(function (_arg1) {
    var $var453 = _arg1.Case === "FirstKey" ? [0] : _arg1.Case === "LastKey" ? [0] : _arg1.Case === "MiddleKey" ? [0] : [1];

    switch ($var453[0]) {
      case 0:
        return true;

      case 1:
        return false;
    }
  }, aggs);

  var containsField = function containsField(fld_1) {
    return (0, _Seq.exists)(function (_arg2) {
      var $var454 = _arg2.Case === "Max" ? [0, _arg2.Fields[0]] : _arg2.Case === "Min" ? [0, _arg2.Fields[0]] : _arg2.Case === "Mean" ? [0, _arg2.Fields[0]] : _arg2.Case === "FirstKey" ? [1] : _arg2.Case === "LastKey" ? [1] : _arg2.Case === "MiddleKey" ? [1] : [0, _arg2.Fields[0]];

      switch ($var454[0]) {
        case 0:
          return $var454[1] === fld_1;

        case 1:
          return false;
      }
    }, aggs);
  };

  var makeAggMember = function makeAggMember(name) {
    return function (agg) {
      return makeProperty(ctx, name, new _List2.default(make((0, _List.append)(aggs, (0, _List.ofArray)([agg]))), rest));
    };
  };

  return makeObjectType((0, _Seq.toList)((0, _Seq.delay)(function () {
    return (0, _Seq.append)(!(aggs.tail == null) ? (0, _Seq.singleton)(makeProperty(ctx, "then", (0, _List.ofArray)([new Transformation("Empty", []), make(aggs)], rest))) : (0, _Seq.empty)(), (0, _Seq.delay)(function () {
      return (0, _Seq.append)(!containsKey ? (0, _Seq.append)((0, _Seq.singleton)(makeAggMember("first " + fld)(new WindowAggregation("FirstKey", []))), (0, _Seq.delay)(function () {
        return (0, _Seq.append)((0, _Seq.singleton)(makeAggMember("last " + fld)(new WindowAggregation("LastKey", []))), (0, _Seq.delay)(function () {
          return (0, _Seq.singleton)(makeAggMember("middle " + fld)(new WindowAggregation("MiddleKey", [])));
        }));
      })) : (0, _Seq.empty)(), (0, _Seq.delay)(function () {
        return (0, _Seq.collect)(function (fld_2) {
          return !containsField(fld_2.Name) ? (isNumeric(fld_2.Type) ? true : isBool(fld_2.Type)) ? (0, _Seq.append)((0, _Seq.singleton)(makeAggMember("min " + fld_2.Name)(new WindowAggregation("Min", [fld_2.Name]))), (0, _Seq.delay)(function () {
            return (0, _Seq.append)((0, _Seq.singleton)(makeAggMember("sum " + fld_2.Name)(new WindowAggregation("Sum", [fld_2.Name]))), (0, _Seq.delay)(function () {
              return (0, _Seq.append)((0, _Seq.singleton)(makeAggMember("max " + fld_2.Name)(new WindowAggregation("Max", [fld_2.Name]))), (0, _Seq.delay)(function () {
                return (0, _Seq.singleton)(makeAggMember("mean " + fld_2.Name)(new WindowAggregation("Mean", [fld_2.Name])));
              }));
            }));
          })) : (0, _Seq.empty)() : (0, _Seq.empty)();
        }, ctx.Fields);
      }));
    }));
  })));
}

function aggregationMembers(ctx, rest, keys, aggs) {
  var containsCountAll = (0, _Seq.exists)(function () {
    var x = new GroupAggregation("CountAll", []);
    return function (y) {
      return x.Equals(y);
    };
  }(), aggs);

  var containsField = function containsField(fld) {
    return (0, _Seq.exists)(function (_arg3) {
      var $var455 = _arg3.Case === "ConcatValues" ? [0, _arg3.Fields[0]] : _arg3.Case === "Sum" ? [0, _arg3.Fields[0]] : _arg3.Case === "Mean" ? [0, _arg3.Fields[0]] : _arg3.Case === "CountAll" ? [1] : _arg3.Case === "GroupKey" ? [1] : [0, _arg3.Fields[0]];

      switch ($var455[0]) {
        case 0:
          return $var455[1] === fld;

        case 1:
          return false;
      }
    }, aggs);
  };

  var makeAggMember = function makeAggMember(name) {
    return function (agg) {
      return makeProperty(ctx, name, new _List2.default(new Transformation("GroupBy", [keys, (0, _List.append)(aggs, (0, _List.ofArray)([agg]))]), rest));
    };
  };

  return (0, _Seq.toList)((0, _Seq.delay)(function () {
    return (0, _Seq.append)((0, _Seq.singleton)(makeProperty(ctx, "then", (0, _List.ofArray)([new Transformation("Empty", []), new Transformation("GroupBy", [keys, aggs])], rest))), (0, _Seq.delay)(function () {
      return (0, _Seq.append)(!containsCountAll ? (0, _Seq.singleton)(makeAggMember("count all")(new GroupAggregation("CountAll", []))) : (0, _Seq.empty)(), (0, _Seq.delay)(function () {
        return (0, _Seq.collect)(function (fld_1) {
          return !containsField(fld_1.Name) ? (0, _Seq.append)((0, _Seq.singleton)(makeAggMember("count distinct " + fld_1.Name)(new GroupAggregation("CountDistinct", [fld_1.Name]))), (0, _Seq.delay)(function () {
            return (0, _Seq.append)(isConcatenable(fld_1.Type) ? (0, _Seq.singleton)(makeAggMember("concatenate values of " + fld_1.Name)(new GroupAggregation("ConcatValues", [fld_1.Name]))) : (0, _Seq.empty)(), (0, _Seq.delay)(function () {
              return (isNumeric(fld_1.Type) ? true : isBool(fld_1.Type)) ? (0, _Seq.append)((0, _Seq.singleton)(makeAggMember("average " + fld_1.Name)(new GroupAggregation("Mean", [fld_1.Name]))), (0, _Seq.delay)(function () {
                return (0, _Seq.singleton)(makeAggMember("sum " + fld_1.Name)(new GroupAggregation("Sum", [fld_1.Name])));
              })) : (0, _Seq.empty)();
            }));
          })) : (0, _Seq.empty)();
        }, ctx.Fields);
      }));
    }));
  }));
}

function handleGroupAggRequest(ctx, rest, keys, aggs) {
  return makeObjectType(aggregationMembers(ctx, rest, keys, aggs));
}

function handleGroupRequest(ctx, rest, keys) {
  var prefix = keys.tail == null ? "by " : "and ";
  return makeObjectType((0, _Seq.toList)((0, _Seq.delay)(function () {
    return (0, _Seq.append)((0, _Seq.map)(function (field) {
      return makeProperty(ctx, prefix + field.Name, new _List2.default(new Transformation("GroupBy", [new _List2.default(field.Name, keys), new _List2.default()]), rest));
    }, ctx.Fields), (0, _Seq.delay)(function () {
      return !(keys.tail == null) ? aggregationMembers(ctx, rest, keys, (0, _List.ofArray)([new GroupAggregation("GroupKey", [])])) : (0, _Seq.empty)();
    }));
  })));
}

function handleFilterEqNeqRequest(ctx, rest, fld, eq, op, conds) {
  return function (builder_) {
    return builder_.Delay(function () {
      var tfs = op.Equals(new FilterOperator("Or", [])) ? rest : conds.tail == null ? rest : new _List2.default(new Transformation("FilterBy", [op, conds]), rest);
      var tfs_1 = (0, _List.filter)(function (_arg4) {
        var $var456 = _arg4.Case === "FilterBy" ? ctx.IgnoreFiltersInRange ? [0] : [1] : [1];

        switch ($var456[0]) {
          case 0:
            return false;

          case 1:
            var $var457 = _arg4.Case === "FilterBy" ? (0, _Seq.exists)(function (_arg5) {
              var $var458 = _arg5[0].Case === "Equals" ? [0] : _arg5[0].Case === "NotEquals" ? [0] : [1];

              switch ($var458[0]) {
                case 0:
                  return false;

                case 1:
                  return true;
              }
            }, _arg4.Fields[1]) ? [0, _arg4.Fields[1]] : [1] : [1];

            switch ($var457[0]) {
              case 0:
                return false;

              case 1:
                return true;
            }

        }
      }, tfs);
      var url = ctx.Root + "?" + encodeURIComponent(Transform.toUrl((0, _List.reverse)(new _List2.default(new Transformation("GetRange", [fld]), tfs_1))));
      return builder_.Bind(_common.Http.Request("GET", url), function (_arg6) {
        var options = JSON.parse(_arg6);
        return builder_.Return(makeObjectType((0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.map)(function (opt) {
            return makeProperty(ctx, opt, new _List2.default(new Transformation("FilterBy", [op, new _List2.default([eq, fld, opt], conds)]), rest));
          }, options);
        }))));
      });
    });
  }(_AsyncBuilder.singleton);
}

function handleFilterRequest(ctx, rest, flid, op, conds) {
  var prefixes = void 0;
  var matchValue = [conds, op];

  if (matchValue[0].tail != null) {
    if (matchValue[0].tail.tail == null) {
      prefixes = (0, _List.ofArray)([["and ", new FilterOperator("And", [])], ["or ", new FilterOperator("Or", [])]]);
    } else if (matchValue[1].Case === "Or") {
      prefixes = (0, _List.ofArray)([["or ", new FilterOperator("Or", [])]]);
    } else {
      prefixes = (0, _List.ofArray)([["and ", new FilterOperator("And", [])]]);
    }
  } else {
    prefixes = (0, _List.ofArray)([["", new FilterOperator("And", [])]]);
  }

  return makeObjectType((0, _Seq.toList)((0, _Seq.delay)(function () {
    return (0, _Seq.append)((0, _Seq.collect)(function (matchValue_1) {
      return (0, _Seq.collect)(function (field) {
        return (0, _Seq.append)(field.Type.Equals(new _ast.PrimitiveType("String", [])) ? (0, _Seq.append)((0, _Seq.singleton)(makeProperty(ctx, matchValue_1[0] + field.Name + " is", new _List2.default(new Transformation("FilterBy", [matchValue_1[1], new _List2.default([new RelationalOperator("Equals", []), field.Name, "!"], conds)]), rest))), (0, _Seq.delay)(function () {
          return (0, _Seq.append)((0, _Seq.singleton)(makeProperty(ctx, matchValue_1[0] + field.Name + " is not", new _List2.default(new Transformation("FilterBy", [matchValue_1[1], new _List2.default([new RelationalOperator("NotEquals", []), field.Name, "!"], conds)]), rest))), (0, _Seq.delay)(function () {
            return (0, _Seq.singleton)(makeMethod(ctx, matchValue_1[0] + field.Name + " contains", new _List2.default(new Transformation("FilterBy", [matchValue_1[1], new _List2.default([new RelationalOperator("Like", []), field.Name, flid], conds)]), rest), flid, (0, _List.ofArray)([["text", new _ast.PrimitiveType("String", [])]])));
          }));
        })) : (0, _Seq.empty)(), (0, _Seq.delay)(function () {
          return (0, _Seq.append)(field.Type.Equals(new _ast.PrimitiveType("Number", [])) ? (0, _Seq.append)((0, _Seq.singleton)(makeMethod(ctx, matchValue_1[0] + field.Name + " is less than", new _List2.default(new Transformation("FilterBy", [matchValue_1[1], new _List2.default([new RelationalOperator("LessThan", []), field.Name, flid], conds)]), rest), flid, (0, _List.ofArray)([["value", new _ast.PrimitiveType("Number", [])]]))), (0, _Seq.delay)(function () {
            return (0, _Seq.append)((0, _Seq.singleton)(makeMethod(ctx, matchValue_1[0] + field.Name + " is greater than", new _List2.default(new Transformation("FilterBy", [matchValue_1[1], new _List2.default([new RelationalOperator("GreaterThan", []), field.Name, flid], conds)]), rest), flid, (0, _List.ofArray)([["value", new _ast.PrimitiveType("Number", [])]]))), (0, _Seq.delay)(function () {
              return (0, _Seq.singleton)(makeMethod(ctx, matchValue_1[0] + field.Name + " is in range", new _List2.default(new Transformation("FilterBy", [matchValue_1[1], new _List2.default([new RelationalOperator("InRange", []), field.Name, flid], conds)]), rest), flid, (0, _List.ofArray)([["minimum", new _ast.PrimitiveType("Number", [])], ["maximum", new _ast.PrimitiveType("Number", [])]])));
            }));
          })) : (0, _Seq.empty)(), (0, _Seq.delay)(function () {
            return field.Type.Equals(new _ast.PrimitiveType("Date", [])) ? (0, _Seq.append)((0, _Seq.singleton)(makeMethod(ctx, matchValue_1[0] + field.Name + " is less than", new _List2.default(new Transformation("FilterBy", [matchValue_1[1], new _List2.default([new RelationalOperator("LessThan", []), field.Name, flid], conds)]), rest), flid, (0, _List.ofArray)([["value", new _ast.PrimitiveType("Date", [])]]))), (0, _Seq.delay)(function () {
              return (0, _Seq.append)((0, _Seq.singleton)(makeMethod(ctx, matchValue_1[0] + field.Name + " is greater than", new _List2.default(new Transformation("FilterBy", [matchValue_1[1], new _List2.default([new RelationalOperator("GreaterThan", []), field.Name, flid], conds)]), rest), flid, (0, _List.ofArray)([["value", new _ast.PrimitiveType("Date", [])]]))), (0, _Seq.delay)(function () {
                return (0, _Seq.singleton)(makeMethod(ctx, matchValue_1[0] + field.Name + " is in range", new _List2.default(new Transformation("FilterBy", [matchValue_1[1], new _List2.default([new RelationalOperator("InRange", []), field.Name, flid], conds)]), rest), flid, (0, _List.ofArray)([["minimum", new _ast.PrimitiveType("Date", [])], ["maximum", new _ast.PrimitiveType("Date", [])]])));
              }));
            })) : (0, _Seq.empty)();
          }));
        }));
      }, ctx.Fields);
    }, prefixes), (0, _Seq.delay)(function () {
      return !(conds.tail == null) ? (0, _Seq.singleton)(makeProperty(ctx, "then", (0, _List.ofArray)([new Transformation("Empty", []), new Transformation("FilterBy", [op, conds])], rest))) : (0, _Seq.empty)();
    }));
  })));
}

function makePivotTypeImmediate(ctx, tfs) {
  return function (builder_) {
    return builder_.Delay(function () {
      var patternInput = tfs.tail != null ? [tfs.head, tfs.tail] : [new Transformation("Empty", []), new _List2.default()];
      var ctx_1 = void 0;
      var Fields = Transform.transformFields(ctx.InputFields, (0, _List.reverse)(patternInput[1]));
      ctx_1 = new Context(ctx.Root, ctx.IgnoreFiltersInRange, ctx.LookupNamed, ctx.InputFields, Fields);
      var $var459 = patternInput[0].Case === "GetSeries" ? [1, patternInput[0].Fields[0], patternInput[0].Fields[1]] : patternInput[0].Case === "Paging" ? [2, patternInput[0].Fields[0]] : patternInput[0].Case === "SortBy" ? [3, patternInput[0].Fields[0]] : patternInput[0].Case === "DropColumns" ? [4, patternInput[0].Fields[0]] : patternInput[0].Case === "FilterBy" ? patternInput[0].Fields[1].tail != null ? patternInput[0].Fields[1].head[0].Case === "Equals" ? patternInput[0].Fields[1].head[2] === "!" ? [5, patternInput[0].Fields[1].tail, patternInput[0].Fields[1].head[1], patternInput[0].Fields[0], patternInput[0].Fields[1].head[0]] : [6, patternInput[0].Fields[1], patternInput[0].Fields[0]] : patternInput[0].Fields[1].head[0].Case === "NotEquals" ? patternInput[0].Fields[1].head[2] === "!" ? [5, patternInput[0].Fields[1].tail, patternInput[0].Fields[1].head[1], patternInput[0].Fields[0], patternInput[0].Fields[1].head[0]] : [6, patternInput[0].Fields[1], patternInput[0].Fields[0]] : [6, patternInput[0].Fields[1], patternInput[0].Fields[0]] : [6, patternInput[0].Fields[1], patternInput[0].Fields[0]] : patternInput[0].Case === "WindowBy" ? patternInput[0].Fields[0] === "!" ? patternInput[0].Fields[1] === "!" ? patternInput[0].Fields[2].tail == null ? [7] : [8, patternInput[0].Fields[2], patternInput[0].Fields[0], patternInput[0].Fields[1]] : [8, patternInput[0].Fields[2], patternInput[0].Fields[0], patternInput[0].Fields[1]] : [8, patternInput[0].Fields[2], patternInput[0].Fields[0], patternInput[0].Fields[1]] : patternInput[0].Case === "ExpandBy" ? [9, patternInput[0].Fields[1], patternInput[0].Fields[0]] : patternInput[0].Case === "GroupBy" ? patternInput[0].Fields[1].tail == null ? [10, patternInput[0].Fields[0]] : [11, patternInput[0].Fields[1], patternInput[0].Fields[0]] : patternInput[0].Case === "GetTheData" ? [12] : patternInput[0].Case === "GetRange" ? [12] : patternInput[0].Case === "Metadata" ? [12] : [0];

      switch ($var459[0]) {
        case 0:
          return builder_.Return(makeObjectType((0, _Seq.toList)((0, _Seq.delay)(function () {
            return (0, _Seq.append)((0, _Seq.singleton)(makeProperty(ctx_1, "group data", new _List2.default(new Transformation("GroupBy", [new _List2.default(), new _List2.default()]), patternInput[1]))), (0, _Seq.delay)(function () {
              return (0, _Seq.append)((0, _Seq.singleton)(makeProperty(ctx_1, "filter data", new _List2.default(new Transformation("FilterBy", [new FilterOperator("And", []), new _List2.default()]), patternInput[1]))), (0, _Seq.delay)(function () {
                return (0, _Seq.append)((0, _Seq.singleton)(makeProperty(ctx_1, "sort data", new _List2.default(new Transformation("SortBy", [new _List2.default()]), patternInput[1]))), (0, _Seq.delay)(function () {
                  return (0, _Seq.append)((0, _Seq.singleton)(makeProperty(ctx_1, "drop columns", new _List2.default(new Transformation("DropColumns", [new _List2.default()]), patternInput[1]))), (0, _Seq.delay)(function () {
                    return (0, _Seq.append)((0, _Seq.singleton)(makeProperty(ctx_1, "paging", new _List2.default(new Transformation("Paging", [new _List2.default()]), patternInput[1]))), (0, _Seq.delay)(function () {
                      return (0, _Seq.append)((0, _Seq.singleton)(makeProperty(ctx_1, "get series", new _List2.default(new Transformation("GetSeries", ["!", "!"]), patternInput[1]))), (0, _Seq.delay)(function () {
                        return (0, _Seq.append)((0, _Seq.singleton)(makeDataMember(ctx_1, "get the data", false, patternInput[1])), (0, _Seq.delay)(function () {
                          return (0, _Seq.exists)(function (fld) {
                            return fld.Type.Equals(new _ast.PrimitiveType("Date", [])) ? true : fld.Type.Equals(new _ast.PrimitiveType("Number", []));
                          }, ctx_1.Fields) ? (0, _Seq.singleton)(makeProperty(ctx_1, "windowing", new _List2.default(new Transformation("WindowBy", ["!", "!", new _List2.default()]), patternInput[1]))) : (0, _Seq.empty)();
                        }));
                      }));
                    }));
                  }));
                }));
              }));
            }));
          }))));

        case 1:
          return builder_.Return(handleGetSeriesRequest(ctx_1, patternInput[1], $var459[1], $var459[2]));

        case 2:
          var pgid = (0, _String.fsFormat)("pgid-%d")(function (x) {
            return x;
          })((0, _Seq.sumBy)(function (_arg7) {
            return _arg7.Case === "Paging" ? 1 : 0;
          }, patternInput[1]));
          return builder_.Return(handlePagingRequest(ctx_1, patternInput[1], pgid, $var459[1]));

        case 3:
          return builder_.Return(handleSortRequest(ctx_1, patternInput[1], $var459[1]));

        case 4:
          return builder_.Return(handleDropRequest(ctx_1, patternInput[1], $var459[1]));

        case 5:
          return builder_.ReturnFrom(handleFilterEqNeqRequest(ctx_1, patternInput[1], $var459[2], $var459[4], $var459[3], $var459[1]));

        case 6:
          var flid = $var459[1].length + (0, _Seq.sumBy)(function (_arg8) {
            return _arg8.Case === "FilterBy" ? _arg8.Fields[1].length : 0;
          }, patternInput[1]);
          return builder_.Return(handleFilterRequest(ctx_1, patternInput[1], (0, _String.fsFormat)("flid-%d")(function (x) {
            return x;
          })(flid), $var459[2], $var459[1]));

        case 7:
          var wnid = (0, _String.fsFormat)("wnid-%d")(function (x) {
            return x;
          })((0, _Seq.sumBy)(function (_arg9) {
            return _arg9.Case === "WindowBy" ? 1 : 0;
          }, patternInput[1]));
          return builder_.Return(handleWindowRequest(ctx_1, patternInput[1], wnid));

        case 8:
          return builder_.Return(handleWindowExpandAggRequest(ctx_1, patternInput[1], $var459[2], function (aggs) {
            return new Transformation("WindowBy", [$var459[2], $var459[3], aggs]);
          }, $var459[1]));

        case 9:
          return builder_.Return(handleWindowExpandAggRequest(ctx_1, patternInput[1], $var459[2], function (aggs_1) {
            return new Transformation("ExpandBy", [$var459[2], aggs_1]);
          }, $var459[1]));

        case 10:
          return builder_.Return(handleGroupRequest(ctx_1, patternInput[1], $var459[1]));

        case 11:
          return builder_.Return(handleGroupAggRequest(ctx_1, patternInput[1], $var459[2], $var459[1]));

        case 12:
          return builder_.Return(function () {
            throw new Error("makePivotTypeImmediate: GetTheData, GetRange and Metadata shouldn't be of pivot type");
          }());
      }
    });
  }(_AsyncBuilder.singleton);
}

function adjustForPreview(tfs) {
  var $var460 = tfs.tail != null ? tfs.head.Case === "WindowBy" ? tfs.head.Fields[1] === "!" ? [0, tfs.tail] : [4] : tfs.head.Case === "GroupBy" ? tfs.head.Fields[0].tail == null ? [1, tfs.tail] : tfs.head.Fields[1].tail == null ? [2, tfs.head.Fields[0], tfs.tail] : [4] : tfs.head.Case === "GetSeries" ? [3, tfs.tail] : [4] : [4];

  switch ($var460[0]) {
    case 0:
      return $var460[1];

    case 1:
      return $var460[1];

    case 2:
      return new _List2.default(new Transformation("GroupBy", [$var460[1], (0, _List.ofArray)([new GroupAggregation("GroupKey", [])])]), $var460[2]);

    case 3:
      return $var460[1];

    case 4:
      return tfs;
  }
}

function withPreview(ctx, tfs, typ) {
  if (typ.Case === "Object") {
    var preview = makeDataMember(ctx, "preview", true, adjustForPreview(tfs));
    return makeObjectType([preview].concat(typ.Fields[0].Members));
  } else {
    throw new Error("withPreview: Expected object type");
  }
}

function makePivotType(ctx, tfs) {
  var guid = Transform.toUrl(tfs);

  var typ = function (builder_) {
    return builder_.Delay(function () {
      return builder_.TryWith(builder_.Delay(function () {
        return builder_.Bind(makePivotTypeImmediate(ctx, tfs), function (_arg10) {
          return builder_.Return(withPreview(ctx, tfs, _arg10));
        });
      }), function (_arg11) {
        _common.Log.exn("providers", "Failed when generating type for %O with exception %O", tfs, _arg11);

        return builder_.Return(function () {
          throw _arg11;
        }());
      });
    });
  }(_AsyncBuilder.singleton);

  return new _ast.Type("Delayed", [function (arg00) {
    return function (arg10) {
      return (0, _common.Async$2E$CreateNamedFuture$2E$Static)(arg00, arg10);
    };
  }(guid)(typ)]);
}

function makePivotExpression(root) {
  return new _babel.Expression("NewExpression", [_babel.BabelOperators.ident("PivotContext"), (0, _List.ofArray)([_babel.BabelOperators.str(root), new _babel.Expression("ArrayExpression", [new _List2.default(), null])]), null]);
}

function makePivotGlobalValue(root, name, lookupNamed, ignoreFilter, fields) {
  var fields_1 = (0, _Seq.toList)((0, _Seq.delay)(function () {
    return (0, _Seq.collect)(function (matchValue) {
      return (0, _Seq.singleton)(new Field(matchValue[0], matchValue[1]));
    }, fields);
  }));
  var typ = makePivotType(new Context(root, ignoreFilter, lookupNamed, fields_1, fields_1), new _List2.default());
  var meta1 = new _ast.Metadata("http://schema.thegamma.net/pivot", "Transformations", new _List2.default());
  var meta2 = new _ast.Metadata("http://schema.thegamma.net/pivot", "Fields", fields_1);
  return new _providers.ProvidedType("GlobalValue", [name, (0, _List.ofArray)([meta1, meta2]), makePivotExpression(root), typ]);
}

function providePivotType(root, ignoreFilter, name, lookupNamed) {
  return function (builder_) {
    return builder_.Delay(function () {
      return builder_.Bind(_common.Http.Request("GET", root + "?metadata"), function (_arg1) {
        var fields = function (o) {
          return (0, _keys2.default)(o).map(function (k) {
            return {
              "key": k,
              "value": o[k]
            };
          });
        }(JSON.parse(_arg1)).map(function (kv) {
          var typ = void 0;
          var matchValue = kv.value;

          switch (matchValue) {
            case "string":
              typ = new _ast.PrimitiveType("String", []);
              break;

            case "bool":
              typ = new _ast.PrimitiveType("Bool", []);
              break;

            case "number":
              typ = new _ast.PrimitiveType("Number", []);
              break;

            case "date":
              typ = new _ast.PrimitiveType("Date", []);
              break;

            default:
              throw new Error((0, _String.fsFormat)("The property '%s' has invalid type '%s'. Only 'string', 'number' and 'bool' are supported.")(function (x) {
                return x;
              })(kv.key)(matchValue));
          }

          return [kv.key, typ];
        });

        return builder_.Return(makePivotGlobalValue(root, name, lookupNamed, ignoreFilter, fields));
      });
    });
  }(_AsyncBuilder.singleton);
}
//# sourceMappingURL=pivot.js.map