"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.restTypeCache = exports.RawResultType = exports.RawField = exports.ResultType = exports.Member = exports.Parameter = exports.Documentation = exports.TypePrimitive = exports.TypeProvider = exports.TypeNested = exports.AnyType = undefined;

var _map = require("babel-runtime/core-js/map");

var _map2 = _interopRequireDefault(_map);

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

exports.parseDoc = parseDoc;
exports.fromRawType = fromRawType;
exports.trimLeft = trimLeft;
exports.trimRight = trimRight;
exports.concatUrl = concatUrl;
exports.load = load;
exports.addTraceCall = addTraceCall;
exports.propAccess = propAccess;
exports.methCall = methCall;
exports.dataCall = dataCall;
exports.getTypeAndEmitter = getTypeAndEmitter;
exports.createRestType = createRestType;
exports.provideRestType = provideRestType;

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _Util = require("fable-core/umd/Util");

var _ast = require("../ast/ast");

var _Seq = require("fable-core/umd/Seq");

var _common = require("../../libraries/common");

var _AsyncBuilder = require("fable-core/umd/AsyncBuilder");

var _babel = require("../common/babel");

var _List = require("fable-core/umd/List");

var _List2 = _interopRequireDefault(_List);

var _String = require("fable-core/umd/String");

var _fsharp = require("./fsharp");

var _providers = require("./providers");

var _typeops = require("../ast/typeops");

var _Map2 = require("fable-core/umd/Map");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AnyType = exports.AnyType = function () {
  function AnyType(kind) {
    (0, _classCallCheck3.default)(this, AnyType);
    this.kind = kind;
  }

  (0, _createClass3.default)(AnyType, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.AnyType",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          kind: "string"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareRecords)(this, other);
    }
  }]);
  return AnyType;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.RestProvider.AnyType", AnyType);

var TypeNested = exports.TypeNested = function () {
  function TypeNested(kind, endpoint) {
    (0, _classCallCheck3.default)(this, TypeNested);
    this.kind = kind;
    this.endpoint = endpoint;
  }

  (0, _createClass3.default)(TypeNested, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.TypeNested",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          kind: "string",
          endpoint: "string"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareRecords)(this, other);
    }
  }]);
  return TypeNested;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.RestProvider.TypeNested", TypeNested);

var TypeProvider = exports.TypeProvider = function () {
  function TypeProvider(kind, provider, endpoint) {
    (0, _classCallCheck3.default)(this, TypeProvider);
    this.kind = kind;
    this.provider = provider;
    this.endpoint = endpoint;
  }

  (0, _createClass3.default)(TypeProvider, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.TypeProvider",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          kind: "string",
          provider: "string",
          endpoint: "string"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareRecords)(this, other);
    }
  }]);
  return TypeProvider;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.RestProvider.TypeProvider", TypeProvider);

var TypePrimitive = exports.TypePrimitive = function () {
  function TypePrimitive(kind, type, endpoint) {
    (0, _classCallCheck3.default)(this, TypePrimitive);
    this.kind = kind;
    this.type = type;
    this.endpoint = endpoint;
  }

  (0, _createClass3.default)(TypePrimitive, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.TypePrimitive",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          kind: "string",
          type: _Util.Any,
          endpoint: "string"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }]);
  return TypePrimitive;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.RestProvider.TypePrimitive", TypePrimitive);

var Documentation = exports.Documentation = function () {
  function Documentation(title, details) {
    (0, _classCallCheck3.default)(this, Documentation);
    this.title = title;
    this.details = details;
  }

  (0, _createClass3.default)(Documentation, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.Documentation",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          title: (0, _Util.Option)("string"),
          details: (0, _Util.Option)("string")
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareRecords)(this, other);
    }
  }]);
  return Documentation;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.RestProvider.Documentation", Documentation);

var Parameter = exports.Parameter = function () {
  function Parameter(name, optional, kind, cookie, trace, type) {
    (0, _classCallCheck3.default)(this, Parameter);
    this.name = name;
    this.optional = optional;
    this.kind = kind;
    this.cookie = cookie;
    this.trace = trace;
    this.type = type;
  }

  (0, _createClass3.default)(Parameter, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.Parameter",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          name: "string",
          optional: "boolean",
          kind: "string",
          cookie: (0, _Util.Option)("string"),
          trace: (0, _Util.Option)("string"),
          type: _Util.Any
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }]);
  return Parameter;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.RestProvider.Parameter", Parameter);

var Member = exports.Member = function () {
  function Member(name, returns, parameters, documentation, schema, trace) {
    (0, _classCallCheck3.default)(this, Member);
    this.name = name;
    this.returns = returns;
    this.parameters = parameters;
    this.documentation = documentation;
    this.schema = schema;
    this.trace = trace;
  }

  (0, _createClass3.default)(Member, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.Member",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          name: "string",
          returns: AnyType,
          parameters: (0, _Util.Option)((0, _Util.Array)(Parameter)),
          documentation: (0, _Util.Option)(_Util.Any),
          schema: (0, _Util.Array)(_Util.Any),
          trace: (0, _Util.Array)("string")
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }]);
  return Member;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.RestProvider.Member", Member);

var ResultType = exports.ResultType = function () {
  function ResultType(caseName, fields) {
    (0, _classCallCheck3.default)(this, ResultType);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(ResultType, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.ResultType",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Generic: ["string", (0, _Util.Array)(ResultType)],
          Primitive: ["string"],
          Record: [(0, _Util.Array)((0, _Util.Tuple)(["string", ResultType]))]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsUnions)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareUnions)(this, other);
    }
  }]);
  return ResultType;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.RestProvider.ResultType", ResultType);

var RawField = exports.RawField = function () {
  function RawField(name, type) {
    (0, _classCallCheck3.default)(this, RawField);
    this.name = name;
    this.type = type;
  }

  (0, _createClass3.default)(RawField, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.RawField",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          name: "string",
          type: _Util.Any
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }]);
  return RawField;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.RestProvider.RawField", RawField);

var RawResultType = exports.RawResultType = function () {
  function RawResultType(name, fields, params) {
    (0, _classCallCheck3.default)(this, RawResultType);
    this.name = name;
    this.fields = fields;
    this.params = params;
  }

  (0, _createClass3.default)(RawResultType, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.RawResultType",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          name: "string",
          fields: (0, _Util.Array)(RawField),
          params: (0, _Util.Array)(_Util.Any)
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }]);
  return RawResultType;
}();

(0, _Symbol2.setType)("TheGamma.TypeProviders.RestProvider.RawResultType", RawResultType);

function parseDoc(json) {
  if (function () {
    return json == null;
  }(null)) {
    return new _ast.Documentation("None", []);
  } else if (typeof json === "string") {
    return new _ast.Documentation("Text", [json]);
  } else {
    var doc = json;
    var matchValue = [doc.title, doc.details];
    var $var426 = matchValue[0] != null ? matchValue[1] != null ? [0, matchValue[1], matchValue[0]] : [1] : [1];

    switch ($var426[0]) {
      case 0:
        return new _ast.Documentation("Details", [$var426[2], $var426[1]]);

      case 1:
        return new _ast.Documentation("None", []);
    }
  }
}

function fromRawType(json) {
  if (typeof json === "string") {
    return new ResultType("Primitive", [json]);
  } else {
    var res = json;

    if (res.name === "record") {
      return new ResultType("Record", [res.fields.map(function (f) {
        return [f.name, fromRawType(f.type)];
      })]);
    } else {
      return new ResultType("Generic", [res.name, (0, _from2.default)((0, _Seq.map)(function (json_1) {
        return fromRawType(json_1);
      }, res.params))]);
    }
  }
}

function trimLeft(c, s) {
  return (0, _from2.default)((0, _Seq.skipWhile)(function (y) {
    return c === y;
  }, s.split(""))).join('');
}

function trimRight(c, s) {
  return (0, _from2.default)((0, _Seq.skipWhile)(function (y) {
    return c === y;
  }, s.split("").slice().reverse())).slice().reverse().join('');
}

function concatUrl(a, b) {
  if (b.indexOf("http://") === 0 ? true : b.indexOf("https://") === 0) {
    return b;
  } else {
    return trimRight("/", a) + "/" + trimLeft("/", b);
  }
}

function load(url, cookies) {
  return function (builder_) {
    return builder_.Delay(function () {
      return builder_.Bind(_common.Http.Request("GET", url, null, cookies), function (_arg1) {
        var members = JSON.parse(_arg1);
        return builder_.Return(members);
      });
    });
  }(_AsyncBuilder.singleton);
}

function addTraceCall(inst, trace) {
  if ((0, _Seq.isEmpty)(trace)) {
    return inst;
  } else {
    return _babel.BabelOperators.op_DivideAtDivide(_babel.BabelOperators.op_Dynamic(inst, "addTrace"), (0, _List.ofArray)([_babel.BabelOperators.str((0, _String.join)("&", trace))]));
  }
}

function propAccess(trace) {
  return new _ast.Emitter(function (inst) {
    return addTraceCall(inst, trace);
  });
}

function methCall(traceNames, trace) {
  return new _ast.Emitter(function (inst) {
    return _babel.BabelOperators.funcN((0, _Seq.count)(traceNames), function (args) {
      var withTrace = addTraceCall(inst, trace);
      return function () {
        var folder = function folder(inst_1) {
          return function (tupledArg) {
            var trace_1 = new _babel.Expression("BinaryExpression", [new _babel.BinaryOperator("BinaryPlus", []), _babel.BabelOperators.str(tupledArg[0] + "="), tupledArg[1], null]);
            return _babel.BabelOperators.op_DivideAtDivide(_babel.BabelOperators.op_Dynamic(inst_1, "addTrace"), (0, _List.ofArray)([trace_1]));
          };
        };

        return function (source) {
          return (0, _Seq.fold)(function ($var427, $var428) {
            return folder($var427)($var428);
          }, withTrace, source);
        };
      }()((0, _Seq.zip)(traceNames, args));
    });
  });
}

function dataCall(parser, trace, endp) {
  return new _ast.Emitter(function (inst) {
    var tr = propAccess(trace).Emit(inst);
    var mem = new _babel.Expression("MemberExpression", [tr, new _babel.Expression("IdentifierExpression", ["getValue", null]), false, null]);
    return parser(new _babel.Expression("CallExpression", [mem, (0, _List.ofArray)([new _babel.Expression("StringLiteral", [endp, null])]), null]));
  });
}

function getTypeAndEmitter(lookupNamed, ty) {
  var $var429 = ty.Case === "Generic" ? ty.Fields[0] === "seq" ? ty.Fields[1].length === 1 ? ty.Fields[1][0].Case === "Generic" ? ty.Fields[1][0].Fields[0] === "tuple" ? function () {
    var testExpr = ty.Fields[1][0].Fields[1];
    return testExpr.length === 2;
  }() ? [4, ty.Fields[1][0].Fields[1][0], ty.Fields[1][0].Fields[1][1]] : [5, ty.Fields[1][0]] : [5, ty.Fields[1][0]] : [5, ty.Fields[1][0]] : [7] : [7] : ty.Case === "Record" ? [6, ty.Fields[0]] : ty.Fields[0] === "string" ? [0] : ty.Fields[0] === "obj" ? [1] : ty.Fields[0] === "int" ? [2] : ty.Fields[0] === "float" ? [2] : ty.Fields[0] === "date" ? [3] : [7];

  switch ($var429[0]) {
    case 0:
      return [new _ast.Type("Primitive", [new _ast.PrimitiveType("String", [])]), function (x) {
        return x;
      }];

    case 1:
      return [new _ast.Type("Primitive", [new _ast.PrimitiveType("String", [])]), function (x_1) {
        return x_1;
      }];

    case 2:
      return [new _ast.Type("Primitive", [new _ast.PrimitiveType("Number", [])]), function (e) {
        return _babel.BabelOperators.op_DivideAtDivide(_babel.BabelOperators.ident("Number"), (0, _List.ofArray)([e]));
      }];

    case 3:
      return [new _ast.Type("Primitive", [new _ast.PrimitiveType("Date", [])]), function (e_1) {
        return new _babel.Expression("NewExpression", [_babel.BabelOperators.ident("Date"), (0, _List.ofArray)([_babel.BabelOperators.op_DivideAtDivide(_babel.BabelOperators.op_Dynamic(_babel.BabelOperators.ident("Date"), "parse"), (0, _List.ofArray)([e_1]))]), null]);
      }];

    case 4:
      var patternInput = getTypeAndEmitter(lookupNamed, $var429[1]);
      var patternInput_1 = getTypeAndEmitter(lookupNamed, $var429[2]);
      var typ = (0, _fsharp.applyTypes)(lookupNamed("series"), (0, _List.ofArray)([patternInput[0], patternInput_1[0]]));
      return [typ, function (d) {
        return _babel.BabelOperators.op_DivideAtDivide(_babel.BabelOperators.op_Dynamic(_babel.BabelOperators.ident("series"), "create"), (0, _List.ofArray)([_babel.BabelOperators.op_DivideAtDivide(_babel.BabelOperators.ident("convertTupleSequence"), (0, _List.ofArray)([_babel.BabelOperators.func("v", patternInput[1]), _babel.BabelOperators.func("v", patternInput_1[1]), d])), _babel.BabelOperators.str("key"), _babel.BabelOperators.str("value"), _babel.BabelOperators.str("")]));
      }];

    case 5:
      var patternInput_2 = getTypeAndEmitter(lookupNamed, $var429[1]);
      var serTy = (0, _fsharp.applyTypes)(lookupNamed("series"), (0, _List.ofArray)([new _ast.Type("Primitive", [new _ast.PrimitiveType("Number", [])]), patternInput_2[0]]));
      return [serTy, function (d_1) {
        return _babel.BabelOperators.op_DivideAtDivide(_babel.BabelOperators.op_Dynamic(_babel.BabelOperators.ident("series"), "ordinal"), (0, _List.ofArray)([_babel.BabelOperators.op_DivideAtDivide(_babel.BabelOperators.ident("convertSequence"), (0, _List.ofArray)([_babel.BabelOperators.func("v", patternInput_2[1]), d_1])), _babel.BabelOperators.str("key"), _babel.BabelOperators.str("value"), _babel.BabelOperators.str("")]));
      }];

    case 6:
      var membs = $var429[1].map(function (tupledArg) {
        var patternInput_3 = getTypeAndEmitter(lookupNamed, tupledArg[1]);
        var emitter = new _ast.Emitter(function (inst) {
          return patternInput_3[1](_babel.BabelOperators.op_Dynamic(inst, tupledArg[0]));
        });
        return new _ast.Member(tupledArg[0], patternInput_3[0], (0, _List.ofArray)([_providers.ProviderHelpers.docMeta(new _ast.Documentation("Text", [""]))]), emitter);
      });
      var obj = new _ast.Type("Object", [(0, _defineProperty3.default)({
        get Members() {
          return membs;
        },

        TypeEquals: function (_arg1) {
          return false;
        }
      }, _Symbol3.default.reflection, function () {
        return {
          interfaces: ["TheGamma.ObjectType"]
        };
      })]);
      return [obj, function (x_2) {
        return x_2;
      }];

    case 7:
      console.log("getTypeAndEmitter: Cannot handle %O", ty);
      throw new Error("getTypeAndEmitter: Cannot handle type");
  }
}

var restTypeCache = exports.restTypeCache = new _map2.default();

function createRestType(lookupNamed, resolveProvider, root, cookies, url) {
  var provideMember = function provideMember(m) {
    var schema = m.schema == null ? new _List2.default() : Array.isArray(m.schema) ? (0, _Seq.toList)((0, _from2.default)((0, _Seq.map)(function (s) {
      var Type = s["@type"];
      return new _ast.Metadata(s["@context"], Type, s);
    }, m.schema))) : (0, _List.ofArray)([function () {
      var Type_1 = m.schema["@type"];
      return new _ast.Metadata(m.schema["@context"], Type_1, m.schema);
    }()]);
    var matchValue = m.returns.kind;

    switch (matchValue) {
      case "provider":
        var returns = m.returns;
        var patternInput = resolveProvider(returns.provider)(returns.endpoint);
        return new _ast.Member(m.name, patternInput[0], new _List2.default(_providers.ProviderHelpers.docMeta(parseDoc(m.documentation)), schema), patternInput[1]);

      case "nested":
        var returns_1 = m.returns;

        var createReturnType = function createReturnType(cookies_1) {
          try {
            return createRestType(lookupNamed, resolveProvider, root, cookies_1, returns_1.endpoint);
          } catch (matchValue_1) {
            return null;
          }
        };

        if (m.parameters == null) {
          var retTyp = (0, _Util.defaultArg)(createReturnType(cookies), new _ast.Type("Any", []));
          return new _ast.Member(m.name, retTyp, new _List2.default(_providers.ProviderHelpers.docMeta(parseDoc(m.documentation)), schema), propAccess(m.trace));
        } else {
          var args = (0, _Seq.toList)((0, _Seq.delay)(function () {
            return (0, _Seq.map)(function (p) {
              var ty = fromRawType(p.type);
              var patternInput_1 = getTypeAndEmitter(lookupNamed, ty);
              return new _ast.MethodArgument(p.name, p.optional, p.kind === "static", patternInput_1[0]);
            }, m.parameters);
          }));

          var retFunc = function retFunc(tys) {
            if (!(0, _typeops.listsEqual)((0, _List.map)(function (tuple) {
              return tuple[0];
            }, tys), (0, _Seq.toList)((0, _Seq.delay)(function () {
              return (0, _Seq.map)(function (ma) {
                return ma.Type;
              }, args);
            })), function (t1) {
              return function (t2) {
                return (0, _typeops.typesEqual)(t1, t2);
              };
            })) {
              return null;
            } else {
              var matched = (0, _Seq.zip)(m.parameters, tys);
              var newCookies = (0, _Seq.choose)(function (_arg1) {
                var $var430 = _arg1[1][1] != null ? function () {
                  var value = _arg1[1][1];
                  return _arg1[0].kind === "static";
                }() ? [0, _arg1[0], _arg1[1][1]] : [1] : [1];

                switch ($var430[0]) {
                  case 0:
                    return $var430[1].cookie + "=" + encodeURIComponent((0, _Util.toString)($var430[2]));

                  case 1:
                    return null;
                }
              }, matched);
              var cookies_2 = (0, _String.join)("&", (0, _Seq.append)((0, _List.ofArray)([cookies]), newCookies));
              return createReturnType(cookies_2);
            }
          };

          var traceNames = (0, _Seq.choose)(function (p_1) {
            return p_1.trace;
          }, m.parameters);
          var Metadata = (0, _List.ofArray)([_providers.ProviderHelpers.docMeta(parseDoc(m.documentation))]);
          return new _ast.Member(m.name, new _ast.Type("Method", [args, retFunc]), Metadata, methCall(traceNames, m.trace));
        }

      case "primitive":
        var returns_2 = m.returns;
        var ty_1 = fromRawType(returns_2.type);
        var patternInput_2 = getTypeAndEmitter(lookupNamed, ty_1);
        return new _ast.Member(m.name, patternInput_2[0], new _List2.default(_providers.ProviderHelpers.docMeta(parseDoc(m.documentation)), schema), dataCall(patternInput_2[1], m.trace, returns_2.endpoint));

      default:
        throw new Error("?");
    }
  };

  var guid = concatUrl(root, url) + cookies;
  var matchValue_2 = (0, _Map2.tryGetValue)(restTypeCache, guid, null);

  if (matchValue_2[0]) {
    return matchValue_2[1];
  } else {
    var future = function (builder_) {
      return builder_.Delay(function () {
        return builder_.TryWith(builder_.Delay(function () {
          return builder_.Bind(load(concatUrl(root, url), cookies), function (_arg2) {
            var members = function (array) {
              return array.map(provideMember);
            }(_arg2);

            return builder_.Return(new _ast.Type("Object", [(0, _defineProperty3.default)({
              get Members() {
                return members;
              },

              TypeEquals: function (_arg3) {
                return false;
              }
            }, _Symbol3.default.reflection, function () {
              return {
                interfaces: ["TheGamma.ObjectType"]
              };
            })]));
          });
        }), function (_arg4) {
          _common.Log.error("providers", "Cannot provide object type: %O", _arg4);

          return builder_.Return(new _ast.Type("Any", []));
        });
      });
    }(_AsyncBuilder.singleton);

    var ty_2 = new _ast.Type("Delayed", [function (arg00) {
      return function (arg10) {
        return (0, _common.Async$2E$CreateNamedFuture$2E$Static)(arg00, arg10);
      };
    }(guid)(future)]);
    restTypeCache.set(guid, ty_2);
    return ty_2;
  }
}

function provideRestType(lookupNamed, resolveProvider, name, root, cookies) {
  var ctx = _babel.BabelOperators.ident("RuntimeContext");

  return new _providers.ProvidedType("GlobalValue", [name, new _List2.default(), new _babel.Expression("NewExpression", [ctx, (0, _List.ofArray)([_babel.BabelOperators.str(root), _babel.BabelOperators.str(cookies), _babel.BabelOperators.str("")]), null]), createRestType(lookupNamed, resolveProvider, root, cookies, "/")]);
}
//# sourceMappingURL=rest.js.map