import _typeof from "babel-runtime/helpers/typeof";
import _Map from "babel-runtime/core-js/map";
import _defineProperty from "babel-runtime/helpers/defineProperty";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import _getIterator from "babel-runtime/core-js/get-iterator";
import _Array$from from "babel-runtime/core-js/array/from";
import { equalsRecords, makeGeneric, GenericParam, Option, defaultArg, compare, toString } from "fable-core/Util";
import { unfold, sumBy, toList, iterate, append, forAll, rangeStep, range, map as map_1, delay } from "fable-core/Seq";
import { fsFormat, padLeft, insert } from "fable-core/String";
import { create } from "fable-core/Set";
import { append as append_1, ofArray } from "fable-core/List";
import List_1 from "fable-core/List";
import GenericComparer from "fable-core/GenericComparer";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { millisecond, second, minute, hour, now } from "fable-core/Date";
import { parallel, startImmediate, fromContinuations } from "fable-core/Async";
import Choice from "fable-core/Choice";
import { singleton } from "fable-core/AsyncBuilder";
export function niceNumber(num, decs) {
  var str = toString(num);
  var dot = str.indexOf(".");
  var patternInput = dot === -1 ? [str, ""] : [str.substr(0, dot), str.substr(dot + 1, decs < str.length - dot - 1 ? decs : str.length - dot - 1)];
  var after = patternInput[1].length < decs ? patternInput[1] + _Array$from(delay(function () {
    return map_1(function (i) {
      return "0";
    }, range(1, decs - patternInput[1].length));
  })).join('') : patternInput[1];
  var res = patternInput[0];

  if (patternInput[0].length > 5) {
    var inputSequence = rangeStep(patternInput[0].length - 1, -1, 0);
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = _getIterator(inputSequence), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var i_1 = _step.value;
        var j = patternInput[0].length - i_1;

        if (i_1 !== 0 ? j % 3 === 0 : false) {
          res = insert(res, i_1, ",");
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  }

  if (forAll(function () {
    var x = "0";
    return function (y) {
      return x === y;
    };
  }(), after)) {
    return res;
  } else {
    return res + "." + after;
  }
}
export function isLocalHost() {
  if (typeof window == 'undefined' ? true : window.location.hostname === "localhost") {
    return true;
  } else {
    return window.location.hostname === "127.0.0.1";
  }
}
export var enabledCategories = !isLocalHost() ? create(new List_1(), new GenericComparer(compare)) : create(ofArray(["*"]), new GenericComparer(compare));
export var Log = function () {
  function Log() {
    _classCallCheck(this, Log);
  }

  _createClass(Log, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Common.Log",
        properties: {}
      };
    }
  }], [{
    key: "setEnabled",
    value: function (cats) {
      enabledCategories = cats;
    }
  }, {
    key: "event",
    value: function (category, evt, article, data) {
      if (typeof logEvent != 'undefined') logEvent(category, evt, article, data);
    }
  }, {
    key: "message",
    value: function (level, category, msg) {
      for (var _len = arguments.length, args = Array(_len > 3 ? _len - 3 : 0), _key = 3; _key < _len; _key++) {
        args[_key - 3] = arguments[_key];
      }

      var args_1 = args == null ? [] : args;
      var category_1 = category.toLocaleUpperCase();

      if (!isLocalHost() ? level === "EXCEPTION" : false) {
        if (typeof logEvent != 'undefined') logEvent("system", "exception", "", {
          category: category_1,
          msg: msg,
          args: args_1
        });
      }

      if (((level === "EXCEPTION" ? true : level === "ERROR") ? true : enabledCategories.has("*")) ? true : enabledCategories.has(category_1)) {
        var dt = now();

        var p2 = function p2(s) {
          return padLeft(String(s), 2, "0");
        };

        var p4 = function p4(s_1) {
          return padLeft(String(s_1), 4, "0");
        };

        var prefix = fsFormat("[%s:%s:%s:%s] %s: ")(function (x) {
          return x;
        })(p2(hour(dt)))(p2(minute(dt)))(p2(second(dt)))(p4(millisecond(dt)))(category_1);
        var color = void 0;

        switch (level) {
          case "TRACE":
            color = "color:#808080";
            break;

          case "EXCEPTION":
            color = "color:#c00000";
            break;

          case "ERROR":
            color = "color:#900000";
            break;

          default:
            color = "";
        }

        console.log.apply(console, _Array$from(append(["%c" + prefix + msg, color], args_1)));
      }
    }
  }, {
    key: "trace",
    value: function (category, msg) {
      for (var _len2 = arguments.length, args = Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
        args[_key2 - 2] = arguments[_key2];
      }

      Log.message.apply(Log, ["TRACE", category, msg].concat(args));
    }
  }, {
    key: "exn",
    value: function (category, msg) {
      for (var _len3 = arguments.length, args = Array(_len3 > 2 ? _len3 - 2 : 0), _key3 = 2; _key3 < _len3; _key3++) {
        args[_key3 - 2] = arguments[_key3];
      }

      Log.message.apply(Log, ["EXCEPTION", category, msg].concat(args));
    }
  }, {
    key: "error",
    value: function (category, msg) {
      for (var _len4 = arguments.length, args = Array(_len4 > 2 ? _len4 - 2 : 0), _key4 = 2; _key4 < _len4; _key4++) {
        args[_key4 - 2] = arguments[_key4];
      }

      Log.message.apply(Log, ["ERROR", category, msg].concat(args));
    }
  }]);

  return Log;
}();
setType("TheGamma.Common.Log", Log);
export var Http = function () {
  function Http() {
    _classCallCheck(this, Http);
  }

  _createClass(Http, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Common.Http",
        properties: {}
      };
    }
  }], [{
    key: "Request",
    value: function (meth, url, data, cookies) {
      return fromContinuations(function (tupledArg) {
        var xhr = new XMLHttpRequest();
        xhr.open(meth, url, true);
        var $var1 = cookies != null ? cookies !== "" ? [0, cookies] : [1] : [1];

        switch ($var1[0]) {
          case 0:
            xhr.setRequestHeader("X-Cookie", $var1[1]);
            break;

          case 1:
            break;
        }

        xhr.onreadystatechange = function (_arg1) {
          if (xhr.readyState > 3 ? xhr.status === 200 : false) {
            tupledArg[0](xhr.responseText);
          }

          if (xhr.readyState > 3 ? xhr.status === 0 : false) {
            tupledArg[1](new Error(meth + " " + url + " failed: " + xhr.statusText));
          }

          return {};
        };

        xhr.send(data != null ? data : "");
      });
    }
  }]);

  return Http;
}();
setType("TheGamma.Common.Http", Http);

function Async_AwaitFuture_Static(f) {
  return fromContinuations(function (tupledArg) {
    f.Then(tupledArg[0]);
  });
}

export { Async_AwaitFuture_Static as Async$2E$AwaitFuture$2E$Static };

function Async_Future_Static(n, op, start) {
  var res = new Choice("Choice1Of3", [null]);
  var handlers = new List_1();
  var running = false;

  var trigger = function trigger(h) {
    if (res.Case === "Choice2Of3") {
      var v = res.Fields[0];
      h(v);
    } else if (res.Case === "Choice3Of3") {
      var e = res.Fields[0];
      throw e;
    } else {
      handlers = new List_1(h, handlers);
    }
  };

  var ensureStarted = function ensureStarted() {
    if (!running) {
      iterate(function (n_1) {
        Log.trace("system", "Starting future '%s'....", n_1);
      }, defaultArg(n, [], function (x) {
        return [x];
      }));
      running = true;

      (function (arg00) {
        startImmediate(arg00);
      })(function (builder_) {
        return builder_.Delay(function () {
          return builder_.Combine(builder_.TryWith(builder_.Delay(function () {
            return builder_.Bind(op, function (_arg1) {
              iterate(function (n_2) {
                Log.trace("system", "Future '%s' evaluated to: %O", n_2, _arg1);
              }, defaultArg(n, [], function (x) {
                return [x];
              }));
              res = new Choice("Choice2Of3", [_arg1]);
              return builder_.Zero();
            });
          }), function (_arg2) {
            Log.exn("system", "Evaluating future failed: %O", _arg2);
            res = new Choice("Choice3Of3", [_arg2]);
            return builder_.Zero();
          }), builder_.Delay(function () {
            return builder_.For(handlers, function (_arg3) {
              trigger(_arg3);
              return builder_.Zero();
            });
          }));
        });
      }(singleton));
    }
  };

  if (start === true) {
    ensureStarted(null);
  }

  return _defineProperty({
    Then: function (f) {
      ensureStarted(null);
      trigger(f);
    }
  }, _Symbol.reflection, function () {
    return {
      interfaces: ["TheGamma.Common.Future"]
    };
  });
}

export { Async_Future_Static as Async$2E$Future$2E$Static };

function Async_CreateFuture_Static(op) {
  return function (arg00) {
    return function (arg10) {
      return function (arg20) {
        return Async_Future_Static(arg00, arg10, arg20);
      };
    };
  }(null)(op)(false);
}

export { Async_CreateFuture_Static as Async$2E$CreateFuture$2E$Static };

function Async_StartAsFuture_Static(op) {
  return function (arg00) {
    return function (arg10) {
      return function (arg20) {
        return Async_Future_Static(arg00, arg10, arg20);
      };
    };
  }(null)(op)(true);
}

export { Async_StartAsFuture_Static as Async$2E$StartAsFuture$2E$Static };

function Async_CreateNamedFuture_Static(name, op) {
  return function (arg00) {
    return function (arg10) {
      return function (arg20) {
        return Async_Future_Static(arg00, arg10, arg20);
      };
    };
  }(name)(op)(false);
}

export { Async_CreateNamedFuture_Static as Async$2E$CreateNamedFuture$2E$Static };

function Async_StartAsNamedFuture_Static(name, op) {
  return function (arg00) {
    return function (arg10) {
      return function (arg20) {
        return Async_Future_Static(arg00, arg10, arg20);
      };
    };
  }(name)(op)(true);
}

export { Async_StartAsNamedFuture_Static as Async$2E$StartAsNamedFuture$2E$Static };
export var Async = function (__exports) {
  var _Array = __exports.Array = function (__exports) {
    var Parallel = __exports.Parallel = function (__exports) {
      var map = __exports.map = function (f, ar) {
        return function (builder_) {
          return builder_.Delay(function () {
            var res = new Array(ar.length).fill(null);
            var work = parallel(toList(delay(function () {
              return map_1(function (i) {
                return function (builder__1) {
                  return builder__1.Delay(function () {
                    return builder__1.Bind(f(ar[i]), function (_arg1) {
                      res[i] = _arg1;
                      return builder__1.Zero();
                    });
                  });
                }(singleton);
              }, range(0, ar.length - 1));
            })));
            return builder_.Bind(work, function (_arg2) {
              return builder_.Return(res);
            });
          });
        }(singleton);
      };

      return __exports;
    }({});

    var map = __exports.map = function (f, ar) {
      return function (builder_) {
        return builder_.Delay(function () {
          var res = new Array(ar.length).fill(null);
          return builder_.Combine(builder_.For(range(0, ar.length - 1), function (_arg1) {
            return builder_.Bind(f(ar[_arg1]), function (_arg2) {
              res[_arg1] = _arg2;
              return builder_.Zero();
            });
          }), builder_.Delay(function () {
            return builder_.Return(res);
          }));
        });
      }(singleton);
    };

    return __exports;
  }({});

  var collect = __exports.collect = function (f, l) {
    return function (builder_) {
      return builder_.Delay(function () {
        return l.tail == null ? builder_.Return(new List_1()) : builder_.Bind(f(l.head), function (_arg1) {
          return builder_.Bind(collect(f, l.tail), function (_arg2) {
            return builder_.Return(append_1(_arg1, _arg2));
          });
        });
      });
    }(singleton);
  };

  var choose = __exports.choose = function (f, l) {
    return function (builder_) {
      return builder_.Delay(function () {
        return l.tail == null ? builder_.Return(new List_1()) : builder_.Bind(f(l.head), function (_arg1) {
          return builder_.Bind(choose(f, l.tail), function (_arg2) {
            return builder_.Return(_arg1 != null ? new List_1(_arg1, _arg2) : _arg2);
          });
        });
      });
    }(singleton);
  };

  var map = __exports.map = function (f, l) {
    return function (builder_) {
      return builder_.Delay(function () {
        return l.tail == null ? builder_.Return(new List_1()) : builder_.Bind(f(l.head), function (_arg1) {
          return builder_.Bind(map(f, l.tail), function (_arg2) {
            return builder_.Return(new List_1(_arg1, _arg2));
          });
        });
      });
    }(singleton);
  };

  var foldMap = __exports.foldMap = function (f, st, l) {
    return function (builder_) {
      return builder_.Delay(function () {
        return l.tail == null ? builder_.Return([st, new List_1()]) : builder_.Bind(f(st)(l.head), function (_arg1) {
          return builder_.Bind(foldMap(f, _arg1[1], l.tail), function (_arg2) {
            return builder_.Return([_arg2[0], new List_1(_arg1[0], _arg2[1])]);
          });
        });
      });
    }(singleton);
  };

  var fold = __exports.fold = function (f, st, l) {
    return function (builder_) {
      return builder_.Delay(function () {
        return l.tail == null ? builder_.Return(st) : builder_.Bind(f(st)(l.head), function (_arg1) {
          return builder_.ReturnFrom(fold(f, _arg1, l.tail));
        });
      });
    }(singleton);
  };

  return __exports;
}({});
export var ListDictionaryNode = function () {
  function ListDictionaryNode(result, nested) {
    _classCallCheck(this, ListDictionaryNode);

    this.Result = result;
    this.Nested = nested;
  }

  _createClass(ListDictionaryNode, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Common.ListDictionaryNode",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          Result: Option(GenericParam("T")),
          Nested: makeGeneric(_Map, {
            TKey: GenericParam("K"),
            TValue: makeGeneric(ListDictionaryNode, {
              K: GenericParam("K"),
              T: GenericParam("T")
            })
          })
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }]);

  return ListDictionaryNode;
}();
setType("TheGamma.Common.ListDictionaryNode", ListDictionaryNode);
export var ListDictionaryModule = function (__exports) {
  var tryFind = __exports.tryFind = function (ks, dict) {
    var loop = function loop(ks_1) {
      return function (node) {
        var _loop = function _loop() {
          var matchValue = [ks_1, node];
          var $var2 = matchValue[0].tail != null ? function () {
            var ks_2 = matchValue[0].tail;
            var k = matchValue[0].head;
            var d = matchValue[1].Nested;
            return d.has(k);
          }() ? [1, matchValue[1].Nested, matchValue[0].head, matchValue[0].tail] : [2] : matchValue[1].Result != null ? [0, matchValue[1].Result] : [2];

          switch ($var2[0]) {
            case 0:
              return {
                v: $var2[1]
              };

            case 1:
              ks_1 = $var2[3];
              node = $var2[1].get($var2[2]);
              return "continue|loop";

            case 2:
              return {
                v: null
              };
          }
        };

        loop: while (true) {
          var _ret = _loop();

          switch (_ret) {
            case "continue|loop":
              continue loop;

            default:
              if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;
          }
        }
      };
    };

    return loop(ks)(new ListDictionaryNode(null, dict));
  };

  var set = __exports.set = function (ks, v, dict) {
    var loop = function loop(ks_1) {
      return function (dict_1) {
        if (ks_1.tail != null) {
          if (!dict_1.has(ks_1.head)) {
            dict_1.set(ks_1.head, function () {
              var Nested = new _Map();
              return new ListDictionaryNode(null, Nested);
            }());
          }

          if (ks_1.tail.tail == null) {
            dict_1.get(ks_1.head).Result = v;
          } else {
            loop(ks_1.tail)(dict_1.get(ks_1.head).Nested);
          }
        } else {
          throw new Error("Empty key not supported");
        }
      };
    };

    loop(ks)(dict);
  };

  var count = __exports.count = function (dict) {
    var loop = function loop(node) {
      var nest = sumBy(function (kv) {
        return loop(kv[1]);
      }, node.Nested);

      if (function () {
        return node.Result != null;
      }(null)) {
        return 1 + nest;
      } else {
        return nest;
      }
    };

    return sumBy(function (kv_1) {
      return loop(kv_1[1]);
    }, dict);
  };

  return __exports;
}({});
export var List = function (__exports) {
  var groupWith = __exports.groupWith = function (f, list) {
    var groups = [];
    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
      for (var _iterator2 = _getIterator(list), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
        var e = _step2.value;
        var added = false;
        var i = 0;

        while (!added ? i < groups.length : false) {
          if (f(e)(groups[i][0])) {
            groups[i][1].push(e);
            added = true;
          }

          i = i + 1;
        }

        if (!added) {
          groups.push([e, _Array$from(ofArray([e]))]);
        }
      }
    } catch (err) {
      _didIteratorError2 = true;
      _iteratorError2 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion2 && _iterator2.return) {
          _iterator2.return();
        }
      } finally {
        if (_didIteratorError2) {
          throw _iteratorError2;
        }
      }
    }

    return toList(map_1(function ($var3) {
      return toList($var3[1]);
    }, groups));
  };

  var unreduce = __exports.unreduce = function (f, s) {
    return toList(unfold(function (s_1) {
      return defaultArg(f(s_1), null, function (v) {
        return [v, v];
      });
    }, s));
  };

  return __exports;
}({});
//# sourceMappingURL=common.js.map