import _Array$from from "babel-runtime/core-js/array/from";
import _getIterator from "babel-runtime/core-js/get-iterator";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { startImmediate } from "fable-core/Async";
import Async from "fable-core/Async";
import { Async$2E$AwaitFuture$2E$Static as Async_AwaitFuture_Static, Log } from "../common";
import { singleton } from "fable-core/AsyncBuilder";
import { ofArray, append } from "fable-core/List";
import List from "fable-core/List";
import { append as append_1, initialize, fold, mapIndexed, range, sortWith, toList, zip } from "fable-core/Seq";
import { defaultArg, compare } from "fable-core/Util";
import { tryFind, add, create } from "fable-core/Map";
import GenericComparer from "fable-core/GenericComparer";
import { SeriesInternals } from "../series";
export var ChartData = function () {
  function ChartData(data) {
    _classCallCheck(this, ChartData);

    this.data = data;
  }

  _createClass(ChartData, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.ChartData",
        interfaces: ["FSharpRecord"],
        properties: {
          data: Async
        }
      };
    }
  }]);

  return ChartData;
}();
setType("TheGamma.GoogleCharts.ChartData", ChartData);
export var LazyCharting = function (__exports) {
  var chartsToDraw = __exports.chartsToDraw = [];
  var googleLoaded = (Object.defineProperty(__exports, 'googleLoaded', {
    get: function get() {
      return googleLoaded;
    },
    set: function set(x) {
      return googleLoaded = x;
    }
  }), false);

  var drawChartOnLoad = __exports.drawChartOnLoad = function (f) {
    if (googleLoaded) {
      f(null);
    } else {
      chartsToDraw.push(f);
    }
  };

  if (typeof google != "undefined") google.load('visualization', '1', {
    'packages': ['corechart'],
    'callback': function () {
      (function () {
        googleLoaded = true;
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = _getIterator(chartsToDraw), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var f = _step.value;
            f(null);
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      })();
    }
  });
  return __exports;
}({});
export var Helpers = function (__exports) {
  var copy = __exports.copy = function (o, prop) {
    if (o == null) {
      return undefined;
    } else {
      return o[prop];
    }
  };

  var orDefault = __exports.orDefault = function (newValue) {
    if (newValue != null) {
      return newValue;
    } else {
      return undefined;
    }
  };

  var right = __exports.right = function (o, prop, newValue) {
    if (newValue != null) {
      return newValue;
    } else if (o == null) {
      return undefined;
    } else {
      return o[prop];
    }
  };

  var showChart = __exports.showChart = function (chart, outputId) {
    LazyCharting.drawChartOnLoad(function () {
      (function (arg00) {
        startImmediate(arg00);
      })(function (builder_) {
        return builder_.Delay(function () {
          return builder_.TryWith(builder_.Delay(function () {
            return builder_.Bind(chart["data"].data, function (_arg1) {
              var ctor = eval("(function(a) { return new google.visualization." + chart.typeName + " (a); })");
              var ch = ctor(document.getElementById(outputId));
              if (chart.options.height == undefined) chart.options.height = 400;
              ch.draw(_arg1, chart.options);
              return builder_.Zero();
            });
          }), function (_arg2) {
            Log.error("google", "Error when getting data or rendering chart: %O", _arg2);
            return builder_.Zero();
          });
        });
      }(singleton));
    });
  };

  return __exports;
}({});
export var ChartDataOperations = function (__exports) {
  var collect = __exports.collect = function (f, l) {
    return function (builder_) {
      return builder_.Delay(function () {
        return l.tail == null ? builder_.Return(new List()) : builder_.Bind(f(l.head), function (_arg1) {
          return builder_.Bind(collect(f, l.tail), function (_arg2) {
            return builder_.Return(append(_arg1, _arg2));
          });
        });
      });
    }(singleton);
  };

  var oneKeyValue = __exports.oneKeyValue = function (keyType, v) {
    return new ChartData(function (builder_) {
      return builder_.Delay(function () {
        var data = new google.visualization.DataTable();
        data.addColumn(keyType, v.keyName);
        data.addColumn("number", v.seriesName);
        return builder_.Bind(Async_AwaitFuture_Static(v.mapPairs(function (k) {
          return function (v_1) {
            return [k, v_1];
          };
        }).data), function (_arg1) {
          (function (arg00) {
            data.addRows(arg00);
          })(_arg1.map(function (tuple) {
            return tuple[1];
          }));

          return builder_.Return(data);
        });
      });
    }(singleton));
  };

  var oneKeyTwoValues = __exports.oneKeyTwoValues = function (keyType, v) {
    return new ChartData(function (builder_) {
      return builder_.Delay(function () {
        var data = new google.visualization.DataTable();
        data.addColumn(keyType, v.keyName);
        data.addColumn("number", v.seriesName);
        data.addColumn("number", v.seriesName);
        return builder_.Bind(Async_AwaitFuture_Static(v.mapPairs(function (k) {
          return function (tupledArg) {
            return [k, tupledArg[0], tupledArg[1]];
          };
        }).data), function (_arg1) {
          (function (arg00) {
            data.addRows(arg00);
          })(_arg1.map(function (tuple) {
            return tuple[1];
          }));

          return builder_.Return(data);
        });
      });
    }(singleton));
  };

  var oneKeyAppendValues = __exports.oneKeyAppendValues = function (keyType, vs, colors) {
    return new ChartData(function (builder_) {
      return builder_.Delay(function () {
        var data = new google.visualization.DataTable();
        data.addColumn(keyType, vs[0].keyName);
        data.addColumn("number", vs[0].valueName);
        data.addColumn({
          type: "string",
          role: "style"
        });
        return builder_.Bind(collect(function (tupledArg) {
          return function (builder__1) {
            return builder__1.Delay(function () {
              return builder__1.Bind(Async_AwaitFuture_Static(tupledArg[0].mapPairs(function (k) {
                return function (v) {
                  return [k, v, tupledArg[1]];
                };
              }).data), function (_arg1) {
                return builder__1.Return(ofArray(_arg1.map(function (tuple) {
                  return tuple[1];
                })));
              });
            });
          }(singleton);
        }, ofArray(_Array$from(zip(vs, colors)))), function (_arg2) {
          (function (arg00) {
            data.addRows(arg00);
          })(_Array$from(toList(sortWith(function (x, y) {
            return -compare(function (tupledArg_2) {
              return tupledArg_2[1];
            }(x), function (tupledArg_2) {
              return tupledArg_2[1];
            }(y));
          }, _arg2))).map(function (tupledArg_1) {
            return [tupledArg_1[0], tupledArg_1[1], tupledArg_1[2]];
          }));

          return builder_.Return(data);
        });
      });
    }(singleton));
  };

  var oneKeyNValues = __exports.oneKeyNValues = function (keyType, v) {
    return new ChartData(function (builder_) {
      return builder_.Delay(function () {
        var data = new google.visualization.DataTable();
        return builder_.Bind(Async_AwaitFuture_Static(v.data), function (_arg1) {
          var v_1 = _arg1.map(function (tuple) {
            return tuple[1];
          });

          data.addColumn(keyType, v_1[0].keyName);
          return builder_.Combine(builder_.For(range(0, v_1.length - 1), function (_arg2) {
            data.addColumn("number", v_1[_arg2].seriesName);
            return builder_.Zero();
          }), builder_.Delay(function () {
            var head = v_1[0].map(function (v_2) {
              return create(ofArray([[0, v_2]]), new GenericComparer(compare));
            });

            var tail = _Array$from(mapIndexed(function (i, v_3) {
              return [i + 1, v_3];
            }, SeriesInternals.slice(1, v_1.length - 1, v_1)));

            var all = fold(function (s1, tupledArg) {
              return s1.joinOuter(tupledArg[1]).map(function (tupledArg_1) {
                var matchValue = [defaultArg(tupledArg_1[0], create(null, new GenericComparer(compare))), tupledArg_1[1]];

                if (matchValue[1] == null) {
                  return matchValue[0];
                } else {
                  var r = matchValue[1];
                  return add(tupledArg[0], r, matchValue[0]);
                }
              });
            }, head, tail);
            return builder_.Bind(Async_AwaitFuture_Static(all.mapPairs(function (k) {
              return function (vals) {
                var data_1 = _Array$from(initialize(v_1.length, function (i_1) {
                  return defaultArg(tryFind(i_1, vals), undefined);
                }));

                return _Array$from(append_1([k], data_1));
              };
            }).data), function (_arg3) {
              (function (arg00) {
                data.addRows(arg00);
              })(_arg3.map(function (tuple_1) {
                return tuple_1[1];
              }));

              return builder_.Return(data);
            });
          }));
        });
      });
    }(singleton));
  };

  var twoValues = __exports.twoValues = function (v1, v2) {
    return new ChartData(function (builder_) {
      return builder_.Delay(function () {
        var data = new google.visualization.DataTable();
        data.addColumn("number", v1.seriesName);
        data.addColumn("number", v2.seriesName);
        return builder_.Bind(Async_AwaitFuture_Static(v1.joinInner(v2).map(function (v) {
          return [v.first, v.second];
        }).data), function (_arg1) {
          (function (arg00) {
            data.addRows(arg00);
          })(_arg1.map(function (tuple) {
            return tuple[1];
          }));

          return builder_.Return(data);
        });
      });
    }(singleton));
  };

  return __exports;
}({});
//# sourceMappingURL=core.js.map