import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import _getIterator from "babel-runtime/core-js/get-iterator";
import _Map from "babel-runtime/core-js/map";
import _Array$from from "babel-runtime/core-js/array/from";
import { maxBy as _maxBy, minBy as _minBy, sumBy as _sumBy, choose as _choose, sortWith, rangeStep, range as _range, mapIndexed, initialize } from "fable-core/Seq";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { startImmediate } from "fable-core/Async";
import Async from "fable-core/Async";
import { singleton } from "fable-core/AsyncBuilder";
import { toString, makeGeneric, Any, randomNext, compare, equals, equalsRecords, Interface } from "fable-core/Util";
import { Async$2E$AwaitFuture$2E$Static as Async_AwaitFuture_Static, Async$2E$StartAsFuture$2E$Static as Async_StartAsFuture_Static } from "./common";
import { pair } from "./general";
import { tryFind, create } from "fable-core/Map";
import GenericComparer from "fable-core/GenericComparer";
export var SeriesInternals = function (__exports) {
  var slice = __exports.slice = function (lo, hi, arr) {
    return _Array$from(initialize(hi - lo + 1, function (i) {
      return arr[lo + i];
    }));
  };

  var dictAny = __exports.dictAny = function (v) {
    return new _Map(v);
  };

  var zipUnsorted = __exports.zipUnsorted = function (arr1, arr2) {
    var d1 = dictAny(arr1);
    var d2 = dictAny(arr2);
    var res = [];
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = _getIterator(d1), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var kv1 = _step.value;
        var v2 = d2.has(kv1[0]) ? d2.get(kv1[0]) : null;
        res.push([kv1[0], [kv1[1], v2]]);
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
      for (var _iterator2 = _getIterator(d2), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
        var kv2 = _step2.value;

        if (!d1.has(kv2[0])) {
          res.push([kv2[0], [null, kv2[1]]]);
        }
      }
    } catch (err) {
      _didIteratorError2 = true;
      _iteratorError2 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion2 && _iterator2.return) {
          _iterator2.return();
        }
      } finally {
        if (_didIteratorError2) {
          throw _iteratorError2;
        }
      }
    }

    return _Array$from(res);
  };

  var isSortedUsing = __exports.isSortedUsing = function (test, proj, arr) {
    var loop = function loop(i) {
      loop: while (true) {
        if (i === arr.length) {
          return true;
        } else if (test(proj(arr[i - 1]))(proj(arr[i]))) {
          i = i + 1;
          continue loop;
        } else {
          return false;
        }
      }
    };

    if (arr.length === 0) {
      return true;
    } else {
      return loop(1);
    }
  };

  var zipSorted = __exports.zipSorted = function (arr1, arr2) {
    var i1 = 0;
    var i2 = 0;
    var res = [];

    while (i1 < arr1.length ? i2 < arr2.length : false) {
      var patternInput = [arr1[i1], arr2[i2]];
      var v2 = patternInput[1][1];
      var v1 = patternInput[0][1];
      var k2 = patternInput[1][0];
      var k1 = patternInput[0][0];

      if (function (a) {
        return function (b) {
          return (a < b ? -1 : a == b ? 0 : 1) === 0;
        };
      }(k1)(k2)) {
        res.push([k1, [v1, v2]]);
        i1 = i1 + 1;
        i2 = i2 + 1;
      } else if (function (a_1) {
        return function (b_1) {
          return (a_1 < b_1 ? -1 : a_1 == b_1 ? 0 : 1) < 0;
        };
      }(k1)(k2)) {
        res.push([k1, [v1, null]]);
        i1 = i1 + 1;
      } else if (function (a_2) {
        return function (b_2) {
          return (a_2 < b_2 ? -1 : a_2 == b_2 ? 0 : 1) < 0;
        };
      }(k2)(k1)) {
        res.push([k2, [null, v2]]);
        i2 = i2 + 1;
      }
    }

    while (i1 < arr1.length) {
      var patternInput_1 = arr1[i1];
      res.push([patternInput_1[0], [patternInput_1[1], null]]);
      i1 = i1 + 1;
    }

    while (i2 < arr2.length) {
      var patternInput_2 = arr2[i2];
      res.push([patternInput_2[0], [null, patternInput_2[1]]]);
      i2 = i2 + 2;
    }

    return _Array$from(res);
  };

  var zipAny = __exports.zipAny = function (arr1, arr2) {
    var op_LessEqualsDot = function op_LessEqualsDot(a) {
      return function (b) {
        return (a < b ? -1 : a == b ? 0 : 1) <= 0;
      };
    };

    var op_GreaterEqualsDot = function op_GreaterEqualsDot(a_1) {
      return function (b_1) {
        return (a_1 < b_1 ? -1 : a_1 == b_1 ? 0 : 1) >= 0;
      };
    };

    if (isSortedUsing(op_LessEqualsDot, function (tuple) {
      return tuple[0];
    }, arr1) ? isSortedUsing(op_LessEqualsDot, function (tuple_1) {
      return tuple_1[0];
    }, arr2) : false) {
      return zipSorted(arr1, arr2);
    } else if (isSortedUsing(op_GreaterEqualsDot, function (tuple_2) {
      return tuple_2[0];
    }, arr1) ? isSortedUsing(op_GreaterEqualsDot, function (tuple_3) {
      return tuple_3[0];
    }, arr2) : false) {
      return zipSorted(arr1.slice().reverse(), arr2.slice().reverse()).slice().reverse();
    } else {
      return zipUnsorted(arr1, arr2);
    }
  };

  return __exports;
}({});
export var val = function () {
  function val(value) {
    _classCallCheck(this, val);

    this.value = value;
  }

  _createClass(val, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Series.val",
        interfaces: ["FSharpRecord"],
        properties: {
          value: Async
        }
      };
    }
  }, {
    key: "map",
    value: function (f) {
      var _this = this;

      return new val(function (builder_) {
        return builder_.Delay(function () {
          return builder_.Bind(_this.value, function (_arg1) {
            return builder_.Return(f(_arg1));
          });
        });
      }(singleton));
    }
  }]);

  return val;
}();
setType("TheGamma.Series.val", val);
export var helpers = function () {
  function helpers() {
    _classCallCheck(this, helpers);
  }

  _createClass(helpers, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Series.helpers",
        properties: {}
      };
    }
  }]);

  return helpers;
}();
setType("TheGamma.Series.helpers", helpers);

var series = function () {
  function series(data, keyName, valueName, seriesName) {
    _classCallCheck(this, series);

    this.data = data;
    this.keyName = keyName;
    this.valueName = valueName;
    this.seriesName = seriesName;
  }

  _createClass(series, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Series.series",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          data: Interface("TheGamma.Common.Future"),
          keyName: "string",
          valueName: "string",
          seriesName: "string"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }, {
    key: "set",
    value: function (data, keyName, valueName, seriesName) {
      return new series(data, keyName != null ? keyName : this.keyName, valueName != null ? valueName : this.valueName, seriesName != null ? seriesName : this.seriesName);
    }
  }, {
    key: "setProperties",
    value: function (keyName, valueName, seriesName) {
      var keyName_1 = keyName != null ? keyName : this.keyName;
      var valueName_1 = valueName != null ? valueName : this.valueName;
      var seriesName_1 = seriesName != null ? seriesName : this.seriesName;
      return new series(this.data, keyName_1, valueName_1, seriesName_1);
    }
  }, {
    key: "sortKeys",
    value: function (reverse) {
      return function (arg00) {
        return function (arg10) {
          var $var44 = arg10;
          var nd = Async_StartAsFuture_Static(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static($var44.data), function (_arg1) {
                return builder_.Return(arg00(_arg1));
              });
            });
          }(singleton));
          return new series(nd, $var44.keyName, $var44.valueName, $var44.seriesName);
        };
      }(function (arr) {
        return (equals(reverse, true) ? function (array) {
          return array.slice().reverse();
        } : function (x) {
          return x;
        })(_Array$from(sortWith(function (tupledArg, tupledArg_1) {
          return tupledArg[0] < tupledArg_1[0] ? -1 : tupledArg[0] == tupledArg_1[0] ? 0 : 1;
        }, arr)));
      })(this);
    }
  }, {
    key: "sortValues",
    value: function (reverse) {
      return function (arg00) {
        return function (arg10) {
          var $var45 = arg10;
          var nd = Async_StartAsFuture_Static(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static($var45.data), function (_arg1) {
                return builder_.Return(arg00(_arg1));
              });
            });
          }(singleton));
          return new series(nd, $var45.keyName, $var45.valueName, $var45.seriesName);
        };
      }(function (arr) {
        return (equals(reverse, true) ? function (array) {
          return array.slice().reverse();
        } : function (x) {
          return x;
        })(_Array$from(sortWith(function (tupledArg, tupledArg_1) {
          return tupledArg[1] < tupledArg_1[1] ? -1 : tupledArg[1] == tupledArg_1[1] ? 0 : 1;
        }, arr)));
      })(this);
    }
  }, {
    key: "sortBy",
    value: function (f, reverse) {
      return function (arg00) {
        return function (arg10) {
          var $var46 = arg10;
          var nd = Async_StartAsFuture_Static(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static($var46.data), function (_arg1) {
                return builder_.Return(arg00(_arg1));
              });
            });
          }(singleton));
          return new series(nd, $var46.keyName, $var46.valueName, $var46.seriesName);
        };
      }(function (arr) {
        return (equals(reverse, true) ? function (array) {
          return array.slice().reverse();
        } : function (x) {
          return x;
        })(_Array$from(sortWith(function (tupledArg, tupledArg_1) {
          return f(tupledArg[1]) < f(tupledArg_1[1]) ? -1 : f(tupledArg[1]) == f(tupledArg_1[1]) ? 0 : 1;
        }, arr)));
      })(this);
    }
  }, {
    key: "reverse",
    value: function () {
      return function (arg00) {
        return function (arg10) {
          var $var47 = arg10;
          var nd = Async_StartAsFuture_Static(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static($var47.data), function (_arg1) {
                return builder_.Return(arg00(_arg1));
              });
            });
          }(singleton));
          return new series(nd, $var47.keyName, $var47.valueName, $var47.seriesName);
        };
      }(function (array) {
        return array.slice().reverse();
      })(this);
    }
  }, {
    key: "take",
    value: function (count) {
      return function (arg00) {
        return function (arg10) {
          var $var48 = arg10;
          var nd = Async_StartAsFuture_Static(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static($var48.data), function (_arg1) {
                return builder_.Return(arg00(_arg1));
              });
            });
          }(singleton));
          return new series(nd, $var48.keyName, $var48.valueName, $var48.seriesName);
        };
      }(function (arr) {
        return SeriesInternals.slice(0, (arr.length < count ? arr.length : count) - 1, arr);
      })(this);
    }
  }, {
    key: "skip",
    value: function (count) {
      return function (arg00) {
        return function (arg10) {
          var $var49 = arg10;
          var nd = Async_StartAsFuture_Static(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static($var49.data), function (_arg1) {
                return builder_.Return(arg00(_arg1));
              });
            });
          }(singleton));
          return new series(nd, $var49.keyName, $var49.valueName, $var49.seriesName);
        };
      }(function (arr) {
        return SeriesInternals.slice(arr.length < count ? arr.length : count, arr.length - 1, arr);
      })(this);
    }
  }, {
    key: "shuffle",
    value: function () {
      return function (arg00) {
        return function (arg10) {
          var $var50 = arg10;
          var nd = Async_StartAsFuture_Static(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static($var50.data), function (_arg1) {
                return builder_.Return(arg00(_arg1));
              });
            });
          }(singleton));
          return new series(nd, $var50.keyName, $var50.valueName, $var50.seriesName);
        };
      }(function (arr) {
        var rnd = {};
        return _Array$from(sortWith(function (x, y) {
          return compare(function (_arg7) {
            return randomNext(0, 2147483647);
          }(x), function (_arg7) {
            return randomNext(0, 2147483647);
          }(y));
        }, arr));
      })(this);
    }
  }, {
    key: "map",
    value: function (f) {
      return function (arg00) {
        return function (arg10) {
          var $var51 = arg10;
          var nd = Async_StartAsFuture_Static(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static($var51.data), function (_arg1) {
                return builder_.Return(arg00(_arg1));
              });
            });
          }(singleton));
          return new series(nd, $var51.keyName, $var51.valueName, $var51.seriesName);
        };
      }(function () {
        var mapping = function mapping(tupledArg) {
          return [tupledArg[0], f(tupledArg[1])];
        };

        return function (array) {
          return array.map(mapping);
        };
      }())(this);
    }
  }, {
    key: "mapKeys",
    value: function (f) {
      return function (arg00) {
        return function (arg10) {
          var $var52 = arg10;
          var nd = Async_StartAsFuture_Static(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static($var52.data), function (_arg1) {
                return builder_.Return(arg00(_arg1));
              });
            });
          }(singleton));
          return new series(nd, $var52.keyName, $var52.valueName, $var52.seriesName);
        };
      }(function () {
        var mapping = function mapping(tupledArg) {
          return [f(tupledArg[0]), tupledArg[1]];
        };

        return function (array) {
          return array.map(mapping);
        };
      }())(this);
    }
  }, {
    key: "mapPairs",
    value: function (f) {
      return function (arg00) {
        return function (arg10) {
          var $var53 = arg10;
          var nd = Async_StartAsFuture_Static(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static($var53.data), function (_arg1) {
                return builder_.Return(arg00(_arg1));
              });
            });
          }(singleton));
          return new series(nd, $var53.keyName, $var53.valueName, $var53.seriesName);
        };
      }(function () {
        var mapping = function mapping(tupledArg) {
          return [tupledArg[0], f(tupledArg[0])(tupledArg[1])];
        };

        return function (array) {
          return array.map(mapping);
        };
      }())(this);
    }
  }, {
    key: "filter",
    value: function (f) {
      return function (arg00) {
        return function (arg10) {
          var $var54 = arg10;
          var nd = Async_StartAsFuture_Static(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static($var54.data), function (_arg1) {
                return builder_.Return(arg00(_arg1));
              });
            });
          }(singleton));
          return new series(nd, $var54.keyName, $var54.valueName, $var54.seriesName);
        };
      }(function () {
        var predicate = function predicate($var55) {
          return f(function (tuple) {
            return tuple[1];
          }($var55));
        };

        return function (array) {
          return array.filter(predicate);
        };
      }())(this);
    }
  }, {
    key: "filterIndex",
    value: function (f) {
      return function (arg00) {
        return function (arg10) {
          var $var56 = arg10;
          var nd = Async_StartAsFuture_Static(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static($var56.data), function (_arg1) {
                return builder_.Return(arg00(_arg1));
              });
            });
          }(singleton));
          return new series(nd, $var56.keyName, $var56.valueName, $var56.seriesName);
        };
      }(function ($var58) {
        return function () {
          var mapping = function mapping(tuple_1) {
            return tuple_1[1];
          };

          return function (array) {
            return array.map(mapping);
          };
        }()(function ($var57) {
          return _Array$from(mapIndexed(function (i, v) {
            return [f(i), v];
          }, $var57)).filter(function (tuple) {
            return tuple[0];
          });
        }($var58));
      })(this);
    }
  }, {
    key: "choose",
    value: function (f) {
      return function (arg00) {
        return function (arg10) {
          var $var59 = arg10;
          var nd = Async_StartAsFuture_Static(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static($var59.data), function (_arg1) {
                return builder_.Return(arg00(_arg1));
              });
            });
          }(singleton));
          return new series(nd, $var59.keyName, $var59.valueName, $var59.seriesName);
        };
      }(function () {
        var chooser = function chooser(tupledArg) {
          var matchValue = f(tupledArg[1]);

          if (matchValue != null) {
            return [tupledArg[0], matchValue];
          } else {
            return null;
          }
        };

        return function (array) {
          return _Array$from(_choose(chooser, array));
        };
      }())(this);
    }
  }, {
    key: "joinOuter",
    value: function (s2) {
      var _this2 = this;

      var data = function (builder_) {
        return builder_.Delay(function () {
          return builder_.Bind(Async_AwaitFuture_Static(_this2.data), function (_arg5) {
            return builder_.Bind(Async_AwaitFuture_Static(s2.data), function (_arg6) {
              return builder_.Return(SeriesInternals.zipAny(_arg5, _arg6));
            });
          });
        });
      }(singleton);

      return series.create(data, this.keyName, "Values", this.seriesName + " and " + s2.seriesName);
    }
  }, {
    key: "joinInner",
    value: function (s2) {
      return this.joinOuter(s2).choose(function (_arg7) {
        var $var60 = _arg7[0] != null ? _arg7[1] != null ? [0, _arg7[0], _arg7[1]] : [1] : [1];

        switch ($var60[0]) {
          case 0:
            return new pair($var60[1], $var60[2]);

          case 1:
            return null;
        }
      });
    }
  }, {
    key: "appendScalar",
    value: function (key, _value) {
      return function (arg00) {
        return function (arg10) {
          var $var61 = arg10;
          var nd = Async_StartAsFuture_Static(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static($var61.data), function (_arg1) {
                return builder_.Return(arg00(_arg1));
              });
            });
          }(singleton));
          return new series(nd, $var61.keyName, $var61.valueName, $var61.seriesName);
        };
      }(function (arr) {
        return arr.concat([[key, _value]]);
      })(this);
    }
  }, {
    key: "append",
    value: function (s2) {
      var _this3 = this;

      return this.set(Async_StartAsFuture_Static(function (builder_) {
        return builder_.Delay(function () {
          return builder_.Bind(Async_AwaitFuture_Static(_this3.data), function (_arg8) {
            return builder_.Bind(Async_AwaitFuture_Static(s2.data), function (_arg9) {
              return builder_.Return(_arg8.concat(_arg9));
            });
          });
        });
      }(singleton)));
    }
  }, {
    key: "count",
    value: function () {
      return function (arg00) {
        return function (arg10) {
          return new val(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static(arg10.data), function (_arg3) {
                return builder_.Return(arg00(_arg3));
              });
            });
          }(singleton));
        };
      }(function (arr) {
        return arr.length;
      })(this);
    }
  }, {
    key: "last",
    value: function () {
      return function (arg00) {
        return function (arg10) {
          return new val(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static(arg10.data), function (_arg3) {
                return builder_.Return(arg00(_arg3));
              });
            });
          }(singleton));
        };
      }(function (arr) {
        return arr[arr.length - 1][1];
      })(this);
    }
  }, {
    key: "first",
    value: function () {
      return function (arg00) {
        return function (arg10) {
          return new val(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static(arg10.data), function (_arg3) {
                return builder_.Return(arg00(_arg3));
              });
            });
          }(singleton));
        };
      }(function (arr) {
        return arr[0][1];
      })(this);
    }
  }, {
    key: "sumBy",
    value: function (f) {
      return function (arg00) {
        return function (arg10) {
          return new val(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static(arg10.data), function (_arg3) {
                return builder_.Return(arg00(_arg3));
              });
            });
          }(singleton));
        };
      }(function () {
        var projection = function projection(tupledArg) {
          return f(tupledArg[1]);
        };

        return function (array) {
          return _sumBy(projection, array);
        };
      }())(this);
    }
  }, {
    key: "minBy",
    value: function (f) {
      return function (arg00) {
        return function (arg10) {
          return new val(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static(arg10.data), function (_arg3) {
                return builder_.Return(arg00(_arg3));
              });
            });
          }(singleton));
        };
      }(function () {
        var projection = function projection(tupledArg) {
          return f(tupledArg[1]);
        };

        return function (array) {
          return _minBy(projection, array);
        };
      }())(this);
    }
  }, {
    key: "maxBy",
    value: function (f) {
      return function (arg00) {
        return function (arg10) {
          return new val(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static(arg10.data), function (_arg3) {
                return builder_.Return(arg00(_arg3));
              });
            });
          }(singleton));
        };
      }(function () {
        var projection = function projection(tupledArg) {
          return f(tupledArg[1]);
        };

        return function (array) {
          return _maxBy(projection, array);
        };
      }())(this);
    }
  }, {
    key: "realign",
    value: function (newKeys, defaultValue) {
      return function (arg00) {
        return function (arg10) {
          var $var62 = arg10;
          var nd = Async_StartAsFuture_Static(function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(Async_AwaitFuture_Static($var62.data), function (_arg2) {
                return builder_.ReturnFrom(arg00(_arg2));
              });
            });
          }(singleton));
          return new series(nd, $var62.keyName, $var62.valueName, $var62.seriesName);
        };
      }(function (arr) {
        return function (builder__1) {
          return builder__1.Delay(function () {
            return builder__1.Bind(Async_AwaitFuture_Static(newKeys.data), function (_arg10) {
              var newKeys_1 = _arg10.map(function (tupledArg) {
                return tupledArg[1];
              });

              var lookup = create(arr, new GenericComparer(compare));
              return builder__1.Return(newKeys_1.map(function (k) {
                var matchValue = tryFind(k, lookup);

                if (matchValue == null) {
                  return [k, defaultValue];
                } else {
                  return [k, matchValue];
                }
              }));
            });
          });
        }(singleton);
      })(this);
    }
  }, {
    key: "preview",
    value: function () {
      return this.take(10);
    }
  }], [{
    key: "create",
    value: function (data, keyName, valueName, seriesName) {
      return new series(Async_StartAsFuture_Static(data), keyName, valueName, seriesName);
    }
  }, {
    key: "values",
    value: function (_values) {
      var data = Async_StartAsFuture_Static(function (builder_) {
        return builder_.Delay(function () {
          return builder_.Return(_Array$from(mapIndexed(function (i, v) {
            return [i, v];
          }, _values)));
        });
      }(singleton));
      return new series(data, "key", "value", "");
    }
  }, {
    key: "range",
    value: function (from, to) {
      return series.values(Int32Array.from(_range(from, to)));
    }
  }, {
    key: "rangeBy",
    value: function (from, to, step) {
      return series.values(Int32Array.from(rangeStep(from, step, to)));
    }
  }, {
    key: "ordinal",
    value: function (data, keyName, valueName, seriesName) {
      var data_1 = Async_StartAsFuture_Static(function (builder_) {
        return builder_.Delay(function () {
          return builder_.Bind(data, function (_arg4) {
            return builder_.Return(_Array$from(mapIndexed(function (i, v) {
              return [i, v];
            }, _arg4)));
          });
        });
      }(singleton));
      return new series(data_1, keyName, valueName, seriesName);
    }
  }]);

  return series;
}();

export { series };
setType("TheGamma.Series.series", series);
export var inline = function () {
  function inline(value) {
    _classCallCheck(this, inline);

    this.value = value;
  }

  _createClass(inline, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Series.inline",
        interfaces: ["FSharpRecord"],
        properties: {
          value: makeGeneric(val, {
            k: Any
          })
        }
      };
    }
  }, {
    key: "show",
    value: function (outputId) {
      var _this4 = this;

      (function (arg00) {
        startImmediate(arg00);
      })(function (builder_) {
        return builder_.Delay(function () {
          return builder_.Bind(_this4.value.value, function (_arg1) {
            document.getElementById(outputId).innerText = toString(_arg1);
            return builder_.Zero();
          });
        });
      }(singleton));
    }
  }], [{
    key: "create",
    value: function (value) {
      return new inline(value);
    }
  }]);

  return inline;
}();
setType("TheGamma.Series.inline", inline);
//# sourceMappingURL=series.js.map