import _Symbol2 from "babel-runtime/core-js/symbol";
import _Array$from from "babel-runtime/core-js/array/from";
import _getIterator from "babel-runtime/core-js/get-iterator";
import _Map2 from "babel-runtime/core-js/map";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { setType } from "fable-core/Symbol";
import _Symbol_1 from "fable-core/Symbol";
import { compare, Array as _Array, Tuple, Interface, Option, makeGeneric } from "fable-core/Util";
import { tryFind, add as add_1, create, tryGetValue } from "fable-core/Map";
import _Map from "fable-core/Map";
import { Constant, EntityKind, Range as _Range, Entity, Name } from "../ast/ast";
import { Log, ListDictionaryModule, ListDictionaryNode } from "../../libraries/common";
import { Entity$2E$get_Name as Entity_get_Name, formatEntityKind, entityCodeNameAndAntecedents, Entity$2E$get_Antecedents as Entity_get_Antecedents } from "../ast/astops";
import { mapIndexed, map } from "fable-core/List";
import List from "fable-core/List";
import GenericComparer from "fable-core/GenericComparer";
import Choice from "fable-core/Choice";
import { map as map_1, delay, toList, fold } from "fable-core/Seq";
export var BindingContext = function () {
  function BindingContext(variables, globalValues, root, callSite, chain, table, bound) {
    _classCallCheck(this, BindingContext);

    this.Variables = variables;
    this.GlobalValues = globalValues;
    this.Root = root;
    this.CallSite = callSite;
    this.Chain = chain;
    this.Table = table;
    this.Bound = bound;
  }

  _createClass(BindingContext, [{
    key: _Symbol_1.reflection,
    value: function () {
      return {
        type: "TheGamma.Binder.BindingContext",
        interfaces: ["FSharpRecord"],
        properties: {
          Variables: makeGeneric(_Map, {
            Key: Name,
            Value: Entity
          }),
          GlobalValues: makeGeneric(_Map, {
            Key: Name,
            Value: Entity
          }),
          Root: Entity,
          CallSite: Option(Entity),
          Chain: Option(Entity),
          Table: makeGeneric(_Map2, {
            TKey: Interface("TheGamma.Common.Symbol"),
            TValue: makeGeneric(ListDictionaryNode, {
              K: Interface("TheGamma.Common.Symbol"),
              T: makeGeneric(_Map, {
                Key: Tuple(["number", "string"]),
                Value: Entity
              })
            })
          }),
          Bound: _Array(Tuple([_Range, Entity]))
        }
      };
    }
  }]);

  return BindingContext;
}();
setType("TheGamma.Binder.BindingContext", BindingContext);
export var BindingResult = function () {
  _createClass(BindingResult, [{
    key: _Symbol_1.reflection,
    value: function () {
      return {
        type: "TheGamma.Binder.BindingResult",
        properties: {
          Entities: _Array(Tuple([_Range, Entity]))
        }
      };
    }
  }]);

  function BindingResult(ents) {
    _classCallCheck(this, BindingResult);

    this.ents = ents;
    var res = new _Map2();

    var add = function add(a) {
      return function (e) {
        if (!res.has(a)) {
          res.set(a, []);
        }

        res.get(a).push(e);
      };
    };

    var arr = this.ents;

    for (var idx = 0; idx <= arr.length - 1; idx++) {
      var forLoopVar = arr[idx];
      var inputSequence = Entity_get_Antecedents.bind(forLoopVar[1])();
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = _getIterator(inputSequence), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var a_1 = _step.value;
          add(a_1.Symbol)(forLoopVar[1]);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }

    this.childrenLookup = res;
  }

  _createClass(BindingResult, [{
    key: "GetChildren",
    value: function (ent) {
      var matchValue = tryGetValue(this.childrenLookup, ent.Symbol, null);

      if (matchValue[0]) {
        return _Array$from(matchValue[1]);
      } else {
        return [];
      }
    }
  }, {
    key: "Entities",
    get: function () {
      return this.ents;
    }
  }]);

  return BindingResult;
}();
setType("TheGamma.Binder.BindingResult", BindingResult);
export function bindEntity(ctx, kind) {
  var patternInput = entityCodeNameAndAntecedents(kind);
  var symbols = map(function (a) {
    return a.Symbol;
  }, new List(ctx.Root, patternInput[1]));
  var nestedDict = void 0;
  var matchValue = ListDictionaryModule.tryFind(symbols, ctx.Table);

  if (matchValue != null) {
    nestedDict = matchValue;
  } else {
    nestedDict = create(null, new GenericComparer(compare));
  }

  if (nestedDict.has([patternInput[0], patternInput[2]])) {
    Log.trace("binder", "Cached: binding %s %s", formatEntityKind(kind), patternInput[2]);
    return nestedDict.get([patternInput[0], patternInput[2]]);
  } else {
    Log.trace("binder", "New: binding %s %s", formatEntityKind(kind), patternInput[2]);

    var symbol = _Symbol2();

    var entity = void 0;
    var Type = null;
    var Errors = new List();
    var Meta = new List();
    entity = new Entity(kind, symbol, null, Meta, Type, Errors);
    ListDictionaryModule.set(symbols, add_1([patternInput[0], patternInput[2]], entity, nestedDict), ctx.Table);
    return entity;
  }
}
export function setEntity(ctx, node, entity) {
  ctx.Bound.push([node.Range, entity]);
  node.Entity = entity;
  return entity;
}
export function bindExpression(ctx, node) {
  var bindCallArgExpression = function bindCallArgExpression(site) {
    return function (ctx_1) {
      var ctx_2 = void 0;
      var CallSite = site;
      var Chain = null;
      ctx_2 = new BindingContext(ctx_1.Variables, ctx_1.GlobalValues, ctx_1.Root, CallSite, Chain, ctx_1.Table, ctx_1.Bound);
      return function (node_1) {
        return bindExpression(ctx_2, node_1);
      };
    };
  };

  var bindMemberExpression = function bindMemberExpression(chain) {
    return function (ctx_3) {
      var ctx_4 = void 0;
      var CallSite_1 = null;
      var Chain_1 = chain;
      ctx_4 = new BindingContext(ctx_3.Variables, ctx_3.GlobalValues, ctx_3.Root, CallSite_1, Chain_1, ctx_3.Table, ctx_3.Bound);
      return function (node_2) {
        return bindExpression(ctx_4, node_2);
      };
    };
  };

  var bindPlaceExpression = function bindPlaceExpression(ctx_5) {
    var ctx_6 = void 0;
    var CallSite_2 = null;
    ctx_6 = new BindingContext(ctx_5.Variables, ctx_5.GlobalValues, ctx_5.Root, CallSite_2, ctx_5.Chain, ctx_5.Table, ctx_5.Bound);
    return function (node_3) {
      return bindExpression(ctx_6, node_3);
    };
  };

  var bindExpression_1 = function bindExpression_1(ctx_7) {
    var ctx_8 = void 0;
    var CallSite_3 = null;
    var Chain_2 = null;
    ctx_8 = new BindingContext(ctx_7.Variables, ctx_7.GlobalValues, ctx_7.Root, CallSite_3, Chain_2, ctx_7.Table, ctx_7.Bound);
    return function (node_4) {
      return bindExpression(ctx_8, node_4);
    };
  };

  if (node.Node.Case === "Variable") {
    if (ctx.Chain != null) {
      var memberName = function (entity) {
        return setEntity(ctx, node.Node.Fields[0], entity);
      }(bindEntity(ctx, new EntityKind("MemberName", [node.Node.Fields[0].Node])));

      return function (entity_1) {
        return setEntity(ctx, node, entity_1);
      }(bindEntity(ctx, new EntityKind("Member", [ctx.Chain, memberName])));
    } else {
      var matchValue = tryFind(node.Node.Fields[0].Node, ctx.Variables);

      if (matchValue != null) {
        return function (entity_2) {
          return setEntity(ctx, node, entity_2);
        }(bindEntity(ctx, new EntityKind("Variable", [node.Node.Fields[0].Node, matchValue])));
      } else {
        var matchValue_1 = tryFind(node.Node.Fields[0].Node, ctx.GlobalValues);

        if (matchValue_1 != null) {
          return function (entity_3) {
            return setEntity(ctx, node, entity_3);
          }(matchValue_1);
        } else {
          return function (entity_4) {
            return setEntity(ctx, node, entity_4);
          }(bindEntity(ctx, new EntityKind("GlobalValue", [node.Node.Fields[0].Node, null])));
        }
      }
    }
  } else if (node.Node.Case === "Call") {
    var inst = bindExpression_1(ctx)(node.Node.Fields[0]);

    var site_1 = function site_1(arg) {
      return bindEntity(ctx, new EntityKind("CallSite", [inst, arg]));
    };

    var args = mapIndexed(function (idx, arg_1) {
      var site_2 = site_1(arg_1.Name != null ? new Choice("Choice1Of2", [arg_1.Name.Node.Name]) : new Choice("Choice2Of2", [idx]));
      var expr = bindCallArgExpression(site_2)(ctx)(arg_1.Value);

      if (arg_1.Name == null) {
        return expr;
      } else {
        return function (entity_5) {
          return setEntity(ctx, arg_1.Name, entity_5);
        }(bindEntity(ctx, new EntityKind("NamedParam", [arg_1.Name.Node, expr])));
      }
    }, node.Node.Fields[1].Node);

    var args_1 = function (entity_6) {
      return setEntity(ctx, node.Node.Fields[1], entity_6);
    }(bindEntity(ctx, new EntityKind("ArgumentList", [args])));

    return function (entity_7) {
      return setEntity(ctx, node, entity_7);
    }(bindEntity(ctx, new EntityKind("Call", [inst, args_1])));
  } else if (node.Node.Case === "Member") {
    var instEnt = bindExpression_1(ctx)(node.Node.Fields[0]);
    var memEnt = bindMemberExpression(instEnt)(ctx)(node.Node.Fields[1]);
    return function (entity_8) {
      return setEntity(ctx, node, entity_8);
    }(bindEntity(ctx, new EntityKind("MemberAccess", [memEnt])));
  } else if (node.Node.Case === "Binary") {
    var lEnt = bindExpression_1(ctx)(node.Node.Fields[0]);
    var rEnt = bindExpression_1(ctx)(node.Node.Fields[2]);
    return function (entity_9) {
      return setEntity(ctx, node, entity_9);
    }(bindEntity(ctx, new EntityKind("Operator", [lEnt, node.Node.Fields[1].Node, rEnt])));
  } else if (node.Node.Case === "List") {
    var elEnts = map(bindExpression_1(ctx), node.Node.Fields[0]);
    return function (entity_10) {
      return setEntity(ctx, node, entity_10);
    }(bindEntity(ctx, new EntityKind("List", [elEnts])));
  } else if (node.Node.Case === "Function") {
    var callSite = void 0;

    if (ctx.CallSite == null) {
      throw new Error("bindExpression: Function missing call site");
    } else {
      callSite = ctx.CallSite;
    }

    var varEnt = function (entity_11) {
      return setEntity(ctx, node.Node.Fields[0], entity_11);
    }(bindEntity(ctx, new EntityKind("Binding", [node.Node.Fields[0].Node, callSite])));

    var bodyEnt = bindExpression_1(new BindingContext(add_1(node.Node.Fields[0].Node, varEnt, ctx.Variables), ctx.GlobalValues, ctx.Root, ctx.CallSite, ctx.Chain, ctx.Table, ctx.Bound))(node.Node.Fields[1]);
    return function (entity_12) {
      return setEntity(ctx, node, entity_12);
    }(bindEntity(ctx, new EntityKind("Function", [varEnt, bodyEnt])));
  } else if (node.Node.Case === "Boolean") {
    return function (entity_13) {
      return setEntity(ctx, node, entity_13);
    }(bindEntity(ctx, new EntityKind("Constant", [new Constant("Boolean", [node.Node.Fields[0]])])));
  } else if (node.Node.Case === "String") {
    return function (entity_14) {
      return setEntity(ctx, node, entity_14);
    }(bindEntity(ctx, new EntityKind("Constant", [new Constant("String", [node.Node.Fields[0]])])));
  } else if (node.Node.Case === "Number") {
    return function (entity_15) {
      return setEntity(ctx, node, entity_15);
    }(bindEntity(ctx, new EntityKind("Constant", [new Constant("Number", [node.Node.Fields[0]])])));
  } else if (node.Node.Case === "Empty") {
    return function (entity_16) {
      return setEntity(ctx, node, entity_16);
    }(bindEntity(ctx, new EntityKind("Constant", [new Constant("Empty", [])])));
  } else {
    var bodyEnt_1 = bindPlaceExpression(ctx)(node.Node.Fields[1]);

    (function (entity_17) {
      return setEntity(ctx, node, entity_17);
    })(bindEntity(ctx, new EntityKind("Placeholder", [node.Node.Fields[0].Node, bodyEnt_1])));

    return bodyEnt_1;
  }
}
export function bindCommand(ctx, node) {
  if (node.Node.Case === "Expr") {
    var body = bindExpression(ctx, node.Node.Fields[0]);

    var node_1 = function (entity) {
      return setEntity(ctx, node, entity);
    }(bindEntity(ctx, new EntityKind("RunCommand", [body])));

    return [ctx, node_1];
  } else {
    var body_1 = bindExpression(ctx, node.Node.Fields[1]);

    var _var = function (entity_1) {
      return setEntity(ctx, node.Node.Fields[0], entity_1);
    }(bindEntity(ctx, new EntityKind("Variable", [node.Node.Fields[0].Node, body_1])));

    var node_2 = function (entity_2) {
      return setEntity(ctx, node, entity_2);
    }(bindEntity(ctx, new EntityKind("LetCommand", [_var, body_1])));

    return [new BindingContext(add_1(node.Node.Fields[0].Node, _var, ctx.Variables), ctx.GlobalValues, ctx.Root, ctx.CallSite, ctx.Chain, ctx.Table, ctx.Bound), node_2];
  }
}
export function bindProgram(ctx, program) {
  ctx.Bound.splice(0);
  var patternInput_1 = fold(function (tupledArg, cmd) {
    var patternInput = bindCommand(tupledArg[0], cmd);
    return [patternInput[0], new List(patternInput[1], tupledArg[1])];
  }, [ctx, new List()], program.Body.Node);
  return [function (entity) {
    return setEntity(ctx, program.Body, entity);
  }(bindEntity(ctx, new EntityKind("Program", [patternInput_1[1]]))), new BindingResult(_Array$from(ctx.Bound))];
}
export function createContext(globals, name) {
  var root = void 0;
  var Kind = new EntityKind("Root", []);
  var Errors = new List();

  var _Symbol = _Symbol2();

  var Type = null;
  var Meta = new List();
  root = new Entity(Kind, _Symbol, null, Meta, Type, Errors);
  var Table = new _Map2();
  var Bound = [];
  return new BindingContext(create(null, new GenericComparer(function (x, y) {
    return x.CompareTo(y);
  })), create(toList(delay(function () {
    return map_1(function (e) {
      return [new Name(Entity_get_Name.bind(e)()), e];
    }, globals);
  })), new GenericComparer(function (x, y) {
    return x.CompareTo(y);
  })), root, null, null, Table, Bound);
}
//# sourceMappingURL=binder.js.map