import _Symbol2 from "babel-runtime/core-js/symbol";
import _getIterator from "babel-runtime/core-js/get-iterator";
import _Map from "babel-runtime/core-js/map";
import _Array$from from "babel-runtime/core-js/array/from";
import { choose, map, ofArray, mapIndexed } from "fable-core/List";
import List from "fable-core/List";
import { BinaryOperator, BabelOperators, Serializer, Statement, Program, Expression } from "../common/babel";
import { BabelOptions } from "../../bindings/babel";
import { Log } from "../../libraries/common";
import { series } from "../../libraries/series";
import { singleton } from "fable-core/AsyncBuilder";
import { convertSequence, convertTupleSequence, trimLeft, RuntimeContext } from "../codegen/runtime";
import { chart } from "../../libraries/google/charts";
import { placeholder, table } from "../../libraries/tables";
import { date } from "../../libraries/general";
import { youguess } from "../../libraries/interactive";
import { Entity, EntityKind, EntityValue, Name } from "../ast/ast";
import { Entity$2E$get_Antecedents as Entity_get_Antecedents, lastChainElement, Entity$2E$get_Name as Entity_get_Name, $7C$FindMember$7C$_$7C$ as _FindMember___, formatType } from "../ast/astops";
import { defaultArg } from "fable-core/Util";
import { skipWhile, takeWhile, toList } from "fable-core/Seq";
import Lazy from "fable-core/Lazy";
export function storeArguments(values) {
    return [_Array$from(values), mapIndexed(function (i, _arg1) {
        return new Expression("MemberExpression", [new Expression("IdentifierExpression", ["_stored", null]), new Expression("NumericLiteral", [i, null]), true, null]);
    }, values)];
}
export function evaluateExpression(_stored, expr) {
    var prog = new Program(null, ofArray([new Statement("ExpressionStatement", [expr, null])]));
    var code = Babel.transformFromAst(Serializer.serializeProgram(prog), "", new BabelOptions(["es2015"]));
    Log.trace("interpreter", "Interpreter evaluating: %O using values %O", code.code, _stored);

    try {
        var s = series.create(function (builder_) {
            return builder_.Delay(function () {
                return builder_.Return([]);
            });
        }(singleton), "", "", "");
        new RuntimeContext("lol", "", "troll");

        (function (c) {
            return function (s_1) {
                return trimLeft(c, s_1);
            };
        });

        (function (f) {
            return function (g) {
                return function (data) {
                    return convertTupleSequence(f, g, data);
                };
            };
        });

        (function (f_1) {
            return function (data_1) {
                return convertSequence(f_1, data_1);
            };
        });

        (function (arg00) {
            return chart.bar(arg00);
        });

        table.create(s);
        date.now();
        series.values(new Int32Array([1]));
        placeholder.create("");

        (function (arg00_1) {
            return youguess.line(arg00_1);
        });

        _stored.length;
        return eval(code.code);
    } catch (e) {
        Log.exn("interpreter", "Evaluation failed: %O", e);
        throw new Error();
    }
}
export function evaluateExpr(args, exprBuilder) {
    var patternInput = storeArguments(args);
    return evaluateExpression(patternInput[0], exprBuilder(patternInput[1]));
}
export function evaluatePreview(ent, value) {
    var previewName = new Name("preview");
    Log.trace("interpreter", "Evaluating preview on: %O (%s)", ent, formatType(ent.Type));
    var matchValue = ent.Type;
    var $var389 = void 0;

    if (matchValue != null) {
        if (matchValue.Case === "Object") {
            var activePatternResult7108 = function (obj) {
                return _FindMember___(previewName, obj);
            }(matchValue.Fields[0]);

            if (activePatternResult7108 != null) {
                $var389 = [0, activePatternResult7108];
            } else {
                $var389 = [1];
            }
        } else {
            $var389 = [1];
        }
    } else {
        $var389 = [1];
    }

    switch ($var389[0]) {
        case 0:
            if ($var389[1].Type.Case === "Method") {
                return evaluateExpr(ofArray([value]), function (inst) {
                    return BabelOperators.op_DivideAtDivide($var389[1].Emitter.Emit(inst.head), new List());
                });
            } else {
                return evaluateExpr(ofArray([value]), function (inst_1) {
                    return $var389[1].Emitter.Emit(inst_1.head);
                });
            }

        case 1:
            return null;
    }
}
export function evaluateEntity(e) {
    var $var390 = e.Kind.Case === "Variable" ? [4, e.Kind.Fields[1]] : e.Kind.Case === "GlobalValue" ? [5, e.Kind.Fields[1], e.Kind.Fields[0]] : e.Kind.Case === "Member" ? e.Kind.Fields[1].Kind.Case === "MemberName" ? [6, e.Kind.Fields[0], e.Kind.Fields[1].Kind.Fields[0]] : [9, e.Kind.Fields[0]] : e.Kind.Case === "MemberAccess" ? [7, e.Kind.Fields[0]] : e.Kind.Case === "Call" ? e.Kind.Fields[1].Kind.Case === "ArgumentList" ? [8, e.Kind.Fields[1].Kind.Fields[0], e.Kind.Fields[0]] : [10, e.Kind.Fields[0]] : e.Kind.Case === "Operator" ? e.Kind.Fields[1].Case === "Power" ? [11, e.Kind.Fields[0], e.Kind.Fields[2]] : [12, e.Kind.Fields[0], e.Kind.Fields[1], e.Kind.Fields[2]] : e.Kind.Case === "List" ? [13, e.Kind.Fields[0]] : e.Kind.Case === "Placeholder" ? [14, e.Kind.Fields[1]] : e.Kind.Case === "ArgumentList" ? [15] : e.Kind.Case === "NamedParam" ? [15] : e.Kind.Case === "MemberName" ? [15] : e.Kind.Case === "Binding" ? [15] : e.Kind.Case === "Root" ? [15] : e.Kind.Case === "CallSite" ? [15] : e.Kind.Case === "Function" ? [16] : e.Kind.Case === "Program" ? [16] : e.Kind.Case === "LetCommand" ? [16] : e.Kind.Case === "RunCommand" ? [16] : e.Kind.Fields[0].Case === "Number" ? [1, e.Kind.Fields[0].Fields[0]] : e.Kind.Fields[0].Case === "String" ? [2, e.Kind.Fields[0].Fields[0]] : e.Kind.Fields[0].Case === "Empty" ? [3] : [0, e.Kind.Fields[0].Fields[0]];

    switch ($var390[0]) {
        case 0:
            return $var390[1];

        case 1:
            return $var390[1];

        case 2:
            return $var390[1];

        case 3:
            return null;

        case 4:
            return defaultArg($var390[1].Value, null, function (v) {
                return v.Value;
            });

        case 5:
            if ($var390[1] != null) {
                return evaluateExpression([], $var390[1]);
            } else {
                return null;
            }

        case 6:
            var matchValue = $var390[1].Type;
            var $var391 = void 0;

            if (matchValue.Case === "Object") {
                var activePatternResult7115 = function (obj) {
                    return _FindMember___($var390[2], obj);
                }(matchValue.Fields[0]);

                if (activePatternResult7115 != null) {
                    $var391 = [0, activePatternResult7115];
                } else {
                    $var391 = [1];
                }
            } else {
                $var391 = [1];
            }

            switch ($var391[0]) {
                case 0:
                    return evaluateExpr(ofArray([getValue($var390[1])]), function (inst) {
                        return $var391[1].Emitter.Emit(inst.head);
                    });

                case 1:
                    return null;
            }

        case 7:
            return getValue($var390[1]);

        case 8:
            var pb = toList(takeWhile(function (_arg1) {
                return _arg1.Kind.Case === "NamedParam" ? false : true;
            }, $var390[1]));
            var nb = toList(skipWhile(function (_arg2) {
                return _arg2.Kind.Case === "NamedParam" ? false : true;
            }, $var390[1]));

            var positionBased = _Array$from(map(function (e_1) {
                return getValue(e_1);
            }, pb));

            var nameBased = new _Map(choose(function (_arg3) {
                if (_arg3.Kind.Case === "NamedParam") {
                    var value = _arg3.Kind.Fields[1];
                    var name = _arg3.Kind.Fields[0];
                    return [name.Name, getValue(value)];
                } else {
                    return null;
                }
            }, nb));
            var expectedArgs = void 0;
            var matchValue_1 = $var390[2].Type;

            if (matchValue_1.Case === "Method") {
                expectedArgs = matchValue_1.Fields[0];
            } else {
                expectedArgs = new List();
            }

            var pars = mapIndexed(function (i, ma) {
                return i < positionBased.length ? positionBased[i] : nameBased.has(ma.Name) ? nameBased.get(ma.Name) : null;
            }, expectedArgs);
            var $var392 = $var390[2].Kind.Case === "MemberAccess" ? $var390[2].Kind.Fields[0].Kind.Case === "Member" ? $var390[2].Kind.Fields[0].Kind.Fields[1].Kind.Case === "MemberName" ? [0, $var390[2].Kind.Fields[0].Kind.Fields[0], $var390[2].Kind.Fields[0].Kind.Fields[1].Kind.Fields[0]] : [1] : [1] : [1];

            switch ($var392[0]) {
                case 0:
                    var instValue = getValue($var392[1]);
                    var matchValue_2 = $var392[1].Type;
                    var $var393 = void 0;

                    if (matchValue_2 != null) {
                        if (matchValue_2.Case === "Object") {
                            var activePatternResult7124 = function (obj_1) {
                                return _FindMember___($var392[2], obj_1);
                            }(matchValue_2.Fields[0]);

                            if (activePatternResult7124 != null) {
                                $var393 = [0, activePatternResult7124];
                            } else {
                                $var393 = [1];
                            }
                        } else {
                            $var393 = [1];
                        }
                    } else {
                        $var393 = [1];
                    }

                    switch ($var393[0]) {
                        case 0:
                            return evaluateExpr(new List(instValue, pars), function (stored) {
                                return BabelOperators.op_DivideAtDivide($var393[1].Emitter.Emit(stored.head), stored.tail);
                            });

                        case 1:
                            return evaluateExpr(new List(instValue, pars), function (stored_1) {
                                return BabelOperators.op_DivideAtDivide(BabelOperators.op_DivideQmarkDivide(stored_1.head, BabelOperators.str($var392[2].Name)), stored_1.tail);
                            });
                    }

                case 1:
                    var instValue_1 = getValue($var390[2]);
                    return evaluateExpr(new List(instValue_1, pars), function (stored_2) {
                        return BabelOperators.op_DivideAtDivide(stored_2.head, stored_2.tail);
                    });
            }

        case 9:
            Log.error("interpreter", "typeCheckEntity: Member access is missing member name!");
            return null;

        case 10:
            Log.error("interpreter", "typeCheckEntity: Call to %s is missing argument list!", Entity_get_Name.bind(lastChainElement($var390[1]))());
            return null;

        case 11:
            return evaluateExpr(ofArray([getValue($var390[1]), getValue($var390[2])]), function (_arg4) {
                var $var394 = _arg4.tail != null ? _arg4.tail.tail != null ? _arg4.tail.tail.tail == null ? [0, _arg4.head, _arg4.tail.head] : [1] : [1] : [1];

                switch ($var394[0]) {
                    case 0:
                        return BabelOperators.op_DivideAtDivide(BabelOperators.op_Dynamic(BabelOperators.ident("Math"), "pow"), ofArray([$var394[1], $var394[2]]));

                    case 1:
                        throw new Error("evaluateEntity: Expected two arguments");
                }
            });

        case 12:
            return evaluateExpr(ofArray([getValue($var390[1]), getValue($var390[3])]), function (_arg5) {
                var $var395 = _arg5.tail != null ? _arg5.tail.tail != null ? _arg5.tail.tail.tail == null ? [0, _arg5.head, _arg5.tail.head] : [1] : [1] : [1];

                switch ($var395[0]) {
                    case 0:
                        var op = void 0;

                        if ($var390[2].Case === "Equals") {
                            op = new BinaryOperator("BinaryEqualStrict", []);
                        } else if ($var390[2].Case === "Plus") {
                            op = new BinaryOperator("BinaryPlus", []);
                        } else if ($var390[2].Case === "Minus") {
                            op = new BinaryOperator("BinaryMinus", []);
                        } else if ($var390[2].Case === "Multiply") {
                            op = new BinaryOperator("BinaryMultiply", []);
                        } else if ($var390[2].Case === "Divide") {
                            op = new BinaryOperator("BinaryDivide", []);
                        } else if ($var390[2].Case === "GreaterThan") {
                            op = new BinaryOperator("BinaryGreater", []);
                        } else if ($var390[2].Case === "LessThan") {
                            op = new BinaryOperator("BinaryLess", []);
                        } else if ($var390[2].Case === "GreaterThanOrEqual") {
                            op = new BinaryOperator("BinaryGreaterOrEqual", []);
                        } else if ($var390[2].Case === "LessThanOrEqual") {
                            op = new BinaryOperator("BinaryLessOrEqual", []);
                        } else if ($var390[2].Case === "Power") {
                            throw new Error("evaluateEntity: Power is not a binary operation");
                        } else {
                            op = new BinaryOperator("BinaryModulus", []);
                        }

                        return new Expression("BinaryExpression", [op, $var395[1], $var395[2], null]);

                    case 1:
                        throw new Error("evaluateEntity: Expected two arguments");
                }
            });

        case 13:
            return evaluateExpr(map(function (e_2) {
                return getValue(e_2);
            }, $var390[1]), function (elements) {
                return new Expression("ArrayExpression", [elements, null]);
            });

        case 14:
            return getValue($var390[1]);

        case 15:
            return null;

        case 16:
            Log.error("interpreter", "Cannot evaluate entity (probably not supported yet): %O", e);
            return null;
    }
}
export function ensureValue(e) {
    if (function () {
        return e.Value == null;
    }(null)) {
        var matchValue = evaluateEntity(e);

        if (matchValue != null) {
            e.Value = new EntityValue(matchValue, new Lazy(function () {
                return evaluatePreview(e, matchValue);
            }));
        }
    }
}
export function getValue(e) {
    if (function () {
        return e.Value == null;
    }(null)) {
        Log.error("interpreter", "getValue: Value of entity %O has not been evaluated.", e);
    }

    return e.Value.Value;
}
export function evaluateEntityTree(e) {
    var visited = new _Map();

    var loop = function loop(e_1) {
        if (!visited.has(e_1.Symbol) ? function () {
            return e_1.Value == null;
        }(null) : false) {
            visited.set(e_1.Symbol, true);
            var inputSequence = Entity_get_Antecedents.bind(e_1)();
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = _getIterator(inputSequence), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var e_2 = _step.value;
                    loop(e_2);
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            ensureValue(e_1);
        }
    };

    loop(e);
    return e.Value;
}
export function globalEntity(name, meta, typ, expr) {
    var Kind = new EntityKind("GlobalValue", [new Name(name), expr]);

    var _Symbol = _Symbol2();

    var Type = typ;
    return new Entity(Kind, _Symbol, null, meta, Type, new List());
}
export function evaluate(globals, e) {
    var res = evaluateEntityTree(e);
    return res;
}
//# sourceMappingURL=interpreter.js.map