import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { Option, Interface, makeGeneric, Any, compareUnions, equalsUnions, GenericParam, compareRecords, equalsRecords } from "fable-core/Util";
import List from "fable-core/List";
import Choice from "fable-core/Choice";
import { Expression } from "../common/babel";

var _Range = function () {
  function _Range(start, end) {
    _classCallCheck(this, _Range);

    this.Start = start;
    this.End = end;
  }

  _createClass(_Range, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Range",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          Start: "number",
          End: "number"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareRecords(this, other);
    }
  }]);

  return _Range;
}();

export { _Range as Range };
setType("TheGamma.Range", _Range);

var _Error = function () {
  function _Error(number, message, range) {
    _classCallCheck(this, _Error);

    this.Number = number;
    this.Message = message;
    this.Range = range;
  }

  _createClass(_Error, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Error",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          Number: "number",
          Message: "string",
          Range: GenericParam("Range")
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareRecords(this, other);
    }
  }]);

  return _Error;
}();

export { _Error as Error };
setType("TheGamma.Error", _Error);
export var Operator = function () {
  function Operator(caseName, fields) {
    _classCallCheck(this, Operator);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(Operator, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Operator",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Divide: [],
          Equals: [],
          GreaterThan: [],
          GreaterThanOrEqual: [],
          LessThan: [],
          LessThanOrEqual: [],
          Minus: [],
          Modulo: [],
          Multiply: [],
          Plus: [],
          Power: []
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return Operator;
}();
setType("TheGamma.Operator", Operator);
export var TokenKind = function () {
  function TokenKind(caseName, fields) {
    _classCallCheck(this, TokenKind);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(TokenKind, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TokenKind",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Arrow: [],
          Boolean: ["boolean"],
          Colon: [],
          Comma: [],
          Dot: [],
          EndOfFile: [],
          Equals: [],
          Error: ["string"],
          Fun: [],
          Ident: ["string"],
          LParen: [],
          LSquare: [],
          Let: [],
          Newline: [],
          Number: ["string", "number"],
          Operator: [Operator],
          QIdent: ["string"],
          RParen: [],
          RSquare: [],
          String: ["string"],
          White: ["string"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return TokenKind;
}();
setType("TheGamma.TokenKind", TokenKind);
export var Token = function () {
  function Token(token, range) {
    _classCallCheck(this, Token);

    this.Token = token;
    this.Range = range;
  }

  _createClass(Token, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Token",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          Token: TokenKind,
          Range: _Range
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareRecords(this, other);
    }
  }]);

  return Token;
}();
setType("TheGamma.Token", Token);
export var Emitter = function () {
  function Emitter(emit) {
    _classCallCheck(this, Emitter);

    this.Emit = emit;
  }

  _createClass(Emitter, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Emitter",
        interfaces: ["FSharpRecord"],
        properties: {
          Emit: "function"
        }
      };
    }
  }]);

  return Emitter;
}();
setType("TheGamma.Emitter", Emitter);
export var Metadata = function () {
  function Metadata(context, type, data) {
    _classCallCheck(this, Metadata);

    this.Context = context;
    this.Type = type;
    this.Data = data;
  }

  _createClass(Metadata, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Metadata",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          Context: "string",
          Type: "string",
          Data: Any
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }]);

  return Metadata;
}();
setType("TheGamma.Metadata", Metadata);
export var Documentation = function () {
  function Documentation(caseName, fields) {
    _classCallCheck(this, Documentation);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(Documentation, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Documentation",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Details: ["string", "string"],
          None: [],
          Text: ["string"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return Documentation;
}();
setType("TheGamma.Documentation", Documentation);
export var Member = function () {
  function Member(name, type, metadata, emitter) {
    _classCallCheck(this, Member);

    this.Name = name;
    this.Type = type;
    this.Metadata = metadata;
    this.Emitter = emitter;
  }

  _createClass(Member, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Member",
        interfaces: ["FSharpRecord"],
        properties: {
          Name: "string",
          Type: Type,
          Metadata: makeGeneric(List, {
            T: Metadata
          }),
          Emitter: Emitter
        }
      };
    }
  }]);

  return Member;
}();
setType("TheGamma.Member", Member);
export var PrimitiveType = function () {
  function PrimitiveType(caseName, fields) {
    _classCallCheck(this, PrimitiveType);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(PrimitiveType, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.PrimitiveType",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Bool: [],
          Date: [],
          Number: [],
          String: [],
          Unit: []
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return PrimitiveType;
}();
setType("TheGamma.PrimitiveType", PrimitiveType);
export var MethodArgument = function () {
  function MethodArgument(name, optional, _static, type) {
    _classCallCheck(this, MethodArgument);

    this.Name = name;
    this.Optional = optional;
    this.Static = _static;
    this.Type = type;
  }

  _createClass(MethodArgument, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.MethodArgument",
        interfaces: ["FSharpRecord"],
        properties: {
          Name: "string",
          Optional: "boolean",
          Static: "boolean",
          Type: Type
        }
      };
    }
  }]);

  return MethodArgument;
}();
setType("TheGamma.MethodArgument", MethodArgument);
export var Type = function () {
  function Type(caseName, fields) {
    _classCallCheck(this, Type);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(Type, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Type",
        interfaces: ["FSharpUnion"],
        cases: {
          Any: [],
          Delayed: [Interface("TheGamma.Common.Future")],
          List: [Type],
          Method: [makeGeneric(List, {
            T: MethodArgument
          }), "function"],
          Object: [Interface("TheGamma.ObjectType")],
          Primitive: [PrimitiveType]
        }
      };
    }
  }]);

  return Type;
}();
setType("TheGamma.Type", Type);
export var Name = function () {
  function Name(name) {
    _classCallCheck(this, Name);

    this.Name = name;
  }

  _createClass(Name, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Name",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          Name: "string"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareRecords(this, other);
    }
  }]);

  return Name;
}();
setType("TheGamma.Name", Name);
export var Constant = function () {
  function Constant(caseName, fields) {
    _classCallCheck(this, Constant);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(Constant, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Constant",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Boolean: ["boolean"],
          Empty: [],
          Number: ["number"],
          String: ["string"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return Constant;
}();
setType("TheGamma.Constant", Constant);
export var EntityKind = function () {
  function EntityKind(caseName, fields) {
    _classCallCheck(this, EntityKind);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(EntityKind, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.EntityKind",
        interfaces: ["FSharpUnion"],
        cases: {
          ArgumentList: [makeGeneric(List, {
            T: Entity
          })],
          Binding: [Name, Entity],
          Call: [Entity, Entity],
          CallSite: [Entity, Choice],
          Constant: [Constant],
          Function: [Entity, Entity],
          GlobalValue: [Name, Option(Expression)],
          LetCommand: [Entity, Entity],
          List: [makeGeneric(List, {
            T: Entity
          })],
          Member: [Entity, Entity],
          MemberAccess: [Entity],
          MemberName: [Name],
          NamedParam: [Name, Entity],
          Operator: [Entity, Operator, Entity],
          Placeholder: [Name, Entity],
          Program: [makeGeneric(List, {
            T: Entity
          })],
          Root: [],
          RunCommand: [Entity],
          Variable: [Name, Entity]
        }
      };
    }
  }]);

  return EntityKind;
}();
setType("TheGamma.EntityKind", EntityKind);
export var Entity = function () {
  function Entity(kind, symbol, value, meta, type, errors) {
    _classCallCheck(this, Entity);

    this.Kind = kind;
    this.Symbol = symbol;
    this.Value = value;
    this.Meta = meta;
    this.Type = type;
    this.Errors = errors;
  }

  _createClass(Entity, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Entity",
        interfaces: ["FSharpRecord"],
        properties: {
          Kind: EntityKind,
          Symbol: Interface("TheGamma.Common.Symbol"),
          Value: Option(EntityValue),
          Meta: makeGeneric(List, {
            T: Metadata
          }),
          Type: Option(Type),
          Errors: makeGeneric(List, {
            T: makeGeneric(_Error, {
              Range: _Range
            })
          })
        }
      };
    }
  }]);

  return Entity;
}();
setType("TheGamma.Entity", Entity);
export var EntityValue = function () {
  function EntityValue(value, preview) {
    _classCallCheck(this, EntityValue);

    this.Value = value;
    this.Preview = preview;
  }

  _createClass(EntityValue, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.EntityValue",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          Value: Any,
          Preview: Any
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }]);

  return EntityValue;
}();
setType("TheGamma.EntityValue", EntityValue);

var _Node = function () {
  function _Node(whiteBefore, whiteAfter, range, node, entity) {
    _classCallCheck(this, _Node);

    this.WhiteBefore = whiteBefore;
    this.WhiteAfter = whiteAfter;
    this.Range = range;
    this.Node = node;
    this.Entity = entity;
  }

  _createClass(_Node, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Node",
        interfaces: ["FSharpRecord"],
        properties: {
          WhiteBefore: makeGeneric(List, {
            T: Token
          }),
          WhiteAfter: makeGeneric(List, {
            T: Token
          }),
          Range: _Range,
          Node: GenericParam("T"),
          Entity: Option(Entity)
        }
      };
    }
  }]);

  return _Node;
}();

export { _Node as Node };
setType("TheGamma.Node", _Node);
export var Argument = function () {
  function Argument(name, value) {
    _classCallCheck(this, Argument);

    this.Name = name;
    this.Value = value;
  }

  _createClass(Argument, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Argument",
        interfaces: ["FSharpRecord"],
        properties: {
          Name: Option(makeGeneric(_Node, {
            T: Name
          })),
          Value: makeGeneric(_Node, {
            T: Expr
          })
        }
      };
    }
  }]);

  return Argument;
}();
setType("TheGamma.Argument", Argument);
export var Program = function () {
  function Program(body) {
    _classCallCheck(this, Program);

    this.Body = body;
  }

  _createClass(Program, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Program",
        interfaces: ["FSharpRecord"],
        properties: {
          Body: makeGeneric(_Node, {
            T: makeGeneric(List, {
              T: makeGeneric(_Node, {
                T: Command
              })
            })
          })
        }
      };
    }
  }]);

  return Program;
}();
setType("TheGamma.Program", Program);
export var Command = function () {
  function Command(caseName, fields) {
    _classCallCheck(this, Command);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(Command, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Command",
        interfaces: ["FSharpUnion"],
        cases: {
          Expr: [makeGeneric(_Node, {
            T: Expr
          })],
          Let: [makeGeneric(_Node, {
            T: Name
          }), makeGeneric(_Node, {
            T: Expr
          })]
        }
      };
    }
  }]);

  return Command;
}();
setType("TheGamma.Command", Command);
export var Expr = function () {
  function Expr(caseName, fields) {
    _classCallCheck(this, Expr);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(Expr, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Expr",
        interfaces: ["FSharpUnion"],
        cases: {
          Binary: [makeGeneric(_Node, {
            T: Expr
          }), makeGeneric(_Node, {
            T: Operator
          }), makeGeneric(_Node, {
            T: Expr
          })],
          Boolean: ["boolean"],
          Call: [makeGeneric(_Node, {
            T: Expr
          }), makeGeneric(_Node, {
            T: makeGeneric(List, {
              T: Argument
            })
          })],
          Empty: [],
          Function: [makeGeneric(_Node, {
            T: Name
          }), makeGeneric(_Node, {
            T: Expr
          })],
          List: [makeGeneric(List, {
            T: makeGeneric(_Node, {
              T: Expr
            })
          })],
          Member: [makeGeneric(_Node, {
            T: Expr
          }), makeGeneric(_Node, {
            T: Expr
          })],
          Number: ["number"],
          Placeholder: [makeGeneric(_Node, {
            T: Name
          }), makeGeneric(_Node, {
            T: Expr
          })],
          String: ["string"],
          Variable: [makeGeneric(_Node, {
            T: Name
          })]
        }
      };
    }
  }]);

  return Expr;
}();
setType("TheGamma.Expr", Expr);
//# sourceMappingURL=ast.js.map