import _Array$from from "babel-runtime/core-js/array/from";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { fold, append as append_1, empty, singleton as singleton_1, collect, map, delay, toList, find } from "fable-core/Seq";
import { collectTypeErrors } from "./analyzer/typechecker";
import { singleton } from "fable-core/AsyncBuilder";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { hasInterface, Array as _Array, Option, Tuple, makeGeneric, compareUnions, equalsUnions } from "fable-core/Util";
import { CheckingService } from "./services";
import { append, ofArray, reverse, map as map_1 } from "fable-core/List";
import List from "fable-core/List";
import { Entity as Entity_2 } from "./ast/ast";
import { join } from "fable-core/String";
import { Entity$2E$get_Name as Entity_get_Name, escapeIdent } from "./ast/astops";
import { evaluate } from "./analyzer/interpreter";
import { createVirtualDomAsyncApp, op_EqualsBangGreater, renderTo, text, op_EqualsGreater, h, El } from "../libraries/html";
import { startImmediate } from "fable-core/Async";
import { table } from "../libraries/tables";
import { Log, Async$2E$AwaitFuture$2E$Static as Async_AwaitFuture_Static } from "../libraries/common";
export function getEntity(svc, code) {
  return function (builder_) {
    return builder_.Delay(function () {
      return builder_.Bind(svc.TypeCheck("let it = " + code), function (_arg1) {
        var patternInput = find(function (_arg2) {
          var $var567 = _arg2[1].Kind.Case === "Variable" ? _arg2[1].Kind.Fields[0].Name === "it" ? [0] : [1] : [1];

          switch ($var567[0]) {
            case 0:
              return true;

            case 1:
              return false;
          }
        }, _arg1[1].Entities);
        var patternInput_1 = find(function (_arg3) {
          return _arg3[1].Kind.Case === "Program" ? true : false;
        }, _arg1[1].Entities);
        var errors = collectTypeErrors(patternInput_1[1]);
        var errors_1 = toList(delay(function () {
          return map(function (e) {
            return [code.substr(e.Range.Start, e.Range.End - e.Range.Start + 1), e.Message];
          }, errors);
        }));
        return builder_.Return([errors_1, patternInput[1]]);
      });
    });
  }(singleton);
}

var _Event = function () {
  function _Event(caseName, fields) {
    _classCallCheck(this, _Event);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(_Event, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Blocks.Event",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          AddElement: ["string"],
          RemoveLast: [],
          UpdateParameter: ["string", "string"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return _Event;
}();

export { _Event as Event };
setType("TheGamma.Blocks.Event", _Event);
export var State = function () {
  function State(checkingService, globals, chain, completions, entity) {
    _classCallCheck(this, State);

    this.CheckingService = checkingService;
    this.Globals = globals;
    this.Chain = chain;
    this.Completions = completions;
    this.Entity = entity;
  }

  _createClass(State, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Blocks.State",
        interfaces: ["FSharpRecord"],
        properties: {
          CheckingService: CheckingService,
          Globals: makeGeneric(List, {
            T: Entity_2
          }),
          Chain: makeGeneric(List, {
            T: Tuple(["string", Option(makeGeneric(List, {
              T: Tuple(["string", "string"])
            }))])
          }),
          Completions: _Array("string"),
          Entity: Option(Entity_2)
        }
      };
    }
  }], [{
    key: "Create",
    value: function (svc, globals) {
      var Entity = null;
      return new State(svc, globals, new List(), [], Entity);
    }
  }]);

  return State;
}();
setType("TheGamma.Blocks.State", State);
export function getTypeName(state) {
  var $var568 = state.Entity != null ? state.Entity.Type != null ? state.Entity.Type.Case === "Object" ? hasInterface(state.Entity.Type.Fields[0], "TheGamma.TypeProviders.FSharpProvider.GenericType") ? [0, state.Entity.Type.Fields[0]] : [1] : [1] : [1] : [1];

  switch ($var568[0]) {
    case 0:
      return $var568[1].TypeDefinition.FullName;

    case 1:
      return "object";
  }
}
export function formatChain(chain) {
  return join(".", map_1(function (tupledArg) {
    return escapeIdent(tupledArg[0]) + (tupledArg[1] == null ? "" : "(" + join(", ", map_1(function (tuple) {
      return tuple[1];
    }, tupledArg[1])) + ")");
  }, reverse(chain)));
}
export function updateCompletions(state) {
  return function (builder_) {
    return builder_.Delay(function () {
      return builder_.Bind(state, function (_arg1) {
        if (_arg1.Chain.tail == null) {
          return builder_.Return(function () {
            var Completions = _Array$from(delay(function () {
              return map(function (g) {
                return Entity_get_Name.bind(g)();
              }, _arg1.Globals);
            }));

            return new State(_arg1.CheckingService, _arg1.Globals, _arg1.Chain, Completions, _arg1.Entity);
          }());
        } else {
          var code = formatChain(_arg1.Chain);
          return builder_.Bind(getEntity(_arg1.CheckingService, code), function (_arg2) {
            var matchValue = [_arg2[0], _arg2[1]];
            var $var569 = matchValue[0].tail == null ? matchValue[1].Type != null ? matchValue[1].Type.Case === "Object" ? [0, matchValue[1].Type.Fields[0]] : [1] : [1] : [1];

            switch ($var569[0]) {
              case 0:
                var compls = _Array$from(delay(function () {
                  return collect(function (m) {
                    return m.Name !== "preview" ? singleton_1(m.Name) : empty();
                  }, $var569[1].Members);
                }));

                return builder_.Return(function () {
                  var Entity = _arg2[1];
                  return new State(_arg1.CheckingService, _arg1.Globals, _arg1.Chain, compls, Entity);
                }());

              case 1:
                return builder_.Return(function () {
                  var Entity_1 = _arg2[1];
                  var Completions_1 = [];
                  return new State(_arg1.CheckingService, _arg1.Globals, _arg1.Chain, Completions_1, Entity_1);
                }());
            }
          });
        }
      });
    });
  }(singleton);
}
export function update(state, evt) {
  return updateCompletions(function (builder_) {
    return builder_.Delay(function () {
      var matchValue = [evt, state];
      var $var570 = matchValue[0].Case === "AddElement" ? [2, matchValue[0].Fields[0]] : matchValue[0].Case === "UpdateParameter" ? matchValue[1].Chain.tail != null ? matchValue[1].Chain.head[1] != null ? [3, matchValue[1].Chain.head[0], matchValue[0].Fields[0], matchValue[1].Chain.head[1], matchValue[1].Chain.tail, matchValue[0].Fields[1]] : [4] : [4] : matchValue[1].Chain.tail != null ? matchValue[1].Chain.tail.tail == null ? [0] : [1, matchValue[1].Chain.tail] : [0];

      switch ($var570[0]) {
        case 0:
          return builder_.Return(function () {
            var Chain = new List();
            var Entity = null;
            return new State(state.CheckingService, state.Globals, Chain, state.Completions, Entity);
          }());

        case 1:
          return builder_.Return(new State(state.CheckingService, state.Globals, $var570[1], state.Completions, state.Entity));

        case 2:
          var code = formatChain(new List([$var570[1], null], state.Chain));
          return builder_.Bind(getEntity(state.CheckingService, code), function (_arg1) {
            var $var571 = _arg1[1].Type != null ? _arg1[1].Type.Case === "Method" ? [0, _arg1[1].Type.Fields[0]] : [1] : [1];

            switch ($var571[0]) {
              case 0:
                return builder_.Return(function () {
                  var Chain_1 = new List([$var570[1], toList(delay(function () {
                    return map(function (a) {
                      return [a.Name, ""];
                    }, $var571[1]);
                  }))], state.Chain);
                  return new State(state.CheckingService, state.Globals, Chain_1, state.Completions, state.Entity);
                }());

              case 1:
                return builder_.Return(function () {
                  var Chain_2 = new List([$var570[1], null], state.Chain);
                  return new State(state.CheckingService, state.Globals, Chain_2, state.Completions, state.Entity);
                }());
            }
          });

        case 3:
          var newPars = map_1(function (tupledArg) {
            return $var570[2] === tupledArg[0] ? [$var570[2], $var570[5]] : [tupledArg[0], tupledArg[1]];
          }, $var570[3]);
          return builder_.Return(function () {
            var Chain_3 = new List([$var570[1], newPars], $var570[4]);
            return new State(state.CheckingService, state.Globals, Chain_3, state.Completions, state.Entity);
          }());

        case 4:
          return builder_.Return(state);
      }
    });
  }(singleton));
}
export function tryGetPreview(state) {
  var _Evaluate_ = function _Evaluate_(l) {
    return l.value;
  };

  if (state.Entity != null) {
    evaluate(state.Globals, state.Entity);
    var matchValue = state.Entity.Value;
    var $var572 = void 0;

    if (matchValue != null) {
      var activePatternResult8773 = _Evaluate_(matchValue.Preview);

      if (activePatternResult8773 != null) {
        $var572 = [0, activePatternResult8773];
      } else {
        $var572 = [1];
      }
    } else {
      $var572 = [1];
    }

    switch ($var572[0]) {
      case 0:
        var node = function (arg0) {
          return function (arg1) {
            return El.op_Dynamic(arg0, arg1);
          };
        }(h)("div")(ofArray([op_EqualsGreater("id", "blockspreview")]))(ofArray([text("Loading preview...")]));

        var returned = false;

        (function (arg00) {
          startImmediate(arg00);
        })(function (builder_) {
          return builder_.Delay(function () {
            return builder_.Bind(table.create($var572[1]).render(), function (_arg4) {
              if (returned) {
                renderTo(document.getElementById("blockspreview"), _arg4);
                return builder_.Zero();
              } else {
                node = _arg4;
                return builder_.Zero();
              }
            });
          });
        }(singleton));

        returned = true;
        return node;

      case 1:
        return function (arg0_1) {
          return function (arg1_1) {
            return El.op_Dynamic(arg0_1, arg1_1);
          };
        }(h)("div")(new List())(ofArray([text("Preview has no value")]));
    }
  } else {
    return function (arg0_2) {
      return function (arg1_2) {
        return El.op_Dynamic(arg0_2, arg1_2);
      };
    }(h)("div")(new List())(ofArray([text("No preview available")]));
  }
}
export function render(trigger, state) {
  return function (arg0) {
    return function (arg1) {
      return El.op_Dynamic(arg0, arg1);
    };
  }(h)("div")(ofArray([op_EqualsGreater("class", "pilleditor")]))(ofArray([function (arg0_1) {
    return function (arg1_1) {
      return El.op_Dynamic(arg0_1, arg1_1);
    };
  }(h)("ul")(ofArray([op_EqualsGreater("class", "pills")]))(toList(delay(function () {
    var renderCoreChain = function renderCoreChain(chain) {
      return toList(delay(function () {
        return collect(function (matchValue) {
          return singleton_1(function (arg0_2) {
            return function (arg1_2) {
              return El.op_Dynamic(arg0_2, arg1_2);
            };
          }(h)("li")(new List())(ofArray([text(matchValue[0] + (function () {
            return matchValue[1] != null;
          }(null) ? " (...)" : ""))])));
        }, reverse(chain));
      }));
    };

    var renderChain = function renderChain(removeLast) {
      return function (chain_1) {
        var matchValue_1 = [removeLast, chain_1];
        var $var573 = matchValue_1[0] ? matchValue_1[1].tail != null ? [0] : [1, matchValue_1[1]] : [1, matchValue_1[1]];

        switch ($var573[0]) {
          case 0:
            var rest = matchValue_1[1].tail;
            var last = matchValue_1[1].head[0];
            return append(renderCoreChain(rest), ofArray([function (arg0_3) {
              return function (arg1_3) {
                return El.op_Dynamic(arg0_3, arg1_3);
              };
            }(h)("li")(new List())(ofArray([text(last), function (arg0_4) {
              return function (arg1_4) {
                return El.op_Dynamic(arg0_4, arg1_4);
              };
            }(h)("a")(ofArray([op_EqualsBangGreater("click", function (_arg2) {
              return function (_arg1) {
                trigger(new _Event("RemoveLast", []));
              };
            })]))(ofArray([function (arg0_5) {
              return function (arg1_5) {
                return El.op_Dynamic(arg0_5, arg1_5);
              };
            }(h)("i")(ofArray([op_EqualsGreater("class", "gfa gfa-times")]))(new List())]))]))]));

          case 1:
            return renderCoreChain($var573[1]);
        }
      };
    };

    return append_1(function () {
      var $var574 = state.Chain.tail != null ? state.Chain.head[1] != null ? [0, state.Chain.head[0], state.Chain.head[1], state.Chain.tail] : [1, state.Chain] : [1, state.Chain];

      switch ($var574[0]) {
        case 0:
          return renderChain(false)($var574[3]);

        case 1:
          return renderChain(true)($var574[1]);
      }
    }(), delay(function () {
      return append_1(function () {
        var $var575 = state.Chain.tail != null ? state.Chain.head[1] != null ? [0, state.Chain.head[0], state.Chain.head[1], state.Chain.tail] : [1] : [1];

        switch ($var575[0]) {
          case 0:
            return singleton_1(function (arg0_6) {
              return function (arg1_6) {
                return El.op_Dynamic(arg0_6, arg1_6);
              };
            }(h)("li")(new List())(toList(delay(function () {
              return append_1(singleton_1(text($var575[1] + "(")), delay(function () {
                return append_1(collect(function (matchValue_2) {
                  return append_1(singleton_1(text(matchValue_2[0] + " = ")), delay(function () {
                    return singleton_1(function (arg0_7) {
                      return function (arg1_7) {
                        return El.op_Dynamic(arg0_7, arg1_7);
                      };
                    }(h)("input")(ofArray([op_EqualsGreater("type", "text"), op_EqualsGreater("value", matchValue_2[1]), op_EqualsBangGreater("input", function (el) {
                      return function (_arg3) {
                        trigger(new _Event("UpdateParameter", [matchValue_2[0], el.value]));
                      };
                    })]))(new List()));
                  }));
                }, $var575[2]), delay(function () {
                  return append_1(singleton_1(text(")")), delay(function () {
                    return singleton_1(function (arg0_8) {
                      return function (arg1_8) {
                        return El.op_Dynamic(arg0_8, arg1_8);
                      };
                    }(h)("a")(ofArray([op_EqualsBangGreater("click", function (_arg5) {
                      return function (_arg4) {
                        trigger(new _Event("RemoveLast", []));
                      };
                    })]))(ofArray([function (arg0_9) {
                      return function (arg1_9) {
                        return El.op_Dynamic(arg0_9, arg1_9);
                      };
                    }(h)("i")(ofArray([op_EqualsGreater("class", "gfa gfa-times")]))(new List())])));
                  }));
                }));
              }));
            }))));

          case 1:
            return empty();
        }
      }(), delay(function () {
        return state.Completions.length > 0 ? singleton_1(function (arg0_10) {
          return function (arg1_10) {
            return El.op_Dynamic(arg0_10, arg1_10);
          };
        }(h)("li")(new List())(ofArray([function (arg0_11) {
          return function (arg1_11) {
            return El.op_Dynamic(arg0_11, arg1_11);
          };
        }(h)("div")(ofArray([op_EqualsGreater("class", "selectwrapper")]))(ofArray([function (arg0_12) {
          return function (arg1_12) {
            return El.op_Dynamic(arg0_12, arg1_12);
          };
        }(h)("select")(ofArray([op_EqualsBangGreater("change", function (el_1) {
          return function (_arg6) {
            trigger(new _Event("AddElement", [el_1.value]));
          };
        })]))(toList(delay(function () {
          return append_1(singleton_1(function (arg0_13) {
            return function (arg1_13) {
              return El.op_Dynamic(arg0_13, arg1_13);
            };
          }(h)("option")(new List())(ofArray([text("(choose an operation to add)")]))), delay(function () {
            return map(function (s) {
              return function (arg0_14) {
                return function (arg1_14) {
                  return El.op_Dynamic(arg0_14, arg1_14);
                };
              }(h)("option")(ofArray([op_EqualsGreater("value", s)]))(ofArray([text(s)]));
            }, state.Completions);
          }));
        })))]))]))) : empty();
      }));
    }));
  }))), tryGetPreview(state), function (arg0_15) {
    return function (arg1_15) {
      return El.op_Dynamic(arg0_15, arg1_15);
    };
  }(h)("p")(new List())(ofArray([text(getTypeName(state))]))]));
}
export function createBlockEditor(svc, globals, id) {
  (function (arg00) {
    startImmediate(arg00);
  })(function (builder_) {
    return builder_.Delay(function () {
      return builder_.TryWith(builder_.Delay(function () {
        return builder_.Bind(Async_AwaitFuture_Static(globals), function (_arg1) {
          var state = State.Create(svc, _arg1);
          return builder_.Bind(fold(function (st, s) {
            return function (builder__1) {
              return builder__1.Delay(function () {
                return builder__1.Bind(st, function (_arg2) {
                  return builder__1.ReturnFrom(update(_arg2, new _Event("AddElement", [s])));
                });
              });
            }(singleton);
          }, singleton.Return(state), ofArray(["enigma"])), function (_arg3) {
            createVirtualDomAsyncApp(id, _arg3, function (trigger) {
              return function (state_1) {
                return render(trigger, state_1);
              };
            }, function (state_2) {
              return function (evt) {
                return update(state_2, evt);
              };
            });
            return builder_.Zero();
          });
        });
      }), function (_arg4) {
        Log.exn("system", "Something went wrong: %O", _arg4);
        return builder_.Zero();
      });
    });
  }(singleton));
}
//# sourceMappingURL=blocks.js.map