import _Map2 from "babel-runtime/core-js/map";
import _Array$from from "babel-runtime/core-js/array/from";
import _typeof from "babel-runtime/helpers/typeof";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { compare, compareRecords, equalsRecords, makeGeneric } from "fable-core/Util";
import { choose as choose_1, concat, append, mapIndexed, map, ofArray } from "fable-core/List";
import List from "fable-core/List";
import { create, add } from "fable-core/Map";
import _Map from "fable-core/Map";
import { Serializer, Program, AssignmentOperator, VariableDeclarationKind, VariableDeclarator, Pattern, Statement, BinaryOperator, BabelOperators, SourceLocation, Position, Expression } from "../common/babel";
import { delay, toList, choose, takeWhile, map as map_1, tryPick } from "fable-core/Seq";
import { Async$2E$AwaitFuture$2E$Static as Async_AwaitFuture_Static, Log } from "../../libraries/common";
import GenericComparer from "fable-core/GenericComparer";
import { split } from "fable-core/String";
import { BabelOptions } from "../../bindings/babel";
import { singleton } from "fable-core/AsyncBuilder";
export var CompilationContext = function () {
    function CompilationContext(lineLengths, globals) {
        _classCallCheck(this, CompilationContext);

        this.LineLengths = lineLengths;
        this.Globals = globals;
    }

    _createClass(CompilationContext, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.CodeGenerator.CompilationContext",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    LineLengths: makeGeneric(List, {
                        T: "number"
                    }),
                    Globals: makeGeneric(_Map, {
                        Key: "string",
                        Value: Expression
                    })
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return CompilationContext;
}();
setType("TheGamma.CodeGenerator.CompilationContext", CompilationContext);
export function offsetToLocation(lines, offs, lengths) {
    offsetToLocation: while (true) {
        var $var364 = lengths.tail != null ? offs <= lengths.head ? [0, lengths.head, lengths.tail] : [1] : [1];

        switch ($var364[0]) {
            case 0:
                return new Position(lines, offs);

            case 1:
                if (lengths.tail == null) {
                    throw new Error("offsetToLocation: Out of range");
                } else {
                    lines = lines + 1;
                    offs = offs - lengths.head - 1;
                    lengths = lengths.tail;
                    continue offsetToLocation;
                }

        }
    }
}
export function rangeToLoc(ctx, rng) {
    return new SourceLocation(offsetToLocation(1, rng.Start, ctx.LineLengths), offsetToLocation(1, rng.Start, ctx.LineLengths));
}
export function getMember(name, typ) {
    if (typ.Case === "Object") {
        var matchValue = tryPick(function (m) {
            return m.Name === name ? m : null;
        }, typ.Fields[0].Members);

        if (matchValue != null) {
            return matchValue;
        } else {
            Log.exn("codegen", "getMember: Member %s not found in object %O", name, typ.Fields[0]);
            throw new Error("getMember: Member not found");
        }
    } else {
        Log.exn("codegen", "getMember: Not an object %O", typ);
        throw new Error("getMember: Not an object");
    }
}
export function compileExpression(ctx, expr) {
    var _loop = function _loop() {
        Log.trace("codegen", "Compiling expression: %O", expr);
        var $var365 = expr.Node.Case === "Binary" ? expr.Node.Fields[1].Node.Case === "Power" ? [0, expr.Node.Fields[0], expr.Node.Fields[2]] : [1, expr.Node.Fields[0], expr.Node.Fields[1], expr.Node.Fields[2]] : expr.Node.Case === "Member" ? expr.Node.Fields[1].Node.Case === "Placeholder" ? expr.Node.Fields[1].Node.Fields[1].Node.Case === "Variable" ? [2, expr.Node.Fields[0], expr.Node.Fields[1].Node.Fields[1].Node.Fields[0]] : [3, expr.Node.Fields[0]] : expr.Node.Fields[1].Node.Case === "Variable" ? [2, expr.Node.Fields[0], expr.Node.Fields[1].Node.Fields[0]] : [3, expr.Node.Fields[0]] : expr.Node.Case === "Call" ? [4, expr.Node.Fields[1], expr.Node.Fields[0]] : expr.Node.Case === "Variable" ? ctx.Globals.has(expr.Node.Fields[0].Node.Name) ? [5, expr.Node.Fields[0]] : [6] : [6];

        switch ($var365[0]) {
            case 0:
                var l = compileExpression(ctx, $var365[1]);
                var r = compileExpression(ctx, $var365[2]);
                var rng = rangeToLoc(ctx, expr.Range);
                var pow = BabelOperators.op_Dynamic(BabelOperators.ident("Math"), "pow");
                return {
                    v: new Expression("CallExpression", [pow, ofArray([l, r]), rangeToLoc(ctx, expr.Range)])
                };

            case 1:
                var l_1 = compileExpression(ctx, $var365[1]);
                var r_1 = compileExpression(ctx, $var365[3]);
                var op = void 0;

                if ($var365[2].Node.Case === "Equals") {
                    op = new BinaryOperator("BinaryEqualStrict", []);
                } else if ($var365[2].Node.Case === "Plus") {
                    op = new BinaryOperator("BinaryPlus", []);
                } else if ($var365[2].Node.Case === "Minus") {
                    op = new BinaryOperator("BinaryMinus", []);
                } else if ($var365[2].Node.Case === "Multiply") {
                    op = new BinaryOperator("BinaryMultiply", []);
                } else if ($var365[2].Node.Case === "Divide") {
                    op = new BinaryOperator("BinaryDivide", []);
                } else if ($var365[2].Node.Case === "GreaterThan") {
                    op = new BinaryOperator("BinaryGreater", []);
                } else if ($var365[2].Node.Case === "LessThan") {
                    op = new BinaryOperator("BinaryLess", []);
                } else if ($var365[2].Node.Case === "GreaterThanOrEqual") {
                    op = new BinaryOperator("BinaryGreaterOrEqual", []);
                } else if ($var365[2].Node.Case === "LessThanOrEqual") {
                    op = new BinaryOperator("BinaryLessOrEqual", []);
                } else if ($var365[2].Node.Case === "Power") {
                    throw new Error("compileExpression: Power is not a binary operator");
                } else {
                    op = new BinaryOperator("BinaryModulus", []);
                }

                return {
                    v: new Expression("BinaryExpression", [op, l_1, r_1, rangeToLoc(ctx, expr.Range)])
                };

            case 2:
                var mem = getMember($var365[2].Node.Name, $var365[1].Entity.Type);
                var inst = compileExpression(ctx, $var365[1]);
                return {
                    v: mem.Emitter.Emit(inst)
                };

            case 3:
                throw new Error("compileExpression: Member in member access is not a variable");

            case 4:
                var compiledArgs = map(function (a) {
                    return [a.Name, compileExpression(ctx, a.Value)];
                }, $var365[1].Node);

                var positionArgs = _Array$from(map_1(function (tuple) {
                    return tuple[1];
                }, takeWhile(function (tupledArg) {
                    return function () {
                        return tupledArg[0] == null;
                    }(null);
                }, compiledArgs)));

                var namedArgs = new _Map2(choose(function (_arg1) {
                    if (_arg1[0] != null) {
                        var n = _arg1[0];
                        return [n.Node.Name, _arg1[1]];
                    } else {
                        return null;
                    }
                }, compiledArgs));
                var expectedArgs = void 0;
                var matchValue = $var365[2].Entity.Type;

                if (matchValue.Case === "Method") {
                    expectedArgs = matchValue.Fields[0];
                } else {
                    expectedArgs = new List();
                }

                var inst_1 = compileExpression(ctx, $var365[2]);
                var pars = mapIndexed(function (i, ma) {
                    return i < positionArgs.length ? positionArgs[i] : namedArgs.has(ma.Name) ? namedArgs.get(ma.Name) : new Expression("NullLiteral", [rangeToLoc(ctx, $var365[1].Range)]);
                }, expectedArgs);
                return {
                    v: new Expression("CallExpression", [inst_1, pars, rangeToLoc(ctx, expr.Range)])
                };

            case 5:
                return {
                    v: ctx.Globals.get($var365[1].Node.Name)
                };

            case 6:
                if (expr.Node.Case === "Variable") {
                    return {
                        v: new Expression("IdentifierExpression", [expr.Node.Fields[0].Node.Name, rangeToLoc(ctx, expr.Node.Fields[0].Range)])
                    };
                } else if (expr.Node.Case === "Number") {
                    return {
                        v: new Expression("NumericLiteral", [expr.Node.Fields[0], rangeToLoc(ctx, expr.Range)])
                    };
                } else if (expr.Node.Case === "String") {
                    return {
                        v: new Expression("StringLiteral", [expr.Node.Fields[0], rangeToLoc(ctx, expr.Range)])
                    };
                } else if (expr.Node.Case === "Boolean") {
                    return {
                        v: new Expression("BooleanLiteral", [expr.Node.Fields[0], rangeToLoc(ctx, expr.Range)])
                    };
                } else if (expr.Node.Case === "Placeholder") {
                    ctx = ctx;
                    expr = expr.Node.Fields[1];
                    return "continue|compileExpression";
                } else if (expr.Node.Case === "List") {
                    var es = map(function (expr_1) {
                        return compileExpression(ctx, expr_1);
                    }, expr.Node.Fields[0]);
                    return {
                        v: new Expression("ArrayExpression", [es, rangeToLoc(ctx, expr.Range)])
                    };
                } else if (expr.Node.Case === "Function") {
                    var _var = new Expression("IdentifierExpression", [expr.Node.Fields[0].Node.Name, rangeToLoc(ctx, expr.Node.Fields[0].Range)]);

                    var ce = compileExpression(function () {
                        var Globals = add(expr.Node.Fields[0].Node.Name, _var, ctx.Globals);
                        return new CompilationContext(ctx.LineLengths, Globals);
                    }(), expr.Node.Fields[1]);
                    var body = new Statement("BlockStatement", [ofArray([new Statement("ReturnStatement", [ce, rangeToLoc(ctx, expr.Node.Fields[1].Range)])]), rangeToLoc(ctx, expr.Node.Fields[1].Range)]);
                    return {
                        v: new Expression("FunctionExpression", [null, ofArray([new Pattern("IdentifierPattern", [expr.Node.Fields[0].Node.Name, rangeToLoc(ctx, expr.Node.Fields[0].Range)])]), body, false, false, rangeToLoc(ctx, expr.Range)])
                    };
                } else if (expr.Node.Case === "Empty") {
                    Log.error("codegen", "getEmitterAndParams: Empty expression in the AST");
                    return {
                        v: new Expression("NullLiteral", [rangeToLoc(ctx, expr.Range)])
                    };
                } else {
                    throw new Error("C:\\Tomas\\Public\\the-gamma\\thegamma-script\\src\\thegamma\\codegen/codegen.fs", 43, 8);
                }

        }
    };

    compileExpression: while (true) {
        var _ret = _loop();

        switch (_ret) {
            case "continue|compileExpression":
                continue compileExpression;

            default:
                if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;
        }
    }
}
export function compileCommand(ctx, idx, cmd) {
    var loc = rangeToLoc(ctx, cmd.Range);
    var patternInput = void 0;

    if (cmd.Node.Case === "Expr") {
        patternInput = [new List(), BabelOperators.num(idx), compileExpression(ctx, cmd.Node.Fields[0])];
    } else {
        var e = compileExpression(ctx, cmd.Node.Fields[1]);
        var name = new Pattern("IdentifierPattern", [cmd.Node.Fields[0].Node.Name, rangeToLoc(ctx, cmd.Node.Fields[0].Range)]);
        var decl = new VariableDeclarator("VariableDeclarator", [name, e, loc]);
        patternInput = [ofArray([new Statement("VariableDeclaration", [new VariableDeclarationKind("Var", []), ofArray([decl]), rangeToLoc(ctx, cmd.Range)])]), BabelOperators.str(cmd.Node.Fields[0].Node.Name), BabelOperators.ident(cmd.Node.Fields[0].Node.Name)];
    }

    var res = new Expression("MemberExpression", [BabelOperators.ident("_results"), patternInput[1], true, loc]);
    return append(patternInput[0], ofArray([new Statement("ExpressionStatement", [new Expression("AssignmentExpression", [new AssignmentOperator("AssignEqual", []), res, patternInput[2], loc]), loc])]));
}
export function compileProgram(ctx, prog) {
    var decl = new VariableDeclarator("VariableDeclarator", [new Pattern("IdentifierPattern", ["_results", null]), new Expression("ArrayExpression", [new List(), null]), null]);
    var res = new Statement("VariableDeclaration", [new VariableDeclarationKind("Var", []), ofArray([decl]), null]);
    var body = concat(mapIndexed(function (idx, cmd) {
        return compileCommand(ctx, idx, cmd);
    }, prog.Body.Node));
    var ret = new Statement("ReturnStatement", [BabelOperators.ident("_results"), null]);
    var body_1 = new Statement("BlockStatement", [append(new List(res, body), ofArray([ret])), null]);
    var body_2 = new Expression("CallExpression", [new Expression("FunctionExpression", [null, new List(), body_1, false, false, null]), new List(), null]);
    return new Program(rangeToLoc(ctx, prog.Body.Range), ofArray([new Statement("ExpressionStatement", [body_2, null])]));
}
export function compile(globals, text, prog) {
    return function (builder_) {
        return builder_.Delay(function () {
            return builder_.TryWith(builder_.Delay(function () {
                return builder_.Bind(Async_AwaitFuture_Static(globals), function (_arg1) {
                    var globals_1 = create(choose_1(function (_arg2) {
                        var $var366 = _arg2.Kind.Case === "GlobalValue" ? _arg2.Kind.Fields[1] != null ? [0, _arg2.Kind.Fields[1], _arg2.Kind.Fields[0]] : [1] : [1];

                        switch ($var366[0]) {
                            case 0:
                                return [$var366[2].Name, $var366[1]];

                            case 1:
                                return null;
                        }
                    }, _arg1), new GenericComparer(compare));
                    var ctx = new CompilationContext(toList(delay(function () {
                        return map_1(function (l) {
                            return l.length;
                        }, split(text, "\n"));
                    })), globals_1);
                    var res = compileProgram(ctx, prog);
                    var code = Babel.transformFromAst(Serializer.serializeProgram(res), text, new BabelOptions(["es2015"]));
                    Log.trace("codegen", "Evaluating: %O", code);
                    return builder_.Return(code.code);
                });
            }), function (_arg3) {
                Log.exn("codegen", "Evaluating code failed: %O", _arg3);
                return builder_.Return("");
            });
        });
    }(singleton);
}
//# sourceMappingURL=codegen.js.map