import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import _Array$from from "babel-runtime/core-js/array/from";
import { singleton } from "fable-core/AsyncBuilder";
import { fold, empty, singleton as singleton_1, append, delay, toList, skipWhile, map } from "fable-core/Seq";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { replace, join, isNullOrEmpty } from "fable-core/String";
import { Log, Http } from "../../libraries/common";
import { toString } from "fable-core/Util";
export function convertTupleSequence(f, g, data) {
  return function (builder_) {
    return builder_.Delay(function () {
      return builder_.Bind(data, function (_arg1) {
        return builder_.Return(_arg1.map(function (tupledArg) {
          return [f(tupledArg[0]), g(tupledArg[1])];
        }));
      });
    });
  }(singleton);
}
export function convertSequence(f, data) {
  return function (builder_) {
    return builder_.Delay(function () {
      return builder_.Bind(data, function (_arg1) {
        return builder_.Return(function (array) {
          return _Array$from(map(f, array));
        }(_arg1));
      });
    });
  }(singleton);
}
export function trimLeft(c, s) {
  return _Array$from(skipWhile(function (y) {
    return c === y;
  }, s.split(""))).join('');
}
export function trimRight(c, s) {
  return _Array$from(skipWhile(function (y) {
    return c === y;
  }, s.split("").slice().reverse())).slice().reverse().join('');
}
export function concatUrl(a, b) {
  return trimRight("/", a) + "/" + trimLeft("/", b);
}
export var RuntimeContext = function () {
  _createClass(RuntimeContext, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProvidersRuntime.RuntimeContext",
        properties: {
          root: "string",
          trace: "string"
        }
      };
    }
  }]);

  function RuntimeContext(root, cookies, trace) {
    _classCallCheck(this, RuntimeContext);

    this["root@19"] = root;
    this.cookies = cookies;
    this["trace@19"] = trace;
  }

  _createClass(RuntimeContext, [{
    key: "addTrace",
    value: function (suffix) {
      var _this = this;

      var traces = toList(delay(function () {
        return append(!isNullOrEmpty(_this["trace@19"]) ? singleton_1(_this["trace@19"]) : empty(), delay(function () {
          return !isNullOrEmpty(suffix) ? singleton_1(suffix) : empty();
        }));
      }));
      return new RuntimeContext(this["root@19"], this.cookies, join("&", traces));
    }
  }, {
    key: "getValue",
    value: function (endpoint) {
      var _this2 = this;

      return function (builder_) {
        return builder_.Delay(function () {
          return builder_.Bind(Http.Request("POST", concatUrl(_this2["root@19"], endpoint), _this2["trace@19"], _this2.cookies), function (_arg1) {
            return builder_.Return(JSON.parse(_arg1));
          });
        });
      }(singleton);
    }
  }, {
    key: "root",
    get: function () {
      return this["root@19"];
    }
  }, {
    key: "trace",
    get: function () {
      return this["trace@19"];
    }
  }]);

  return RuntimeContext;
}();
setType("TheGamma.TypeProvidersRuntime.RuntimeContext", RuntimeContext);
export var PivotContext = function () {
  _createClass(PivotContext, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProvidersRuntime.PivotContext",
        properties: {}
      };
    }
  }]);

  function PivotContext(root, calls) {
    _classCallCheck(this, PivotContext);

    this.root = root;
    this.calls = calls;
  }

  _createClass(PivotContext, [{
    key: "addCall",
    value: function (callid, values) {
      var values_1 = _Array$from(map(function (v) {
        return v instanceof Date ? v.toISOString() : v;
      }, values));

      return new PivotContext(this.root, [[callid, values_1]].concat(this.calls));
    }
  }, {
    key: "getData",
    value: function (conv, tfs, isPreview) {
      var _this3 = this;

      return function (builder_) {
        return builder_.Delay(function () {
          var url = function () {
            var folder = function folder(tfs_1) {
              return function (tupledArg) {
                var vals = join(",", map(function (value) {
                  return toString(value);
                }, tupledArg[1]));
                return replace(tfs_1, tupledArg[0], vals);
              };
            };

            return function (array) {
              return fold(function ($var354, $var355) {
                return folder($var354)($var355);
              }, tfs, array);
            };
          }()(_this3.calls);

          var url_1 = encodeURIComponent(url);
          var url_2 = _this3.root + "?" + url_1 + (isPreview ? "&preview" : "");
          Log.trace("runtime", "Pivot: %s", url_2);
          return builder_.Bind(Http.Request("GET", url_2), function (_arg1) {
            return builder_.Return(_Array$from(map(conv, JSON.parse(_arg1))));
          });
        });
      }(singleton);
    }
  }]);

  return PivotContext;
}();
setType("TheGamma.TypeProvidersRuntime.PivotContext", PivotContext);
//# sourceMappingURL=runtime.js.map