import _Array$from from "babel-runtime/core-js/array/from";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { defaultArg, createObj as createObj_1, makeGeneric, Option, compareUnions, equalsUnions, compareRecords, equalsRecords } from "fable-core/Util";
import { initialize, map, ofArray, concat } from "fable-core/List";
import List from "fable-core/List";
export var Position = function () {
    function Position(line, column) {
        _classCallCheck(this, Position);

        this.line = line;
        this.column = column;
    }

    _createClass(Position, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.Position",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    line: "number",
                    column: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return Position;
}();
setType("TheGamma.Babel.Position", Position);
export var SourceLocation = function () {
    function SourceLocation(start, end) {
        _classCallCheck(this, SourceLocation);

        this.start = start;
        this.end = end;
    }

    _createClass(SourceLocation, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.SourceLocation",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    start: Position,
                    end: Position
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return SourceLocation;
}();
setType("TheGamma.Babel.SourceLocation", SourceLocation);
export var AssignmentOperator = function () {
    function AssignmentOperator(caseName, fields) {
        _classCallCheck(this, AssignmentOperator);

        this.Case = caseName;
        this.Fields = fields;
    }

    _createClass(AssignmentOperator, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.AssignmentOperator",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    AssignAndBitwise: [],
                    AssignDivide: [],
                    AssignEqual: [],
                    AssignMinus: [],
                    AssignModulus: [],
                    AssignMultiply: [],
                    AssignOrBitwise: [],
                    AssignPlus: [],
                    AssignShiftLeft: [],
                    AssignShiftRightSignPropagating: [],
                    AssignShiftRightZeroFill: [],
                    AssignXorBitwise: []
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsUnions(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareUnions(this, other);
        }
    }]);

    return AssignmentOperator;
}();
setType("TheGamma.Babel.AssignmentOperator", AssignmentOperator);
export var BinaryOperator = function () {
    function BinaryOperator(caseName, fields) {
        _classCallCheck(this, BinaryOperator);

        this.Case = caseName;
        this.Fields = fields;
    }

    _createClass(BinaryOperator, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.BinaryOperator",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    BinaryAndBitwise: [],
                    BinaryDivide: [],
                    BinaryEqual: [],
                    BinaryEqualStrict: [],
                    BinaryExponent: [],
                    BinaryGreater: [],
                    BinaryGreaterOrEqual: [],
                    BinaryIn: [],
                    BinaryInstanceOf: [],
                    BinaryLess: [],
                    BinaryLessOrEqual: [],
                    BinaryMinus: [],
                    BinaryModulus: [],
                    BinaryMultiply: [],
                    BinaryOrBitwise: [],
                    BinaryPlus: [],
                    BinaryShiftLeft: [],
                    BinaryShiftRightSignPropagating: [],
                    BinaryShiftRightZeroFill: [],
                    BinaryUnequal: [],
                    BinaryUnequalStrict: [],
                    BinaryXorBitwise: []
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsUnions(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareUnions(this, other);
        }
    }]);

    return BinaryOperator;
}();
setType("TheGamma.Babel.BinaryOperator", BinaryOperator);
export var Pattern = function () {
    function Pattern(caseName, fields) {
        _classCallCheck(this, Pattern);

        this.Case = caseName;
        this.Fields = fields;
    }

    _createClass(Pattern, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.Pattern",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    IdentifierPattern: ["string", Option(SourceLocation)]
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsUnions(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareUnions(this, other);
        }
    }]);

    return Pattern;
}();
setType("TheGamma.Babel.Pattern", Pattern);
export var VariableDeclarationKind = function () {
    function VariableDeclarationKind(caseName, fields) {
        _classCallCheck(this, VariableDeclarationKind);

        this.Case = caseName;
        this.Fields = fields;
    }

    _createClass(VariableDeclarationKind, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.VariableDeclarationKind",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    Const: [],
                    Let: [],
                    Var: []
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsUnions(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareUnions(this, other);
        }
    }]);

    return VariableDeclarationKind;
}();
setType("TheGamma.Babel.VariableDeclarationKind", VariableDeclarationKind);
export var VariableDeclarator = function () {
    function VariableDeclarator(caseName, fields) {
        _classCallCheck(this, VariableDeclarator);

        this.Case = caseName;
        this.Fields = fields;
    }

    _createClass(VariableDeclarator, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.VariableDeclarator",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    VariableDeclarator: [Pattern, Option(Expression), Option(SourceLocation)]
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsUnions(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareUnions(this, other);
        }
    }]);

    return VariableDeclarator;
}();
setType("TheGamma.Babel.VariableDeclarator", VariableDeclarator);
export var ObjectMember = function () {
    function ObjectMember(caseName, fields) {
        _classCallCheck(this, ObjectMember);

        this.Case = caseName;
        this.Fields = fields;
    }

    _createClass(ObjectMember, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.ObjectMember",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    ObjectProperty: [Expression, Expression, "boolean", Option(SourceLocation)]
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsUnions(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareUnions(this, other);
        }
    }]);

    return ObjectMember;
}();
setType("TheGamma.Babel.ObjectMember", ObjectMember);
export var Expression = function () {
    function Expression(caseName, fields) {
        _classCallCheck(this, Expression);

        this.Case = caseName;
        this.Fields = fields;
    }

    _createClass(Expression, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.Expression",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    ArrayExpression: [makeGeneric(List, {
                        T: Expression
                    }), Option(SourceLocation)],
                    AssignmentExpression: [AssignmentOperator, Expression, Expression, Option(SourceLocation)],
                    BinaryExpression: [BinaryOperator, Expression, Expression, Option(SourceLocation)],
                    BooleanLiteral: ["boolean", Option(SourceLocation)],
                    CallExpression: [Expression, makeGeneric(List, {
                        T: Expression
                    }), Option(SourceLocation)],
                    FunctionExpression: [Option("string"), makeGeneric(List, {
                        T: Pattern
                    }), Statement, "boolean", "boolean", Option(SourceLocation)],
                    IdentifierExpression: ["string", Option(SourceLocation)],
                    MemberExpression: [Expression, Expression, "boolean", Option(SourceLocation)],
                    NewExpression: [Expression, makeGeneric(List, {
                        T: Expression
                    }), Option(SourceLocation)],
                    NullLiteral: [Option(SourceLocation)],
                    NumericLiteral: ["number", Option(SourceLocation)],
                    ObjectExpression: [makeGeneric(List, {
                        T: ObjectMember
                    }), Option(SourceLocation)],
                    StringLiteral: ["string", Option(SourceLocation)]
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsUnions(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareUnions(this, other);
        }
    }]);

    return Expression;
}();
setType("TheGamma.Babel.Expression", Expression);
export var Statement = function () {
    function Statement(caseName, fields) {
        _classCallCheck(this, Statement);

        this.Case = caseName;
        this.Fields = fields;
    }

    _createClass(Statement, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.Statement",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    BlockStatement: [makeGeneric(List, {
                        T: Statement
                    }), Option(SourceLocation)],
                    EmptyStatement: [Option(SourceLocation)],
                    ExpressionStatement: [Expression, Option(SourceLocation)],
                    ReturnStatement: [Expression, Option(SourceLocation)],
                    VariableDeclaration: [VariableDeclarationKind, makeGeneric(List, {
                        T: VariableDeclarator
                    }), Option(SourceLocation)]
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsUnions(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareUnions(this, other);
        }
    }]);

    return Statement;
}();
setType("TheGamma.Babel.Statement", Statement);
export var Program = function () {
    function Program(location, body) {
        _classCallCheck(this, Program);

        this.location = location;
        this.body = body;
    }

    _createClass(Program, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.Babel.Program",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    location: Option(SourceLocation),
                    body: makeGeneric(List, {
                        T: Statement
                    })
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return Program;
}();
setType("TheGamma.Babel.Program", Program);
export var Serializer = function (__exports) {
    var createObj = __exports.createObj = function (props) {
        return createObj_1(concat(props));
    };

    var serializeBinaryOperator = __exports.serializeBinaryOperator = function (_arg1) {
        if (_arg1.Case === "BinaryUnequal") {
            return "!=";
        } else if (_arg1.Case === "BinaryEqualStrict") {
            return "===";
        } else if (_arg1.Case === "BinaryUnequalStrict") {
            return "!==";
        } else if (_arg1.Case === "BinaryLess") {
            return "<";
        } else if (_arg1.Case === "BinaryLessOrEqual") {
            return "<=";
        } else if (_arg1.Case === "BinaryGreater") {
            return ">";
        } else if (_arg1.Case === "BinaryGreaterOrEqual") {
            return ">=";
        } else if (_arg1.Case === "BinaryShiftLeft") {
            return "<<";
        } else if (_arg1.Case === "BinaryShiftRightSignPropagating") {
            return ">>";
        } else if (_arg1.Case === "BinaryShiftRightZeroFill") {
            return ">>>";
        } else if (_arg1.Case === "BinaryMinus") {
            return "-";
        } else if (_arg1.Case === "BinaryPlus") {
            return "+";
        } else if (_arg1.Case === "BinaryMultiply") {
            return "*";
        } else if (_arg1.Case === "BinaryDivide") {
            return "/";
        } else if (_arg1.Case === "BinaryModulus") {
            return "%";
        } else if (_arg1.Case === "BinaryExponent") {
            return "**";
        } else if (_arg1.Case === "BinaryOrBitwise") {
            return "|";
        } else if (_arg1.Case === "BinaryXorBitwise") {
            return "^";
        } else if (_arg1.Case === "BinaryAndBitwise") {
            return "&";
        } else if (_arg1.Case === "BinaryIn") {
            return "in";
        } else if (_arg1.Case === "BinaryInstanceOf") {
            return "instanceof";
        } else {
            return "==";
        }
    };

    var serializeAssignOperator = __exports.serializeAssignOperator = function (_arg1) {
        if (_arg1.Case === "AssignMinus") {
            return "-=";
        } else if (_arg1.Case === "AssignPlus") {
            return "+=";
        } else if (_arg1.Case === "AssignMultiply") {
            return "*=";
        } else if (_arg1.Case === "AssignDivide") {
            return "/=";
        } else if (_arg1.Case === "AssignModulus") {
            return "%=";
        } else if (_arg1.Case === "AssignShiftLeft") {
            return "<<=";
        } else if (_arg1.Case === "AssignShiftRightSignPropagating") {
            return ">>=";
        } else if (_arg1.Case === "AssignShiftRightZeroFill") {
            return ">>>=";
        } else if (_arg1.Case === "AssignOrBitwise") {
            return "|=";
        } else if (_arg1.Case === "AssignXorBitwise") {
            return "^=";
        } else if (_arg1.Case === "AssignAndBitwise") {
            return "&=";
        } else {
            return "=";
        }
    };

    var serializePattern = __exports.serializePattern = function (pat) {
        return createObj(ofArray([ofArray([["type", "Identifier"]]), ofArray([["name", pat.Fields[0]]]), function () {
            var $var276 = pat.Fields[1];

            if ($var276 != null) {
                return ofArray([["loc", $var276]]);
            } else {
                return new List();
            }
        }()]));
    };

    var serializeMember = __exports.serializeMember = function (mem) {
        return createObj(ofArray([ofArray([["type", "ObjectProperty"]]), ofArray([["key", serializeExpression(mem.Fields[0])]]), ofArray([["value", serializeExpression(mem.Fields[1])]]), ofArray([["computed", mem.Fields[2]]]), function () {
            var $var277 = mem.Fields[3];

            if ($var277 != null) {
                return ofArray([["loc", $var277]]);
            } else {
                return new List();
            }
        }()]));
    };

    var serializeDeclarator = __exports.serializeDeclarator = function (_arg1) {
        return createObj(ofArray([ofArray([["type", "VariableDeclarator"]]), ofArray([["id", serializePattern(_arg1.Fields[0])]]), function () {
            var $var278 = defaultArg(_arg1.Fields[1], null, function (expr) {
                return serializeExpression(expr);
            });

            if ($var278 != null) {
                return ofArray([["init", $var278]]);
            } else {
                return new List();
            }
        }(), function () {
            var $var279 = _arg1.Fields[2];

            if ($var279 != null) {
                return ofArray([["loc", $var279]]);
            } else {
                return new List();
            }
        }()]));
    };

    var serializeExpression = __exports.serializeExpression = function (expr) {
        if (expr.Case === "NewExpression") {
            return createObj(ofArray([ofArray([["type", "NewExpression"]]), ofArray([["callee", serializeExpression(expr.Fields[0])]]), ofArray([["arguments", _Array$from(map(function (expr_1) {
                return serializeExpression(expr_1);
            }, expr.Fields[1]))]]), function () {
                var $var280 = expr.Fields[2];

                if ($var280 != null) {
                    return ofArray([["loc", $var280]]);
                } else {
                    return new List();
                }
            }()]));
        } else if (expr.Case === "FunctionExpression") {
            return createObj(ofArray([ofArray([["type", "FunctionExpression"]]), function () {
                var $var281 = expr.Fields[0];

                if ($var281 != null) {
                    return ofArray([["id", $var281]]);
                } else {
                    return new List();
                }
            }(), ofArray([["params", _Array$from(map(function (pat) {
                return serializePattern(pat);
            }, expr.Fields[1]))]]), ofArray([["body", serializeStatement(expr.Fields[2])]]), ofArray([["generator", expr.Fields[3]]]), ofArray([["async", expr.Fields[4]]]), function () {
                var $var282 = expr.Fields[5];

                if ($var282 != null) {
                    return ofArray([["loc", $var282]]);
                } else {
                    return new List();
                }
            }()]));
        } else if (expr.Case === "AssignmentExpression") {
            return createObj(ofArray([ofArray([["type", "AssignmentExpression"]]), ofArray([["left", serializeExpression(expr.Fields[1])]]), ofArray([["right", serializeExpression(expr.Fields[2])]]), ofArray([["operator", serializeAssignOperator(expr.Fields[0])]]), function () {
                var $var283 = expr.Fields[3];

                if ($var283 != null) {
                    return ofArray([["loc", $var283]]);
                } else {
                    return new List();
                }
            }()]));
        } else if (expr.Case === "CallExpression") {
            return createObj(ofArray([ofArray([["type", "CallExpression"]]), ofArray([["callee", serializeExpression(expr.Fields[0])]]), ofArray([["arguments", _Array$from(map(function (expr_2) {
                return serializeExpression(expr_2);
            }, expr.Fields[1]))]]), function () {
                var $var284 = expr.Fields[2];

                if ($var284 != null) {
                    return ofArray([["loc", $var284]]);
                } else {
                    return new List();
                }
            }()]));
        } else if (expr.Case === "MemberExpression") {
            return createObj(ofArray([ofArray([["type", "MemberExpression"]]), ofArray([["object", serializeExpression(expr.Fields[0])]]), ofArray([["property", serializeExpression(expr.Fields[1])]]), ofArray([["computed", expr.Fields[2]]]), function () {
                var $var285 = expr.Fields[3];

                if ($var285 != null) {
                    return ofArray([["loc", $var285]]);
                } else {
                    return new List();
                }
            }()]));
        } else if (expr.Case === "BinaryExpression") {
            return createObj(ofArray([ofArray([["type", "BinaryExpression"]]), ofArray([["left", serializeExpression(expr.Fields[1])]]), ofArray([["right", serializeExpression(expr.Fields[2])]]), ofArray([["operator", serializeBinaryOperator(expr.Fields[0])]]), function () {
                var $var286 = expr.Fields[3];

                if ($var286 != null) {
                    return ofArray([["loc", $var286]]);
                } else {
                    return new List();
                }
            }()]));
        } else if (expr.Case === "ObjectExpression") {
            return createObj(ofArray([ofArray([["type", "ObjectExpression"]]), ofArray([["properties", _Array$from(map(function (mem) {
                return serializeMember(mem);
            }, expr.Fields[0]))]]), function () {
                var $var287 = expr.Fields[1];

                if ($var287 != null) {
                    return ofArray([["loc", $var287]]);
                } else {
                    return new List();
                }
            }()]));
        } else if (expr.Case === "ArrayExpression") {
            return createObj(ofArray([ofArray([["type", "ArrayExpression"]]), ofArray([["elements", _Array$from(map(function (expr_3) {
                return serializeExpression(expr_3);
            }, expr.Fields[0]))]]), function () {
                var $var288 = expr.Fields[1];

                if ($var288 != null) {
                    return ofArray([["loc", $var288]]);
                } else {
                    return new List();
                }
            }()]));
        } else if (expr.Case === "NullLiteral") {
            return createObj(ofArray([ofArray([["type", "NullLiteral"]]), function () {
                var $var289 = expr.Fields[0];

                if ($var289 != null) {
                    return ofArray([["loc", $var289]]);
                } else {
                    return new List();
                }
            }()]));
        } else if (expr.Case === "StringLiteral") {
            return createObj(ofArray([ofArray([["type", "StringLiteral"]]), ofArray([["value", expr.Fields[0]]]), function () {
                var $var290 = expr.Fields[1];

                if ($var290 != null) {
                    return ofArray([["loc", $var290]]);
                } else {
                    return new List();
                }
            }()]));
        } else if (expr.Case === "BooleanLiteral") {
            return createObj(ofArray([ofArray([["type", "BooleanLiteral"]]), ofArray([["value", expr.Fields[0]]]), function () {
                var $var291 = expr.Fields[1];

                if ($var291 != null) {
                    return ofArray([["loc", $var291]]);
                } else {
                    return new List();
                }
            }()]));
        } else if (expr.Case === "NumericLiteral") {
            return createObj(ofArray([ofArray([["type", "NumericLiteral"]]), ofArray([["value", expr.Fields[0]]]), function () {
                var $var292 = expr.Fields[1];

                if ($var292 != null) {
                    return ofArray([["loc", $var292]]);
                } else {
                    return new List();
                }
            }()]));
        } else {
            return createObj(ofArray([ofArray([["type", "Identifier"]]), ofArray([["name", expr.Fields[0]]]), function () {
                var $var293 = expr.Fields[1];

                if ($var293 != null) {
                    return ofArray([["loc", $var293]]);
                } else {
                    return new List();
                }
            }()]));
        }
    };

    var serializeStatement = __exports.serializeStatement = function (stm) {
        if (stm.Case === "BlockStatement") {
            return createObj(ofArray([ofArray([["type", "BlockStatement"]]), function () {
                var $var294 = stm.Fields[1];

                if ($var294 != null) {
                    return ofArray([["loc", $var294]]);
                } else {
                    return new List();
                }
            }(), ofArray([["body", _Array$from(map(function (stm_1) {
                return serializeStatement(stm_1);
            }, stm.Fields[0]))]])]));
        } else if (stm.Case === "EmptyStatement") {
            return createObj(ofArray([ofArray([["type", "EmptyStatement"]]), function () {
                var $var295 = stm.Fields[0];

                if ($var295 != null) {
                    return ofArray([["loc", $var295]]);
                } else {
                    return new List();
                }
            }()]));
        } else if (stm.Case === "ReturnStatement") {
            return createObj(ofArray([ofArray([["type", "ReturnStatement"]]), function () {
                var $var296 = stm.Fields[1];

                if ($var296 != null) {
                    return ofArray([["loc", $var296]]);
                } else {
                    return new List();
                }
            }(), ofArray([["argument", serializeExpression(stm.Fields[0])]])]));
        } else if (stm.Case === "VariableDeclaration") {
            var kind = stm.Fields[0].Case === "Let" ? "let" : stm.Fields[0].Case === "Const" ? "const" : "var";
            return createObj(ofArray([ofArray([["type", "VariableDeclaration"]]), ofArray([["kind", kind]]), ofArray([["declarations", _Array$from(map(function (arg00_) {
                return serializeDeclarator(arg00_);
            }, stm.Fields[1]))]]), function () {
                var $var297 = stm.Fields[2];

                if ($var297 != null) {
                    return ofArray([["loc", $var297]]);
                } else {
                    return new List();
                }
            }()]));
        } else {
            return createObj(ofArray([ofArray([["type", "ExpressionStatement"]]), function () {
                var $var298 = stm.Fields[1];

                if ($var298 != null) {
                    return ofArray([["loc", $var298]]);
                } else {
                    return new List();
                }
            }(), ofArray([["expression", serializeExpression(stm.Fields[0])]])]));
        }
    };

    var serializeProgram = __exports.serializeProgram = function (prog) {
        return createObj(ofArray([ofArray([["type", "Program"]]), function () {
            var $var299 = prog.location;

            if ($var299 != null) {
                return ofArray([["loc", $var299]]);
            } else {
                return new List();
            }
        }(), ofArray([["sourceType", "module"]]), ofArray([["body", _Array$from(map(function (stm) {
            return serializeStatement(stm);
        }, prog.body))]]), ofArray([["directives", []]])]));
    };

    return __exports;
}({});
export var BabelOperators = function (__exports) {
    var ident = __exports.ident = function (s) {
        return new Expression("IdentifierExpression", [s, null]);
    };

    var str = __exports.str = function (v) {
        return new Expression("StringLiteral", [v, null]);
    };

    var num = __exports.num = function (v) {
        return new Expression("NumericLiteral", [v, null]);
    };

    var bool = __exports.bool = function (v) {
        return new Expression("BooleanLiteral", [v, null]);
    };

    var arr = __exports.arr = function (l) {
        return new Expression("ArrayExpression", [l, null]);
    };

    var op_Dynamic = __exports.op_Dynamic = function (e, s) {
        return new Expression("MemberExpression", [e, new Expression("IdentifierExpression", [s, null]), false, null]);
    };

    var op_DivideQmarkDivide = __exports.op_DivideQmarkDivide = function (e, a) {
        return new Expression("MemberExpression", [e, a, true, null]);
    };

    var op_DivideAtDivide = __exports.op_DivideAtDivide = function (e, args) {
        return new Expression("CallExpression", [e, args, null]);
    };

    var func = __exports.func = function (v, f) {
        var body = new Statement("BlockStatement", [ofArray([new Statement("ReturnStatement", [f(ident(v)), null])]), null]);
        return new Expression("FunctionExpression", [null, ofArray([new Pattern("IdentifierPattern", [v, null])]), body, false, false, null]);
    };

    var funcN = __exports.funcN = function (n, f) {
        var args = initialize(n, function (i) {
            return "_arg" + String(i);
        });
        var body = new Statement("BlockStatement", [ofArray([new Statement("ReturnStatement", [f(map(function (s) {
            return ident(s);
        }, args)), null])]), null]);
        return new Expression("FunctionExpression", [null, map(function (s_1) {
            return new Pattern("IdentifierPattern", [s_1, null]);
        }, args), body, false, false, null]);
    };

    return __exports;
}({});
//# sourceMappingURL=babel.js.map