import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { DomNode } from "../../libraries/html";
import { Tuple, makeGeneric, Option, Interface, GenericParam } from "fable-core/Util";
import { Expr, Node as _Node, Program } from "../ast/ast";
import { LineColumnRange, LocationMapper } from "../common/locations";
import List from "fable-core/List";
import { $7C$ExprLeaf$7C$ExprNode$7C$ as _ExprLeaf_ExprNode_ } from "../ast/astops";
import { tryPick } from "fable-core/Seq";
export var LiveEditorZone = function () {
  function LiveEditorZone(line, preview) {
    _classCallCheck(this, LiveEditorZone);

    this.Line = line;
    this.Preview = preview;
  }

  _createClass(LiveEditorZone, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Live.Common.LiveEditorZone",
        interfaces: ["FSharpRecord"],
        properties: {
          Line: "number",
          Preview: DomNode
        }
      };
    }
  }]);

  return LiveEditorZone;
}();
setType("TheGamma.Live.Common.LiveEditorZone", LiveEditorZone);
export var LivePreview = function () {
  function LivePreview(iD, update, render, initialState) {
    _classCallCheck(this, LivePreview);

    this.ID = iD;
    this.Update = update;
    this.Render = render;
    this.InitialState = initialState;
  }

  _createClass(LivePreview, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Live.Common.LivePreview",
        interfaces: ["FSharpRecord"],
        properties: {
          ID: "string",
          Update: "function",
          Render: "function",
          InitialState: GenericParam("TState")
        }
      };
    }
  }]);

  return LivePreview;
}();
setType("TheGamma.Live.Common.LivePreview", LivePreview);
export var LiveState = function () {
  function LiveState(globals, code, program, mapper, location, selection, state, currentPreview) {
    _classCallCheck(this, LiveState);

    this.Globals = globals;
    this.Code = code;
    this.Program = program;
    this.Mapper = mapper;
    this.Location = location;
    this.Selection = selection;
    this.State = state;
    this.CurrentPreview = currentPreview;
  }

  _createClass(LiveState, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Live.Common.LiveState",
        interfaces: ["FSharpRecord"],
        properties: {
          Globals: Interface("System.Collections.Generic.IEnumerable"),
          Code: "string",
          Program: Program,
          Mapper: LocationMapper,
          Location: "number",
          Selection: Option(LineColumnRange),
          State: GenericParam("T"),
          CurrentPreview: Option(makeGeneric(LivePreview, {
            TState: Interface("TheGamma.Live.Common.CustomLiveState"),
            TEvent: Interface("TheGamma.Live.Common.CustomLiveEvent")
          }))
        }
      };
    }
  }]);

  return LiveState;
}();
setType("TheGamma.Live.Common.LiveState", LiveState);
export var LiveEvent = function () {
  function LiveEvent(caseName, fields) {
    _classCallCheck(this, LiveEvent);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(LiveEvent, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Live.Common.LiveEvent",
        interfaces: ["FSharpUnion"],
        cases: {
          CustomEvent: [GenericParam("T")],
          InitializeGlobals: [Interface("System.Collections.Generic.IEnumerable")],
          UpdateLocation: ["number"],
          UpdateSource: ["string", "number", Program, LocationMapper]
        }
      };
    }
  }]);

  return LiveEvent;
}();
setType("TheGamma.Live.Common.LiveEvent", LiveEvent);
export function updateLiveState(state, event) {
  if (event.Case === "UpdateLocation") {
    return new LiveState(state.Globals, state.Code, state.Program, state.Mapper, event.Fields[0], state.Selection, state.State, state.CurrentPreview);
  } else if (event.Case === "UpdateSource") {
    return new LiveState(state.Globals, event.Fields[0], event.Fields[2], event.Fields[3], event.Fields[1], state.Selection, state.State, state.CurrentPreview);
  } else if (event.Case === "CustomEvent") {
    return state;
  } else {
    return new LiveState(event.Fields[0], state.Code, state.Program, state.Mapper, state.Location, state.Selection, state.State, state.CurrentPreview);
  }
}
export var NestedChain = function () {
  function NestedChain(chain) {
    _classCallCheck(this, NestedChain);

    this.Chain = chain;
  }

  _createClass(NestedChain, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Live.Common.NestedChain",
        interfaces: ["FSharpRecord"],
        properties: {
          Chain: makeGeneric(List, {
            T: Tuple(["number", makeGeneric(_Node, {
              T: Expr
            })])
          })
        }
      };
    }
  }]);

  return NestedChain;
}();
setType("TheGamma.Live.Common.NestedChain", NestedChain);
export function collectChain(acc, node) {
  collectChain: while (true) {
    if (node.Node.Case === "Call") {
      acc = new List([node.Node.Fields[1].Range.Start, node], acc);
      node = node.Node.Fields[0];
      continue collectChain;
    } else if (node.Node.Case === "Member") {
      acc = new List([node.Node.Fields[1].Range.Start, node], acc);
      node = node.Node.Fields[0];
      continue collectChain;
    } else if (node.Node.Case === "Variable") {
      return new List([node.Node.Fields[0].Range.Start, node], acc);
    } else {
      return null;
    }
  }
}
export function collectFirstChain(expr) {
  var matchValue = collectChain(new List(), expr);
  var $var480 = matchValue != null ? matchValue.tail != null ? [0, matchValue] : [1] : [1];

  switch ($var480[0]) {
    case 0:
      return new NestedChain($var480[1]);

    case 1:
      var activePatternResult7975 = _ExprLeaf_ExprNode_(expr.Node);

      if (activePatternResult7975.Case === "Choice2Of2") {
        return tryPick(function (expr_1) {
          return collectFirstChain(expr_1);
        }, activePatternResult7975.Fields[0][0]);
      } else {
        return null;
      }

  }
}
//# sourceMappingURL=live.js.map