import _Map from "babel-runtime/core-js/map";
import _Array$from from "babel-runtime/core-js/array/from";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { formatWhiteAfterExpr, formatWhiteBeforeExpr, node as node_3, formatSingleExpression, escapeIdent, $7C$FindMember$7C$_$7C$ as _FindMember___, pickMetaByType } from "../ast/astops";
import { Transformation, PivotObject } from "../providers/pivot";
import { collect as collect_1, mapIndexed, append, map, filter, choose, reverse, ofArray } from "fable-core/List";
import List from "fable-core/List";
import { exists, append as append_1, map as map_1, choose as choose_1, find, empty, takeWhile, last as last_1, reduce, toList, fold, tryLast, skipWhile, sortWith, tryPick, singleton, collect, delay, tryFind } from "fable-core/Seq";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { equals, compare, defaultArg, Tuple, Option, Interface, compareUnions, equalsUnions, makeGeneric } from "fable-core/Util";
import { TokenKind, Token, Argument, Name, Entity, Range as _Range, Expr, Node as _Node_2 } from "../ast/ast";
import { Log } from "../../libraries/common";
import { op_EqualsBangGreater, text, op_EqualsGreater, h, El, DomNode } from "../../libraries/html";
import { LivePreview, LiveEditorZone, collectFirstChain, LiveEvent, LiveState } from "./live";
import { evaluate } from "../analyzer/interpreter";
import { startImmediate } from "fable-core/Async";
import { table } from "../../libraries/tables";
import { singleton as singleton_1 } from "fable-core/AsyncBuilder";
import { LocationMapper, LineColumnRange } from "../common/locations";
import { trim, replace } from "fable-core/String";
import { countBy } from "fable-core/Map";
import { create } from "fable-core/Set";
import GenericComparer from "fable-core/GenericComparer";
import { parseProgram } from "../parser/parser";
export function pickPivotFields(expr) {
  var matchValue = expr.Entity;
  var $var485 = matchValue != null ? matchValue.Kind.Case === "MemberAccess" ? matchValue.Kind.Fields[0].Kind.Case === "Member" ? [0, matchValue.Kind.Fields[0].Meta] : [1] : matchValue.Kind.Case === "GlobalValue" ? [0, matchValue.Meta] : matchValue.Kind.Case === "Variable" ? [0, matchValue.Kind.Fields[1].Meta] : [1] : [1];

  switch ($var485[0]) {
    case 0:
      var matchValue_1 = pickMetaByType("http://schema.thegamma.net/pivot", "Fields", $var485[1]);

      if (matchValue_1 != null) {
        return matchValue_1;
      } else {
        return null;
      }

    case 1:
      return null;
  }
}
export function pickPivotTransformations(expr) {
  var tryPivotType = void 0;
  var $var486 = expr.Entity != null ? expr.Entity.Type != null ? expr.Entity.Type.Case === "Object" ? expr.Entity.Type.Fields[0] instanceof PivotObject ? [0] : [1] : [1] : [1] : [1];

  switch ($var486[0]) {
    case 0:
      tryPivotType = ofArray([new Transformation("Empty", [])]);
      break;

    case 1:
      tryPivotType = null;
      break;
  }

  var tryTransform = void 0;
  var $var487 = expr.Node.Case === "Call" ? expr.Node.Fields[0].Entity != null ? expr.Node.Fields[0].Entity.Kind.Case === "MemberAccess" ? expr.Node.Fields[0].Entity.Kind.Fields[0].Kind.Case === "Member" ? [0, expr.Node.Fields[0].Entity.Kind.Fields[0].Meta] : expr.Entity != null ? expr.Entity.Kind.Case === "MemberAccess" ? expr.Entity.Kind.Fields[0].Kind.Case === "Member" ? [0, expr.Entity.Kind.Fields[0].Meta] : [1] : [1] : [1] : expr.Entity != null ? expr.Entity.Kind.Case === "MemberAccess" ? expr.Entity.Kind.Fields[0].Kind.Case === "Member" ? [0, expr.Entity.Kind.Fields[0].Meta] : [1] : [1] : [1] : expr.Entity != null ? expr.Entity.Kind.Case === "MemberAccess" ? expr.Entity.Kind.Fields[0].Kind.Case === "Member" ? [0, expr.Entity.Kind.Fields[0].Meta] : [1] : [1] : [1] : expr.Entity != null ? expr.Entity.Kind.Case === "MemberAccess" ? expr.Entity.Kind.Fields[0].Kind.Case === "Member" ? [0, expr.Entity.Kind.Fields[0].Meta] : [1] : [1] : [1];

  switch ($var487[0]) {
    case 0:
      var matchValue = pickMetaByType("http://schema.thegamma.net/pivot", "Transformations", $var487[1]);

      if (matchValue != null) {
        tryTransform = matchValue;
      } else {
        tryTransform = null;
      }

      break;

    case 1:
      tryTransform = null;
      break;
  }

  var matchValue_1 = [tryTransform, tryPivotType];
  var $var488 = matchValue_1[0] != null ? [0, matchValue_1[0]] : matchValue_1[1] != null ? [0, matchValue_1[1]] : [1];

  switch ($var488[0]) {
    case 0:
      return $var488[1];

    case 1:
      return null;
  }
}
export function commandAtLocation(loc, program) {
  return tryFind(function (cmd) {
    return cmd.Range.Start <= loc ? cmd.Range.End + 1 >= loc : false;
  }, program.Body.Node);
}
export var PivotSection = function () {
  function PivotSection(transformation, nodes) {
    _classCallCheck(this, PivotSection);

    this.Transformation = transformation;
    this.Nodes = nodes;
  }

  _createClass(PivotSection, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Live.Pivot.PivotSection",
        interfaces: ["FSharpRecord"],
        properties: {
          Transformation: Transformation,
          Nodes: makeGeneric(List, {
            T: makeGeneric(_Node_2, {
              T: Expr
            })
          })
        }
      };
    }
  }]);

  return PivotSection;
}();
setType("TheGamma.Live.Pivot.PivotSection", PivotSection);
export function transformName(_arg1) {
  var $var489 = _arg1.Case === "Empty" ? [1] : _arg1.Case === "FilterBy" ? [2] : _arg1.Case === "GetSeries" ? [3] : _arg1.Case === "GetTheData" ? [4] : _arg1.Case === "GroupBy" ? [5] : _arg1.Case === "WindowBy" ? [6] : _arg1.Case === "ExpandBy" ? [7] : _arg1.Case === "Paging" ? [8] : _arg1.Case === "SortBy" ? [9] : _arg1.Case === "GetRange" ? [10] : _arg1.Case === "Metadata" ? [10] : [0];

  switch ($var489[0]) {
    case 0:
      return "drop columns";

    case 1:
      return "empty";

    case 2:
      return "filter by";

    case 3:
      return "get series";

    case 4:
      return "get the data";

    case 5:
      return "group by";

    case 6:
      return "window by";

    case 7:
      return "expand by";

    case 8:
      return "paging";

    case 9:
      return "sort by";

    case 10:
      throw new Error("Unexpected get range or metadata");
  }
}
export function createPivotSections(ch) {
  var loop = function loop(acc) {
    return function (tupledArg) {
      return function (_arg1) {
        loop: while (true) {
          var $var490 = _arg1.tail != null ? function () {
            var tfs_1 = _arg1.head[1];
            var e_1 = _arg1.head[0];

            if (transformName(tfs_1.head) === transformName(tupledArg[0])) {
              return tfs_1.length === tupledArg[2];
            } else {
              return false;
            }
          }() ? [0, _arg1.head[0], _arg1.head[1], _arg1.tail] : [1] : [1];

          switch ($var490[0]) {
            case 0:
              acc = acc;
              tupledArg = [tupledArg[0], new List($var490[1], tupledArg[1]), tupledArg[2]];
              _arg1 = $var490[3];
              continue loop;

            case 1:
              if (_arg1.tail == null) {
                var current = new PivotSection(tupledArg[0], reverse(tupledArg[1]));
                return reverse(new List(current, acc));
              } else {
                var tfs = _arg1.head[1];
                var e = _arg1.head[0];
                var current_1 = new PivotSection(tupledArg[0], reverse(tupledArg[1]));
                acc = new List(current_1, acc);
                tupledArg = [tfs.head, ofArray([e]), tfs.length];
                _arg1 = _arg1.tail;
                continue loop;
              }

          }
        }
      };
    };
  };

  var tfss = choose(function (tupledArg_1) {
    var matchValue = pickPivotTransformations(tupledArg_1[1]);

    if (matchValue == null) {
      return null;
    } else {
      var tfs_2 = matchValue.length === 1 ? matchValue : filter(function (_arg2) {
        return _arg2.Case === "Empty" ? false : true;
      }, matchValue);

      if (tfs_2.tail == null) {
        return null;
      } else {
        return [tupledArg_1[1], tfs_2];
      }
    }
  }, ch.Chain);
  Log.trace("live", "Transformations: %O", _Array$from(delay(function () {
    return collect(function (matchValue_1) {
      return singleton([matchValue_1[0].Node, transformName(matchValue_1[1].head) + " " + String(matchValue_1[1].length)]);
    }, tfss);
  })));

  if (tfss.tail == null) {
    return new List();
  } else {
    var tfs_3 = tfss.head[1];
    var e_2 = tfss.head[0];
    return loop(new List())([tfs_3.head, ofArray([e_2]), tfs_3.length])(tfss.tail);
  }
}
export var PivotEditorMenus = function () {
  function PivotEditorMenus(caseName, fields) {
    _classCallCheck(this, PivotEditorMenus);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(PivotEditorMenus, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Live.Pivot.PivotEditorMenus",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          AddDropdownOpen: [],
          ContextualDropdownOpen: [],
          Hidden: []
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return PivotEditorMenus;
}();
setType("TheGamma.Live.Pivot.PivotEditorMenus", PivotEditorMenus);
export var PivotEditorAction = function () {
  function PivotEditorAction(caseName, fields) {
    _classCallCheck(this, PivotEditorAction);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(PivotEditorAction, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Live.Pivot.PivotEditorAction",
        interfaces: ["FSharpUnion"],
        cases: {
          AddElement: [Interface("TheGamma.Common.Symbol"), "string", Option(makeGeneric(List, {
            T: Expr
          }))],
          AddTransform: [Transformation],
          RemoveElement: [Interface("TheGamma.Common.Symbol")],
          RemoveSection: [Interface("TheGamma.Common.Symbol")],
          ReplaceElement: [Interface("TheGamma.Common.Symbol"), "string", Option(makeGeneric(List, {
            T: Expr
          }))],
          ReplaceRange: [_Range, "string"],
          SelectChainElement: ["number"],
          SelectRange: [_Range],
          SwitchMenu: [PivotEditorMenus],
          UpdatePreview: [DomNode]
        }
      };
    }
  }]);

  return PivotEditorAction;
}();
setType("TheGamma.Live.Pivot.PivotEditorAction", PivotEditorAction);
export var PivotEditorState = function () {
  function PivotEditorState(body, firstNode, preview, sections, selectedEntity, menus, focus) {
    _classCallCheck(this, PivotEditorState);

    this.Body = body;
    this.FirstNode = firstNode;
    this.Preview = preview;
    this.Sections = sections;
    this.SelectedEntity = selectedEntity;
    this.Menus = menus;
    this.Focus = focus;
  }

  _createClass(PivotEditorState, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Live.Pivot.PivotEditorState",
        interfaces: ["FSharpRecord"],
        properties: {
          Body: makeGeneric(_Node_2, {
            T: Expr
          }),
          FirstNode: makeGeneric(_Node_2, {
            T: Expr
          }),
          Preview: DomNode,
          Sections: makeGeneric(List, {
            T: PivotSection
          }),
          SelectedEntity: Entity,
          Menus: PivotEditorMenus,
          Focus: Option(Tuple(["string", Option("number")]))
        }
      };
    }
  }]);

  return PivotEditorState;
}();
setType("TheGamma.Live.Pivot.PivotEditorState", PivotEditorState);
export function withPivotState(pivotState, state) {
  return new LiveState(state.Globals, state.Code, state.Program, state.Mapper, state.Location, state.Selection, pivotState, state.CurrentPreview);
}
export function findPreview(ch, trigger, globals, ent) {
  var msg = void 0;
  var $var491 = ent.Kind.Case === "MemberAccess" ? ent.Kind.Fields[0].Kind.Case === "Member" ? ent.Kind.Fields[0].Kind.Fields[1].Kind.Case === "MemberName" ? [0, ent.Kind.Fields[0].Kind.Fields[1].Kind.Fields[0]] : [2] : [2] : ent.Kind.Case === "Call" ? [1] : [2];

  switch ($var491[0]) {
    case 0:
      msg = $var491[1].Name;
      break;

    case 1:
      msg = "call";
      break;

    case 2:
      msg = "whatever";
      break;
  }

  Log.trace("live", "Get preview for: %O", msg);
  var nm = new Name("preview");
  var prevDom = tryPick(function (tupledArg) {
    var matchValue = tupledArg[1].Entity.Type;
    var $var492 = void 0;

    if (matchValue != null) {
      if (matchValue.Case === "Object") {
        var activePatternResult8029 = function (obj) {
          return _FindMember___(nm, obj);
        }(matchValue.Fields[0]);

        if (activePatternResult8029 != null) {
          $var492 = [0, activePatternResult8029];
        } else {
          $var492 = [1];
        }
      } else {
        $var492 = [1];
      }
    } else {
      $var492 = [1];
    }

    switch ($var492[0]) {
      case 0:
        var matchValue_1 = pickMetaByType("http://schema.org", "WebPage", $var492[1].Metadata);

        if (matchValue_1 != null) {
          var url = matchValue_1["url"];
          Log.trace("live", "Found preview webpage at %s: %O", tupledArg[0], url);
          return function (arg0) {
            return function (arg1) {
              return El.op_Dynamic(arg0, arg1);
            };
          }(h)("iframe")(ofArray([op_EqualsGreater("src", url)]))(new List());
        } else {
          var res = evaluate(globals, ent);
          var res_1 = defaultArg(res, null, function (p) {
            return p.Preview.value;
          });

          if (res_1 != null) {
            Log.trace("live", "Found preview value at %s: %O", tupledArg[0], res_1);

            var node = function (arg0_1) {
              return function (arg1_1) {
                return El.op_Dynamic(arg0_1, arg1_1);
              };
            }(h)("div")(ofArray([op_EqualsGreater("class", "placeholder")]))(ofArray([text("Loading preview...")]));

            var returned = false;

            (function (arg00) {
              startImmediate(arg00);
            })(function (builder_) {
              return builder_.Delay(function () {
                return builder_.Bind(table.create(res_1).render(), function (_arg7) {
                  return builder_.Combine(returned ? function () {
                    trigger(new LiveEvent("CustomEvent", [new PivotEditorAction("UpdatePreview", [_arg7])]));
                    return builder_.Zero();
                  }() : function () {
                    node = _arg7;
                    return builder_.Zero();
                  }(), builder_.Delay(function () {
                    Log.trace("live", "Evaluated to a node");
                    return builder_.Zero();
                  }));
                });
              });
            }(singleton_1));

            returned = true;
            Log.trace("live", "After evaluation started: %O", node);
            return node;
          } else {
            return function (arg0_2) {
              return function (arg1_2) {
                return El.op_Dynamic(arg0_2, arg1_2);
              };
            }(h)("div")(ofArray([op_EqualsGreater("class", "placeholder")]))(ofArray([text("Preview could not be evaluated")]));
          }
        }

      case 1:
        return null;
    }
  }, sortWith(function (x, y) {
    return compare(function (tuple) {
      return tuple[0];
    }(x), function (tuple) {
      return tuple[0];
    }(y));
  }, skipWhile(function (tupledArg_1) {
    return !equals(tupledArg_1[1].Entity.Symbol, ent.Symbol);
  }, ch.Chain)));

  if (prevDom != null) {
    return prevDom;
  } else {
    return function (arg0_3) {
      return function (arg1_3) {
        return El.op_Dynamic(arg0_3, arg1_3);
      };
    }(h)("div")(ofArray([op_EqualsGreater("class", "placeholder")]))(ofArray([text("This block does not have a preview")]));
  }
}
export function updateBody(trigger, state) {
  var matchValue = commandAtLocation(state.Location, state.Program);

  if (matchValue != null) {
    var patternInput = state.Mapper.AbsoluteToLineCol(matchValue.Range.End + 1);
    var $var493 = matchValue.Node.Case === "Let" ? [0, matchValue.Node.Fields[1]] : [0, matchValue.Node.Fields[0]];

    switch ($var493[0]) {
      case 0:
        var matchValue_1 = collectFirstChain($var493[1]);

        if (matchValue_1 != null) {
          var sections = createPivotSections(matchValue_1);
          var patternInput_1 = matchValue_1.Chain.head;
          var matchValue_2 = tryLast(filter(function (tupledArg) {
            return state.Location >= tupledArg[0];
          }, matchValue_1.Chain));
          var $var494 = matchValue_2 != null ? function () {
            var selNode = matchValue_2[1];
            return !(sections.tail == null);
          }() ? [0, matchValue_2[1]] : [1] : [1];

          switch ($var494[0]) {
            case 0:
              var _preview = findPreview(matchValue_1, trigger, state.Globals, $var494[1].Entity);

              var ps = void 0;
              var Menus = new PivotEditorMenus("Hidden", []);
              var Focus = null;
              var SelectedEntity = $var494[1].Entity;
              ps = new PivotEditorState($var493[1], patternInput_1[1], _preview, sections, SelectedEntity, Menus, Focus);
              return function (state_1) {
                return withPivotState(ps, state_1);
              }(state);

            case 1:
              return null;
          }
        } else {
          return null;
        }

    }
  } else {
    return null;
  }
}
export function hideMenus(state) {
  var State = void 0;
  var Menus = new PivotEditorMenus("Hidden", []);
  State = new PivotEditorState(state.State.Body, state.State.FirstNode, state.State.Preview, state.State.Sections, state.State.SelectedEntity, Menus, state.State.Focus);
  return new LiveState(state.Globals, state.Code, state.Program, state.Mapper, state.Location, state.Selection, State, state.CurrentPreview);
}
export function editorLocation(mapper, startIndex, endIndex) {
  var patternInput = mapper.AbsoluteToLineCol(startIndex);
  var patternInput_1 = mapper.AbsoluteToLineCol(endIndex);
  var rng = {};
  return new LineColumnRange(patternInput[0], patternInput[1], patternInput_1[0], patternInput_1[1]);
}
export function selectName(nd, state) {
  var rng = void 0;

  if (nd.Node.Case === "Member") {
    var n = nd.Node.Fields[1];
    rng = n.Range;
  } else {
    rng = nd.Range;
  }

  var loc = editorLocation(state.Mapper, rng.Start, rng.End + 1);
  var Selection = loc;
  return new LiveState(state.Globals, state.Code, state.Program, state.Mapper, state.Location, Selection, state.State, state.CurrentPreview);
}
export function tryTransformChain(f, state) {
  var matchValue = collectFirstChain(state.State.Body);

  if (matchValue != null) {
    var sections = createPivotSections(matchValue);
    return hideMenus(f(state.State.Body)(map(function (tuple) {
      return tuple[1];
    }, matchValue.Chain))(sections));
  } else {
    return hideMenus(state);
  }
}
export var marker = "InsertPropertyHere";
export function replaceAndSelectMarker(newName, state) {
  var startIndex = state.Code.indexOf(marker);
  var newCode = replace(state.Code, marker, escapeIdent(newName));
  var mapper = new LocationMapper(state.Code);
  var rng = editorLocation(mapper, startIndex, startIndex + escapeIdent(newName).length);
  var Selection = rng;
  return new LiveState(state.Globals, newCode, state.Program, state.Mapper, state.Location, Selection, state.State, state.CurrentPreview);
}
export function reconstructChain(state, body, newNodes) {
  var newBody = fold(function (prev, part) {
    if (part.Node.Case === "Member") {
      var _Node = new Expr("Member", [prev, part.Node.Fields[1]]);

      return new _Node_2(part.WhiteBefore, part.WhiteAfter, part.Range, _Node, part.Entity);
    } else if (part.Node.Case === "Call") {
      var _Node_1 = new Expr("Call", [prev, part.Node.Fields[1]]);

      return new _Node_2(part.WhiteBefore, part.WhiteAfter, part.Range, _Node_1, part.Entity);
    } else {
      throw new Error("reconstructChain: Unexpected node in call chain");
    }
  }, newNodes.head, newNodes.tail);
  var newCode = trim(formatSingleExpression(newBody), "both");
  var newCode_1 = state.Code.substr(0, body.Range.Start) + newCode + state.Code.substr(body.Range.End + 1);
  return new LiveState(state.Globals, newCode_1, state.Program, state.Mapper, state.Location, state.Selection, state.State, state.CurrentPreview);
}
export function createChainNodes(args, name) {
  var node = function node(nd) {
    return node_3(new _Range(0, 0), nd);
  };

  var mem = node(new Expr("Member", [node(new Expr("Empty", [])), node(new Expr("Variable", [node(new Name(name))]))]));

  if (args != null) {
    var args_1 = map(function (a) {
      return new Argument(null, node(a));
    }, args);
    return ofArray([mem, node(new Expr("Call", [mem, node(args_1)]))]);
  } else {
    return ofArray([mem]);
  }
}
export function getWhiteBeforeAndAfterSections(firstNode, sections) {
  var dominantWhite = function dominantWhite(whites) {
    var whites_1 = toList(toList(countBy(function (x) {
      return x;
    }, whites)));
    return reduce(function (f) {
      return function (x, y) {
        return f(x) > f(y) ? x : y;
      };
    }(function (tupledArg) {
      return tupledArg[0] === "" ? 0 : tupledArg[1];
    }), new List(["", 0], whites_1))[0];
  };

  var patternInput = [dominantWhite(function (list) {
    return map(function (nd) {
      return formatWhiteBeforeExpr(nd);
    }, list);
  }(map(function (sec) {
    return sec.Nodes.head;
  }, sections))), dominantWhite(function (list_1) {
    return map(function (nd_1) {
      return formatWhiteAfterExpr(nd_1);
    }, list_1);
  }(append(ofArray([firstNode]), map(function (sec_1) {
    return last_1(sec_1.Nodes);
  }, sections))))];
  Log.trace("live", "Inserting whitespace before '%s' and after '%s' for sections: %O", patternInput[0], patternInput[1], sections);
  return [ofArray([new Token(new TokenKind("White", [patternInput[0]]), new _Range(0, 0))]), ofArray([new Token(new TokenKind("White", [patternInput[1]]), new _Range(0, 0))])];
}
export function insertWhiteAroundSection(before, after, section) {
  var lastIdx = section.Nodes.length - 1;
  return new PivotSection(section.Transformation, mapIndexed(function (i, node) {
    var node_1 = void 0;
    var matchValue = [before, node];
    var $var495 = matchValue[0] != null ? matchValue[1].Node.Case === "Member" ? function () {
      var n = matchValue[1].Node.Fields[1];
      var inst = matchValue[1].Node.Fields[0];
      var before_1 = matchValue[0];
      return i === 0;
    }() ? [0, matchValue[0], matchValue[1].Node.Fields[0], matchValue[1].Node.Fields[1]] : [1] : [1] : [1];

    switch ($var495[0]) {
      case 0:
        var _Node = new Expr("Member", [$var495[2], new _Node_2($var495[1], $var495[3].WhiteAfter, $var495[3].Range, $var495[3].Node, $var495[3].Entity)]);

        node_1 = new _Node_2(node.WhiteBefore, node.WhiteAfter, node.Range, _Node, node.Entity);
        break;

      case 1:
        node_1 = node;
        break;
    }

    var node_2 = void 0;
    var matchValue_1 = [after, node_1];
    var $var496 = matchValue_1[0] != null ? function () {
      var after_1 = matchValue_1[0];
      return i === lastIdx;
    }() ? [0, matchValue_1[0], matchValue_1[1]] : [1] : [1];

    switch ($var496[0]) {
      case 0:
        node_2 = new _Node_2($var496[2].WhiteBefore, $var496[1], $var496[2].Range, $var496[2].Node, $var496[2].Entity);
        break;

      case 1:
        node_2 = node_1;
        break;
    }

    return node_2;
  }, section.Nodes));
}
export function updatePivotState(trigger, state, event) {
  var $var497 = event.Case === "UpdateLocation" ? [0] : event.Case === "InitializeGlobals" ? [1] : event.Case === "CustomEvent" ? [2] : [0];

  switch ($var497[0]) {
    case 0:
      return function (state_1) {
        return updateBody(trigger, state_1);
      }(hideMenus(state));

    case 1:
      return state;

    case 2:
      if (event.Fields[0].Case === "SwitchMenu") {
        return withPivotState(new PivotEditorState(state.State.Body, state.State.FirstNode, state.State.Preview, state.State.Sections, state.State.SelectedEntity, event.Fields[0].Fields[0], state.State.Focus), state);
      } else if (event.Fields[0].Case === "SelectChainElement") {
        return tryTransformChain(function (body) {
          return function (chain) {
            return function (sections) {
              var loop = function loop(before) {
                return function (chain_1) {
                  loop: while (true) {
                    var $var498 = chain_1.tail != null ? chain_1.head.Range.End + 1 < state.Location ? [0, chain_1.head, chain_1.tail] : [1] : [1];

                    switch ($var498[0]) {
                      case 0:
                        before = $var498[1];
                        chain_1 = $var498[2];
                        continue loop;

                      case 1:
                        if (chain_1.tail == null) {
                          return [before, before, before];
                        } else if (chain_1.tail.tail == null) {
                          return [before, chain_1.head, chain_1.head];
                        } else {
                          return [before, chain_1.head, chain_1.tail.head];
                        }

                    }
                  }
                };
              };

              var patternInput = loop(chain.head)(chain.tail);
              return selectName(event.Fields[0].Fields[0] < 0 ? patternInput[0] : event.Fields[0].Fields[0] > 0 ? patternInput[2] : patternInput[1], state);
            };
          };
        }, state);
      } else if (event.Fields[0].Case === "SelectRange") {
        return function () {
          var Selection = editorLocation(state.Mapper, event.Fields[0].Fields[0].Start, event.Fields[0].Fields[0].End + 1);
          return new LiveState(state.Globals, state.Code, state.Program, state.Mapper, state.Location, Selection, state.State, state.CurrentPreview);
        }();
      } else if (event.Fields[0].Case === "ReplaceRange") {
        Log.trace("live", "Replace '%s' with '%s'", state.Code.substr(event.Fields[0].Fields[0].Start, event.Fields[0].Fields[0].End - event.Fields[0].Fields[0].Start + 1), event.Fields[0].Fields[1]);
        var newCode = state.Code.substr(0, event.Fields[0].Fields[0].Start) + event.Fields[0].Fields[1] + state.Code.substr(event.Fields[0].Fields[0].End + 1);
        var location = editorLocation(new LocationMapper(newCode), event.Fields[0].Fields[0].Start, event.Fields[0].Fields[0].Start + event.Fields[0].Fields[1].length);
        return function () {
          var Selection_1 = location;
          return new LiveState(state.Globals, newCode, state.Program, state.Mapper, state.Location, Selection_1, state.State, state.CurrentPreview);
        }();
      } else if (event.Fields[0].Case === "AddElement") {
        return tryTransformChain(function (body_1) {
          return function (chain_2) {
            return function (sections_1) {
              var newNodes = collect_1(function (nd) {
                return !equals(nd.Entity.Symbol, event.Fields[0].Fields[0]) ? ofArray([nd]) : new List(nd, createChainNodes(event.Fields[0].Fields[2], marker));
              }, chain_2);
              return function (state_2) {
                return replaceAndSelectMarker(event.Fields[0].Fields[1], state_2);
              }(reconstructChain(state, body_1, newNodes));
            };
          };
        }, state);
      } else if (event.Fields[0].Case === "ReplaceElement") {
        return tryTransformChain(function (body_2) {
          return function (chain_3) {
            return function (sections_2) {
              var newNodes_1 = collect_1(function (nd_1) {
                return !equals(nd_1.Entity.Symbol, event.Fields[0].Fields[0]) ? ofArray([nd_1]) : createChainNodes(event.Fields[0].Fields[2], marker);
              }, chain_3);
              return function (state_3) {
                return replaceAndSelectMarker(event.Fields[0].Fields[1], state_3);
              }(reconstructChain(state, body_2, newNodes_1));
            };
          };
        }, state);
      } else if (event.Fields[0].Case === "RemoveElement") {
        return tryTransformChain(function (body_3) {
          return function (chain_4) {
            return function (sections_3) {
              var beforeDropped = tryLast(toList(takeWhile(function (nd_2) {
                return !equals(nd_2.Entity.Symbol, event.Fields[0].Fields[0]);
              }, chain_4)));
              var beforeDropped_1 = beforeDropped != null ? beforeDropped : chain_4.head;
              var newNodes_2 = filter(function (nd_3) {
                return !equals(nd_3.Entity.Symbol, event.Fields[0].Fields[0]);
              }, chain_4);
              return function (state_4) {
                return selectName(beforeDropped_1, state_4);
              }(reconstructChain(state, body_3, newNodes_2));
            };
          };
        }, state);
      } else if (event.Fields[0].Case === "RemoveSection") {
        return tryTransformChain(function (body_4) {
          return function (chain_5) {
            return function (sections_4) {
              var beforeDropped_2 = tryLast(toList(takeWhile(function (nd_4) {
                return !equals(nd_4.Entity.Symbol, event.Fields[0].Fields[0]);
              }, map(function (sec) {
                return sec.Nodes.head;
              }, sections_4))));
              var beforeDropped_3 = beforeDropped_2 != null ? beforeDropped_2 : chain_5.head;
              var newSections = filter(function (sec_1) {
                return !equals(sec_1.Nodes.head.Entity.Symbol, event.Fields[0].Fields[0]);
              }, sections_4);
              var newNodes_3 = collect_1(function (sec_2) {
                return sec_2.Nodes;
              }, newSections);
              return function (state_5) {
                return selectName(beforeDropped_3, state_5);
              }(reconstructChain(state, body_4, newNodes_3));
            };
          };
        }, state);
      } else if (event.Fields[0].Case === "AddTransform") {
        return tryTransformChain(function (body_5) {
          return function (chain_6) {
            return function (sections_5) {
              Log.trace("live", "Adding transform to chain: %O", _Array$from(chain_6));
              Log.trace("live", "Existing sections are: %O", _Array$from(sections_5));
              var patternInput_1 = getWhiteBeforeAndAfterSections(chain_6.head, sections_5);

              var node = function node(n) {
                return node_3(new _Range(0, 0), n);
              };

              var fields = tryPick(function (expr) {
                return pickPivotFields(expr);
              }, reverse(collect_1(function (s) {
                return s.Nodes;
              }, sections_5)));
              var patternInput_2 = void 0;
              var $var499 = event.Fields[0].Fields[0].Case === "Metadata" ? [0] : event.Fields[0].Fields[0].Case === "DropColumns" ? [1] : event.Fields[0].Fields[0].Case === "SortBy" ? [2] : event.Fields[0].Fields[0].Case === "FilterBy" ? [3] : event.Fields[0].Fields[0].Case === "WindowBy" ? [4] : event.Fields[0].Fields[0].Case === "ExpandBy" ? [5] : event.Fields[0].Fields[0].Case === "Paging" ? [6] : event.Fields[0].Fields[0].Case === "GetSeries" ? [7] : event.Fields[0].Fields[0].Case === "GetTheData" ? [8] : event.Fields[0].Fields[0].Case === "GroupBy" ? [9] : event.Fields[0].Fields[0].Case === "Empty" ? [10] : [0];

              switch ($var499[0]) {
                case 0:
                  throw new Error("Unexpected get range or metadata");
                  break;

                case 1:
                  patternInput_2 = ["drop columns", ofArray([marker, "then"])];
                  break;

                case 2:
                  patternInput_2 = ["sort data", ofArray([marker, "then"])];
                  break;

                case 3:
                  patternInput_2 = ["filter data", ofArray([marker, "then"])];
                  break;

                case 4:
                  patternInput_2 = ["windowing", ofArray([marker, "then"])];
                  break;

                case 5:
                  patternInput_2 = ["expanding", ofArray([marker, "then"])];
                  break;

                case 6:
                  patternInput_2 = ["paging", ofArray([marker, "then"])];
                  break;

                case 7:
                  patternInput_2 = ["get series", ofArray([marker])];
                  break;

                case 8:
                  patternInput_2 = ["get the data", ofArray([marker])];
                  break;

                case 9:
                  patternInput_2 = ["group data", function () {
                    var $var500 = fields != null ? fields.tail != null ? [0, fields.head] : [1] : [1];

                    switch ($var500[0]) {
                      case 0:
                        return ofArray([marker, "by " + $var500[1].Name, "then"]);

                      case 1:
                        return ofArray([marker, "by Property", "then"]);
                    }
                  }()];
                  break;

                case 10:
                  patternInput_2 = ["", new List()];
                  break;
              }

              var newSection = insertWhiteAroundSection(patternInput_1[0], patternInput_1[1], new PivotSection(event.Fields[0].Fields[0], collect_1(function () {
                var args = null;
                return function (name) {
                  return createChainNodes(args, name);
                };
              }(), patternInput_2[1])));

              var closeFirstSection = function closeFirstSection(_arg1) {
                if (_arg1.tail == null) {
                  return new List();
                } else {
                  var section = void 0;
                  var matchValue = [_arg1.head.Transformation, last_1(_arg1.head.Nodes)];
                  var $var501 = matchValue[0].Case === "Paging" ? matchValue[1].Node.Case === "Call" ? matchValue[1].Node.Fields[0].Node.Case === "Member" ? matchValue[1].Node.Fields[0].Node.Fields[1].Node.Case === "Variable" ? function () {
                    var n_2 = matchValue[1].Node.Fields[0].Node.Fields[1].Node.Fields[0];
                    return n_2.Node.Name === "take";
                  }() ? [0, matchValue[1].Node.Fields[0].Node.Fields[1].Node.Fields[0]] : [1] : [1] : [1] : [1] : [1];

                  switch ($var501[0]) {
                    case 0:
                      section = _arg1.head;
                      break;

                    case 1:
                      var $var502 = matchValue[1].Node.Case === "Member" ? matchValue[1].Node.Fields[1].Node.Case === "Variable" ? function () {
                        var n_1 = matchValue[1].Node.Fields[1].Node.Fields[0];
                        return n_1.Node.Name === "then";
                      }() ? [0, matchValue[1].Node.Fields[1].Node.Fields[0]] : [1] : [1] : [1];

                      switch ($var502[0]) {
                        case 0:
                          section = _arg1.head;
                          break;

                        case 1:
                          if (matchValue[0].Case === "Empty") {
                            section = _arg1.head;
                          } else {
                            var Nodes = append(_arg1.head.Nodes, createChainNodes(null, "then"));
                            section = new PivotSection(_arg1.head.Transformation, Nodes);
                          }

                          break;
                      }

                      break;
                  }

                  return new List(insertWhiteAroundSection(null, patternInput_1[1], section), _arg1.tail);
                }
              };

              var newSections_1 = void 0;
              var matchValue_1 = reverse(sections_5);
              var $var503 = matchValue_1.tail != null ? matchValue_1.head.Transformation.Case === "GetSeries" ? [0, matchValue_1.head, matchValue_1.tail] : matchValue_1.head.Transformation.Case === "GetTheData" ? [0, matchValue_1.head, matchValue_1.tail] : [1, matchValue_1] : [1, matchValue_1];

              switch ($var503[0]) {
                case 0:
                  newSections_1 = reverse(ofArray([$var503[1], newSection], closeFirstSection($var503[2])));
                  break;

                case 1:
                  newSections_1 = reverse(new List(newSection, closeFirstSection($var503[1])));
                  break;
              }

              Log.trace("live", "Inserted section: %O", _Array$from(newSections_1));
              var newNodes_4 = collect_1(function (sec_3) {
                return sec_3.Nodes;
              }, newSections_1);
              return function (state_6) {
                return replaceAndSelectMarker(patternInput_2[0], state_6);
              }(reconstructChain(state, body_5, newNodes_4));
            };
          };
        }, state);
      } else {
        return withPivotState(new PivotEditorState(state.State.Body, state.State.FirstNode, event.Fields[0].Fields[0], state.State.Sections, state.State.SelectedEntity, state.State.Menus, state.State.Focus), state);
      }

  }
}
export function renderNodeList(trigger, nodes) {
  return toList(delay(function () {
    return collect(function (nd) {
      var $var504 = nd.Node.Case === "Member" ? nd.Node.Fields[1].Node.Case === "Variable" ? function () {
        var n = nd.Node.Fields[1].Node.Fields[0];
        return n.Node.Name !== "then";
      }() ? [0, nd.Node.Fields[1].Node.Fields[0]] : [1] : [1] : [1];

      switch ($var504[0]) {
        case 0:
          return singleton(function (arg0) {
            return function (arg1) {
              return El.op_Dynamic(arg0, arg1);
            };
          }(h)("span")(new List())(ofArray([function (arg0_1) {
            return function (arg1_1) {
              return El.op_Dynamic(arg0_1, arg1_1);
            };
          }(h)("a")(ofArray([op_EqualsBangGreater("click", trigger(new PivotEditorAction("SelectRange", [$var504[1].Range])))]))(ofArray([text($var504[1].Node.Name)])), function (arg0_2) {
            return function (arg1_2) {
              return El.op_Dynamic(arg0_2, arg1_2);
            };
          }(h)("a")(ofArray([op_EqualsBangGreater("click", trigger(new PivotEditorAction("RemoveElement", [nd.Entity.Symbol])))]))(ofArray([function (arg0_3) {
            return function (arg1_3) {
              return El.op_Dynamic(arg0_3, arg1_3);
            };
          }(h)("i")(ofArray([op_EqualsGreater("class", "gfa gfa-times")]))(new List())]))])));

        case 1:
          return empty();
      }
    }, nodes);
  }));
}
export function renderContextMenu(trigger) {
  return function (arg0) {
    return function (arg1) {
      return El.op_Dynamic(arg0, arg1);
    };
  }(h)("a")(ofArray([op_EqualsGreater("class", "right"), op_EqualsBangGreater("click", trigger(new PivotEditorAction("SwitchMenu", [new PivotEditorMenus("ContextualDropdownOpen", [])])))]))(ofArray([function (arg0_1) {
    return function (arg1_1) {
      return El.op_Dynamic(arg0_1, arg1_1);
    };
  }(h)("i")(ofArray([op_EqualsGreater("class", "gfa gfa-plus")]))(new List())]));
}
export function renderAddPropertyMenu(trigger, f, nodes) {
  return toList(delay(function () {
    var lastNode = find(function (_arg1) {
      var $var505 = _arg1.Node.Case === "Member" ? _arg1.Node.Fields[1].Node.Case === "Variable" ? [0, _arg1.Node.Fields[1].Node.Fields[0]] : [1] : [1];

      switch ($var505[0]) {
        case 0:
          return $var505[1].Node.Name !== "then";

        case 1:
          return true;
      }
    }, reverse(nodes));
    var matchValue = lastNode.Entity.Type;
    var $var506 = matchValue != null ? matchValue.Case === "Object" ? [0, matchValue.Fields[0]] : [1] : [1];

    switch ($var506[0]) {
      case 0:
        var members = sortWith(function (x, y) {
          return compare(x, y);
        }, choose_1(function (m) {
          return f(m.Name) ? m.Name : null;
        }, $var506[1].Members));
        return singleton(function (arg0) {
          return function (arg1) {
            return El.op_Dynamic(arg0, arg1);
          };
        }(h)("ul")(new List())(toList(delay(function () {
          return map_1(function (n) {
            return function (arg0_1) {
              return function (arg1_1) {
                return El.op_Dynamic(arg0_1, arg1_1);
              };
            }(h)("li")(new List())(ofArray([function (arg0_2) {
              return function (arg1_2) {
                return El.op_Dynamic(arg0_2, arg1_2);
              };
            }(h)("a")(ofArray([op_EqualsBangGreater("click", trigger(new PivotEditorAction("AddElement", [lastNode.Entity.Symbol, n, null])))]))(ofArray([text(n)]))]));
          }, members);
        }))));

      case 1:
        return empty();
    }
  }));
}
export function renderSection(triggerEvent, section) {
  var trigger = function trigger(action) {
    return function (_arg1) {
      return function (e) {
        e.cancelBubble = true;
        triggerEvent(new LiveEvent("CustomEvent", [action]));
      };
    };
  };

  var triggerWith = function triggerWith(f) {
    return function (el) {
      return function (e_1) {
        e_1.cancelBubble = true;
        triggerEvent(new LiveEvent("CustomEvent", [f(el)]));
      };
    };
  };

  var getNodeNameAndSymbol = function getNodeNameAndSymbol(_arg1_1) {
    var $var507 = _arg1_1 != null ? _arg1_1.Node.Case === "Member" ? _arg1_1.Node.Fields[1].Node.Case === "Variable" ? _arg1_1.Entity != null ? [0, _arg1_1.Entity, _arg1_1.Node.Fields[1].Node.Fields[0]] : [1] : [1] : [1] : [1];

    switch ($var507[0]) {
      case 0:
        return [$var507[2].Node.Name, $var507[1].Symbol];

      case 1:
        return ["", null];
    }
  };

  return toList(delay(function () {
    var $var508 = section != null ? section.Transformation.Case === "GetSeries" ? [0, section.Nodes] : section.Transformation.Case === "GroupBy" ? [1, section.Nodes] : section.Transformation.Case === "Paging" ? [2, section.Nodes] : section.Transformation.Case === "SortBy" ? [3, section.Nodes] : section.Transformation.Case === "DropColumns" ? [4, section.Nodes] : [5] : [5];

    switch ($var508[0]) {
      case 0:
        var patternInput = void 0;

        if ($var508[1].tail != null) {
          if ($var508[1].tail.tail != null) {
            if ($var508[1].tail.tail.tail != null) {
              patternInput = [$var508[1].head, $var508[1].tail.head, $var508[1].tail.tail.head];
            } else {
              patternInput = [$var508[1].head, $var508[1].tail.head, null];
            }
          } else {
            patternInput = [$var508[1].head, null, null];
          }
        } else {
          throw new Error("No get series node in get series transformation");
        }

        var patternInput_1 = getNodeNameAndSymbol(patternInput[1]);
        var patternInput_2 = getNodeNameAndSymbol(patternInput[2]);
        return append_1(function () {
          var matchValue = patternInput[0].Entity.Type;
          var $var509 = matchValue != null ? matchValue.Case === "Object" ? [0, matchValue.Fields[0]] : [1] : [1];

          switch ($var509[0]) {
            case 0:
              return append_1(singleton(function (arg0) {
                return function (arg1) {
                  return El.op_Dynamic(arg0, arg1);
                };
              }(h)("span")(new List())(ofArray([text("with key")]))), delay(function () {
                return singleton(function (arg0_1) {
                  return function (arg1_1) {
                    return El.op_Dynamic(arg0_1, arg1_1);
                  };
                }(h)("select")(ofArray([op_EqualsBangGreater("change", triggerWith(function (el_1) {
                  return patternInput_1[1] != null ? new PivotEditorAction("ReplaceElement", [patternInput_1[1], el_1.value, null]) : new PivotEditorAction("AddElement", [patternInput[0].Entity.Symbol, el_1.value, null]);
                }))]))(toList(delay(function () {
                  return append_1(patternInput_1[0] === "" ? singleton(function (arg0_2) {
                    return function (arg1_2) {
                      return El.op_Dynamic(arg0_2, arg1_2);
                    };
                  }(h)("option")(ofArray([op_EqualsGreater("value", ""), op_EqualsGreater("selected", "selected")]))(ofArray([text("")]))) : empty(), delay(function () {
                    return collect(function (m) {
                      return m.Name.indexOf("with key") === 0 ? singleton(function (arg0_3) {
                        return function (arg1_3) {
                          return El.op_Dynamic(arg0_3, arg1_3);
                        };
                      }(h)("option")(toList(delay(function () {
                        return append_1(singleton(op_EqualsGreater("value", m.Name)), delay(function () {
                          return patternInput_1[0] === m.Name ? singleton(op_EqualsGreater("selected", "selected")) : empty();
                        }));
                      })))(ofArray([text(replace(m.Name, "with key ", ""))]))) : empty();
                    }, $var509[1].Members);
                  }));
                }))));
              }));

            case 1:
              return empty();
          }
        }(), delay(function () {
          var $var510 = patternInput[1] != null ? patternInput[1].Entity != null ? patternInput[1].Entity.Type != null ? patternInput[1].Entity.Type.Case === "Object" ? [0, patternInput[1].Entity, patternInput[1].Entity.Type.Fields[0]] : [1] : [1] : [1] : [1];

          switch ($var510[0]) {
            case 0:
              return append_1(singleton(function (arg0_4) {
                return function (arg1_4) {
                  return El.op_Dynamic(arg0_4, arg1_4);
                };
              }(h)("span")(new List())(ofArray([text("and value")]))), delay(function () {
                return singleton(function (arg0_5) {
                  return function (arg1_5) {
                    return El.op_Dynamic(arg0_5, arg1_5);
                  };
                }(h)("select")(ofArray([op_EqualsBangGreater("change", triggerWith(function (el_2) {
                  return patternInput_2[1] != null ? new PivotEditorAction("ReplaceElement", [patternInput_2[1], el_2.value, null]) : new PivotEditorAction("AddElement", [$var510[1].Symbol, el_2.value, null]);
                }))]))(toList(delay(function () {
                  return append_1(patternInput_2[0] === "" ? singleton(function (arg0_6) {
                    return function (arg1_6) {
                      return El.op_Dynamic(arg0_6, arg1_6);
                    };
                  }(h)("option")(ofArray([op_EqualsGreater("value", ""), op_EqualsGreater("selected", "selected")]))(ofArray([text("")]))) : empty(), delay(function () {
                    return collect(function (m_1) {
                      return m_1.Name.indexOf("and value") === 0 ? singleton(function (arg0_7) {
                        return function (arg1_7) {
                          return El.op_Dynamic(arg0_7, arg1_7);
                        };
                      }(h)("option")(toList(delay(function () {
                        return append_1(singleton(op_EqualsGreater("value", m_1.Name)), delay(function () {
                          return patternInput_2[0] === m_1.Name ? singleton(op_EqualsGreater("selected", "selected")) : empty();
                        }));
                      })))(ofArray([text(replace(m_1.Name, "and value ", ""))]))) : empty();
                    }, $var510[2].Members);
                  }));
                }))));
              }));

            case 1:
              return empty();
          }
        }));

      case 1:
        var patternInput_3 = void 0;

        if ($var508[1].tail != null) {
          if ($var508[1].tail.tail != null) {
            patternInput_3 = [$var508[1].head, $var508[1].tail.head, $var508[1].tail.tail];
          } else {
            patternInput_3 = [$var508[1].head, null, new List()];
          }
        } else {
          throw new Error("No group by node in group by transformation");
        }

        var patternInput_4 = getNodeNameAndSymbol(patternInput_3[1]);
        return append_1(function () {
          var matchValue_1 = patternInput_3[0].Entity.Type;
          var $var511 = matchValue_1 != null ? matchValue_1.Case === "Object" ? [0, matchValue_1.Fields[0]] : [1] : [1];

          switch ($var511[0]) {
            case 0:
              return singleton(function (arg0_8) {
                return function (arg1_8) {
                  return El.op_Dynamic(arg0_8, arg1_8);
                };
              }(h)("select")(ofArray([op_EqualsBangGreater("change", triggerWith(function (el_3) {
                return patternInput_4[1] != null ? new PivotEditorAction("ReplaceElement", [patternInput_4[1], el_3.value, null]) : new PivotEditorAction("AddElement", [patternInput_3[0].Entity.Symbol, el_3.value, null]);
              }))]))(toList(delay(function () {
                return append_1(patternInput_4[0] === "" ? singleton(function (arg0_9) {
                  return function (arg1_9) {
                    return El.op_Dynamic(arg0_9, arg1_9);
                  };
                }(h)("option")(ofArray([op_EqualsGreater("value", ""), op_EqualsGreater("selected", "selected")]))(ofArray([text("")]))) : empty(), delay(function () {
                  return collect(function (m_2) {
                    return m_2.Name.indexOf("by") === 0 ? singleton(function (arg0_10) {
                      return function (arg1_10) {
                        return El.op_Dynamic(arg0_10, arg1_10);
                      };
                    }(h)("option")(toList(delay(function () {
                      return append_1(singleton(op_EqualsGreater("value", m_2.Name)), delay(function () {
                        return patternInput_4[0] === m_2.Name ? singleton(op_EqualsGreater("selected", "selected")) : empty();
                      }));
                    })))(ofArray([text(m_2.Name)]))) : empty();
                  }, $var511[1].Members);
                }));
              }))));

            case 1:
              return empty();
          }
        }(), delay(function () {
          return append_1(renderNodeList(trigger, patternInput_3[2]), delay(function () {
            return singleton(renderContextMenu(trigger));
          }));
        }));

      case 2:
        var methods = create(map(function (_arg35) {
          var $var512 = _arg35.Node.Case === "Member" ? _arg35.Node.Fields[1].Node.Case === "Variable" ? [0, _arg35.Node.Fields[1].Node.Fields[0]] : [1] : [1];

          switch ($var512[0]) {
            case 0:
              return $var512[1].Node.Name;

            case 1:
              return "";
          }
        }, $var508[1]), new GenericComparer(compare));
        return append_1(collect(function (nd) {
          var $var513 = nd.Node.Case === "Call" ? nd.Node.Fields[0].Node.Case === "Member" ? nd.Node.Fields[0].Node.Fields[1].Node.Case === "Variable" ? nd.Node.Fields[1].Node.tail != null ? nd.Node.Fields[1].Node.tail.tail == null ? [0, nd.Node.Fields[1].Node.head, nd.Node.Fields[0].Node.Fields[1].Node.Fields[0]] : [1] : [1] : [1] : [1] : [1];

          switch ($var513[0]) {
            case 0:
              var removeOp = $var513[2].Node.Name === "take" ? new PivotEditorAction("ReplaceElement", [nd.Entity.Symbol, "then", null]) : new PivotEditorAction("RemoveElement", [nd.Entity.Symbol]);
              return singleton(function (arg0_11) {
                return function (arg1_11) {
                  return El.op_Dynamic(arg0_11, arg1_11);
                };
              }(h)("span")(new List())(ofArray([function (arg0_12) {
                return function (arg1_12) {
                  return El.op_Dynamic(arg0_12, arg1_12);
                };
              }(h)("a")(ofArray([op_EqualsBangGreater("click", trigger(new PivotEditorAction("SelectRange", [$var513[2].Range])))]))(ofArray([text($var513[2].Node.Name)])), function (arg0_13) {
                return function (arg1_13) {
                  return El.op_Dynamic(arg0_13, arg1_13);
                };
              }(h)("input")(ofArray([op_EqualsGreater("id", "input-pg-" + $var513[2].Node.Name), op_EqualsBangGreater("input", function (el_4) {
                return function (_arg2) {
                  var input = el_4;
                  var patternInput_5 = parseProgram(input.value);

                  if (patternInput_5[1].length === 0 ? patternInput_5[0].Body.Node.length === 1 : false) {
                    el_4.setCustomValidity("");
                    triggerEvent(new LiveEvent("CustomEvent", [new PivotEditorAction("ReplaceRange", [$var513[1].Value.Range, input.value])]));
                  } else {
                    el_4.setCustomValidity("Cannot parse expression");
                  }
                };
              }), op_EqualsGreater("value", formatSingleExpression($var513[1].Value))]))(new List()), function (arg0_14) {
                return function (arg1_14) {
                  return El.op_Dynamic(arg0_14, arg1_14);
                };
              }(h)("a")(ofArray([op_EqualsBangGreater("click", trigger(removeOp))]))(ofArray([function (arg0_15) {
                return function (arg1_15) {
                  return El.op_Dynamic(arg0_15, arg1_15);
                };
              }(h)("i")(ofArray([op_EqualsGreater("class", "gfa gfa-times")]))(new List())]))])));

            case 1:
              return empty();
          }
        }, $var508[1]), delay(function () {
          return !(methods.has("take") ? methods.has("skip") : false) ? singleton(renderContextMenu(trigger)) : empty();
        }));

      case 3:
        var props = choose(function (_arg51) {
          var $var514 = _arg51.Node.Case === "Member" ? _arg51.Node.Fields[1].Node.Case === "Variable" ? _arg51.Entity != null ? function () {
            var sym = _arg51.Entity.Symbol;
            var n = _arg51.Node.Fields[1].Node.Fields[0];

            if (n.Node.Name !== "then") {
              return n.Node.Name !== "sort data";
            } else {
              return false;
            }
          }() ? [0, _arg51.Node.Fields[1].Node.Fields[0], _arg51.Entity.Symbol] : [1] : [1] : [1] : [1];

          switch ($var514[0]) {
            case 0:
              return [$var514[2], $var514[1]];

            case 1:
              return null;
          }
        }, $var508[1]);
        var last = tryLast(props);
        return append_1(collect(function (matchValue_2) {
          return singleton(function (arg0_16) {
            return function (arg1_16) {
              return El.op_Dynamic(arg0_16, arg1_16);
            };
          }(h)("span")(new List())(toList(delay(function () {
            return append_1(singleton(function (arg0_17) {
              return function (arg1_17) {
                return El.op_Dynamic(arg0_17, arg1_17);
              };
            }(h)("a")(ofArray([op_EqualsBangGreater("click", trigger(new PivotEditorAction("SelectRange", [matchValue_2[1].Range])))]))(ofArray([text(matchValue_2[1].Node.Name)]))), delay(function () {
              return matchValue_2[1].Node.Name === last[1].Node.Name ? singleton(function (arg0_18) {
                return function (arg1_18) {
                  return El.op_Dynamic(arg0_18, arg1_18);
                };
              }(h)("a")(ofArray([op_EqualsBangGreater("click", trigger(new PivotEditorAction("RemoveElement", [matchValue_2[0]])))]))(ofArray([function (arg0_19) {
                return function (arg1_19) {
                  return El.op_Dynamic(arg0_19, arg1_19);
                };
              }(h)("i")(ofArray([op_EqualsGreater("class", "gfa gfa-times")]))(new List())]))) : empty();
            }));
          }))));
        }, props), delay(function () {
          return singleton(renderContextMenu(trigger));
        }));

      case 4:
        return append_1(renderNodeList(trigger, $var508[1].tail), delay(function () {
          return singleton(renderContextMenu(trigger));
        }));

      case 5:
        return empty();
    }
  }));
}
export function renderPivot(triggerEvent, state) {
  var trigger = function trigger(action) {
    return function (_arg1) {
      return function (e) {
        e.cancelBubble = true;
        triggerEvent(new LiveEvent("CustomEvent", [action]));
      };
    };
  };

  var triggerWith = function triggerWith(f) {
    return function (el) {
      return function (e_1) {
        e_1.cancelBubble = true;
        triggerEvent(new LiveEvent("CustomEvent", [f(el)]));
      };
    };
  };

  var selSec = tryFind(function (sec) {
    return exists(function (secEnt) {
      return equals(state.State.SelectedEntity.Symbol, secEnt.Entity.Symbol);
    }, sec.Nodes);
  }, state.State.Sections);
  var firstNode = state.State.FirstNode;

  var dom = function (arg0) {
    return function (arg1) {
      return El.op_Dynamic(arg0, arg1);
    };
  }(h)("div")(toList(delay(function () {
    return append_1(singleton(op_EqualsGreater("class", "pivot-preview")), delay(function () {
      return !state.State.Menus.Equals(new PivotEditorMenus("Hidden", [])) ? singleton(op_EqualsBangGreater("click", trigger(new PivotEditorAction("SwitchMenu", [new PivotEditorMenus("Hidden", [])])))) : empty();
    }));
  })))(ofArray([function (arg0_1) {
    return function (arg1_1) {
      return El.op_Dynamic(arg0_1, arg1_1);
    };
  }(h)("ul")(ofArray([op_EqualsGreater("class", "tabs")]))(toList(delay(function () {
    return append_1(map_1(function (sec_1) {
      var selected = exists(function (secEnt_1) {
        return equals(state.State.SelectedEntity.Symbol, secEnt_1.Entity.Symbol);
      }, sec_1.Nodes);
      var secSymbol = sec_1.Nodes.head.Entity.Symbol;
      var identRange = void 0;
      var $var515 = sec_1.Nodes.tail != null ? sec_1.Nodes.head.Node.Case === "Variable" ? [0, sec_1.Nodes.head.Node.Fields[0]] : sec_1.Nodes.head.Node.Case === "Member" ? sec_1.Nodes.head.Node.Fields[1].Node.Case === "Variable" ? [0, sec_1.Nodes.head.Node.Fields[1].Node.Fields[0]] : [1] : sec_1.Nodes.head.Node.Case === "Call" ? sec_1.Nodes.head.Node.Fields[0].Node.Case === "Variable" ? [0, sec_1.Nodes.head.Node.Fields[0].Node.Fields[0]] : sec_1.Nodes.head.Node.Fields[0].Node.Case === "Member" ? sec_1.Nodes.head.Node.Fields[0].Node.Fields[1].Node.Case === "Variable" ? [0, sec_1.Nodes.head.Node.Fields[0].Node.Fields[1].Node.Fields[0]] : [1] : [1] : [1] : [1];

      switch ($var515[0]) {
        case 0:
          identRange = $var515[1].Range;
          break;

        case 1:
          throw new Error("Unexpected node in pivot call chain");
          break;
      }

      return function (arg0_2) {
        return function (arg1_2) {
          return El.op_Dynamic(arg0_2, arg1_2);
        };
      }(h)("li")(ofArray([op_EqualsGreater("class", selected ? "selected" : "")]))(toList(delay(function () {
        return sec_1.Transformation.Case === "Empty" ? singleton(function (arg0_3) {
          return function (arg1_3) {
            return El.op_Dynamic(arg0_3, arg1_3);
          };
        }(h)("a")(ofArray([op_EqualsBangGreater("click", trigger(new PivotEditorAction("SelectRange", [identRange])))]))(toList(delay(function () {
          return firstNode.Node.Case === "Variable" ? singleton(text(firstNode.Node.Fields[0].Node.Name)) : singleton(text("data"));
        })))) : append_1(singleton(function (arg0_4) {
          return function (arg1_4) {
            return El.op_Dynamic(arg0_4, arg1_4);
          };
        }(h)("a")(ofArray([op_EqualsBangGreater("click", trigger(new PivotEditorAction("SelectRange", [identRange])))]))(ofArray([text(transformName(sec_1.Transformation))]))), delay(function () {
          return singleton(function (arg0_5) {
            return function (arg1_5) {
              return El.op_Dynamic(arg0_5, arg1_5);
            };
          }(h)("a")(ofArray([op_EqualsBangGreater("click", trigger(new PivotEditorAction("RemoveSection", [secSymbol])))]))(ofArray([function (arg0_6) {
            return function (arg1_6) {
              return El.op_Dynamic(arg0_6, arg1_6);
            };
          }(h)("i")(ofArray([op_EqualsGreater("class", "gfa gfa-times")]))(new List())])));
        }));
      })));
    }, state.State.Sections), delay(function () {
      return singleton(function (arg0_7) {
        return function (arg1_7) {
          return El.op_Dynamic(arg0_7, arg1_7);
        };
      }(h)("li")(ofArray([op_EqualsGreater("class", state.State.Menus.Equals(new PivotEditorMenus("AddDropdownOpen", [])) ? "add selected" : "add")]))(ofArray([function (arg0_8) {
        return function (arg1_8) {
          return El.op_Dynamic(arg0_8, arg1_8);
        };
      }(h)("a")(ofArray([op_EqualsBangGreater("click", trigger(new PivotEditorAction("SwitchMenu", [new PivotEditorMenus("AddDropdownOpen", [])])))]))(ofArray([function (arg0_9) {
        return function (arg1_9) {
          return El.op_Dynamic(arg0_9, arg1_9);
        };
      }(h)("i")(ofArray([op_EqualsGreater("class", "gfa gfa-plus")]))(new List())]))])));
    }));
  }))), function (arg0_10) {
    return function (arg1_10) {
      return El.op_Dynamic(arg0_10, arg1_10);
    };
  }(h)("div")(ofArray([op_EqualsGreater("class", "add-menu")]))(toList(delay(function () {
    var clickHandler = function clickHandler(tfs) {
      return op_EqualsBangGreater("click", trigger(new PivotEditorAction("AddTransform", [tfs])));
    };

    if (state.State.Menus.Equals(new PivotEditorMenus("AddDropdownOpen", []))) {
      return singleton(function (arg0_11) {
        return function (arg1_11) {
          return El.op_Dynamic(arg0_11, arg1_11);
        };
      }(h)("ul")(new List())(toList(delay(function () {
        return append_1(singleton(function (arg0_12) {
          return function (arg1_12) {
            return El.op_Dynamic(arg0_12, arg1_12);
          };
        }(h)("li")(new List())(ofArray([function (arg0_13) {
          return function (arg1_13) {
            return El.op_Dynamic(arg0_13, arg1_13);
          };
        }(h)("a")(ofArray([clickHandler(new Transformation("DropColumns", [new List()]))]))(ofArray([text("drop columns")]))]))), delay(function () {
          return append_1(singleton(function (arg0_14) {
            return function (arg1_14) {
              return El.op_Dynamic(arg0_14, arg1_14);
            };
          }(h)("li")(new List())(ofArray([function (arg0_15) {
            return function (arg1_15) {
              return El.op_Dynamic(arg0_15, arg1_15);
            };
          }(h)("a")(ofArray([clickHandler(new Transformation("GroupBy", [new List(), new List()]))]))(ofArray([text("group by")]))]))), delay(function () {
            return append_1(singleton(function (arg0_16) {
              return function (arg1_16) {
                return El.op_Dynamic(arg0_16, arg1_16);
              };
            }(h)("li")(new List())(ofArray([function (arg0_17) {
              return function (arg1_17) {
                return El.op_Dynamic(arg0_17, arg1_17);
              };
            }(h)("a")(ofArray([clickHandler(new Transformation("Paging", [new List()]))]))(ofArray([text("paging")]))]))), delay(function () {
              return append_1(singleton(function (arg0_18) {
                return function (arg1_18) {
                  return El.op_Dynamic(arg0_18, arg1_18);
                };
              }(h)("li")(new List())(ofArray([function (arg0_19) {
                return function (arg1_19) {
                  return El.op_Dynamic(arg0_19, arg1_19);
                };
              }(h)("a")(ofArray([clickHandler(new Transformation("SortBy", [new List()]))]))(ofArray([text("sort by")]))]))), delay(function () {
                var getDataCalled = exists(function (_arg61) {
                  var $var516 = _arg61.Transformation.Case === "GetTheData" ? [0] : _arg61.Transformation.Case === "GetSeries" ? [0] : [1];

                  switch ($var516[0]) {
                    case 0:
                      return true;

                    case 1:
                      return false;
                  }
                }, state.State.Sections);

                if (!getDataCalled) {
                  return append_1(singleton(function (arg0_20) {
                    return function (arg1_20) {
                      return El.op_Dynamic(arg0_20, arg1_20);
                    };
                  }(h)("li")(new List())(ofArray([function (arg0_21) {
                    return function (arg1_21) {
                      return El.op_Dynamic(arg0_21, arg1_21);
                    };
                  }(h)("a")(ofArray([clickHandler(new Transformation("GetTheData", []))]))(ofArray([text("get the data")]))]))), delay(function () {
                    return singleton(function (arg0_22) {
                      return function (arg1_22) {
                        return El.op_Dynamic(arg0_22, arg1_22);
                      };
                    }(h)("li")(new List())(ofArray([function (arg0_23) {
                      return function (arg1_23) {
                        return El.op_Dynamic(arg0_23, arg1_23);
                      };
                    }(h)("a")(ofArray([clickHandler(new Transformation("GetSeries", ["!", "!"]))]))(ofArray([text("get series")]))])));
                  }));
                } else {
                  return empty();
                }
              }));
            }));
          }));
        }));
      }))));
    } else {
      return empty();
    }
  }))), function (arg0_24) {
    return function (arg1_24) {
      return El.op_Dynamic(arg0_24, arg1_24);
    };
  }(h)("div")(ofArray([op_EqualsGreater("class", "toolbar")]))(toList(delay(function () {
    return append_1(singleton(function (arg0_25) {
      return function (arg1_25) {
        return El.op_Dynamic(arg0_25, arg1_25);
      };
    }(h)("span")(ofArray([op_EqualsGreater("class", "navig")]))(ofArray([function (arg0_26) {
      return function (arg1_26) {
        return El.op_Dynamic(arg0_26, arg1_26);
      };
    }(h)("a")(new List())(ofArray([function (arg0_27) {
      return function (arg1_27) {
        return El.op_Dynamic(arg0_27, arg1_27);
      };
    }(h)("i")(ofArray([op_EqualsBangGreater("click", trigger(new PivotEditorAction("SelectChainElement", [-1]))), op_EqualsGreater("class", "gfa gfa-chevron-left")]))(new List())])), function (arg0_28) {
      return function (arg1_28) {
        return El.op_Dynamic(arg0_28, arg1_28);
      };
    }(h)("a")(new List())(ofArray([function (arg0_29) {
      return function (arg1_29) {
        return El.op_Dynamic(arg0_29, arg1_29);
      };
    }(h)("i")(ofArray([op_EqualsBangGreater("click", trigger(new PivotEditorAction("SelectChainElement", [0]))), op_EqualsGreater("class", "gfa gfa-circle")]))(new List())])), function (arg0_30) {
      return function (arg1_30) {
        return El.op_Dynamic(arg0_30, arg1_30);
      };
    }(h)("a")(new List())(ofArray([function (arg0_31) {
      return function (arg1_31) {
        return El.op_Dynamic(arg0_31, arg1_31);
      };
    }(h)("i")(ofArray([op_EqualsBangGreater("click", trigger(new PivotEditorAction("SelectChainElement", [1]))), op_EqualsGreater("class", "gfa gfa-chevron-right")]))(new List())]))]))), delay(function () {
      return renderSection(triggerEvent, selSec);
    }));
  }))), function (arg0_32) {
    return function (arg1_32) {
      return El.op_Dynamic(arg0_32, arg1_32);
    };
  }(h)("div")(ofArray([op_EqualsGreater("class", "add-menu")]))(toList(delay(function () {
    var matchValue = [state.State.Menus, selSec];
    var $var517 = matchValue[0].Case === "ContextualDropdownOpen" ? matchValue[1] != null ? matchValue[1].Transformation.Case === "Paging" ? [0, matchValue[1].Nodes] : matchValue[1].Transformation.Case === "GroupBy" ? [1, matchValue[1].Nodes] : matchValue[1].Transformation.Case === "SortBy" ? [2, matchValue[1].Nodes] : matchValue[1].Transformation.Case === "DropColumns" ? [3, matchValue[1].Nodes] : [4] : [4] : [4];

    switch ($var517[0]) {
      case 0:
        var methods = new _Map(choose(function (_arg101) {
          var $var518 = _arg101.Node.Case === "Member" ? _arg101.Node.Fields[1].Node.Case === "Variable" ? [0, _arg101.Entity, _arg101.Node.Fields[1].Node.Fields[0]] : [1] : [1];

          switch ($var518[0]) {
            case 0:
              return [$var518[2].Node.Name, $var518[1].Symbol];

            case 1:
              return null;
          }
        }, $var517[1]));
        var lastSym = last_1($var517[1]).Entity.Symbol;
        var firstSym = $var517[1].head.Entity.Symbol;
        return singleton(function (arg0_33) {
          return function (arg1_33) {
            return El.op_Dynamic(arg0_33, arg1_33);
          };
        }(h)("ul")(new List())(toList(delay(function () {
          return append_1(!methods.has("take") ? function () {
            var op = methods.has("then") ? new PivotEditorAction("ReplaceElement", [methods.get("then"), "take", ofArray([new Expr("Number", [10])])]) : new PivotEditorAction("AddElement", [lastSym, "take", ofArray([new Expr("Number", [10])])]);
            return singleton(function (arg0_34) {
              return function (arg1_34) {
                return El.op_Dynamic(arg0_34, arg1_34);
              };
            }(h)("li")(new List())(ofArray([function (arg0_35) {
              return function (arg1_35) {
                return El.op_Dynamic(arg0_35, arg1_35);
              };
            }(h)("a")(ofArray([op_EqualsBangGreater("click", trigger(op))]))(ofArray([text("take")]))])));
          }() : empty(), delay(function () {
            if (!methods.has("skip")) {
              var op_1 = new PivotEditorAction("AddElement", [firstSym, "skip", ofArray([new Expr("Number", [10])])]);
              return singleton(function (arg0_36) {
                return function (arg1_36) {
                  return El.op_Dynamic(arg0_36, arg1_36);
                };
              }(h)("li")(new List())(ofArray([function (arg0_37) {
                return function (arg1_37) {
                  return El.op_Dynamic(arg0_37, arg1_37);
                };
              }(h)("a")(ofArray([op_EqualsBangGreater("click", trigger(op_1))]))(ofArray([text("skip")]))])));
            } else {
              return empty();
            }
          }));
        }))));

      case 1:
        return renderAddPropertyMenu(trigger, function (n) {
          return (n !== "then" ? n !== "preview" : false) ? !(n.indexOf("and") === 0) : false;
        }, $var517[1]);

      case 2:
        return renderAddPropertyMenu(trigger, function (n_1) {
          return n_1 !== "then" ? n_1 !== "preview" : false;
        }, $var517[1]);

      case 3:
        return renderAddPropertyMenu(trigger, function (n_2) {
          return n_2 !== "then" ? n_2 !== "preview" : false;
        }, $var517[1]);

      case 4:
        return empty();
    }
  }))), function (arg0_38) {
    return function (arg1_38) {
      return El.op_Dynamic(arg0_38, arg1_38);
    };
  }(h)("div")(ofArray([op_EqualsGreater("class", "preview-body")]))(toList(delay(function () {
    return singleton(state.State.Preview);
  })))]));

  var patternInput = state.Mapper.AbsoluteToLineCol(state.State.Body.Range.End);
  return new LiveEditorZone(patternInput[0], dom);
}
export var preview = new LivePreview("Pivot", function (trigger) {
  return function (state) {
    return function (event) {
      return updatePivotState(trigger, state, event);
    };
  };
}, function (triggerEvent) {
  return function (state_1) {
    return renderPivot(triggerEvent, state_1);
  };
}, function () {
  var Body = node_3(new _Range(0, 0), new Expr("Empty", []));
  var FirstNode = node_3(new _Range(0, 0), new Expr("Empty", []));
  var SelectedEntity = null;
  return new PivotEditorState(Body, FirstNode, text("not created"), new List(), SelectedEntity, new PivotEditorMenus("Hidden", []), null);
}());
//# sourceMappingURL=pivot.js.map