import _Symbol2 from "babel-runtime/core-js/symbol";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { singleton, delay, toList, sortWith, tryPick, tryFind } from "fable-core/Seq";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { text, op_EqualsGreater, h, El, DomNode } from "../../libraries/html";
import { compare, equals, Interface } from "fable-core/Util";
import { Log } from "../../libraries/common";
import { LivePreview, LiveEditorZone, LiveState, collectFirstChain } from "./live";
import { evaluate } from "../analyzer/interpreter";
import { ofArray } from "fable-core/List";
import List from "fable-core/List";
import { Name } from "../ast/ast";
import { pickMetaByType, $7C$FindMember$7C$_$7C$ as _FindMember___ } from "../ast/astops";
export function commandAtLocation(loc, program) {
  return tryFind(function (cmd) {
    return cmd.Range.Start <= loc ? cmd.Range.End + 1 >= loc : false;
  }, program.Body.Node);
}
export var ShowableEditorState = function () {
  function ShowableEditorState(endLocation, preview, previewSymbol, previewID) {
    _classCallCheck(this, ShowableEditorState);

    this.EndLocation = endLocation;
    this.Preview = preview;
    this.PreviewSymbol = previewSymbol;
    this.PreviewID = previewID;
  }

  _createClass(ShowableEditorState, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Live.Showable.ShowableEditorState",
        interfaces: ["FSharpRecord"],
        properties: {
          EndLocation: "number",
          Preview: DomNode,
          PreviewSymbol: Interface("TheGamma.Common.Symbol"),
          PreviewID: "number"
        }
      };
    }
  }]);

  return ShowableEditorState;
}();
setType("TheGamma.Live.Showable.ShowableEditorState", ShowableEditorState);

function _HasShow___(_arg1) {
  if (_arg1.Case === "Object") {
    var hasShow = _arg1.Fields[0].Members.some(function (_arg2) {
      var $var546 = _arg2.Name === "show" ? _arg2.Type.Case === "Method" ? _arg2.Type.Fields[0].tail != null ? _arg2.Type.Fields[0].head.Type.Case === "Primitive" ? _arg2.Type.Fields[0].head.Type.Fields[0].Case === "String" ? _arg2.Type.Fields[0].tail.tail == null ? [0] : [1] : [1] : [1] : [1] : [1] : [1];

      switch ($var546[0]) {
        case 0:
          return true;

        case 1:
          return false;
      }
    });

    if (hasShow) {
      return {};
    } else {
      return null;
    }
  } else {
    return null;
  }
}

export { _HasShow___ as $7C$HasShow$7C$_$7C$ };
export function updateBody(trigger, state) {
  Log.trace("live", "Showable - updating body");
  var matchValue = commandAtLocation(state.Location, state.Program);
  var $var547 = matchValue != null ? matchValue.Node.Case === "Expr" ? matchValue.Entity != null ? matchValue.Entity.Kind.Case === "RunCommand" ? [0, matchValue, matchValue.Node.Fields[0], matchValue.Entity.Kind.Fields[0]] : [1] : [1] : matchValue.Entity != null ? matchValue.Entity.Kind.Case === "LetCommand" ? [0, matchValue, matchValue.Node.Fields[1], matchValue.Entity.Kind.Fields[1]] : [1] : [1] : [1];

  switch ($var547[0]) {
    case 0:
      var chain = collectFirstChain($var547[2]);
      var matchValue_1 = [$var547[3].Type, chain];

      var activePatternResult8378 = _HasShow___(matchValue_1[0]);

      if (activePatternResult8378 != null) {
        var matchValue_2 = evaluate(state.Globals, $var547[3]);

        if (matchValue_2 != null) {
          var id = !equals($var547[3].Symbol, state.State.PreviewSymbol) ? state.State.PreviewID + 1 : state.State.PreviewID;

          var placeholder = function (arg0) {
            return function (arg1) {
              return El.op_Dynamic(arg0, arg1);
            };
          }(h)("div")(ofArray([op_EqualsGreater("class", "placeholder")]))(ofArray([text("Loading preview...")]));

          var dom = function (arg0_1) {
            return function (arg1_1) {
              return El.op_Dynamic(arg0_1, arg1_1);
            };
          }(h)("div")(new List())(ofArray([function (arg00) {
            return function (arg10) {
              return function (arg20) {
                return h.delayed(arg00, arg10, arg20);
              };
            };
          }(String(id))(placeholder)(function (id_1) {
            Log.trace("live", "Show: %O", matchValue_2.Value);
            matchValue_2.Value.show(id_1);
          })]));

          return function () {
            var State = new ShowableEditorState($var547[1].Range.End, dom, $var547[3].Symbol, id);
            return new LiveState(state.Globals, state.Code, state.Program, state.Mapper, state.Location, state.Selection, State, state.CurrentPreview);
          }();
        } else {
          return null;
        }
      } else if (matchValue_1[1] != null) {
        var chain_1 = matchValue_1[1];
        return tryPick(function (tupledArg) {
          var nm = new Name("preview");
          var matchValue_3 = tupledArg[1].Entity.Type;
          var $var548 = void 0;

          if (matchValue_3 != null) {
            if (matchValue_3.Case === "Object") {
              var activePatternResult8376 = function (obj) {
                return _FindMember___(nm, obj);
              }(matchValue_3.Fields[0]);

              if (activePatternResult8376 != null) {
                $var548 = [0, activePatternResult8376];
              } else {
                $var548 = [1];
              }
            } else {
              $var548 = [1];
            }
          } else {
            $var548 = [1];
          }

          switch ($var548[0]) {
            case 0:
              var matchValue_4 = pickMetaByType("http://schema.org", "WebPage", $var548[1].Metadata);

              if (matchValue_4 != null) {
                var url = matchValue_4["url"];

                var dom_1 = function (arg0_2) {
                  return function (arg1_2) {
                    return El.op_Dynamic(arg0_2, arg1_2);
                  };
                }(h)("iframe")(ofArray([op_EqualsGreater("src", url)]))(new List());

                var id_2 = state.State.PreviewID + 1;
                return function () {
                  var State_1 = new ShowableEditorState($var547[1].Range.End, dom_1, $var547[3].Symbol, id_2);
                  return new LiveState(state.Globals, state.Code, state.Program, state.Mapper, state.Location, state.Selection, State_1, state.CurrentPreview);
                }();
              } else {
                return null;
              }

            case 1:
              return null;
          }
        }, sortWith(function (x, y) {
          return -compare(function (tuple) {
            return tuple[0];
          }(x), function (tuple) {
            return tuple[0];
          }(y));
        }, chain_1.Chain));
      } else {
        return null;
      }

    case 1:
      return null;
  }
}
export function updateShowableState(trigger, state, event) {
  var $var549 = event.Case === "UpdateLocation" ? [0] : event.Case === "InitializeGlobals" ? [1] : event.Case === "CustomEvent" ? [1] : [0];

  switch ($var549[0]) {
    case 0:
      return function (state_1) {
        return updateBody(trigger, state_1);
      }(state);

    case 1:
      return state;
  }
}
export function renderShowable(trigger, state) {
  var patternInput = state.Mapper.AbsoluteToLineCol(state.State.EndLocation);

  var dom = function (arg0) {
    return function (arg1) {
      return El.op_Dynamic(arg0, arg1);
    };
  }(h)("div")(ofArray([op_EqualsGreater("class", "pivot-preview")]))(ofArray([function (arg0_1) {
    return function (arg1_1) {
      return El.op_Dynamic(arg0_1, arg1_1);
    };
  }(h)("ul")(ofArray([op_EqualsGreater("class", "tabs")]))(ofArray([function (arg0_2) {
    return function (arg1_2) {
      return El.op_Dynamic(arg0_2, arg1_2);
    };
  }(h)("li")(ofArray([op_EqualsGreater("class", "selected")]))(ofArray([function (arg0_3) {
    return function (arg1_3) {
      return El.op_Dynamic(arg0_3, arg1_3);
    };
  }(h)("a")(new List())(ofArray([text("preview")]))]))])), function (arg0_4) {
    return function (arg1_4) {
      return El.op_Dynamic(arg0_4, arg1_4);
    };
  }(h)("div")(ofArray([op_EqualsGreater("class", "preview-body")]))(toList(delay(function () {
    return singleton(state.State.Preview);
  })))]));

  return new LiveEditorZone(patternInput[0], dom);
}
export var preview = new LivePreview("Showable", function (trigger) {
  return function (state) {
    return function (event) {
      return updateShowableState(trigger, state, event);
    };
  };
}, function (trigger_1) {
  return function (state_1) {
    return renderShowable(trigger_1, state_1);
  };
}, function () {
  var PreviewID = 0;

  var PreviewSymbol = _Symbol2();

  return new ShowableEditorState(0, text("not created"), PreviewSymbol, PreviewID);
}());
//# sourceMappingURL=showable.js.map