import _Object$keys from "babel-runtime/core-js/object/keys";
import _Array$from from "babel-runtime/core-js/array/from";
import _Symbol2 from "babel-runtime/core-js/symbol";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
export { _evaluate as evaluate };
import { Log, Async$2E$StartAsNamedFuture$2E$Static as Async_StartAsNamedFuture_Static } from "../libraries/common";
import { tryFind, create } from "fable-core/Map";
import GenericComparer from "fable-core/GenericComparer";
import { equals, defaultArg, hasInterface, createObj, compareRecords, Option, equalsRecords, Interface, compare } from "fable-core/Util";
import { split, fsFormat } from "fable-core/String";
import { concat, sortWith, empty, map as map_1, tryPick, choose, singleton, append, delay, toList } from "fable-core/Seq";
import { ProvidedType } from "./providers/providers";
import { Node as _Node, Program, Command, EntityKind, Entity, Name, Argument, Expr, Range as _Range, Emitter, Type } from "./ast/ast";
import { map, ofArray, choose as choose_1 } from "fable-core/List";
import List from "fable-core/List";
import { globalEntity } from "./analyzer/interpreter";
import { singleton as singleton_1 } from "fable-core/AsyncBuilder";
import { provideRestType } from "./providers/rest";
import { makePivotExpression, providePivotType } from "./providers/pivot";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { PreviewService, CheckingService } from "./services";
import { Entity$2E$get_Antecedents as Entity_get_Antecedents, node as node_1 } from "./ast/astops";
import { compile } from "./codegen/codegen";
import { series } from "../libraries/series";
import { convertSequence, convertTupleSequence, trimLeft, RuntimeContext } from "./codegen/runtime";
import { chart } from "../libraries/google/charts";
import { placeholder, table } from "../libraries/tables";
import { date } from "../libraries/general";
import { youguess } from "../libraries/interactive";
import { preview } from "./live/pivot";
import { preview as preview_1 } from "./live/showable";
import Choice from "fable-core/Choice";
import { parallel, startImmediate } from "fable-core/Async";
import { add } from "fable-core/Observable";
import { createBlockEditor } from "./blocks";
import { createMonacoEditor } from "./monaco";
import { provideFSharpTypes } from "./providers/fsharp";
export function buildGlobalsTable(provideTypes) {
  return function (arg00) {
    return function (arg10) {
      return Async_StartAsNamedFuture_Static(arg00, arg10);
    };
  }("buildGlobalsTable")(function (builder_) {
    return builder_.Delay(function () {
      var named = create(null, new GenericComparer(compare));

      var lookupNamed = function lookupNamed(n) {
        var matchValue = tryFind(n, named);

        if (matchValue == null) {
          Log.error("typechecker", "Could not find named type '%s'", n);
          throw new Error(fsFormat("Could not find named type '%s'")(function (x) {
            return x;
          })(n));
        } else {
          return matchValue;
        }
      };

      return builder_.Bind(provideTypes(lookupNamed), function (_arg1) {
        var allTypes = toList(delay(function () {
          return append(singleton(new ProvidedType("NamedType", ["value", new Type("Any", [])])), delay(function () {
            return append(singleton(new ProvidedType("NamedType", ["object", new Type("Any", [])])), delay(function () {
              return append(singleton(new ProvidedType("NamedType", ["seq", new Type("Any", [])])), delay(function () {
                return append(singleton(new ProvidedType("NamedType", ["async", new Type("Any", [])])), delay(function () {
                  return _arg1;
                }));
              }));
            }));
          }));
        }));
        named = create(choose(function (_arg2) {
          return _arg2.Case === "NamedType" ? [_arg2.Fields[0], _arg2.Fields[1]] : null;
        }, allTypes), new GenericComparer(compare));
        var globalEntities = choose_1(function (_arg3) {
          return _arg3.Case === "GlobalValue" ? globalEntity(_arg3.Fields[0], _arg3.Fields[1], _arg3.Fields[3], _arg3.Fields[2]) : null;
        }, allTypes);
        return builder_.Return(globalEntities);
      });
    });
  }(singleton_1));
}
export function resolveProvider(lookup, ignoreFilter, kind, endpoint) {
  switch (kind) {
    case "rest":
      var matchValue = provideRestType(lookup, function (kind_1) {
        return function (endpoint_1) {
          return resolveProvider(lookup, ignoreFilter, kind_1, endpoint_1);
        };
      }, "anonymous", endpoint, "");

      if (matchValue.Case === "GlobalValue") {
        return [matchValue.Fields[3], new Emitter(function (_arg1) {
          return matchValue.Fields[2];
        })];
      } else {
        throw new Error("resolveProvider: Expected global value");
      }

    case "pivot":
      var pivotType = function (builder_) {
        return builder_.Delay(function () {
          return builder_.Bind(providePivotType(endpoint, ignoreFilter, "anonymous", lookup), function (_arg1_1) {
            return _arg1_1.Case === "GlobalValue" ? builder_.Return(_arg1_1.Fields[3]) : builder_.Return(function () {
              throw new Error("resolveProvider: Expected global value");
            }());
          });
        });
      }(singleton_1);

      return [new Type("Delayed", [function (arg00) {
        return function (arg10) {
          return Async_StartAsNamedFuture_Static(arg00, arg10);
        };
      }("pivotType:" + endpoint)(pivotType)]), new Emitter(function (_arg2) {
        return makePivotExpression(endpoint);
      })];

    default:
      Log.error("providers", "Cannot resolve provider '%s' (%s)", kind, endpoint);
      throw new Error("resolveProvider: Cannot resolve type provider");
  }
}
export var TheGammaProviders = function () {
  function TheGammaProviders(globals) {
    _classCallCheck(this, TheGammaProviders);

    this.globals = globals;
  }

  _createClass(TheGammaProviders, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Main.TheGammaProviders",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          globals: Interface("TheGamma.Common.Future")
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }]);

  return TheGammaProviders;
}();
setType("TheGamma.Main.TheGammaProviders", TheGammaProviders);
export var TheGammaContext = function () {
  function TheGammaContext(checkingService, providers) {
    _classCallCheck(this, TheGammaContext);

    this.checkingService = checkingService;
    this.providers = providers;
  }

  _createClass(TheGammaContext, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Main.TheGammaContext",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          checkingService: CheckingService,
          providers: TheGammaProviders
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }]);

  return TheGammaContext;
}();
setType("TheGamma.Main.TheGammaContext", TheGammaContext);
export function callShowMethod(outputId, cmd) {
  var $var578 = cmd.Node.Case === "Expr" ? cmd.Node.Fields[0].Entity != null ? cmd.Node.Fields[0].Entity.Type != null ? [0, cmd.Node.Fields[0], cmd.Node.Fields[0].Entity.Type] : [1] : [1] : [1];

  switch ($var578[0]) {
    case 0:
      if ($var578[2].Case === "Object") {
        var showTyp = tryPick(function (_arg1) {
          var $var579 = _arg1.Name === "show" ? _arg1.Type.Case === "Method" ? _arg1.Type.Fields[0].tail != null ? _arg1.Type.Fields[0].head.Type.Case === "Primitive" ? _arg1.Type.Fields[0].head.Type.Fields[0].Case === "String" ? _arg1.Type.Fields[0].tail.tail == null ? [0, _arg1.Type] : [1] : [1] : [1] : [1] : [1] : [1];

          switch ($var579[0]) {
            case 0:
              return $var579[1];

            case 1:
              return null;
          }
        }, $var578[2].Fields[0].Members);

        if (showTyp != null) {
          var rng = new _Range(cmd.Range.End, cmd.Range.End);
          var outExpr = node_1(rng, new Expr("String", [outputId]));
          var args = ofArray([new Argument(null, outExpr)]);

          var showMember = function (node) {
            return node_1(rng, node);
          }(new Expr("Member", [$var578[1], node_1(rng, new Expr("Variable", [node_1(rng, new Name("show"))]))]));

          var showEntity = new Entity(new EntityKind("Root", []), _Symbol2(), null, new List(), showTyp, new List());
          showMember.Entity = showEntity;
          var expr = node_1(rng, new Expr("Call", [showMember, node_1(rng, args)]));
          return node_1(cmd.Range, new Command("Expr", [expr]));
        } else {
          return cmd;
        }
      } else {
        return cmd;
      }

    case 1:
      return cmd;
  }
}

function _evaluate(ctx, code, outputId) {
  return function (builder_) {
    return builder_.Delay(function () {
      return builder_.Bind(ctx.checkingService.TypeCheck(code), function (_arg1) {
        var newBody = outputId != null ? map(function (cmd) {
          return callShowMethod(outputId, cmd);
        }, _arg1[2].Body.Node) : _arg1[2].Body.Node;
        var prog = new Program(new _Node(_arg1[2].Body.WhiteBefore, _arg1[2].Body.WhiteAfter, _arg1[2].Body.Range, newBody, _arg1[2].Body.Entity));
        return builder_.Bind(compile(ctx.providers.globals, code, prog), function (_arg2) {
          var s = series.create(function (builder__1) {
            return builder__1.Delay(function () {
              return builder__1.Return([]);
            });
          }(singleton_1), "", "", "");
          new RuntimeContext("lol", "", "troll");

          (function (c) {
            return function (s_1) {
              return trimLeft(c, s_1);
            };
          });

          (function (arg00) {
            return chart.bar(arg00);
          });

          (function (f) {
            return function (g) {
              return function (data) {
                return convertTupleSequence(f, g, data);
              };
            };
          });

          (function (f_1) {
            return function (data_1) {
              return convertSequence(f_1, data_1);
            };
          });

          table.create(s);
          date.now();
          series.values(new Int32Array([1]));
          placeholder.create("");

          (function (arg00_1) {
            return youguess.line(arg00_1);
          });

          Log.trace("interpreter", "Main evaluating: %O", _arg2);
          return builder_.Return(eval(_arg2));
        });
      });
    });
  }(singleton_1);
}

export var previews = ofArray([preview, preview_1]);
export var editorOptions = function () {
  function editorOptions(width, height, maxHeight, autoHeight, enablePreview, monacoOptions) {
    _classCallCheck(this, editorOptions);

    this.width = width;
    this.height = height;
    this.maxHeight = maxHeight;
    this.autoHeight = autoHeight;
    this.enablePreview = enablePreview;
    this.monacoOptions = monacoOptions;
  }

  _createClass(editorOptions, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Main.editorOptions",
        interfaces: ["FSharpRecord"],
        properties: {
          width: Option("number"),
          height: Option("number"),
          maxHeight: Option("number"),
          autoHeight: Option("boolean"),
          enablePreview: Option("boolean"),
          monacoOptions: Option("function")
        }
      };
    }
  }]);

  return editorOptions;
}();
setType("TheGamma.Main.editorOptions", editorOptions);
export var error = function () {
  function error(number, message, startLine, startColumn, endLine, endColumn) {
    _classCallCheck(this, error);

    this.number = number;
    this.message = message;
    this.startLine = startLine;
    this.startColumn = startColumn;
    this.endLine = endLine;
    this.endColumn = endColumn;
  }

  _createClass(error, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Main.error",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          number: "number",
          message: "string",
          startLine: "number",
          startColumn: "number",
          endLine: "number",
          endColumn: "number"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareRecords(this, other);
    }
  }]);

  return error;
}();
setType("TheGamma.Main.error", error);
export var defaultEditorOptions = function () {
  var width = null;
  var height = null;
  var maxHeight = null;
  var autoHeight = null;
  var monacoOptions = null;
  return new editorOptions(width, height, maxHeight, autoHeight, null, monacoOptions);
}();
export var thenable = function () {
  _createClass(thenable, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Main.thenable",
        properties: {}
      };
    }
  }]);

  function thenable(work) {
    var _this = this;

    _classCallCheck(this, thenable);

    this.resCell = new Choice("Choice1Of3", [null]);

    this.trigger = function () {};

    (function (arg00) {
      startImmediate(arg00);
    })(function (builder_) {
      return builder_.Delay(function () {
        return builder_.TryWith(builder_.Delay(function () {
          return builder_.Bind(work, function (_arg1) {
            _this.resCell = new Choice("Choice2Of3", [_arg1]);

            _this.trigger(null);

            return builder_.Zero();
          });
        }), function (_arg2) {
          _this.resCell = new Choice("Choice3Of3", [_arg2]);

          _this.trigger(null);

          return builder_.Zero();
        });
      });
    }(singleton_1));
  }

  _createClass(thenable, [{
    key: "then",
    value: function (onValue, onError) {
      var _this2 = this;

      this.trigger = function () {
        var matchValue = _this2.resCell;

        if (matchValue.Case === "Choice2Of3") {
          _this2.trigger = function () {};

          onValue(matchValue.Fields[0]);
        } else if (matchValue.Case === "Choice3Of3") {
          _this2.trigger = function () {};

          if (function () {
            return onError != null;
          }(null)) {
            onError(matchValue.Fields[0]);
          }
        }
      };

      this.trigger(null);
    }
  }]);

  return thenable;
}();
setType("TheGamma.Main.thenable", thenable);
export function serializeType(typ) {
  if (typ.Case === "Delayed") {
    return "delayed";
  } else if (typ.Case === "Primitive") {
    if (typ.Fields[0].Case === "Bool") {
      return "bool";
    } else if (typ.Fields[0].Case === "Date") {
      return "date";
    } else if (typ.Fields[0].Case === "Number") {
      return "number";
    } else if (typ.Fields[0].Case === "String") {
      return "string";
    } else {
      return "unit";
    }
  } else if (typ.Case === "Method") {
    return {
      kind: "function",
      arguments: _Array$from(map(function (ma) {
        return [ma.Name, ma.Optional, ma.Static, serializeType(ma.Type)];
      }, typ.Fields[0])),
      result: serializeType(typ.Fields[1](toList(delay(function () {
        return map_1(function (ma_1) {
          return [ma_1.Type, null];
        }, typ.Fields[0]);
      }))))
    };
  } else if (typ.Case === "List") {
    return {
      kind: "array",
      type: serializeType(typ.Fields[0])
    };
  } else if (typ.Case === "Object") {
    return createObj(toList(delay(function () {
      return append(singleton(["kind", "object"]), delay(function () {
        return append(hasInterface(typ.Fields[0], "TheGamma.TypeProviders.FSharpProvider.GenericType") ? singleton(["generics", _Array$from(map_1(function (typ_1) {
          return serializeType(typ_1);
        }, typ.Fields[0].TypeArguments))]) : function () {
          return empty();
        }(), delay(function () {
          return singleton(["members", typ.Fields[0].Members.map(function (m) {
            return m.Name;
          })]);
        }));
      }));
    })));
  } else {
    return "any";
  }
}
export function serializeEntity(rng, ent) {
  var patternInput = ent.Kind.Case === "Program" ? ["program", new List()] : ent.Kind.Case === "RunCommand" ? ["do", new List()] : ent.Kind.Case === "LetCommand" ? ["let", new List()] : ent.Kind.Case === "Operator" ? ["operator", new List()] : ent.Kind.Case === "List" ? ["list", new List()] : ent.Kind.Case === "Constant" ? ["constant", new List()] : ent.Kind.Case === "Function" ? ["function", new List()] : ent.Kind.Case === "GlobalValue" ? ["global", new List()] : ent.Kind.Case === "Variable" ? ["variable", new List()] : ent.Kind.Case === "Binding" ? ["binding", new List()] : ent.Kind.Case === "ArgumentList" ? ["args", new List()] : ent.Kind.Case === "CallSite" ? ["callsite", new List()] : ent.Kind.Case === "Member" ? ["member", new List()] : ent.Kind.Case === "MemberAccess" ? ["access", new List()] : ent.Kind.Case === "MemberName" ? ["name", ofArray([["name", ent.Kind.Fields[0].Name]])] : ent.Kind.Case === "NamedParam" ? ["param", ofArray([["name", ent.Kind.Fields[0].Name]])] : ent.Kind.Case === "Placeholder" ? ["placeholder", ofArray([["name", ent.Kind.Fields[0].Name]])] : ent.Kind.Case === "Call" ? ["call", new List()] : ["root", new List()];
  return createObj(toList(delay(function () {
    return append(singleton(["kind", patternInput[0]]), delay(function () {
      return append(function () {
        return rng != null;
      }(null) ? singleton(["range", {
        start: rng.Start,
        end: rng.End
      }]) : empty(), delay(function () {
        return append(singleton(["getChildren", function () {
          return _Array$from(Entity_get_Antecedents.bind(ent)()).map(function () {
            var rng_1 = null;
            return function (ent_1) {
              return serializeEntity(rng_1, ent_1);
            };
          }());
        }]), delay(function () {
          return append(singleton(["type", function () {
            var matchValue = ent.Type;

            if (matchValue != null) {
              return serializeType(matchValue);
            } else {
              return "unknown";
            }
          }()]), delay(function () {
            return patternInput[1];
          }));
        }));
      }));
    }));
  })));
}
export var checkingResult = function () {
  _createClass(checkingResult, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Main.checkingResult",
        properties: {
          wellTyped: "boolean"
        }
      };
    }
  }]);

  function checkingResult(_wellTyped, _bindingResult, _program) {
    _classCallCheck(this, checkingResult);

    this._wellTyped = _wellTyped;
    this._bindingResult = _bindingResult;
  }

  _createClass(checkingResult, [{
    key: "getEntities",
    value: function () {
      return this._bindingResult.Entities.map(function (tupledArg) {
        return serializeEntity(tupledArg[0], tupledArg[1]);
      });
    }
  }, {
    key: "wellTyped",
    get: function () {
      return this._wellTyped;
    }
  }]);

  return checkingResult;
}();
setType("TheGamma.Main.checkingResult", checkingResult);
export var editor = function () {
  _createClass(editor, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Main.editor",
        properties: {}
      };
    }
  }]);

  function editor(ed) {
    _classCallCheck(this, editor);

    this.ed = ed;
  }

  _createClass(editor, [{
    key: "getMonacoEditor",
    value: function () {
      return this.ed;
    }
  }, {
    key: "getValue",
    value: function () {
      return this.ed.getModel().getValue(1, false);
    }
  }, {
    key: "setValue",
    value: function (text) {
      this.ed.getModel().setValue(text);
    }
  }]);

  return editor;
}();
setType("TheGamma.Main.editor", editor);
export var gamma = function () {
  _createClass(gamma, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Main.gamma",
        properties: {}
      };
    }
  }]);

  function gamma(ctx) {
    _classCallCheck(this, gamma);

    this.ctx = ctx;
  }

  _createClass(gamma, [{
    key: "check",
    value: function (code) {
      var _this3 = this;

      return new thenable(function (builder_) {
        return builder_.Delay(function () {
          return builder_.Bind(_this3.ctx.checkingService.TypeCheck(code), function (_arg1) {
            return builder_.Return(function (tupledArg) {
              return new checkingResult(tupledArg[0], tupledArg[1], tupledArg[2]);
            }(_arg1));
          });
        });
      }(singleton_1));
    }
  }, {
    key: "evaluate",
    value: function (code, outputId) {
      var _this4 = this;

      return new thenable(function (builder_) {
        return builder_.Delay(function () {
          return builder_.TryWith(builder_.Delay(function () {
            return builder_.ReturnFrom(_evaluate(_this4.ctx, code, outputId));
          }), function (_arg2) {
            Log.exn("api", "Evaluating code '%O' failed with error '%O'.", code, _arg2);
            return builder_.ReturnFrom(function () {
              throw _arg2;
            }());
          });
        });
      }(singleton_1));
    }
  }, {
    key: "errorsReported",
    value: function (f) {
      add(function (tupledArg) {
        f(_Array$from(sortWith(function (x, y) {
          return compare(function (e_1) {
            return e_1.Range.Start;
          }(x), function (e_1) {
            return e_1.Range.Start;
          }(y));
        }, tupledArg[1])).map(function (e) {
          return new error(e.Number, e.Message, e.Range.Start.Line, e.Range.Start.Column, e.Range.End.Line, e.Range.End.Column);
        }));
      }, this.ctx.checkingService.ErrorsReported);
    }
  }, {
    key: "createBlocks",
    value: function (id) {
      createBlockEditor(this.ctx.checkingService, this.ctx.providers.globals, id);
    }
  }, {
    key: "createEditor",
    value: function (id, source, options) {
      var lineHeight = 20;
      var options_1 = options != null ? options : defaultEditorOptions;
      var el = document.getElementById(id);
      var width = defaultArg(options_1.width, el.clientWidth);
      var height = defaultArg(options_1.height, el.clientHeight);
      var maxHeight = defaultArg(options_1.maxHeight, 2147483647);
      var ed = createMonacoEditor(id, source, this.ctx.checkingService, function (opts) {
        opts.fontSize = 15;
        opts.lineHeight = 20;
        defaultArg(options_1.monacoOptions, function (value) {
          value;
        })(opts);
        var matchValue = opts.lineHeight;

        if (matchValue != null) {
          lineHeight = matchValue;
        }
      });
      var dim = {};
      dim.width = width;
      dim.height = height;
      ed.layout(dim);
      var previewService = defaultArg(options_1.enablePreview, true) ? new PreviewService(this.ctx.checkingService, this.ctx.providers.globals, ed, previews) : null;
      var lastHeight = -1;

      var autosizeEditor = function autosizeEditor() {
        var text = ed.getModel().getValue(1, false);
        var lines = 1 + split(text, "\n").length;
        var zoneHeight = previewService != null ? previewService.ZoneHeight : 0;
        var height_1 = maxHeight < (200 > lines * 20 + zoneHeight ? 200 : lines * 20 + zoneHeight) ? maxHeight : 200 > lines * 20 + zoneHeight ? 200 : lines * 20 + zoneHeight;

        if (height_1 !== lastHeight) {
          lastHeight = height_1;
          var dim_1 = {};
          dim_1.width = width;
          dim_1.height = height_1;
          ed.layout(dim_1);
          el.style.height = String(dim_1.height) + "px";
          el.style.width = String(dim_1.width) + "px";
        }
      };

      if (equals(options_1.autoHeight, true)) {
        ed.getModel().onDidChangeContent(function (_arg1) {
          autosizeEditor(null);
        });

        if (previewService != null) {
          add(function () {
            autosizeEditor(null);
          }, previewService.ZoneSizeChanged);
        }

        autosizeEditor(null);
      }

      return new editor(ed);
    }
  }], [{
    key: "createContext",
    value: function (providers) {
      var checkingSvc = new CheckingService("", providers.globals);
      return new gamma(new TheGammaContext(checkingSvc, providers));
    }
  }]);

  return gamma;
}();
setType("TheGamma.Main.gamma", gamma);
export var providers = function () {
  function providers() {
    _classCallCheck(this, providers);
  }

  _createClass(providers, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Main.providers",
        properties: {}
      };
    }
  }], [{
    key: "createProviders",
    value: function (providers_1) {
      var globals = buildGlobalsTable(function (lookup) {
        return function (builder_) {
          return builder_.Delay(function () {
            var providers_2 = function (o) {
              return _Object$keys(o).map(function (k) {
                return {
                  "key": k,
                  "value": o[k]
                };
              });
            }(providers_1).map(function (kv) {
              return kv.value(kv.key)(lookup);
            });

            return builder_.Bind(parallel(providers_2), function (_arg1) {
              return builder_.Return(concat(_arg1));
            });
          });
        }(singleton_1);
      });
      return new TheGammaProviders(globals);
    }
  }, {
    key: "rest",
    value: function (url, cookies, ignoreFilter) {
      return function (name) {
        return function (lookup) {
          return function (builder_) {
            return builder_.Delay(function () {
              var provider = provideRestType(lookup, function () {
                var ignoreFilter_1 = ignoreFilter != null ? ignoreFilter : false;
                return function (kind) {
                  return function (endpoint) {
                    return resolveProvider(lookup, ignoreFilter_1, kind, endpoint);
                  };
                };
              }(), name, url, cookies != null ? cookies : "");
              return builder_.Return(ofArray([provider]));
            });
          }(singleton_1);
        };
      };
    }
  }, {
    key: "library",
    value: function (url) {
      return function (_arg3) {
        return function (lookup) {
          return provideFSharpTypes(lookup, url);
        };
      };
    }
  }, {
    key: "pivot",
    value: function (url, ignoreFilter) {
      return function (name) {
        return function (lookup) {
          return function (builder_) {
            return builder_.Delay(function () {
              return builder_.Bind(providePivotType(url, ignoreFilter != null ? ignoreFilter : false, name, lookup), function (_arg2) {
                return builder_.Return(ofArray([_arg2]));
              });
            });
          }(singleton_1);
        };
      };
    }
  }]);

  return providers;
}();
setType("TheGamma.Main.providers", providers);
//# sourceMappingURL=main.js.map