import _typeof from "babel-runtime/helpers/typeof";
import _Array$from from "babel-runtime/core-js/array/from";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { toString, equals, Tuple, Option, compareUnions, equalsUnions, equalsRecords, makeGeneric, Array as _Array } from "fable-core/Util";
import { Program, Command, TokenKind, Argument, Operator, Expr, Name, Node as _Node, Range as _Range, Error as _Error, Token } from "../ast/ast";
import { reduce, fold, toList } from "fable-core/Seq";
import { map, ofArray, reverse, append } from "fable-core/List";
import List from "fable-core/List";
import { unionRanges } from "../ast/astops";
import { Parser } from "../ast/errors";
import Choice from "fable-core/Choice";
import { Log } from "../../libraries/common";
import { tokenize } from "./tokenizer";
export var ParsingContext = function () {
    function ParsingContext(tokens, whitespace, errors, silentMode, position) {
        _classCallCheck(this, ParsingContext);

        this.Tokens = tokens;
        this.Whitespace = whitespace;
        this.Errors = errors;
        this.SilentMode = silentMode;
        this.Position = position;
    }

    _createClass(ParsingContext, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.Parser.ParsingContext",
                interfaces: ["FSharpRecord", "System.IEquatable"],
                properties: {
                    Tokens: _Array(Token),
                    Whitespace: _Array(Token),
                    Errors: _Array(makeGeneric(_Error, {
                        Range: _Range
                    })),
                    SilentMode: "boolean",
                    Position: "number"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }]);

    return ParsingContext;
}();
setType("TheGamma.Parser.ParsingContext", ParsingContext);
export var Context = function (__exports) {
    var clone = __exports.clone = function (ctx) {
        var Whitespace = _Array$from(ctx.Whitespace);

        var Errors = _Array$from(ctx.Errors);

        var Position = ctx.Position;
        return new ParsingContext(ctx.Tokens, Whitespace, Errors, ctx.SilentMode, Position);
    };

    var next = __exports.next = function (ctx) {
        ctx.Position = ctx.Position + 1;
    };

    var error = __exports.error = function (ctx, e) {
        if (!ctx.SilentMode) {
            ctx.Errors.push(e);
        }
    };

    var silent = __exports.silent = function (ctx, f) {
        ctx.SilentMode = true;
        var res = f(ctx);
        ctx.SilentMode = false;
        return res;
    };

    var tokenIndent = __exports.tokenIndent = function (ctx) {
        tokenIndent: while (true) {
            var matchValue = ctx.Tokens[ctx.Position];
            var $var329 = matchValue.Token.Case === "Newline" ? [0] : matchValue.Token.Case === "Error" ? [1, matchValue] : matchValue.Token.Case === "White" ? [1, matchValue] : [2];

            switch ($var329[0]) {
                case 0:
                    var matchValue_1 = ctx.Tokens[ctx.Position + 1];

                    if (matchValue_1.Token.Case === "White") {
                        var s = matchValue_1.Token.Fields[0];
                        next(ctx);
                        next(ctx);
                        ctx.Whitespace.push(matchValue);
                        ctx.Whitespace.push(matchValue_1);
                        ctx = ctx;
                        continue tokenIndent;
                    } else {
                        return null;
                    }

                case 1:
                    ctx.Whitespace.push($var329[1]);
                    next(ctx);
                    ctx = ctx;
                    continue tokenIndent;

                case 2:
                    var white = toList(ctx.Whitespace);
                    ctx.Whitespace.splice(0);
                    return [white, matchValue];
            }
        }
    };

    var tokenNonIndent = __exports.tokenNonIndent = function (ctx) {
        var matchValue = ctx.Tokens[ctx.Position];
        var $var330 = matchValue.Token.Case === "Newline" ? [0, matchValue] : matchValue.Token.Case === "White" ? ctx.Position === 0 ? [1] : [2] : [2];

        switch ($var330[0]) {
            case 0:
                var newNonEmptyLinePos = ctx.Position;
                var i = ctx.Position;

                while (i < ctx.Tokens.length) {
                    var matchValue_1 = ctx.Tokens[i].Token;

                    if (matchValue_1.Case === "Newline") {
                        newNonEmptyLinePos = i;
                        i = i + 1;
                    } else if (matchValue_1.Case === "White") {
                        i = i + 1;
                    } else {
                        i = ctx.Tokens.length;
                    }
                }

                ctx.Position = newNonEmptyLinePos;
                var matchValue_2 = ctx.Tokens[ctx.Position + 1];

                if (matchValue_2.Token.Case === "White") {
                    return null;
                } else {
                    next(ctx);
                    ctx.Whitespace.push($var330[1]);
                    var white = toList(ctx.Whitespace);
                    ctx.Whitespace.splice(0);
                    return [white, matchValue_2];
                }

            case 1:
                return null;

            case 2:
                if (ctx.Position === 0 ? true : ctx.Position === ctx.Tokens.length - 1) {
                    return [new List(), matchValue];
                } else {
                    return null;
                }

        }
    };

    return __exports;
}({});
export function node(rng, n) {
    return new _Node(new List(), new List(), rng, n, null);
}
export function whiteAfter(w, n) {
    var WhiteAfter = append(n.WhiteAfter, w);
    return new _Node(n.WhiteBefore, WhiteAfter, n.Range, n.Node, n.Entity);
}
export function whiteBefore(w, n) {
    return new _Node(append(w, n.WhiteBefore), n.WhiteAfter, n.Range, n.Node, n.Entity);
}

function _Identifier___(t_0, t_1) {
    var t = [t_0, t_1];
    var $var331 = t[1].Token.Case === "Ident" ? [0, t[1].Token.Fields[0], t[1].Range, t[0]] : t[1].Token.Case === "QIdent" ? [0, t[1].Token.Fields[0], t[1].Range, t[0]] : [1];

    switch ($var331[0]) {
        case 0:
            return function (n) {
                return whiteBefore($var331[3], n);
            }(node($var331[2], new Name($var331[1])));

        case 1:
            return null;
    }
}

export { _Identifier___ as $7C$Identifier$7C$_$7C$ };
export var Associativity = function () {
    function Associativity(caseName, fields) {
        _classCallCheck(this, Associativity);

        this.Case = caseName;
        this.Fields = fields;
    }

    _createClass(Associativity, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.Parser.Associativity",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    Left: [],
                    Right: []
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsUnions(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareUnions(this, other);
        }
    }]);

    return Associativity;
}();
setType("TheGamma.Parser.Associativity", Associativity);
export function precedence(_arg1) {
    var $var332 = _arg1.Case === "GreaterThan" ? [1] : _arg1.Case === "GreaterThanOrEqual" ? [1] : _arg1.Case === "LessThan" ? [1] : _arg1.Case === "LessThanOrEqual" ? [1] : _arg1.Case === "Plus" ? [2] : _arg1.Case === "Minus" ? [2] : _arg1.Case === "Modulo" ? [3] : _arg1.Case === "Multiply" ? [3] : _arg1.Case === "Divide" ? [3] : _arg1.Case === "Power" ? [4] : [0];

    switch ($var332[0]) {
        case 0:
            return [0, new Associativity("Left", [])];

        case 1:
            return [1, new Associativity("Left", [])];

        case 2:
            return [2, new Associativity("Left", [])];

        case 3:
            return [3, new Associativity("Left", [])];

        case 4:
            return [4, new Associativity("Right", [])];
    }
}
export var OpExpr = function () {
    function OpExpr(caseName, fields) {
        _classCallCheck(this, OpExpr);

        this.Case = caseName;
        this.Fields = fields;
    }

    _createClass(OpExpr, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "TheGamma.Parser.OpExpr",
                interfaces: ["FSharpUnion"],
                cases: {
                    OpExpr: [makeGeneric(_Node, {
                        T: Expr
                    }), Option(Tuple([makeGeneric(_Node, {
                        T: Operator
                    }), OpExpr]))]
                }
            };
        }
    }]);

    return OpExpr;
}();
setType("TheGamma.Parser.OpExpr", OpExpr);
export function precClimb(minPrec, _arg1) {
    var loop = function loop(result) {
        return function (next) {
            loop: while (true) {
                var $var333 = next != null ? function () {
                    var op = next[0];
                    var next_1 = next[1];
                    return precedence(op.Node)[0] >= minPrec;
                }() ? [0, next[1], next[0]] : [1] : [1];

                switch ($var333[0]) {
                    case 0:
                        var patternInput = precedence($var333[2].Node);
                        var nextMinPrec = patternInput[1].Equals(new Associativity("Left", [])) ? patternInput[0] + 1 : patternInput[0];
                        var patternInput_1 = precClimb(nextMinPrec, $var333[1]);
                        var result_1 = node(unionRanges(result.Range, patternInput_1[0].Range), new Expr("Binary", [result, $var333[2], patternInput_1[0]]));
                        result = result_1;
                        next = patternInput_1[1];
                        continue loop;

                    case 1:
                        return [result, next];
                }
            }
        };
    };

    return loop(_arg1.Fields[0])(_arg1.Fields[1]);
}
export function buildExpression(terms, term) {
    return precClimb(0, fold(function (oe, tupledArg) {
        return new OpExpr("OpExpr", [tupledArg[0], [tupledArg[1], oe]]);
    }, new OpExpr("OpExpr", [term, null]), terms))[0];
}
export function parseExpressionOrNamedParam(ctx) {
    var lookAheadCtx = Context.clone(ctx);
    var matchValue = Context.tokenIndent(lookAheadCtx);
    var $var334 = void 0;

    if (matchValue != null) {
        var activePatternResult6748 = _Identifier___(matchValue[0], matchValue[1]);

        if (activePatternResult6748 != null) {
            $var334 = [0, activePatternResult6748];
        } else {
            $var334 = [1];
        }
    } else {
        $var334 = [1];
    }

    switch ($var334[0]) {
        case 0:
            Context.next(lookAheadCtx);
            var matchValue_1 = Context.tokenIndent(lookAheadCtx);
            var $var335 = matchValue_1 != null ? matchValue_1[1].Token.Case === "Equals" ? [0, matchValue_1[1], matchValue_1[0]] : [1] : [1];

            switch ($var335[0]) {
                case 0:
                    Context.tokenIndent(ctx);
                    Context.next(ctx);
                    Context.tokenIndent(ctx);
                    Context.next(ctx);
                    var matchValue_2 = parseExpression(new List(), ctx);

                    if (matchValue_2 == null) {
                        (function (e) {
                            Context.error(ctx, e);
                        })(Parser.unexpectedTokenInArgList($var335[1].Range, $var335[1].Token));

                        return new Choice("Choice1Of2", [[whiteAfter($var335[2], $var334[1]), node(new _Range($var334[1].Range.End, $var334[1].Range.End), new Expr("Empty", []))]]);
                    } else {
                        return new Choice("Choice1Of2", [[whiteAfter($var335[2], $var334[1]), matchValue_2]]);
                    }

                case 1:
                    return new Choice("Choice2Of2", [parseExpression(new List(), ctx)]);
            }

        case 1:
            return new Choice("Choice2Of2", [parseExpression(new List(), ctx)]);
    }
}
export function parseCallArgList(afterComma, lastRng, acc, ctx) {
    var _loop = function _loop() {
        var patternInput = void 0;
        var matchValue = parseExpressionOrNamedParam(ctx);

        if (matchValue.Case === "Choice1Of2") {
            patternInput = [true, new List(new Argument(matchValue.Fields[0][0], matchValue.Fields[0][1]), acc)];
        } else if (matchValue.Fields[0] != null) {
            patternInput = [true, new List(new Argument(null, matchValue.Fields[0]), acc)];
        } else {
            patternInput = [false, acc];
        }

        var matchValue_1 = Context.tokenIndent(ctx);
        var $var336 = matchValue_1 != null ? matchValue_1[1].Token.Case === "RParen" ? [0, matchValue_1[1], matchValue_1[0]] : matchValue_1[1].Token.Case === "Comma" ? function () {
            var white = matchValue_1[0];
            var lastRng_1 = matchValue_1[1].Range;
            return patternInput[0];
        }() ? [1, matchValue_1[1].Range, matchValue_1[0]] : [2] : [2] : [2];

        switch ($var336[0]) {
            case 0:
                Context.next(ctx);

                if (afterComma ? !patternInput[0] : false) {
                    (function (e) {
                        Context.error(ctx, e);
                    })(Parser.unexpectedTokenInArgList(lastRng, new TokenKind("RParen", [])));
                }

                return {
                    v: [$var336[1].Range, $var336[2], reverse(patternInput[1])]
                };

            case 1:
                Context.next(ctx);
                afterComma = true;
                lastRng = $var336[1];
                acc = patternInput[1];
                ctx = ctx;
                return "continue|parseCallArgList";

            case 2:
                var $var337 = matchValue_1 != null ? function () {
                    var t = matchValue_1[1];
                    return !t.Token.Equals(new TokenKind("EndOfFile", []));
                }() ? [0, matchValue_1[1]] : [1] : [1];

                switch ($var337[0]) {
                    case 0:
                        Context.next(ctx);

                        (function (e_1) {
                            Context.error(ctx, e_1);
                        })(Parser.unexpectedTokenInArgList($var337[1].Range, $var337[1].Token));

                        return {
                            v: Context.silent(ctx, function (ctx_1) {
                                return parseCallArgList(afterComma, $var337[1].Range, patternInput[1], ctx_1);
                            })
                        };

                    case 1:
                        (function (e_2) {
                            Context.error(ctx, e_2);
                        })(Parser.unexpectedScopeEndInArgList(lastRng));

                        return {
                            v: [lastRng, new List(), reverse(patternInput[1])]
                        };
                }

        }
    };

    parseCallArgList: while (true) {
        var _ret = _loop();

        switch (_ret) {
            case "continue|parseCallArgList":
                continue parseCallArgList;

            default:
                if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;
        }
    }
}
export function parsePlaceholderRecovery(silent, lastTokRng, lastTokOpt, whiteAcc, ctx) {
    var _loop2 = function _loop2() {
        var matchValue = Context.tokenIndent(ctx);
        var $var338 = matchValue != null ? matchValue[1].Token.Case === "RSquare" ? [0, matchValue[1].Range, matchValue[0]] : function () {
            var white = matchValue[0];
            var t = matchValue[1];
            return !t.Token.Equals(new TokenKind("EndOfFile", []));
        }() ? [1, matchValue[1], matchValue[0]] : [2] : [2];

        switch ($var338[0]) {
            case 0:
                Context.next(ctx);

                if (!silent) {
                    (function (e) {
                        Context.error(ctx, e);
                    })(Parser.unexpectedEndOfPlaceholder($var338[1]));
                }

                return {
                    v: [$var338[1], append(whiteAcc, $var338[2])]
                };

            case 1:
                Context.next(ctx);

                if (!silent) {
                    (function (e_1) {
                        Context.error(ctx, e_1);
                    })(Parser.unexpectedTokenInPlaceholder($var338[1].Range, $var338[1].Token));
                }

                silent = true;
                lastTokRng = $var338[1].Range;
                lastTokOpt = $var338[1].Token;
                whiteAcc = append(whiteAcc, append($var338[2], ofArray([$var338[1]])));
                ctx = ctx;
                return "continue|parsePlaceholderRecovery";

            case 2:
                if (!silent) {
                    (function (e_2) {
                        Context.error(ctx, e_2);
                    })(Parser.unexpectedScopeEndInPlaceholder(lastTokRng, lastTokOpt));
                }

                return {
                    v: [lastTokRng, whiteAcc]
                };
        }
    };

    parsePlaceholderRecovery: while (true) {
        var _ret2 = _loop2();

        switch (_ret2) {
            case "continue|parsePlaceholderRecovery":
                continue parsePlaceholderRecovery;

            default:
                if ((typeof _ret2 === "undefined" ? "undefined" : _typeof(_ret2)) === "object") return _ret2.v;
        }
    }
}
export function parsePlaceholder(rngLSQuare, ctx) {
    var matchValue = Context.tokenIndent(ctx);
    var $var339 = void 0;

    if (matchValue != null) {
        var activePatternResult6760 = _Identifier___(matchValue[0], matchValue[1]);

        if (activePatternResult6760 != null) {
            $var339 = [0, activePatternResult6760, matchValue[1]];
        } else {
            $var339 = [1];
        }
    } else {
        $var339 = [1];
    }

    switch ($var339[0]) {
        case 0:
            Context.next(ctx);

            var _matchValue_ = Context.tokenIndent(ctx);

            var $var340 = _matchValue_ != null ? _matchValue_[1].Token.Case === "Colon" ? [0, _matchValue_[1].Range, _matchValue_[0]] : [1] : [1];

            switch ($var340[0]) {
                case 0:
                    Context.next(ctx);
                    var matchValue_2 = parseExpression(new List(), ctx);

                    if (matchValue_2 != null) {
                        var matchValue_3 = Context.tokenIndent(ctx);
                        var $var341 = matchValue_3 != null ? matchValue_3[1].Token.Case === "RSquare" ? [0, matchValue_3[1].Range, matchValue_3[0]] : [1] : [1];

                        switch ($var341[0]) {
                            case 0:
                                Context.next(ctx);
                                return [$var341[1], new Expr("Placeholder", [whiteAfter($var340[2], $var339[1]), whiteAfter($var341[2], matchValue_2)])];

                            case 1:
                                var _patternInput = parsePlaceholderRecovery(false, matchValue_2.Range, null, new List(), ctx);

                                return [_patternInput[0], new Expr("Placeholder", [$var339[1], whiteAfter(_patternInput[1], matchValue_2)])];
                        }
                    } else {
                        var patternInput_1 = parsePlaceholderRecovery(false, $var340[1], new TokenKind("Colon", []), new List(), ctx);
                        return [patternInput_1[0], new Expr("Placeholder", [$var339[1], whiteAfter(patternInput_1[1], node(patternInput_1[0], new Expr("Empty", [])))])];
                    }

                case 1:
                    var patternInput_2 = parsePlaceholderRecovery(false, $var339[1].Range, $var339[2].Token, new List(), ctx);
                    return [patternInput_2[0], new Expr("Placeholder", [$var339[1], whiteAfter(patternInput_2[1], node(patternInput_2[0], new Expr("Empty", [])))])];
            }

        case 1:
            var patternInput_3 = parsePlaceholderRecovery(false, rngLSQuare, new TokenKind("LSquare", []), new List(), ctx);
            return [patternInput_3[0], new Expr("Placeholder", [node(rngLSQuare, new Name("")), whiteAfter(patternInput_3[1], node(patternInput_3[0], new Expr("Empty", [])))])];
    }
}
export function parseIdentAfterDot(body, prevDotRng, prevDotTok, ctx) {
    var matchValue = Context.tokenIndent(ctx);
    var $var342 = void 0;

    if (matchValue != null) {
        var activePatternResult6763 = _Identifier___(matchValue[0], matchValue[1]);

        if (activePatternResult6763 != null) {
            $var342 = [0, activePatternResult6763];
        } else {
            $var342 = [1];
        }
    } else {
        $var342 = [1];
    }

    switch ($var342[0]) {
        case 0:
            Context.next(ctx);
            var body_1 = node(unionRanges(body.Range, $var342[1].Range), new Expr("Member", [body, node($var342[1].Range, new Expr("Variable", [$var342[1]]))]));
            return parseCallOrMember(body_1, ctx);

        case 1:
            var $var343 = matchValue == null ? [1] : matchValue[1].Token.Case === "LSquare" ? [0, matchValue[1].Range, matchValue[0]] : matchValue[1].Token.Case === "EndOfFile" ? [1] : [2, matchValue[1], matchValue[0]];

            switch ($var343[0]) {
                case 0:
                    Context.next(ctx);

                    var _patternInput2 = parsePlaceholder($var343[1], ctx);

                    var body_2 = function (n) {
                        return whiteBefore($var343[2], n);
                    }(node(unionRanges($var343[1], _patternInput2[0]), new Expr("Member", [body, node(unionRanges(_patternInput2[0], $var343[1]), _patternInput2[1])])));

                    return parseCallOrMember(body_2, ctx);

                case 1:
                    (function (e) {
                        Context.error(ctx, e);
                    })(Parser.unexpectedScopeEndAfterDot(prevDotRng, prevDotTok));

                    var emptyRng = new _Range(prevDotRng.End + 1, prevDotRng.End);
                    return node(unionRanges(body.Range, emptyRng), new Expr("Member", [body, node(emptyRng, new Expr("Variable", [node(emptyRng, new Name(""))]))]));

                case 2:
                    Context.next(ctx);

                    (function (e_1) {
                        Context.error(ctx, e_1);
                    })(Parser.unexpectedTokenAfterDot($var343[1].Range, $var343[1].Token));

                    var emptyRng_1 = new _Range(prevDotRng.End + 1, prevDotRng.End);
                    var body_3 = node(unionRanges(body.Range, emptyRng_1), new Expr("Member", [body, node(emptyRng_1, new Expr("Variable", [node(emptyRng_1, new Name(""))]))]));
                    return Context.silent(ctx, function (ctx_1) {
                        return parseIdentAfterDot(body_3, prevDotRng, prevDotTok, ctx_1);
                    });
            }

    }
}
export function parseCallOrMember(body, ctx) {
    var matchValue = Context.tokenIndent(ctx);
    var $var344 = matchValue != null ? matchValue[1].Token.Case === "LParen" ? [0, matchValue[1].Range, matchValue[0]] : matchValue[1].Token.Case === "Dot" ? [1, matchValue[1], matchValue[0]] : [2] : [2];

    switch ($var344[0]) {
        case 0:
            Context.next(ctx);

            var _patternInput3 = parseCallArgList(false, $var344[1], new List(), ctx);

            var body_1 = node(unionRanges(body.Range, _patternInput3[0]), new Expr("Call", [body, whiteAfter(_patternInput3[1], node(unionRanges($var344[1], _patternInput3[0]), _patternInput3[2]))]));

            var _matchValue_2 = Context.tokenIndent(ctx);

            var $var345 = _matchValue_2 != null ? _matchValue_2[1].Token.Case === "Dot" ? [0, _matchValue_2[1], _matchValue_2[0]] : [1] : [1];

            switch ($var345[0]) {
                case 0:
                    Context.next(ctx);
                    return parseIdentAfterDot(whiteAfter($var345[2], body_1), $var345[1].Range, $var345[1].Token, ctx);

                case 1:
                    return body_1;
            }

        case 1:
            Context.next(ctx);
            return parseIdentAfterDot(whiteAfter($var344[2], body), $var344[1].Range, $var344[1].Token, ctx);

        case 2:
            return body;
    }
}
export function parseFunction(ctx, funRng) {
    var matchValue = Context.tokenIndent(ctx);
    var $var346 = void 0;

    if (matchValue != null) {
        var activePatternResult6774 = _Identifier___(matchValue[0], matchValue[1]);

        if (activePatternResult6774 != null) {
            $var346 = [0, activePatternResult6774];
        } else {
            $var346 = [1];
        }
    } else {
        $var346 = [1];
    }

    switch ($var346[0]) {
        case 0:
            Context.next(ctx);

            var _matchValue_3 = Context.tokenIndent(ctx);

            var $var347 = _matchValue_3 != null ? _matchValue_3[1].Token.Case === "Arrow" ? [0, _matchValue_3[1].Range, _matchValue_3[0]] : [1, _matchValue_3] : [1, _matchValue_3];

            switch ($var347[0]) {
                case 0:
                    Context.next(ctx);
                    var body = void 0;
                    var matchValue_2 = parseExpression(new List(), ctx);

                    if (matchValue_2 != null) {
                        body = matchValue_2;
                    } else {
                        (function (e) {
                            Context.error(ctx, e);
                        })(Parser.missingBodyOfFunc(unionRanges(funRng, $var347[1])));

                        body = node(new _Range($var347[1].End, $var347[1].End), new Expr("Empty", []));
                    }

                    var rng = unionRanges(funRng, body.Range);
                    return node(rng, new Expr("Function", [whiteAfter($var347[2], $var346[1]), body]));

                case 1:
                    var _patternInput4 = void 0;

                    if ($var347[1] != null) {
                        var whiteAfterId = $var347[1][0];
                        var t = $var347[1][1];
                        _patternInput4 = [t.Range, whiteAfterId];
                    } else {
                        _patternInput4 = [unionRanges(funRng, $var346[1].Range), new List()];
                    }

                    (function (e_1) {
                        Context.error(ctx, e_1);
                    })(Parser.missingArrowInFunc(_patternInput4[0]));

                    var body_1 = void 0;
                    var matchValue_3 = parseExpression(new List(), ctx);

                    if (matchValue_3 != null) {
                        body_1 = matchValue_3;
                    } else {
                        body_1 = node(new _Range($var346[1].Range.End, $var346[1].Range.End), new Expr("Empty", []));
                    }

                    return node(unionRanges(funRng, body_1.Range), new Expr("Function", [$var346[1], whiteBefore(_patternInput4[1], body_1)]));
            }

        case 1:
            if (matchValue == null) {
                (function (e_2) {
                    Context.error(ctx, e_2);
                })(Parser.unexpectedScopeEndInFunc(funRng));

                var rng_1 = new _Range(funRng.End, funRng.End);
                return node(rng_1, new Expr("Function", [node(rng_1, new Name("")), node(rng_1, new Expr("Empty", []))]));
            } else {
                var white = matchValue[0];
                var t_1 = matchValue[1];

                (function (e_3) {
                    Context.error(ctx, e_3);
                })(Parser.unexpectedTokenAfterFun(t_1.Range, t_1.Token));

                var rng_2 = new _Range(funRng.End, funRng.End);
                return function (n) {
                    return whiteBefore(white, n);
                }(node(rng_2, new Expr("Function", [node(rng_2, new Name("")), node(rng_2, new Expr("Empty", []))])));
            }

    }
}
export function parseListElements(afterComma, lastRng, whiteStart, startRng, acc, ctx) {
    var _loop3 = function _loop3() {
        var patternInput = void 0;
        var matchValue = parseExpression(new List(), ctx);

        if (matchValue != null) {
            patternInput = [true, function (white) {
                return new List(whiteAfter(white, matchValue), acc);
            }];
        } else {
            patternInput = [false, function (_arg1) {
                return acc;
            }];
        }

        var matchValue_1 = Context.tokenIndent(ctx);
        var $var348 = matchValue_1 != null ? matchValue_1[1].Token.Case === "RSquare" ? [0, matchValue_1[1].Range, matchValue_1[0]] : matchValue_1[1].Token.Case === "Comma" ? [1, matchValue_1[1].Range, matchValue_1[0]] : function () {
            var t = matchValue_1[1];
            return !t.Token.Equals(new TokenKind("EndOfFile", []));
        }() ? [2, matchValue_1[1]] : [3] : [3];

        switch ($var348[0]) {
            case 0:
                Context.next(ctx);

                if (!patternInput[0] ? afterComma : false) {
                    (function (e) {
                        Context.error(ctx, e);
                    })(Parser.unexpectedTokenInList(lastRng, new TokenKind("Comma", [])));
                }

                return {
                    v: function (n) {
                        return whiteBefore($var348[2], n);
                    }(node(unionRanges(startRng, $var348[1]), new Expr("List", [reverse(patternInput[1](new List()))])))
                };

            case 1:
                Context.next(ctx);

                if (!patternInput[0] ? afterComma : false) {
                    (function (e_1) {
                        Context.error(ctx, e_1);
                    })(Parser.unexpectedTokenInList($var348[1], new TokenKind("Comma", [])));
                }

                afterComma = true;
                lastRng = $var348[1];
                whiteStart = whiteStart;
                startRng = startRng;
                acc = patternInput[1]($var348[2]);
                ctx = ctx;
                return "continue|parseListElements";

            case 2:
                Context.next(ctx);

                (function (e_2) {
                    Context.error(ctx, e_2);
                })(Parser.unexpectedTokenInList($var348[1].Range, $var348[1].Token));

                return {
                    v: Context.silent(ctx, function (ctx_1) {
                        return parseListElements(afterComma, $var348[1].Range, whiteStart, startRng, patternInput[1](new List()), ctx_1);
                    })
                };

            case 3:
                (function (e_3) {
                    Context.error(ctx, e_3);
                })(Parser.unexpectedScopeEndInList(lastRng));

                return {
                    v: node(unionRanges(startRng, lastRng), new Expr("List", [reverse(patternInput[1](new List()))]))
                };
        }
    };

    parseListElements: while (true) {
        var _ret3 = _loop3();

        switch (_ret3) {
            case "continue|parseListElements":
                continue parseListElements;

            default:
                if ((typeof _ret3 === "undefined" ? "undefined" : _typeof(_ret3)) === "object") return _ret3.v;
        }
    }
}
export function parseTerm(ctx) {
    var matchValue = Context.tokenIndent(ctx);
    var $var349 = void 0;

    if (matchValue != null) {
        var activePatternResult6792 = _Identifier___(matchValue[0], matchValue[1]);

        if (activePatternResult6792 != null) {
            $var349 = [0, activePatternResult6792];
        } else {
            $var349 = [1];
        }
    } else {
        $var349 = [1];
    }

    switch ($var349[0]) {
        case 0:
            Context.next(ctx);
            return parseCallOrMember(node($var349[1].Range, new Expr("Variable", [$var349[1]])), ctx);

        case 1:
            var $var350 = matchValue != null ? matchValue[1].Token.Case === "Number" ? [0, matchValue[1].Token.Fields[1], matchValue[1].Range, matchValue[0]] : matchValue[1].Token.Case === "String" ? [1, matchValue[1].Range, matchValue[1].Token.Fields[0], matchValue[0]] : matchValue[1].Token.Case === "Boolean" ? [2, matchValue[1].Token.Fields[0], matchValue[1].Range, matchValue[0]] : matchValue[1].Token.Case === "LParen" ? [3, matchValue[1], matchValue[0]] : matchValue[1].Token.Case === "LSquare" ? [4, matchValue[1], matchValue[0]] : matchValue[1].Token.Case === "Fun" ? [5, matchValue[1], matchValue[0]] : [6] : [6];

            switch ($var350[0]) {
                case 0:
                    Context.next(ctx);
                    return function (n) {
                        return whiteAfter($var350[3], n);
                    }(node($var350[2], new Expr("Number", [$var350[1]])));

                case 1:
                    Context.next(ctx);
                    return function (n_1) {
                        return whiteAfter($var350[3], n_1);
                    }(node($var350[1], new Expr("String", [$var350[2]])));

                case 2:
                    Context.next(ctx);
                    return function (n_2) {
                        return whiteAfter($var350[3], n_2);
                    }(node($var350[2], new Expr("Boolean", [$var350[1]])));

                case 3:
                    Context.next(ctx);
                    return parseParenTermEnd(new List($var350[1], reverse($var350[2])), new List(), parseExpression(new List(), ctx), ctx);

                case 4:
                    Context.next(ctx);
                    return parseListElements(false, $var350[1].Range, $var350[2], $var350[1].Range, new List(), ctx);

                case 5:
                    Context.next(ctx);
                    return parseFunction(ctx, $var350[1].Range);

                case 6:
                    return null;
            }

    }
}
export function parseParenTermEnd(wb, wa, bodyOpt, ctx) {
    var makeBody = function makeBody(wa_1) {
        var body = void 0;

        if (bodyOpt == null) {
            var rng = function (list) {
                return reduce(function (r1, r2) {
                    return unionRanges(r1, r2);
                }, list);
            }(map(function (t) {
                return t.Range;
            }, append(ofArray([wb.head]), wa_1)));

            (function (e) {
                Context.error(ctx, e);
            })(Parser.missingParenthesizedExpr(rng));

            body = node(rng, new Expr("Empty", []));
        } else {
            body = bodyOpt;
        }

        return whiteAfter(reverse(wa_1), whiteBefore(reverse(wb), body));
    };

    var matchValue = Context.tokenIndent(ctx);

    if (matchValue == null) {
        var rng_1 = bodyOpt != null ? bodyOpt.Range : wb.head.Range;

        (function (e_1) {
            Context.error(ctx, e_1);
        })(Parser.unexpectedScopeEndInParenthesizedExpr(rng_1));

        return makeBody(wa);
    } else if (matchValue[1].Token.Case === "RParen") {
        Context.next(ctx);
        return makeBody(new List(matchValue[1], append(reverse(matchValue[0]), wa)));
    } else {
        Context.next(ctx);

        (function (e_2) {
            Context.error(ctx, e_2);
        })(Parser.unexpectedTokenInParenthesizedExpr(matchValue[1].Range, matchValue[1].Token));

        return Context.silent(ctx, function (ctx_1) {
            return parseParenTermEnd(wb, new List(matchValue[1], append(reverse(matchValue[0]), wa)), bodyOpt, ctx_1);
        });
    }
}
export function parseExpression(terms, ctx) {
    parseExpression: while (true) {
        var _matchValue = [terms, parseTerm(ctx)];

        if (_matchValue[1] == null) {
            if (_matchValue[0].tail != null) {
                var terms_1 = _matchValue[0].tail;
                var term = _matchValue[0].head[0];
                var op = _matchValue[0].head[1];

                (function (e) {
                    Context.error(ctx, e);
                })(Parser.unexpectedEndAfterOperator(op.Range, new TokenKind("Operator", [op.Node])));

                return buildExpression(terms_1, term);
            } else {
                return null;
            }
        } else {
            var _ret4 = function () {
                var term_1 = _matchValue[1];
                var matchValue_1 = Context.tokenIndent(ctx);

                if (matchValue_1 == null) {
                    return {
                        v: buildExpression(_matchValue[0], term_1)
                    };
                } else if (matchValue_1[1].Token.Case === "Equals") {
                    Context.next(ctx);
                    terms = new List([term_1, whiteBefore(matchValue_1[0], node(matchValue_1[1].Range, new Operator("Equals", [])))], _matchValue[0]);
                    ctx = ctx;
                    return "continue|parseExpression";
                } else if (matchValue_1[1].Token.Case === "Operator") {
                    Context.next(ctx);
                    terms = new List([term_1, whiteBefore(matchValue_1[0], node(matchValue_1[1].Range, matchValue_1[1].Token.Fields[0]))], _matchValue[0]);
                    ctx = ctx;
                    return "continue|parseExpression";
                } else {
                    return {
                        v: function (n) {
                            return whiteAfter(matchValue_1[0], n);
                        }(buildExpression(_matchValue[0], term_1))
                    };
                }
            }();

            switch (_ret4) {
                case "continue|parseExpression":
                    continue parseExpression;

                default:
                    if ((typeof _ret4 === "undefined" ? "undefined" : _typeof(_ret4)) === "object") return _ret4.v;
            }
        }
    }
}
export function parseLetBindingBody(lastRng, ctx) {
    var matchValue = parseExpression(new List(), ctx);

    if (matchValue == null) {
        var _matchValue_4 = Context.tokenIndent(ctx);

        if (_matchValue_4 != null) {
            var white = _matchValue_4[0];
            var t = _matchValue_4[1];

            (function (e) {
                Context.error(ctx, e);
            })(Parser.unexpectedTokenInLetBinding(t.Range, t.Token));

            return Context.silent(ctx, function (ctx_1) {
                return parseLetBindingBody(t.Range, ctx_1);
            });
        } else {
            (function (e_1) {
                Context.error(ctx, e_1);
            })(Parser.unexpectedScopeEndInLet(lastRng));

            return node(lastRng, new Expr("Empty", []));
        }
    } else {
        return matchValue;
    }
}
export function skipNestedTokens(firstTok, white, ctx) {
    skipNestedTokens: while (true) {
        var _matchValue2 = Context.tokenIndent(ctx);

        if (_matchValue2 != null) {
            if (_matchValue2[1].Token.Case === "EndOfFile") {
                return [equals(firstTok, null) ? _matchValue2[1] : firstTok, append(white, _matchValue2[0])];
            } else {
                Context.next(ctx);
                var firstTok_1 = equals(firstTok, null) ? _matchValue2[1] : firstTok;
                firstTok = firstTok_1;
                white = append(white, append(_matchValue2[0], ofArray([_matchValue2[1]])));
                ctx = ctx;
                continue skipNestedTokens;
            }
        } else {
            return [firstTok, white];
        }
    }
}
export function parseLetBinding(whiteBeforeLet, rngLet, ctx) {
    var matchValue = Context.tokenIndent(ctx);
    var $var351 = void 0;

    if (matchValue != null) {
        var activePatternResult6813 = _Identifier___(matchValue[0], matchValue[1]);

        if (activePatternResult6813 != null) {
            $var351 = [0, activePatternResult6813];
        } else {
            $var351 = [1];
        }
    } else {
        $var351 = [1];
    }

    switch ($var351[0]) {
        case 0:
            Context.next(ctx);

            var _matchValue_5 = Context.tokenIndent(ctx);

            if (_matchValue_5 == null) {
                (function (e) {
                    Context.error(ctx, e);
                })(Parser.missingBodyInLetBinding($var351[1].Range));

                var body = node(new _Range($var351[1].Range.End, $var351[1].Range.End), new Expr("Empty", []));
                return function (n) {
                    return whiteBefore(whiteBeforeLet, n);
                }(node(unionRanges(rngLet, $var351[1].Range), new Command("Let", [$var351[1], body])));
            } else if (_matchValue_5[1].Token.Case === "Equals") {
                Context.next(ctx);
                var body_1 = parseLetBindingBody(_matchValue_5[1].Range, ctx);
                return function (n_1) {
                    return whiteBefore(whiteBeforeLet, n_1);
                }(node(unionRanges(rngLet, body_1.Range), new Command("Let", [whiteAfter(_matchValue_5[0], $var351[1]), body_1])));
            } else {
                (function (e_1) {
                    Context.error(ctx, e_1);
                })(Parser.unexpectedTokenInLetBinding(_matchValue_5[1].Range, _matchValue_5[1].Token));

                var body_2 = parseLetBindingBody(_matchValue_5[1].Range, ctx);
                return function (n_2) {
                    return whiteBefore(whiteBeforeLet, n_2);
                }(node(unionRanges(rngLet, $var351[1].Range), new Command("Let", [whiteAfter(_matchValue_5[0], $var351[1]), body_2])));
            }

        case 1:
            if (matchValue == null) {
                (function (e_2) {
                    Context.error(ctx, e_2);
                })(Parser.missingBodyInLetBinding(rngLet));

                var rng = new _Range(rngLet.End, rngLet.End);
                return function (n_3) {
                    return whiteBefore(whiteBeforeLet, n_3);
                }(function (n_4) {
                    return node(rng, n_4);
                }(new Command("Let", [node(rng, new Name("")), node(rng, new Expr("Empty", []))])));
            } else {
                var whiteAfterLet = matchValue[0];
                var t = matchValue[1];

                (function (e_3) {
                    Context.error(ctx, e_3);
                })(Parser.unexpectedTokenInLetBinding(t.Range, t.Token));

                var letEndRng = new _Range(rngLet.End, rngLet.End);
                var body_3 = void 0;
                var matchValue_2 = parseExpression(new List(), ctx);

                if (matchValue_2 == null) {
                    var _patternInput5 = skipNestedTokens(null, new List(), ctx);

                    var skipRng = function (list) {
                        return reduce(function (r1, r2) {
                            return unionRanges(r1, r2);
                        }, list);
                    }(map(function (t_1) {
                        return t_1.Range;
                    }, new List(t, _patternInput5[1])));

                    body_3 = whiteAfter(new List(t, _patternInput5[1]), node(skipRng, new Expr("Empty", [])));
                } else {
                    body_3 = matchValue_2;
                }

                return function (n_5) {
                    return whiteBefore(whiteBeforeLet, n_5);
                }(node(unionRanges(rngLet, body_3.Range), new Command("Let", [whiteBefore(whiteAfterLet, node(letEndRng, new Name(""))), body_3])));
            }

    }
}
export function parseCommands(acc, ctx) {
    var _loop4 = function _loop4() {
        var matchValue = Context.tokenNonIndent(ctx);

        if (matchValue == null) {
            var _patternInput6 = skipNestedTokens(null, new List(), ctx);

            var firstSkipped = _patternInput6[0];

            (function (e) {
                Context.error(ctx, e);
            })(Parser.unexpectedNestedTokenInCommand(firstSkipped.Range, firstSkipped.Token));

            var skipRng = function (list) {
                return reduce(function (r1, r2) {
                    return unionRanges(r1, r2);
                }, list);
            }(map(function (t) {
                return t.Range;
            }, new List(firstSkipped, _patternInput6[1])));

            var cmd = function (n) {
                return whiteAfter(_patternInput6[1], n);
            }(node(skipRng, new Command("Expr", [node(skipRng, new Expr("Empty", []))])));

            acc = new List(cmd, acc);
            ctx = ctx;
            return "continue|parseCommands";
        } else if (matchValue[1].Token.Case === "EndOfFile") {
            if (acc.tail == null) {
                return {
                    v: new List()
                };
            } else {
                return {
                    v: reverse(new List(new _Node(acc.head.WhiteBefore, matchValue[0], acc.head.Range, acc.head.Node, acc.head.Entity), acc.tail))
                };
            }
        } else if (matchValue[1].Token.Case === "Let") {
            Context.next(ctx);
            var cmd_1 = parseLetBinding(matchValue[0], matchValue[1].Range, ctx);
            acc = new List(cmd_1, acc);
            ctx = ctx;
            return "continue|parseCommands";
        } else {
            var _matchValue_6 = parseExpression(new List(), ctx);

            if (_matchValue_6 == null) {
                var patternInput_1 = skipNestedTokens(null, new List(), ctx);

                (function (e_1) {
                    Context.error(ctx, e_1);
                })(Parser.unexpectedNestedTokenInCommand(matchValue[1].Range, matchValue[1].Token));

                var skipRng_1 = function (list_1) {
                    return reduce(function (r1_1, r2_1) {
                        return unionRanges(r1_1, r2_1);
                    }, list_1);
                }(map(function (t_1) {
                    return t_1.Range;
                }, new List(matchValue[1], patternInput_1[1])));

                var cmd_2 = whiteAfter(new List(matchValue[1], patternInput_1[1]), node(skipRng_1, new Command("Expr", [node(skipRng_1, new Expr("Empty", []))])));
                acc = new List(cmd_2, acc);
                ctx = ctx;
                return "continue|parseCommands";
            } else {
                var cmd_3 = function (n_1) {
                    return whiteBefore(matchValue[0], n_1);
                }(node(_matchValue_6.Range, new Command("Expr", [_matchValue_6])));

                acc = new List(cmd_3, acc);
                ctx = ctx;
                return "continue|parseCommands";
            }
        }
    };

    parseCommands: while (true) {
        var _ret5 = _loop4();

        switch (_ret5) {
            case "continue|parseCommands":
                continue parseCommands;

            default:
                if ((typeof _ret5 === "undefined" ? "undefined" : _typeof(_ret5)) === "object") return _ret5.v;
        }
    }
}
export function parseProgram(input) {
    try {
        var _patternInput7 = tokenize(input);

        var ctx = void 0;
        var Position = 0;
        var SilentMode = false;
        var Errors = [];
        ctx = new ParsingContext(_patternInput7[0], [], Errors, SilentMode, Position);
        var cmds = parseCommands(new List(), ctx);

        var errors = _patternInput7[1].concat(_Array$from(ctx.Errors));

        var rng_1 = fold(function (rng, cmd) {
            return unionRanges(rng, cmd.Range);
        }, new _Range(0, 0), cmds);
        return [new Program(node(rng_1, cmds)), errors];
    } catch (e) {
        Log.exn("parsing", "Exception while parsing program: %O", e);
        var rng_2 = new _Range(0, 0);
        var error = Parser.exceptionWhileParsing(rng_2, toString(e));
        return [new Program(node(rng_2, new List())), [error]];
    }
}
//# sourceMappingURL=parser.js.map