import _Number$parseFloat from "babel-runtime/core-js/number/parse-float";
import _Array$from from "babel-runtime/core-js/array/from";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { equalsRecords, makeGeneric, Array as _Array } from "fable-core/Util";
import { Operator, TokenKind, Range as _Range, Error as _Error, Token } from "../ast/ast";
import { ofArray } from "fable-core/List";
import List from "fable-core/List";
import { Tokenizer } from "../ast/errors";
import { endsWith } from "fable-core/String";
export var Context = function () {
  function Context(tokens, errors, input) {
    _classCallCheck(this, Context);

    this.Tokens = tokens;
    this.Errors = errors;
    this.Input = input;
  }

  _createClass(Context, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.Tokenizer.Context",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          Tokens: _Array(Token),
          Errors: _Array(makeGeneric(_Error, {
            Range: _Range
          })),
          Input: "string"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }]);

  return Context;
}();
setType("TheGamma.Tokenizer.Context", Context);
export function startsWith(s, i, j, prefix) {
  startsWith: while (true) {
    if (j === prefix.length) {
      return true;
    } else if (i === s.length) {
      return false;
    } else if (s[i] !== prefix[j]) {
      return false;
    } else {
      s = s;
      i = i + 1;
      j = j + 1;
      prefix = prefix;
      continue startsWith;
    }
  }
}
export function letter(c) {
  if (c >= "a" ? c <= "z" : false) {
    return true;
  } else if (c >= "A") {
    return c <= "Z";
  } else {
    return false;
  }
}
export function number(c) {
  if (c >= "0") {
    return c <= "9";
  } else {
    return false;
  }
}
export function addAndTokenize(ctx, tok, i, l) {
  (function (arg00) {
    ctx.Tokens.push(arg00);
  })(new Token(tok, new _Range(i, i + l - 1)));

  return tokenizeInput(ctx, i + l);
}
export function tokenizeIdent(ctx, start, l) {
  tokenizeIdent: while (true) {
    if (start + l < ctx.Input.length ? letter(ctx.Input[start + l]) ? true : number(ctx.Input[start + l]) : false) {
      ctx = ctx;
      start = start;
      l = l + 1;
      continue tokenizeIdent;
    } else {
      return addAndTokenize(ctx, new TokenKind("Ident", [ctx.Input.substr(start, l)]), start, l);
    }
  }
}
export function tokenizeString(ctx, acc, start, l) {
  tokenizeString: while (true) {
    if (start + l >= ctx.Input.length) {
      return tokenizeStringEnd(true, ctx, acc, start, l);
    } else {
      var matchValue = ctx.Input[start + l];
      var $var321 = matchValue === "\\" ? start + l + 1 >= ctx.Input.length ? [0] : [1] : [1];

      switch ($var321[0]) {
        case 0:
          return tokenizeStringEnd(true, ctx, new List("\\", acc), start, l + 1);

        case 1:
          if (matchValue === "\"") {
            return tokenizeStringEnd(false, ctx, acc, start, l + 1);
          } else if (matchValue === "\\") {
            var matchValue_1 = ctx.Input[start + l + 1];

            if (matchValue_1 === "\"") {
              ctx = ctx;
              acc = new List("\"", acc);
              start = start;
              l = l + 2;
              continue tokenizeString;
            } else if (matchValue_1 === "\\") {
              ctx = ctx;
              acc = new List("\\", acc);
              start = start;
              l = l + 2;
              continue tokenizeString;
            } else if (matchValue_1 === "n") {
              ctx = ctx;
              acc = new List("\n", acc);
              start = start;
              l = l + 2;
              continue tokenizeString;
            } else if (matchValue_1 === "t") {
              ctx = ctx;
              acc = new List("\t", acc);
              start = start;
              l = l + 2;
              continue tokenizeString;
            } else {
              ctx = ctx;
              acc = ofArray([matchValue_1, "\\"], acc);
              start = start;
              l = l + 2;
              continue tokenizeString;
            }
          } else {
            ctx = ctx;
            acc = new List(matchValue, acc);
            start = start;
            l = l + 1;
            continue tokenizeString;
          }

      }
    }
  }
}
export function tokenizeStringEnd(error, ctx, acc, start, l) {
  var str = _Array$from(acc).slice().reverse().join('');

  var rng = new _Range(start, start + l);

  if (error) {
    ctx.Errors.push(Tokenizer.inputEndInsideString(rng, str));
  }

  return addAndTokenize(ctx, new TokenKind("String", [str]), start, l);
}
export function tokenizeQuotedIdent(ctx, start, l) {
  tokenizeQuotedIdent: while (true) {
    if (start + l >= ctx.Input.length) {
      return tokenizeQuotedIdentEnd(true, ctx, start, l);
    } else {
      var matchValue = ctx.Input[start + l];

      if (matchValue === "\n") {
        return tokenizeQuotedIdentEnd(true, ctx, start, l + 1);
      } else if (matchValue === "'") {
        return tokenizeQuotedIdentEnd(false, ctx, start, l + 1);
      } else {
        ctx = ctx;
        start = start;
        l = l + 1;
        continue tokenizeQuotedIdent;
      }
    }
  }
}
export function tokenizeQuotedIdentEnd(error, ctx, start, l) {
  var rng = new _Range(start, start + l);
  var qid = ctx.Input.substr(start + 1, l - (error ? 1 : 2));
  var qid_1 = endsWith(qid, "\n") ? qid.substr(0, qid.length - 1) : qid;

  if (error) {
    ctx.Errors.push(Tokenizer.missingClosingQuote(rng, qid_1));
  }

  return addAndTokenize(ctx, new TokenKind("QIdent", [qid_1]), start, l);
}
export function tokenizeWhite(ctx, start, l) {
  tokenizeWhite: while (true) {
    if (start + l < ctx.Input.length ? ctx.Input[start + l] === " " : false) {
      ctx = ctx;
      start = start;
      l = l + 1;
      continue tokenizeWhite;
    } else {
      return addAndTokenize(ctx, new TokenKind("White", [ctx.Input.substr(start, l)]), start, l);
    }
  }
}
export function tokenizeNumber(ctx, decimal, start, l) {
  tokenizeNumber: while (true) {
    if (start + l < ctx.Input.length ? number(ctx.Input[start + l]) : false) {
      ctx = ctx;
      decimal = decimal;
      start = start;
      l = l + 1;
      continue tokenizeNumber;
    } else if ((start + l < ctx.Input.length ? !decimal : false) ? ctx.Input[start + l] === "." : false) {
      ctx = ctx;
      decimal = true;
      start = start;
      l = l + 1;
      continue tokenizeNumber;
    } else {
      var str = ctx.Input.substr(start, l);
      return addAndTokenize(ctx, new TokenKind("Number", [str, _Number$parseFloat(str)]), start, l);
    }
  }
}
export function tokenizeInput(ctx, i) {
  if (i >= ctx.Input.length) {
    return ctx;
  } else {
    var matchValue = ctx.Input[i];
    var $var322 = matchValue === "-" ? startsWith(ctx.Input, i, 0, "->") ? [0] : [1] : [1];

    switch ($var322[0]) {
      case 0:
        return addAndTokenize(ctx, new TokenKind("Arrow", []), i, 2);

      case 1:
        var $var323 = matchValue === "f" ? startsWith(ctx.Input, i, 0, "fun") ? [0] : [1] : [1];

        switch ($var323[0]) {
          case 0:
            return addAndTokenize(ctx, new TokenKind("Fun", []), i, 3);

          case 1:
            var $var324 = matchValue === "l" ? startsWith(ctx.Input, i, 0, "let") ? [0] : [1] : [1];

            switch ($var324[0]) {
              case 0:
                return addAndTokenize(ctx, new TokenKind("Let", []), i, 3);

              case 1:
                var $var325 = matchValue === "t" ? startsWith(ctx.Input, i, 0, "true") ? [0] : [1] : [1];

                switch ($var325[0]) {
                  case 0:
                    return addAndTokenize(ctx, new TokenKind("Boolean", [true]), i, 4);

                  case 1:
                    var $var326 = matchValue === "f" ? startsWith(ctx.Input, i, 0, "false") ? [0] : [1] : [1];

                    switch ($var326[0]) {
                      case 0:
                        return addAndTokenize(ctx, new TokenKind("Boolean", [false]), i, 5);

                      case 1:
                        var $var327 = matchValue === "<" ? startsWith(ctx.Input, i, 0, "<=") ? [0] : [1] : [1];

                        switch ($var327[0]) {
                          case 0:
                            return addAndTokenize(ctx, new TokenKind("Operator", [new Operator("LessThanOrEqual", [])]), i, 2);

                          case 1:
                            var $var328 = matchValue === ">" ? startsWith(ctx.Input, i, 0, ">=") ? [0] : [1] : [1];

                            switch ($var328[0]) {
                              case 0:
                                return addAndTokenize(ctx, new TokenKind("Operator", [new Operator("GreaterThanOrEqual", [])]), i, 2);

                              case 1:
                                if (matchValue === "\n") {
                                  return addAndTokenize(ctx, new TokenKind("Newline", []), i, 1);
                                } else if (matchValue === " ") {
                                  return tokenizeWhite(ctx, i, 1);
                                } else if (matchValue === "\"") {
                                  return tokenizeString(ctx, new List(), i, 1);
                                } else if (matchValue === "%") {
                                  return addAndTokenize(ctx, new TokenKind("Operator", [new Operator("Modulo", [])]), i, 1);
                                } else if (matchValue === "'") {
                                  return tokenizeQuotedIdent(ctx, i, 1);
                                } else if (matchValue === "(") {
                                  return addAndTokenize(ctx, new TokenKind("LParen", []), i, 1);
                                } else if (matchValue === ")") {
                                  return addAndTokenize(ctx, new TokenKind("RParen", []), i, 1);
                                } else if (matchValue === "*") {
                                  return addAndTokenize(ctx, new TokenKind("Operator", [new Operator("Multiply", [])]), i, 1);
                                } else if (matchValue === "+") {
                                  return addAndTokenize(ctx, new TokenKind("Operator", [new Operator("Plus", [])]), i, 1);
                                } else if (matchValue === ",") {
                                  return addAndTokenize(ctx, new TokenKind("Comma", []), i, 1);
                                } else if (matchValue === "-") {
                                  return addAndTokenize(ctx, new TokenKind("Operator", [new Operator("Minus", [])]), i, 1);
                                } else if (matchValue === ".") {
                                  return addAndTokenize(ctx, new TokenKind("Dot", []), i, 1);
                                } else if (matchValue === "/") {
                                  return addAndTokenize(ctx, new TokenKind("Operator", [new Operator("Divide", [])]), i, 1);
                                } else if (matchValue === ":") {
                                  return addAndTokenize(ctx, new TokenKind("Colon", []), i, 1);
                                } else if (matchValue === "<") {
                                  return addAndTokenize(ctx, new TokenKind("Operator", [new Operator("LessThan", [])]), i, 1);
                                } else if (matchValue === "=") {
                                  return addAndTokenize(ctx, new TokenKind("Equals", []), i, 1);
                                } else if (matchValue === ">") {
                                  return addAndTokenize(ctx, new TokenKind("Operator", [new Operator("GreaterThan", [])]), i, 1);
                                } else if (matchValue === "[") {
                                  return addAndTokenize(ctx, new TokenKind("LSquare", []), i, 1);
                                } else if (matchValue === "]") {
                                  return addAndTokenize(ctx, new TokenKind("RSquare", []), i, 1);
                                } else if (matchValue === "^") {
                                  return addAndTokenize(ctx, new TokenKind("Operator", [new Operator("Power", [])]), i, 1);
                                } else if (letter(matchValue)) {
                                  return tokenizeIdent(ctx, i, 1);
                                } else if (number(matchValue)) {
                                  return tokenizeNumber(ctx, false, i, 1);
                                } else {
                                  ctx.Errors.push(Tokenizer.unexpectedCharacter(new _Range(i, i), matchValue));
                                  return addAndTokenize(ctx, new TokenKind("Error", [matchValue]), i, 1);
                                }

                            }

                        }

                    }

                }

            }

        }

    }
  }
}
export function tokenize(input) {
  var ctx = void 0;
  var Errors = [];
  ctx = new Context([], Errors, input);
  var ctx_1 = tokenizeInput(ctx, 0);
  ctx_1.Tokens.push(new Token(new TokenKind("EndOfFile", []), new _Range(input.length, input.length)));
  return [_Array$from(ctx_1.Tokens), _Array$from(ctx_1.Errors)];
}
//# sourceMappingURL=tokenizer.js.map