import _Map from "babel-runtime/core-js/map";
import _Array$from from "babel-runtime/core-js/array/from";
import _defineProperty from "babel-runtime/helpers/defineProperty";
import _typeof from "babel-runtime/helpers/typeof";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { defaultArg, hasInterface, Interface, makeGeneric, Array as _Array, Any, compareRecords, equalsRecords } from "fable-core/Util";
import { ofArray, map as map_1, append } from "fable-core/List";
import List from "fable-core/List";
import { Member, Emitter, PrimitiveType as PrimitiveType_1, MethodArgument, Type } from "../ast/ast";
import { Http, Log, Async$2E$AwaitFuture$2E$Static as Async_AwaitFuture_Static, Async$2E$CreateNamedFuture$2E$Static as Async_CreateNamedFuture_Static } from "../../libraries/common";
import { singleton } from "fable-core/AsyncBuilder";
import { range, zip, fold, singleton as singleton_1, collect, exists, choose, map, delay, toList } from "fable-core/Seq";
import { listsEqual, typesEqual } from "../ast/typeops";
import { Expression } from "../common/babel";
import { tryGetValue, groupBy } from "fable-core/Map";
import { concatUrl } from "../codegen/runtime";
import { fsFormat } from "fable-core/String";
import Lazy from "fable-core/Lazy";
import { ProvidedType } from "./providers";
export var GenericParameterType = function () {
  function GenericParameterType(kind, name) {
    _classCallCheck(this, GenericParameterType);

    this.kind = kind;
    this.name = name;
  }

  _createClass(GenericParameterType, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.GenericParameterType",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          kind: "string",
          name: "string"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareRecords(this, other);
    }
  }]);

  return GenericParameterType;
}();
setType("TheGamma.TypeProviders.FSharpProvider.GenericParameterType", GenericParameterType);
export var ArrayType = function () {
  function ArrayType(kind, element) {
    _classCallCheck(this, ArrayType);

    this.kind = kind;
    this.element = element;
  }

  _createClass(ArrayType, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.ArrayType",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          kind: "string",
          element: Any
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }]);

  return ArrayType;
}();
setType("TheGamma.TypeProviders.FSharpProvider.ArrayType", ArrayType);
export var PrimitiveType = function () {
  function PrimitiveType(kind, name) {
    _classCallCheck(this, PrimitiveType);

    this.kind = kind;
    this.name = name;
  }

  _createClass(PrimitiveType, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.PrimitiveType",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          kind: "string",
          name: "string"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareRecords(this, other);
    }
  }]);

  return PrimitiveType;
}();
setType("TheGamma.TypeProviders.FSharpProvider.PrimitiveType", PrimitiveType);
export var FunctionType = function () {
  function FunctionType(kind, _arguments, returns) {
    _classCallCheck(this, FunctionType);

    this.kind = kind;
    this.arguments = _arguments;
    this.returns = returns;
  }

  _createClass(FunctionType, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.FunctionType",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          kind: "string",
          arguments: _Array(Any),
          returns: Any
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }]);

  return FunctionType;
}();
setType("TheGamma.TypeProviders.FSharpProvider.FunctionType", FunctionType);
export var NamedType = function () {
  function NamedType(kind, name, typargs) {
    _classCallCheck(this, NamedType);

    this.kind = kind;
    this.name = name;
    this.typargs = typargs;
  }

  _createClass(NamedType, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.NamedType",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          kind: "string",
          name: "string",
          typargs: _Array(Any)
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }]);

  return NamedType;
}();
setType("TheGamma.TypeProviders.FSharpProvider.NamedType", NamedType);
export var Argument = function () {
  function Argument(name, optional, type) {
    _classCallCheck(this, Argument);

    this.name = name;
    this.optional = optional;
    this.type = type;
  }

  _createClass(Argument, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.Argument",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          name: "string",
          optional: "boolean",
          type: Any
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }]);

  return Argument;
}();
setType("TheGamma.TypeProviders.FSharpProvider.Argument", Argument);
export var MethodMember = function () {
  function MethodMember(kind, name, typepars, _arguments, returns) {
    _classCallCheck(this, MethodMember);

    this.kind = kind;
    this.name = name;
    this.typepars = typepars;
    this.arguments = _arguments;
    this.returns = returns;
  }

  _createClass(MethodMember, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.MethodMember",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          kind: "string",
          name: "string",
          typepars: _Array(Any),
          arguments: _Array(Argument),
          returns: Any
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }]);

  return MethodMember;
}();
setType("TheGamma.TypeProviders.FSharpProvider.MethodMember", MethodMember);
export var PropertyMember = function () {
  function PropertyMember(kind, name, returns) {
    _classCallCheck(this, PropertyMember);

    this.kind = kind;
    this.name = name;
    this.returns = returns;
  }

  _createClass(PropertyMember, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.PropertyMember",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          kind: "string",
          name: "string",
          returns: Any
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }]);

  return PropertyMember;
}();
setType("TheGamma.TypeProviders.FSharpProvider.PropertyMember", PropertyMember);
export var ExportedType = function () {
  function ExportedType(name, typepars, _static, instance, members) {
    _classCallCheck(this, ExportedType);

    this.name = name;
    this.typepars = typepars;
    this.static = _static;
    this.instance = instance;
    this.members = members;
  }

  _createClass(ExportedType, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.ExportedType",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          name: "string",
          typepars: _Array(Any),
          static: "boolean",
          instance: _Array("string"),
          members: _Array(Any)
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }]);

  return ExportedType;
}();
setType("TheGamma.TypeProviders.FSharpProvider.ExportedType", ExportedType);
export var TypeSchema = function () {
  function TypeSchema(caseName, fields) {
    _classCallCheck(this, TypeSchema);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(TypeSchema, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.FSharpProvider.TypeSchema",
        interfaces: ["FSharpUnion"],
        cases: {
          Function: [makeGeneric(List, {
            T: TypeSchema
          }), TypeSchema],
          GenericType: [Interface("TheGamma.TypeProviders.FSharpProvider.GenericTypeSchema")],
          List: [TypeSchema],
          Parameter: ["string"],
          Primitive: [Type]
        }
      };
    }
  }]);

  return TypeSchema;
}();
setType("TheGamma.TypeProviders.FSharpProvider.TypeSchema", TypeSchema);
export function mapGenericType(typ, g) {
  var $var398 = typ.Case === "Delayed" ? [0, typ.Fields[0]] : typ.Case === "Object" ? hasInterface(typ.Fields[0], "TheGamma.TypeProviders.FSharpProvider.GenericTypeDefinition") ? [1, typ.Fields[0]] : [2, typ] : [2, typ];

  switch ($var398[0]) {
    case 0:
      return new Type("Delayed", [function (arg00) {
        return function (arg10) {
          return Async_CreateNamedFuture_Static(arg00, arg10);
        };
      }("applyTypes")(function (builder_) {
        return builder_.Delay(function () {
          return builder_.Bind(Async_AwaitFuture_Static($var398[1]), function (_arg1) {
            return builder_.Return(mapGenericType(_arg1, g));
          });
        });
      }(singleton))]);

    case 1:
      return new Type("Object", [$var398[1].Apply(toList(delay(function () {
        return map(function (t) {
          return new TypeSchema("Primitive", [t]);
        }, g($var398[1]));
      }))).Substitute(function (_arg1_1) {
        return null;
      })]);

    case 2:
      return $var398[1];
  }
}
export function applyTypes(typ, tyargs) {
  var $var399 = typ.Case === "Delayed" ? [0, typ.Fields[0]] : typ.Case === "Object" ? hasInterface(typ.Fields[0], "TheGamma.TypeProviders.FSharpProvider.GenericTypeDefinition") ? [1, typ.Fields[0]] : [2] : [2];

  switch ($var399[0]) {
    case 0:
      return new Type("Delayed", [function (arg00) {
        return function (arg10) {
          return Async_CreateNamedFuture_Static(arg00, arg10);
        };
      }("applyTypes")(function (builder_) {
        return builder_.Delay(function () {
          return builder_.Bind(Async_AwaitFuture_Static($var399[1]), function (_arg1) {
            return builder_.Return(applyTypes(_arg1, tyargs));
          });
        });
      }(singleton))]);

    case 1:
      return new Type("Object", [$var399[1].Apply(toList(delay(function () {
        return map(function (t) {
          return new TypeSchema("Primitive", [t]);
        }, tyargs);
      }))).Substitute(function (_arg1_1) {
        return null;
      })]);

    case 2:
      throw new Error("applyTypes: Expected generic type definition");
  }
}
export function unifyTypes(ctx, schemas, tys) {
  var _loop = function _loop() {
    var matchValue = [schemas, tys];
    var $var400 = matchValue[0].tail != null ? matchValue[0].head.Case === "GenericType" ? matchValue[1].tail != null ? matchValue[1].head.Case === "Object" ? hasInterface(matchValue[1].head.Fields[0], "TheGamma.TypeProviders.FSharpProvider.GenericType") ? function () {
      var ts_2 = matchValue[1].tail;
      var ss_2 = matchValue[0].tail;
      var gt = matchValue[1].head.Fields[0];
      var gs = matchValue[0].head.Fields[0];

      if (gt.TypeDefinition.FullName === gs.TypeDefinition.FullName) {
        return gs.TypeArguments.length === gt.TypeArguments.length;
      } else {
        return false;
      }
    }() ? [1, matchValue[0].head.Fields[0], matchValue[1].head.Fields[0], matchValue[0].tail, matchValue[1].tail] : [2] : [2] : [2] : [2] : [2] : matchValue[1].tail == null ? [0] : [2];

    switch ($var400[0]) {
      case 0:
        return {
          v: ctx
        };

      case 1:
        ctx = ctx;
        schemas = append($var400[1].TypeArguments, $var400[3]);
        tys = append($var400[2].TypeArguments, $var400[4]);
        return "continue|unifyTypes";

      case 2:
        var $var401 = matchValue[0].tail != null ? matchValue[0].head.Case === "Primitive" ? matchValue[1].tail != null ? function () {
          var ts_1 = matchValue[1].tail;
          var t2 = matchValue[1].head;
          var t1 = matchValue[0].head.Fields[0];
          var ss_1 = matchValue[0].tail;
          return typesEqual(t1, t2);
        }() ? [0, matchValue[0].tail, matchValue[0].head.Fields[0], matchValue[1].head, matchValue[1].tail] : [1] : [1] : [1] : [1];

        switch ($var401[0]) {
          case 0:
            ctx = ctx;
            schemas = $var401[1];
            tys = $var401[4];
            return "continue|unifyTypes";

          case 1:
            var $var402 = matchValue[0].tail != null ? matchValue[0].head.Case === "Parameter" ? matchValue[1].tail != null ? [0, matchValue[0].head.Fields[0], matchValue[0].tail, matchValue[1].head, matchValue[1].tail] : [3] : matchValue[0].head.Case === "List" ? matchValue[1].tail != null ? matchValue[1].head.Case === "List" ? [1, matchValue[0].head.Fields[0], matchValue[0].tail, matchValue[1].head.Fields[0], matchValue[1].tail] : [3] : [3] : matchValue[0].head.Case === "Function" ? matchValue[1].tail != null ? matchValue[1].head.Case === "Method" ? function () {
              var ts = matchValue[1].tail;
              var tr_1 = matchValue[1].head.Fields[1];
              var ta_1 = matchValue[1].head.Fields[0];
              var ss = matchValue[0].tail;
              var sr = matchValue[0].head.Fields[1];
              var sa = matchValue[0].head.Fields[0];
              return sa.length === ta_1.length;
            }() ? [2, matchValue[0].head.Fields[0], matchValue[0].head.Fields[1], matchValue[0].tail, matchValue[1].head.Fields[0], matchValue[1].head.Fields[1], matchValue[1].tail] : [3] : [3] : [3] : [3] : [3];

            switch ($var402[0]) {
              case 0:
                ctx = new List([$var402[1], $var402[3]], ctx);
                schemas = $var402[2];
                tys = $var402[4];
                return "continue|unifyTypes";

              case 1:
                ctx = ctx;
                schemas = new List($var402[1], $var402[2]);
                tys = new List($var402[3], $var402[4]);
                return "continue|unifyTypes";

              case 2:
                var ta = toList(delay(function () {
                  return map(function (ma) {
                    return [ma.Type, null];
                  }, $var402[4]);
                }));
                var tr = defaultArg($var402[5](ta), new Type("Any", []));
                ctx = ctx;
                schemas = new List($var402[2], append($var402[1], $var402[3]));
                tys = new List(tr, append(map_1(function (tuple) {
                  return tuple[0];
                }, ta), $var402[6]));
                return "continue|unifyTypes";

              case 3:
                var $var403 = matchValue[0].tail == null ? [0] : matchValue[0].head.Case === "GenericType" ? [0] : matchValue[0].head.Case === "Primitive" ? [0] : matchValue[0].head.Case === "List" ? [0] : matchValue[0].head.Case === "Function" ? [0] : matchValue[1].tail == null ? [0] : [1];

                switch ($var403[0]) {
                  case 0:
                    var matchValue_1 = [schemas, tys];
                    var $var404 = matchValue_1[0].tail != null ? matchValue_1[1].tail != null ? [0, matchValue_1[0].head, matchValue_1[1].head] : [1] : [1];

                    switch ($var404[0]) {
                      case 0:
                        Log.trace("providers", "Failed to unify types %O and %O", $var404[1], $var404[2]);
                        break;

                      case 1:
                        Log.trace("providers", "Failed to unify types %O and %O", schemas, tys);
                        break;
                    }

                    return {
                      v: null
                    };

                  case 1:
                    throw new Error("C:\\Tomas\\Public\\the-gamma\\thegamma-script\\src\\thegamma\\providers/fsharp.fs", 126, 8);
                }

            }

        }

    }
  };

  unifyTypes: while (true) {
    var _ret = _loop();

    switch (_ret) {
      case "continue|unifyTypes":
        continue unifyTypes;

      default:
        if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;
    }
  }
}
export function substituteTypeParams(assigns, schema) {
  if (schema.Case === "Primitive") {
    return schema.Fields[0];
  } else if (schema.Case === "List") {
    return new Type("List", [substituteTypeParams(assigns, schema.Fields[0])]);
  } else if (schema.Case === "Parameter") {
    var _matchValue = assigns(schema.Fields[0]);

    if (_matchValue != null) {
      return _matchValue;
    } else {
      throw new Error("substituteTypeParams: unresolved type parameter");
    }
  } else if (schema.Case === "Function") {
    var args = map_1(function (it) {
      return new MethodArgument("", false, false, substituteTypeParams(assigns, it));
    }, schema.Fields[0]);
    return new Type("Method", [args, function (_arg1) {
      return substituteTypeParams(assigns, schema.Fields[1]);
    }]);
  } else {
    return new Type("Object", [schema.Fields[0].Substitute(assigns)]);
  }
}
export function partiallySubstituteTypeParams(assigns, schema) {
  var $var405 = schema.Case === "Primitive" ? [0, schema.Fields[0]] : schema.Case === "List" ? [1, schema.Fields[0]] : schema.Case === "Parameter" ? function () {
    return assigns(schema.Fields[0]) != null;
  }(null) ? [2, schema.Fields[0]] : [3] : [3];

  switch ($var405[0]) {
    case 0:
      return new TypeSchema("Primitive", [$var405[1]]);

    case 1:
      return new TypeSchema("List", [partiallySubstituteTypeParams(assigns, $var405[1])]);

    case 2:
      return new TypeSchema("Primitive", [assigns($var405[1])]);

    case 3:
      if (schema.Case === "Parameter") {
        return new TypeSchema("Parameter", [schema.Fields[0]]);
      } else if (schema.Case === "Function") {
        return new TypeSchema("Function", [map_1(function (schema_1) {
          return partiallySubstituteTypeParams(assigns, schema_1);
        }, schema.Fields[0]), partiallySubstituteTypeParams(assigns, schema.Fields[1])]);
      } else if (schema.Case === "GenericType") {
        return new TypeSchema("GenericType", [_defineProperty({
          get Members() {
            throw new Error("Uninstantiated generic type schema");
          },

          TypeEquals: function (_arg1) {
            throw new Error("Uninstantiated generic type schema");
          },

          get TypeArguments() {
            return map_1(function (schema_1) {
              return partiallySubstituteTypeParams(assigns, schema_1);
            }, schema.Fields[0].TypeArguments);
          },

          get TypeDefinition() {
            return schema.Fields[0].TypeDefinition;
          },

          Substitute: function (assigns2) {
            return schema.Fields[0].Substitute(function (n) {
              var matchValue = [assigns2(n), assigns(n)];
              var $var406 = matchValue[0] != null ? [0, matchValue[0]] : matchValue[1] != null ? [0, matchValue[1]] : [1];

              switch ($var406[0]) {
                case 0:
                  return $var406[1];

                case 1:
                  return null;
              }
            });
          }
        }, _Symbol.reflection, function () {
          return {
            interfaces: ["TheGamma.TypeProviders.FSharpProvider.GenericTypeSchema"]
          };
        })]);
      } else {
        throw new Error("C:\\Tomas\\Public\\the-gamma\\thegamma-script\\src\\thegamma\\providers/fsharp.fs", 161, 8);
      }

  }
}
export function importProvidedType(url, lookupNamed, exp) {
  var mapType = function mapType(t) {
    var matchValue = t.kind;

    switch (matchValue) {
      case "primitive":
        return new TypeSchema("Primitive", [function () {
          var matchValue_1 = t.name;

          switch (matchValue_1) {
            case "object":
              return new Type("Any", []);

            case "int":
            case "float":
              return new Type("Primitive", [new PrimitiveType_1("Number", [])]);

            case "string":
              return new Type("Primitive", [new PrimitiveType_1("String", [])]);

            case "bool":
              return new Type("Primitive", [new PrimitiveType_1("Bool", [])]);

            case "unit":
              return new Type("Primitive", [new PrimitiveType_1("Unit", [])]);

            case "date":
              return new Type("Primitive", [new PrimitiveType_1("Date", [])]);

            default:
              throw new Error("provideFSharpType: Unsupported type: " + matchValue_1);
          }
        }()]);

      case "function":
        var t_1 = t;
        return new TypeSchema("Function", [toList(_Array$from(map(mapType, t_1.arguments))), mapType(t_1.returns)]);

      case "named":
        var t_2 = t;
        var tyargs = ofArray(_Array$from(map(mapType, t_2.typargs)));
        var matchValue_2 = lookupNamed(t_2.name);
        var $var407 = matchValue_2.Case === "Object" ? hasInterface(matchValue_2.Fields[0], "TheGamma.TypeProviders.FSharpProvider.GenericTypeDefinition") ? [0, matchValue_2.Fields[0]] : [1, matchValue_2] : [1, matchValue_2];

        switch ($var407[0]) {
          case 0:
            if ($var407[1].TypeParameterCount !== tyargs.length) {
              throw new Error("provideFSharpType: Named type has mismatching nuumber of arguments");
            }

            return new TypeSchema("GenericType", [$var407[1].Apply(tyargs)]);

          case 1:
            return new TypeSchema("Primitive", [$var407[1]]);
        }

      case "parameter":
        return new TypeSchema("Parameter", [t.name]);

      case "array":
        return new TypeSchema("List", [mapType(t.element)]);

      default:
        throw new Error("provideFSharpType: Unexpected type");
    }
  };

  var getTypeParameters = function getTypeParameters(typars) {
    return ofArray(_Array$from(map(function (t_3) {
      var matchValue_3 = function (arg00) {
        return mapType(arg00);
      }(t_3);

      if (matchValue_3.Case === "Parameter") {
        return matchValue_3.Fields[0];
      } else {
        throw new Error("importProvidedType: expected type parameter");
      }
    }, typars)));
  };

  var generateMembers = function generateMembers(assigns) {
    return _Array$from(choose(function (m) {
      if (m.kind === "property") {
        var m_1 = m;
        var retTyp = substituteTypeParams(assigns, mapType(m_1.returns));
        var emitter = new Emitter(function (inst) {
          return new Expression("MemberExpression", [inst, new Expression("IdentifierExpression", [m_1.name, null]), false, null]);
        });
        return new Member(m_1.name, retTyp, new List(), emitter);
      } else if (m.kind === "method") {
        var m_2 = m;
        var typars_1 = getTypeParameters(m_2.typepars);

        var assigns_1 = function assigns_1(n) {
          if (exists(function (y) {
            return n === y;
          }, typars_1)) {
            return null;
          } else {
            return assigns(n);
          }
        };

        var args = toList(delay(function () {
          return map(function (a) {
            return [a.name, a.optional, partiallySubstituteTypeParams(assigns_1, mapType(a.type))];
          }, m_2.arguments);
        }));
        var emitter_1 = new Emitter(function (inst_1) {
          return new Expression("MemberExpression", [inst_1, new Expression("IdentifierExpression", [m_2.name, null]), false, null]);
        });
        var retTyp_1 = partiallySubstituteTypeParams(assigns_1, mapType(m_2.returns));

        var retFunc = function retFunc(tys) {
          var tys_1 = map_1(function (tuple) {
            return tuple[0];
          }, tys);
          Log.trace("providers", "F# provider unifying: %O, %O", _Array$from(delay(function () {
            return collect(function (matchValue_4) {
              return singleton_1(matchValue_4[2]);
            }, args);
          })), _Array$from(tys_1));
          var matchValue_6 = unifyTypes(new List(), toList(delay(function () {
            return collect(function (matchValue_5) {
              return singleton_1(matchValue_5[2]);
            }, args);
          })), tys_1);

          if (matchValue_6 != null) {
            var assigns_3 = fold(function (assigns_2, assign) {
              var matchValue_7 = [assigns_2, assign];
              var $var408 = matchValue_7[0] != null ? matchValue_7[1][1] != null ? [0, matchValue_7[1][1], matchValue_7[0], matchValue_7[1][0]] : [1] : [1];

              switch ($var408[0]) {
                case 0:
                  return new List([$var408[3], $var408[1]], $var408[2]);

                case 1:
                  return null;
              }
            }, new List(), map(function (tupledArg) {
              return [tupledArg[0], fold(function (st, tupledArg_1) {
                return st == null ? null : typesEqual(st, tupledArg_1[1]) ? tupledArg_1[1] : null;
              }, new Type("Any", []), tupledArg[1])];
            }, groupBy(function (tuple_1) {
              return tuple_1[0];
            }, matchValue_6)));
            var $var409 = assigns_3 != null ? assigns_3.length === typars_1.length ? [0, assigns_3] : [1] : [1];

            switch ($var409[0]) {
              case 0:
                var assigns_4 = new _Map($var409[1]);

                var subst = function subst(n_1) {
                  if (assigns_4.has(n_1)) {
                    return assigns_4.get(n_1);
                  } else {
                    return null;
                  }
                };

                return substituteTypeParams(subst, retTyp_1);

              case 1:
                return null;
            }
          } else {
            return null;
          }
        };

        var args_1 = toList(delay(function () {
          return collect(function (matchValue_8) {
            return singleton_1(new MethodArgument(matchValue_8[0], matchValue_8[1], false, substituteTypeParams(function (_arg2) {
              return new Type("Any", []);
            }, matchValue_8[2])));
          }, args);
        }));
        return new Member(m_2.name, new Type("Method", [args_1, retFunc]), new List(), emitter_1);
      } else {
        return null;
      }
    }, exp.members));
  };

  var objectType = void 0;
  var matchValue_9 = getTypeParameters(exp.typepars);

  if (matchValue_9.tail == null) {
    objectType = _defineProperty({
      get Members() {
        return generateMembers(function (_arg3) {
          return null;
        });
      },

      TypeEquals: function (_arg1) {
        return false;
      }
    }, _Symbol.reflection, function () {
      return {
        interfaces: ["TheGamma.ObjectType"]
      };
    });
  } else {
    objectType = _defineProperty({
      get TypeParameterCount() {
        return matchValue_9.length;
      },

      get FullName() {
        return concatUrl(url, exp.name);
      },

      get Members() {
        return fsFormat("Uninstantiated generic type definition (%s)")(function (x) {
          throw new Error(x);
        })(this.FullName);
      },

      TypeEquals: function (_arg2) {
        return fsFormat("Uninstantiated generic type definition (%s)")(function (x) {
          throw new Error(x);
        })(this.FullName);
      },
      Apply: function (tyargs) {
        var $var410 = this;
        return _defineProperty({
          get Members() {
            throw new Error("Uninstantiated generic type schema");
          },

          get TypeDefinition() {
            return $var410;
          },

          TypeEquals: function (_arg3) {
            throw new Error("Uninstantiated generic type schema");
          },
          Substitute: function (assigns) {
            var tyArgLookup = new _Map(toList(zip(matchValue_9, tyargs)));
            var members = new Lazy(function () {
              return generateMembers(function (n) {
                var matchValue = tryGetValue(tyArgLookup, n, null);

                if (matchValue[0]) {
                  return substituteTypeParams(assigns, matchValue[1]);
                } else {
                  return null;
                }
              });
            });
            var $var411 = this;
            return _defineProperty({
              get TypeArguments() {
                return map_1(function (schema) {
                  return substituteTypeParams(assigns, schema);
                }, tyargs);
              },

              get TypeDefinition() {
                return $var410;
              },

              get Members() {
                return members.value;
              },

              TypeEquals: function (t2) {
                if (hasInterface(t2, "TheGamma.TypeProviders.FSharpProvider.GenericType")) {
                  if (t2.TypeDefinition.FullName === this.TypeDefinition.FullName) {
                    return listsEqual(this.TypeArguments, t2.TypeArguments, function (t1) {
                      return function (t2_1) {
                        return typesEqual(t1, t2_1);
                      };
                    });
                  } else {
                    return false;
                  }
                } else {
                  return false;
                }
              }
            }, _Symbol.reflection, function () {
              return {
                interfaces: ["TheGamma.TypeProviders.FSharpProvider.GenericType"]
              };
            });
          },

          get TypeArguments() {
            return tyargs;
          }

        }, _Symbol.reflection, function () {
          return {
            interfaces: ["TheGamma.TypeProviders.FSharpProvider.GenericTypeSchema"]
          };
        });
      }
    }, _Symbol.reflection, function () {
      return {
        interfaces: ["TheGamma.TypeProviders.FSharpProvider.GenericTypeDefinition"]
      };
    });
  }

  return new Type("Object", [objectType]);
}
export function provideFSharpTypes(lookupNamed, url) {
  return function (builder_) {
    return builder_.Delay(function () {
      return builder_.Bind(Http.Request("GET", url), function (_arg1) {
        var expTys = JSON.parse(_arg1);
        return builder_.Return(toList(delay(function () {
          return map(function (exp) {
            var ty = importProvidedType(url, lookupNamed, exp);

            if (exp.static) {
              var e = fold(function (chain, s) {
                return chain != null ? new Expression("MemberExpression", [chain, new Expression("IdentifierExpression", [s, null]), false, null]) : new Expression("IdentifierExpression", [s, null]);
              }, null, exp.instance);
              var ty_1 = mapGenericType(ty, function (gtd) {
                return toList(delay(function () {
                  return map(function (i) {
                    return new Type("Any", []);
                  }, range(1, gtd.TypeParameterCount));
                }));
              });
              return new ProvidedType("GlobalValue", [exp.name, new List(), e, ty_1]);
            } else {
              return new ProvidedType("NamedType", [exp.name, ty]);
            }
          }, expTys);
        })));
      });
    });
  }(singleton);
}
//# sourceMappingURL=fsharp.js.map