import _Object$keys from "babel-runtime/core-js/object/keys";
import _Array$from from "babel-runtime/core-js/array/from";
import _Map from "babel-runtime/core-js/map";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { compare, compareRecords, equalsRecords, Tuple, makeGeneric, compareUnions, equalsUnions } from "fable-core/Util";
import { reverse, collect, filter, append, ofArray, concat, map } from "fable-core/List";
import List from "fable-core/List";
import { Documentation, MethodArgument, Member, Metadata as Metadata_1, Emitter, Type, PrimitiveType } from "../ast/ast";
import { escapeIdent } from "../ast/astops";
import { fsFormat, join } from "fable-core/String";
import { sumBy, exists, empty, append as append_1, singleton, collect as collect_1, count, skipWhile, fold, find, map as map_1, delay, toList } from "fable-core/Seq";
import { create } from "fable-core/Set";
import GenericComparer from "fable-core/GenericComparer";
import { ObjectMember, BabelOperators, Expression } from "../common/babel";
import { typesEqual, listsEqual } from "../ast/typeops";
import { Async$2E$CreateNamedFuture$2E$Static as Async_CreateNamedFuture_Static, Http, Log } from "../../libraries/common";
import { applyTypes } from "./fsharp";
import { unzip } from "fable-core/Array";
import { ProvidedType, ProviderHelpers } from "./providers";
import { singleton as singleton_1 } from "fable-core/AsyncBuilder";
export var GroupAggregation = function () {
  function GroupAggregation(caseName, fields) {
    _classCallCheck(this, GroupAggregation);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(GroupAggregation, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.GroupAggregation",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          ConcatValues: ["string"],
          CountAll: [],
          CountDistinct: ["string"],
          GroupKey: [],
          Mean: ["string"],
          Sum: ["string"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return GroupAggregation;
}();
setType("TheGamma.TypeProviders.Pivot.GroupAggregation", GroupAggregation);
export var WindowAggregation = function () {
  function WindowAggregation(caseName, fields) {
    _classCallCheck(this, WindowAggregation);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(WindowAggregation, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.WindowAggregation",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          FirstKey: [],
          LastKey: [],
          Max: ["string"],
          Mean: ["string"],
          MiddleKey: [],
          Min: ["string"],
          Sum: ["string"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return WindowAggregation;
}();
setType("TheGamma.TypeProviders.Pivot.WindowAggregation", WindowAggregation);
export var SortDirection = function () {
  function SortDirection(caseName, fields) {
    _classCallCheck(this, SortDirection);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(SortDirection, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.SortDirection",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Ascending: [],
          Descending: []
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return SortDirection;
}();
setType("TheGamma.TypeProviders.Pivot.SortDirection", SortDirection);
export var Paging = function () {
  function Paging(caseName, fields) {
    _classCallCheck(this, Paging);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(Paging, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.Paging",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Skip: ["string"],
          Take: ["string"]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return Paging;
}();
setType("TheGamma.TypeProviders.Pivot.Paging", Paging);
export var FilterOperator = function () {
  function FilterOperator(caseName, fields) {
    _classCallCheck(this, FilterOperator);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(FilterOperator, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.FilterOperator",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          And: [],
          Or: []
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return FilterOperator;
}();
setType("TheGamma.TypeProviders.Pivot.FilterOperator", FilterOperator);
export var RelationalOperator = function () {
  function RelationalOperator(caseName, fields) {
    _classCallCheck(this, RelationalOperator);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(RelationalOperator, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.RelationalOperator",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Equals: [],
          GreaterThan: [],
          InRange: [],
          LessThan: [],
          Like: [],
          NotEquals: []
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return RelationalOperator;
}();
setType("TheGamma.TypeProviders.Pivot.RelationalOperator", RelationalOperator);
export var Transformation = function () {
  function Transformation(caseName, fields) {
    _classCallCheck(this, Transformation);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(Transformation, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.Transformation",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          DropColumns: [makeGeneric(List, {
            T: "string"
          })],
          Empty: [],
          ExpandBy: ["string", makeGeneric(List, {
            T: WindowAggregation
          })],
          FilterBy: [FilterOperator, makeGeneric(List, {
            T: Tuple([RelationalOperator, "string", "string"])
          })],
          GetRange: ["string"],
          GetSeries: ["string", "string"],
          GetTheData: [],
          GroupBy: [makeGeneric(List, {
            T: "string"
          }), makeGeneric(List, {
            T: GroupAggregation
          })],
          Metadata: [],
          Paging: [makeGeneric(List, {
            T: Paging
          })],
          SortBy: [makeGeneric(List, {
            T: Tuple(["string", SortDirection])
          })],
          WindowBy: ["string", "string", makeGeneric(List, {
            T: WindowAggregation
          })]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return Transformation;
}();
setType("TheGamma.TypeProviders.Pivot.Transformation", Transformation);
export var Field = function () {
  function Field(name, type) {
    _classCallCheck(this, Field);

    this.Name = name;
    this.Type = type;
  }

  _createClass(Field, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.Field",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          Name: "string",
          Type: PrimitiveType
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareRecords(this, other);
    }
  }]);

  return Field;
}();
setType("TheGamma.TypeProviders.Pivot.Field", Field);
export var Transform = function (__exports) {
  var formatGroupAgg = function formatGroupAgg(_arg1) {
    if (_arg1.Case === "CountAll") {
      return "count-all";
    } else if (_arg1.Case === "CountDistinct") {
      return "count-dist " + escapeIdent(_arg1.Fields[0]);
    } else if (_arg1.Case === "ConcatValues") {
      return "concat-vals " + escapeIdent(_arg1.Fields[0]);
    } else if (_arg1.Case === "Sum") {
      return "sum " + escapeIdent(_arg1.Fields[0]);
    } else if (_arg1.Case === "Mean") {
      return "mean " + escapeIdent(_arg1.Fields[0]);
    } else {
      return "key";
    }
  };

  var formatWinAgg = function formatWinAgg(_arg1) {
    if (_arg1.Case === "MiddleKey") {
      return "mid-key";
    } else if (_arg1.Case === "LastKey") {
      return "last-key";
    } else if (_arg1.Case === "Mean") {
      return "mean " + escapeIdent(_arg1.Fields[0]);
    } else if (_arg1.Case === "Min") {
      return "min " + escapeIdent(_arg1.Fields[0]);
    } else if (_arg1.Case === "Max") {
      return "max " + escapeIdent(_arg1.Fields[0]);
    } else if (_arg1.Case === "Sum") {
      return "sum " + escapeIdent(_arg1.Fields[0]);
    } else {
      return "first-key";
    }
  };

  var formatCondition = __exports.formatCondition = function (op, f, v) {
    var op_1 = op.Case === "NotEquals" ? "neq" : op.Case === "LessThan" ? "lte" : op.Case === "GreaterThan" ? "gte" : op.Case === "InRange" ? "in" : op.Case === "Like" ? "like" : "eq";
    return escapeIdent(f) + " " + op_1 + " " + escapeIdent(v);
  };

  var toUrl = __exports.toUrl = function (transforms) {
    return join("$", map(function (tupledArg) {
      return tupledArg[1].tail == null ? tupledArg[0] : tupledArg[0] + "(" + join(",", tupledArg[1]) + ")";
    }, concat(toList(delay(function () {
      return map_1(function (t) {
        return t.Case === "Metadata" ? ofArray([["metadata", new List()]]) : t.Case === "GetRange" ? ofArray([["range", ofArray([t.Fields[0]])]]) : t.Case === "FilterBy" ? ofArray([["filter", new List(t.Fields[0].Case === "Or" ? "or" : "and", map(function (tupledArg_1) {
          return formatCondition(tupledArg_1[0], tupledArg_1[1], tupledArg_1[2]);
        }, t.Fields[1]))]]) : t.Case === "DropColumns" ? ofArray([["drop", t.Fields[0]]]) : t.Case === "SortBy" ? ofArray([["sort", map(function (tupledArg_2) {
          return tupledArg_2[0] + (tupledArg_2[1].Equals(new SortDirection("Ascending", [])) ? " asc" : " desc");
        }, t.Fields[0])]]) : t.Case === "GroupBy" ? ofArray([["groupby", append(map(function (fld) {
          return "by " + escapeIdent(fld);
        }, t.Fields[0]), map(function (_arg1) {
          return formatGroupAgg(_arg1);
        }, t.Fields[1]))]]) : t.Case === "WindowBy" ? ofArray([["windowby", ofArray(["by " + escapeIdent(t.Fields[0]), t.Fields[1]], map(function (_arg1_1) {
          return formatWinAgg(_arg1_1);
        }, t.Fields[2]))]]) : t.Case === "ExpandBy" ? ofArray([["expandby", new List("by " + escapeIdent(t.Fields[0]), map(function (_arg1_2) {
          return formatWinAgg(_arg1_2);
        }, t.Fields[1]))]]) : t.Case === "Paging" ? map(function (_arg1_3) {
          return _arg1_3.Case === "Skip" ? ["skip", ofArray([_arg1_3.Fields[0]])] : ["take", ofArray([_arg1_3.Fields[0]])];
        }, t.Fields[0]) : t.Case === "GetSeries" ? ofArray([["series", ofArray([t.Fields[0], t.Fields[1]])]]) : t.Case === "Empty" ? new List() : new List();
      }, transforms);
    })))));
  };

  var singleTransformFields = __exports.singleTransformFields = function (fields, _arg1) {
    var $var446 = _arg1.Case === "Metadata" ? [1] : _arg1.Case === "GetRange" ? [2] : _arg1.Case === "GetTheData" ? [3] : _arg1.Case === "SortBy" ? [4] : _arg1.Case === "Paging" ? [5] : _arg1.Case === "FilterBy" ? [6] : _arg1.Case === "GetSeries" ? [7] : _arg1.Case === "DropColumns" ? [8] : _arg1.Case === "ExpandBy" ? [9, _arg1.Fields[1], _arg1.Fields[0]] : _arg1.Case === "WindowBy" ? [9, _arg1.Fields[2], _arg1.Fields[0]] : _arg1.Case === "GroupBy" ? [10] : [0];

    switch ($var446[0]) {
      case 0:
        return fields;

      case 1:
        throw new Error("Metadata should not appear in normal queries");

      case 2:
        throw new Error("GetRange should not appear in normal queries");

      case 3:
        return fields;

      case 4:
        return fields;

      case 5:
        return fields;

      case 6:
        return fields;

      case 7:
        return ofArray([find(function (f) {
          return f.Name === _arg1.Fields[0];
        }, fields), find(function (f_1) {
          return f_1.Name === _arg1.Fields[1];
        }, fields)]);

      case 8:
        var dropped = create(_arg1.Fields[0], new GenericComparer(compare));
        return filter(function (f_2) {
          return !dropped.has(f_2.Name);
        }, fields);

      case 9:
        var oldFields = new _Map(toList(delay(function () {
          return map_1(function (f_3) {
            return [f_3.Name, f_3];
          }, fields);
        })));
        return collect(function (_arg2) {
          var $var447 = _arg2.Case === "MiddleKey" ? [1] : _arg2.Case === "LastKey" ? [2] : _arg2.Case === "Mean" ? [3, _arg2.Fields[0]] : _arg2.Case === "Min" ? [3, _arg2.Fields[0]] : _arg2.Case === "Sum" ? [3, _arg2.Fields[0]] : _arg2.Case === "Max" ? [3, _arg2.Fields[0]] : [0];

          switch ($var447[0]) {
            case 0:
              return ofArray([new Field("first " + $var446[2], oldFields.get($var446[2]).Type)]);

            case 1:
              return ofArray([new Field("middle " + $var446[2], oldFields.get($var446[2]).Type)]);

            case 2:
              return ofArray([new Field("last " + $var446[2], oldFields.get($var446[2]).Type)]);

            case 3:
              return ofArray([oldFields.get($var447[1])]);
          }
        }, $var446[1]);

      case 10:
        var oldFields_1 = new _Map(toList(delay(function () {
          return map_1(function (f_4) {
            return [f_4.Name, f_4];
          }, fields);
        })));
        return collect(function (_arg3) {
          var $var448 = _arg3.Case === "ConcatValues" ? [1, _arg3.Fields[0]] : _arg3.Case === "Sum" ? [1, _arg3.Fields[0]] : _arg3.Case === "Mean" ? [2] : _arg3.Case === "CountAll" ? [3] : _arg3.Case === "CountDistinct" ? [4] : [0];

          switch ($var448[0]) {
            case 0:
              return map(function (f_5) {
                return oldFields_1.get(f_5);
              }, _arg1.Fields[0]);

            case 1:
              return ofArray([oldFields_1.get($var448[1])]);

            case 2:
              return ofArray([oldFields_1.get(_arg3.Fields[0])]);

            case 3:
              return ofArray([new Field("count", new PrimitiveType("Number", []))]);

            case 4:
              return ofArray([new Field(oldFields_1.get(_arg3.Fields[0]).Name, new PrimitiveType("Number", []))]);
          }
        }, _arg1.Fields[1]);
    }
  };

  var transformFields = __exports.transformFields = function (fields, tfs) {
    return toList(function () {
      var state = toList(fields);
      return function (list) {
        return fold(function (fields_1, _arg1) {
          return singleTransformFields(fields_1, _arg1);
        }, state, list);
      };
    }()(tfs));
  };

  return __exports;
}({});
export function trimLeft(c, s) {
  return _Array$from(skipWhile(function (y) {
    return c === y;
  }, s.split(""))).join('');
}
export function trimRight(c, s) {
  return _Array$from(skipWhile(function (y) {
    return c === y;
  }, s.split("").slice().reverse())).slice().reverse().join('');
}
export function concatUrl(a, b) {
  return trimRight("/", a) + "/" + trimLeft("/", b);
}
export var PivotObject = function () {
  _createClass(PivotObject, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.PivotObject",
        interfaces: ["TheGamma.ObjectType"],
        properties: {
          MemberNames: makeGeneric(List, {
            T: "string"
          })
        }
      };
    }
  }]);

  function PivotObject(members) {
    _classCallCheck(this, PivotObject);

    this.members = members;
  }

  _createClass(PivotObject, [{
    key: "TypeEquals",
    value: function (y) {
      if (y instanceof PivotObject) {
        return y.MemberNames.Equals(this.MemberNames);
      } else {
        return false;
      }
    }
  }, {
    key: "MemberNames",
    get: function () {
      var _this2 = this;

      return toList(delay(function () {
        return map_1(function (m) {
          return m.Name;
        }, _this2.members);
      }));
    }
  }, {
    key: "Members",
    get: function () {
      return _Array$from(this.members);
    }
  }]);

  return PivotObject;
}();
setType("TheGamma.TypeProviders.Pivot.PivotObject", PivotObject);
export function makeObjectType(members) {
  return new Type("Object", [new PivotObject(members)]);
}
export function isNumeric(fld) {
  return fld.Equals(new PrimitiveType("Number", []));
}
export function isBool(fld) {
  return fld.Equals(new PrimitiveType("Bool", []));
}
export function isDate(fld) {
  return fld.Equals(new PrimitiveType("Date", []));
}
export function isConcatenable(fld) {
  return fld.Equals(new PrimitiveType("String", []));
}
export function getTypeAndEmitter(_arg1) {
  if (_arg1.Case === "Date") {
    return [new Type("Primitive", [new PrimitiveType("String", [])]), function (e) {
      return new Expression("NewExpression", [BabelOperators.ident("Date"), ofArray([BabelOperators.op_DivideAtDivide(BabelOperators.op_Dynamic(BabelOperators.ident("Date"), "parse"), ofArray([e]))]), null]);
    }];
  } else if (_arg1.Case === "Number") {
    return [new Type("Primitive", [new PrimitiveType("Number", [])]), function (e_1) {
      return BabelOperators.op_DivideAtDivide(BabelOperators.ident("Number"), ofArray([e_1]));
    }];
  } else if (_arg1.Case === "Bool") {
    return [new Type("Primitive", [new PrimitiveType("Number", [])]), function (e_2) {
      return BabelOperators.op_DivideAtDivide(BabelOperators.ident("Boolean"), ofArray([e_2]));
    }];
  } else if (_arg1.Case === "Unit") {
    return [new Type("Primitive", [new PrimitiveType("Unit", [])]), function (e_3) {
      return new Expression("NullLiteral", [null]);
    }];
  } else {
    return [new Type("Primitive", [new PrimitiveType("String", [])]), function (x) {
      return x;
    }];
  }
}
export var propertyEmitter = new Emitter(function (_this) {
  return _this;
});
export function makeMethodEmitter(callid, pars) {
  return new Emitter(function (_this) {
    return BabelOperators.funcN(count(pars), function (args) {
      var args_1 = BabelOperators.arr(toList(delay(function () {
        return map_1(function (v) {
          return v;
        }, args);
      })));
      return BabelOperators.op_DivideAtDivide(BabelOperators.op_Dynamic(_this, "addCall"), ofArray([BabelOperators.str(callid), args_1]));
    });
  });
}
export function makeDataEmitter(isPreview, isSeries, convValues, tfs) {
  return new Emitter(function (_this) {
    return isSeries ? BabelOperators.op_DivideAtDivide(BabelOperators.op_Dynamic(BabelOperators.ident("series"), "create"), ofArray([BabelOperators.op_DivideAtDivide(BabelOperators.op_Dynamic(_this, "getData"), ofArray([convValues, BabelOperators.str(Transform.toUrl(reverse(tfs))), BabelOperators.bool(isPreview)])), BabelOperators.str("key"), BabelOperators.str("value"), BabelOperators.str("")])) : BabelOperators.op_DivideAtDivide(BabelOperators.op_Dynamic(BabelOperators.ident("series"), "ordinal"), ofArray([BabelOperators.op_DivideAtDivide(BabelOperators.op_Dynamic(_this, "getData"), ofArray([convValues, BabelOperators.str(Transform.toUrl(reverse(tfs))), BabelOperators.bool(isPreview)])), BabelOperators.str("key"), BabelOperators.str("value"), BabelOperators.str("")]));
  });
}
export var Context = function () {
  function Context(root, ignoreFiltersInRange, lookupNamed, inputFields, fields) {
    _classCallCheck(this, Context);

    this.Root = root;
    this.IgnoreFiltersInRange = ignoreFiltersInRange;
    this.LookupNamed = lookupNamed;
    this.InputFields = inputFields;
    this.Fields = fields;
  }

  _createClass(Context, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.Pivot.Context",
        interfaces: ["FSharpRecord"],
        properties: {
          Root: "string",
          IgnoreFiltersInRange: "boolean",
          LookupNamed: "function",
          InputFields: makeGeneric(List, {
            T: Field
          }),
          Fields: makeGeneric(List, {
            T: Field
          })
        }
      };
    }
  }]);

  return Context;
}();
setType("TheGamma.TypeProviders.Pivot.Context", Context);
export function makeProperty(ctx, name, tfs) {
  var meta1 = new Metadata_1("http://schema.thegamma.net/pivot", "Transformations", tfs);
  var meta2 = new Metadata_1("http://schema.thegamma.net/pivot", "Fields", ctx.Fields);
  return new Member(name, makePivotType(ctx, tfs), ofArray([meta1, meta2]), propertyEmitter);
}
export function makeMethod(ctx, name, tfs, callid, args) {
  var meta1 = new Metadata_1("http://schema.thegamma.net/pivot", "Transformations", tfs);
  var meta2 = new Metadata_1("http://schema.thegamma.net/pivot", "Fields", ctx.Fields);
  var Metadata = ofArray([meta1, meta2]);
  return new Member(name, new Type("Method", [toList(delay(function () {
    return collect_1(function (matchValue) {
      return singleton(new MethodArgument(matchValue[0], false, false, new Type("Primitive", [matchValue[1]])));
    }, args);
  })), function (ts) {
    var ts_1 = map(function (tuple) {
      return tuple[0];
    }, ts);

    if (listsEqual(ts_1, args, function (t1) {
      return function (tupledArg) {
        return typesEqual(t1, new Type("Primitive", [tupledArg[1]]));
      };
    })) {
      return makePivotType(ctx, tfs);
    } else {
      return null;
    }
  }]), Metadata, makeMethodEmitter(callid, args));
}
export function makeDataMember(ctx, name, isPreview, tfs) {
  var fields = Transform.transformFields(ctx.InputFields, reverse(tfs));
  Log.trace("providers", "Make data member using transform %O. Got fields: %O", tfs, fields);
  var patternInput_2 = void 0;
  var $var449 = tfs.tail != null ? tfs.head.Case === "GetSeries" ? [0] : [1] : [1];

  switch ($var449[0]) {
    case 0:
      var $var450 = fields.tail != null ? fields.tail.tail != null ? fields.tail.tail.tail == null ? [0, fields.head, fields.tail.head] : [1] : [1] : [1];

      switch ($var450[0]) {
        case 0:
          patternInput_2 = [true, applyTypes(ctx.LookupNamed("series"), ofArray([new Type("Primitive", [$var450[1].Type]), new Type("Primitive", [$var450[2].Type])])), BabelOperators.func("o", function (arg) {
            return BabelOperators.arr(ofArray([getTypeAndEmitter($var450[1].Type)[1](BabelOperators.op_DivideQmarkDivide(arg, BabelOperators.num(0))), getTypeAndEmitter($var450[2].Type)[1](BabelOperators.op_DivideQmarkDivide(arg, BabelOperators.num(1)))]));
          })];
          break;

        case 1:
          throw new Error("makeDataMember: Series should have key and value");
          break;
      }

      break;

    case 1:
      var patternInput_1 = unzip(_Array$from(fields).map(function (fld) {
        var patternInput = getTypeAndEmitter(fld.Type);
        var emitter = new Emitter(function (inst) {
          return BabelOperators.op_DivideQmarkDivide(inst, BabelOperators.str(fld.Name));
        });
        return [[fld.Name, patternInput[1]], new Member(fld.Name, patternInput[0], ofArray([ProviderHelpers.docMeta(new Documentation("Text", [""]))]), emitter)];
      }));
      var recTyp = makeObjectType(patternInput_1[1]);
      patternInput_2 = [false, applyTypes(ctx.LookupNamed("series"), ofArray([new Type("Primitive", [new PrimitiveType("Number", [])]), recTyp])), BabelOperators.func("o", function (arg_1) {
        var mems = toList(delay(function () {
          return collect_1(function (matchValue) {
            return singleton(new ObjectMember("ObjectProperty", [BabelOperators.str(matchValue[0]), matchValue[1](BabelOperators.op_DivideQmarkDivide(arg_1, BabelOperators.str(matchValue[0]))), true, null]));
          }, patternInput_1[0]);
        }));
        return new Expression("ObjectExpression", [mems, null]);
      })];
      break;
  }

  var tfs_1 = patternInput_2[0] ? tfs : new List(new Transformation("GetTheData", []), tfs);
  var meta = toList(delay(function () {
    return append_1(singleton(new Metadata_1("http://schema.thegamma.net/pivot", "Transformations", tfs_1)), delay(function () {
      return append_1(singleton(new Metadata_1("http://schema.thegamma.net/pivot", "Fields", ctx.Fields)), delay(function () {
        return isPreview ? singleton(new Metadata_1("http://schema.thegamma.net", "CompletionItem", {
          hidden: true
        })) : empty();
      }));
    }));
  }));
  return new Member(name, patternInput_2[1], meta, makeDataEmitter(isPreview, patternInput_2[0], patternInput_2[2], tfs_1));
}
export function handleGetSeriesRequest(ctx, rest, k, v) {
  var matchValue = [k, v];
  var $var451 = matchValue[0] === "!" ? matchValue[1] === "!" ? [0] : [2] : matchValue[1] === "!" ? [1] : [2];

  switch ($var451[0]) {
    case 0:
      return makeObjectType(toList(delay(function () {
        return map_1(function (field) {
          return makeProperty(ctx, "with key " + field.Name, new List(new Transformation("GetSeries", [field.Name, "!"]), rest));
        }, ctx.Fields);
      })));

    case 1:
      return makeObjectType(toList(delay(function () {
        return map_1(function (field_1) {
          return makeDataMember(ctx, "and value " + field_1.Name, false, new List(new Transformation("GetSeries", [matchValue[0], field_1.Name]), rest));
        }, ctx.Fields);
      })));

    case 2:
      throw new Error("handleGetSeriesRequest: Should not happen");
  }
}
export function handlePagingRequest(ctx, rest, pgid, ops) {
  var takeMemb = makeMethod(ctx, "take", ofArray([new Transformation("Empty", []), new Transformation("Paging", [reverse(new List(new Paging("Take", [pgid + "-take"]), ops))])], rest), pgid + "-take", ofArray([["count", new PrimitiveType("Number", [])]]));
  var skipMemb = makeMethod(ctx, "skip", new List(new Transformation("Paging", [new List(new Paging("Skip", [pgid + "-skip"]), ops)]), rest), pgid + "-skip", ofArray([["count", new PrimitiveType("Number", [])]]));
  var thenMemb = makeProperty(ctx, "then", ofArray([new Transformation("Empty", []), new Transformation("Paging", [reverse(ops)])], rest));
  return makeObjectType(function () {
    var $var452 = ops.tail != null ? ops.head.Case === "Skip" ? ops.tail.tail == null ? [1] : [2] : [2] : [0];

    switch ($var452[0]) {
      case 0:
        return ofArray([skipMemb, takeMemb, thenMemb]);

      case 1:
        return ofArray([takeMemb, thenMemb]);

      case 2:
        throw new Error("handlePagingRequest: Shold not happen");
    }
  }());
}
export function handleDropRequest(ctx, rest, dropped) {
  var droppedFields = create(dropped, new GenericComparer(compare));
  return makeObjectType(toList(delay(function () {
    return append_1(singleton(makeProperty(ctx, "then", ofArray([new Transformation("Empty", []), new Transformation("DropColumns", [dropped])], rest))), delay(function () {
      return collect_1(function (field) {
        return !droppedFields.has(field.Name) ? singleton(makeProperty(ctx, "drop " + field.Name, new List(new Transformation("DropColumns", [new List(field.Name, dropped)]), rest))) : empty();
      }, ctx.Fields);
    }));
  })));
}
export function handleSortRequest(ctx, rest, keys) {
  var usedKeys = create(map(function (tuple) {
    return tuple[0];
  }, keys), new GenericComparer(compare));
  return makeObjectType(toList(delay(function () {
    return append_1(singleton(makeProperty(ctx, "then", ofArray([new Transformation("Empty", []), new Transformation("SortBy", [keys])], rest))), delay(function () {
      return collect_1(function (field) {
        if (!usedKeys.has(field.Name)) {
          var doc = fsFormat("Use the field '%s' as the next sorting keys")(function (x) {
            return x;
          })(field.Name);
          var prefix = keys.Equals(new List()) ? "by " : "and by ";
          return append_1(singleton(makeProperty(ctx, prefix + field.Name, new List(new Transformation("SortBy", [new List([field.Name, new SortDirection("Ascending", [])], keys)]), rest))), delay(function () {
            return singleton(makeProperty(ctx, prefix + field.Name + " descending", new List(new Transformation("SortBy", [new List([field.Name, new SortDirection("Descending", [])], keys)]), rest)));
          }));
        } else {
          return empty();
        }
      }, ctx.Fields);
    }));
  })));
}
export function handleWindowRequest(ctx, rest, wndid) {
  return makeObjectType(toList(delay(function () {
    return collect_1(function (field) {
      return (isDate(field.Type) ? true : isNumeric(field.Type)) ? append_1(singleton(makeMethod(ctx, "window by " + field.Name, new List(new Transformation("WindowBy", [field.Name, wndid, new List()]), rest), wndid, ofArray([["size", new PrimitiveType("Number", [])]]))), delay(function () {
        return singleton(makeProperty(ctx, "expanding by " + field.Name, new List(new Transformation("ExpandBy", [field.Name, ofArray([new WindowAggregation("LastKey", [])])]), rest)));
      })) : empty();
    }, ctx.Fields);
  })));
}
export function handleWindowExpandAggRequest(ctx, rest, fld, make, aggs) {
  var containsKey = exists(function (_arg1) {
    var $var453 = _arg1.Case === "FirstKey" ? [0] : _arg1.Case === "LastKey" ? [0] : _arg1.Case === "MiddleKey" ? [0] : [1];

    switch ($var453[0]) {
      case 0:
        return true;

      case 1:
        return false;
    }
  }, aggs);

  var containsField = function containsField(fld_1) {
    return exists(function (_arg2) {
      var $var454 = _arg2.Case === "Max" ? [0, _arg2.Fields[0]] : _arg2.Case === "Min" ? [0, _arg2.Fields[0]] : _arg2.Case === "Mean" ? [0, _arg2.Fields[0]] : _arg2.Case === "FirstKey" ? [1] : _arg2.Case === "LastKey" ? [1] : _arg2.Case === "MiddleKey" ? [1] : [0, _arg2.Fields[0]];

      switch ($var454[0]) {
        case 0:
          return $var454[1] === fld_1;

        case 1:
          return false;
      }
    }, aggs);
  };

  var makeAggMember = function makeAggMember(name) {
    return function (agg) {
      return makeProperty(ctx, name, new List(make(append(aggs, ofArray([agg]))), rest));
    };
  };

  return makeObjectType(toList(delay(function () {
    return append_1(!(aggs.tail == null) ? singleton(makeProperty(ctx, "then", ofArray([new Transformation("Empty", []), make(aggs)], rest))) : empty(), delay(function () {
      return append_1(!containsKey ? append_1(singleton(makeAggMember("first " + fld)(new WindowAggregation("FirstKey", []))), delay(function () {
        return append_1(singleton(makeAggMember("last " + fld)(new WindowAggregation("LastKey", []))), delay(function () {
          return singleton(makeAggMember("middle " + fld)(new WindowAggregation("MiddleKey", [])));
        }));
      })) : empty(), delay(function () {
        return collect_1(function (fld_2) {
          return !containsField(fld_2.Name) ? (isNumeric(fld_2.Type) ? true : isBool(fld_2.Type)) ? append_1(singleton(makeAggMember("min " + fld_2.Name)(new WindowAggregation("Min", [fld_2.Name]))), delay(function () {
            return append_1(singleton(makeAggMember("sum " + fld_2.Name)(new WindowAggregation("Sum", [fld_2.Name]))), delay(function () {
              return append_1(singleton(makeAggMember("max " + fld_2.Name)(new WindowAggregation("Max", [fld_2.Name]))), delay(function () {
                return singleton(makeAggMember("mean " + fld_2.Name)(new WindowAggregation("Mean", [fld_2.Name])));
              }));
            }));
          })) : empty() : empty();
        }, ctx.Fields);
      }));
    }));
  })));
}
export function aggregationMembers(ctx, rest, keys, aggs) {
  var containsCountAll = exists(function () {
    var x = new GroupAggregation("CountAll", []);
    return function (y) {
      return x.Equals(y);
    };
  }(), aggs);

  var containsField = function containsField(fld) {
    return exists(function (_arg3) {
      var $var455 = _arg3.Case === "ConcatValues" ? [0, _arg3.Fields[0]] : _arg3.Case === "Sum" ? [0, _arg3.Fields[0]] : _arg3.Case === "Mean" ? [0, _arg3.Fields[0]] : _arg3.Case === "CountAll" ? [1] : _arg3.Case === "GroupKey" ? [1] : [0, _arg3.Fields[0]];

      switch ($var455[0]) {
        case 0:
          return $var455[1] === fld;

        case 1:
          return false;
      }
    }, aggs);
  };

  var makeAggMember = function makeAggMember(name) {
    return function (agg) {
      return makeProperty(ctx, name, new List(new Transformation("GroupBy", [keys, append(aggs, ofArray([agg]))]), rest));
    };
  };

  return toList(delay(function () {
    return append_1(singleton(makeProperty(ctx, "then", ofArray([new Transformation("Empty", []), new Transformation("GroupBy", [keys, aggs])], rest))), delay(function () {
      return append_1(!containsCountAll ? singleton(makeAggMember("count all")(new GroupAggregation("CountAll", []))) : empty(), delay(function () {
        return collect_1(function (fld_1) {
          return !containsField(fld_1.Name) ? append_1(singleton(makeAggMember("count distinct " + fld_1.Name)(new GroupAggregation("CountDistinct", [fld_1.Name]))), delay(function () {
            return append_1(isConcatenable(fld_1.Type) ? singleton(makeAggMember("concatenate values of " + fld_1.Name)(new GroupAggregation("ConcatValues", [fld_1.Name]))) : empty(), delay(function () {
              return (isNumeric(fld_1.Type) ? true : isBool(fld_1.Type)) ? append_1(singleton(makeAggMember("average " + fld_1.Name)(new GroupAggregation("Mean", [fld_1.Name]))), delay(function () {
                return singleton(makeAggMember("sum " + fld_1.Name)(new GroupAggregation("Sum", [fld_1.Name])));
              })) : empty();
            }));
          })) : empty();
        }, ctx.Fields);
      }));
    }));
  }));
}
export function handleGroupAggRequest(ctx, rest, keys, aggs) {
  return makeObjectType(aggregationMembers(ctx, rest, keys, aggs));
}
export function handleGroupRequest(ctx, rest, keys) {
  var prefix = keys.tail == null ? "by " : "and ";
  return makeObjectType(toList(delay(function () {
    return append_1(map_1(function (field) {
      return makeProperty(ctx, prefix + field.Name, new List(new Transformation("GroupBy", [new List(field.Name, keys), new List()]), rest));
    }, ctx.Fields), delay(function () {
      return !(keys.tail == null) ? aggregationMembers(ctx, rest, keys, ofArray([new GroupAggregation("GroupKey", [])])) : empty();
    }));
  })));
}
export function handleFilterEqNeqRequest(ctx, rest, fld, eq, op, conds) {
  return function (builder_) {
    return builder_.Delay(function () {
      var tfs = op.Equals(new FilterOperator("Or", [])) ? rest : conds.tail == null ? rest : new List(new Transformation("FilterBy", [op, conds]), rest);
      var tfs_1 = filter(function (_arg4) {
        var $var456 = _arg4.Case === "FilterBy" ? ctx.IgnoreFiltersInRange ? [0] : [1] : [1];

        switch ($var456[0]) {
          case 0:
            return false;

          case 1:
            var $var457 = _arg4.Case === "FilterBy" ? exists(function (_arg5) {
              var $var458 = _arg5[0].Case === "Equals" ? [0] : _arg5[0].Case === "NotEquals" ? [0] : [1];

              switch ($var458[0]) {
                case 0:
                  return false;

                case 1:
                  return true;
              }
            }, _arg4.Fields[1]) ? [0, _arg4.Fields[1]] : [1] : [1];

            switch ($var457[0]) {
              case 0:
                return false;

              case 1:
                return true;
            }

        }
      }, tfs);
      var url = ctx.Root + "?" + encodeURIComponent(Transform.toUrl(reverse(new List(new Transformation("GetRange", [fld]), tfs_1))));
      return builder_.Bind(Http.Request("GET", url), function (_arg6) {
        var options = JSON.parse(_arg6);
        return builder_.Return(makeObjectType(toList(delay(function () {
          return map_1(function (opt) {
            return makeProperty(ctx, opt, new List(new Transformation("FilterBy", [op, new List([eq, fld, opt], conds)]), rest));
          }, options);
        }))));
      });
    });
  }(singleton_1);
}
export function handleFilterRequest(ctx, rest, flid, op, conds) {
  var prefixes = void 0;
  var matchValue = [conds, op];

  if (matchValue[0].tail != null) {
    if (matchValue[0].tail.tail == null) {
      prefixes = ofArray([["and ", new FilterOperator("And", [])], ["or ", new FilterOperator("Or", [])]]);
    } else if (matchValue[1].Case === "Or") {
      prefixes = ofArray([["or ", new FilterOperator("Or", [])]]);
    } else {
      prefixes = ofArray([["and ", new FilterOperator("And", [])]]);
    }
  } else {
    prefixes = ofArray([["", new FilterOperator("And", [])]]);
  }

  return makeObjectType(toList(delay(function () {
    return append_1(collect_1(function (matchValue_1) {
      return collect_1(function (field) {
        return append_1(field.Type.Equals(new PrimitiveType("String", [])) ? append_1(singleton(makeProperty(ctx, matchValue_1[0] + field.Name + " is", new List(new Transformation("FilterBy", [matchValue_1[1], new List([new RelationalOperator("Equals", []), field.Name, "!"], conds)]), rest))), delay(function () {
          return append_1(singleton(makeProperty(ctx, matchValue_1[0] + field.Name + " is not", new List(new Transformation("FilterBy", [matchValue_1[1], new List([new RelationalOperator("NotEquals", []), field.Name, "!"], conds)]), rest))), delay(function () {
            return singleton(makeMethod(ctx, matchValue_1[0] + field.Name + " contains", new List(new Transformation("FilterBy", [matchValue_1[1], new List([new RelationalOperator("Like", []), field.Name, flid], conds)]), rest), flid, ofArray([["text", new PrimitiveType("String", [])]])));
          }));
        })) : empty(), delay(function () {
          return append_1(field.Type.Equals(new PrimitiveType("Number", [])) ? append_1(singleton(makeMethod(ctx, matchValue_1[0] + field.Name + " is less than", new List(new Transformation("FilterBy", [matchValue_1[1], new List([new RelationalOperator("LessThan", []), field.Name, flid], conds)]), rest), flid, ofArray([["value", new PrimitiveType("Number", [])]]))), delay(function () {
            return append_1(singleton(makeMethod(ctx, matchValue_1[0] + field.Name + " is greater than", new List(new Transformation("FilterBy", [matchValue_1[1], new List([new RelationalOperator("GreaterThan", []), field.Name, flid], conds)]), rest), flid, ofArray([["value", new PrimitiveType("Number", [])]]))), delay(function () {
              return singleton(makeMethod(ctx, matchValue_1[0] + field.Name + " is in range", new List(new Transformation("FilterBy", [matchValue_1[1], new List([new RelationalOperator("InRange", []), field.Name, flid], conds)]), rest), flid, ofArray([["minimum", new PrimitiveType("Number", [])], ["maximum", new PrimitiveType("Number", [])]])));
            }));
          })) : empty(), delay(function () {
            return field.Type.Equals(new PrimitiveType("Date", [])) ? append_1(singleton(makeMethod(ctx, matchValue_1[0] + field.Name + " is less than", new List(new Transformation("FilterBy", [matchValue_1[1], new List([new RelationalOperator("LessThan", []), field.Name, flid], conds)]), rest), flid, ofArray([["value", new PrimitiveType("Date", [])]]))), delay(function () {
              return append_1(singleton(makeMethod(ctx, matchValue_1[0] + field.Name + " is greater than", new List(new Transformation("FilterBy", [matchValue_1[1], new List([new RelationalOperator("GreaterThan", []), field.Name, flid], conds)]), rest), flid, ofArray([["value", new PrimitiveType("Date", [])]]))), delay(function () {
                return singleton(makeMethod(ctx, matchValue_1[0] + field.Name + " is in range", new List(new Transformation("FilterBy", [matchValue_1[1], new List([new RelationalOperator("InRange", []), field.Name, flid], conds)]), rest), flid, ofArray([["minimum", new PrimitiveType("Date", [])], ["maximum", new PrimitiveType("Date", [])]])));
              }));
            })) : empty();
          }));
        }));
      }, ctx.Fields);
    }, prefixes), delay(function () {
      return !(conds.tail == null) ? singleton(makeProperty(ctx, "then", ofArray([new Transformation("Empty", []), new Transformation("FilterBy", [op, conds])], rest))) : empty();
    }));
  })));
}
export function makePivotTypeImmediate(ctx, tfs) {
  return function (builder_) {
    return builder_.Delay(function () {
      var patternInput = tfs.tail != null ? [tfs.head, tfs.tail] : [new Transformation("Empty", []), new List()];
      var ctx_1 = void 0;
      var Fields = Transform.transformFields(ctx.InputFields, reverse(patternInput[1]));
      ctx_1 = new Context(ctx.Root, ctx.IgnoreFiltersInRange, ctx.LookupNamed, ctx.InputFields, Fields);
      var $var459 = patternInput[0].Case === "GetSeries" ? [1, patternInput[0].Fields[0], patternInput[0].Fields[1]] : patternInput[0].Case === "Paging" ? [2, patternInput[0].Fields[0]] : patternInput[0].Case === "SortBy" ? [3, patternInput[0].Fields[0]] : patternInput[0].Case === "DropColumns" ? [4, patternInput[0].Fields[0]] : patternInput[0].Case === "FilterBy" ? patternInput[0].Fields[1].tail != null ? patternInput[0].Fields[1].head[0].Case === "Equals" ? patternInput[0].Fields[1].head[2] === "!" ? [5, patternInput[0].Fields[1].tail, patternInput[0].Fields[1].head[1], patternInput[0].Fields[0], patternInput[0].Fields[1].head[0]] : [6, patternInput[0].Fields[1], patternInput[0].Fields[0]] : patternInput[0].Fields[1].head[0].Case === "NotEquals" ? patternInput[0].Fields[1].head[2] === "!" ? [5, patternInput[0].Fields[1].tail, patternInput[0].Fields[1].head[1], patternInput[0].Fields[0], patternInput[0].Fields[1].head[0]] : [6, patternInput[0].Fields[1], patternInput[0].Fields[0]] : [6, patternInput[0].Fields[1], patternInput[0].Fields[0]] : [6, patternInput[0].Fields[1], patternInput[0].Fields[0]] : patternInput[0].Case === "WindowBy" ? patternInput[0].Fields[0] === "!" ? patternInput[0].Fields[1] === "!" ? patternInput[0].Fields[2].tail == null ? [7] : [8, patternInput[0].Fields[2], patternInput[0].Fields[0], patternInput[0].Fields[1]] : [8, patternInput[0].Fields[2], patternInput[0].Fields[0], patternInput[0].Fields[1]] : [8, patternInput[0].Fields[2], patternInput[0].Fields[0], patternInput[0].Fields[1]] : patternInput[0].Case === "ExpandBy" ? [9, patternInput[0].Fields[1], patternInput[0].Fields[0]] : patternInput[0].Case === "GroupBy" ? patternInput[0].Fields[1].tail == null ? [10, patternInput[0].Fields[0]] : [11, patternInput[0].Fields[1], patternInput[0].Fields[0]] : patternInput[0].Case === "GetTheData" ? [12] : patternInput[0].Case === "GetRange" ? [12] : patternInput[0].Case === "Metadata" ? [12] : [0];

      switch ($var459[0]) {
        case 0:
          return builder_.Return(makeObjectType(toList(delay(function () {
            return append_1(singleton(makeProperty(ctx_1, "group data", new List(new Transformation("GroupBy", [new List(), new List()]), patternInput[1]))), delay(function () {
              return append_1(singleton(makeProperty(ctx_1, "filter data", new List(new Transformation("FilterBy", [new FilterOperator("And", []), new List()]), patternInput[1]))), delay(function () {
                return append_1(singleton(makeProperty(ctx_1, "sort data", new List(new Transformation("SortBy", [new List()]), patternInput[1]))), delay(function () {
                  return append_1(singleton(makeProperty(ctx_1, "drop columns", new List(new Transformation("DropColumns", [new List()]), patternInput[1]))), delay(function () {
                    return append_1(singleton(makeProperty(ctx_1, "paging", new List(new Transformation("Paging", [new List()]), patternInput[1]))), delay(function () {
                      return append_1(singleton(makeProperty(ctx_1, "get series", new List(new Transformation("GetSeries", ["!", "!"]), patternInput[1]))), delay(function () {
                        return append_1(singleton(makeDataMember(ctx_1, "get the data", false, patternInput[1])), delay(function () {
                          return exists(function (fld) {
                            return fld.Type.Equals(new PrimitiveType("Date", [])) ? true : fld.Type.Equals(new PrimitiveType("Number", []));
                          }, ctx_1.Fields) ? singleton(makeProperty(ctx_1, "windowing", new List(new Transformation("WindowBy", ["!", "!", new List()]), patternInput[1]))) : empty();
                        }));
                      }));
                    }));
                  }));
                }));
              }));
            }));
          }))));

        case 1:
          return builder_.Return(handleGetSeriesRequest(ctx_1, patternInput[1], $var459[1], $var459[2]));

        case 2:
          var pgid = fsFormat("pgid-%d")(function (x) {
            return x;
          })(sumBy(function (_arg7) {
            return _arg7.Case === "Paging" ? 1 : 0;
          }, patternInput[1]));
          return builder_.Return(handlePagingRequest(ctx_1, patternInput[1], pgid, $var459[1]));

        case 3:
          return builder_.Return(handleSortRequest(ctx_1, patternInput[1], $var459[1]));

        case 4:
          return builder_.Return(handleDropRequest(ctx_1, patternInput[1], $var459[1]));

        case 5:
          return builder_.ReturnFrom(handleFilterEqNeqRequest(ctx_1, patternInput[1], $var459[2], $var459[4], $var459[3], $var459[1]));

        case 6:
          var flid = $var459[1].length + sumBy(function (_arg8) {
            return _arg8.Case === "FilterBy" ? _arg8.Fields[1].length : 0;
          }, patternInput[1]);
          return builder_.Return(handleFilterRequest(ctx_1, patternInput[1], fsFormat("flid-%d")(function (x) {
            return x;
          })(flid), $var459[2], $var459[1]));

        case 7:
          var wnid = fsFormat("wnid-%d")(function (x) {
            return x;
          })(sumBy(function (_arg9) {
            return _arg9.Case === "WindowBy" ? 1 : 0;
          }, patternInput[1]));
          return builder_.Return(handleWindowRequest(ctx_1, patternInput[1], wnid));

        case 8:
          return builder_.Return(handleWindowExpandAggRequest(ctx_1, patternInput[1], $var459[2], function (aggs) {
            return new Transformation("WindowBy", [$var459[2], $var459[3], aggs]);
          }, $var459[1]));

        case 9:
          return builder_.Return(handleWindowExpandAggRequest(ctx_1, patternInput[1], $var459[2], function (aggs_1) {
            return new Transformation("ExpandBy", [$var459[2], aggs_1]);
          }, $var459[1]));

        case 10:
          return builder_.Return(handleGroupRequest(ctx_1, patternInput[1], $var459[1]));

        case 11:
          return builder_.Return(handleGroupAggRequest(ctx_1, patternInput[1], $var459[2], $var459[1]));

        case 12:
          return builder_.Return(function () {
            throw new Error("makePivotTypeImmediate: GetTheData, GetRange and Metadata shouldn't be of pivot type");
          }());
      }
    });
  }(singleton_1);
}
export function adjustForPreview(tfs) {
  var $var460 = tfs.tail != null ? tfs.head.Case === "WindowBy" ? tfs.head.Fields[1] === "!" ? [0, tfs.tail] : [4] : tfs.head.Case === "GroupBy" ? tfs.head.Fields[0].tail == null ? [1, tfs.tail] : tfs.head.Fields[1].tail == null ? [2, tfs.head.Fields[0], tfs.tail] : [4] : tfs.head.Case === "GetSeries" ? [3, tfs.tail] : [4] : [4];

  switch ($var460[0]) {
    case 0:
      return $var460[1];

    case 1:
      return $var460[1];

    case 2:
      return new List(new Transformation("GroupBy", [$var460[1], ofArray([new GroupAggregation("GroupKey", [])])]), $var460[2]);

    case 3:
      return $var460[1];

    case 4:
      return tfs;
  }
}
export function withPreview(ctx, tfs, typ) {
  if (typ.Case === "Object") {
    var preview = makeDataMember(ctx, "preview", true, adjustForPreview(tfs));
    return makeObjectType([preview].concat(typ.Fields[0].Members));
  } else {
    throw new Error("withPreview: Expected object type");
  }
}
export function makePivotType(ctx, tfs) {
  var guid = Transform.toUrl(tfs);

  var typ = function (builder_) {
    return builder_.Delay(function () {
      return builder_.TryWith(builder_.Delay(function () {
        return builder_.Bind(makePivotTypeImmediate(ctx, tfs), function (_arg10) {
          return builder_.Return(withPreview(ctx, tfs, _arg10));
        });
      }), function (_arg11) {
        Log.exn("providers", "Failed when generating type for %O with exception %O", tfs, _arg11);
        return builder_.Return(function () {
          throw _arg11;
        }());
      });
    });
  }(singleton_1);

  return new Type("Delayed", [function (arg00) {
    return function (arg10) {
      return Async_CreateNamedFuture_Static(arg00, arg10);
    };
  }(guid)(typ)]);
}
export function makePivotExpression(root) {
  return new Expression("NewExpression", [BabelOperators.ident("PivotContext"), ofArray([BabelOperators.str(root), new Expression("ArrayExpression", [new List(), null])]), null]);
}
export function makePivotGlobalValue(root, name, lookupNamed, ignoreFilter, fields) {
  var fields_1 = toList(delay(function () {
    return collect_1(function (matchValue) {
      return singleton(new Field(matchValue[0], matchValue[1]));
    }, fields);
  }));
  var typ = makePivotType(new Context(root, ignoreFilter, lookupNamed, fields_1, fields_1), new List());
  var meta1 = new Metadata_1("http://schema.thegamma.net/pivot", "Transformations", new List());
  var meta2 = new Metadata_1("http://schema.thegamma.net/pivot", "Fields", fields_1);
  return new ProvidedType("GlobalValue", [name, ofArray([meta1, meta2]), makePivotExpression(root), typ]);
}
export function providePivotType(root, ignoreFilter, name, lookupNamed) {
  return function (builder_) {
    return builder_.Delay(function () {
      return builder_.Bind(Http.Request("GET", root + "?metadata"), function (_arg1) {
        var fields = function (o) {
          return _Object$keys(o).map(function (k) {
            return {
              "key": k,
              "value": o[k]
            };
          });
        }(JSON.parse(_arg1)).map(function (kv) {
          var typ = void 0;
          var matchValue = kv.value;

          switch (matchValue) {
            case "string":
              typ = new PrimitiveType("String", []);
              break;

            case "bool":
              typ = new PrimitiveType("Bool", []);
              break;

            case "number":
              typ = new PrimitiveType("Number", []);
              break;

            case "date":
              typ = new PrimitiveType("Date", []);
              break;

            default:
              throw new Error(fsFormat("The property '%s' has invalid type '%s'. Only 'string', 'number' and 'bool' are supported.")(function (x) {
                return x;
              })(kv.key)(matchValue));
          }

          return [kv.key, typ];
        });

        return builder_.Return(makePivotGlobalValue(root, name, lookupNamed, ignoreFilter, fields));
      });
    });
  }(singleton_1);
}
//# sourceMappingURL=pivot.js.map