import _Map from "babel-runtime/core-js/map";
import _defineProperty from "babel-runtime/helpers/defineProperty";
import _Array$from from "babel-runtime/core-js/array/from";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { toString, defaultArg, compareUnions, equalsUnions, Tuple, Array as _Array, Option, Any, compareRecords, equalsRecords } from "fable-core/Util";
import { MethodArgument, Metadata as Metadata_1, Member as Member_1, PrimitiveType, Type as Type_2, Emitter, Documentation as Documentation_1 } from "../ast/ast";
import { append, choose, delay, toList, zip, fold, count, isEmpty, skipWhile, map } from "fable-core/Seq";
import { Async$2E$CreateNamedFuture$2E$Static as Async_CreateNamedFuture_Static, Log, Http } from "../../libraries/common";
import { singleton } from "fable-core/AsyncBuilder";
import { BinaryOperator, Expression, BabelOperators } from "../common/babel";
import { map as map_1, ofArray } from "fable-core/List";
import List from "fable-core/List";
import { join } from "fable-core/String";
import { applyTypes } from "./fsharp";
import { ProvidedType, ProviderHelpers } from "./providers";
import { typesEqual, listsEqual } from "../ast/typeops";
import { tryGetValue } from "fable-core/Map";
export var AnyType = function () {
  function AnyType(kind) {
    _classCallCheck(this, AnyType);

    this.kind = kind;
  }

  _createClass(AnyType, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.AnyType",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          kind: "string"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareRecords(this, other);
    }
  }]);

  return AnyType;
}();
setType("TheGamma.TypeProviders.RestProvider.AnyType", AnyType);
export var TypeNested = function () {
  function TypeNested(kind, endpoint) {
    _classCallCheck(this, TypeNested);

    this.kind = kind;
    this.endpoint = endpoint;
  }

  _createClass(TypeNested, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.TypeNested",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          kind: "string",
          endpoint: "string"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareRecords(this, other);
    }
  }]);

  return TypeNested;
}();
setType("TheGamma.TypeProviders.RestProvider.TypeNested", TypeNested);
export var TypeProvider = function () {
  function TypeProvider(kind, provider, endpoint) {
    _classCallCheck(this, TypeProvider);

    this.kind = kind;
    this.provider = provider;
    this.endpoint = endpoint;
  }

  _createClass(TypeProvider, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.TypeProvider",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          kind: "string",
          provider: "string",
          endpoint: "string"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareRecords(this, other);
    }
  }]);

  return TypeProvider;
}();
setType("TheGamma.TypeProviders.RestProvider.TypeProvider", TypeProvider);
export var TypePrimitive = function () {
  function TypePrimitive(kind, type, endpoint) {
    _classCallCheck(this, TypePrimitive);

    this.kind = kind;
    this.type = type;
    this.endpoint = endpoint;
  }

  _createClass(TypePrimitive, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.TypePrimitive",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          kind: "string",
          type: Any,
          endpoint: "string"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }]);

  return TypePrimitive;
}();
setType("TheGamma.TypeProviders.RestProvider.TypePrimitive", TypePrimitive);
export var Documentation = function () {
  function Documentation(title, details) {
    _classCallCheck(this, Documentation);

    this.title = title;
    this.details = details;
  }

  _createClass(Documentation, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.Documentation",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          title: Option("string"),
          details: Option("string")
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareRecords(this, other);
    }
  }]);

  return Documentation;
}();
setType("TheGamma.TypeProviders.RestProvider.Documentation", Documentation);
export var Parameter = function () {
  function Parameter(name, optional, kind, cookie, trace, type) {
    _classCallCheck(this, Parameter);

    this.name = name;
    this.optional = optional;
    this.kind = kind;
    this.cookie = cookie;
    this.trace = trace;
    this.type = type;
  }

  _createClass(Parameter, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.Parameter",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          name: "string",
          optional: "boolean",
          kind: "string",
          cookie: Option("string"),
          trace: Option("string"),
          type: Any
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }]);

  return Parameter;
}();
setType("TheGamma.TypeProviders.RestProvider.Parameter", Parameter);
export var Member = function () {
  function Member(name, returns, parameters, documentation, schema, trace) {
    _classCallCheck(this, Member);

    this.name = name;
    this.returns = returns;
    this.parameters = parameters;
    this.documentation = documentation;
    this.schema = schema;
    this.trace = trace;
  }

  _createClass(Member, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.Member",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          name: "string",
          returns: AnyType,
          parameters: Option(_Array(Parameter)),
          documentation: Option(Any),
          schema: _Array(Any),
          trace: _Array("string")
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }]);

  return Member;
}();
setType("TheGamma.TypeProviders.RestProvider.Member", Member);
export var ResultType = function () {
  function ResultType(caseName, fields) {
    _classCallCheck(this, ResultType);

    this.Case = caseName;
    this.Fields = fields;
  }

  _createClass(ResultType, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.ResultType",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Generic: ["string", _Array(ResultType)],
          Primitive: ["string"],
          Record: [_Array(Tuple(["string", ResultType]))]
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsUnions(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return compareUnions(this, other);
    }
  }]);

  return ResultType;
}();
setType("TheGamma.TypeProviders.RestProvider.ResultType", ResultType);
export var RawField = function () {
  function RawField(name, type) {
    _classCallCheck(this, RawField);

    this.name = name;
    this.type = type;
  }

  _createClass(RawField, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.RawField",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          name: "string",
          type: Any
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }]);

  return RawField;
}();
setType("TheGamma.TypeProviders.RestProvider.RawField", RawField);
export var RawResultType = function () {
  function RawResultType(name, fields, params) {
    _classCallCheck(this, RawResultType);

    this.name = name;
    this.fields = fields;
    this.params = params;
  }

  _createClass(RawResultType, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.TypeProviders.RestProvider.RawResultType",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          name: "string",
          fields: _Array(RawField),
          params: _Array(Any)
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return equalsRecords(this, other);
    }
  }]);

  return RawResultType;
}();
setType("TheGamma.TypeProviders.RestProvider.RawResultType", RawResultType);
export function parseDoc(json) {
  if (function () {
    return json == null;
  }(null)) {
    return new Documentation_1("None", []);
  } else if (typeof json === "string") {
    return new Documentation_1("Text", [json]);
  } else {
    var doc = json;
    var matchValue = [doc.title, doc.details];
    var $var426 = matchValue[0] != null ? matchValue[1] != null ? [0, matchValue[1], matchValue[0]] : [1] : [1];

    switch ($var426[0]) {
      case 0:
        return new Documentation_1("Details", [$var426[2], $var426[1]]);

      case 1:
        return new Documentation_1("None", []);
    }
  }
}
export function fromRawType(json) {
  if (typeof json === "string") {
    return new ResultType("Primitive", [json]);
  } else {
    var res = json;

    if (res.name === "record") {
      return new ResultType("Record", [res.fields.map(function (f) {
        return [f.name, fromRawType(f.type)];
      })]);
    } else {
      return new ResultType("Generic", [res.name, _Array$from(map(function (json_1) {
        return fromRawType(json_1);
      }, res.params))]);
    }
  }
}
export function trimLeft(c, s) {
  return _Array$from(skipWhile(function (y) {
    return c === y;
  }, s.split(""))).join('');
}
export function trimRight(c, s) {
  return _Array$from(skipWhile(function (y) {
    return c === y;
  }, s.split("").slice().reverse())).slice().reverse().join('');
}
export function concatUrl(a, b) {
  if (b.indexOf("http://") === 0 ? true : b.indexOf("https://") === 0) {
    return b;
  } else {
    return trimRight("/", a) + "/" + trimLeft("/", b);
  }
}
export function load(url, cookies) {
  return function (builder_) {
    return builder_.Delay(function () {
      return builder_.Bind(Http.Request("GET", url, null, cookies), function (_arg1) {
        var members = JSON.parse(_arg1);
        return builder_.Return(members);
      });
    });
  }(singleton);
}
export function addTraceCall(inst, trace) {
  if (isEmpty(trace)) {
    return inst;
  } else {
    return BabelOperators.op_DivideAtDivide(BabelOperators.op_Dynamic(inst, "addTrace"), ofArray([BabelOperators.str(join("&", trace))]));
  }
}
export function propAccess(trace) {
  return new Emitter(function (inst) {
    return addTraceCall(inst, trace);
  });
}
export function methCall(traceNames, trace) {
  return new Emitter(function (inst) {
    return BabelOperators.funcN(count(traceNames), function (args) {
      var withTrace = addTraceCall(inst, trace);
      return function () {
        var folder = function folder(inst_1) {
          return function (tupledArg) {
            var trace_1 = new Expression("BinaryExpression", [new BinaryOperator("BinaryPlus", []), BabelOperators.str(tupledArg[0] + "="), tupledArg[1], null]);
            return BabelOperators.op_DivideAtDivide(BabelOperators.op_Dynamic(inst_1, "addTrace"), ofArray([trace_1]));
          };
        };

        return function (source) {
          return fold(function ($var427, $var428) {
            return folder($var427)($var428);
          }, withTrace, source);
        };
      }()(zip(traceNames, args));
    });
  });
}
export function dataCall(parser, trace, endp) {
  return new Emitter(function (inst) {
    var tr = propAccess(trace).Emit(inst);
    var mem = new Expression("MemberExpression", [tr, new Expression("IdentifierExpression", ["getValue", null]), false, null]);
    return parser(new Expression("CallExpression", [mem, ofArray([new Expression("StringLiteral", [endp, null])]), null]));
  });
}
export function getTypeAndEmitter(lookupNamed, ty) {
  var $var429 = ty.Case === "Generic" ? ty.Fields[0] === "seq" ? ty.Fields[1].length === 1 ? ty.Fields[1][0].Case === "Generic" ? ty.Fields[1][0].Fields[0] === "tuple" ? function () {
    var testExpr = ty.Fields[1][0].Fields[1];
    return testExpr.length === 2;
  }() ? [4, ty.Fields[1][0].Fields[1][0], ty.Fields[1][0].Fields[1][1]] : [5, ty.Fields[1][0]] : [5, ty.Fields[1][0]] : [5, ty.Fields[1][0]] : [7] : [7] : ty.Case === "Record" ? [6, ty.Fields[0]] : ty.Fields[0] === "string" ? [0] : ty.Fields[0] === "obj" ? [1] : ty.Fields[0] === "int" ? [2] : ty.Fields[0] === "float" ? [2] : ty.Fields[0] === "date" ? [3] : [7];

  switch ($var429[0]) {
    case 0:
      return [new Type_2("Primitive", [new PrimitiveType("String", [])]), function (x) {
        return x;
      }];

    case 1:
      return [new Type_2("Primitive", [new PrimitiveType("String", [])]), function (x_1) {
        return x_1;
      }];

    case 2:
      return [new Type_2("Primitive", [new PrimitiveType("Number", [])]), function (e) {
        return BabelOperators.op_DivideAtDivide(BabelOperators.ident("Number"), ofArray([e]));
      }];

    case 3:
      return [new Type_2("Primitive", [new PrimitiveType("Date", [])]), function (e_1) {
        return new Expression("NewExpression", [BabelOperators.ident("Date"), ofArray([BabelOperators.op_DivideAtDivide(BabelOperators.op_Dynamic(BabelOperators.ident("Date"), "parse"), ofArray([e_1]))]), null]);
      }];

    case 4:
      var patternInput = getTypeAndEmitter(lookupNamed, $var429[1]);
      var patternInput_1 = getTypeAndEmitter(lookupNamed, $var429[2]);
      var typ = applyTypes(lookupNamed("series"), ofArray([patternInput[0], patternInput_1[0]]));
      return [typ, function (d) {
        return BabelOperators.op_DivideAtDivide(BabelOperators.op_Dynamic(BabelOperators.ident("series"), "create"), ofArray([BabelOperators.op_DivideAtDivide(BabelOperators.ident("convertTupleSequence"), ofArray([BabelOperators.func("v", patternInput[1]), BabelOperators.func("v", patternInput_1[1]), d])), BabelOperators.str("key"), BabelOperators.str("value"), BabelOperators.str("")]));
      }];

    case 5:
      var patternInput_2 = getTypeAndEmitter(lookupNamed, $var429[1]);
      var serTy = applyTypes(lookupNamed("series"), ofArray([new Type_2("Primitive", [new PrimitiveType("Number", [])]), patternInput_2[0]]));
      return [serTy, function (d_1) {
        return BabelOperators.op_DivideAtDivide(BabelOperators.op_Dynamic(BabelOperators.ident("series"), "ordinal"), ofArray([BabelOperators.op_DivideAtDivide(BabelOperators.ident("convertSequence"), ofArray([BabelOperators.func("v", patternInput_2[1]), d_1])), BabelOperators.str("key"), BabelOperators.str("value"), BabelOperators.str("")]));
      }];

    case 6:
      var membs = $var429[1].map(function (tupledArg) {
        var patternInput_3 = getTypeAndEmitter(lookupNamed, tupledArg[1]);
        var emitter = new Emitter(function (inst) {
          return patternInput_3[1](BabelOperators.op_Dynamic(inst, tupledArg[0]));
        });
        return new Member_1(tupledArg[0], patternInput_3[0], ofArray([ProviderHelpers.docMeta(new Documentation_1("Text", [""]))]), emitter);
      });
      var obj = new Type_2("Object", [_defineProperty({
        get Members() {
          return membs;
        },

        TypeEquals: function (_arg1) {
          return false;
        }
      }, _Symbol.reflection, function () {
        return {
          interfaces: ["TheGamma.ObjectType"]
        };
      })]);
      return [obj, function (x_2) {
        return x_2;
      }];

    case 7:
      console.log("getTypeAndEmitter: Cannot handle %O", ty);
      throw new Error("getTypeAndEmitter: Cannot handle type");
  }
}
export var restTypeCache = new _Map();
export function createRestType(lookupNamed, resolveProvider, root, cookies, url) {
  var provideMember = function provideMember(m) {
    var schema = m.schema == null ? new List() : Array.isArray(m.schema) ? toList(_Array$from(map(function (s) {
      var Type = s["@type"];
      return new Metadata_1(s["@context"], Type, s);
    }, m.schema))) : ofArray([function () {
      var Type_1 = m.schema["@type"];
      return new Metadata_1(m.schema["@context"], Type_1, m.schema);
    }()]);
    var matchValue = m.returns.kind;

    switch (matchValue) {
      case "provider":
        var returns = m.returns;
        var patternInput = resolveProvider(returns.provider)(returns.endpoint);
        return new Member_1(m.name, patternInput[0], new List(ProviderHelpers.docMeta(parseDoc(m.documentation)), schema), patternInput[1]);

      case "nested":
        var returns_1 = m.returns;

        var createReturnType = function createReturnType(cookies_1) {
          try {
            return createRestType(lookupNamed, resolveProvider, root, cookies_1, returns_1.endpoint);
          } catch (matchValue_1) {
            return null;
          }
        };

        if (m.parameters == null) {
          var retTyp = defaultArg(createReturnType(cookies), new Type_2("Any", []));
          return new Member_1(m.name, retTyp, new List(ProviderHelpers.docMeta(parseDoc(m.documentation)), schema), propAccess(m.trace));
        } else {
          var args = toList(delay(function () {
            return map(function (p) {
              var ty = fromRawType(p.type);
              var patternInput_1 = getTypeAndEmitter(lookupNamed, ty);
              return new MethodArgument(p.name, p.optional, p.kind === "static", patternInput_1[0]);
            }, m.parameters);
          }));

          var retFunc = function retFunc(tys) {
            if (!listsEqual(map_1(function (tuple) {
              return tuple[0];
            }, tys), toList(delay(function () {
              return map(function (ma) {
                return ma.Type;
              }, args);
            })), function (t1) {
              return function (t2) {
                return typesEqual(t1, t2);
              };
            })) {
              return null;
            } else {
              var matched = zip(m.parameters, tys);
              var newCookies = choose(function (_arg1) {
                var $var430 = _arg1[1][1] != null ? function () {
                  var value = _arg1[1][1];
                  return _arg1[0].kind === "static";
                }() ? [0, _arg1[0], _arg1[1][1]] : [1] : [1];

                switch ($var430[0]) {
                  case 0:
                    return $var430[1].cookie + "=" + encodeURIComponent(toString($var430[2]));

                  case 1:
                    return null;
                }
              }, matched);
              var cookies_2 = join("&", append(ofArray([cookies]), newCookies));
              return createReturnType(cookies_2);
            }
          };

          var traceNames = choose(function (p_1) {
            return p_1.trace;
          }, m.parameters);
          var Metadata = ofArray([ProviderHelpers.docMeta(parseDoc(m.documentation))]);
          return new Member_1(m.name, new Type_2("Method", [args, retFunc]), Metadata, methCall(traceNames, m.trace));
        }

      case "primitive":
        var returns_2 = m.returns;
        var ty_1 = fromRawType(returns_2.type);
        var patternInput_2 = getTypeAndEmitter(lookupNamed, ty_1);
        return new Member_1(m.name, patternInput_2[0], new List(ProviderHelpers.docMeta(parseDoc(m.documentation)), schema), dataCall(patternInput_2[1], m.trace, returns_2.endpoint));

      default:
        throw new Error("?");
    }
  };

  var guid = concatUrl(root, url) + cookies;
  var matchValue_2 = tryGetValue(restTypeCache, guid, null);

  if (matchValue_2[0]) {
    return matchValue_2[1];
  } else {
    var future = function (builder_) {
      return builder_.Delay(function () {
        return builder_.TryWith(builder_.Delay(function () {
          return builder_.Bind(load(concatUrl(root, url), cookies), function (_arg2) {
            var members = function (array) {
              return array.map(provideMember);
            }(_arg2);

            return builder_.Return(new Type_2("Object", [_defineProperty({
              get Members() {
                return members;
              },

              TypeEquals: function (_arg3) {
                return false;
              }
            }, _Symbol.reflection, function () {
              return {
                interfaces: ["TheGamma.ObjectType"]
              };
            })]));
          });
        }), function (_arg4) {
          Log.error("providers", "Cannot provide object type: %O", _arg4);
          return builder_.Return(new Type_2("Any", []));
        });
      });
    }(singleton);

    var ty_2 = new Type_2("Delayed", [function (arg00) {
      return function (arg10) {
        return Async_CreateNamedFuture_Static(arg00, arg10);
      };
    }(guid)(future)]);
    restTypeCache.set(guid, ty_2);
    return ty_2;
  }
}
export function provideRestType(lookupNamed, resolveProvider, name, root, cookies) {
  var ctx = BabelOperators.ident("RuntimeContext");
  return new ProvidedType("GlobalValue", [name, new List(), new Expression("NewExpression", [ctx, ofArray([BabelOperators.str(root), BabelOperators.str(cookies), BabelOperators.str("")]), null]), createRestType(lookupNamed, resolveProvider, root, cookies, "/")]);
}
//# sourceMappingURL=rest.js.map