"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.compost = exports.CompostCharts = exports.CompostLinesAreasChart = exports.CompostLineAreaChart = exports.CompostColBarChart = exports.CompostBubblesChart = exports.CompostBubblesChartSet = exports.youguess = exports.YouGuessSortBars = exports.YouGuessLineOffset = exports.YouGuessLine = exports.YouGuessColsBars = exports.YouGuessColsBarsKind = exports.YouGuessSortHelpers = exports.YouGuessColsHelpers = exports.YouGeussLineOffsetHelpers = exports.YouGuessLineHelpers = exports.Charts = exports.Internal = exports.CompostHelpers = exports.InteractiveHelpers = exports.ChartOptions = exports.LegendOptions = exports.AxisOptions = undefined;

var _map = require("babel-runtime/core-js/map");

var _map2 = _interopRequireDefault(_map);

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _Symbol2 = require("fable-core/umd/Symbol");

var _Symbol3 = _interopRequireDefault(_Symbol2);

var _Util = require("fable-core/umd/Util");

var _String = require("fable-core/umd/String");

var _html = require("./html");

var _List = require("fable-core/umd/List");

var _List2 = _interopRequireDefault(_List);

var _common = require("./common");

var _Async = require("fable-core/umd/Async");

var _AsyncBuilder = require("fable-core/umd/AsyncBuilder");

var _Seq = require("fable-core/umd/Seq");

var _compost = require("./compost");

var _Date = require("fable-core/umd/Date");

var _TimeSpan = require("fable-core/umd/TimeSpan");

var _Map3 = require("fable-core/umd/Map");

var _Map4 = _interopRequireDefault(_Map3);

var _GenericComparer = require("fable-core/umd/GenericComparer");

var _GenericComparer2 = _interopRequireDefault(_GenericComparer);

var _Set = require("fable-core/umd/Set");

var _series = require("./series");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AxisOptions = exports.AxisOptions = function () {
  function AxisOptions(minValue, maxValue, label, labelOffset, labelMinimalSize) {
    (0, _classCallCheck3.default)(this, AxisOptions);
    this.minValue = minValue;
    this.maxValue = maxValue;
    this.label = label;
    this.labelOffset = labelOffset;
    this.labelMinimalSize = labelMinimalSize;
  }

  (0, _createClass3.default)(AxisOptions, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.AxisOptions",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          minValue: (0, _Util.Option)(_Util.Any),
          maxValue: (0, _Util.Option)(_Util.Any),
          label: (0, _Util.Option)("string"),
          labelOffset: (0, _Util.Option)("number"),
          labelMinimalSize: (0, _Util.Option)("number")
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }], [{
    key: "Default",
    get: function () {
      return new AxisOptions(null, null, null, null, null);
    }
  }]);
  return AxisOptions;
}();

(0, _Symbol2.setType)("TheGamma.Interactive.AxisOptions", AxisOptions);

var LegendOptions = exports.LegendOptions = function () {
  function LegendOptions(position) {
    (0, _classCallCheck3.default)(this, LegendOptions);
    this.position = position;
  }

  (0, _createClass3.default)(LegendOptions, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.LegendOptions",
        interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
        properties: {
          position: "string"
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareRecords)(this, other);
    }
  }], [{
    key: "Default",
    get: function () {
      return new LegendOptions("none");
    }
  }]);
  return LegendOptions;
}();

(0, _Symbol2.setType)("TheGamma.Interactive.LegendOptions", LegendOptions);

var ChartOptions = exports.ChartOptions = function () {
  function ChartOptions(size, xAxis, yAxis, title, legend, emptyMessage) {
    (0, _classCallCheck3.default)(this, ChartOptions);
    this.size = size;
    this.xAxis = xAxis;
    this.yAxis = yAxis;
    this.title = title;
    this.legend = legend;
    this.emptyMessage = emptyMessage;
  }

  (0, _createClass3.default)(ChartOptions, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.ChartOptions",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          size: (0, _Util.Tuple)([(0, _Util.Option)("number"), (0, _Util.Option)("number")]),
          xAxis: AxisOptions,
          yAxis: AxisOptions,
          title: (0, _Util.Option)("string"),
          legend: LegendOptions,
          emptyMessage: (0, _Util.Option)("string")
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }], [{
    key: "Default",
    get: function () {
      var size = [null, null];
      var title = null;
      var legend = LegendOptions.Default;
      return new ChartOptions(size, AxisOptions.Default, AxisOptions.Default, title, legend, null);
    }
  }]);
  return ChartOptions;
}();

(0, _Symbol2.setType)("TheGamma.Interactive.ChartOptions", ChartOptions);

var InteractiveHelpers = exports.InteractiveHelpers = function (__exports) {
  var showAppAsync = __exports.showAppAsync = function (outputId, opts, data, initial, render, update) {
    return function (builder_) {
      return builder_.Delay(function () {
        var id = "container" + (0, _String.replace)(function () {
          var copyOfStruct = (0, _String.newGuid)();
          return copyOfStruct;
        }(), "-", "");
        (0, _html.renderTo)(document.getElementById(outputId), function (arg0) {
          return function (arg1) {
            return _html.El.op_Dynamic(arg0, arg1);
          };
        }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("id", id)]))(new _List2.default()));
        return builder_.Bind((0, _common.Async$2E$AwaitFuture$2E$Static)(data.data), function (_arg4) {
          var i = 10;
          return builder_.Combine(builder_.While(function () {
            return i > 0 ? document.getElementById(id) == null : false;
          }, builder_.Delay(function () {
            return builder_.Bind((0, _Async.sleep)(10), function () {
              i = i - 1;
              return builder_.Zero();
            });
          })), builder_.Delay(function () {
            var element = document.getElementById(id);

            if (_arg4.length === 0 ? function () {
              return opts.emptyMessage != null;
            }(null) : false) {
              (function (dom) {
                (0, _html.renderTo)(element, dom);
              })(function (arg0_1) {
                return function (arg1_1) {
                  return _html.El.op_Dynamic(arg0_1, arg1_1);
                };
              }(_html.h)("p")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "placeholder")]))((0, _List.ofArray)([(0, _html.text)(opts.emptyMessage)])));

              return builder_.Zero();
            } else {
              var size = [opts.size[0] != null ? function () {
                var w = opts.size[0];
                return w;
              }() : element.clientWidth, opts.size[1] != null ? function () {
                var h = opts.size[1];
                return h;
              }() : 400 > element.clientWidth / 2 ? 400 : element.clientWidth / 2];

              try {
                (0, _html.createVirtualDomApp)(outputId, initial(_arg4), render(_arg4)(size), update(_arg4));
              } catch (e) {
                _common.Log.exn("GUI", "Interactive rendering failed: %O", e);
              }

              return builder_.Zero();
            }
          }));
        });
      });
    }(_AsyncBuilder.singleton);
  };

  var showApp = __exports.showApp = function (outputId, opts, data, initial, render, update) {
    (function (arg00) {
      (0, _Async.startImmediate)(arg00);
    })(showAppAsync(outputId, opts, data, initial, render, update));
  };

  var showStaticAppAsync = __exports.showStaticAppAsync = function (outputId, opts, data, render) {
    return showAppAsync(outputId, opts, data, function (_arg1) {}, function (_arg4) {
      return function (size) {
        return function (_arg3) {
          return function () {
            return render(size);
          };
        };
      };
    }, function (_arg7) {
      return function () {
        return function (_arg5) {};
      };
    });
  };

  var showStaticApp = __exports.showStaticApp = function (outputId, opts, data, render) {
    showApp(outputId, opts, data, function (_arg1) {}, function (data_1) {
      return function (size) {
        return function (_arg3) {
          return function () {
            return render(data_1)(size);
          };
        };
      };
    }, function (_arg6) {
      return function () {
        return function (_arg4) {};
      };
    });
  };

  var calclateMax = __exports.calclateMax = function (maxValue, data) {
    var max = maxValue != null ? maxValue : (0, _Seq.reduce)(function (x, y) {
      return Math.max(x, y);
    }, (0, _Seq.map)(function (tuple) {
      return tuple[1];
    }, data));
    return _compost.Scales.adjustRange(0, max)[1];
  };

  var createLogger = __exports.createLogger = function (id, logger) {
    if (logger == null) {
      return function (_arg2) {
        return function (_arg1) {};
      };
    } else {
      return function (event) {
        return function (data) {
          logger({
            event: event,
            id: id,
            data: (0, _Util.createObj)(data)
          });
        };
      };
    }
  };

  return __exports;
}({});

var CompostHelpers = exports.CompostHelpers = function (__exports) {
  var _Cont_ = __exports["|Cont|"] = function (_arg1) {
    if (_arg1.Case === "COV") {
      var x = _arg1.Fields[0].Fields[0];
      return x;
    } else {
      throw new Error("Expected continuous value");
    }
  };

  var _Cat_ = __exports["|Cat|"] = function (_arg1) {
    if (_arg1.Case === "CAR") {
      var x = _arg1.Fields[0].Fields[0];
      return [x, _arg1.Fields[1]];
    } else {
      throw new Error("Expected categorical value");
    }
  };

  var Cont = __exports.Cont = function (x) {
    return new _compost.Value("COV", [new _compost.continuous("CO", [x])]);
  };

  var Cat = __exports.Cat = function (x, r) {
    return new _compost.Value("CAR", [new _compost.categorical("CA", [x]), r]);
  };

  var orElse = __exports.orElse = function (a, b) {
    if (function () {
      return a != null;
    }(null)) {
      return a;
    } else {
      return b;
    }
  };

  var vega10 = __exports.vega10 = ["#1f77b4", "#ff7f0e", "#2ca02c", "#d62728", "#9467bd", "#8c564b", "#e377c2", "#7f7f7f", "#bcbd22", "#17becf"];

  var infinitely = __exports.infinitely = function (s) {
    if ((0, _Seq.isEmpty)(s)) {
      return (0, _Seq.delay)(function () {
        return (0, _Seq.enumerateWhile)(function () {
          return true;
        }, (0, _Seq.delay)(function () {
          return (0, _Seq.singleton)("black");
        }));
      });
    } else {
      return (0, _Seq.delay)(function () {
        return (0, _Seq.enumerateWhile)(function () {
          return true;
        }, (0, _Seq.delay)(function () {
          return s;
        }));
      });
    }
  };

  return __exports;
}({});

var Internal = exports.Internal = function (__exports) {
  var prevAndNext = __exports.prevAndNext = function (data) {
    if (data.length === 1) {
      return [[data[0], data[0], data[0]]];
    } else {
      var res = [[data[0], data[0], data[1]]];

      for (var x = 1; x <= data.length - 2; x++) {
        res.push([data[x - 1], data[x], data[x + 1]]);
      }

      res.push([data[data.length - 2], data[data.length - 1], data[data.length - 1]]);
      return (0, _from2.default)(res);
    }
  };

  var arrayMap = __exports.arrayMap = function (f, s) {
    return (0, _from2.default)((0, _Seq.map)(f, s));
  };

  var parseColor = __exports.parseColor = function (clr) {
    var r = parseInt(clr.substr(1, 2), 16);
    var g = parseInt(clr.substr(3, 2), 16);
    var b = parseInt(clr.substr(5, 2), 16);
    return [r, g, b];
  };

  var formatColor = __exports.formatColor = function (r, g, b) {
    var fi = function fi(n) {
      return (0, _String.padLeft)((~~n).toString(16), 2, "0");
    };

    return "#" + fi(r) + fi(g) + fi(b);
  };

  var mapColor = __exports.mapColor = function (f, clr) {
    var tupledArg = f(parseColor(clr));
    return formatColor(tupledArg[0], tupledArg[1], tupledArg[2]);
  };

  var ScalePoints = __exports.ScalePoints = function () {
    function ScalePoints(minimum, maximum, middle, pixelSize) {
      (0, _classCallCheck3.default)(this, ScalePoints);
      this.Minimum = minimum;
      this.Maximum = maximum;
      this.Middle = middle;
      this.PixelSize = pixelSize;
    }

    (0, _createClass3.default)(ScalePoints, [{
      key: _Symbol3.default.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.Internal.ScalePoints",
          interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
          properties: {
            Minimum: (0, _Util.makeGeneric)(_compost.Value, {
              u: _Util.Any
            }),
            Maximum: (0, _Util.makeGeneric)(_compost.Value, {
              u: _Util.Any
            }),
            Middle: (0, _Util.makeGeneric)(_compost.Value, {
              u: _Util.Any
            }),
            PixelSize: "number"
          }
        };
      }
    }, {
      key: "Equals",
      value: function (other) {
        return (0, _Util.equalsRecords)(this, other);
      }
    }, {
      key: "CompareTo",
      value: function (other) {
        return (0, _Util.compareRecords)(this, other);
      }
    }]);
    return ScalePoints;
  }();

  (0, _Symbol2.setType)("TheGamma.Interactive.Internal.ScalePoints", ScalePoints);

  var ChartContext = __exports.ChartContext = function () {
    function ChartContext(chart, width, height, xPoints, yPoints, xData, yData, padding, chartOptions) {
      (0, _classCallCheck3.default)(this, ChartContext);
      this.Chart = chart;
      this.Width = width;
      this.Height = height;
      this.XPoints = xPoints;
      this.YPoints = yPoints;
      this.XData = xData;
      this.YData = yData;
      this.Padding = padding;
      this.ChartOptions = chartOptions;
    }

    (0, _createClass3.default)(ChartContext, [{
      key: _Symbol3.default.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.Internal.ChartContext",
          interfaces: ["FSharpRecord"],
          properties: {
            Chart: (0, _Util.makeGeneric)(_compost.Shape, {
              vx: _Util.Any,
              vy: _Util.Any
            }),
            Width: "number",
            Height: "number",
            XPoints: ScalePoints,
            YPoints: ScalePoints,
            XData: (0, _Util.Array)(_Util.Any),
            YData: (0, _Util.Array)(_Util.Any),
            Padding: (0, _Util.Tuple)(["number", "number", "number", "number"]),
            ChartOptions: ChartOptions
          }
        };
      }
    }]);
    return ChartContext;
  }();

  (0, _Symbol2.setType)("TheGamma.Interactive.Internal.ChartContext", ChartContext);

  var calculateScales = __exports.calculateScales = function (width, height, chart) {
    var scaled = _compost.Scales.calculateScales(_compost.Compost.defstyle, chart);

    var sy = scaled.Fields[0][1];
    var sx = scaled.Fields[0][0];

    var getPoints = function getPoints(_arg1) {
      if (_arg1.Case === "Categorical") {
        return new ScalePoints(new _compost.Value("CAR", [_arg1.Fields[0][0], 0]), new _compost.Value("CAR", [_arg1.Fields[0][_arg1.Fields[0].length - 1], 1]), _arg1.Fields[0].length % 2 === 1 ? new _compost.Value("CAR", [_arg1.Fields[0][~~(_arg1.Fields[0].length / 2)], 0.5]) : new _compost.Value("CAR", [_arg1.Fields[0][~~(_arg1.Fields[0].length / 2)], 0]), 0);
      } else {
        var lo = _arg1.Fields[0].Fields[0];
        var hi = _arg1.Fields[1].Fields[0];
        var master = new _compost.Projections.Projection("Scale", [[0, width], [height, 0]]);

        var patternInput = _compost.Projections.calculateProjections(scaled, master);

        var patternInput_1 = _compost.Projections.projectInv(_arg1, _arg1, new _compost.continuous("CO", [100]), new _compost.continuous("CO", [0]), patternInput.Fields[0]);

        var activePatternResult3852 = CompostHelpers["|Cont|"](patternInput_1[0]);

        var patternInput_2 = _compost.Projections.projectInv(_arg1, _arg1, new _compost.continuous("CO", [101]), new _compost.continuous("CO", [0]), patternInput.Fields[0]);

        var activePatternResult3851 = CompostHelpers["|Cont|"](patternInput_2[0]);
        return new ScalePoints(new _compost.Value("COV", [new _compost.continuous("CO", [lo])]), new _compost.Value("COV", [new _compost.continuous("CO", [hi])]), new _compost.Value("COV", [new _compost.continuous("CO", [(hi + lo) / 2])]), Math.abs(activePatternResult3852 - activePatternResult3851));
      }
    };

    return [getPoints(sx), getPoints(sy)];
  };

  var initChart = __exports.initChart = function (size_0, size_1, xdata, ydata, options, chart) {
    var size = [size_0, size_1];
    var patternInput = calculateScales(size[0], size[1], chart);
    var Padding = [20, 20, 20, 20];
    return new ChartContext(chart, size[0], size[1], patternInput[0], patternInput[1], xdata, ydata, Padding, options);
  };

  var applyStyle = __exports.applyStyle = function (f, chart) {
    return new _compost.Shape("Style", [f, chart]);
  };

  var applyStyleCtx = __exports.applyStyleCtx = function (f, ctx) {
    return new ChartContext(new _compost.Shape("Style", [f, ctx.Chart]), ctx.Width, ctx.Height, ctx.XPoints, ctx.YPoints, ctx.XData, ctx.YData, ctx.Padding, ctx.ChartOptions);
  };

  var applyInteractive = __exports.applyInteractive = function (e, chart) {
    return new _compost.Shape("Interactive", [e, chart]);
  };

  var applyInteractiveCtx = __exports.applyInteractiveCtx = function (e, ctx) {
    return new ChartContext(new _compost.Shape("Interactive", [e(ctx), ctx.Chart]), ctx.Width, ctx.Height, ctx.XPoints, ctx.YPoints, ctx.XData, ctx.YData, ctx.Padding, ctx.ChartOptions);
  };

  var applyScales = __exports.applyScales = function (ctx) {
    var getInnerScale = function getInnerScale(axis) {
      return function (sp) {
        if ((0, _Util.equals)(axis.minValue, null) ? (0, _Util.equals)(axis.maxValue, null) : false) {
          return null;
        } else {
          var $var117 = sp.Minimum.Case === "COV" ? sp.Maximum.Case === "COV" ? [0, sp.Maximum.Fields[0].Fields[0], sp.Minimum.Fields[0].Fields[0]] : [1] : [1];

          switch ($var117[0]) {
            case 0:
              var amin = (0, _Util.defaultArg)(axis.minValue, null, function (n) {
                return n instanceof Date ? n.getTime() : n;
              });
              var amax = (0, _Util.defaultArg)(axis.maxValue, null, function (n_1) {
                return n_1 instanceof Date ? n_1.getTime() : n_1;
              });
              var patternInput = [amin != null ? amin : $var117[2], amax != null ? amax : $var117[1]];
              return [new _compost.continuous("CO", [patternInput[0]]), new _compost.continuous("CO", [patternInput[1]])];

            case 1:
              return null;
          }
        }
      };
    };

    var sx = getInnerScale(ctx.ChartOptions.xAxis)(ctx.XPoints);
    var sy = getInnerScale(ctx.ChartOptions.yAxis)(ctx.YPoints);
    var chart = new _compost.Shape("AutoScale", [function () {
      return sx == null;
    }(null), function () {
      return sy == null;
    }(null), new _compost.Shape("InnerScale", [sx, sy, ctx.Chart])]);
    var patternInput_1 = calculateScales(ctx.Width, ctx.Height, chart);
    return new ChartContext(chart, ctx.Width, ctx.Height, patternInput_1[0], patternInput_1[1], ctx.XData, ctx.YData, ctx.Padding, ctx.ChartOptions);
  };

  var applyAxes = __exports.applyAxes = function (tlab, rlab, blab, llab, ctx) {
    var style = function style(data) {
      var isDate = (0, _Seq.exists)(function (n) {
        return n instanceof Date;
      }, data);

      if (isDate) {
        var values = arrayMap(function (n_1) {
          return n_1 instanceof Date ? n_1.getTime() : n_1;
        }, data);
        var patternInput = [new Date((0, _Seq.reduce)(function (x, y) {
          return Math.min(x, y);
        }, values)), new Date((0, _Seq.reduce)(function (x, y) {
          return Math.max(x, y);
        }, values))];

        if (function () {
          var copyOfStruct = (0, _Date.op_Subtraction)(patternInput[1], patternInput[0]);
          return (0, _TimeSpan.totalDays)(copyOfStruct);
        }() <= 1) {
          return function (_arg2) {
            return function (_arg1) {
              var activePatternResult3876 = CompostHelpers["|Cont|"](_arg1);
              return new Date(activePatternResult3876).toLocaleString("en-US", {
                hour: "numeric",
                minute: "numeric",
                second: "numeric"
              });
            };
          };
        } else {
          return function (_arg4) {
            return function (_arg3) {
              var activePatternResult3879 = CompostHelpers["|Cont|"](_arg3);
              return new Date(activePatternResult3879).toLocaleString("en-US", {
                day: "numeric",
                year: "numeric",
                month: "short"
              });
            };
          };
        }
      } else {
        return function (scale) {
          return function (value) {
            return _compost.Compost.defaultFormat(scale, value);
          };
        };
      }
    };

    var chart = applyStyle(function (s) {
      var FormatAxisXLabel = style(ctx.XData);
      var FormatAxisYLabel = style(ctx.YData);
      return new _compost.Style(s.StrokeColor, s.StrokeWidth, s.StrokeDashArray, s.Fill, s.Animation, s.Font, s.Cursor, FormatAxisXLabel, FormatAxisYLabel);
    }, new _compost.Shape("Axes", [tlab, rlab, blab, llab, ctx.Chart]));
    return new ChartContext(new _compost.Shape("Padding", [ctx.Padding, chart]), ctx.Width, ctx.Height, ctx.XPoints, ctx.YPoints, ctx.XData, ctx.YData, ctx.Padding, ctx.ChartOptions);
  };

  var applyLegend = __exports.applyLegend = function (width, height, labels, ctx) {
    var labels_1 = (0, _from2.default)(labels);
    var matchValue = [ctx.ChartOptions.legend.position, width > 600];
    var $var118 = matchValue[0] === "right" ? [0] : matchValue[0] === "auto" ? matchValue[1] ? [0] : [1] : matchValue[0] === "bottom" ? [1] : [2];

    switch ($var118[0]) {
      case 0:
        var labs = new _compost.Shape("InnerScale", [[new _compost.continuous("CO", [0]), new _compost.continuous("CO", [100])], null, new _compost.Shape("Layered", [(0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.collect)(function (matchValue_1) {
            var style = function style(clr) {
              var f = function f(s) {
                var Font = "9pt Roboto,sans-serif";
                var Fill = new _compost.FillStyle("Solid", [[1, new _compost.Color("HTML", [clr])]]);
                return new _compost.Style([0, new _compost.Color("RGB", [0, 0, 0])], s.StrokeWidth, s.StrokeDashArray, Fill, s.Animation, Font, s.Cursor, s.FormatAxisXLabel, s.FormatAxisYLabel);
              };

              return function (chart) {
                return applyStyle(f, chart);
              };
            };

            return (0, _Seq.append)((0, _Seq.singleton)(style(matchValue_1[0])(new _compost.Shape("Padding", [[4, 0, 4, 0], _compost.Derived.Bar(new _compost.continuous("CO", [6]), new _compost.categorical("CA", [matchValue_1[1]]))]))), (0, _Seq.delay)(function () {
              return (0, _Seq.singleton)(style("black")(new _compost.Shape("Text", [new _compost.Value("COV", [new _compost.continuous("CO", [8])]), new _compost.Value("CAR", [new _compost.categorical("CA", [matchValue_1[1]]), 0.5]), new _compost.VerticalAlign("Middle", []), new _compost.HorizontalAlign("Start", []), 0, matchValue_1[1]])));
            }));
          }, labels_1);
        }))])]);
        var patternInput = [(width - 250) / width, (ctx.Padding[0] + labels_1.length * 30) / height];
        var chart_1 = new _compost.Shape("Layered", [(0, _List.ofArray)([new _compost.Shape("OuterScale", [new _compost.Scale("Continuous", [new _compost.continuous("CO", [0]), new _compost.continuous("CO", [patternInput[0]])]), new _compost.Scale("Continuous", [new _compost.continuous("CO", [0]), new _compost.continuous("CO", [1])]), ctx.Chart]), new _compost.Shape("OuterScale", [new _compost.Scale("Continuous", [new _compost.continuous("CO", [patternInput[0]]), new _compost.continuous("CO", [1])]), new _compost.Scale("Continuous", [new _compost.continuous("CO", [0]), new _compost.continuous("CO", [patternInput[1]])]), new _compost.Shape("Padding", [[ctx.Padding[0], 0, 0, 20], labs])])])]);
        return new ChartContext(chart_1, ctx.Width, ctx.Height, ctx.XPoints, ctx.YPoints, ctx.XData, ctx.YData, ctx.Padding, ctx.ChartOptions);

      case 1:
        var labs_1 = new _compost.Shape("InnerScale", [[new _compost.continuous("CO", [0]), new _compost.continuous("CO", [100])], null, new _compost.Shape("Layered", [(0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.collect)(function (matchValue_2) {
            var style_1 = function style_1(clr_1) {
              var f_1 = function f_1(s_1) {
                var Font_1 = "9pt Roboto,sans-serif";
                var Fill_1 = new _compost.FillStyle("Solid", [[1, new _compost.Color("HTML", [clr_1])]]);
                return new _compost.Style([0, new _compost.Color("RGB", [0, 0, 0])], s_1.StrokeWidth, s_1.StrokeDashArray, Fill_1, s_1.Animation, Font_1, s_1.Cursor, s_1.FormatAxisXLabel, s_1.FormatAxisYLabel);
              };

              return function (chart_2) {
                return applyStyle(f_1, chart_2);
              };
            };

            return (0, _Seq.append)((0, _Seq.singleton)(style_1(matchValue_2[0])(new _compost.Shape("Padding", [[4, 0, 4, 0], new _compost.Shape("Shape", [(0, _List.ofArray)([[new _compost.Value("COV", [new _compost.continuous("CO", [94])]), new _compost.Value("CAR", [new _compost.categorical("CA", [matchValue_2[1]]), 0])], [new _compost.Value("COV", [new _compost.continuous("CO", [94])]), new _compost.Value("CAR", [new _compost.categorical("CA", [matchValue_2[1]]), 1])], [new _compost.Value("COV", [new _compost.continuous("CO", [100])]), new _compost.Value("CAR", [new _compost.categorical("CA", [matchValue_2[1]]), 1])], [new _compost.Value("COV", [new _compost.continuous("CO", [100])]), new _compost.Value("CAR", [new _compost.categorical("CA", [matchValue_2[1]]), 0])]])])]))), (0, _Seq.delay)(function () {
              return (0, _Seq.singleton)(style_1("black")(new _compost.Shape("Text", [new _compost.Value("COV", [new _compost.continuous("CO", [92])]), new _compost.Value("CAR", [new _compost.categorical("CA", [matchValue_2[1]]), 0.5]), new _compost.VerticalAlign("Middle", []), new _compost.HorizontalAlign("End", []), 0, matchValue_2[1]])));
            }));
          }, labels_1);
        }))])]);
        var lhgt = (height - labels_1.length * 30) / height;
        var chart_3 = new _compost.Shape("Layered", [(0, _List.ofArray)([new _compost.Shape("OuterScale", [new _compost.Scale("Continuous", [new _compost.continuous("CO", [0]), new _compost.continuous("CO", [1])]), new _compost.Scale("Continuous", [new _compost.continuous("CO", [0]), new _compost.continuous("CO", [lhgt])]), ctx.Chart]), new _compost.Shape("OuterScale", [new _compost.Scale("Continuous", [new _compost.continuous("CO", [0]), new _compost.continuous("CO", [1])]), new _compost.Scale("Continuous", [new _compost.continuous("CO", [lhgt]), new _compost.continuous("CO", [1])]), new _compost.Shape("Padding", [[20, ctx.Padding[1], 0, ctx.Padding[3]], labs_1])])])]);
        return new ChartContext(chart_3, ctx.Width, ctx.Height, ctx.XPoints, ctx.YPoints, ctx.XData, ctx.YData, ctx.Padding, ctx.ChartOptions);

      case 2:
        return ctx;
    }
  };

  var applyLabels = __exports.applyLabels = function (ctx) {
    var lblStyle = function lblStyle(font) {
      return function (chart) {
        return applyStyle(function (s) {
          var StrokeWidth = new _compost.Width("Pixels", [0]);
          var Fill = new _compost.FillStyle("Solid", [[1, new _compost.Color("HTML", ["black"])]]);
          return new _compost.Style(s.StrokeColor, StrokeWidth, s.StrokeDashArray, Fill, s.Animation, font, s.Cursor, s.FormatAxisXLabel, s.FormatAxisYLabel);
        }, chart);
      };
    };

    var patternInput = void 0;
    var matchValue = [ctx.ChartOptions.xAxis.label, ctx.ChartOptions.xAxis.labelMinimalSize];
    var $var119 = matchValue[1] != null ? function () {
      var min = matchValue[1];
      return ctx.Height < min;
    }() ? [0, matchValue[1]] : [1] : [1];

    switch ($var119[0]) {
      case 0:
        patternInput = [ctx.Chart, ctx.Padding[2]];
        break;

      case 1:
        if (matchValue[0] != null) {
          var xl = matchValue[0];
          var offs = (0, _Util.defaultArg)(ctx.ChartOptions.xAxis.labelOffset, 40);
          var lbl = new _compost.Shape("Offset", [[0, offs], new _compost.Shape("Text", [ctx.XPoints.Middle, ctx.YPoints.Minimum, new _compost.VerticalAlign("Middle", []), new _compost.HorizontalAlign("Center", []), 0, xl])]);
          patternInput = [new _compost.Shape("Layered", [(0, _List.ofArray)([ctx.Chart, lblStyle("bold 9pt Roboto,sans-serif")(lbl)])]), offs + 10 - 30];
        } else {
          patternInput = [ctx.Chart, ctx.Padding[2]];
        }

        break;
    }

    var patternInput_1 = void 0;
    var matchValue_1 = [ctx.ChartOptions.yAxis.label, ctx.ChartOptions.yAxis.labelMinimalSize];
    var $var120 = matchValue_1[1] != null ? function () {
      var min_1 = matchValue_1[1];
      return ctx.Width < min_1;
    }() ? [0, matchValue_1[1]] : [1] : [1];

    switch ($var120[0]) {
      case 0:
        patternInput_1 = [patternInput[0], patternInput[1]];
        break;

      case 1:
        if (matchValue_1[0] != null) {
          var yl = matchValue_1[0];
          var offs_1 = (0, _Util.defaultArg)(ctx.ChartOptions.yAxis.labelOffset, 60);
          var lbl_1 = new _compost.Shape("Offset", [[-offs_1, 0], new _compost.Shape("Text", [ctx.XPoints.Minimum, ctx.YPoints.Middle, new _compost.VerticalAlign("Middle", []), new _compost.HorizontalAlign("Center", []), -90, yl])]);
          patternInput_1 = [new _compost.Shape("Layered", [(0, _List.ofArray)([patternInput[0], lblStyle("bold 9pt Roboto,sans-serif")(lbl_1)])]), offs_1 + 10 - 50];
        } else {
          patternInput_1 = [patternInput[0], ctx.Padding[3]];
        }

        break;
    }

    var patternInput_2 = void 0;
    var matchValue_2 = ctx.ChartOptions.title;

    if (matchValue_2 != null) {
      var ttl = new _compost.Shape("Offset", [[0, -30], new _compost.Shape("Text", [ctx.XPoints.Middle, ctx.YPoints.Maximum, new _compost.VerticalAlign("Hanging", []), new _compost.HorizontalAlign("Center", []), 0, matchValue_2])]);
      patternInput_2 = [new _compost.Shape("Layered", [(0, _List.ofArray)([patternInput_1[0], lblStyle("13pt Roboto,sans-serif")(ttl)])]), 40];
    } else {
      patternInput_2 = [patternInput_1[0], ctx.Padding[0]];
    }

    var Padding = [patternInput_2[1], ctx.Padding[1], patternInput[1], patternInput_1[1]];
    return new ChartContext(patternInput_2[0], ctx.Width, ctx.Height, ctx.XPoints, ctx.YPoints, ctx.XData, ctx.YData, Padding, ctx.ChartOptions);
  };

  var createChart = __exports.createChart = function (size_0, size_1, ctx) {
    var size = [size_0, size_1];
    return function (arg0) {
      return function (arg1) {
        return _html.El.op_Dynamic(arg0, arg1);
      };
    }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", "text-align:center;padding-top:20px")]))((0, _List.ofArray)([function () {
      var revX = false;
      var revY = false;
      return _compost.Compost.createSvg(revX, revY, size[0], size[1], ctx.Chart);
    }()]));
  };

  var inAxis = __exports.inAxis = function (axis, value) {
    if (function () {
      return axis.minValue != null;
    }(null) ? (value instanceof Date ? value.getTime() : value) < (axis.minValue instanceof Date ? axis.minValue.getTime() : axis.minValue) : false) {
      return false;
    } else if (function () {
      return axis.maxValue != null;
    }(null) ? (value instanceof Date ? value.getTime() : value) > (axis.maxValue instanceof Date ? axis.maxValue.getTime() : axis.maxValue) : false) {
      return false;
    } else {
      return true;
    }
  };

  return __exports;
}({});

var Charts = exports.Charts = function (__exports) {
  var renderBubbles = __exports.renderBubbles = function (trigger, selectedBubble, chartOptions, size_0, size_1, bc, data) {
    var size = [size_0, size_1];
    var patternInput = [data.map(function (tupledArg) {
      return tupledArg[0];
    }), data.map(function (tupledArg_1) {
      return tupledArg_1[1];
    })];

    var tryFindBubble = function tryFindBubble(rx) {
      return function (ry) {
        return function (px) {
          return function (py) {
            return (0, _Seq.tryFindIndex)(function (tupledArg_2) {
              var size_2 = (0, _Util.defaultArg)(tupledArg_2[2], 2);
              var patternInput_1 = [rx * size_2 * 2, ry * size_2 * 2];
              var patternInput_2 = [tupledArg_2[0] instanceof Date ? tupledArg_2[0].getTime() : tupledArg_2[0], tupledArg_2[1] instanceof Date ? tupledArg_2[1].getTime() : tupledArg_2[1]];
              return (px - patternInput_2[0]) * (px - patternInput_2[0]) / (patternInput_1[0] * patternInput_1[0]) + (py - patternInput_2[1]) * (py - patternInput_2[1]) / (patternInput_1[1] * patternInput_1[1]) < 1;
            }, data);
          };
        };
      };
    };

    return Internal.createChart(size[0], size[1], Internal.applyAxes(false, false, true, true, Internal.applyLabels(Internal.applyScales(Internal.applyInteractiveCtx(function (ctx) {
      return (0, _List.ofArray)([new _compost.EventHandler("TouchStart", [function (evt) {
        return function (tupledArg_3) {
          var activePatternResult3935 = CompostHelpers["|Cont|"](tupledArg_3[0]);
          var activePatternResult3934 = CompostHelpers["|Cont|"](tupledArg_3[1]);
          var bub = (0, _Util.defaultArg)(tryFindBubble(ctx.XPoints.PixelSize)(ctx.YPoints.PixelSize)(activePatternResult3935)(activePatternResult3934), -1);

          if (bub !== selectedBubble) {
            trigger(bub);
          }
        };
      }]), new _compost.EventHandler("MouseMove", [function (evt_1) {
        return function (tupledArg_4) {
          var activePatternResult3939 = CompostHelpers["|Cont|"](tupledArg_4[0]);
          var activePatternResult3938 = CompostHelpers["|Cont|"](tupledArg_4[1]);
          var bub_1 = (0, _Util.defaultArg)(tryFindBubble(ctx.XPoints.PixelSize)(ctx.YPoints.PixelSize)(activePatternResult3939)(activePatternResult3938), -1);

          if (bub_1 !== selectedBubble) {
            trigger(bub_1);
          }
        };
      }]), new _compost.EventHandler("MouseLeave", [function (_arg12) {
        trigger(-1);
      }])]);
    }, function (chart) {
      return Internal.initChart(size[0], size[1], patternInput[0], patternInput[1], chartOptions, chart);
    }(new _compost.Shape("Layered", [(0, _Seq.toList)((0, _Seq.delay)(function () {
      return (0, _Seq.append)((0, _Seq.collect)(function (matchValue) {
        var y = matchValue[1][1];
        var x = matchValue[1][0];
        var s = matchValue[1][2];
        var l = matchValue[1][3];

        if (Internal.inAxis(chartOptions.xAxis, x) ? Internal.inAxis(chartOptions.yAxis, y) : false) {
          var size_3 = s != null ? s : 2;
          var b = new _compost.Shape("Bubble", [new _compost.Value("COV", [new _compost.continuous("CO", [x instanceof Date ? x.getTime() : x])]), new _compost.Value("COV", [new _compost.continuous("CO", [y instanceof Date ? y.getTime() : y])]), size_3, size_3]);
          var alpha = matchValue[0] === selectedBubble ? 1 : 0.6;
          return (0, _Seq.singleton)(Internal.applyStyle(function (s_1) {
            var StrokeWidth = new _compost.Width("Pixels", [0]);
            var Fill = new _compost.FillStyle("Solid", [[alpha, new _compost.Color("HTML", [bc])]]);
            return new _compost.Style(s_1.StrokeColor, StrokeWidth, s_1.StrokeDashArray, Fill, s_1.Animation, s_1.Font, s_1.Cursor, s_1.FormatAxisXLabel, s_1.FormatAxisYLabel);
          }, b));
        } else {
          return (0, _Seq.empty)();
        }
      }, (0, _Seq.mapIndexed)(function (i, v) {
        return [i, v];
      }, data)), (0, _Seq.delay)(function () {
        return (0, _Seq.collect)(function (matchValue_1) {
          var y_1 = matchValue_1[1][1];
          var x_1 = matchValue_1[1][0];
          var s_2 = matchValue_1[1][2];
          var l_1 = matchValue_1[1][3];

          if (matchValue_1[0] === selectedBubble ? function () {
            return l_1 != null;
          }(null) : false) {
            var t = new _compost.Shape("Text", [new _compost.Value("COV", [new _compost.continuous("CO", [x_1 instanceof Date ? x_1.getTime() : x_1])]), new _compost.Value("COV", [new _compost.continuous("CO", [y_1 instanceof Date ? y_1.getTime() : y_1])]), new _compost.VerticalAlign("Baseline", []), new _compost.HorizontalAlign("Center", []), 0, l_1]);
            return (0, _Seq.singleton)(Internal.applyStyle(function (s_3) {
              var Font = "10pt roboto,sans-serif";
              var StrokeWidth_1 = new _compost.Width("Pixels", [0]);
              var Fill_1 = new _compost.FillStyle("Solid", [[1, new _compost.Color("HTML", ["black"])]]);
              return new _compost.Style(s_3.StrokeColor, StrokeWidth_1, s_3.StrokeDashArray, Fill_1, s_3.Animation, Font, s_3.Cursor, s_3.FormatAxisXLabel, s_3.FormatAxisYLabel);
            }, t));
          } else {
            return (0, _Seq.empty)();
          }
        }, (0, _Seq.mapIndexed)(function (i_1, v_1) {
          return [i_1, v_1];
        }, data));
      }));
    }))])))))));
  };

  var renderLines = __exports.renderLines = function (isArea, chartOptions, size_0, size_1, lcs, labels, data) {
    var size = [size_0, size_1];
    var patternInput = [(0, _from2.default)((0, _Seq.collect)(function () {
      var mapping = function mapping(tuple) {
        return tuple[0];
      };

      return function (array) {
        return array.map(mapping);
      };
    }(), data)), (0, _from2.default)((0, _Seq.collect)(function () {
      var mapping_1 = function mapping_1(tuple_1) {
        return tuple_1[1];
      };

      return function (array_1) {
        return array_1.map(mapping_1);
      };
    }(), data))];
    return Internal.createChart(size[0], size[1], function () {
      var labels_1 = (0, _Seq.zip)(CompostHelpers.infinitely(lcs), labels);
      return function (ctx) {
        return Internal.applyLegend(size[0], size[1], labels_1, ctx);
      };
    }()(Internal.applyAxes(false, false, true, true, Internal.applyLabels(Internal.applyScales(function (chart) {
      return Internal.initChart(size[0], size[1], patternInput[0], patternInput[1], chartOptions, chart);
    }(new _compost.Shape("Layered", [(0, _Seq.toList)((0, _Seq.delay)(function () {
      return (0, _Seq.collect)(function (matchValue) {
        var points = (0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.collect)(function (matchValue_1) {
            return (Internal.inAxis(chartOptions.xAxis, matchValue_1[0]) ? Internal.inAxis(chartOptions.yAxis, matchValue_1[1]) : false) ? (0, _Seq.singleton)([new _compost.Value("COV", [new _compost.continuous("CO", [matchValue_1[0] instanceof Date ? matchValue_1[0].getTime() : matchValue_1[0]])]), new _compost.Value("COV", [new _compost.continuous("CO", [matchValue_1[1] instanceof Date ? matchValue_1[1].getTime() : matchValue_1[1]])])]) : (0, _Seq.empty)();
          }, matchValue[1]);
        }));

        if (!(points.tail == null)) {
          return (0, _Seq.append)(isArea ? (0, _Seq.singleton)(Internal.applyStyle(function (s) {
            var Fill = new _compost.FillStyle("Solid", [[0.4, new _compost.Color("HTML", [matchValue[0]])]]);
            var StrokeWidth = new _compost.Width("Pixels", [0]);
            return new _compost.Style(s.StrokeColor, StrokeWidth, s.StrokeDashArray, Fill, s.Animation, s.Font, s.Cursor, s.FormatAxisXLabel, s.FormatAxisYLabel);
          }, _compost.Derived.Area(points))) : (0, _Seq.empty)(), (0, _Seq.delay)(function () {
            return (0, _Seq.singleton)(Internal.applyStyle(function (s_1) {
              return new _compost.Style([1, new _compost.Color("HTML", [matchValue[0]])], new _compost.Width("Pixels", [2]), s_1.StrokeDashArray, s_1.Fill, s_1.Animation, s_1.Font, s_1.Cursor, s_1.FormatAxisXLabel, s_1.FormatAxisYLabel);
            }, new _compost.Shape("Line", [points])));
          }));
        } else {
          return (0, _Seq.empty)();
        }
      }, (0, _Seq.zip)(CompostHelpers.infinitely(lcs), data));
    }))])))))));
  };

  var renderColsBars = __exports.renderColsBars = function (isBar, inlineLabels, chartOptions, size_0, size_1, clrs, labels, data) {
    var size = [size_0, size_1];
    var patternInput = isBar ? [data.map(function ($var121) {
      return $var121[1];
    }), data.map(function ($var122) {
      return $var122[0];
    })] : [data.map(function ($var123) {
      return $var123[0];
    }), data.map(function ($var124) {
      return $var124[1];
    })];
    var patternInput_1 = Internal.applyScales(function (chart) {
      return Internal.initChart(size[0], size[1], patternInput[0], patternInput[1], chartOptions, chart);
    }(new _compost.Shape("Layered", [(0, _Seq.toList)((0, _Seq.delay)(function () {
      return (0, _Seq.collect)(function (matchValue) {
        return (0, _Seq.singleton)(isBar ? _compost.Derived.Bar(new _compost.continuous("CO", [matchValue[1]]), new _compost.categorical("CA", [matchValue[0]])) : _compost.Derived.Column(new _compost.categorical("CA", [matchValue[0]]), new _compost.continuous("CO", [matchValue[1]])));
      }, data);
    }))])));
    var chartOptions_1 = void 0;

    if ((isBar ? inlineLabels : false) ? function () {
      return chartOptions.yAxis.labelOffset == null;
    }(null) : false) {
      var yAxis = void 0;
      var labelOffset = null;
      yAxis = new AxisOptions(chartOptions.yAxis.minValue, chartOptions.yAxis.maxValue, chartOptions.yAxis.label, labelOffset, chartOptions.yAxis.labelMinimalSize);
      chartOptions_1 = new ChartOptions(chartOptions.size, chartOptions.xAxis, yAxis, chartOptions.title, chartOptions.legend, chartOptions.emptyMessage);
    } else if ((!isBar ? inlineLabels : false) ? function () {
      return chartOptions.yAxis.labelOffset == null;
    }(null) : false) {
      var xAxis = void 0;
      var labelOffset_1 = null;
      xAxis = new AxisOptions(chartOptions.xAxis.minValue, chartOptions.xAxis.maxValue, chartOptions.xAxis.label, labelOffset_1, chartOptions.xAxis.labelMinimalSize);
      chartOptions_1 = new ChartOptions(chartOptions.size, xAxis, chartOptions.yAxis, chartOptions.title, chartOptions.legend, chartOptions.emptyMessage);
    } else {
      chartOptions_1 = chartOptions;
    }

    return Internal.createChart(size[0], size[1], function () {
      var labels_1 = (0, _Seq.zip)(CompostHelpers.infinitely(clrs), labels);
      return function (ctx) {
        return Internal.applyLegend(size[0], size[1], labels_1, ctx);
      };
    }()(Internal.applyAxes(false, false, !(inlineLabels ? !isBar : false), !(inlineLabels ? isBar : false), Internal.applyLabels(Internal.applyScales(function (chart_1) {
      return Internal.initChart(size[0], size[1], patternInput[0], patternInput[1], chartOptions_1, chart_1);
    }(new _compost.Shape("Layered", [(0, _Seq.toList)((0, _Seq.delay)(function () {
      return (0, _Seq.collect)(function (matchValue_1) {
        var v = matchValue_1[1][1];
        var lbl = matchValue_1[1][0];
        var elem = isBar ? new _compost.Shape("Padding", [[6, 0, 6, 1], _compost.Derived.Bar(new _compost.continuous("CO", [v]), new _compost.categorical("CA", [lbl]))]) : new _compost.Shape("Padding", [[0, 6, 1, 6], _compost.Derived.Column(new _compost.categorical("CA", [lbl]), new _compost.continuous("CO", [v]))]);
        var label = !inlineLabels ? null : isBar ? new _compost.Shape("Offset", [[20, 0], new _compost.Shape("Text", [patternInput_1.XPoints.Minimum, new _compost.Value("CAR", [new _compost.categorical("CA", [lbl]), 0.5]), new _compost.VerticalAlign("Middle", []), new _compost.HorizontalAlign("Start", []), 0, lbl])]) : new _compost.Shape("Offset", [[0, -20], new _compost.Shape("Text", [new _compost.Value("CAR", [new _compost.categorical("CA", [lbl]), 0.5]), patternInput_1.YPoints.Minimum, new _compost.VerticalAlign("Middle", []), new _compost.HorizontalAlign("Start", []), -90, lbl])]);
        return (0, _Seq.append)((0, _Seq.singleton)(Internal.applyStyle(function (s) {
          var Fill = new _compost.FillStyle("Solid", [[0.6, new _compost.Color("HTML", [matchValue_1[0]])]]);
          return new _compost.Style(s.StrokeColor, s.StrokeWidth, s.StrokeDashArray, Fill, s.Animation, s.Font, s.Cursor, s.FormatAxisXLabel, s.FormatAxisYLabel);
        }, elem)), (0, _Seq.delay)(function () {
          if (function () {
            return label != null;
          }(null)) {
            var clr = Internal.mapColor(function (tupledArg) {
              return [tupledArg[0] * 0.8, tupledArg[1] * 0.8, tupledArg[2] * 0.8];
            }, matchValue_1[0]);
            return (0, _Seq.singleton)(Internal.applyStyle(function (s_1) {
              var Font = "11pt Roboto,sans-serif";
              var Fill_1 = new _compost.FillStyle("Solid", [[1, new _compost.Color("HTML", [clr])]]);
              var StrokeWidth = new _compost.Width("Pixels", [0]);
              return new _compost.Style(s_1.StrokeColor, StrokeWidth, s_1.StrokeDashArray, Fill_1, s_1.Animation, Font, s_1.Cursor, s_1.FormatAxisXLabel, s_1.FormatAxisYLabel);
            }, label));
          } else {
            return (0, _Seq.empty)();
          }
        }));
      }, (0, _Seq.zip)(CompostHelpers.infinitely(clrs), data));
    }))])))))));
  };

  return __exports;
}({});

var YouGuessLineHelpers = exports.YouGuessLineHelpers = function (__exports) {
  var YouDrawEvent = __exports.YouDrawEvent = function () {
    function YouDrawEvent(caseName, fields) {
      (0, _classCallCheck3.default)(this, YouDrawEvent);
      this.Case = caseName;
      this.Fields = fields;
    }

    (0, _createClass3.default)(YouDrawEvent, [{
      key: _Symbol3.default.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.YouGuessLineHelpers.YouDrawEvent",
          interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
          cases: {
            Draw: ["number", "number"],
            ShowResults: []
          }
        };
      }
    }, {
      key: "Equals",
      value: function (other) {
        return (0, _Util.equalsUnions)(this, other);
      }
    }, {
      key: "CompareTo",
      value: function (other) {
        return (0, _Util.compareUnions)(this, other);
      }
    }]);
    return YouDrawEvent;
  }();

  (0, _Symbol2.setType)("TheGamma.Interactive.YouGuessLineHelpers.YouDrawEvent", YouDrawEvent);

  var Status = __exports.Status = function () {
    function Status(caseName, fields) {
      (0, _classCallCheck3.default)(this, Status);
      this.Case = caseName;
      this.Fields = fields;
    }

    (0, _createClass3.default)(Status, [{
      key: _Symbol3.default.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.YouGuessLineHelpers.Status",
          interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
          cases: {
            Autofilled: ["number"],
            NotSet: [],
            Set: ["number"]
          }
        };
      }
    }, {
      key: "Equals",
      value: function (other) {
        return (0, _Util.equalsUnions)(this, other);
      }
    }, {
      key: "CompareTo",
      value: function (other) {
        return (0, _Util.compareUnions)(this, other);
      }
    }]);
    return Status;
  }();

  (0, _Symbol2.setType)("TheGamma.Interactive.YouGuessLineHelpers.Status", Status);

  var YouDrawState = __exports.YouDrawState = function () {
    function YouDrawState(completed, clip, data, xData, yData, guessed, isKeyDate) {
      (0, _classCallCheck3.default)(this, YouDrawState);
      this.Completed = completed;
      this.Clip = clip;
      this.Data = data;
      this.XData = xData;
      this.YData = yData;
      this.Guessed = guessed;
      this.IsKeyDate = isKeyDate;
    }

    (0, _createClass3.default)(YouDrawState, [{
      key: _Symbol3.default.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.YouGuessLineHelpers.YouDrawState",
          interfaces: ["FSharpRecord", "System.IEquatable"],
          properties: {
            Completed: "boolean",
            Clip: "number",
            Data: (0, _Util.Array)((0, _Util.Tuple)(["number", "number"])),
            XData: (0, _Util.Array)(_Util.Any),
            YData: (0, _Util.Array)(_Util.Any),
            Guessed: (0, _Util.Array)((0, _Util.Tuple)(["number", Status])),
            IsKeyDate: "boolean"
          }
        };
      }
    }, {
      key: "Equals",
      value: function (other) {
        return (0, _Util.equalsRecords)(this, other);
      }
    }]);
    return YouDrawState;
  }();

  (0, _Symbol2.setType)("TheGamma.Interactive.YouGuessLineHelpers.YouDrawState", YouDrawState);

  var initState = __exports.initState = function (completed, data, clipx) {
    var isDate = (0, _Seq.exists)(function ($var125) {
      return $var125[0] instanceof Date;
    }, data);
    var numData = data.map(function (tupledArg) {
      return [tupledArg[0] instanceof Date ? tupledArg[0].getTime() : tupledArg[0], tupledArg[1]];
    });
    var XData = data.map(function ($var126) {
      return $var126[0];
    });
    var YData = data.map(function ($var127) {
      return $var127[1];
    });
    return new YouDrawState(completed, clipx, numData, XData, YData, (0, _from2.default)((0, _Seq.delay)(function () {
      return (0, _Seq.collect)(function (matchValue) {
        return matchValue[0] > clipx ? completed ? (0, _Seq.singleton)([matchValue[0], new Status("Set", [matchValue[1]])]) : (0, _Seq.singleton)([matchValue[0], new Status("NotSet", [])]) : (0, _Seq.empty)();
      }, numData);
    })), isDate);
  };

  var handler = __exports.handler = function (log, state, evt) {
    var collectData = function collectData() {
      return state.Data.map(function (tupledArg) {
        return [tupledArg[0], tupledArg[1]];
      });
    };

    var collectGuesses = function collectGuesses() {
      return (0, _from2.default)((0, _Seq.choose)(function (_arg1) {
        if (_arg1[1].Case === "Set") {
          var v = _arg1[1].Fields[0];
          return [_arg1[0], v];
        } else {
          return null;
        }
      }, state.Guessed));
    };

    if (evt.Case === "Draw") {
      var indexed = state.Guessed.map(function (x, y) {
        return [y, x];
      });
      var patternInput = (0, _Seq.reduce)(function (f) {
        return function (x, y) {
          return f(x) < f(y) ? x : y;
        };
      }(function (tupledArg_1) {
        return Math.abs(evt.Fields[0] - tupledArg_1[1][0]);
      }), indexed);
      var Guessed = indexed.map(function (tupledArg_2) {
        if (tupledArg_2[0] === patternInput[0]) {
          return [tupledArg_2[1][0], new Status("Set", [evt.Fields[1]])];
        } else {
          var $var128 = tupledArg_2[1][1].Case === "NotSet" ? tupledArg_2[0] > patternInput[0] ? [0] : [1] : [1];

          switch ($var128[0]) {
            case 0:
              return [tupledArg_2[1][0], new Status("Autofilled", [evt.Fields[1]])];

            case 1:
              return [tupledArg_2[1][0], tupledArg_2[1][1]];
          }
        }
      });
      return new YouDrawState(state.Completed, state.Clip, state.Data, state.XData, state.YData, Guessed, state.IsKeyDate);
    } else {
      log("completed")((0, _List.ofArray)([["guess", collectGuesses(null)], ["values", collectData(null)]]));
      return new YouDrawState(true, state.Clip, state.Data, state.XData, state.YData, state.Guessed, state.IsKeyDate);
    }
  };

  var render = __exports.render = function (solvedComment, interactive, chartOptions, width, height, markers, leftLbl, rightLbl, leftClr, rightClr, guessClr, markClr, trigger, state) {
    var all = (0, _from2.default)((0, _Seq.delay)(function () {
      return (0, _Seq.collect)(function (matchValue) {
        return (0, _Seq.singleton)([CompostHelpers.Cont(matchValue[0]), CompostHelpers.Cont(matchValue[1])]);
      }, state.Data);
    }));
    var known = (0, _from2.default)((0, _Seq.delay)(function () {
      return (0, _Seq.collect)(function (matchValue_1) {
        return matchValue_1[0] <= state.Clip ? (0, _Seq.singleton)([CompostHelpers.Cont(matchValue_1[0]), CompostHelpers.Cont(matchValue_1[1])]) : (0, _Seq.empty)();
      }, state.Data);
    }));
    var right = (0, _from2.default)((0, _Seq.delay)(function () {
      return (0, _Seq.append)((0, _Seq.singleton)((0, _Seq.last)(known)), (0, _Seq.delay)(function () {
        return (0, _Seq.collect)(function (matchValue_2) {
          return matchValue_2[0] > state.Clip ? (0, _Seq.singleton)([CompostHelpers.Cont(matchValue_2[0]), CompostHelpers.Cont(matchValue_2[1])]) : (0, _Seq.empty)();
        }, state.Data);
      }));
    }));
    var guessed = (0, _from2.default)((0, _Seq.delay)(function () {
      return (0, _Seq.append)((0, _Seq.singleton)((0, _Seq.last)(known)), (0, _Seq.delay)(function () {
        return (0, _Seq.collect)(function (matchValue_3) {
          var $var129 = matchValue_3[1].Case === "Set" ? [0, matchValue_3[1].Fields[0]] : matchValue_3[1].Case === "Autofilled" ? [0, matchValue_3[1].Fields[0]] : [1];

          switch ($var129[0]) {
            case 0:
              return (0, _Seq.singleton)([CompostHelpers.Cont(matchValue_3[0]), CompostHelpers.Cont($var129[1])]);

            case 1:
              return (0, _Seq.empty)();
          }
        }, state.Guessed);
      }));
    }));
    var loy = void 0;
    var matchValue_4 = chartOptions.yAxis.minValue;

    if (matchValue_4 != null) {
      loy = matchValue_4;
    } else {
      loy = (0, _Seq.reduce)(function (x, y) {
        return Math.min(x, y);
      }, (0, _Seq.map)(function (tuple) {
        return tuple[1];
      }, state.Data));
    }

    var hiy = void 0;
    var matchValue_5 = chartOptions.yAxis.maxValue;

    if (matchValue_5 != null) {
      hiy = matchValue_5;
    } else {
      hiy = (0, _Seq.reduce)(function (x, y) {
        return Math.max(x, y);
      }, (0, _Seq.map)(function (tuple_1) {
        return tuple_1[1];
      }, state.Data));
    }

    var patternInput = [((0, _Seq.head)(state.Data)[0] + state.Clip) / 2, loy + (hiy - loy) / 10];
    var patternInput_1 = [((0, _Seq.last)(state.Data)[0] + state.Clip) / 2, loy + (hiy - loy) / 10];
    var patternInput_2 = [state.Clip, hiy - (hiy - loy) / 10];

    var setColor = function setColor(c) {
      return function (s) {
        var Font = "12pt Roboto,sans-serif";
        var Fill = new _compost.FillStyle("Solid", [[1, new _compost.Color("HTML", [c])]]);
        return new _compost.Style([0, new _compost.Color("RGB", [0, 0, 0])], s.StrokeWidth, s.StrokeDashArray, Fill, s.Animation, Font, s.Cursor, s.FormatAxisXLabel, s.FormatAxisYLabel);
      };
    };

    var labels = new _compost.Shape("Layered", [(0, _List.ofArray)([new _compost.Shape("Style", [setColor(leftClr), new _compost.Shape("Text", [new _compost.Value("COV", [new _compost.continuous("CO", [patternInput[0]])]), new _compost.Value("COV", [new _compost.continuous("CO", [patternInput[1]])]), new _compost.VerticalAlign("Baseline", []), new _compost.HorizontalAlign("Center", []), 0, leftLbl])]), new _compost.Shape("Style", [setColor(rightClr), new _compost.Shape("Text", [new _compost.Value("COV", [new _compost.continuous("CO", [patternInput_1[0]])]), new _compost.Value("COV", [new _compost.continuous("CO", [patternInput_1[1]])]), new _compost.VerticalAlign("Baseline", []), new _compost.HorizontalAlign("Center", []), 0, rightLbl])])])]);

    var LineStyle = function LineStyle(shape) {
      return new _compost.Shape("Style", [function (s_1) {
        var Fill_1 = new _compost.FillStyle("Solid", [[1, new _compost.Color("HTML", ["transparent"])]]);
        var StrokeWidth = new _compost.Width("Pixels", [2]);
        var StrokeDashArray = (0, _List.ofArray)([new _compost.Number("Integer", [5]), new _compost.Number("Integer", [5])]);
        return new _compost.Style([0.6, new _compost.Color("HTML", [markClr])], StrokeWidth, StrokeDashArray, Fill_1, s_1.Animation, s_1.Font, s_1.Cursor, s_1.FormatAxisXLabel, s_1.FormatAxisYLabel);
      }, shape]);
    };

    var FontStyle = function FontStyle(shape_1) {
      return new _compost.Shape("Style", [function (s_2) {
        var Font_1 = "11pt Roboto,sans-serif";
        var Fill_2 = new _compost.FillStyle("Solid", [[1, new _compost.Color("HTML", [markClr])]]);
        return new _compost.Style([0, new _compost.Color("HTML", ["transparent"])], s_2.StrokeWidth, s_2.StrokeDashArray, Fill_2, s_2.Animation, Font_1, s_2.Cursor, s_2.FormatAxisXLabel, s_2.FormatAxisYLabel);
      }, shape_1]);
    };

    var patternInput_3 = _compost.Scales.adjustRange(loy, hiy);

    var markers_1 = (0, _Seq.toList)((0, _Seq.delay)(function () {
      return (0, _Seq.collect)(function (matchValue_6) {
        var x = matchValue_6[1][0];
        var lbl = matchValue_6[1][1];
        var patternInput_4 = matchValue_6[0] % 2 === 0 ? [0.9, 0.95] : [0.8, 0.85];
        var ytx = patternInput_3[0] + (patternInput_3[1] - patternInput_3[0]) * patternInput_4[1];
        var hiln = patternInput_3[0] + (patternInput_3[1] - patternInput_3[0]) * patternInput_4[0];
        return (0, _Seq.append)((0, _Seq.singleton)(LineStyle(new _compost.Shape("Line", [(0, _List.ofArray)([[new _compost.Value("COV", [new _compost.continuous("CO", [x])]), new _compost.Value("COV", [new _compost.continuous("CO", [patternInput_3[0]])])], [new _compost.Value("COV", [new _compost.continuous("CO", [x])]), new _compost.Value("COV", [new _compost.continuous("CO", [hiln])])]])]))), (0, _Seq.delay)(function () {
          return (0, _Seq.singleton)(FontStyle(new _compost.Shape("Text", [new _compost.Value("COV", [new _compost.continuous("CO", [x])]), new _compost.Value("COV", [new _compost.continuous("CO", [ytx])]), new _compost.VerticalAlign("Middle", []), new _compost.HorizontalAlign("Center", []), 0, (0, _Util.toString)(lbl)])));
        }));
      }, (0, _Seq.mapIndexed)(function (i, v) {
        return [i, v];
      }, markers));
    }));
    var coreChart = new _compost.Shape("Layered", [(0, _Seq.toList)((0, _Seq.delay)(function () {
      return (0, _Seq.append)((0, _Seq.singleton)(labels), (0, _Seq.delay)(function () {
        return (0, _Seq.append)(markers_1, (0, _Seq.delay)(function () {
          return (0, _Seq.append)((0, _Seq.singleton)(new _compost.Shape("Style", [function ($var130) {
            return _compost.Drawing.hideStroke(_compost.Drawing.hideFill($var130));
          }, new _compost.Shape("Line", [all])])), (0, _Seq.delay)(function () {
            return (0, _Seq.append)((0, _Seq.singleton)(new _compost.Shape("Style", [function (s_3) {
              var StrokeColor = [1, new _compost.Color("HTML", [leftClr])];
              var Fill_3 = new _compost.FillStyle("Solid", [[0.2, new _compost.Color("HTML", [leftClr])]]);
              return new _compost.Style(StrokeColor, s_3.StrokeWidth, s_3.StrokeDashArray, Fill_3, s_3.Animation, s_3.Font, s_3.Cursor, s_3.FormatAxisXLabel, s_3.FormatAxisYLabel);
            }, new _compost.Shape("Layered", [(0, _List.ofArray)([_compost.Derived.Area(known), new _compost.Shape("Line", [known])])])])), (0, _Seq.delay)(function () {
              return (0, _Seq.append)(state.Completed ? (0, _Seq.singleton)(new _compost.Shape("Style", [function (s_4) {
                var StrokeColor_1 = [1, new _compost.Color("HTML", [rightClr])];
                var StrokeDashArray_1 = (0, _List.ofArray)([new _compost.Number("Percentage", [0]), new _compost.Number("Percentage", [100])]);
                var Fill_4 = new _compost.FillStyle("Solid", [[0, new _compost.Color("HTML", [rightClr])]]);
                var Animation = [1000, "ease", function (s_5) {
                  var StrokeDashArray_2 = (0, _List.ofArray)([new _compost.Number("Percentage", [100]), new _compost.Number("Percentage", [0])]);
                  var Fill_5 = new _compost.FillStyle("Solid", [[0.2, new _compost.Color("HTML", [rightClr])]]);
                  return new _compost.Style(s_5.StrokeColor, s_5.StrokeWidth, StrokeDashArray_2, Fill_5, s_5.Animation, s_5.Font, s_5.Cursor, s_5.FormatAxisXLabel, s_5.FormatAxisYLabel);
                }];
                return new _compost.Style(StrokeColor_1, s_4.StrokeWidth, StrokeDashArray_1, Fill_4, Animation, s_4.Font, s_4.Cursor, s_4.FormatAxisXLabel, s_4.FormatAxisYLabel);
              }, new _compost.Shape("Layered", [(0, _List.ofArray)([_compost.Derived.Area(right), new _compost.Shape("Line", [right])])])])) : (0, _Seq.empty)(), (0, _Seq.delay)(function () {
                return guessed.length > 1 ? (0, _Seq.singleton)(new _compost.Shape("Style", [function (s_6) {
                  var StrokeColor_2 = [1, new _compost.Color("HTML", [guessClr])];
                  var StrokeDashArray_3 = (0, _List.ofArray)([new _compost.Number("Integer", [5]), new _compost.Number("Integer", [5])]);
                  return new _compost.Style(StrokeColor_2, s_6.StrokeWidth, StrokeDashArray_3, s_6.Fill, s_6.Animation, s_6.Font, s_6.Cursor, s_6.FormatAxisXLabel, s_6.FormatAxisYLabel);
                }, new _compost.Shape("Line", [guessed])])) : (0, _Seq.empty)();
              }));
            }));
          }));
        }));
      }));
    }))]);
    var patternInput_5 = Internal.applyAxes(false, false, true, true, Internal.applyLabels(Internal.applyScales(function () {
      var tupledArg = [width, height];
      return function (chart) {
        return Internal.initChart(tupledArg[0], tupledArg[1], state.XData, state.YData, chartOptions, chart);
      };
    }()(coreChart))));
    var chart_1 = Internal.applyInteractive(state.Completed ? new _List2.default() : (0, _List.ofArray)([new _compost.EventHandler("MouseMove", [function (evt) {
      return function (tupledArg_1) {
        var activePatternResult4070 = CompostHelpers["|Cont|"](tupledArg_1[0]);
        var activePatternResult4069 = CompostHelpers["|Cont|"](tupledArg_1[1]);

        if ((~~evt.buttons & 1) === 1) {
          trigger(new YouDrawEvent("Draw", [activePatternResult4070, activePatternResult4069]));
        }
      };
    }]), new _compost.EventHandler("TouchMove", [function (evt_1) {
      return function (tupledArg_2) {
        var activePatternResult4074 = CompostHelpers["|Cont|"](tupledArg_2[0]);
        var activePatternResult4073 = CompostHelpers["|Cont|"](tupledArg_2[1]);
        trigger(new YouDrawEvent("Draw", [activePatternResult4074, activePatternResult4073]));
      };
    }]), new _compost.EventHandler("MouseDown", [function (evt_2) {
      return function (tupledArg_3) {
        var activePatternResult4078 = CompostHelpers["|Cont|"](tupledArg_3[0]);
        var activePatternResult4077 = CompostHelpers["|Cont|"](tupledArg_3[1]);
        trigger(new YouDrawEvent("Draw", [activePatternResult4078, activePatternResult4077]));
      };
    }]), new _compost.EventHandler("TouchStart", [function (evt_3) {
      return function (tupledArg_4) {
        var activePatternResult4082 = CompostHelpers["|Cont|"](tupledArg_4[0]);
        var activePatternResult4081 = CompostHelpers["|Cont|"](tupledArg_4[1]);
        trigger(new YouDrawEvent("Draw", [activePatternResult4082, activePatternResult4081]));
      };
    }])]), patternInput_5.Chart);
    return function (arg0) {
      return function (arg1) {
        return _html.El.op_Dynamic(arg0, arg1);
      };
    }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", "text-align:center;padding-top:20px")]))((0, _Seq.toList)((0, _Seq.delay)(function () {
      return (0, _Seq.append)((0, _Seq.singleton)(_compost.Compost.createSvg(false, false, width, height, chart_1)), (0, _Seq.delay)(function () {
        return (state.Completed ? function () {
          return solvedComment != null;
        }(null) : false) ? (0, _Seq.singleton)(function (arg0_1) {
          return function (arg1_1) {
            return _html.El.op_Dynamic(arg0_1, arg1_1);
          };
        }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", "padding-bottom:20px")]))((0, _List.ofArray)([function (arg0_2) {
          return function (arg1_2) {
            return _html.El.op_Dynamic(arg0_2, arg1_2);
          };
        }(_html.h)("p")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "solved")]))((0, _List.ofArray)([(0, _html.text)(solvedComment)]))]))) : interactive ? (0, _Seq.singleton)(function (arg0_3) {
          return function (arg1_3) {
            return _html.El.op_Dynamic(arg0_3, arg1_3);
          };
        }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", "padding-bottom:20px")]))((0, _List.ofArray)([function (arg0_4) {
          return function (arg1_4) {
            return _html.El.op_Dynamic(arg0_4, arg1_4);
          };
        }(_html.h)("button")((0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.append)((0, _Seq.singleton)((0, _html.op_EqualsGreater)("type", "button")), (0, _Seq.delay)(function () {
            return (0, _Seq.append)((0, _Seq.singleton)((0, _html.op_EqualsBangGreater)("click", function (_arg10) {
              return function (_arg9) {
                trigger(new YouDrawEvent("ShowResults", []));
              };
            })), (0, _Seq.delay)(function () {
              return (0, _Seq.last)(state.Guessed)[1].Equals(new Status("NotSet", [])) ? (0, _Seq.singleton)((0, _html.op_EqualsGreater)("disabled", "disabled")) : (0, _Seq.empty)();
            }));
          }));
        })))((0, _List.ofArray)([(0, _html.text)("Show me how I did")]))]))) : (0, _Seq.empty)();
      }));
    })));
  };

  return __exports;
}({});

var YouGeussLineOffsetHelpers = exports.YouGeussLineOffsetHelpers = function (__exports) {
  var YouDrawEvent = __exports.YouDrawEvent = function () {
    function YouDrawEvent(caseName, fields) {
      (0, _classCallCheck3.default)(this, YouDrawEvent);
      this.Case = caseName;
      this.Fields = fields;
    }

    (0, _createClass3.default)(YouDrawEvent, [{
      key: _Symbol3.default.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.YouGeussLineOffsetHelpers.YouDrawEvent",
          interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
          cases: {
            Animate: [],
            ContinueMoving: ["number"],
            HideOverlay: [],
            ShowResults: [],
            StartMoving: ["number"],
            StopMoving: []
          }
        };
      }
    }, {
      key: "Equals",
      value: function (other) {
        return (0, _Util.equalsUnions)(this, other);
      }
    }, {
      key: "CompareTo",
      value: function (other) {
        return (0, _Util.compareUnions)(this, other);
      }
    }]);
    return YouDrawEvent;
  }();

  (0, _Symbol2.setType)("TheGamma.Interactive.YouGeussLineOffsetHelpers.YouDrawEvent", YouDrawEvent);

  var YouDrawState = __exports.YouDrawState = function () {
    function YouDrawState(completed, interactive, data, xData, yData, isKeyDate, offsetStart, offset, offsetRange, xRange, yRange, overlayHiding, overlayOpacity, completionStep, chartOptions) {
      (0, _classCallCheck3.default)(this, YouDrawState);
      this.Completed = completed;
      this.Interactive = interactive;
      this.Data = data;
      this.XData = xData;
      this.YData = yData;
      this.IsKeyDate = isKeyDate;
      this.OffsetStart = offsetStart;
      this.Offset = offset;
      this.OffsetRange = offsetRange;
      this.XRange = xRange;
      this.YRange = yRange;
      this.OverlayHiding = overlayHiding;
      this.OverlayOpacity = overlayOpacity;
      this.CompletionStep = completionStep;
      this.ChartOptions = chartOptions;
    }

    (0, _createClass3.default)(YouDrawState, [{
      key: _Symbol3.default.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.YouGeussLineOffsetHelpers.YouDrawState",
          interfaces: ["FSharpRecord", "System.IEquatable"],
          properties: {
            Completed: "boolean",
            Interactive: "boolean",
            Data: (0, _Util.Array)((0, _Util.Tuple)(["number", "number"])),
            XData: (0, _Util.Array)(_Util.Any),
            YData: (0, _Util.Array)(_Util.Any),
            IsKeyDate: "boolean",
            OffsetStart: (0, _Util.Option)("number"),
            Offset: "number",
            OffsetRange: (0, _Util.Tuple)(["number", "number"]),
            XRange: (0, _Util.Tuple)(["number", "number"]),
            YRange: (0, _Util.Tuple)(["number", "number"]),
            OverlayHiding: "boolean",
            OverlayOpacity: "number",
            CompletionStep: "number",
            ChartOptions: ChartOptions
          }
        };
      }
    }, {
      key: "Equals",
      value: function (other) {
        return (0, _Util.equalsRecords)(this, other);
      }
    }]);
    return YouDrawState;
  }();

  (0, _Symbol2.setType)("TheGamma.Interactive.YouGeussLineOffsetHelpers.YouDrawState", YouDrawState);

  var initState = __exports.initState = function (completed, chartOptions, data) {
    var isDate = (0, _Seq.exists)(function ($var131) {
      return $var131[0] instanceof Date;
    }, data);
    var numData = data.map(function (tupledArg) {
      return [tupledArg[0] instanceof Date ? tupledArg[0].getTime() : tupledArg[0], tupledArg[1]];
    });

    var range = function range(axis) {
      return function (data_1) {
        return [(0, _Util.defaultArg)(axis.minValue, (0, _Seq.min)(data_1)) instanceof Date ? (0, _Util.defaultArg)(axis.minValue, (0, _Seq.min)(data_1)).getTime() : (0, _Util.defaultArg)(axis.minValue, (0, _Seq.min)(data_1)), (0, _Util.defaultArg)(axis.maxValue, (0, _Seq.max)(data_1)) instanceof Date ? (0, _Util.defaultArg)(axis.maxValue, (0, _Seq.max)(data_1)).getTime() : (0, _Util.defaultArg)(axis.maxValue, (0, _Seq.max)(data_1))];
      };
    };

    var patternInput = range(chartOptions.xAxis)((0, _Seq.map)(function (tuple) {
      return tuple[1];
    }, numData));
    var patternInput_1 = range(chartOptions.yAxis)((0, _Seq.map)(function (tuple_1) {
      return tuple_1[0];
    }, numData));
    var minData = (0, _Seq.reduce)(function (x, y) {
      return Math.min(x, y);
    }, (0, _Seq.map)(function ($var132) {
      return $var132[0] instanceof Date ? $var132[0].getTime() : $var132[0];
    }, data));
    var maxData = (0, _Seq.reduce)(function (x, y) {
      return Math.max(x, y);
    }, (0, _Seq.map)(function ($var133) {
      return $var133[0] instanceof Date ? $var133[0].getTime() : $var133[0];
    }, data));
    var Interactive = !completed;
    var XData = data.map(function ($var134) {
      return $var134[1];
    });
    var YData = data.map(function ($var135) {
      return $var135[0];
    });
    var Offset = patternInput_1[0] - minData;
    var OffsetRange = [patternInput_1[1] - maxData, patternInput_1[0] - minData];
    return new YouDrawState(completed, Interactive, numData, XData, YData, isDate, null, Offset, OffsetRange, [patternInput[0], patternInput[1]], [patternInput_1[0], patternInput_1[1]], completed, completed ? 1 : 0, completed ? 1 : 0, chartOptions);
  };

  var handler = __exports.handler = function (log, state, evt) {
    var collectData = function collectData() {
      return state.Data.map(function (tupledArg) {
        return [tupledArg[0], tupledArg[1]];
      });
    };

    if (evt.Case === "HideOverlay") {
      var OverlayOpacity = state.OverlayOpacity + 0.1;
      return new YouDrawState(state.Completed, state.Interactive, state.Data, state.XData, state.YData, state.IsKeyDate, state.OffsetStart, state.Offset, state.OffsetRange, state.XRange, state.YRange, state.OverlayHiding, OverlayOpacity, state.CompletionStep, state.ChartOptions);
    } else if (evt.Case === "StartMoving") {
      var OffsetStart = evt.Fields[0] - state.Offset;
      var OverlayHiding = true;
      return new YouDrawState(state.Completed, state.Interactive, state.Data, state.XData, state.YData, state.IsKeyDate, OffsetStart, state.Offset, state.OffsetRange, state.XRange, state.YRange, OverlayHiding, state.OverlayOpacity, state.CompletionStep, state.ChartOptions);
    } else if (evt.Case === "ContinueMoving") {
      if (function () {
        return state.OffsetStart == null;
      }(null)) {
        return state;
      } else {
        var Offset = state.OffsetRange[1] < (state.OffsetRange[0] > evt.Fields[0] - state.OffsetStart ? state.OffsetRange[0] : evt.Fields[0] - state.OffsetStart) ? state.OffsetRange[1] : state.OffsetRange[0] > evt.Fields[0] - state.OffsetStart ? state.OffsetRange[0] : evt.Fields[0] - state.OffsetStart;
        return new YouDrawState(state.Completed, state.Interactive, state.Data, state.XData, state.YData, state.IsKeyDate, state.OffsetStart, Offset, state.OffsetRange, state.XRange, state.YRange, state.OverlayHiding, state.OverlayOpacity, state.CompletionStep, state.ChartOptions);
      }
    } else if (evt.Case === "ShowResults") {
      log("completed")((0, _List.ofArray)([["offset", state.Offset], ["values", collectData(null)]]));
      return new YouDrawState(true, state.Interactive, state.Data, state.XData, state.YData, state.IsKeyDate, state.OffsetStart, state.Offset, state.OffsetRange, state.XRange, state.YRange, state.OverlayHiding, state.OverlayOpacity, state.CompletionStep, state.ChartOptions);
    } else if (evt.Case === "Animate") {
      var CompletionStep = 1 < state.CompletionStep + 0.05 ? 1 : state.CompletionStep + 0.05;
      return new YouDrawState(state.Completed, state.Interactive, state.Data, state.XData, state.YData, state.IsKeyDate, state.OffsetStart, state.Offset, state.OffsetRange, state.XRange, state.YRange, state.OverlayHiding, state.OverlayOpacity, CompletionStep, state.ChartOptions);
    } else {
      var OffsetStart_1 = null;
      return new YouDrawState(state.Completed, state.Interactive, state.Data, state.XData, state.YData, state.IsKeyDate, OffsetStart_1, state.Offset, state.OffsetRange, state.XRange, state.YRange, state.OverlayHiding, state.OverlayOpacity, state.CompletionStep, state.ChartOptions);
    }
  };

  var render = __exports.render = function (solvedComment, interactive, width, height, labels, markers, guessClr, correctClr, markerClr, trigger, state) {
    if (state.Completed ? state.CompletionStep < 1 : false) {
      window.setTimeout(function () {
        trigger(new YouDrawEvent("Animate", []));
      }, 50);
    }

    if (state.OverlayHiding ? state.OverlayOpacity < 1 : false) {
      window.setTimeout(function () {
        trigger(new YouDrawEvent("HideOverlay", []));
      }, 50);
    }

    var patternInput = [state.XRange, state.YRange];
    var ly = patternInput[1][0];
    var lx = patternInput[0][0];
    var hy = patternInput[1][1];
    var hx = patternInput[0][1];

    var visiblePoints = function visiblePoints(offset) {
      var lo = (state.ChartOptions.yAxis.minValue instanceof Date ? state.ChartOptions.yAxis.minValue.getTime() : state.ChartOptions.yAxis.minValue) - offset;
      var hi = (state.ChartOptions.yAxis.maxValue instanceof Date ? state.ChartOptions.yAxis.maxValue.getTime() : state.ChartOptions.yAxis.maxValue) - offset;
      return function () {
        var $var137 = hi;
        var $var136 = lo;
        var inRange = Internal.prevAndNext(state.Data).filter(function (tupledArg_1) {
          return tupledArg_1[1][0] > $var136 ? tupledArg_1[1][0] < $var137 : false;
        });

        if (inRange.length === 0) {
          return [];
        } else {
          var patternInput_1 = [inRange[0], inRange[inRange.length - 1]];
          var s2 = patternInput_1[0][1];
          var s1 = patternInput_1[0][0];
          var e2 = patternInput_1[1][2];
          var e1 = patternInput_1[1][1];
          var core = inRange.map(function (tupledArg_2) {
            return tupledArg_2[1];
          });
          return (0, _from2.default)((0, _Seq.concat)((0, _List.ofArray)([function () {
            var $var141 = $var136;
            var $var140 = s2[0];
            var $var139 = s1[1];
            var $var138 = s1[0];

            if ((0, _Util.equals)($var138, $var140)) {
              return [];
            } else {
              return [[$var141, $var139 + (s2[1] - $var139) * ($var141 - $var138) / ($var140 - $var138)]];
            }
          }(), core, function () {
            var $var145 = $var137;
            var $var144 = e2[0];
            var $var143 = e1[1];
            var $var142 = e1[0];

            if ((0, _Util.equals)($var142, $var144)) {
              return [];
            } else {
              return [[$var145, $var143 + (e2[1] - $var143) * ($var145 - $var142) / ($var144 - $var142)]];
            }
          }()])));
        }
      }().map(function (tupledArg) {
        return [new _compost.Value("COV", [new _compost.continuous("CO", [tupledArg[1]])]), new _compost.Value("COV", [new _compost.continuous("CO", [tupledArg[0] + offset])])];
      });
    };

    var coreChart = Internal.applyStyle(function (s) {
      var cursor = state.Completed ? "" : "move,grab,-moz-grab,-webkit-grab";
      return new _compost.Style(s.StrokeColor, s.StrokeWidth, s.StrokeDashArray, s.Fill, s.Animation, s.Font, cursor, s.FormatAxisXLabel, s.FormatAxisYLabel);
    }, new _compost.Shape("Layered", [(0, _Seq.toList)((0, _Seq.delay)(function () {
      return (0, _Seq.append)((0, _Seq.collect)(function (matchValue) {
        var y = matchValue[0][0];
        var str = matchValue[0][1];

        var patternInput_3 = function (points) {
          var $var146 = y;
          var patternInput_2 = (0, _Seq.find)(function (tupledArg_3) {
            return tupledArg_3[0][0] <= $var146 ? tupledArg_3[1][0] >= $var146 : false;
          }, (0, _Seq.pairwise)(points));
          return (0, _Seq.head)(function () {
            var $var150 = $var146;
            var $var149 = patternInput_2[1][0];
            var $var148 = patternInput_2[0][1];
            var $var147 = patternInput_2[0][0];

            if ((0, _Util.equals)($var147, $var149)) {
              return [];
            } else {
              return [[$var150, $var148 + (patternInput_2[1][1] - $var148) * ($var150 - $var147) / ($var149 - $var147)]];
            }
          }());
        }((0, _Seq.map)(function (tupledArg_4) {
          return [tupledArg_4[0] + state.Offset * (1 - state.CompletionStep), tupledArg_4[1]];
        }, state.Data));

        var b = new _compost.Shape("Bubble", [new _compost.Value("COV", [new _compost.continuous("CO", [hx])]), new _compost.Value("COV", [new _compost.continuous("CO", [y])]), 4, 4]);
        var t = new _compost.Shape("Offset", [[0, 5], new _compost.Shape("Text", [new _compost.Value("COV", [new _compost.continuous("CO", [hx])]), new _compost.Value("COV", [new _compost.continuous("CO", [y])]), new _compost.VerticalAlign("Hanging", []), new _compost.HorizontalAlign("End", []), 0, matchValue[1]])]);
        return (0, _Seq.append)((0, _Seq.singleton)(Internal.applyStyle(function (s_1) {
          var StrokeWidth = new _compost.Width("Pixels", [0]);
          var Fill = new _compost.FillStyle("Solid", [[0.8, new _compost.Color("HTML", [markerClr])]]);
          return new _compost.Style(s_1.StrokeColor, StrokeWidth, s_1.StrokeDashArray, Fill, s_1.Animation, s_1.Font, s_1.Cursor, s_1.FormatAxisXLabel, s_1.FormatAxisYLabel);
        }, t)), (0, _Seq.delay)(function () {
          var l = new _compost.Shape("Line", [(0, _List.ofArray)([[new _compost.Value("COV", [new _compost.continuous("CO", [patternInput_3[1]])]), new _compost.Value("COV", [new _compost.continuous("CO", [y])])], [new _compost.Value("COV", [new _compost.continuous("CO", [hx])]), new _compost.Value("COV", [new _compost.continuous("CO", [y])])]])]);
          return (0, _Seq.singleton)(Internal.applyStyle(function (s_2) {
            var StrokeWidth_1 = new _compost.Width("Pixels", [2]);
            return new _compost.Style([0.8, new _compost.Color("HTML", [markerClr])], StrokeWidth_1, s_2.StrokeDashArray, s_2.Fill, s_2.Animation, s_2.Font, s_2.Cursor, s_2.FormatAxisXLabel, s_2.FormatAxisYLabel);
          }, l));
        }));
      }, (0, _Seq.zip)(markers, labels)), (0, _Seq.delay)(function () {
        return (0, _Seq.append)(!state.Completed ? (0, _Seq.singleton)(new _compost.Shape("Style", [function (s_3) {
          var Fill_1 = new _compost.FillStyle("Solid", [[0.5, new _compost.Color("HTML", [guessClr])]]);
          return new _compost.Style(s_3.StrokeColor, s_3.StrokeWidth, s_3.StrokeDashArray, Fill_1, s_3.Animation, s_3.Font, s_3.Cursor, s_3.FormatAxisXLabel, s_3.FormatAxisYLabel);
        }, _compost.Derived.VShiftedArea(lx, visiblePoints(state.Offset))])) : (0, _Seq.empty)(), (0, _Seq.delay)(function () {
          return (0, _Seq.append)(state.Interactive ? (0, _Seq.singleton)(new _compost.Shape("Style", [function (s_4) {
            var StrokeColor = [1, new _compost.Color("HTML", [guessClr])];
            var StrokeDashArray = (0, _List.ofArray)([new _compost.Number("Integer", [5]), new _compost.Number("Integer", [5])]);
            return new _compost.Style(StrokeColor, s_4.StrokeWidth, StrokeDashArray, s_4.Fill, s_4.Animation, s_4.Font, s_4.Cursor, s_4.FormatAxisXLabel, s_4.FormatAxisYLabel);
          }, new _compost.Shape("Line", [visiblePoints(state.Offset)])])) : (0, _Seq.empty)(), (0, _Seq.delay)(function () {
            return (0, _Seq.append)(state.Completed ? function () {
              var patternInput_4 = Internal.parseColor(guessClr);
              var patternInput_5 = Internal.parseColor(correctClr);

              var dc = function dc(c1) {
                return function (c2) {
                  return (1 - state.CompletionStep) * c1 + state.CompletionStep * c2;
                };
              };

              var clr = Internal.formatColor(dc(patternInput_4[0])(patternInput_5[0]), dc(patternInput_4[1])(patternInput_5[1]), dc(patternInput_4[2])(patternInput_5[2]));
              var correct = visiblePoints(state.Offset * (1 - state.CompletionStep));
              return (0, _Seq.append)((0, _Seq.singleton)(new _compost.Shape("Style", [function (s_5) {
                var Fill_2 = new _compost.FillStyle("Solid", [[0.5, new _compost.Color("HTML", [clr])]]);
                return new _compost.Style(s_5.StrokeColor, s_5.StrokeWidth, s_5.StrokeDashArray, Fill_2, s_5.Animation, s_5.Font, s_5.Cursor, s_5.FormatAxisXLabel, s_5.FormatAxisYLabel);
              }, _compost.Derived.VShiftedArea(lx, correct)])), (0, _Seq.delay)(function () {
                return (0, _Seq.singleton)(new _compost.Shape("Style", [function (s_6) {
                  return new _compost.Style([1, new _compost.Color("HTML", [clr])], s_6.StrokeWidth, s_6.StrokeDashArray, s_6.Fill, s_6.Animation, s_6.Font, s_6.Cursor, s_6.FormatAxisXLabel, s_6.FormatAxisYLabel);
                }, new _compost.Shape("Layered", [(0, _List.ofArray)([new _compost.Shape("Line", [correct])])])]));
              }));
            }() : (0, _Seq.empty)(), (0, _Seq.delay)(function () {
              return (0, _Seq.singleton)(Internal.applyStyle(function (x) {
                var Fill_3 = new _compost.FillStyle("Solid", [[0.75 * (1 - state.OverlayOpacity), new _compost.Color("HTML", ["#eaeaea"])]]);
                return new _compost.Style(x.StrokeColor, x.StrokeWidth, x.StrokeDashArray, Fill_3, x.Animation, x.Font, x.Cursor, x.FormatAxisXLabel, x.FormatAxisYLabel);
              }, new _compost.Shape("Shape", [(0, _List.ofArray)([[new _compost.Value("COV", [new _compost.continuous("CO", [lx])]), new _compost.Value("COV", [new _compost.continuous("CO", [ly])])], [new _compost.Value("COV", [new _compost.continuous("CO", [lx])]), new _compost.Value("COV", [new _compost.continuous("CO", [hy])])], [new _compost.Value("COV", [new _compost.continuous("CO", [hx])]), new _compost.Value("COV", [new _compost.continuous("CO", [hy])])], [new _compost.Value("COV", [new _compost.continuous("CO", [hx])]), new _compost.Value("COV", [new _compost.continuous("CO", [ly])])]])])));
            }));
          }));
        }));
      }));
    }))]));
    var patternInput_6 = Internal.applyAxes(false, false, true, true, Internal.applyLabels(Internal.applyScales(function () {
      var tupledArg_5 = [width, height];
      return function (chart) {
        return Internal.initChart(tupledArg_5[0], tupledArg_5[1], state.XData, state.YData, state.ChartOptions, chart);
      };
    }()(coreChart))));
    var chart_1 = Internal.applyInteractive(state.Completed ? new _List2.default() : (0, _List.ofArray)([new _compost.EventHandler("MouseUp", [function (_arg2) {
      return function (_arg1) {
        trigger(new YouDrawEvent("StopMoving", []));
      };
    }]), new _compost.EventHandler("TouchEnd", [function (_arg3) {
      trigger(new YouDrawEvent("StopMoving", []));
    }]), new _compost.EventHandler("MouseMove", [function (evt) {
      return function (tupledArg_6) {
        var activePatternResult4177 = CompostHelpers["|Cont|"](tupledArg_6[0]);
        var activePatternResult4176 = CompostHelpers["|Cont|"](tupledArg_6[1]);

        if ((~~evt.buttons & 1) === 1) {
          trigger(new YouDrawEvent("ContinueMoving", [activePatternResult4176]));
        }
      };
    }]), new _compost.EventHandler("TouchMove", [function (evt_1) {
      return function (tupledArg_7) {
        var activePatternResult4181 = CompostHelpers["|Cont|"](tupledArg_7[0]);
        var activePatternResult4180 = CompostHelpers["|Cont|"](tupledArg_7[1]);
        trigger(new YouDrawEvent("ContinueMoving", [activePatternResult4180]));
      };
    }]), new _compost.EventHandler("MouseDown", [function (evt_2) {
      return function (tupledArg_8) {
        var activePatternResult4185 = CompostHelpers["|Cont|"](tupledArg_8[0]);
        var activePatternResult4184 = CompostHelpers["|Cont|"](tupledArg_8[1]);
        trigger(new YouDrawEvent("StartMoving", [activePatternResult4184]));
      };
    }]), new _compost.EventHandler("TouchStart", [function (evt_3) {
      return function (tupledArg_9) {
        var activePatternResult4189 = CompostHelpers["|Cont|"](tupledArg_9[0]);
        var activePatternResult4188 = CompostHelpers["|Cont|"](tupledArg_9[1]);
        trigger(new YouDrawEvent("StartMoving", [activePatternResult4188]));
      };
    }])]), new _compost.Shape("Padding", [[20, 0, 0, 0], patternInput_6.Chart]));
    return function (arg0) {
      return function (arg1) {
        return _html.El.op_Dynamic(arg0, arg1);
      };
    }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", "text-align:center;padding-top:20px")]))((0, _Seq.toList)((0, _Seq.delay)(function () {
      return (0, _Seq.append)((0, _Seq.singleton)(function (arg0_1) {
        return function (arg1_1) {
          return _html.El.op_Dynamic(arg0_1, arg1_1);
        };
      }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", (0, _String.fsFormat)("width:%dpx; height:0px; margin:0px auto 0px auto")(function (x) {
        return x;
      })(~~width))]))((0, _List.ofArray)([function (arg0_2) {
        return function (arg1_2) {
          return _html.El.op_Dynamic(arg0_2, arg1_2);
        };
      }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", "pointer-events:none; move,grab,-moz-grab,-webkit-grab;" + (0, _String.fsFormat)("opacity:%f; width:50px; height:70px; border-radius:15px; background:#808080;")(function (x) {
        return x;
      })(0.5 * (1 - state.OverlayOpacity)) + (0, _String.fsFormat)("position:relative; left:%dpx;top:%dpx")(function (x) {
        return x;
      })(~~(~~(width - 50) / 2) + 45)(~~(~~(height - 70) / 2) - 30))]))((0, _List.ofArray)([function (arg0_3) {
        return function (arg1_3) {
          return _html.El.op_Dynamic(arg0_3, arg1_3);
        };
      }(_html.h)("i")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", "margin:12px 0px 0px 1px;font-size:42px;color:#f0f0f0"), (0, _html.op_EqualsGreater)("class", "fa fa-hand-o-down")]))(new _List2.default())]))]))), (0, _Seq.delay)(function () {
        return (0, _Seq.append)((0, _Seq.singleton)(_compost.Compost.createSvg(false, state.IsKeyDate, width, height, chart_1)), (0, _Seq.delay)(function () {
          return (state.Completed ? function () {
            return solvedComment != null;
          }(null) : false) ? (0, _Seq.singleton)(function (arg0_4) {
            return function (arg1_4) {
              return _html.El.op_Dynamic(arg0_4, arg1_4);
            };
          }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", "padding-bottom:20px")]))((0, _List.ofArray)([function (arg0_5) {
            return function (arg1_5) {
              return _html.El.op_Dynamic(arg0_5, arg1_5);
            };
          }(_html.h)("p")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "solved")]))((0, _List.ofArray)([(0, _html.text)(solvedComment)]))]))) : interactive ? (0, _Seq.singleton)(function (arg0_6) {
            return function (arg1_6) {
              return _html.El.op_Dynamic(arg0_6, arg1_6);
            };
          }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", "padding-bottom:20px")]))((0, _List.ofArray)([function (arg0_7) {
            return function (arg1_7) {
              return _html.El.op_Dynamic(arg0_7, arg1_7);
            };
          }(_html.h)("button")((0, _Seq.toList)((0, _Seq.delay)(function () {
            return (0, _Seq.append)((0, _Seq.singleton)((0, _html.op_EqualsGreater)("type", "button")), (0, _Seq.delay)(function () {
              return (0, _Seq.append)((0, _Seq.singleton)((0, _html.op_EqualsBangGreater)("click", function (_arg13) {
                return function (_arg12) {
                  trigger(new YouDrawEvent("ShowResults", []));
                };
              })), (0, _Seq.delay)(function () {
                return state.OverlayOpacity < 1 ? (0, _Seq.singleton)((0, _html.op_EqualsGreater)("disabled", "disabled")) : (0, _Seq.empty)();
              }));
            }));
          })))((0, _List.ofArray)([(0, _html.text)("Show me how I did")]))]))) : (0, _Seq.empty)();
        }));
      }));
    })));
  };

  return __exports;
}({});

var YouGuessColsHelpers = exports.YouGuessColsHelpers = function (__exports) {
  var YouGuessState = __exports.YouGuessState = function () {
    function YouGuessState(completed, completionStep, _default, maximum, xData, yData, data, guesses) {
      (0, _classCallCheck3.default)(this, YouGuessState);
      this.Completed = completed;
      this.CompletionStep = completionStep;
      this.Default = _default;
      this.Maximum = maximum;
      this.XData = xData;
      this.YData = yData;
      this.Data = data;
      this.Guesses = guesses;
    }

    (0, _createClass3.default)(YouGuessState, [{
      key: _Symbol3.default.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.YouGuessColsHelpers.YouGuessState",
          interfaces: ["FSharpRecord", "System.IEquatable"],
          properties: {
            Completed: "boolean",
            CompletionStep: "number",
            Default: "number",
            Maximum: "number",
            XData: (0, _Util.Array)(_Util.Any),
            YData: (0, _Util.Array)(_Util.Any),
            Data: (0, _Util.Array)((0, _Util.Tuple)(["string", "number"])),
            Guesses: (0, _Util.makeGeneric)(_Map4.default, {
              Key: "string",
              Value: "number"
            })
          }
        };
      }
    }, {
      key: "Equals",
      value: function (other) {
        return (0, _Util.equalsRecords)(this, other);
      }
    }]);
    return YouGuessState;
  }();

  (0, _Symbol2.setType)("TheGamma.Interactive.YouGuessColsHelpers.YouGuessState", YouGuessState);

  var YouGuessEvent = __exports.YouGuessEvent = function () {
    function YouGuessEvent(caseName, fields) {
      (0, _classCallCheck3.default)(this, YouGuessEvent);
      this.Case = caseName;
      this.Fields = fields;
    }

    (0, _createClass3.default)(YouGuessEvent, [{
      key: _Symbol3.default.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.YouGuessColsHelpers.YouGuessEvent",
          interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
          cases: {
            Animate: [],
            ShowResults: [],
            Update: ["string", "number"]
          }
        };
      }
    }, {
      key: "Equals",
      value: function (other) {
        return (0, _Util.equalsUnions)(this, other);
      }
    }, {
      key: "CompareTo",
      value: function (other) {
        return (0, _Util.compareUnions)(this, other);
      }
    }]);
    return YouGuessEvent;
  }();

  (0, _Symbol2.setType)("TheGamma.Interactive.YouGuessColsHelpers.YouGuessEvent", YouGuessEvent);

  var initState = __exports.initState = function (completed, isBar, data, maxValue) {
    var CompletionStep = 0;
    var XData = isBar ? Internal.arrayMap(function ($var151) {
      return $var151[1];
    }, data) : Internal.arrayMap(function ($var152) {
      return $var152[0];
    }, data);
    var YData = isBar ? Internal.arrayMap(function ($var153) {
      return $var153[0];
    }, data) : Internal.arrayMap(function ($var154) {
      return $var154[1];
    }, data);
    return new YouGuessState(completed, CompletionStep, (0, _Seq.averageBy)(function (tuple) {
      return tuple[1];
    }, data), InteractiveHelpers.calclateMax(maxValue, data), XData, YData, data, completed ? (0, _Map3.create)(data, new _GenericComparer2.default(_Util.compare)) : (0, _Map3.create)(null, new _GenericComparer2.default(_Util.compare)));
  };

  var update = __exports.update = function (log, state, evt) {
    var collectData = function collectData() {
      return state.Data.map(function (tupledArg) {
        return [tupledArg[0], tupledArg[1]];
      });
    };

    var collectGuesses = function collectGuesses() {
      return (0, _from2.default)((0, _Seq.map)(function (_arg1) {
        var activePatternResult4256 = _arg1;
        return [activePatternResult4256[0], activePatternResult4256[1]];
      }, state.Guesses));
    };

    if (evt.Case === "Animate") {
      var CompletionStep = 1 < state.CompletionStep + 0.05 ? 1 : state.CompletionStep + 0.05;
      return new YouGuessState(state.Completed, CompletionStep, state.Default, state.Maximum, state.XData, state.YData, state.Data, state.Guesses);
    } else if (evt.Case === "Update") {
      var Guesses = (0, _Map3.add)(evt.Fields[0], evt.Fields[1], state.Guesses);
      return new YouGuessState(state.Completed, state.CompletionStep, state.Default, state.Maximum, state.XData, state.YData, state.Data, Guesses);
    } else {
      log("completed")((0, _List.ofArray)([["guess", collectGuesses(null)], ["values", collectData(null)]]));
      return new YouGuessState(true, state.CompletionStep, state.Default, state.Maximum, state.XData, state.YData, state.Data, state.Guesses);
    }
  };

  var renderCols = __exports.renderCols = function (solvedComment, interactive, width, height, topLabel, trigger, state) {
    if (state.Completed ? state.CompletionStep < 1 : false) {
      window.setTimeout(function () {
        trigger(new YouGuessEvent("Animate", []));
      }, 50);
    }

    var chart = new _compost.Shape("Axes", [false, false, true, true, new _compost.Shape("AutoScale", [false, true, new _compost.Shape("Interactive", [state.Completed ? new _List2.default() : (0, _List.ofArray)([new _compost.EventHandler("MouseMove", [function (evt) {
      return function (tupledArg) {
        var activePatternResult4264 = CompostHelpers["|Cat|"](tupledArg[0]);
        var activePatternResult4263 = CompostHelpers["|Cont|"](tupledArg[1]);

        if ((~~evt.buttons & 1) === 1) {
          trigger(new YouGuessEvent("Update", [activePatternResult4264[0], activePatternResult4263]));
        }
      };
    }]), new _compost.EventHandler("MouseDown", [function (evt_1) {
      return function (tupledArg_1) {
        var activePatternResult4268 = CompostHelpers["|Cat|"](tupledArg_1[0]);
        var activePatternResult4267 = CompostHelpers["|Cont|"](tupledArg_1[1]);
        trigger(new YouGuessEvent("Update", [activePatternResult4268[0], activePatternResult4267]));
      };
    }]), new _compost.EventHandler("TouchStart", [function (evt_2) {
      return function (tupledArg_2) {
        var activePatternResult4272 = CompostHelpers["|Cat|"](tupledArg_2[0]);
        var activePatternResult4271 = CompostHelpers["|Cont|"](tupledArg_2[1]);
        trigger(new YouGuessEvent("Update", [activePatternResult4272[0], activePatternResult4271]));
      };
    }]), new _compost.EventHandler("TouchMove", [function (evt_3) {
      return function (tupledArg_3) {
        var activePatternResult4276 = CompostHelpers["|Cat|"](tupledArg_3[0]);
        var activePatternResult4275 = CompostHelpers["|Cont|"](tupledArg_3[1]);
        trigger(new YouGuessEvent("Update", [activePatternResult4276[0], activePatternResult4275]));
      };
    }])]), new _compost.Shape("Style", [function (s) {
      if (state.Completed) {
        return s;
      } else {
        var Cursor = "row-resize";
        return new _compost.Style(s.StrokeColor, s.StrokeWidth, s.StrokeDashArray, s.Fill, s.Animation, s.Font, Cursor, s.FormatAxisXLabel, s.FormatAxisYLabel);
      }
    }, new _compost.Shape("Layered", [(0, _Seq.toList)((0, _Seq.delay)(function () {
      return (0, _Seq.append)((0, _Seq.singleton)(new _compost.Shape("Stack", [new _compost.Orientation("Horizontal", []), (0, _Seq.toList)((0, _Seq.delay)(function () {
        return (0, _Seq.collect)(function (matchValue) {
          var value = matchValue[1][1];
          var lbl = matchValue[1][0];
          return (0, _Seq.singleton)(function () {
            var sh = new _compost.Shape("Style", [function (s_1) {
              var Fill = new _compost.FillStyle("Solid", [[0.2, new _compost.Color("HTML", ["#a0a0a0"])]]);
              return new _compost.Style(s_1.StrokeColor, s_1.StrokeWidth, s_1.StrokeDashArray, Fill, s_1.Animation, s_1.Font, s_1.Cursor, s_1.FormatAxisXLabel, s_1.FormatAxisYLabel);
            }, _compost.Derived.Column(new _compost.categorical("CA", [lbl]), new _compost.continuous("CO", [state.Maximum]))]);
            return new _compost.Shape("Padding", [[0, 10, 0, 10], sh]);
          }());
        }, (0, _Seq.zip)(CompostHelpers.infinitely(CompostHelpers.vega10), state.Data));
      }))])), (0, _Seq.delay)(function () {
        return (0, _Seq.append)((0, _Seq.singleton)(new _compost.Shape("Stack", [new _compost.Orientation("Horizontal", []), (0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.collect)(function (matchValue_1) {
            var value_1 = matchValue_1[1][1];
            var lbl_1 = matchValue_1[1][0];
            return (0, _Seq.singleton)(function () {
              var patternInput = void 0;
              var matchValue_2 = [state.Completed, (0, _Map3.tryFind)(lbl_1, state.Guesses)];
              var $var155 = matchValue_2[0] ? matchValue_2[1] == null ? [2] : [0] : matchValue_2[1] == null ? [2] : [1];

              switch ($var155[0]) {
                case 0:
                  var guess = matchValue_2[1];
                  patternInput = [0.6, state.CompletionStep * value_1 + (1 - state.CompletionStep) * guess];
                  break;

                case 1:
                  var v = matchValue_2[1];
                  patternInput = [0.6, v];
                  break;

                case 2:
                  patternInput = [0.2, state.Default];
                  break;
              }

              var sh_1 = new _compost.Shape("Style", [function (s_2) {
                var Fill_1 = new _compost.FillStyle("Solid", [[patternInput[0], new _compost.Color("HTML", [matchValue_1[0]])]]);
                return new _compost.Style(s_2.StrokeColor, s_2.StrokeWidth, s_2.StrokeDashArray, Fill_1, s_2.Animation, s_2.Font, s_2.Cursor, s_2.FormatAxisXLabel, s_2.FormatAxisYLabel);
              }, _compost.Derived.Column(new _compost.categorical("CA", [lbl_1]), new _compost.continuous("CO", [patternInput[1]]))]);
              return new _compost.Shape("Padding", [[0, 10, 0, 10], sh_1]);
            }());
          }, (0, _Seq.zip)(CompostHelpers.infinitely(CompostHelpers.vega10), state.Data));
        }))])), (0, _Seq.delay)(function () {
          return (0, _Seq.append)((0, _Seq.collect)(function (matchValue_3) {
            var value_2 = matchValue_3[1][1];
            var lbl_2 = matchValue_3[1][0];
            var matchValue_4 = (0, _Map3.tryFind)(lbl_2, state.Guesses);

            if (matchValue_4 != null) {
              var line = new _compost.Shape("Line", [(0, _List.ofArray)([[new _compost.Value("CAR", [new _compost.categorical("CA", [lbl_2]), 0]), new _compost.Value("COV", [new _compost.continuous("CO", [matchValue_4])])], [new _compost.Value("CAR", [new _compost.categorical("CA", [lbl_2]), 1]), new _compost.Value("COV", [new _compost.continuous("CO", [matchValue_4])])]])]);
              return (0, _Seq.singleton)(new _compost.Shape("Style", [function (s_3) {
                return new _compost.Style([1, new _compost.Color("HTML", [matchValue_3[0]])], new _compost.Width("Pixels", [4]), (0, _List.ofArray)([new _compost.Number("Integer", [5]), new _compost.Number("Integer", [5])]), s_3.Fill, s_3.Animation, s_3.Font, s_3.Cursor, s_3.FormatAxisXLabel, s_3.FormatAxisYLabel);
              }, new _compost.Shape("Padding", [[0, 10, 0, 10], line])]));
            } else {
              return (0, _Seq.empty)();
            }
          }, (0, _Seq.zip)(CompostHelpers.infinitely(CompostHelpers.vega10), state.Data)), (0, _Seq.delay)(function () {
            if (topLabel != null) {
              var x = new _compost.Value("CAR", [new _compost.categorical("CA", [state.Data[~~(state.Data.length / 2)][0]]), state.Data.length % 2 === 0 ? 0 : 0.5]);
              var y = new _compost.Value("COV", [new _compost.continuous("CO", [state.Maximum * 0.9])]);
              return (0, _Seq.singleton)(new _compost.Shape("Style", [function (s_4) {
                var Font = "13pt Roboto,sans-serif";
                var Fill_2 = new _compost.FillStyle("Solid", [[1, new _compost.Color("HTML", ["#808080"])]]);
                return new _compost.Style([0, new _compost.Color("RGB", [0, 0, 0])], s_4.StrokeWidth, s_4.StrokeDashArray, Fill_2, s_4.Animation, Font, s_4.Cursor, s_4.FormatAxisXLabel, s_4.FormatAxisYLabel);
              }, new _compost.Shape("Text", [x, y, new _compost.VerticalAlign("Baseline", []), new _compost.HorizontalAlign("Center", []), 0, topLabel])]));
            } else {
              return (0, _Seq.empty)();
            }
          }));
        }));
      }));
    }))])])])])]);
    return function (arg0) {
      return function (arg1) {
        return _html.El.op_Dynamic(arg0, arg1);
      };
    }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", "text-align:center;padding-top:20px")]))((0, _Seq.toList)((0, _Seq.delay)(function () {
      return (0, _Seq.append)((0, _Seq.singleton)(_compost.Compost.createSvg(false, false, width, height, chart)), (0, _Seq.delay)(function () {
        return (state.Completed ? function () {
          return solvedComment != null;
        }(null) : false) ? (0, _Seq.singleton)(function (arg0_1) {
          return function (arg1_1) {
            return _html.El.op_Dynamic(arg0_1, arg1_1);
          };
        }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", "padding-bottom:20px")]))((0, _List.ofArray)([function (arg0_2) {
          return function (arg1_2) {
            return _html.El.op_Dynamic(arg0_2, arg1_2);
          };
        }(_html.h)("p")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "solved")]))((0, _List.ofArray)([(0, _html.text)(solvedComment)]))]))) : interactive ? (0, _Seq.singleton)(function (arg0_3) {
          return function (arg1_3) {
            return _html.El.op_Dynamic(arg0_3, arg1_3);
          };
        }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", "padding-bottom:20px")]))((0, _List.ofArray)([function (arg0_4) {
          return function (arg1_4) {
            return _html.El.op_Dynamic(arg0_4, arg1_4);
          };
        }(_html.h)("button")((0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.append)((0, _Seq.singleton)((0, _html.op_EqualsGreater)("type", "button")), (0, _Seq.delay)(function () {
            return (0, _Seq.append)((0, _Seq.singleton)((0, _html.op_EqualsBangGreater)("click", function (_arg10) {
              return function (_arg9) {
                trigger(new YouGuessEvent("ShowResults", []));
              };
            })), (0, _Seq.delay)(function () {
              return state.Guesses.size !== state.Data.length ? (0, _Seq.singleton)((0, _html.op_EqualsGreater)("disabled", "disabled")) : (0, _Seq.empty)();
            }));
          }));
        })))((0, _List.ofArray)([(0, _html.text)("Show me how I did")]))]))) : (0, _Seq.empty)();
      }));
    })));
  };

  var renderBars = __exports.renderBars = function (solvedComment, interactive, inlineLabels, size_0, size_1, chartOptions, trigger, state) {
    var size = [size_0, size_1];

    if (state.Completed ? state.CompletionStep < 1 : false) {
      window.setTimeout(function () {
        trigger(new YouGuessEvent("Animate", []));
      }, 50);
    }

    var chartOptions_1 = void 0;

    if (inlineLabels ? function () {
      return chartOptions.yAxis.labelOffset == null;
    }(null) : false) {
      var yAxis = void 0;
      var labelOffset = 10;
      yAxis = new AxisOptions(chartOptions.yAxis.minValue, chartOptions.yAxis.maxValue, chartOptions.yAxis.label, labelOffset, chartOptions.yAxis.labelMinimalSize);
      chartOptions_1 = new ChartOptions(chartOptions.size, chartOptions.xAxis, yAxis, chartOptions.title, chartOptions.legend, chartOptions.emptyMessage);
    } else {
      chartOptions_1 = chartOptions;
    }

    var chart = Internal.applyStyle(function (s) {
      if (state.Completed) {
        return s;
      } else {
        var Cursor = "col-resize";
        return new _compost.Style(s.StrokeColor, s.StrokeWidth, s.StrokeDashArray, s.Fill, s.Animation, s.Font, Cursor, s.FormatAxisXLabel, s.FormatAxisYLabel);
      }
    }, Internal.applyInteractive(state.Completed ? new _List2.default() : (0, _List.ofArray)([new _compost.EventHandler("MouseMove", [function (evt) {
      return function (tupledArg) {
        var activePatternResult4333 = CompostHelpers["|Cont|"](tupledArg[0]);
        var activePatternResult4332 = CompostHelpers["|Cat|"](tupledArg[1]);

        if ((~~evt.buttons & 1) === 1) {
          trigger(new YouGuessEvent("Update", [activePatternResult4332[0], activePatternResult4333]));
        }
      };
    }]), new _compost.EventHandler("MouseDown", [function (evt_1) {
      return function (tupledArg_1) {
        var activePatternResult4337 = CompostHelpers["|Cont|"](tupledArg_1[0]);
        var activePatternResult4336 = CompostHelpers["|Cat|"](tupledArg_1[1]);
        trigger(new YouGuessEvent("Update", [activePatternResult4336[0], activePatternResult4337]));
      };
    }]), new _compost.EventHandler("TouchStart", [function (evt_2) {
      return function (tupledArg_2) {
        var activePatternResult4341 = CompostHelpers["|Cont|"](tupledArg_2[0]);
        var activePatternResult4340 = CompostHelpers["|Cat|"](tupledArg_2[1]);
        trigger(new YouGuessEvent("Update", [activePatternResult4340[0], activePatternResult4341]));
      };
    }]), new _compost.EventHandler("TouchMove", [function (evt_3) {
      return function (tupledArg_3) {
        var activePatternResult4345 = CompostHelpers["|Cont|"](tupledArg_3[0]);
        var activePatternResult4344 = CompostHelpers["|Cat|"](tupledArg_3[1]);
        trigger(new YouGuessEvent("Update", [activePatternResult4344[0], activePatternResult4345]));
      };
    }])]), new _compost.Shape("Layered", [(0, _Seq.toList)((0, _Seq.delay)(function () {
      return (0, _Seq.append)((0, _Seq.singleton)(new _compost.Shape("Stack", [new _compost.Orientation("Vertical", []), (0, _Seq.toList)((0, _Seq.delay)(function () {
        return (0, _Seq.collect)(function (matchValue) {
          var value = matchValue[1][1];
          var lbl = matchValue[1][0];
          return (0, _Seq.singleton)(function () {
            var sh = new _compost.Shape("Style", [function (s_1) {
              var Fill = new _compost.FillStyle("Solid", [[0.2, new _compost.Color("HTML", ["#a0a0a0"])]]);
              return new _compost.Style(s_1.StrokeColor, s_1.StrokeWidth, s_1.StrokeDashArray, Fill, s_1.Animation, s_1.Font, s_1.Cursor, s_1.FormatAxisXLabel, s_1.FormatAxisYLabel);
            }, _compost.Derived.Bar(new _compost.continuous("CO", [state.Maximum]), new _compost.categorical("CA", [lbl]))]);
            return new _compost.Shape("Padding", [[10, 0, 10, 0], sh]);
          }());
        }, (0, _Seq.zip)(CompostHelpers.infinitely(CompostHelpers.vega10), state.Data));
      }))])), (0, _Seq.delay)(function () {
        return (0, _Seq.append)((0, _Seq.singleton)(new _compost.Shape("Stack", [new _compost.Orientation("Vertical", []), (0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.collect)(function (matchValue_1) {
            var value_1 = matchValue_1[1][1];
            var lbl_1 = matchValue_1[1][0];
            return (0, _Seq.singleton)(function () {
              var patternInput = void 0;
              var matchValue_2 = [state.Completed, (0, _Map3.tryFind)(lbl_1, state.Guesses)];
              var $var156 = matchValue_2[0] ? matchValue_2[1] == null ? [2] : [0] : matchValue_2[1] == null ? [2] : [1];

              switch ($var156[0]) {
                case 0:
                  var guess = matchValue_2[1];
                  patternInput = [0.6, state.CompletionStep * value_1 + (1 - state.CompletionStep) * guess];
                  break;

                case 1:
                  var v = matchValue_2[1];
                  patternInput = [0.6, v];
                  break;

                case 2:
                  patternInput = [0.2, state.Default];
                  break;
              }

              var sh_1 = new _compost.Shape("Style", [function (s_2) {
                var Fill_1 = new _compost.FillStyle("Solid", [[patternInput[0], new _compost.Color("HTML", [matchValue_1[0]])]]);
                return new _compost.Style(s_2.StrokeColor, s_2.StrokeWidth, s_2.StrokeDashArray, Fill_1, s_2.Animation, s_2.Font, s_2.Cursor, s_2.FormatAxisXLabel, s_2.FormatAxisYLabel);
              }, _compost.Derived.Bar(new _compost.continuous("CO", [patternInput[1]]), new _compost.categorical("CA", [lbl_1]))]);
              return new _compost.Shape("Padding", [[10, 0, 10, 0], sh_1]);
            }());
          }, (0, _Seq.zip)(CompostHelpers.infinitely(CompostHelpers.vega10), state.Data));
        }))])), (0, _Seq.delay)(function () {
          return (0, _Seq.append)(inlineLabels ? (0, _Seq.collect)(function (matchValue_3) {
            var lbl_2 = matchValue_3[1][0];
            var x = new _compost.Value("COV", [new _compost.continuous("CO", [state.Maximum * 0.95])]);
            var y = new _compost.Value("CAR", [new _compost.categorical("CA", [lbl_2]), 0.5]);
            return (0, _Seq.singleton)(new _compost.Shape("Style", [function (s_3) {
              var Font = "13pt Roboto,sans-serif";
              var Fill_2 = new _compost.FillStyle("Solid", [[1, new _compost.Color("HTML", [matchValue_3[0]])]]);
              return new _compost.Style([0, new _compost.Color("RGB", [0, 0, 0])], s_3.StrokeWidth, s_3.StrokeDashArray, Fill_2, s_3.Animation, Font, s_3.Cursor, s_3.FormatAxisXLabel, s_3.FormatAxisYLabel);
            }, new _compost.Shape("Text", [x, y, new _compost.VerticalAlign("Middle", []), new _compost.HorizontalAlign("End", []), 0, lbl_2])]));
          }, (0, _Seq.zip)(CompostHelpers.infinitely(CompostHelpers.vega10), state.Data)) : (0, _Seq.empty)(), (0, _Seq.delay)(function () {
            return (0, _Seq.collect)(function (matchValue_4) {
              var value_2 = matchValue_4[1][1];
              var lbl_3 = matchValue_4[1][0];
              var matchValue_5 = (0, _Map3.tryFind)(lbl_3, state.Guesses);

              if (matchValue_5 != null) {
                var line = new _compost.Shape("Line", [(0, _List.ofArray)([[new _compost.Value("COV", [new _compost.continuous("CO", [matchValue_5])]), new _compost.Value("CAR", [new _compost.categorical("CA", [lbl_3]), 0])], [new _compost.Value("COV", [new _compost.continuous("CO", [matchValue_5])]), new _compost.Value("CAR", [new _compost.categorical("CA", [lbl_3]), 1])]])]);
                return (0, _Seq.singleton)(new _compost.Shape("Style", [function (s_4) {
                  return new _compost.Style([1, new _compost.Color("HTML", [matchValue_4[0]])], new _compost.Width("Pixels", [4]), (0, _List.ofArray)([new _compost.Number("Integer", [5]), new _compost.Number("Integer", [5])]), s_4.Fill, s_4.Animation, s_4.Font, s_4.Cursor, s_4.FormatAxisXLabel, s_4.FormatAxisYLabel);
                }, new _compost.Shape("Padding", [[10, 0, 10, 0], line])]));
              } else {
                return (0, _Seq.empty)();
              }
            }, (0, _Seq.zip)(CompostHelpers.infinitely(CompostHelpers.vega10), state.Data));
          }));
        }));
      }));
    }))])));

    var ctx_1 = function () {
      var labels = (0, _Seq.zip)(CompostHelpers.infinitely(CompostHelpers.vega10), (0, _Seq.map)(function (tuple) {
        return tuple[0];
      }, state.Data));
      return function (ctx) {
        return Internal.applyLegend(size[0], size[1], labels, ctx);
      };
    }()(Internal.applyAxes(false, false, true, !inlineLabels, Internal.applyLabels(Internal.applyScales(function (chart_1) {
      return Internal.initChart(size[0], size[1], state.XData, state.YData, chartOptions_1, chart_1);
    }(chart)))));

    return function (arg0) {
      return function (arg1) {
        return _html.El.op_Dynamic(arg0, arg1);
      };
    }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", "text-align:center;padding-top:20px")]))((0, _Seq.toList)((0, _Seq.delay)(function () {
      return (0, _Seq.append)((0, _Seq.singleton)(function () {
        var revX = false;
        var revY = false;
        return _compost.Compost.createSvg(revX, revY, size[0], size[1], ctx_1.Chart);
      }()), (0, _Seq.delay)(function () {
        return (state.Completed ? function () {
          return solvedComment != null;
        }(null) : false) ? (0, _Seq.singleton)(function (arg0_1) {
          return function (arg1_1) {
            return _html.El.op_Dynamic(arg0_1, arg1_1);
          };
        }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", "padding-bottom:20px")]))((0, _List.ofArray)([function (arg0_2) {
          return function (arg1_2) {
            return _html.El.op_Dynamic(arg0_2, arg1_2);
          };
        }(_html.h)("p")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "solved")]))((0, _List.ofArray)([(0, _html.text)(solvedComment)]))]))) : interactive ? (0, _Seq.singleton)(function (arg0_3) {
          return function (arg1_3) {
            return _html.El.op_Dynamic(arg0_3, arg1_3);
          };
        }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", "padding-bottom:20px")]))((0, _List.ofArray)([function (arg0_4) {
          return function (arg1_4) {
            return _html.El.op_Dynamic(arg0_4, arg1_4);
          };
        }(_html.h)("button")((0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.append)((0, _Seq.singleton)((0, _html.op_EqualsGreater)("type", "button")), (0, _Seq.delay)(function () {
            return (0, _Seq.append)((0, _Seq.singleton)((0, _html.op_EqualsBangGreater)("click", function (_arg10) {
              return function (_arg9) {
                trigger(new YouGuessEvent("ShowResults", []));
              };
            })), (0, _Seq.delay)(function () {
              return state.Guesses.size !== state.Data.length ? (0, _Seq.singleton)((0, _html.op_EqualsGreater)("disabled", "disabled")) : (0, _Seq.empty)();
            }));
          }));
        })))((0, _List.ofArray)([(0, _html.text)("Show me how I did")]))]))) : (0, _Seq.empty)();
      }));
    })));
  };

  return __exports;
}({});

var YouGuessSortHelpers = exports.YouGuessSortHelpers = function (__exports) {
  var YouGuessState = __exports.YouGuessState = function () {
    function YouGuessState(data, colors, assignments, selected, maximum, completionStep, completed) {
      (0, _classCallCheck3.default)(this, YouGuessState);
      this.Data = data;
      this.Colors = colors;
      this.Assignments = assignments;
      this.Selected = selected;
      this.Maximum = maximum;
      this.CompletionStep = completionStep;
      this.Completed = completed;
    }

    (0, _createClass3.default)(YouGuessState, [{
      key: _Symbol3.default.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.YouGuessSortHelpers.YouGuessState",
          interfaces: ["FSharpRecord", "System.IEquatable"],
          properties: {
            Data: (0, _Util.Array)((0, _Util.Tuple)(["string", "number"])),
            Colors: (0, _Util.Interface)("System.Collections.Generic.IDictionary"),
            Assignments: (0, _Util.makeGeneric)(_Map4.default, {
              Key: "string",
              Value: "string"
            }),
            Selected: "string",
            Maximum: "number",
            CompletionStep: "number",
            Completed: "boolean"
          }
        };
      }
    }, {
      key: "Equals",
      value: function (other) {
        return (0, _Util.equalsRecords)(this, other);
      }
    }]);
    return YouGuessState;
  }();

  (0, _Symbol2.setType)("TheGamma.Interactive.YouGuessSortHelpers.YouGuessState", YouGuessState);

  var YouGuessEvent = __exports.YouGuessEvent = function () {
    function YouGuessEvent(caseName, fields) {
      (0, _classCallCheck3.default)(this, YouGuessEvent);
      this.Case = caseName;
      this.Fields = fields;
    }

    (0, _createClass3.default)(YouGuessEvent, [{
      key: _Symbol3.default.reflection,
      value: function () {
        return {
          type: "TheGamma.Interactive.YouGuessSortHelpers.YouGuessEvent",
          interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
          cases: {
            Animate: [],
            AssignCurrent: ["string"],
            SelectItem: ["string"],
            ShowResults: []
          }
        };
      }
    }, {
      key: "Equals",
      value: function (other) {
        return (0, _Util.equalsUnions)(this, other);
      }
    }, {
      key: "CompareTo",
      value: function (other) {
        return (0, _Util.compareUnions)(this, other);
      }
    }]);
    return YouGuessEvent;
  }();

  (0, _Symbol2.setType)("TheGamma.Interactive.YouGuessSortHelpers.YouGuessEvent", YouGuessEvent);

  var initState = __exports.initState = function (completed, maxValue, data) {
    var CompletionStep = 0;
    var Colors = new _map2.default((0, _Seq.map2)(function (tupledArg, clr) {
      return [tupledArg[0], clr];
    }, data, CompostHelpers.vega10));
    var Selected = (0, _Seq.head)(data)[0];
    var Maximum = InteractiveHelpers.calclateMax(maxValue, data);
    return new YouGuessState(data, Colors, completed ? (0, _Map3.create)((0, _Seq.toList)((0, _Seq.delay)(function () {
      return (0, _Seq.collect)(function (matchValue) {
        return (0, _Seq.singleton)([matchValue[0], matchValue[0]]);
      }, data);
    })), new _GenericComparer2.default(_Util.compare)) : (0, _Map3.create)(null, new _GenericComparer2.default(_Util.compare)), Selected, Maximum, CompletionStep, completed);
  };

  var update = __exports.update = function (log, state, evt) {
    var collectData = function collectData() {
      return state.Data.map(function (tupledArg) {
        return [tupledArg[0], tupledArg[1]];
      });
    };

    var collectGuesses = function collectGuesses() {
      return (0, _from2.default)((0, _Seq.map)(function (_arg1) {
        var activePatternResult4409 = _arg1;
        var v = (0, _Seq.pick)(function (tupledArg_1) {
          return tupledArg_1[0] === activePatternResult4409[0] ? tupledArg_1[1] : null;
        }, state.Data);
        return [activePatternResult4409[1], v];
      }, state.Assignments));
    };

    if (evt.Case === "ShowResults") {
      log("completed")((0, _List.ofArray)([["values", collectData(null)], ["guess", collectGuesses(null)]]));
      var Completed = true;
      return new YouGuessState(state.Data, state.Colors, state.Assignments, state.Selected, state.Maximum, state.CompletionStep, Completed);
    } else if (evt.Case === "SelectItem") {
      log("select")((0, _List.ofArray)([["selection", evt.Fields[0]]]));
      return new YouGuessState(state.Data, state.Colors, state.Assignments, evt.Fields[0], state.Maximum, state.CompletionStep, state.Completed);
    } else if (evt.Case === "AssignCurrent") {
      var newAssigns = function (table) {
        return (0, _Map3.add)(evt.Fields[0], state.Selected, table);
      }((0, _Map3.filter)(function (_arg2, v_1) {
        return v_1 !== state.Selected;
      }, state.Assignments));

      var assigned = (0, _Set.create)((0, _Seq.map)(function (kvp) {
        return kvp[1];
      }, newAssigns), new _GenericComparer2.default(_Util.compare));
      var newSelected = (0, _Seq.tryHead)((0, _Seq.filter)(function ($var157) {
        return function (value) {
          return !value;
        }(function (arg00) {
          return assigned.has(arg00);
        }($var157));
      }, (0, _Seq.map)(function (tuple) {
        return tuple[0];
      }, state.Data)));
      var Selected = newSelected != null ? newSelected : state.Selected;
      return new YouGuessState(state.Data, state.Colors, newAssigns, Selected, state.Maximum, state.CompletionStep, state.Completed);
    } else {
      var CompletionStep = 1 < state.CompletionStep + 0.05 ? 1 : state.CompletionStep + 0.05;
      return new YouGuessState(state.Data, state.Colors, state.Assignments, state.Selected, state.Maximum, CompletionStep, state.Completed);
    }
  };

  var renderBars = __exports.renderBars = function (solvedComment, interactive, width, height, trigger, state) {
    if (state.Completed ? state.CompletionStep < 1 : false) {
      window.setTimeout(function () {
        trigger(new YouGuessEvent("Animate", []));
      }, 50);
    }

    var chart = new _compost.Shape("Axes", [false, false, true, false, new _compost.Shape("AutoScale", [true, false, new _compost.Shape("Interactive", [state.Completed ? new _List2.default() : (0, _List.ofArray)([new _compost.EventHandler("MouseDown", [function (evt) {
      return function (tupledArg) {
        var activePatternResult4420 = CompostHelpers["|Cat|"](tupledArg[1]);
        trigger(new YouGuessEvent("AssignCurrent", [activePatternResult4420[0]]));
      };
    }]), new _compost.EventHandler("TouchStart", [function (evt_1) {
      return function (tupledArg_1) {
        var activePatternResult4423 = CompostHelpers["|Cat|"](tupledArg_1[1]);
        trigger(new YouGuessEvent("AssignCurrent", [activePatternResult4423[0]]));
      };
    }]), new _compost.EventHandler("TouchMove", [function (evt_2) {
      return function (tupledArg_2) {
        var activePatternResult4426 = CompostHelpers["|Cat|"](tupledArg_2[1]);
        trigger(new YouGuessEvent("AssignCurrent", [activePatternResult4426[0]]));
      };
    }])]), new _compost.Shape("Style", [function (s) {
      if (state.Completed) {
        return s;
      } else {
        var Cursor = "pointer";
        return new _compost.Style(s.StrokeColor, s.StrokeWidth, s.StrokeDashArray, s.Fill, s.Animation, s.Font, Cursor, s.FormatAxisXLabel, s.FormatAxisYLabel);
      }
    }, new _compost.Shape("Layered", [(0, _Seq.toList)((0, _Seq.delay)(function () {
      return (0, _Seq.singleton)(new _compost.Shape("Stack", [new _compost.Orientation("Vertical", []), (0, _Seq.toList)((0, _Seq.delay)(function () {
        return (0, _Seq.collect)(function (matchValue) {
          var original = matchValue[1][1];
          var lbl = matchValue[1][0];
          var patternInput_1 = void 0;
          var matchValue_1 = [state.Completed, (0, _Map3.tryFind)(lbl, state.Assignments)];
          var $var158 = matchValue_1[0] ? matchValue_1[1] == null ? [2] : [0] : matchValue_1[1] == null ? [2] : [1];

          switch ($var158[0]) {
            case 0:
              var assigned = matchValue_1[1];
              var patternInput = (0, _Seq.find)(function (tupledArg_3) {
                return tupledArg_3[0] === assigned;
              }, state.Data);
              patternInput_1 = [0.6, state.CompletionStep * patternInput[1] + (1 - state.CompletionStep) * original, state.Colors.get(assigned)];
              break;

            case 1:
              var assigned_1 = matchValue_1[1];
              patternInput_1 = [0.6, original, state.Colors.get(assigned_1)];
              break;

            case 2:
              patternInput_1 = [0.3, original, "#a0a0a0"];
              break;
          }

          return (0, _Seq.append)((matchValue[0] === state.Data.length - 1 ? state.Assignments.size === 0 : false) ? function () {
            var txt = new _compost.Shape("Text", [new _compost.Value("COV", [new _compost.continuous("CO", [state.Maximum * 0.05])]), new _compost.Value("CAR", [new _compost.categorical("CA", [lbl]), 0.5]), new _compost.VerticalAlign("Middle", []), new _compost.HorizontalAlign("Start", []), 0, "Assign highlighted value to one of the bars by clicking on it!"]);
            return (0, _Seq.singleton)(new _compost.Shape("Style", [function (s_1) {
              var Font = "13pt Roboto,sans-serif";
              var Fill = new _compost.FillStyle("Solid", [[1, new _compost.Color("HTML", ["#606060"])]]);
              return new _compost.Style([0, new _compost.Color("HTML", ["white"])], s_1.StrokeWidth, s_1.StrokeDashArray, Fill, s_1.Animation, Font, s_1.Cursor, s_1.FormatAxisXLabel, s_1.FormatAxisYLabel);
            }, txt]));
          }() : (0, _Seq.empty)(), (0, _Seq.delay)(function () {
            var sh = new _compost.Shape("Style", [function (s_2) {
              var Fill_1 = new _compost.FillStyle("Solid", [[patternInput_1[0], new _compost.Color("HTML", [patternInput_1[2]])]]);
              return new _compost.Style(s_2.StrokeColor, s_2.StrokeWidth, s_2.StrokeDashArray, Fill_1, s_2.Animation, s_2.Font, s_2.Cursor, s_2.FormatAxisXLabel, s_2.FormatAxisYLabel);
            }, _compost.Derived.Bar(new _compost.continuous("CO", [patternInput_1[1]]), new _compost.categorical("CA", [lbl]))]);
            return (0, _Seq.append)(patternInput_1[2] !== "#a0a0a0" ? function () {
              var line = new _compost.Shape("Line", [(0, _List.ofArray)([[new _compost.Value("COV", [new _compost.continuous("CO", [original])]), new _compost.Value("CAR", [new _compost.categorical("CA", [lbl]), 0])], [new _compost.Value("COV", [new _compost.continuous("CO", [original])]), new _compost.Value("CAR", [new _compost.categorical("CA", [lbl]), 1])]])]);
              return (0, _Seq.singleton)(new _compost.Shape("Style", [function (s_3) {
                return new _compost.Style([1, new _compost.Color("HTML", [patternInput_1[2]])], new _compost.Width("Pixels", [4]), (0, _List.ofArray)([new _compost.Number("Integer", [5]), new _compost.Number("Integer", [5])]), s_3.Fill, s_3.Animation, s_3.Font, s_3.Cursor, s_3.FormatAxisXLabel, s_3.FormatAxisYLabel);
              }, new _compost.Shape("Padding", [[5, 0, 5, 0], line])]));
            }() : (0, _Seq.empty)(), (0, _Seq.delay)(function () {
              return (0, _Seq.singleton)(new _compost.Shape("Padding", [[5, 0, 5, 0], sh]));
            }));
          }));
        }, (0, _Seq.mapIndexed)(function (i, v) {
          return [i, v];
        }, (0, _Seq.sortWith)(function (x, y) {
          return (0, _Util.compare)(function (tuple) {
            return tuple[1];
          }(x), function (tuple) {
            return tuple[1];
          }(y));
        }, state.Data)));
      }))]));
    }))])])])])]);
    var labs = new _compost.Shape("Padding", [[0, 20, 20, 25], new _compost.Shape("InnerScale", [[new _compost.continuous("CO", [0]), new _compost.continuous("CO", [100])], null, new _compost.Shape("Interactive", [state.Completed ? new _List2.default() : (0, _List.ofArray)([new _compost.EventHandler("MouseDown", [function (evt_3) {
      return function (tupledArg_4) {
        var activePatternResult4441 = CompostHelpers["|Cat|"](tupledArg_4[1]);
        trigger(new YouGuessEvent("SelectItem", [activePatternResult4441[0]]));
      };
    }]), new _compost.EventHandler("TouchStart", [function (evt_4) {
      return function (tupledArg_5) {
        var activePatternResult4444 = CompostHelpers["|Cat|"](tupledArg_5[1]);
        trigger(new YouGuessEvent("SelectItem", [activePatternResult4444[0]]));
      };
    }]), new _compost.EventHandler("TouchMove", [function (evt_5) {
      return function (tupledArg_6) {
        var activePatternResult4447 = CompostHelpers["|Cat|"](tupledArg_6[1]);
        trigger(new YouGuessEvent("SelectItem", [activePatternResult4447[0]]));
      };
    }])]), new _compost.Shape("Layered", [(0, _Seq.toList)((0, _Seq.delay)(function () {
      return (0, _Seq.collect)(function (matchValue_2) {
        var clr = state.Colors.get(matchValue_2[0]);
        var x = new _compost.Value("COV", [new _compost.continuous("CO", [5])]);
        var y = new _compost.Value("CAR", [new _compost.categorical("CA", [matchValue_2[0]]), 0.5]);
        var patternInput_2 = (state.Completed ? true : matchValue_2[0] === state.Selected) ? [0.9, 1] : [0.2, 0.6];
        return (0, _Seq.append)((0, _Seq.singleton)(new _compost.Shape("Style", [function (s_4) {
          var Fill_2 = new _compost.FillStyle("Solid", [[patternInput_2[0], new _compost.Color("HTML", [clr])]]);
          return new _compost.Style(s_4.StrokeColor, s_4.StrokeWidth, s_4.StrokeDashArray, Fill_2, s_4.Animation, s_4.Font, s_4.Cursor, s_4.FormatAxisXLabel, s_4.FormatAxisYLabel);
        }, new _compost.Shape("Padding", [[2, 0, 2, 0], _compost.Derived.Bar(new _compost.continuous("CO", [4]), new _compost.categorical("CA", [matchValue_2[0]]))])])), (0, _Seq.delay)(function () {
          return (0, _Seq.append)((0, _Seq.singleton)(new _compost.Shape("Style", [function (s_5) {
            var Font_1 = "11pt Roboto,sans-serif";
            var Fill_3 = new _compost.FillStyle("Solid", [[patternInput_2[1], new _compost.Color("HTML", [clr])]]);
            return new _compost.Style([0, new _compost.Color("RGB", [0, 0, 0])], s_5.StrokeWidth, s_5.StrokeDashArray, Fill_3, s_5.Animation, Font_1, s_5.Cursor, s_5.FormatAxisXLabel, s_5.FormatAxisYLabel);
          }, new _compost.Shape("Text", [x, y, new _compost.VerticalAlign("Middle", []), new _compost.HorizontalAlign("Start", []), 0, matchValue_2[0]])])), (0, _Seq.delay)(function () {
            return !state.Completed ? (0, _Seq.singleton)(new _compost.Shape("Style", [function (s_6) {
              var Cursor_1 = "pointer";
              var Fill_4 = new _compost.FillStyle("Solid", [[0, new _compost.Color("HTML", ["white"])]]);
              return new _compost.Style(s_6.StrokeColor, s_6.StrokeWidth, s_6.StrokeDashArray, Fill_4, s_6.Animation, s_6.Font, Cursor_1, s_6.FormatAxisXLabel, s_6.FormatAxisYLabel);
            }, _compost.Derived.Bar(new _compost.continuous("CO", [100]), new _compost.categorical("CA", [matchValue_2[0]]))])) : (0, _Seq.empty)();
          }));
        }));
      }, (0, _Seq.reverse)(state.Data));
    }))])])])]);
    var all = new _compost.Shape("Layered", [(0, _List.ofArray)([new _compost.Shape("OuterScale", [null, new _compost.Scale("Continuous", [new _compost.continuous("CO", [0]), new _compost.continuous("CO", [3])]), labs]), new _compost.Shape("OuterScale", [null, new _compost.Scale("Continuous", [new _compost.continuous("CO", [3]), new _compost.continuous("CO", [10])]), new _compost.Shape("Padding", [[0, 20, 0, 20], chart])])])]);
    return function (arg0) {
      return function (arg1) {
        return _html.El.op_Dynamic(arg0, arg1);
      };
    }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", "text-align:center;padding-top:20px")]))((0, _Seq.toList)((0, _Seq.delay)(function () {
      return (0, _Seq.append)((0, _Seq.singleton)(_compost.Compost.createSvg(false, false, width, height, all)), (0, _Seq.delay)(function () {
        return (state.Completed ? function () {
          return solvedComment != null;
        }(null) : false) ? (0, _Seq.singleton)(function (arg0_1) {
          return function (arg1_1) {
            return _html.El.op_Dynamic(arg0_1, arg1_1);
          };
        }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", "padding-bottom:20px")]))((0, _List.ofArray)([function (arg0_2) {
          return function (arg1_2) {
            return _html.El.op_Dynamic(arg0_2, arg1_2);
          };
        }(_html.h)("p")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("class", "solved")]))((0, _List.ofArray)([(0, _html.text)(solvedComment)]))]))) : interactive ? (0, _Seq.singleton)(function (arg0_3) {
          return function (arg1_3) {
            return _html.El.op_Dynamic(arg0_3, arg1_3);
          };
        }(_html.h)("div")((0, _List.ofArray)([(0, _html.op_EqualsGreater)("style", "padding-bottom:20px")]))((0, _List.ofArray)([function (arg0_4) {
          return function (arg1_4) {
            return _html.El.op_Dynamic(arg0_4, arg1_4);
          };
        }(_html.h)("button")((0, _Seq.toList)((0, _Seq.delay)(function () {
          return (0, _Seq.append)((0, _Seq.singleton)((0, _html.op_EqualsGreater)("type", "button")), (0, _Seq.delay)(function () {
            return (0, _Seq.append)((0, _Seq.singleton)((0, _html.op_EqualsBangGreater)("click", function (_arg15) {
              return function (_arg14) {
                trigger(new YouGuessEvent("ShowResults", []));
              };
            })), (0, _Seq.delay)(function () {
              return state.Assignments.size !== state.Data.length ? (0, _Seq.singleton)((0, _html.op_EqualsGreater)("disabled", "disabled")) : (0, _Seq.empty)();
            }));
          }));
        })))((0, _List.ofArray)([(0, _html.text)("Show me how I did")]))]))) : (0, _Seq.empty)();
      }));
    })));
  };

  return __exports;
}({});

var YouGuessColsBarsKind = exports.YouGuessColsBarsKind = function () {
  function YouGuessColsBarsKind(caseName, fields) {
    (0, _classCallCheck3.default)(this, YouGuessColsBarsKind);
    this.Case = caseName;
    this.Fields = fields;
  }

  (0, _createClass3.default)(YouGuessColsBarsKind, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.YouGuessColsBarsKind",
        interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
        cases: {
          Bars: [],
          Cols: []
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsUnions)(this, other);
    }
  }, {
    key: "CompareTo",
    value: function (other) {
      return (0, _Util.compareUnions)(this, other);
    }
  }]);
  return YouGuessColsBarsKind;
}();

(0, _Symbol2.setType)("TheGamma.Interactive.YouGuessColsBarsKind", YouGuessColsBarsKind);

var YouGuessColsBars = exports.YouGuessColsBars = function () {
  function YouGuessColsBars(kind, data, logger, interactive, solvedComment, options) {
    (0, _classCallCheck3.default)(this, YouGuessColsBars);
    this.kind = kind;
    this.data = data;
    this.logger = logger;
    this.interactive = interactive;
    this.solvedComment = solvedComment;
    this.options = options;
  }

  (0, _createClass3.default)(YouGuessColsBars, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.YouGuessColsBars",
        interfaces: ["FSharpRecord"],
        properties: {
          kind: YouGuessColsBarsKind,
          data: (0, _Util.makeGeneric)(_series.series, {
            k: "string",
            v: "number"
          }),
          logger: (0, _Util.Option)("function"),
          interactive: "boolean",
          solvedComment: (0, _Util.Option)("string"),
          options: ChartOptions
        }
      };
    }
  }, {
    key: "setEmptyMessage",
    value: function (message) {
      var options = void 0;
      var emptyMessage = message;
      options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, this.options.title, this.options.legend, emptyMessage);
      return new YouGuessColsBars(this.kind, this.data, this.logger, this.interactive, this.solvedComment, options);
    }
  }, {
    key: "setTitle",
    value: function (title) {
      var options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, title, this.options.legend, this.options.emptyMessage);
      return new YouGuessColsBars(this.kind, this.data, this.logger, this.interactive, this.solvedComment, options);
    }
  }, {
    key: "setLegend",
    value: function (position) {
      var options = void 0;
      var legend = new LegendOptions(position);
      options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, this.options.title, legend, this.options.emptyMessage);
      return new YouGuessColsBars(this.kind, this.data, this.logger, this.interactive, this.solvedComment, options);
    }
  }, {
    key: "setSize",
    value: function (width, height) {
      var options = new ChartOptions([CompostHelpers.orElse(width, this.options.size[0]), CompostHelpers.orElse(height, this.options.size[1])], this.options.xAxis, this.options.yAxis, this.options.title, this.options.legend, this.options.emptyMessage);
      return new YouGuessColsBars(this.kind, this.data, this.logger, this.interactive, this.solvedComment, options);
    }
  }, {
    key: "setAxisX",
    value: function (minValue, maxValue, label, labelOffset, labelMinimalSize) {
      var ax = void 0;
      var inputRecord = this.options.xAxis;
      ax = new AxisOptions(CompostHelpers.orElse(minValue, this.options.xAxis.minValue), CompostHelpers.orElse(maxValue, this.options.xAxis.maxValue), CompostHelpers.orElse(label, this.options.xAxis.label), CompostHelpers.orElse(labelOffset, this.options.xAxis.labelOffset), CompostHelpers.orElse(labelMinimalSize, this.options.xAxis.labelMinimalSize));
      var options = new ChartOptions(this.options.size, ax, this.options.yAxis, this.options.title, this.options.legend, this.options.emptyMessage);
      return new YouGuessColsBars(this.kind, this.data, this.logger, this.interactive, this.solvedComment, options);
    }
  }, {
    key: "setAxisY",
    value: function (minValue, maxValue, label, labelOffset, labelMinimalSize) {
      var ax = void 0;
      var inputRecord = this.options.yAxis;
      ax = new AxisOptions(CompostHelpers.orElse(minValue, this.options.yAxis.minValue), CompostHelpers.orElse(maxValue, this.options.yAxis.maxValue), CompostHelpers.orElse(label, this.options.yAxis.label), CompostHelpers.orElse(labelOffset, this.options.yAxis.labelOffset), CompostHelpers.orElse(labelMinimalSize, this.options.yAxis.labelMinimalSize));
      var options = new ChartOptions(this.options.size, this.options.xAxis, ax, this.options.title, this.options.legend, this.options.emptyMessage);
      return new YouGuessColsBars(this.kind, this.data, this.logger, this.interactive, this.solvedComment, options);
    }
  }, {
    key: "setSolvedComment",
    value: function (comment) {
      var solvedComment = comment;
      return new YouGuessColsBars(this.kind, this.data, this.logger, this.interactive, solvedComment, this.options);
    }
  }, {
    key: "setLogger",
    value: function (logger) {
      var logger_1 = logger;
      return new YouGuessColsBars(this.kind, this.data, logger_1, this.interactive, this.solvedComment, this.options);
    }
  }, {
    key: "setLabel",
    value: function (top) {
      return this.setTitle(top);
    }
  }, {
    key: "setMaximum",
    value: function (max) {
      if (this.kind.Equals(new YouGuessColsBarsKind("Bars", []))) {
        return this.setAxisX(null, max);
      } else {
        return this.setAxisY(null, max);
      }
    }
  }, {
    key: "setInteractive",
    value: function (state) {
      return new YouGuessColsBars(this.kind, this.data, this.logger, state, this.solvedComment, this.options);
    }
  }, {
    key: "show",
    value: function (outputId) {
      var _this = this;

      InteractiveHelpers.showApp(outputId, this.options, this.data, function (data) {
        return YouGuessColsHelpers.initState(!_this.interactive, _this.kind.Equals(new YouGuessColsBarsKind("Bars", [])), data, _this.kind.Equals(new YouGuessColsBarsKind("Bars", [])) ? _this.options.xAxis.maxValue : _this.options.yAxis.maxValue);
      }, function (_arg1) {
        return function (size) {
          if (_this.kind.Case === "Cols") {
            var topLabel = _this.options.title;
            return function (trigger) {
              return function (state) {
                return YouGuessColsHelpers.renderCols(_this.solvedComment, _this.interactive, size[0], size[1], topLabel, trigger, state);
              };
            };
          } else {
            var inlineLabels = true;
            return function (trigger_1) {
              return function (state_1) {
                return YouGuessColsHelpers.renderBars(_this.solvedComment, _this.interactive, inlineLabels, size[0], size[1], _this.options, trigger_1, state_1);
              };
            };
          }
        };
      }, function (_arg2) {
        var log = void 0;
        var clo2 = InteractiveHelpers.createLogger(outputId, _this.logger);

        log = function log(arg20) {
          var clo3 = clo2(arg20);
          return function (arg30) {
            clo3(arg30);
          };
        };

        return function (state_2) {
          return function (evt) {
            return YouGuessColsHelpers.update(log, state_2, evt);
          };
        };
      });
    }
  }]);
  return YouGuessColsBars;
}();

(0, _Symbol2.setType)("TheGamma.Interactive.YouGuessColsBars", YouGuessColsBars);

var YouGuessLine = exports.YouGuessLine = function () {
  function YouGuessLine(data, markers, clip, markerColor, knownColor, unknownColor, drawColor, knownLabel, guessLabel, logger, interactive, solvedComment, options) {
    (0, _classCallCheck3.default)(this, YouGuessLine);
    this.data = data;
    this.markers = markers;
    this.clip = clip;
    this.markerColor = markerColor;
    this.knownColor = knownColor;
    this.unknownColor = unknownColor;
    this.drawColor = drawColor;
    this.knownLabel = knownLabel;
    this.guessLabel = guessLabel;
    this.logger = logger;
    this.interactive = interactive;
    this.solvedComment = solvedComment;
    this.options = options;
  }

  (0, _createClass3.default)(YouGuessLine, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.YouGuessLine",
        interfaces: ["FSharpRecord"],
        properties: {
          data: (0, _Util.makeGeneric)(_series.series, {
            k: _Util.Any,
            v: "number"
          }),
          markers: (0, _Util.Option)((0, _Util.makeGeneric)(_series.series, {
            k: _Util.Any,
            v: _Util.Any
          })),
          clip: (0, _Util.Option)("number"),
          markerColor: (0, _Util.Option)("string"),
          knownColor: (0, _Util.Option)("string"),
          unknownColor: (0, _Util.Option)("string"),
          drawColor: (0, _Util.Option)("string"),
          knownLabel: (0, _Util.Option)("string"),
          guessLabel: (0, _Util.Option)("string"),
          logger: (0, _Util.Option)("function"),
          interactive: "boolean",
          solvedComment: (0, _Util.Option)("string"),
          options: ChartOptions
        }
      };
    }
  }, {
    key: "setEmptyMessage",
    value: function (message) {
      var options = void 0;
      var emptyMessage = message;
      options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, this.options.title, this.options.legend, emptyMessage);
      return new YouGuessLine(this.data, this.markers, this.clip, this.markerColor, this.knownColor, this.unknownColor, this.drawColor, this.knownLabel, this.guessLabel, this.logger, this.interactive, this.solvedComment, options);
    }
  }, {
    key: "setTitle",
    value: function (title) {
      var options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, title, this.options.legend, this.options.emptyMessage);
      return new YouGuessLine(this.data, this.markers, this.clip, this.markerColor, this.knownColor, this.unknownColor, this.drawColor, this.knownLabel, this.guessLabel, this.logger, this.interactive, this.solvedComment, options);
    }
  }, {
    key: "setLegend",
    value: function (position) {
      var options = void 0;
      var legend = new LegendOptions(position);
      options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, this.options.title, legend, this.options.emptyMessage);
      return new YouGuessLine(this.data, this.markers, this.clip, this.markerColor, this.knownColor, this.unknownColor, this.drawColor, this.knownLabel, this.guessLabel, this.logger, this.interactive, this.solvedComment, options);
    }
  }, {
    key: "setSize",
    value: function (width, height) {
      var options = new ChartOptions([CompostHelpers.orElse(width, this.options.size[0]), CompostHelpers.orElse(height, this.options.size[1])], this.options.xAxis, this.options.yAxis, this.options.title, this.options.legend, this.options.emptyMessage);
      return new YouGuessLine(this.data, this.markers, this.clip, this.markerColor, this.knownColor, this.unknownColor, this.drawColor, this.knownLabel, this.guessLabel, this.logger, this.interactive, this.solvedComment, options);
    }
  }, {
    key: "setAxisX",
    value: function (minValue, maxValue, label, labelOffset, labelMinimalSize) {
      var ax = void 0;
      var inputRecord = this.options.xAxis;
      ax = new AxisOptions(CompostHelpers.orElse(minValue, this.options.xAxis.minValue), CompostHelpers.orElse(maxValue, this.options.xAxis.maxValue), CompostHelpers.orElse(label, this.options.xAxis.label), CompostHelpers.orElse(labelOffset, this.options.xAxis.labelOffset), CompostHelpers.orElse(labelMinimalSize, this.options.xAxis.labelMinimalSize));
      var options = new ChartOptions(this.options.size, ax, this.options.yAxis, this.options.title, this.options.legend, this.options.emptyMessage);
      return new YouGuessLine(this.data, this.markers, this.clip, this.markerColor, this.knownColor, this.unknownColor, this.drawColor, this.knownLabel, this.guessLabel, this.logger, this.interactive, this.solvedComment, options);
    }
  }, {
    key: "setAxisY",
    value: function (minValue, maxValue, label, labelOffset, labelMinimalSize) {
      var ax = void 0;
      var inputRecord = this.options.yAxis;
      ax = new AxisOptions(CompostHelpers.orElse(minValue, this.options.yAxis.minValue), CompostHelpers.orElse(maxValue, this.options.yAxis.maxValue), CompostHelpers.orElse(label, this.options.yAxis.label), CompostHelpers.orElse(labelOffset, this.options.yAxis.labelOffset), CompostHelpers.orElse(labelMinimalSize, this.options.yAxis.labelMinimalSize));
      var options = new ChartOptions(this.options.size, this.options.xAxis, ax, this.options.title, this.options.legend, this.options.emptyMessage);
      return new YouGuessLine(this.data, this.markers, this.clip, this.markerColor, this.knownColor, this.unknownColor, this.drawColor, this.knownLabel, this.guessLabel, this.logger, this.interactive, this.solvedComment, options);
    }
  }, {
    key: "setSolvedComment",
    value: function (comment) {
      var solvedComment = comment;
      return new YouGuessLine(this.data, this.markers, this.clip, this.markerColor, this.knownColor, this.unknownColor, this.drawColor, this.knownLabel, this.guessLabel, this.logger, this.interactive, solvedComment, this.options);
    }
  }, {
    key: "setLogger",
    value: function (logger) {
      var logger_1 = logger;
      return new YouGuessLine(this.data, this.markers, this.clip, this.markerColor, this.knownColor, this.unknownColor, this.drawColor, this.knownLabel, this.guessLabel, logger_1, this.interactive, this.solvedComment, this.options);
    }
  }, {
    key: "setRange",
    value: function (min, max) {
      return this.setAxisY(min, max);
    }
  }, {
    key: "setClip",
    value: function (clip) {
      var clip_1 = clip instanceof Date ? clip.getTime() : clip;
      return new YouGuessLine(this.data, this.markers, clip_1, this.markerColor, this.knownColor, this.unknownColor, this.drawColor, this.knownLabel, this.guessLabel, this.logger, this.interactive, this.solvedComment, this.options);
    }
  }, {
    key: "setColors",
    value: function (known, unknown) {
      var knownColor = known;
      var unknownColor = unknown;
      return new YouGuessLine(this.data, this.markers, this.clip, this.markerColor, knownColor, unknownColor, this.drawColor, this.knownLabel, this.guessLabel, this.logger, this.interactive, this.solvedComment, this.options);
    }
  }, {
    key: "setDrawColor",
    value: function (draw) {
      var drawColor = draw;
      return new YouGuessLine(this.data, this.markers, this.clip, this.markerColor, this.knownColor, this.unknownColor, drawColor, this.knownLabel, this.guessLabel, this.logger, this.interactive, this.solvedComment, this.options);
    }
  }, {
    key: "setMarkerColor",
    value: function (marker) {
      var markerColor = marker;
      return new YouGuessLine(this.data, this.markers, this.clip, markerColor, this.knownColor, this.unknownColor, this.drawColor, this.knownLabel, this.guessLabel, this.logger, this.interactive, this.solvedComment, this.options);
    }
  }, {
    key: "setLabels",
    value: function (top, known, guess) {
      var knownLabel = CompostHelpers.orElse(known, this.knownLabel);
      var guessLabel = CompostHelpers.orElse(guess, this.guessLabel);
      var options = void 0;
      var title = CompostHelpers.orElse(top, this.options.title);
      options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, title, this.options.legend, this.options.emptyMessage);
      return new YouGuessLine(this.data, this.markers, this.clip, this.markerColor, this.knownColor, this.unknownColor, this.drawColor, knownLabel, guessLabel, this.logger, this.interactive, this.solvedComment, options);
    }
  }, {
    key: "setMarkers",
    value: function (markers) {
      var markers_1 = markers;
      return new YouGuessLine(this.data, markers_1, this.clip, this.markerColor, this.knownColor, this.unknownColor, this.drawColor, this.knownLabel, this.guessLabel, this.logger, this.interactive, this.solvedComment, this.options);
    }
  }, {
    key: "setInteractive",
    value: function (state) {
      return new YouGuessLine(this.data, this.markers, this.clip, this.markerColor, this.knownColor, this.unknownColor, this.drawColor, this.knownLabel, this.guessLabel, this.logger, state, this.solvedComment, this.options);
    }
  }, {
    key: "show",
    value: function (outputId) {
      var _this2 = this;

      (function (arg00) {
        (0, _Async.startImmediate)(arg00);
      })(function (builder_) {
        return builder_.Delay(function () {
          var markers = (0, _Util.defaultArg)(_this2.markers, _series.series.create(_AsyncBuilder.singleton.Return([]), "", "", ""));
          return builder_.Bind((0, _common.Async$2E$AwaitFuture$2E$Static)(markers.data), function (_arg1) {
            var markers_1 = (0, _from2.default)((0, _Seq.sortWith)(function (x, y) {
              return (0, _Util.compare)(function (tuple) {
                return tuple[0];
              }(x), function (tuple) {
                return tuple[0];
              }(y));
            }, _arg1.map(function (tupledArg) {
              return [tupledArg[0] instanceof Date ? tupledArg[0].getTime() : tupledArg[0], tupledArg[1]];
            })));
            return builder_.ReturnFrom(InteractiveHelpers.showAppAsync(outputId, _this2.options, _this2.data, function (data) {
              var clipx = _this2.clip != null ? _this2.clip : data[~~(data.length / 2)][0] instanceof Date ? data[~~(data.length / 2)][0].getTime() : data[~~(data.length / 2)][0];
              return YouGuessLineHelpers.initState(!_this2.interactive, (0, _from2.default)((0, _Seq.sortWith)(function (x, y) {
                return (0, _Util.compare)(function ($var159) {
                  return $var159[0] instanceof Date ? $var159[0].getTime() : $var159[0];
                }(x), function ($var159) {
                  return $var159[0] instanceof Date ? $var159[0].getTime() : $var159[0];
                }(y));
              }, data)), clipx);
            }, function (data_1) {
              return function (size) {
                return function (trig) {
                  var patternInput = [(0, _Util.defaultArg)(_this2.knownColor, "#606060"), (0, _Util.defaultArg)(_this2.unknownColor, "#FFC700"), (0, _Util.defaultArg)(_this2.drawColor, "#808080"), (0, _Util.defaultArg)(_this2.markerColor, "#C65E31")];
                  var data_2 = (0, _from2.default)((0, _Seq.sortWith)(function (x, y) {
                    return (0, _Util.compare)(function ($var160) {
                      return $var160[0] instanceof Date ? $var160[0].getTime() : $var160[0];
                    }(x), function ($var160) {
                      return $var160[0] instanceof Date ? $var160[0].getTime() : $var160[0];
                    }(y));
                  }, data_1));
                  var co = void 0;
                  var xAxis = void 0;
                  var inputRecord = _this2.options.xAxis;
                  xAxis = new AxisOptions(data_2[0][0] instanceof Date ? data_2[0][0].getTime() : data_2[0][0], data_2[data_2.length - 1][0] instanceof Date ? data_2[data_2.length - 1][0].getTime() : data_2[data_2.length - 1][0], inputRecord.label, inputRecord.labelOffset, inputRecord.labelMinimalSize);
                  co = new ChartOptions(_this2.options.size, xAxis, _this2.options.yAxis, _this2.options.title, _this2.options.legend, _this2.options.emptyMessage);
                  var tupledArg_1 = [(0, _Util.defaultArg)(_this2.knownLabel, ""), (0, _Util.defaultArg)(_this2.guessLabel, "")];
                  var tupledArg_2 = [patternInput[0], patternInput[1], patternInput[2], patternInput[3]];
                  return function (state) {
                    return YouGuessLineHelpers.render(_this2.solvedComment, _this2.interactive, co, size[0], size[1], markers_1, tupledArg_1[0], tupledArg_1[1], tupledArg_2[0], tupledArg_2[1], tupledArg_2[2], tupledArg_2[3], trig, state);
                  };
                };
              };
            }, function (_arg3) {
              var log = void 0;
              var clo2 = InteractiveHelpers.createLogger(outputId, _this2.logger);

              log = function log(arg20) {
                var clo3 = clo2(arg20);
                return function (arg30) {
                  clo3(arg30);
                };
              };

              return function (state_1) {
                return function (evt) {
                  return YouGuessLineHelpers.handler(log, state_1, evt);
                };
              };
            }));
          });
        });
      }(_AsyncBuilder.singleton));
    }
  }]);
  return YouGuessLine;
}();

(0, _Symbol2.setType)("TheGamma.Interactive.YouGuessLine", YouGuessLine);

var YouGuessLineOffset = exports.YouGuessLineOffset = function () {
  function YouGuessLineOffset(data, markers, labels, logger, interactive, lineColor, guessColor, markerColor, solvedComment, options) {
    (0, _classCallCheck3.default)(this, YouGuessLineOffset);
    this.data = data;
    this.markers = markers;
    this.labels = labels;
    this.logger = logger;
    this.interactive = interactive;
    this.lineColor = lineColor;
    this.guessColor = guessColor;
    this.markerColor = markerColor;
    this.solvedComment = solvedComment;
    this.options = options;
  }

  (0, _createClass3.default)(YouGuessLineOffset, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.YouGuessLineOffset",
        interfaces: ["FSharpRecord"],
        properties: {
          data: (0, _Util.makeGeneric)(_series.series, {
            k: _Util.Any,
            v: "number"
          }),
          markers: (0, _Util.Option)((0, _Util.makeGeneric)(_series.series, {
            k: _Util.Any,
            v: _Util.Any
          })),
          labels: (0, _Util.Array)("string"),
          logger: (0, _Util.Option)("function"),
          interactive: "boolean",
          lineColor: (0, _Util.Option)("string"),
          guessColor: (0, _Util.Option)("string"),
          markerColor: (0, _Util.Option)("string"),
          solvedComment: (0, _Util.Option)("string"),
          options: ChartOptions
        }
      };
    }
  }, {
    key: "setEmptyMessage",
    value: function (message) {
      var options = void 0;
      var emptyMessage = message;
      options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, this.options.title, this.options.legend, emptyMessage);
      return new YouGuessLineOffset(this.data, this.markers, this.labels, this.logger, this.interactive, this.lineColor, this.guessColor, this.markerColor, this.solvedComment, options);
    }
  }, {
    key: "setTitle",
    value: function (title) {
      var options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, title, this.options.legend, this.options.emptyMessage);
      return new YouGuessLineOffset(this.data, this.markers, this.labels, this.logger, this.interactive, this.lineColor, this.guessColor, this.markerColor, this.solvedComment, options);
    }
  }, {
    key: "setLegend",
    value: function (position) {
      var options = void 0;
      var legend = new LegendOptions(position);
      options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, this.options.title, legend, this.options.emptyMessage);
      return new YouGuessLineOffset(this.data, this.markers, this.labels, this.logger, this.interactive, this.lineColor, this.guessColor, this.markerColor, this.solvedComment, options);
    }
  }, {
    key: "setSize",
    value: function (width, height) {
      var options = new ChartOptions([CompostHelpers.orElse(width, this.options.size[0]), CompostHelpers.orElse(height, this.options.size[1])], this.options.xAxis, this.options.yAxis, this.options.title, this.options.legend, this.options.emptyMessage);
      return new YouGuessLineOffset(this.data, this.markers, this.labels, this.logger, this.interactive, this.lineColor, this.guessColor, this.markerColor, this.solvedComment, options);
    }
  }, {
    key: "setAxisX",
    value: function (minValue, maxValue, label, labelOffset, labelMinimalSize) {
      var ax = void 0;
      var inputRecord = this.options.xAxis;
      ax = new AxisOptions(CompostHelpers.orElse(minValue, this.options.xAxis.minValue), CompostHelpers.orElse(maxValue, this.options.xAxis.maxValue), CompostHelpers.orElse(label, this.options.xAxis.label), CompostHelpers.orElse(labelOffset, this.options.xAxis.labelOffset), CompostHelpers.orElse(labelMinimalSize, this.options.xAxis.labelMinimalSize));
      var options = new ChartOptions(this.options.size, ax, this.options.yAxis, this.options.title, this.options.legend, this.options.emptyMessage);
      return new YouGuessLineOffset(this.data, this.markers, this.labels, this.logger, this.interactive, this.lineColor, this.guessColor, this.markerColor, this.solvedComment, options);
    }
  }, {
    key: "setAxisY",
    value: function (minValue, maxValue, label, labelOffset, labelMinimalSize) {
      var ax = void 0;
      var inputRecord = this.options.yAxis;
      ax = new AxisOptions(CompostHelpers.orElse(minValue, this.options.yAxis.minValue), CompostHelpers.orElse(maxValue, this.options.yAxis.maxValue), CompostHelpers.orElse(label, this.options.yAxis.label), CompostHelpers.orElse(labelOffset, this.options.yAxis.labelOffset), CompostHelpers.orElse(labelMinimalSize, this.options.yAxis.labelMinimalSize));
      var options = new ChartOptions(this.options.size, this.options.xAxis, ax, this.options.title, this.options.legend, this.options.emptyMessage);
      return new YouGuessLineOffset(this.data, this.markers, this.labels, this.logger, this.interactive, this.lineColor, this.guessColor, this.markerColor, this.solvedComment, options);
    }
  }, {
    key: "setLabels",
    value: function (labels) {
      return new YouGuessLineOffset(this.data, this.markers, labels, this.logger, this.interactive, this.lineColor, this.guessColor, this.markerColor, this.solvedComment, this.options);
    }
  }, {
    key: "setSolvedComment",
    value: function (comment) {
      var solvedComment = comment;
      return new YouGuessLineOffset(this.data, this.markers, this.labels, this.logger, this.interactive, this.lineColor, this.guessColor, this.markerColor, solvedComment, this.options);
    }
  }, {
    key: "setLogger",
    value: function (logger) {
      var logger_1 = logger;
      return new YouGuessLineOffset(this.data, this.markers, this.labels, logger_1, this.interactive, this.lineColor, this.guessColor, this.markerColor, this.solvedComment, this.options);
    }
  }, {
    key: "setColors",
    value: function (draw, solved, marker) {
      var guessColor = CompostHelpers.orElse(draw, this.guessColor);
      var lineColor = CompostHelpers.orElse(solved, this.lineColor);
      var markerColor = CompostHelpers.orElse(marker, this.markerColor);
      return new YouGuessLineOffset(this.data, this.markers, this.labels, this.logger, this.interactive, lineColor, guessColor, markerColor, this.solvedComment, this.options);
    }
  }, {
    key: "setMarkers",
    value: function (markers) {
      var markers_1 = markers;
      return new YouGuessLineOffset(this.data, markers_1, this.labels, this.logger, this.interactive, this.lineColor, this.guessColor, this.markerColor, this.solvedComment, this.options);
    }
  }, {
    key: "setInteractive",
    value: function (state) {
      return new YouGuessLineOffset(this.data, this.markers, this.labels, this.logger, state, this.lineColor, this.guessColor, this.markerColor, this.solvedComment, this.options);
    }
  }, {
    key: "show",
    value: function (outputId) {
      var _this3 = this;

      (function (arg00) {
        (0, _Async.startImmediate)(arg00);
      })(function (builder_) {
        return builder_.Delay(function () {
          var markers = (0, _Util.defaultArg)(_this3.markers, _series.series.create(_AsyncBuilder.singleton.Return([]), "", "", ""));
          return builder_.Bind((0, _common.Async$2E$AwaitFuture$2E$Static)(markers.data), function (_arg1) {
            var markers_1 = (0, _from2.default)((0, _Seq.sortWith)(function (x, y) {
              return (0, _Util.compare)(function (tuple) {
                return tuple[0];
              }(x), function (tuple) {
                return tuple[0];
              }(y));
            }, _arg1.map(function (tupledArg) {
              return [tupledArg[0] instanceof Date ? tupledArg[0].getTime() : tupledArg[0], tupledArg[1]];
            })));
            return builder_.ReturnFrom(InteractiveHelpers.showAppAsync(outputId, _this3.options, _this3.data, function (data) {
              var data_1 = (0, _from2.default)((0, _Seq.sortWith)(function (x, y) {
                return (0, _Util.compare)(function ($var161) {
                  return $var161[0] instanceof Date ? $var161[0].getTime() : $var161[0];
                }(x), function ($var161) {
                  return $var161[0] instanceof Date ? $var161[0].getTime() : $var161[0];
                }(y));
              }, data));
              var lo = (0, _Util.defaultArg)(_this3.options.yAxis.minValue, data_1[0][0] instanceof Date ? data_1[0][0].getTime() : data_1[0][0]);
              var hi = (0, _Util.defaultArg)(_this3.options.yAxis.maxValue, data_1[data_1.length - 1][0] instanceof Date ? data_1[data_1.length - 1][0].getTime() : data_1[data_1.length - 1][0]);
              var co = void 0;
              var yAxis = void 0;
              var inputRecord = _this3.options.yAxis;
              yAxis = new AxisOptions(lo, hi, inputRecord.label, inputRecord.labelOffset, inputRecord.labelMinimalSize);
              co = new ChartOptions(_this3.options.size, _this3.options.xAxis, yAxis, _this3.options.title, _this3.options.legend, _this3.options.emptyMessage);
              return YouGeussLineOffsetHelpers.initState(!_this3.interactive, co, (0, _from2.default)((0, _Seq.sortWith)(function (x, y) {
                return (0, _Util.compare)(function ($var162) {
                  return $var162[0] instanceof Date ? $var162[0].getTime() : $var162[0];
                }(x), function ($var162) {
                  return $var162[0] instanceof Date ? $var162[0].getTime() : $var162[0];
                }(y));
              }, data_1)));
            }, function (data_2) {
              return function (size) {
                return function (trig) {
                  var lc = (0, _Util.defaultArg)(_this3.lineColor, "#bcbd22");
                  var gc = (0, _Util.defaultArg)(_this3.guessColor, "#808080");
                  var mc = (0, _Util.defaultArg)(_this3.markerColor, "#800080");
                  var arg = [gc, lc, mc];
                  return function (state) {
                    return YouGeussLineOffsetHelpers.render(_this3.solvedComment, _this3.interactive, size[0], size[1], _this3.labels, markers_1, arg[0], arg[1], arg[2], trig, state);
                  };
                };
              };
            }, function (_arg4) {
              var log = void 0;
              var clo2 = InteractiveHelpers.createLogger(outputId, _this3.logger);

              log = function log(arg20) {
                var clo3 = clo2(arg20);
                return function (arg30) {
                  clo3(arg30);
                };
              };

              return function (state_1) {
                return function (evt) {
                  return YouGeussLineOffsetHelpers.handler(log, state_1, evt);
                };
              };
            }));
          });
        });
      }(_AsyncBuilder.singleton));
    }
  }]);
  return YouGuessLineOffset;
}();

(0, _Symbol2.setType)("TheGamma.Interactive.YouGuessLineOffset", YouGuessLineOffset);

var YouGuessSortBars = exports.YouGuessSortBars = function () {
  function YouGuessSortBars(data, maxValue, size, logger, interactive, solvedComment) {
    (0, _classCallCheck3.default)(this, YouGuessSortBars);
    this.data = data;
    this.maxValue = maxValue;
    this.size = size;
    this.logger = logger;
    this.interactive = interactive;
    this.solvedComment = solvedComment;
  }

  (0, _createClass3.default)(YouGuessSortBars, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.YouGuessSortBars",
        interfaces: ["FSharpRecord"],
        properties: {
          data: (0, _Util.makeGeneric)(_series.series, {
            k: "string",
            v: "number"
          }),
          maxValue: (0, _Util.Option)("number"),
          size: (0, _Util.Tuple)([(0, _Util.Option)("number"), (0, _Util.Option)("number")]),
          logger: (0, _Util.Option)("function"),
          interactive: "boolean",
          solvedComment: (0, _Util.Option)("string")
        }
      };
    }
  }, {
    key: "setSolvedComment",
    value: function (comment) {
      var solvedComment = comment;
      return new YouGuessSortBars(this.data, this.maxValue, this.size, this.logger, this.interactive, solvedComment);
    }
  }, {
    key: "setLogger",
    value: function (logger) {
      var logger_1 = logger;
      return new YouGuessSortBars(this.data, this.maxValue, this.size, logger_1, this.interactive, this.solvedComment);
    }
  }, {
    key: "setMaximum",
    value: function (max) {
      var maxValue = max;
      return new YouGuessSortBars(this.data, maxValue, this.size, this.logger, this.interactive, this.solvedComment);
    }
  }, {
    key: "setSize",
    value: function (width, height) {
      var size = [CompostHelpers.orElse(width, this.size[0]), CompostHelpers.orElse(height, this.size[1])];
      return new YouGuessSortBars(this.data, this.maxValue, size, this.logger, this.interactive, this.solvedComment);
    }
  }, {
    key: "setInteractive",
    value: function (state) {
      return new YouGuessSortBars(this.data, this.maxValue, this.size, this.logger, state, this.solvedComment);
    }
  }, {
    key: "show",
    value: function (outputId) {
      var _this4 = this;

      InteractiveHelpers.showApp(outputId, function () {
        var inputRecord = ChartOptions.Default;
        return new ChartOptions(_this4.size, inputRecord.xAxis, inputRecord.yAxis, inputRecord.title, inputRecord.legend, inputRecord.emptyMessage);
      }(), this.data, function () {
        var completed = !_this4.interactive;
        return function (data) {
          return YouGuessSortHelpers.initState(completed, _this4.maxValue, data);
        };
      }(), function (_arg5) {
        return function (size) {
          return function (trigger) {
            return function (state) {
              return YouGuessSortHelpers.renderBars(_this4.solvedComment, _this4.interactive, size[0], size[1], trigger, state);
            };
          };
        };
      }, function (_arg6) {
        var log = void 0;
        var clo2 = InteractiveHelpers.createLogger(outputId, _this4.logger);

        log = function log(arg20) {
          var clo3 = clo2(arg20);
          return function (arg30) {
            clo3(arg30);
          };
        };

        return function (state_1) {
          return function (evt) {
            return YouGuessSortHelpers.update(log, state_1, evt);
          };
        };
      });
    }
  }]);
  return YouGuessSortBars;
}();

(0, _Symbol2.setType)("TheGamma.Interactive.YouGuessSortBars", YouGuessSortBars);

var youguess = exports.youguess = function () {
  function youguess() {
    (0, _classCallCheck3.default)(this, youguess);
  }

  (0, _createClass3.default)(youguess, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.youguess",
        properties: {}
      };
    }
  }], [{
    key: "columns",
    value: function (data) {
      var kind = new YouGuessColsBarsKind("Cols", []);
      var options = ChartOptions.Default;
      return new YouGuessColsBars(kind, data, null, true, null, options);
    }
  }, {
    key: "bars",
    value: function (data) {
      var kind = new YouGuessColsBarsKind("Bars", []);
      var options = ChartOptions.Default;
      return new YouGuessColsBars(kind, data, null, true, null, options);
    }
  }, {
    key: "sortBars",
    value: function (data) {
      return new YouGuessSortBars(data, null, [null, null], null, true, null);
    }
  }, {
    key: "line",
    value: function (data) {
      var clip = null;
      var markerColor = null;
      var guessLabel = null;
      var knownLabel = null;
      var markers = null;
      var knownColor = null;
      var unknownColor = null;
      var drawColor = null;
      var options = ChartOptions.Default;
      return new YouGuessLine(data, markers, clip, markerColor, knownColor, unknownColor, drawColor, knownLabel, guessLabel, null, true, null, options);
    }
  }, {
    key: "vlineOffset",
    value: function (data) {
      var markers = null;
      var lineColor = null;
      var guessColor = null;
      var markerColor = null;
      var labels = (0, _from2.default)((0, _Seq.delay)(function () {
        return (0, _Seq.map)(function (c) {
          return c;
        }, (0, _Seq.rangeChar)("A", "Z"));
      }));
      var options = ChartOptions.Default;
      return new YouGuessLineOffset(data, markers, labels, null, true, lineColor, guessColor, markerColor, null, options);
    }
  }]);
  return youguess;
}();

(0, _Symbol2.setType)("TheGamma.Interactive.youguess", youguess);

var CompostBubblesChartSet = exports.CompostBubblesChartSet = function () {
  function CompostBubblesChartSet(data, selectY, selectX, selectLabel, selectSize, bubbleColor, options) {
    (0, _classCallCheck3.default)(this, CompostBubblesChartSet);
    this.data = data;
    this.selectY = selectY;
    this.selectX = selectX;
    this.selectLabel = selectLabel;
    this.selectSize = selectSize;
    this.bubbleColor = bubbleColor;
    this.options = options;
  }

  (0, _createClass3.default)(CompostBubblesChartSet, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.CompostBubblesChartSet",
        interfaces: ["FSharpRecord"],
        properties: {
          data: (0, _Util.makeGeneric)(_series.series, {
            k: _Util.Any,
            v: _Util.Any
          }),
          selectY: "function",
          selectX: "function",
          selectLabel: (0, _Util.Option)("function"),
          selectSize: (0, _Util.Option)("function"),
          bubbleColor: (0, _Util.Option)("string"),
          options: ChartOptions
        }
      };
    }
  }, {
    key: "setEmptyMessage",
    value: function (message) {
      var options = void 0;
      var emptyMessage = message;
      options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, this.options.title, this.options.legend, emptyMessage);
      return new CompostBubblesChartSet(this.data, this.selectY, this.selectX, this.selectLabel, this.selectSize, this.bubbleColor, options);
    }
  }, {
    key: "setTitle",
    value: function (title) {
      var options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, title, this.options.legend, this.options.emptyMessage);
      return new CompostBubblesChartSet(this.data, this.selectY, this.selectX, this.selectLabel, this.selectSize, this.bubbleColor, options);
    }
  }, {
    key: "setLegend",
    value: function (position) {
      var options = void 0;
      var legend = new LegendOptions(position);
      options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, this.options.title, legend, this.options.emptyMessage);
      return new CompostBubblesChartSet(this.data, this.selectY, this.selectX, this.selectLabel, this.selectSize, this.bubbleColor, options);
    }
  }, {
    key: "setSize",
    value: function (width, height) {
      var options = new ChartOptions([CompostHelpers.orElse(width, this.options.size[0]), CompostHelpers.orElse(height, this.options.size[1])], this.options.xAxis, this.options.yAxis, this.options.title, this.options.legend, this.options.emptyMessage);
      return new CompostBubblesChartSet(this.data, this.selectY, this.selectX, this.selectLabel, this.selectSize, this.bubbleColor, options);
    }
  }, {
    key: "setAxisX",
    value: function (minValue, maxValue, label, labelOffset, labelMinimalSize) {
      var ax = void 0;
      var inputRecord = this.options.xAxis;
      ax = new AxisOptions(CompostHelpers.orElse(minValue, this.options.xAxis.minValue), CompostHelpers.orElse(maxValue, this.options.xAxis.maxValue), CompostHelpers.orElse(label, this.options.xAxis.label), CompostHelpers.orElse(labelOffset, this.options.xAxis.labelOffset), CompostHelpers.orElse(labelMinimalSize, this.options.xAxis.labelMinimalSize));
      var options = new ChartOptions(this.options.size, ax, this.options.yAxis, this.options.title, this.options.legend, this.options.emptyMessage);
      return new CompostBubblesChartSet(this.data, this.selectY, this.selectX, this.selectLabel, this.selectSize, this.bubbleColor, options);
    }
  }, {
    key: "setAxisY",
    value: function (minValue, maxValue, label, labelOffset, labelMinimalSize) {
      var ax = void 0;
      var inputRecord = this.options.yAxis;
      ax = new AxisOptions(CompostHelpers.orElse(minValue, this.options.yAxis.minValue), CompostHelpers.orElse(maxValue, this.options.yAxis.maxValue), CompostHelpers.orElse(label, this.options.yAxis.label), CompostHelpers.orElse(labelOffset, this.options.yAxis.labelOffset), CompostHelpers.orElse(labelMinimalSize, this.options.yAxis.labelMinimalSize));
      var options = new ChartOptions(this.options.size, this.options.xAxis, ax, this.options.title, this.options.legend, this.options.emptyMessage);
      return new CompostBubblesChartSet(this.data, this.selectY, this.selectX, this.selectLabel, this.selectSize, this.bubbleColor, options);
    }
  }, {
    key: "setColors",
    value: function (bubbleColor) {
      var bubbleColor_1 = bubbleColor != null ? bubbleColor : this.bubbleColor;
      return new CompostBubblesChartSet(this.data, this.selectY, this.selectX, this.selectLabel, this.selectSize, bubbleColor_1, this.options);
    }
  }, {
    key: "show",
    value: function (outputId) {
      var _this5 = this;

      InteractiveHelpers.showApp(outputId, this.options, this.data, function (data) {
        return -1;
      }, function (data_1) {
        return function (size) {
          return function (trigger) {
            return function (selectedBubble) {
              var ss = function ss(f) {
                if (f != null) {
                  return function (x) {
                    return f(x);
                  };
                } else {
                  return function (_arg7) {
                    return null;
                  };
                }
              };

              var data_2 = data_1.map(function (tupledArg) {
                return [_this5.selectX(tupledArg[1]), _this5.selectY(tupledArg[1]), ss(_this5.selectSize)(tupledArg[1]), ss(_this5.selectLabel)(tupledArg[1])];
              });
              var bc = (0, _Util.defaultArg)(_this5.bubbleColor, "#20a030");
              return Charts.renderBubbles(trigger, selectedBubble, _this5.options, size[0], size[1], bc, data_2);
            };
          };
        };
      }, function (_arg10) {
        return function (_arg9) {
          return function (evt) {
            return evt;
          };
        };
      });
    }
  }]);
  return CompostBubblesChartSet;
}();

(0, _Symbol2.setType)("TheGamma.Interactive.CompostBubblesChartSet", CompostBubblesChartSet);

var CompostBubblesChart = exports.CompostBubblesChart = function () {
  (0, _createClass3.default)(CompostBubblesChart, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.CompostBubblesChart",
        properties: {}
      };
    }
  }]);

  function CompostBubblesChart(data) {
    (0, _classCallCheck3.default)(this, CompostBubblesChart);
    this.data = data;
  }

  (0, _createClass3.default)(CompostBubblesChart, [{
    key: "set",
    value: function (x, y, size, label) {
      var data = this.data;
      var selectX = void 0;
      var clo1 = x;

      selectX = function selectX(arg10) {
        return clo1(arg10);
      };

      var selectY = void 0;
      var clo1_1 = y;

      selectY = function selectY(arg10_1) {
        return clo1_1(arg10_1);
      };

      var selectSize = size;
      var bubbleColor = null;
      var options = ChartOptions.Default;
      return new CompostBubblesChartSet(data, selectY, selectX, label, selectSize, bubbleColor, options);
    }
  }]);
  return CompostBubblesChart;
}();

(0, _Symbol2.setType)("TheGamma.Interactive.CompostBubblesChart", CompostBubblesChart);

var CompostColBarChart = exports.CompostColBarChart = function () {
  function CompostColBarChart(isBar, data, colors, inlineLabels, options) {
    (0, _classCallCheck3.default)(this, CompostColBarChart);
    this.isBar = isBar;
    this.data = data;
    this.colors = colors;
    this.inlineLabels = inlineLabels;
    this.options = options;
  }

  (0, _createClass3.default)(CompostColBarChart, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.CompostColBarChart",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          isBar: "boolean",
          data: (0, _Util.makeGeneric)(_series.series, {
            k: "string",
            v: "number"
          }),
          colors: (0, _Util.Option)((0, _Util.Array)("string")),
          inlineLabels: "boolean",
          options: ChartOptions
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }, {
    key: "setEmptyMessage",
    value: function (message) {
      var options = void 0;
      var emptyMessage = message;
      options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, this.options.title, this.options.legend, emptyMessage);
      return new CompostColBarChart(this.isBar, this.data, this.colors, this.inlineLabels, options);
    }
  }, {
    key: "setTitle",
    value: function (title) {
      var options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, title, this.options.legend, this.options.emptyMessage);
      return new CompostColBarChart(this.isBar, this.data, this.colors, this.inlineLabels, options);
    }
  }, {
    key: "setLegend",
    value: function (position) {
      var options = void 0;
      var legend = new LegendOptions(position);
      options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, this.options.title, legend, this.options.emptyMessage);
      return new CompostColBarChart(this.isBar, this.data, this.colors, this.inlineLabels, options);
    }
  }, {
    key: "setSize",
    value: function (width, height) {
      var options = new ChartOptions([CompostHelpers.orElse(width, this.options.size[0]), CompostHelpers.orElse(height, this.options.size[1])], this.options.xAxis, this.options.yAxis, this.options.title, this.options.legend, this.options.emptyMessage);
      return new CompostColBarChart(this.isBar, this.data, this.colors, this.inlineLabels, options);
    }
  }, {
    key: "setAxisX",
    value: function (minValue, maxValue, label, labelOffset, labelMinimalSize) {
      var ax = void 0;
      var inputRecord = this.options.xAxis;
      ax = new AxisOptions(CompostHelpers.orElse(minValue, this.options.xAxis.minValue), CompostHelpers.orElse(maxValue, this.options.xAxis.maxValue), CompostHelpers.orElse(label, this.options.xAxis.label), CompostHelpers.orElse(labelOffset, this.options.xAxis.labelOffset), CompostHelpers.orElse(labelMinimalSize, this.options.xAxis.labelMinimalSize));
      var options = new ChartOptions(this.options.size, ax, this.options.yAxis, this.options.title, this.options.legend, this.options.emptyMessage);
      return new CompostColBarChart(this.isBar, this.data, this.colors, this.inlineLabels, options);
    }
  }, {
    key: "setAxisY",
    value: function (minValue, maxValue, label, labelOffset, labelMinimalSize) {
      var ax = void 0;
      var inputRecord = this.options.yAxis;
      ax = new AxisOptions(CompostHelpers.orElse(minValue, this.options.yAxis.minValue), CompostHelpers.orElse(maxValue, this.options.yAxis.maxValue), CompostHelpers.orElse(label, this.options.yAxis.label), CompostHelpers.orElse(labelOffset, this.options.yAxis.labelOffset), CompostHelpers.orElse(labelMinimalSize, this.options.yAxis.labelMinimalSize));
      var options = new ChartOptions(this.options.size, this.options.xAxis, ax, this.options.title, this.options.legend, this.options.emptyMessage);
      return new CompostColBarChart(this.isBar, this.data, this.colors, this.inlineLabels, options);
    }
  }, {
    key: "setStyle",
    value: function (inlineLabels) {
      var inlineLabels_1 = inlineLabels != null ? inlineLabels : this.inlineLabels;
      return new CompostColBarChart(this.isBar, this.data, this.colors, inlineLabels_1, this.options);
    }
  }, {
    key: "setColors",
    value: function (colors) {
      var colors_1 = colors != null ? colors : this.colors;
      return new CompostColBarChart(this.isBar, this.data, colors_1, this.inlineLabels, this.options);
    }
  }, {
    key: "show",
    value: function (outputId) {
      var _this6 = this;

      InteractiveHelpers.showStaticApp(outputId, this.options, this.data, function (data) {
        return function (size) {
          var cc = (0, _Util.defaultArg)(_this6.colors, CompostHelpers.vega10);
          var clrs = cc;
          var labels = (0, _Seq.map)(function (tuple) {
            return tuple[0];
          }, data);
          return Charts.renderColsBars(_this6.isBar, _this6.inlineLabels, _this6.options, size[0], size[1], clrs, labels, data);
        };
      });
    }
  }]);
  return CompostColBarChart;
}();

(0, _Symbol2.setType)("TheGamma.Interactive.CompostColBarChart", CompostColBarChart);

var CompostLineAreaChart = exports.CompostLineAreaChart = function () {
  function CompostLineAreaChart(isArea, data, lineColor, options) {
    (0, _classCallCheck3.default)(this, CompostLineAreaChart);
    this.isArea = isArea;
    this.data = data;
    this.lineColor = lineColor;
    this.options = options;
  }

  (0, _createClass3.default)(CompostLineAreaChart, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.CompostLineAreaChart",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          isArea: "boolean",
          data: (0, _Util.makeGeneric)(_series.series, {
            k: _Util.Any,
            v: _Util.Any
          }),
          lineColor: (0, _Util.Option)("string"),
          options: ChartOptions
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }, {
    key: "setEmptyMessage",
    value: function (message) {
      var options = void 0;
      var emptyMessage = message;
      options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, this.options.title, this.options.legend, emptyMessage);
      return new CompostLineAreaChart(this.isArea, this.data, this.lineColor, options);
    }
  }, {
    key: "setTitle",
    value: function (title) {
      var options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, title, this.options.legend, this.options.emptyMessage);
      return new CompostLineAreaChart(this.isArea, this.data, this.lineColor, options);
    }
  }, {
    key: "setLegend",
    value: function (position) {
      var options = void 0;
      var legend = new LegendOptions(position);
      options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, this.options.title, legend, this.options.emptyMessage);
      return new CompostLineAreaChart(this.isArea, this.data, this.lineColor, options);
    }
  }, {
    key: "setSize",
    value: function (width, height) {
      var options = new ChartOptions([CompostHelpers.orElse(width, this.options.size[0]), CompostHelpers.orElse(height, this.options.size[1])], this.options.xAxis, this.options.yAxis, this.options.title, this.options.legend, this.options.emptyMessage);
      return new CompostLineAreaChart(this.isArea, this.data, this.lineColor, options);
    }
  }, {
    key: "setAxisX",
    value: function (minValue, maxValue, label, labelOffset, labelMinimalSize) {
      var ax = void 0;
      var inputRecord = this.options.xAxis;
      ax = new AxisOptions(CompostHelpers.orElse(minValue, this.options.xAxis.minValue), CompostHelpers.orElse(maxValue, this.options.xAxis.maxValue), CompostHelpers.orElse(label, this.options.xAxis.label), CompostHelpers.orElse(labelOffset, this.options.xAxis.labelOffset), CompostHelpers.orElse(labelMinimalSize, this.options.xAxis.labelMinimalSize));
      var options = new ChartOptions(this.options.size, ax, this.options.yAxis, this.options.title, this.options.legend, this.options.emptyMessage);
      return new CompostLineAreaChart(this.isArea, this.data, this.lineColor, options);
    }
  }, {
    key: "setAxisY",
    value: function (minValue, maxValue, label, labelOffset, labelMinimalSize) {
      var ax = void 0;
      var inputRecord = this.options.yAxis;
      ax = new AxisOptions(CompostHelpers.orElse(minValue, this.options.yAxis.minValue), CompostHelpers.orElse(maxValue, this.options.yAxis.maxValue), CompostHelpers.orElse(label, this.options.yAxis.label), CompostHelpers.orElse(labelOffset, this.options.yAxis.labelOffset), CompostHelpers.orElse(labelMinimalSize, this.options.yAxis.labelMinimalSize));
      var options = new ChartOptions(this.options.size, this.options.xAxis, ax, this.options.title, this.options.legend, this.options.emptyMessage);
      return new CompostLineAreaChart(this.isArea, this.data, this.lineColor, options);
    }
  }, {
    key: "setColors",
    value: function (lineColor) {
      var lineColor_1 = lineColor != null ? lineColor : this.lineColor;
      return new CompostLineAreaChart(this.isArea, this.data, lineColor_1, this.options);
    }
  }, {
    key: "show",
    value: function (outputId) {
      var _this7 = this;

      InteractiveHelpers.showStaticApp(outputId, this.options, this.data, function (data) {
        return function (size) {
          var lc = (0, _Util.defaultArg)(_this7.lineColor, "#1f77b4");
          var lcs = [lc];
          var labels = (0, _List.ofArray)(["Data"]);
          var data_1 = [data];
          return Charts.renderLines(_this7.isArea, _this7.options, size[0], size[1], lcs, labels, data_1);
        };
      });
    }
  }]);
  return CompostLineAreaChart;
}();

(0, _Symbol2.setType)("TheGamma.Interactive.CompostLineAreaChart", CompostLineAreaChart);

var CompostLinesAreasChart = exports.CompostLinesAreasChart = function () {
  function CompostLinesAreasChart(isArea, data, lineColors, options) {
    (0, _classCallCheck3.default)(this, CompostLinesAreasChart);
    this.isArea = isArea;
    this.data = data;
    this.lineColors = lineColors;
    this.options = options;
  }

  (0, _createClass3.default)(CompostLinesAreasChart, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.CompostLinesAreasChart",
        interfaces: ["FSharpRecord", "System.IEquatable"],
        properties: {
          isArea: "boolean",
          data: (0, _Util.Array)((0, _Util.makeGeneric)(_series.series, {
            k: _Util.Any,
            v: _Util.Any
          })),
          lineColors: (0, _Util.Option)((0, _Util.Array)("string")),
          options: ChartOptions
        }
      };
    }
  }, {
    key: "Equals",
    value: function (other) {
      return (0, _Util.equalsRecords)(this, other);
    }
  }, {
    key: "setEmptyMessage",
    value: function (message) {
      var options = void 0;
      var emptyMessage = message;
      options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, this.options.title, this.options.legend, emptyMessage);
      return new CompostLinesAreasChart(this.isArea, this.data, this.lineColors, options);
    }
  }, {
    key: "setTitle",
    value: function (title) {
      var options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, title, this.options.legend, this.options.emptyMessage);
      return new CompostLinesAreasChart(this.isArea, this.data, this.lineColors, options);
    }
  }, {
    key: "setLegend",
    value: function (position) {
      var options = void 0;
      var legend = new LegendOptions(position);
      options = new ChartOptions(this.options.size, this.options.xAxis, this.options.yAxis, this.options.title, legend, this.options.emptyMessage);
      return new CompostLinesAreasChart(this.isArea, this.data, this.lineColors, options);
    }
  }, {
    key: "setSize",
    value: function (width, height) {
      var options = new ChartOptions([CompostHelpers.orElse(width, this.options.size[0]), CompostHelpers.orElse(height, this.options.size[1])], this.options.xAxis, this.options.yAxis, this.options.title, this.options.legend, this.options.emptyMessage);
      return new CompostLinesAreasChart(this.isArea, this.data, this.lineColors, options);
    }
  }, {
    key: "setAxisX",
    value: function (minValue, maxValue, label, labelOffset, labelMinimalSize) {
      var ax = void 0;
      var inputRecord = this.options.xAxis;
      ax = new AxisOptions(CompostHelpers.orElse(minValue, this.options.xAxis.minValue), CompostHelpers.orElse(maxValue, this.options.xAxis.maxValue), CompostHelpers.orElse(label, this.options.xAxis.label), CompostHelpers.orElse(labelOffset, this.options.xAxis.labelOffset), CompostHelpers.orElse(labelMinimalSize, this.options.xAxis.labelMinimalSize));
      var options = new ChartOptions(this.options.size, ax, this.options.yAxis, this.options.title, this.options.legend, this.options.emptyMessage);
      return new CompostLinesAreasChart(this.isArea, this.data, this.lineColors, options);
    }
  }, {
    key: "setAxisY",
    value: function (minValue, maxValue, label, labelOffset, labelMinimalSize) {
      var ax = void 0;
      var inputRecord = this.options.yAxis;
      ax = new AxisOptions(CompostHelpers.orElse(minValue, this.options.yAxis.minValue), CompostHelpers.orElse(maxValue, this.options.yAxis.maxValue), CompostHelpers.orElse(label, this.options.yAxis.label), CompostHelpers.orElse(labelOffset, this.options.yAxis.labelOffset), CompostHelpers.orElse(labelMinimalSize, this.options.yAxis.labelMinimalSize));
      var options = new ChartOptions(this.options.size, this.options.xAxis, ax, this.options.title, this.options.legend, this.options.emptyMessage);
      return new CompostLinesAreasChart(this.isArea, this.data, this.lineColors, options);
    }
  }, {
    key: "setColors",
    value: function (lineColors) {
      var lineColors_1 = lineColors != null ? lineColors : this.lineColors;
      return new CompostLinesAreasChart(this.isArea, this.data, lineColors_1, this.options);
    }
  }, {
    key: "show",
    value: function (outputId) {
      var _this8 = this;

      (function (arg00) {
        (0, _Async.startImmediate)(arg00);
      })(function (builder_) {
        return builder_.Delay(function () {
          return builder_.Bind((0, _Async.parallel)((0, _Seq.toList)((0, _Seq.delay)(function () {
            return (0, _Seq.map)(function (d) {
              return (0, _common.Async$2E$AwaitFuture$2E$Static)(d.data);
            }, _this8.data);
          }))), function (_arg1) {
            var allData = (0, _Seq.fold)(function (s1, s2) {
              return s1.append(s2);
            }, _series.series.create(_AsyncBuilder.singleton.Return([]), "", "", ""), _this8.data);
            return builder_.ReturnFrom(InteractiveHelpers.showStaticAppAsync(outputId, _this8.options, allData, function (size) {
              var lcs = (0, _Util.defaultArg)(_this8.lineColors, CompostHelpers.vega10);
              var lcs_1 = lcs;
              var labels = (0, _Seq.map)(function (s) {
                return s.seriesName;
              }, _this8.data);
              return Charts.renderLines(_this8.isArea, _this8.options, size[0], size[1], lcs_1, labels, _arg1);
            }));
          });
        });
      }(_AsyncBuilder.singleton));
    }
  }]);
  return CompostLinesAreasChart;
}();

(0, _Symbol2.setType)("TheGamma.Interactive.CompostLinesAreasChart", CompostLinesAreasChart);

var CompostCharts = exports.CompostCharts = function () {
  (0, _createClass3.default)(CompostCharts, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.CompostCharts",
        properties: {}
      };
    }
  }]);

  function CompostCharts() {
    (0, _classCallCheck3.default)(this, CompostCharts);
  }

  (0, _createClass3.default)(CompostCharts, [{
    key: "bubbles",
    value: function (data) {
      return new CompostBubblesChart(data);
    }
  }, {
    key: "line",
    value: function (data) {
      var data_1 = data;
      var lineColor = null;
      var options = ChartOptions.Default;
      return new CompostLineAreaChart(false, data_1, lineColor, options);
    }
  }, {
    key: "area",
    value: function (data) {
      var data_1 = data;
      var lineColor = null;
      var options = ChartOptions.Default;
      return new CompostLineAreaChart(true, data_1, lineColor, options);
    }
  }, {
    key: "lines",
    value: function (data) {
      var data_1 = data;
      var lineColors = null;
      var options = ChartOptions.Default;
      return new CompostLinesAreasChart(false, data_1, lineColors, options);
    }
  }, {
    key: "areas",
    value: function (data) {
      var data_1 = data;
      var lineColors = null;
      var options = ChartOptions.Default;
      return new CompostLinesAreasChart(true, data_1, lineColors, options);
    }
  }, {
    key: "bar",
    value: function (data) {
      var colors = null;
      var options = ChartOptions.Default;
      return new CompostColBarChart(true, data, colors, false, options);
    }
  }, {
    key: "column",
    value: function (data) {
      var colors = null;
      var options = ChartOptions.Default;
      return new CompostColBarChart(false, data, colors, false, options);
    }
  }]);
  return CompostCharts;
}();

(0, _Symbol2.setType)("TheGamma.Interactive.CompostCharts", CompostCharts);

var compost = exports.compost = function () {
  function compost() {
    (0, _classCallCheck3.default)(this, compost);
  }

  (0, _createClass3.default)(compost, [{
    key: _Symbol3.default.reflection,
    value: function () {
      return {
        type: "TheGamma.Interactive.compost",
        properties: {
          charts: CompostCharts
        }
      };
    }
  }], [{
    key: "charts",
    get: function () {
      return new CompostCharts();
    }
  }]);
  return compost;
}();

(0, _Symbol2.setType)("TheGamma.Interactive.compost", compost);
//# sourceMappingURL=interactive.js.map