import _Array$from from "babel-runtime/core-js/array/from";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { Helpers, ChartData } from "./core";
import { LabelStyle, Trendline, ChartBoundingBox, ChartViewWindow, ChartGridlines, ChartStroke, ChartCrosshairSelected, ChartCrosshairFocused, ChartAnnotations, ChartBoxStyle, ChartBoxStyleGradient, CandlestickCandlestick, CandlestickChartOptions, TimelineTimeline, TimelineOptions, CssClassNames, TableOptions, TreeMapOptions, ChartBubble, BubbleChartOptions, PieChartOptions, SteppedAreaChartOptions, AnnotationChartOptions, AreaChartOptions, HistogramHistogram, HistogramOptions, BarChartOptions, LineChartOptions, GroupWidth, ColumnChartOptions, ChartTextStyle, ChartAxis, ChartExplorer, ChartCrosshair, ChartArea, TransitionAnimation, ScatterChartOptions, ChartTooltip, ChartSizeAxis, GeoChartMagnifyingGlass, ChartLegend, ChartColorAxis, GeoChartOptions } from "./options";
import { defaultArg } from "fable-core/Util";
export var Geo = function () {
  function Geo(data, typeName, options) {
    _classCallCheck(this, Geo);

    this.data = data;
    this.typeName = typeName;
    this.options = options;
  }

  _createClass(Geo, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.Extensions.Geo",
        interfaces: ["FSharpRecord", "TheGamma.GoogleCharts.Chart"],
        properties: {
          data: ChartData,
          typeName: "string",
          options: GeoChartOptions
        }
      };
    }
  }, {
    key: "show",
    value: function (outputId) {
      Helpers.showChart(this, outputId);
    }
  }, {
    key: "set",
    value: function (backgroundColor, datalessRegionColor, displayMode, enableRegionInteractivity, height, keepAspectRatio, region, markerOpacity, resolution, width) {
      var newOptions = void 0;
      var backgroundColor_1 = Helpers.right(this.options, "backgroundColor", backgroundColor);
      var datalessRegionColor_1 = Helpers.right(this.options, "datalessRegionColor", datalessRegionColor);
      var displayMode_1 = Helpers.right(this.options, "displayMode", displayMode);
      var enableRegionInteractivity_1 = Helpers.right(this.options, "enableRegionInteractivity", enableRegionInteractivity);
      var height_1 = Helpers.right(this.options, "height", height);
      var keepAspectRatio_1 = Helpers.right(this.options, "keepAspectRatio", keepAspectRatio);
      var region_1 = Helpers.right(this.options, "region", region);
      var markerOpacity_1 = Helpers.right(this.options, "markerOpacity", markerOpacity);
      var resolution_1 = Helpers.right(this.options, "resolution", resolution);
      var width_1 = Helpers.right(this.options, "width", width);
      newOptions = new GeoChartOptions(backgroundColor_1, this.options.colorAxis, datalessRegionColor_1, displayMode_1, enableRegionInteractivity_1, height_1, keepAspectRatio_1, this.options.legend, region_1, this.options.magnifyingGlass, markerOpacity_1, resolution_1, this.options.sizeAxis, this.options.tooltip, width_1);
      return new Geo(this.data, this.typeName, newOptions);
    }
  }, {
    key: "colorAxis",
    value: function (minValue, maxValue, values, colors) {
      var o = this.options.colorAxis;
      var newNested = new ChartColorAxis(Helpers.right(o, "minValue", minValue), Helpers.right(o, "maxValue", maxValue), Helpers.right(o, "values", defaultArg(values, null, function (source) {
        return Float64Array.from(source);
      })), Helpers.right(o, "colors", defaultArg(colors, null, function (source_1) {
        return _Array$from(source_1);
      })), Helpers.copy(o, "legend"));
      var options = new GeoChartOptions(this.options.backgroundColor, newNested, this.options.datalessRegionColor, this.options.displayMode, this.options.enableRegionInteractivity, this.options.height, this.options.keepAspectRatio, this.options.legend, this.options.region, this.options.magnifyingGlass, this.options.markerOpacity, this.options.resolution, this.options.sizeAxis, this.options.tooltip, this.options.width);
      return new Geo(this.data, this.typeName, options);
    }
  }, {
    key: "legend",
    value: function (alignment, maxLines, position, numberFormat) {
      var o = this.options.legend;
      var newNested = void 0;
      var alignment_1 = Helpers.right(o, "alignment", alignment);
      var maxLines_1 = Helpers.right(o, "maxLines", maxLines);
      var position_1 = Helpers.right(o, "position", position);
      var numberFormat_1 = Helpers.right(o, "numberFormat", numberFormat);
      newNested = new ChartLegend(alignment_1, maxLines_1, position_1, Helpers.copy(o, "textStyle"), numberFormat_1);
      var options = new GeoChartOptions(this.options.backgroundColor, this.options.colorAxis, this.options.datalessRegionColor, this.options.displayMode, this.options.enableRegionInteractivity, this.options.height, this.options.keepAspectRatio, newNested, this.options.region, this.options.magnifyingGlass, this.options.markerOpacity, this.options.resolution, this.options.sizeAxis, this.options.tooltip, this.options.width);
      return new Geo(this.data, this.typeName, options);
    }
  }, {
    key: "magnifyingGlass",
    value: function (enable, zoomFactor) {
      var o = this.options.magnifyingGlass;
      var newNested = new GeoChartMagnifyingGlass(Helpers.right(o, "enable", enable), Helpers.right(o, "zoomFactor", zoomFactor));
      var options = new GeoChartOptions(this.options.backgroundColor, this.options.colorAxis, this.options.datalessRegionColor, this.options.displayMode, this.options.enableRegionInteractivity, this.options.height, this.options.keepAspectRatio, this.options.legend, this.options.region, newNested, this.options.markerOpacity, this.options.resolution, this.options.sizeAxis, this.options.tooltip, this.options.width);
      return new Geo(this.data, this.typeName, options);
    }
  }, {
    key: "sizeAxis",
    value: function (maxSize, maxValue, minSize, minValue) {
      var o = this.options.sizeAxis;
      var newNested = new ChartSizeAxis(Helpers.right(o, "maxSize", maxSize), Helpers.right(o, "maxValue", maxValue), Helpers.right(o, "minSize", minSize), Helpers.right(o, "minValue", minValue));
      var options = new GeoChartOptions(this.options.backgroundColor, this.options.colorAxis, this.options.datalessRegionColor, this.options.displayMode, this.options.enableRegionInteractivity, this.options.height, this.options.keepAspectRatio, this.options.legend, this.options.region, this.options.magnifyingGlass, this.options.markerOpacity, this.options.resolution, newNested, this.options.tooltip, this.options.width);
      return new Geo(this.data, this.typeName, options);
    }
  }, {
    key: "tooltip",
    value: function (isHtml, showColorCode, trigger) {
      var o = this.options.tooltip;
      var newNested = void 0;
      var isHtml_1 = Helpers.right(o, "isHtml", isHtml);
      var showColorCode_1 = Helpers.right(o, "showColorCode", showColorCode);
      var trigger_1 = Helpers.right(o, "trigger", trigger);
      newNested = new ChartTooltip(isHtml_1, showColorCode_1, Helpers.copy(o, "textStyle"), trigger_1);
      var options = new GeoChartOptions(this.options.backgroundColor, this.options.colorAxis, this.options.datalessRegionColor, this.options.displayMode, this.options.enableRegionInteractivity, this.options.height, this.options.keepAspectRatio, this.options.legend, this.options.region, this.options.magnifyingGlass, this.options.markerOpacity, this.options.resolution, this.options.sizeAxis, newNested, this.options.width);
      return new Geo(this.data, this.typeName, options);
    }
  }]);

  return Geo;
}();
setType("TheGamma.GoogleCharts.Extensions.Geo", Geo);

var Scatter = function () {
  function Scatter(data, typeName, options) {
    _classCallCheck(this, Scatter);

    this.data = data;
    this.typeName = typeName;
    this.options = options;
  }

  _createClass(Scatter, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.Extensions.Scatter",
        interfaces: ["FSharpRecord", "TheGamma.GoogleCharts.Chart"],
        properties: {
          data: ChartData,
          typeName: "string",
          options: ScatterChartOptions
        }
      };
    }
  }, {
    key: "show",
    value: function (outputId) {
      Helpers.showChart(this, outputId);
    }
  }, {
    key: "set",
    value: function (aggregationTarget, axisTitlesPosition, backgroundColor, colors, curveType, dataOpacity, enableInteractivity, fontSize, fontName, forceIFrame, height, lineWidth, pointSize, selectionMode, series, theme, title, titlePosition, width) {
      var newOptions = void 0;
      var aggregationTarget_1 = Helpers.right(this.options, "aggregationTarget", aggregationTarget);
      var axisTitlesPosition_1 = Helpers.right(this.options, "axisTitlesPosition", axisTitlesPosition);
      var backgroundColor_1 = Helpers.right(this.options, "backgroundColor", backgroundColor);
      var colors_1 = Helpers.right(this.options, "colors", defaultArg(colors, null, function (source) {
        return _Array$from(source);
      }));
      var curveType_1 = Helpers.right(this.options, "curveType", curveType);
      var dataOpacity_1 = Helpers.right(this.options, "dataOpacity", dataOpacity);
      var enableInteractivity_1 = Helpers.right(this.options, "enableInteractivity", enableInteractivity);
      var fontSize_1 = Helpers.right(this.options, "fontSize", fontSize);
      var fontName_1 = Helpers.right(this.options, "fontName", fontName);
      var forceIFrame_1 = Helpers.right(this.options, "forceIFrame", forceIFrame);
      var height_1 = Helpers.right(this.options, "height", height);
      var lineWidth_1 = Helpers.right(this.options, "lineWidth", lineWidth);
      var pointSize_1 = Helpers.right(this.options, "pointSize", pointSize);
      var selectionMode_1 = Helpers.right(this.options, "selectionMode", selectionMode);
      var series_1 = Helpers.right(this.options, "series", series);
      var theme_1 = Helpers.right(this.options, "theme", theme);
      var title_1 = Helpers.right(this.options, "title", title);
      var titlePosition_1 = Helpers.right(this.options, "titlePosition", titlePosition);
      var width_1 = Helpers.right(this.options, "width", width);
      newOptions = new ScatterChartOptions(aggregationTarget_1, this.options.animation, this.options.annotations, axisTitlesPosition_1, backgroundColor_1, this.options.chartArea, colors_1, this.options.crosshair, curveType_1, dataOpacity_1, enableInteractivity_1, this.options.explorer, fontSize_1, fontName_1, forceIFrame_1, this.options.hAxis, height_1, this.options.legend, lineWidth_1, pointSize_1, selectionMode_1, series_1, theme_1, title_1, titlePosition_1, this.options.titleTextStyle, this.options.tooltip, this.options.trendlines, this.options.vAxis, width_1);
      return new Scatter(this.data, this.typeName, newOptions);
    }
  }, {
    key: "trendlines",
    value: function (_trendlines) {
      var options = void 0;
      var trendlines_1 = Helpers.right(this.options, "trendlines", defaultArg(_trendlines, null, function (source) {
        return _Array$from(source);
      }));
      options = new ScatterChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, this.options.legend, this.options.lineWidth, this.options.pointSize, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, trendlines_1, this.options.vAxis, this.options.width);
      return new Scatter(this.data, this.typeName, options);
    }
  }, {
    key: "animation",
    value: function (duration, easing) {
      var o = this.options.animation;
      var newNested = new TransitionAnimation(Helpers.right(o, "duration", duration), Helpers.right(o, "easing", easing));
      var options = new ScatterChartOptions(this.options.aggregationTarget, newNested, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, this.options.legend, this.options.lineWidth, this.options.pointSize, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.trendlines, this.options.vAxis, this.options.width);
      return new Scatter(this.data, this.typeName, options);
    }
  }, {
    key: "chartArea",
    value: function (top, left, width, height) {
      var o = this.options.chartArea;
      var newNested = new ChartArea(Helpers.right(o, "top", top), Helpers.right(o, "left", left), Helpers.right(o, "width", width), Helpers.right(o, "height", height));
      var options = new ScatterChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, newNested, this.options.colors, this.options.crosshair, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, this.options.legend, this.options.lineWidth, this.options.pointSize, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.trendlines, this.options.vAxis, this.options.width);
      return new Scatter(this.data, this.typeName, options);
    }
  }, {
    key: "crosshair",
    value: function (color, opacity, orientation, trigger) {
      var o = this.options.crosshair;
      var newNested = void 0;
      var color_1 = Helpers.right(o, "color", color);
      var opacity_1 = Helpers.right(o, "opacity", opacity);
      var orientation_1 = Helpers.right(o, "orientation", orientation);
      var trigger_1 = Helpers.right(o, "trigger", trigger);
      newNested = new ChartCrosshair(color_1, Helpers.copy(o, "focused"), opacity_1, orientation_1, Helpers.copy(o, "selected"), trigger_1);
      var options = new ScatterChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, newNested, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, this.options.legend, this.options.lineWidth, this.options.pointSize, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.trendlines, this.options.vAxis, this.options.width);
      return new Scatter(this.data, this.typeName, options);
    }
  }, {
    key: "explorer",
    value: function (actions, axis, keepInBounds, maxZoomIn, maxZoomOut, zoomDelta) {
      var o = this.options.explorer;
      var newNested = new ChartExplorer(Helpers.right(o, "actions", defaultArg(actions, null, function (source) {
        return _Array$from(source);
      })), Helpers.right(o, "axis", axis), Helpers.right(o, "keepInBounds", keepInBounds), Helpers.right(o, "maxZoomIn", maxZoomIn), Helpers.right(o, "maxZoomOut", maxZoomOut), Helpers.right(o, "zoomDelta", zoomDelta));
      var options = new ScatterChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, newNested, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, this.options.legend, this.options.lineWidth, this.options.pointSize, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.trendlines, this.options.vAxis, this.options.width);
      return new Scatter(this.data, this.typeName, options);
    }
  }, {
    key: "hAxis",
    value: function (baseline, baselineColor, direction, format, logScale, textPosition, ticks, title, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode) {
      var o = this.options.hAxis;
      var newNested = void 0;
      var baseline_1 = Helpers.right(o, "baseline", baseline);
      var baselineColor_1 = Helpers.right(o, "baselineColor", baselineColor);
      var direction_1 = Helpers.right(o, "direction", direction);
      var format_1 = Helpers.right(o, "format", format);
      var logScale_1 = Helpers.right(o, "logScale", logScale);
      var textPosition_1 = Helpers.right(o, "textPosition", textPosition);
      var ticks_1 = Helpers.right(o, "ticks", defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      }));
      var title_1 = Helpers.right(o, "title", title);
      var allowContainerBoundaryTextCufoff_1 = Helpers.right(o, "allowContainerBoundaryTextCufoff", allowContainerBoundaryTextCufoff);
      var slantedText_1 = Helpers.right(o, "slantedText", slantedText);
      var slantedTextAngle_1 = Helpers.right(o, "slantedTextAngle", slantedTextAngle);
      var maxAlternation_1 = Helpers.right(o, "maxAlternation", maxAlternation);
      var maxTextLines_1 = Helpers.right(o, "maxTextLines", maxTextLines);
      var minTextSpacing_1 = Helpers.right(o, "minTextSpacing", minTextSpacing);
      var showTextEvery_1 = Helpers.right(o, "showTextEvery", showTextEvery);
      var maxValue_1 = Helpers.right(o, "maxValue", maxValue);
      var minValue_1 = Helpers.right(o, "minValue", minValue);
      var viewWindowMode_1 = Helpers.right(o, "viewWindowMode", viewWindowMode);
      newNested = new ChartAxis(baseline_1, baselineColor_1, direction_1, format_1, Helpers.copy(o, "gridlines"), Helpers.copy(o, "minorGridlines"), logScale_1, textPosition_1, Helpers.copy(o, "textStyle"), ticks_1, title_1, Helpers.copy(o, "titleTextStyle"), allowContainerBoundaryTextCufoff_1, slantedText_1, slantedTextAngle_1, maxAlternation_1, maxTextLines_1, minTextSpacing_1, showTextEvery_1, maxValue_1, minValue_1, viewWindowMode_1, Helpers.copy(o, "viewWindow"));
      var options = new ScatterChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, newNested, this.options.height, this.options.legend, this.options.lineWidth, this.options.pointSize, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.trendlines, this.options.vAxis, this.options.width);
      return new Scatter(this.data, this.typeName, options);
    }
  }, {
    key: "legend",
    value: function (alignment, maxLines, position, numberFormat) {
      var o = this.options.legend;
      var newNested = void 0;
      var alignment_1 = Helpers.right(o, "alignment", alignment);
      var maxLines_1 = Helpers.right(o, "maxLines", maxLines);
      var position_1 = Helpers.right(o, "position", position);
      var numberFormat_1 = Helpers.right(o, "numberFormat", numberFormat);
      newNested = new ChartLegend(alignment_1, maxLines_1, position_1, Helpers.copy(o, "textStyle"), numberFormat_1);
      var options = new ScatterChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, newNested, this.options.lineWidth, this.options.pointSize, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.trendlines, this.options.vAxis, this.options.width);
      return new Scatter(this.data, this.typeName, options);
    }
  }, {
    key: "titleTextStyle",
    value: function (fontName, fontSize, bold, italic, color, auraColor, opacity) {
      var o = this.options.titleTextStyle;
      var newNested = new ChartTextStyle(Helpers.right(o, "fontName", fontName), Helpers.right(o, "fontSize", fontSize), Helpers.right(o, "bold", bold), Helpers.right(o, "italic", italic), Helpers.right(o, "color", color), Helpers.right(o, "auraColor", auraColor), Helpers.right(o, "opacity", opacity));
      var options = new ScatterChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, this.options.legend, this.options.lineWidth, this.options.pointSize, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, newNested, this.options.tooltip, this.options.trendlines, this.options.vAxis, this.options.width);
      return new Scatter(this.data, this.typeName, options);
    }
  }, {
    key: "tooltip",
    value: function (isHtml, showColorCode, trigger) {
      var o = this.options.tooltip;
      var newNested = void 0;
      var isHtml_1 = Helpers.right(o, "isHtml", isHtml);
      var showColorCode_1 = Helpers.right(o, "showColorCode", showColorCode);
      var trigger_1 = Helpers.right(o, "trigger", trigger);
      newNested = new ChartTooltip(isHtml_1, showColorCode_1, Helpers.copy(o, "textStyle"), trigger_1);
      var options = new ScatterChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, this.options.legend, this.options.lineWidth, this.options.pointSize, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, newNested, this.options.trendlines, this.options.vAxis, this.options.width);
      return new Scatter(this.data, this.typeName, options);
    }
  }, {
    key: "vAxis",
    value: function (baseline, baselineColor, direction, format, logScale, textPosition, ticks, title, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode) {
      var o = this.options.vAxis;
      var newNested = void 0;
      var baseline_1 = Helpers.right(o, "baseline", baseline);
      var baselineColor_1 = Helpers.right(o, "baselineColor", baselineColor);
      var direction_1 = Helpers.right(o, "direction", direction);
      var format_1 = Helpers.right(o, "format", format);
      var logScale_1 = Helpers.right(o, "logScale", logScale);
      var textPosition_1 = Helpers.right(o, "textPosition", textPosition);
      var ticks_1 = Helpers.right(o, "ticks", defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      }));
      var title_1 = Helpers.right(o, "title", title);
      var allowContainerBoundaryTextCufoff_1 = Helpers.right(o, "allowContainerBoundaryTextCufoff", allowContainerBoundaryTextCufoff);
      var slantedText_1 = Helpers.right(o, "slantedText", slantedText);
      var slantedTextAngle_1 = Helpers.right(o, "slantedTextAngle", slantedTextAngle);
      var maxAlternation_1 = Helpers.right(o, "maxAlternation", maxAlternation);
      var maxTextLines_1 = Helpers.right(o, "maxTextLines", maxTextLines);
      var minTextSpacing_1 = Helpers.right(o, "minTextSpacing", minTextSpacing);
      var showTextEvery_1 = Helpers.right(o, "showTextEvery", showTextEvery);
      var maxValue_1 = Helpers.right(o, "maxValue", maxValue);
      var minValue_1 = Helpers.right(o, "minValue", minValue);
      var viewWindowMode_1 = Helpers.right(o, "viewWindowMode", viewWindowMode);
      newNested = new ChartAxis(baseline_1, baselineColor_1, direction_1, format_1, Helpers.copy(o, "gridlines"), Helpers.copy(o, "minorGridlines"), logScale_1, textPosition_1, Helpers.copy(o, "textStyle"), ticks_1, title_1, Helpers.copy(o, "titleTextStyle"), allowContainerBoundaryTextCufoff_1, slantedText_1, slantedTextAngle_1, maxAlternation_1, maxTextLines_1, minTextSpacing_1, showTextEvery_1, maxValue_1, minValue_1, viewWindowMode_1, Helpers.copy(o, "viewWindow"));
      var options = new ScatterChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, this.options.legend, this.options.lineWidth, this.options.pointSize, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.trendlines, newNested, this.options.width);
      return new Scatter(this.data, this.typeName, options);
    }
  }]);

  return Scatter;
}();

export { Scatter };
setType("TheGamma.GoogleCharts.Extensions.Scatter", Scatter);
export var Column = function () {
  function Column(data, typeName, options) {
    _classCallCheck(this, Column);

    this.data = data;
    this.typeName = typeName;
    this.options = options;
  }

  _createClass(Column, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.Extensions.Column",
        interfaces: ["FSharpRecord", "TheGamma.GoogleCharts.Chart"],
        properties: {
          data: ChartData,
          typeName: "string",
          options: ColumnChartOptions
        }
      };
    }
  }, {
    key: "show",
    value: function (outputId) {
      Helpers.showChart(this, outputId);
    }
  }, {
    key: "set",
    value: function (aggregationTarget, axisTitlesPosition, backgroundColor, colors, enableInteractivity, focusTarget, fontSize, fontName, height, isStacked, reverseCategories, selectionMode, series, theme, title, titlePosition, vAxes, width) {
      var newOptions = void 0;
      var aggregationTarget_1 = Helpers.right(this.options, "aggregationTarget", aggregationTarget);
      var axisTitlesPosition_1 = Helpers.right(this.options, "axisTitlesPosition", axisTitlesPosition);
      var backgroundColor_1 = Helpers.right(this.options, "backgroundColor", backgroundColor);
      var colors_1 = Helpers.right(this.options, "colors", defaultArg(colors, null, function (source) {
        return _Array$from(source);
      }));
      var enableInteractivity_1 = Helpers.right(this.options, "enableInteractivity", enableInteractivity);
      var focusTarget_1 = Helpers.right(this.options, "focusTarget", focusTarget);
      var fontSize_1 = Helpers.right(this.options, "fontSize", fontSize);
      var fontName_1 = Helpers.right(this.options, "fontName", fontName);
      var height_1 = Helpers.right(this.options, "height", height);
      var isStacked_1 = Helpers.right(this.options, "isStacked", isStacked);
      var reverseCategories_1 = Helpers.right(this.options, "reverseCategories", reverseCategories);
      var selectionMode_1 = Helpers.right(this.options, "selectionMode", selectionMode);
      var series_1 = Helpers.right(this.options, "series", series);
      var theme_1 = Helpers.right(this.options, "theme", theme);
      var title_1 = Helpers.right(this.options, "title", title);
      var titlePosition_1 = Helpers.right(this.options, "titlePosition", titlePosition);
      var vAxes_1 = Helpers.right(this.options, "vAxes", vAxes);
      var width_1 = Helpers.right(this.options, "width", width);
      newOptions = new ColumnChartOptions(aggregationTarget_1, this.options.animation, this.options.annotations, axisTitlesPosition_1, backgroundColor_1, this.options.bar, this.options.chartArea, colors_1, enableInteractivity_1, focusTarget_1, fontSize_1, fontName_1, this.options.hAxis, height_1, isStacked_1, this.options.legend, reverseCategories_1, selectionMode_1, series_1, theme_1, title_1, titlePosition_1, this.options.titleTextStyle, this.options.tooltip, vAxes_1, this.options.vAxis, width_1);
      return new Column(this.data, this.typeName, newOptions);
    }
  }, {
    key: "animation",
    value: function (duration, easing) {
      var o = this.options.animation;
      var newNested = new TransitionAnimation(Helpers.right(o, "duration", duration), Helpers.right(o, "easing", easing));
      var options = new ColumnChartOptions(this.options.aggregationTarget, newNested, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Column(this.data, this.typeName, options);
    }
  }, {
    key: "bar",
    value: function (groupWidth) {
      var o = this.options.bar;
      var newNested = new GroupWidth(Helpers.right(o, "groupWidth", groupWidth));
      var options = new ColumnChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, newNested, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Column(this.data, this.typeName, options);
    }
  }, {
    key: "chartArea",
    value: function (top, left, width, height) {
      var o = this.options.chartArea;
      var newNested = new ChartArea(Helpers.right(o, "top", top), Helpers.right(o, "left", left), Helpers.right(o, "width", width), Helpers.right(o, "height", height));
      var options = new ColumnChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, newNested, this.options.colors, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Column(this.data, this.typeName, options);
    }
  }, {
    key: "hAxis",
    value: function (baseline, baselineColor, direction, format, logScale, textPosition, ticks, title, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode) {
      var o = this.options.hAxis;
      var newNested = void 0;
      var baseline_1 = Helpers.right(o, "baseline", baseline);
      var baselineColor_1 = Helpers.right(o, "baselineColor", baselineColor);
      var direction_1 = Helpers.right(o, "direction", direction);
      var format_1 = Helpers.right(o, "format", format);
      var logScale_1 = Helpers.right(o, "logScale", logScale);
      var textPosition_1 = Helpers.right(o, "textPosition", textPosition);
      var ticks_1 = Helpers.right(o, "ticks", defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      }));
      var title_1 = Helpers.right(o, "title", title);
      var allowContainerBoundaryTextCufoff_1 = Helpers.right(o, "allowContainerBoundaryTextCufoff", allowContainerBoundaryTextCufoff);
      var slantedText_1 = Helpers.right(o, "slantedText", slantedText);
      var slantedTextAngle_1 = Helpers.right(o, "slantedTextAngle", slantedTextAngle);
      var maxAlternation_1 = Helpers.right(o, "maxAlternation", maxAlternation);
      var maxTextLines_1 = Helpers.right(o, "maxTextLines", maxTextLines);
      var minTextSpacing_1 = Helpers.right(o, "minTextSpacing", minTextSpacing);
      var showTextEvery_1 = Helpers.right(o, "showTextEvery", showTextEvery);
      var maxValue_1 = Helpers.right(o, "maxValue", maxValue);
      var minValue_1 = Helpers.right(o, "minValue", minValue);
      var viewWindowMode_1 = Helpers.right(o, "viewWindowMode", viewWindowMode);
      newNested = new ChartAxis(baseline_1, baselineColor_1, direction_1, format_1, Helpers.copy(o, "gridlines"), Helpers.copy(o, "minorGridlines"), logScale_1, textPosition_1, Helpers.copy(o, "textStyle"), ticks_1, title_1, Helpers.copy(o, "titleTextStyle"), allowContainerBoundaryTextCufoff_1, slantedText_1, slantedTextAngle_1, maxAlternation_1, maxTextLines_1, minTextSpacing_1, showTextEvery_1, maxValue_1, minValue_1, viewWindowMode_1, Helpers.copy(o, "viewWindow"));
      var options = new ColumnChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, newNested, this.options.height, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Column(this.data, this.typeName, options);
    }
  }, {
    key: "legend",
    value: function (alignment, maxLines, position, numberFormat) {
      var o = this.options.legend;
      var newNested = void 0;
      var alignment_1 = Helpers.right(o, "alignment", alignment);
      var maxLines_1 = Helpers.right(o, "maxLines", maxLines);
      var position_1 = Helpers.right(o, "position", position);
      var numberFormat_1 = Helpers.right(o, "numberFormat", numberFormat);
      newNested = new ChartLegend(alignment_1, maxLines_1, position_1, Helpers.copy(o, "textStyle"), numberFormat_1);
      var options = new ColumnChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.isStacked, newNested, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Column(this.data, this.typeName, options);
    }
  }, {
    key: "titleTextStyle",
    value: function (fontName, fontSize, bold, italic, color, auraColor, opacity) {
      var o = this.options.titleTextStyle;
      var newNested = new ChartTextStyle(Helpers.right(o, "fontName", fontName), Helpers.right(o, "fontSize", fontSize), Helpers.right(o, "bold", bold), Helpers.right(o, "italic", italic), Helpers.right(o, "color", color), Helpers.right(o, "auraColor", auraColor), Helpers.right(o, "opacity", opacity));
      var options = new ColumnChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, newNested, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Column(this.data, this.typeName, options);
    }
  }, {
    key: "tooltip",
    value: function (isHtml, showColorCode, trigger) {
      var o = this.options.tooltip;
      var newNested = void 0;
      var isHtml_1 = Helpers.right(o, "isHtml", isHtml);
      var showColorCode_1 = Helpers.right(o, "showColorCode", showColorCode);
      var trigger_1 = Helpers.right(o, "trigger", trigger);
      newNested = new ChartTooltip(isHtml_1, showColorCode_1, Helpers.copy(o, "textStyle"), trigger_1);
      var options = new ColumnChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, newNested, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Column(this.data, this.typeName, options);
    }
  }, {
    key: "vAxis",
    value: function (baseline, baselineColor, direction, format, logScale, textPosition, ticks, title, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode) {
      var o = this.options.vAxis;
      var newNested = void 0;
      var baseline_1 = Helpers.right(o, "baseline", baseline);
      var baselineColor_1 = Helpers.right(o, "baselineColor", baselineColor);
      var direction_1 = Helpers.right(o, "direction", direction);
      var format_1 = Helpers.right(o, "format", format);
      var logScale_1 = Helpers.right(o, "logScale", logScale);
      var textPosition_1 = Helpers.right(o, "textPosition", textPosition);
      var ticks_1 = Helpers.right(o, "ticks", defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      }));
      var title_1 = Helpers.right(o, "title", title);
      var allowContainerBoundaryTextCufoff_1 = Helpers.right(o, "allowContainerBoundaryTextCufoff", allowContainerBoundaryTextCufoff);
      var slantedText_1 = Helpers.right(o, "slantedText", slantedText);
      var slantedTextAngle_1 = Helpers.right(o, "slantedTextAngle", slantedTextAngle);
      var maxAlternation_1 = Helpers.right(o, "maxAlternation", maxAlternation);
      var maxTextLines_1 = Helpers.right(o, "maxTextLines", maxTextLines);
      var minTextSpacing_1 = Helpers.right(o, "minTextSpacing", minTextSpacing);
      var showTextEvery_1 = Helpers.right(o, "showTextEvery", showTextEvery);
      var maxValue_1 = Helpers.right(o, "maxValue", maxValue);
      var minValue_1 = Helpers.right(o, "minValue", minValue);
      var viewWindowMode_1 = Helpers.right(o, "viewWindowMode", viewWindowMode);
      newNested = new ChartAxis(baseline_1, baselineColor_1, direction_1, format_1, Helpers.copy(o, "gridlines"), Helpers.copy(o, "minorGridlines"), logScale_1, textPosition_1, Helpers.copy(o, "textStyle"), ticks_1, title_1, Helpers.copy(o, "titleTextStyle"), allowContainerBoundaryTextCufoff_1, slantedText_1, slantedTextAngle_1, maxAlternation_1, maxTextLines_1, minTextSpacing_1, showTextEvery_1, maxValue_1, minValue_1, viewWindowMode_1, Helpers.copy(o, "viewWindow"));
      var options = new ColumnChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, newNested, this.options.width);
      return new Column(this.data, this.typeName, options);
    }
  }]);

  return Column;
}();
setType("TheGamma.GoogleCharts.Extensions.Column", Column);
export var Line = function () {
  function Line(data, typeName, options) {
    _classCallCheck(this, Line);

    this.data = data;
    this.typeName = typeName;
    this.options = options;
  }

  _createClass(Line, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.Extensions.Line",
        interfaces: ["FSharpRecord", "TheGamma.GoogleCharts.Chart"],
        properties: {
          data: ChartData,
          typeName: "string",
          options: LineChartOptions
        }
      };
    }
  }, {
    key: "show",
    value: function (outputId) {
      Helpers.showChart(this, outputId);
    }
  }, {
    key: "set",
    value: function (aggregationTarget, axisTitlesPosition, backgroundColor, colors, curveType, dataOpacity, enableInteractivity, focusTarget, fontSize, fontName, height, interpolateNulls, lineWidth, orientation, pointSize, reverseCategories, selectionMode, series, theme, title, titlePosition, vAxes, width) {
      var newOptions = void 0;
      var aggregationTarget_1 = Helpers.right(this.options, "aggregationTarget", aggregationTarget);
      var axisTitlesPosition_1 = Helpers.right(this.options, "axisTitlesPosition", axisTitlesPosition);
      var backgroundColor_1 = Helpers.right(this.options, "backgroundColor", backgroundColor);
      var colors_1 = Helpers.right(this.options, "colors", defaultArg(colors, null, function (source) {
        return _Array$from(source);
      }));
      var curveType_1 = Helpers.right(this.options, "curveType", curveType);
      var dataOpacity_1 = Helpers.right(this.options, "dataOpacity", dataOpacity);
      var enableInteractivity_1 = Helpers.right(this.options, "enableInteractivity", enableInteractivity);
      var focusTarget_1 = Helpers.right(this.options, "focusTarget", focusTarget);
      var fontSize_1 = Helpers.right(this.options, "fontSize", fontSize);
      var fontName_1 = Helpers.right(this.options, "fontName", fontName);
      var height_1 = Helpers.right(this.options, "height", height);
      var interpolateNulls_1 = Helpers.right(this.options, "interpolateNulls", interpolateNulls);
      var lineWidth_1 = Helpers.right(this.options, "lineWidth", lineWidth);
      var orientation_1 = Helpers.right(this.options, "orientation", orientation);
      var pointSize_1 = Helpers.right(this.options, "pointSize", pointSize);
      var reverseCategories_1 = Helpers.right(this.options, "reverseCategories", reverseCategories);
      var selectionMode_1 = Helpers.right(this.options, "selectionMode", selectionMode);
      var series_1 = Helpers.right(this.options, "series", series);
      var theme_1 = Helpers.right(this.options, "theme", theme);
      var title_1 = Helpers.right(this.options, "title", title);
      var titlePosition_1 = Helpers.right(this.options, "titlePosition", titlePosition);
      var vAxes_1 = Helpers.right(this.options, "vAxes", vAxes);
      var width_1 = Helpers.right(this.options, "width", width);
      newOptions = new LineChartOptions(aggregationTarget_1, this.options.animation, this.options.annotations, axisTitlesPosition_1, backgroundColor_1, this.options.chartArea, colors_1, this.options.crosshair, curveType_1, dataOpacity_1, enableInteractivity_1, this.options.explorer, focusTarget_1, fontSize_1, fontName_1, this.options.hAxis, height_1, interpolateNulls_1, this.options.legend, lineWidth_1, orientation_1, pointSize_1, reverseCategories_1, selectionMode_1, series_1, theme_1, title_1, titlePosition_1, this.options.titleTextStyle, this.options.tooltip, vAxes_1, this.options.vAxis, width_1);
      return new Line(this.data, this.typeName, newOptions);
    }
  }, {
    key: "animation",
    value: function (duration, easing) {
      var o = this.options.animation;
      var newNested = new TransitionAnimation(Helpers.right(o, "duration", duration), Helpers.right(o, "easing", easing));
      var options = new LineChartOptions(this.options.aggregationTarget, newNested, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.legend, this.options.lineWidth, this.options.orientation, this.options.pointSize, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Line(this.data, this.typeName, options);
    }
  }, {
    key: "chartArea",
    value: function (top, left, width, height) {
      var o = this.options.chartArea;
      var newNested = new ChartArea(Helpers.right(o, "top", top), Helpers.right(o, "left", left), Helpers.right(o, "width", width), Helpers.right(o, "height", height));
      var options = new LineChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, newNested, this.options.colors, this.options.crosshair, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.legend, this.options.lineWidth, this.options.orientation, this.options.pointSize, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Line(this.data, this.typeName, options);
    }
  }, {
    key: "crosshair",
    value: function (color, opacity, orientation, trigger) {
      var o = this.options.crosshair;
      var newNested = void 0;
      var color_1 = Helpers.right(o, "color", color);
      var opacity_1 = Helpers.right(o, "opacity", opacity);
      var orientation_1 = Helpers.right(o, "orientation", orientation);
      var trigger_1 = Helpers.right(o, "trigger", trigger);
      newNested = new ChartCrosshair(color_1, Helpers.copy(o, "focused"), opacity_1, orientation_1, Helpers.copy(o, "selected"), trigger_1);
      var options = new LineChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, newNested, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.legend, this.options.lineWidth, this.options.orientation, this.options.pointSize, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Line(this.data, this.typeName, options);
    }
  }, {
    key: "explorer",
    value: function (actions, axis, keepInBounds, maxZoomIn, maxZoomOut, zoomDelta) {
      var o = this.options.explorer;
      var newNested = new ChartExplorer(Helpers.right(o, "actions", defaultArg(actions, null, function (source) {
        return _Array$from(source);
      })), Helpers.right(o, "axis", axis), Helpers.right(o, "keepInBounds", keepInBounds), Helpers.right(o, "maxZoomIn", maxZoomIn), Helpers.right(o, "maxZoomOut", maxZoomOut), Helpers.right(o, "zoomDelta", zoomDelta));
      var options = new LineChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, newNested, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.legend, this.options.lineWidth, this.options.orientation, this.options.pointSize, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Line(this.data, this.typeName, options);
    }
  }, {
    key: "hAxis",
    value: function (baseline, baselineColor, direction, format, logScale, textPosition, ticks, title, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode) {
      var o = this.options.hAxis;
      var newNested = void 0;
      var baseline_1 = Helpers.right(o, "baseline", baseline);
      var baselineColor_1 = Helpers.right(o, "baselineColor", baselineColor);
      var direction_1 = Helpers.right(o, "direction", direction);
      var format_1 = Helpers.right(o, "format", format);
      var logScale_1 = Helpers.right(o, "logScale", logScale);
      var textPosition_1 = Helpers.right(o, "textPosition", textPosition);
      var ticks_1 = Helpers.right(o, "ticks", defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      }));
      var title_1 = Helpers.right(o, "title", title);
      var allowContainerBoundaryTextCufoff_1 = Helpers.right(o, "allowContainerBoundaryTextCufoff", allowContainerBoundaryTextCufoff);
      var slantedText_1 = Helpers.right(o, "slantedText", slantedText);
      var slantedTextAngle_1 = Helpers.right(o, "slantedTextAngle", slantedTextAngle);
      var maxAlternation_1 = Helpers.right(o, "maxAlternation", maxAlternation);
      var maxTextLines_1 = Helpers.right(o, "maxTextLines", maxTextLines);
      var minTextSpacing_1 = Helpers.right(o, "minTextSpacing", minTextSpacing);
      var showTextEvery_1 = Helpers.right(o, "showTextEvery", showTextEvery);
      var maxValue_1 = Helpers.right(o, "maxValue", maxValue);
      var minValue_1 = Helpers.right(o, "minValue", minValue);
      var viewWindowMode_1 = Helpers.right(o, "viewWindowMode", viewWindowMode);
      newNested = new ChartAxis(baseline_1, baselineColor_1, direction_1, format_1, Helpers.copy(o, "gridlines"), Helpers.copy(o, "minorGridlines"), logScale_1, textPosition_1, Helpers.copy(o, "textStyle"), ticks_1, title_1, Helpers.copy(o, "titleTextStyle"), allowContainerBoundaryTextCufoff_1, slantedText_1, slantedTextAngle_1, maxAlternation_1, maxTextLines_1, minTextSpacing_1, showTextEvery_1, maxValue_1, minValue_1, viewWindowMode_1, Helpers.copy(o, "viewWindow"));
      var options = new LineChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.focusTarget, this.options.fontSize, this.options.fontName, newNested, this.options.height, this.options.interpolateNulls, this.options.legend, this.options.lineWidth, this.options.orientation, this.options.pointSize, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Line(this.data, this.typeName, options);
    }
  }, {
    key: "legend",
    value: function (alignment, maxLines, position, numberFormat) {
      var o = this.options.legend;
      var newNested = void 0;
      var alignment_1 = Helpers.right(o, "alignment", alignment);
      var maxLines_1 = Helpers.right(o, "maxLines", maxLines);
      var position_1 = Helpers.right(o, "position", position);
      var numberFormat_1 = Helpers.right(o, "numberFormat", numberFormat);
      newNested = new ChartLegend(alignment_1, maxLines_1, position_1, Helpers.copy(o, "textStyle"), numberFormat_1);
      var options = new LineChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, newNested, this.options.lineWidth, this.options.orientation, this.options.pointSize, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Line(this.data, this.typeName, options);
    }
  }, {
    key: "titleTextStyle",
    value: function (fontName, fontSize, bold, italic, color, auraColor, opacity) {
      var o = this.options.titleTextStyle;
      var newNested = new ChartTextStyle(Helpers.right(o, "fontName", fontName), Helpers.right(o, "fontSize", fontSize), Helpers.right(o, "bold", bold), Helpers.right(o, "italic", italic), Helpers.right(o, "color", color), Helpers.right(o, "auraColor", auraColor), Helpers.right(o, "opacity", opacity));
      var options = new LineChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.legend, this.options.lineWidth, this.options.orientation, this.options.pointSize, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, newNested, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Line(this.data, this.typeName, options);
    }
  }, {
    key: "tooltip",
    value: function (isHtml, showColorCode, trigger) {
      var o = this.options.tooltip;
      var newNested = void 0;
      var isHtml_1 = Helpers.right(o, "isHtml", isHtml);
      var showColorCode_1 = Helpers.right(o, "showColorCode", showColorCode);
      var trigger_1 = Helpers.right(o, "trigger", trigger);
      newNested = new ChartTooltip(isHtml_1, showColorCode_1, Helpers.copy(o, "textStyle"), trigger_1);
      var options = new LineChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.legend, this.options.lineWidth, this.options.orientation, this.options.pointSize, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, newNested, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Line(this.data, this.typeName, options);
    }
  }, {
    key: "vAxis",
    value: function (baseline, baselineColor, direction, format, logScale, textPosition, ticks, title, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode) {
      var o = this.options.vAxis;
      var newNested = void 0;
      var baseline_1 = Helpers.right(o, "baseline", baseline);
      var baselineColor_1 = Helpers.right(o, "baselineColor", baselineColor);
      var direction_1 = Helpers.right(o, "direction", direction);
      var format_1 = Helpers.right(o, "format", format);
      var logScale_1 = Helpers.right(o, "logScale", logScale);
      var textPosition_1 = Helpers.right(o, "textPosition", textPosition);
      var ticks_1 = Helpers.right(o, "ticks", defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      }));
      var title_1 = Helpers.right(o, "title", title);
      var allowContainerBoundaryTextCufoff_1 = Helpers.right(o, "allowContainerBoundaryTextCufoff", allowContainerBoundaryTextCufoff);
      var slantedText_1 = Helpers.right(o, "slantedText", slantedText);
      var slantedTextAngle_1 = Helpers.right(o, "slantedTextAngle", slantedTextAngle);
      var maxAlternation_1 = Helpers.right(o, "maxAlternation", maxAlternation);
      var maxTextLines_1 = Helpers.right(o, "maxTextLines", maxTextLines);
      var minTextSpacing_1 = Helpers.right(o, "minTextSpacing", minTextSpacing);
      var showTextEvery_1 = Helpers.right(o, "showTextEvery", showTextEvery);
      var maxValue_1 = Helpers.right(o, "maxValue", maxValue);
      var minValue_1 = Helpers.right(o, "minValue", minValue);
      var viewWindowMode_1 = Helpers.right(o, "viewWindowMode", viewWindowMode);
      newNested = new ChartAxis(baseline_1, baselineColor_1, direction_1, format_1, Helpers.copy(o, "gridlines"), Helpers.copy(o, "minorGridlines"), logScale_1, textPosition_1, Helpers.copy(o, "textStyle"), ticks_1, title_1, Helpers.copy(o, "titleTextStyle"), allowContainerBoundaryTextCufoff_1, slantedText_1, slantedTextAngle_1, maxAlternation_1, maxTextLines_1, minTextSpacing_1, showTextEvery_1, maxValue_1, minValue_1, viewWindowMode_1, Helpers.copy(o, "viewWindow"));
      var options = new LineChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.curveType, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.legend, this.options.lineWidth, this.options.orientation, this.options.pointSize, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, newNested, this.options.width);
      return new Line(this.data, this.typeName, options);
    }
  }]);

  return Line;
}();
setType("TheGamma.GoogleCharts.Extensions.Line", Line);
export var Bar = function () {
  function Bar(data, typeName, options) {
    _classCallCheck(this, Bar);

    this.data = data;
    this.typeName = typeName;
    this.options = options;
  }

  _createClass(Bar, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.Extensions.Bar",
        interfaces: ["FSharpRecord", "TheGamma.GoogleCharts.Chart"],
        properties: {
          data: ChartData,
          typeName: "string",
          options: BarChartOptions
        }
      };
    }
  }, {
    key: "show",
    value: function (outputId) {
      Helpers.showChart(this, outputId);
    }
  }, {
    key: "set",
    value: function (aggregationTarget, axisTitlesPosition, backgroundColor, colors, dataOpacity, enableInteractivity, focusTarget, fontSize, fontName, hAxes, height, isStacked, reverseCategories, series, theme, title, titlePosition, vAxes, width) {
      var newOptions = void 0;
      var aggregationTarget_1 = Helpers.right(this.options, "aggregationTarget", aggregationTarget);
      var axisTitlesPosition_1 = Helpers.right(this.options, "axisTitlesPosition", axisTitlesPosition);
      var backgroundColor_1 = Helpers.right(this.options, "backgroundColor", backgroundColor);
      var colors_1 = Helpers.right(this.options, "colors", defaultArg(colors, null, function (source) {
        return _Array$from(source);
      }));
      var dataOpacity_1 = Helpers.right(this.options, "dataOpacity", dataOpacity);
      var enableInteractivity_1 = Helpers.right(this.options, "enableInteractivity", enableInteractivity);
      var focusTarget_1 = Helpers.right(this.options, "focusTarget", focusTarget);
      var fontSize_1 = Helpers.right(this.options, "fontSize", fontSize);
      var fontName_1 = Helpers.right(this.options, "fontName", fontName);
      var hAxes_1 = Helpers.right(this.options, "hAxes", hAxes);
      var height_1 = Helpers.right(this.options, "height", height);
      var isStacked_1 = Helpers.right(this.options, "isStacked", isStacked);
      var reverseCategories_1 = Helpers.right(this.options, "reverseCategories", reverseCategories);
      var series_1 = Helpers.right(this.options, "series", series);
      var theme_1 = Helpers.right(this.options, "theme", theme);
      var title_1 = Helpers.right(this.options, "title", title);
      var titlePosition_1 = Helpers.right(this.options, "titlePosition", titlePosition);
      var vAxes_1 = Helpers.right(this.options, "vAxes", vAxes);
      var width_1 = Helpers.right(this.options, "width", width);
      newOptions = new BarChartOptions(aggregationTarget_1, this.options.animation, this.options.annotations, axisTitlesPosition_1, backgroundColor_1, this.options.bar, this.options.chartArea, colors_1, dataOpacity_1, enableInteractivity_1, focusTarget_1, fontSize_1, fontName_1, hAxes_1, this.options.hAxis, height_1, isStacked_1, this.options.legend, reverseCategories_1, series_1, theme_1, title_1, titlePosition_1, this.options.titleTextStyle, this.options.tooltip, vAxes_1, this.options.vAxis, width_1);
      return new Bar(this.data, this.typeName, newOptions);
    }
  }, {
    key: "animation",
    value: function (duration, easing) {
      var o = this.options.animation;
      var newNested = new TransitionAnimation(Helpers.right(o, "duration", duration), Helpers.right(o, "easing", easing));
      var options = new BarChartOptions(this.options.aggregationTarget, newNested, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.dataOpacity, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxes, this.options.hAxis, this.options.height, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Bar(this.data, this.typeName, options);
    }
  }, {
    key: "bar",
    value: function (groupWidth) {
      var o = this.options.bar;
      var newNested = new GroupWidth(Helpers.right(o, "groupWidth", groupWidth));
      var options = new BarChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, newNested, this.options.chartArea, this.options.colors, this.options.dataOpacity, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxes, this.options.hAxis, this.options.height, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Bar(this.data, this.typeName, options);
    }
  }, {
    key: "chartArea",
    value: function (top, left, width, height) {
      var o = this.options.chartArea;
      var newNested = new ChartArea(Helpers.right(o, "top", top), Helpers.right(o, "left", left), Helpers.right(o, "width", width), Helpers.right(o, "height", height));
      var options = new BarChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, newNested, this.options.colors, this.options.dataOpacity, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxes, this.options.hAxis, this.options.height, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Bar(this.data, this.typeName, options);
    }
  }, {
    key: "hAxis",
    value: function (baseline, baselineColor, direction, format, logScale, textPosition, ticks, title, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode) {
      var o = this.options.hAxis;
      var newNested = void 0;
      var baseline_1 = Helpers.right(o, "baseline", baseline);
      var baselineColor_1 = Helpers.right(o, "baselineColor", baselineColor);
      var direction_1 = Helpers.right(o, "direction", direction);
      var format_1 = Helpers.right(o, "format", format);
      var logScale_1 = Helpers.right(o, "logScale", logScale);
      var textPosition_1 = Helpers.right(o, "textPosition", textPosition);
      var ticks_1 = Helpers.right(o, "ticks", defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      }));
      var title_1 = Helpers.right(o, "title", title);
      var allowContainerBoundaryTextCufoff_1 = Helpers.right(o, "allowContainerBoundaryTextCufoff", allowContainerBoundaryTextCufoff);
      var slantedText_1 = Helpers.right(o, "slantedText", slantedText);
      var slantedTextAngle_1 = Helpers.right(o, "slantedTextAngle", slantedTextAngle);
      var maxAlternation_1 = Helpers.right(o, "maxAlternation", maxAlternation);
      var maxTextLines_1 = Helpers.right(o, "maxTextLines", maxTextLines);
      var minTextSpacing_1 = Helpers.right(o, "minTextSpacing", minTextSpacing);
      var showTextEvery_1 = Helpers.right(o, "showTextEvery", showTextEvery);
      var maxValue_1 = Helpers.right(o, "maxValue", maxValue);
      var minValue_1 = Helpers.right(o, "minValue", minValue);
      var viewWindowMode_1 = Helpers.right(o, "viewWindowMode", viewWindowMode);
      newNested = new ChartAxis(baseline_1, baselineColor_1, direction_1, format_1, Helpers.copy(o, "gridlines"), Helpers.copy(o, "minorGridlines"), logScale_1, textPosition_1, Helpers.copy(o, "textStyle"), ticks_1, title_1, Helpers.copy(o, "titleTextStyle"), allowContainerBoundaryTextCufoff_1, slantedText_1, slantedTextAngle_1, maxAlternation_1, maxTextLines_1, minTextSpacing_1, showTextEvery_1, maxValue_1, minValue_1, viewWindowMode_1, Helpers.copy(o, "viewWindow"));
      var options = new BarChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.dataOpacity, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxes, newNested, this.options.height, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Bar(this.data, this.typeName, options);
    }
  }, {
    key: "legend",
    value: function (alignment, maxLines, position, numberFormat) {
      var o = this.options.legend;
      var newNested = void 0;
      var alignment_1 = Helpers.right(o, "alignment", alignment);
      var maxLines_1 = Helpers.right(o, "maxLines", maxLines);
      var position_1 = Helpers.right(o, "position", position);
      var numberFormat_1 = Helpers.right(o, "numberFormat", numberFormat);
      newNested = new ChartLegend(alignment_1, maxLines_1, position_1, Helpers.copy(o, "textStyle"), numberFormat_1);
      var options = new BarChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.dataOpacity, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxes, this.options.hAxis, this.options.height, this.options.isStacked, newNested, this.options.reverseCategories, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Bar(this.data, this.typeName, options);
    }
  }, {
    key: "titleTextStyle",
    value: function (fontName, fontSize, bold, italic, color, auraColor, opacity) {
      var o = this.options.titleTextStyle;
      var newNested = new ChartTextStyle(Helpers.right(o, "fontName", fontName), Helpers.right(o, "fontSize", fontSize), Helpers.right(o, "bold", bold), Helpers.right(o, "italic", italic), Helpers.right(o, "color", color), Helpers.right(o, "auraColor", auraColor), Helpers.right(o, "opacity", opacity));
      var options = new BarChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.dataOpacity, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxes, this.options.hAxis, this.options.height, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, newNested, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Bar(this.data, this.typeName, options);
    }
  }, {
    key: "tooltip",
    value: function (isHtml, showColorCode, trigger) {
      var o = this.options.tooltip;
      var newNested = void 0;
      var isHtml_1 = Helpers.right(o, "isHtml", isHtml);
      var showColorCode_1 = Helpers.right(o, "showColorCode", showColorCode);
      var trigger_1 = Helpers.right(o, "trigger", trigger);
      newNested = new ChartTooltip(isHtml_1, showColorCode_1, Helpers.copy(o, "textStyle"), trigger_1);
      var options = new BarChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.dataOpacity, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxes, this.options.hAxis, this.options.height, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, newNested, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Bar(this.data, this.typeName, options);
    }
  }, {
    key: "vAxis",
    value: function (baseline, baselineColor, direction, format, logScale, textPosition, ticks, title, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode) {
      var o = this.options.vAxis;
      var newNested = void 0;
      var baseline_1 = Helpers.right(o, "baseline", baseline);
      var baselineColor_1 = Helpers.right(o, "baselineColor", baselineColor);
      var direction_1 = Helpers.right(o, "direction", direction);
      var format_1 = Helpers.right(o, "format", format);
      var logScale_1 = Helpers.right(o, "logScale", logScale);
      var textPosition_1 = Helpers.right(o, "textPosition", textPosition);
      var ticks_1 = Helpers.right(o, "ticks", defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      }));
      var title_1 = Helpers.right(o, "title", title);
      var allowContainerBoundaryTextCufoff_1 = Helpers.right(o, "allowContainerBoundaryTextCufoff", allowContainerBoundaryTextCufoff);
      var slantedText_1 = Helpers.right(o, "slantedText", slantedText);
      var slantedTextAngle_1 = Helpers.right(o, "slantedTextAngle", slantedTextAngle);
      var maxAlternation_1 = Helpers.right(o, "maxAlternation", maxAlternation);
      var maxTextLines_1 = Helpers.right(o, "maxTextLines", maxTextLines);
      var minTextSpacing_1 = Helpers.right(o, "minTextSpacing", minTextSpacing);
      var showTextEvery_1 = Helpers.right(o, "showTextEvery", showTextEvery);
      var maxValue_1 = Helpers.right(o, "maxValue", maxValue);
      var minValue_1 = Helpers.right(o, "minValue", minValue);
      var viewWindowMode_1 = Helpers.right(o, "viewWindowMode", viewWindowMode);
      newNested = new ChartAxis(baseline_1, baselineColor_1, direction_1, format_1, Helpers.copy(o, "gridlines"), Helpers.copy(o, "minorGridlines"), logScale_1, textPosition_1, Helpers.copy(o, "textStyle"), ticks_1, title_1, Helpers.copy(o, "titleTextStyle"), allowContainerBoundaryTextCufoff_1, slantedText_1, slantedTextAngle_1, maxAlternation_1, maxTextLines_1, minTextSpacing_1, showTextEvery_1, maxValue_1, minValue_1, viewWindowMode_1, Helpers.copy(o, "viewWindow"));
      var options = new BarChartOptions(this.options.aggregationTarget, this.options.animation, this.options.annotations, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.dataOpacity, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxes, this.options.hAxis, this.options.height, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, newNested, this.options.width);
      return new Bar(this.data, this.typeName, options);
    }
  }]);

  return Bar;
}();
setType("TheGamma.GoogleCharts.Extensions.Bar", Bar);
export var Histogram = function () {
  function Histogram(data, typeName, options) {
    _classCallCheck(this, Histogram);

    this.data = data;
    this.typeName = typeName;
    this.options = options;
  }

  _createClass(Histogram, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.Extensions.Histogram",
        interfaces: ["FSharpRecord", "TheGamma.GoogleCharts.Chart"],
        properties: {
          data: ChartData,
          typeName: "string",
          options: HistogramOptions
        }
      };
    }
  }, {
    key: "show",
    value: function (outputId) {
      Helpers.showChart(this, outputId);
    }
  }, {
    key: "set",
    value: function (axisTitlesPosition, backgroundColor, colors, dataOpacity, enableInteractivity, focusTarget, fontSize, fontName, height, interpolateNulls, isStacked, orientation, reverseCategories, series, theme, title, titlePosition, vAxes, width) {
      var newOptions = void 0;
      var axisTitlesPosition_1 = Helpers.right(this.options, "axisTitlesPosition", axisTitlesPosition);
      var backgroundColor_1 = Helpers.right(this.options, "backgroundColor", backgroundColor);
      var colors_1 = Helpers.right(this.options, "colors", defaultArg(colors, null, function (source) {
        return _Array$from(source);
      }));
      var dataOpacity_1 = Helpers.right(this.options, "dataOpacity", dataOpacity);
      var enableInteractivity_1 = Helpers.right(this.options, "enableInteractivity", enableInteractivity);
      var focusTarget_1 = Helpers.right(this.options, "focusTarget", focusTarget);
      var fontSize_1 = Helpers.right(this.options, "fontSize", fontSize);
      var fontName_1 = Helpers.right(this.options, "fontName", fontName);
      var height_1 = Helpers.right(this.options, "height", height);
      var interpolateNulls_1 = Helpers.right(this.options, "interpolateNulls", interpolateNulls);
      var isStacked_1 = Helpers.right(this.options, "isStacked", isStacked);
      var orientation_1 = Helpers.right(this.options, "orientation", orientation);
      var reverseCategories_1 = Helpers.right(this.options, "reverseCategories", reverseCategories);
      var series_1 = Helpers.right(this.options, "series", series);
      var theme_1 = Helpers.right(this.options, "theme", theme);
      var title_1 = Helpers.right(this.options, "title", title);
      var titlePosition_1 = Helpers.right(this.options, "titlePosition", titlePosition);
      var vAxes_1 = Helpers.right(this.options, "vAxes", vAxes);
      var width_1 = Helpers.right(this.options, "width", width);
      newOptions = new HistogramOptions(this.options.animation, axisTitlesPosition_1, backgroundColor_1, this.options.bar, this.options.chartArea, colors_1, dataOpacity_1, enableInteractivity_1, focusTarget_1, fontSize_1, fontName_1, this.options.hAxis, this.options.histogram, height_1, interpolateNulls_1, isStacked_1, this.options.legend, orientation_1, reverseCategories_1, series_1, theme_1, title_1, titlePosition_1, this.options.titleTextStyle, this.options.tooltip, vAxes_1, this.options.vAxis, width_1);
      return new Histogram(this.data, this.typeName, newOptions);
    }
  }, {
    key: "animation",
    value: function (duration, easing) {
      var o = this.options.animation;
      var newNested = new TransitionAnimation(Helpers.right(o, "duration", duration), Helpers.right(o, "easing", easing));
      var options = new HistogramOptions(newNested, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.dataOpacity, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.histogram, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.orientation, this.options.reverseCategories, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Histogram(this.data, this.typeName, options);
    }
  }, {
    key: "bar",
    value: function (groupWidth) {
      var o = this.options.bar;
      var newNested = new GroupWidth(Helpers.right(o, "groupWidth", groupWidth));
      var options = new HistogramOptions(this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, newNested, this.options.chartArea, this.options.colors, this.options.dataOpacity, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.histogram, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.orientation, this.options.reverseCategories, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Histogram(this.data, this.typeName, options);
    }
  }, {
    key: "chartArea",
    value: function (top, left, width, height) {
      var o = this.options.chartArea;
      var newNested = new ChartArea(Helpers.right(o, "top", top), Helpers.right(o, "left", left), Helpers.right(o, "width", width), Helpers.right(o, "height", height));
      var options = new HistogramOptions(this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, newNested, this.options.colors, this.options.dataOpacity, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.histogram, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.orientation, this.options.reverseCategories, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Histogram(this.data, this.typeName, options);
    }
  }, {
    key: "hAxis",
    value: function (baseline, baselineColor, direction, format, logScale, textPosition, ticks, title, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode) {
      var o = this.options.hAxis;
      var newNested = void 0;
      var baseline_1 = Helpers.right(o, "baseline", baseline);
      var baselineColor_1 = Helpers.right(o, "baselineColor", baselineColor);
      var direction_1 = Helpers.right(o, "direction", direction);
      var format_1 = Helpers.right(o, "format", format);
      var logScale_1 = Helpers.right(o, "logScale", logScale);
      var textPosition_1 = Helpers.right(o, "textPosition", textPosition);
      var ticks_1 = Helpers.right(o, "ticks", defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      }));
      var title_1 = Helpers.right(o, "title", title);
      var allowContainerBoundaryTextCufoff_1 = Helpers.right(o, "allowContainerBoundaryTextCufoff", allowContainerBoundaryTextCufoff);
      var slantedText_1 = Helpers.right(o, "slantedText", slantedText);
      var slantedTextAngle_1 = Helpers.right(o, "slantedTextAngle", slantedTextAngle);
      var maxAlternation_1 = Helpers.right(o, "maxAlternation", maxAlternation);
      var maxTextLines_1 = Helpers.right(o, "maxTextLines", maxTextLines);
      var minTextSpacing_1 = Helpers.right(o, "minTextSpacing", minTextSpacing);
      var showTextEvery_1 = Helpers.right(o, "showTextEvery", showTextEvery);
      var maxValue_1 = Helpers.right(o, "maxValue", maxValue);
      var minValue_1 = Helpers.right(o, "minValue", minValue);
      var viewWindowMode_1 = Helpers.right(o, "viewWindowMode", viewWindowMode);
      newNested = new ChartAxis(baseline_1, baselineColor_1, direction_1, format_1, Helpers.copy(o, "gridlines"), Helpers.copy(o, "minorGridlines"), logScale_1, textPosition_1, Helpers.copy(o, "textStyle"), ticks_1, title_1, Helpers.copy(o, "titleTextStyle"), allowContainerBoundaryTextCufoff_1, slantedText_1, slantedTextAngle_1, maxAlternation_1, maxTextLines_1, minTextSpacing_1, showTextEvery_1, maxValue_1, minValue_1, viewWindowMode_1, Helpers.copy(o, "viewWindow"));
      var options = new HistogramOptions(this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.dataOpacity, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, newNested, this.options.histogram, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.orientation, this.options.reverseCategories, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Histogram(this.data, this.typeName, options);
    }
  }, {
    key: "histogram",
    value: function (bucketSize, hideBucketItems, lastBucketPercentile) {
      var o = this.options.histogram;
      var newNested = new HistogramHistogram(Helpers.right(o, "bucketSize", bucketSize), Helpers.right(o, "hideBucketItems", hideBucketItems), Helpers.right(o, "lastBucketPercentile", lastBucketPercentile));
      var options = new HistogramOptions(this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.dataOpacity, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, newNested, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.orientation, this.options.reverseCategories, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Histogram(this.data, this.typeName, options);
    }
  }, {
    key: "legend",
    value: function (alignment, maxLines, position, numberFormat) {
      var o = this.options.legend;
      var newNested = void 0;
      var alignment_1 = Helpers.right(o, "alignment", alignment);
      var maxLines_1 = Helpers.right(o, "maxLines", maxLines);
      var position_1 = Helpers.right(o, "position", position);
      var numberFormat_1 = Helpers.right(o, "numberFormat", numberFormat);
      newNested = new ChartLegend(alignment_1, maxLines_1, position_1, Helpers.copy(o, "textStyle"), numberFormat_1);
      var options = new HistogramOptions(this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.dataOpacity, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.histogram, this.options.height, this.options.interpolateNulls, this.options.isStacked, newNested, this.options.orientation, this.options.reverseCategories, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Histogram(this.data, this.typeName, options);
    }
  }, {
    key: "titleTextStyle",
    value: function (fontName, fontSize, bold, italic, color, auraColor, opacity) {
      var o = this.options.titleTextStyle;
      var newNested = new ChartTextStyle(Helpers.right(o, "fontName", fontName), Helpers.right(o, "fontSize", fontSize), Helpers.right(o, "bold", bold), Helpers.right(o, "italic", italic), Helpers.right(o, "color", color), Helpers.right(o, "auraColor", auraColor), Helpers.right(o, "opacity", opacity));
      var options = new HistogramOptions(this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.dataOpacity, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.histogram, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.orientation, this.options.reverseCategories, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, newNested, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Histogram(this.data, this.typeName, options);
    }
  }, {
    key: "tooltip",
    value: function (isHtml, showColorCode, trigger) {
      var o = this.options.tooltip;
      var newNested = void 0;
      var isHtml_1 = Helpers.right(o, "isHtml", isHtml);
      var showColorCode_1 = Helpers.right(o, "showColorCode", showColorCode);
      var trigger_1 = Helpers.right(o, "trigger", trigger);
      newNested = new ChartTooltip(isHtml_1, showColorCode_1, Helpers.copy(o, "textStyle"), trigger_1);
      var options = new HistogramOptions(this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.dataOpacity, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.histogram, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.orientation, this.options.reverseCategories, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, newNested, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Histogram(this.data, this.typeName, options);
    }
  }, {
    key: "vAxis",
    value: function (baseline, baselineColor, direction, format, logScale, textPosition, ticks, title, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode) {
      var o = this.options.vAxis;
      var newNested = void 0;
      var baseline_1 = Helpers.right(o, "baseline", baseline);
      var baselineColor_1 = Helpers.right(o, "baselineColor", baselineColor);
      var direction_1 = Helpers.right(o, "direction", direction);
      var format_1 = Helpers.right(o, "format", format);
      var logScale_1 = Helpers.right(o, "logScale", logScale);
      var textPosition_1 = Helpers.right(o, "textPosition", textPosition);
      var ticks_1 = Helpers.right(o, "ticks", defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      }));
      var title_1 = Helpers.right(o, "title", title);
      var allowContainerBoundaryTextCufoff_1 = Helpers.right(o, "allowContainerBoundaryTextCufoff", allowContainerBoundaryTextCufoff);
      var slantedText_1 = Helpers.right(o, "slantedText", slantedText);
      var slantedTextAngle_1 = Helpers.right(o, "slantedTextAngle", slantedTextAngle);
      var maxAlternation_1 = Helpers.right(o, "maxAlternation", maxAlternation);
      var maxTextLines_1 = Helpers.right(o, "maxTextLines", maxTextLines);
      var minTextSpacing_1 = Helpers.right(o, "minTextSpacing", minTextSpacing);
      var showTextEvery_1 = Helpers.right(o, "showTextEvery", showTextEvery);
      var maxValue_1 = Helpers.right(o, "maxValue", maxValue);
      var minValue_1 = Helpers.right(o, "minValue", minValue);
      var viewWindowMode_1 = Helpers.right(o, "viewWindowMode", viewWindowMode);
      newNested = new ChartAxis(baseline_1, baselineColor_1, direction_1, format_1, Helpers.copy(o, "gridlines"), Helpers.copy(o, "minorGridlines"), logScale_1, textPosition_1, Helpers.copy(o, "textStyle"), ticks_1, title_1, Helpers.copy(o, "titleTextStyle"), allowContainerBoundaryTextCufoff_1, slantedText_1, slantedTextAngle_1, maxAlternation_1, maxTextLines_1, minTextSpacing_1, showTextEvery_1, maxValue_1, minValue_1, viewWindowMode_1, Helpers.copy(o, "viewWindow"));
      var options = new HistogramOptions(this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.chartArea, this.options.colors, this.options.dataOpacity, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.histogram, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.orientation, this.options.reverseCategories, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, newNested, this.options.width);
      return new Histogram(this.data, this.typeName, options);
    }
  }]);

  return Histogram;
}();
setType("TheGamma.GoogleCharts.Extensions.Histogram", Histogram);
export var Area = function () {
  function Area(data, typeName, options) {
    _classCallCheck(this, Area);

    this.data = data;
    this.typeName = typeName;
    this.options = options;
  }

  _createClass(Area, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.Extensions.Area",
        interfaces: ["FSharpRecord", "TheGamma.GoogleCharts.Chart"],
        properties: {
          data: ChartData,
          typeName: "string",
          options: AreaChartOptions
        }
      };
    }
  }, {
    key: "show",
    value: function (outputId) {
      Helpers.showChart(this, outputId);
    }
  }, {
    key: "set",
    value: function (aggregationTarget, areaOpacity, axisTitlesPosition, backgroundColor, colors, dataOpacity, enableInteractivity, focusTarget, fontSize, fontName, height, interpolateNulls, isStacked, lineWidth, orientation, pointSize, reverseCategories, selectionMode, series, theme, title, titlePosition, vAxes, width) {
      var newOptions = void 0;
      var aggregationTarget_1 = Helpers.right(this.options, "aggregationTarget", aggregationTarget);
      var areaOpacity_1 = Helpers.right(this.options, "areaOpacity", areaOpacity);
      var axisTitlesPosition_1 = Helpers.right(this.options, "axisTitlesPosition", axisTitlesPosition);
      var backgroundColor_1 = Helpers.right(this.options, "backgroundColor", backgroundColor);
      var colors_1 = Helpers.right(this.options, "colors", defaultArg(colors, null, function (source) {
        return _Array$from(source);
      }));
      var dataOpacity_1 = Helpers.right(this.options, "dataOpacity", dataOpacity);
      var enableInteractivity_1 = Helpers.right(this.options, "enableInteractivity", enableInteractivity);
      var focusTarget_1 = Helpers.right(this.options, "focusTarget", focusTarget);
      var fontSize_1 = Helpers.right(this.options, "fontSize", fontSize);
      var fontName_1 = Helpers.right(this.options, "fontName", fontName);
      var height_1 = Helpers.right(this.options, "height", height);
      var interpolateNulls_1 = Helpers.right(this.options, "interpolateNulls", interpolateNulls);
      var isStacked_1 = Helpers.right(this.options, "isStacked", isStacked);
      var lineWidth_1 = Helpers.right(this.options, "lineWidth", lineWidth);
      var orientation_1 = Helpers.right(this.options, "orientation", orientation);
      var pointSize_1 = Helpers.right(this.options, "pointSize", pointSize);
      var reverseCategories_1 = Helpers.right(this.options, "reverseCategories", reverseCategories);
      var selectionMode_1 = Helpers.right(this.options, "selectionMode", selectionMode);
      var series_1 = Helpers.right(this.options, "series", series);
      var theme_1 = Helpers.right(this.options, "theme", theme);
      var title_1 = Helpers.right(this.options, "title", title);
      var titlePosition_1 = Helpers.right(this.options, "titlePosition", titlePosition);
      var vAxes_1 = Helpers.right(this.options, "vAxes", vAxes);
      var width_1 = Helpers.right(this.options, "width", width);
      newOptions = new AreaChartOptions(aggregationTarget_1, this.options.animation, areaOpacity_1, axisTitlesPosition_1, backgroundColor_1, this.options.chartArea, colors_1, this.options.crosshair, dataOpacity_1, enableInteractivity_1, this.options.explorer, focusTarget_1, fontSize_1, fontName_1, this.options.hAxis, height_1, interpolateNulls_1, isStacked_1, this.options.legend, lineWidth_1, orientation_1, pointSize_1, reverseCategories_1, selectionMode_1, series_1, theme_1, title_1, titlePosition_1, this.options.titleTextStyle, this.options.tooltip, vAxes_1, this.options.vAxis, width_1);
      return new Area(this.data, this.typeName, newOptions);
    }
  }, {
    key: "animation",
    value: function (duration, easing) {
      var o = this.options.animation;
      var newNested = new TransitionAnimation(Helpers.right(o, "duration", duration), Helpers.right(o, "easing", easing));
      var options = new AreaChartOptions(this.options.aggregationTarget, newNested, this.options.areaOpacity, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.lineWidth, this.options.orientation, this.options.pointSize, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Area(this.data, this.typeName, options);
    }
  }, {
    key: "chartArea",
    value: function (top, left, width, height) {
      var o = this.options.chartArea;
      var newNested = new ChartArea(Helpers.right(o, "top", top), Helpers.right(o, "left", left), Helpers.right(o, "width", width), Helpers.right(o, "height", height));
      var options = new AreaChartOptions(this.options.aggregationTarget, this.options.animation, this.options.areaOpacity, this.options.axisTitlesPosition, this.options.backgroundColor, newNested, this.options.colors, this.options.crosshair, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.lineWidth, this.options.orientation, this.options.pointSize, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Area(this.data, this.typeName, options);
    }
  }, {
    key: "crosshair",
    value: function (color, opacity, orientation, trigger) {
      var o = this.options.crosshair;
      var newNested = void 0;
      var color_1 = Helpers.right(o, "color", color);
      var opacity_1 = Helpers.right(o, "opacity", opacity);
      var orientation_1 = Helpers.right(o, "orientation", orientation);
      var trigger_1 = Helpers.right(o, "trigger", trigger);
      newNested = new ChartCrosshair(color_1, Helpers.copy(o, "focused"), opacity_1, orientation_1, Helpers.copy(o, "selected"), trigger_1);
      var options = new AreaChartOptions(this.options.aggregationTarget, this.options.animation, this.options.areaOpacity, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, newNested, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.lineWidth, this.options.orientation, this.options.pointSize, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Area(this.data, this.typeName, options);
    }
  }, {
    key: "explorer",
    value: function (actions, axis, keepInBounds, maxZoomIn, maxZoomOut, zoomDelta) {
      var o = this.options.explorer;
      var newNested = new ChartExplorer(Helpers.right(o, "actions", defaultArg(actions, null, function (source) {
        return _Array$from(source);
      })), Helpers.right(o, "axis", axis), Helpers.right(o, "keepInBounds", keepInBounds), Helpers.right(o, "maxZoomIn", maxZoomIn), Helpers.right(o, "maxZoomOut", maxZoomOut), Helpers.right(o, "zoomDelta", zoomDelta));
      var options = new AreaChartOptions(this.options.aggregationTarget, this.options.animation, this.options.areaOpacity, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.dataOpacity, this.options.enableInteractivity, newNested, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.lineWidth, this.options.orientation, this.options.pointSize, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Area(this.data, this.typeName, options);
    }
  }, {
    key: "hAxis",
    value: function (baseline, baselineColor, direction, format, logScale, textPosition, ticks, title, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode) {
      var o = this.options.hAxis;
      var newNested = void 0;
      var baseline_1 = Helpers.right(o, "baseline", baseline);
      var baselineColor_1 = Helpers.right(o, "baselineColor", baselineColor);
      var direction_1 = Helpers.right(o, "direction", direction);
      var format_1 = Helpers.right(o, "format", format);
      var logScale_1 = Helpers.right(o, "logScale", logScale);
      var textPosition_1 = Helpers.right(o, "textPosition", textPosition);
      var ticks_1 = Helpers.right(o, "ticks", defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      }));
      var title_1 = Helpers.right(o, "title", title);
      var allowContainerBoundaryTextCufoff_1 = Helpers.right(o, "allowContainerBoundaryTextCufoff", allowContainerBoundaryTextCufoff);
      var slantedText_1 = Helpers.right(o, "slantedText", slantedText);
      var slantedTextAngle_1 = Helpers.right(o, "slantedTextAngle", slantedTextAngle);
      var maxAlternation_1 = Helpers.right(o, "maxAlternation", maxAlternation);
      var maxTextLines_1 = Helpers.right(o, "maxTextLines", maxTextLines);
      var minTextSpacing_1 = Helpers.right(o, "minTextSpacing", minTextSpacing);
      var showTextEvery_1 = Helpers.right(o, "showTextEvery", showTextEvery);
      var maxValue_1 = Helpers.right(o, "maxValue", maxValue);
      var minValue_1 = Helpers.right(o, "minValue", minValue);
      var viewWindowMode_1 = Helpers.right(o, "viewWindowMode", viewWindowMode);
      newNested = new ChartAxis(baseline_1, baselineColor_1, direction_1, format_1, Helpers.copy(o, "gridlines"), Helpers.copy(o, "minorGridlines"), logScale_1, textPosition_1, Helpers.copy(o, "textStyle"), ticks_1, title_1, Helpers.copy(o, "titleTextStyle"), allowContainerBoundaryTextCufoff_1, slantedText_1, slantedTextAngle_1, maxAlternation_1, maxTextLines_1, minTextSpacing_1, showTextEvery_1, maxValue_1, minValue_1, viewWindowMode_1, Helpers.copy(o, "viewWindow"));
      var options = new AreaChartOptions(this.options.aggregationTarget, this.options.animation, this.options.areaOpacity, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.focusTarget, this.options.fontSize, this.options.fontName, newNested, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.lineWidth, this.options.orientation, this.options.pointSize, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Area(this.data, this.typeName, options);
    }
  }, {
    key: "legend",
    value: function (alignment, maxLines, position, numberFormat) {
      var o = this.options.legend;
      var newNested = void 0;
      var alignment_1 = Helpers.right(o, "alignment", alignment);
      var maxLines_1 = Helpers.right(o, "maxLines", maxLines);
      var position_1 = Helpers.right(o, "position", position);
      var numberFormat_1 = Helpers.right(o, "numberFormat", numberFormat);
      newNested = new ChartLegend(alignment_1, maxLines_1, position_1, Helpers.copy(o, "textStyle"), numberFormat_1);
      var options = new AreaChartOptions(this.options.aggregationTarget, this.options.animation, this.options.areaOpacity, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.isStacked, newNested, this.options.lineWidth, this.options.orientation, this.options.pointSize, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Area(this.data, this.typeName, options);
    }
  }, {
    key: "titleTextStyle",
    value: function (fontName, fontSize, bold, italic, color, auraColor, opacity) {
      var o = this.options.titleTextStyle;
      var newNested = new ChartTextStyle(Helpers.right(o, "fontName", fontName), Helpers.right(o, "fontSize", fontSize), Helpers.right(o, "bold", bold), Helpers.right(o, "italic", italic), Helpers.right(o, "color", color), Helpers.right(o, "auraColor", auraColor), Helpers.right(o, "opacity", opacity));
      var options = new AreaChartOptions(this.options.aggregationTarget, this.options.animation, this.options.areaOpacity, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.lineWidth, this.options.orientation, this.options.pointSize, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, newNested, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Area(this.data, this.typeName, options);
    }
  }, {
    key: "tooltip",
    value: function (isHtml, showColorCode, trigger) {
      var o = this.options.tooltip;
      var newNested = void 0;
      var isHtml_1 = Helpers.right(o, "isHtml", isHtml);
      var showColorCode_1 = Helpers.right(o, "showColorCode", showColorCode);
      var trigger_1 = Helpers.right(o, "trigger", trigger);
      newNested = new ChartTooltip(isHtml_1, showColorCode_1, Helpers.copy(o, "textStyle"), trigger_1);
      var options = new AreaChartOptions(this.options.aggregationTarget, this.options.animation, this.options.areaOpacity, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.lineWidth, this.options.orientation, this.options.pointSize, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, newNested, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Area(this.data, this.typeName, options);
    }
  }, {
    key: "vAxis",
    value: function (baseline, baselineColor, direction, format, logScale, textPosition, ticks, title, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode) {
      var o = this.options.vAxis;
      var newNested = void 0;
      var baseline_1 = Helpers.right(o, "baseline", baseline);
      var baselineColor_1 = Helpers.right(o, "baselineColor", baselineColor);
      var direction_1 = Helpers.right(o, "direction", direction);
      var format_1 = Helpers.right(o, "format", format);
      var logScale_1 = Helpers.right(o, "logScale", logScale);
      var textPosition_1 = Helpers.right(o, "textPosition", textPosition);
      var ticks_1 = Helpers.right(o, "ticks", defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      }));
      var title_1 = Helpers.right(o, "title", title);
      var allowContainerBoundaryTextCufoff_1 = Helpers.right(o, "allowContainerBoundaryTextCufoff", allowContainerBoundaryTextCufoff);
      var slantedText_1 = Helpers.right(o, "slantedText", slantedText);
      var slantedTextAngle_1 = Helpers.right(o, "slantedTextAngle", slantedTextAngle);
      var maxAlternation_1 = Helpers.right(o, "maxAlternation", maxAlternation);
      var maxTextLines_1 = Helpers.right(o, "maxTextLines", maxTextLines);
      var minTextSpacing_1 = Helpers.right(o, "minTextSpacing", minTextSpacing);
      var showTextEvery_1 = Helpers.right(o, "showTextEvery", showTextEvery);
      var maxValue_1 = Helpers.right(o, "maxValue", maxValue);
      var minValue_1 = Helpers.right(o, "minValue", minValue);
      var viewWindowMode_1 = Helpers.right(o, "viewWindowMode", viewWindowMode);
      newNested = new ChartAxis(baseline_1, baselineColor_1, direction_1, format_1, Helpers.copy(o, "gridlines"), Helpers.copy(o, "minorGridlines"), logScale_1, textPosition_1, Helpers.copy(o, "textStyle"), ticks_1, title_1, Helpers.copy(o, "titleTextStyle"), allowContainerBoundaryTextCufoff_1, slantedText_1, slantedTextAngle_1, maxAlternation_1, maxTextLines_1, minTextSpacing_1, showTextEvery_1, maxValue_1, minValue_1, viewWindowMode_1, Helpers.copy(o, "viewWindow"));
      var options = new AreaChartOptions(this.options.aggregationTarget, this.options.animation, this.options.areaOpacity, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.crosshair, this.options.dataOpacity, this.options.enableInteractivity, this.options.explorer, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.lineWidth, this.options.orientation, this.options.pointSize, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, newNested, this.options.width);
      return new Area(this.data, this.typeName, options);
    }
  }]);

  return Area;
}();
setType("TheGamma.GoogleCharts.Extensions.Area", Area);
export var Annotation = function () {
  function Annotation(data, typeName, options) {
    _classCallCheck(this, Annotation);

    this.data = data;
    this.typeName = typeName;
    this.options = options;
  }

  _createClass(Annotation, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.Extensions.Annotation",
        interfaces: ["FSharpRecord", "TheGamma.GoogleCharts.Chart"],
        properties: {
          data: ChartData,
          typeName: "string",
          options: AnnotationChartOptions
        }
      };
    }
  }, {
    key: "show",
    value: function (outputId) {
      Helpers.showChart(this, outputId);
    }
  }, {
    key: "set",
    value: function (allowHtml, allValuesSuffix, annotationsWidth, colors, dateFormat, displayAnnotations, displayAnnotationsFilter, displayDateTimeBarSeparator, displayExactValues, displayLegendDots, displayLegendValues, displayRangeSelector, displayZoomButtons, fill, legendPosition, max, min, numberFormats, scaleColumns, scaleFormat, scaleType, thickness, zoomEndTime, zoomStartTime) {
      var newOptions = new AnnotationChartOptions(Helpers.right(this.options, "allowHtml", allowHtml), Helpers.right(this.options, "allValuesSuffix", allValuesSuffix), Helpers.right(this.options, "annotationsWidth", annotationsWidth), Helpers.right(this.options, "colors", defaultArg(colors, null, function (source) {
        return _Array$from(source);
      })), Helpers.right(this.options, "dateFormat", dateFormat), Helpers.right(this.options, "displayAnnotations", displayAnnotations), Helpers.right(this.options, "displayAnnotationsFilter", displayAnnotationsFilter), Helpers.right(this.options, "displayDateTimeBarSeparator", displayDateTimeBarSeparator), Helpers.right(this.options, "displayExactValues", displayExactValues), Helpers.right(this.options, "displayLegendDots", displayLegendDots), Helpers.right(this.options, "displayLegendValues", displayLegendValues), Helpers.right(this.options, "displayRangeSelector", displayRangeSelector), Helpers.right(this.options, "displayZoomButtons", displayZoomButtons), Helpers.right(this.options, "fill", fill), Helpers.right(this.options, "legendPosition", legendPosition), Helpers.right(this.options, "max", max), Helpers.right(this.options, "min", min), Helpers.right(this.options, "numberFormats", numberFormats), Helpers.right(this.options, "scaleColumns", defaultArg(scaleColumns, null, function (source_1) {
        return Float64Array.from(source_1);
      })), Helpers.right(this.options, "scaleFormat", scaleFormat), Helpers.right(this.options, "scaleType", scaleType), Helpers.right(this.options, "thickness", thickness), Helpers.right(this.options, "zoomEndTime", zoomEndTime), Helpers.right(this.options, "zoomStartTime", zoomStartTime));
      return new Annotation(this.data, this.typeName, newOptions);
    }
  }]);

  return Annotation;
}();
setType("TheGamma.GoogleCharts.Extensions.Annotation", Annotation);
export var SteppedArea = function () {
  function SteppedArea(data, typeName, options) {
    _classCallCheck(this, SteppedArea);

    this.data = data;
    this.typeName = typeName;
    this.options = options;
  }

  _createClass(SteppedArea, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.Extensions.SteppedArea",
        interfaces: ["FSharpRecord", "TheGamma.GoogleCharts.Chart"],
        properties: {
          data: ChartData,
          typeName: "string",
          options: SteppedAreaChartOptions
        }
      };
    }
  }, {
    key: "show",
    value: function (outputId) {
      Helpers.showChart(this, outputId);
    }
  }, {
    key: "set",
    value: function (aggregationTarget, areaOpacity, axisTitlesPosition, backgroundColor, colors, connectSteps, enableInteractivity, focusTarget, fontSize, fontName, height, interpolateNulls, isStacked, reverseCategories, selectionMode, series, theme, title, titlePosition, vAxes, width) {
      var newOptions = void 0;
      var aggregationTarget_1 = Helpers.right(this.options, "aggregationTarget", aggregationTarget);
      var areaOpacity_1 = Helpers.right(this.options, "areaOpacity", areaOpacity);
      var axisTitlesPosition_1 = Helpers.right(this.options, "axisTitlesPosition", axisTitlesPosition);
      var backgroundColor_1 = Helpers.right(this.options, "backgroundColor", backgroundColor);
      var colors_1 = Helpers.right(this.options, "colors", defaultArg(colors, null, function (source) {
        return _Array$from(source);
      }));
      var connectSteps_1 = Helpers.right(this.options, "connectSteps", connectSteps);
      var enableInteractivity_1 = Helpers.right(this.options, "enableInteractivity", enableInteractivity);
      var focusTarget_1 = Helpers.right(this.options, "focusTarget", focusTarget);
      var fontSize_1 = Helpers.right(this.options, "fontSize", fontSize);
      var fontName_1 = Helpers.right(this.options, "fontName", fontName);
      var height_1 = Helpers.right(this.options, "height", height);
      var interpolateNulls_1 = Helpers.right(this.options, "interpolateNulls", interpolateNulls);
      var isStacked_1 = Helpers.right(this.options, "isStacked", isStacked);
      var reverseCategories_1 = Helpers.right(this.options, "reverseCategories", reverseCategories);
      var selectionMode_1 = Helpers.right(this.options, "selectionMode", selectionMode);
      var series_1 = Helpers.right(this.options, "series", series);
      var theme_1 = Helpers.right(this.options, "theme", theme);
      var title_1 = Helpers.right(this.options, "title", title);
      var titlePosition_1 = Helpers.right(this.options, "titlePosition", titlePosition);
      var vAxes_1 = Helpers.right(this.options, "vAxes", vAxes);
      var width_1 = Helpers.right(this.options, "width", width);
      newOptions = new SteppedAreaChartOptions(aggregationTarget_1, this.options.animation, areaOpacity_1, axisTitlesPosition_1, backgroundColor_1, this.options.chartArea, colors_1, connectSteps_1, enableInteractivity_1, focusTarget_1, fontSize_1, fontName_1, this.options.hAxis, height_1, interpolateNulls_1, isStacked_1, this.options.legend, reverseCategories_1, selectionMode_1, series_1, theme_1, title_1, titlePosition_1, this.options.titleTextStyle, this.options.tooltip, vAxes_1, this.options.vAxis, width_1);
      return new SteppedArea(this.data, this.typeName, newOptions);
    }
  }, {
    key: "animation",
    value: function (duration, easing) {
      var o = this.options.animation;
      var newNested = new TransitionAnimation(Helpers.right(o, "duration", duration), Helpers.right(o, "easing", easing));
      var options = new SteppedAreaChartOptions(this.options.aggregationTarget, newNested, this.options.areaOpacity, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.connectSteps, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new SteppedArea(this.data, this.typeName, options);
    }
  }, {
    key: "chartArea",
    value: function (top, left, width, height) {
      var o = this.options.chartArea;
      var newNested = new ChartArea(Helpers.right(o, "top", top), Helpers.right(o, "left", left), Helpers.right(o, "width", width), Helpers.right(o, "height", height));
      var options = new SteppedAreaChartOptions(this.options.aggregationTarget, this.options.animation, this.options.areaOpacity, this.options.axisTitlesPosition, this.options.backgroundColor, newNested, this.options.colors, this.options.connectSteps, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new SteppedArea(this.data, this.typeName, options);
    }
  }, {
    key: "hAxis",
    value: function (baseline, baselineColor, direction, format, logScale, textPosition, ticks, title, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode) {
      var o = this.options.hAxis;
      var newNested = void 0;
      var baseline_1 = Helpers.right(o, "baseline", baseline);
      var baselineColor_1 = Helpers.right(o, "baselineColor", baselineColor);
      var direction_1 = Helpers.right(o, "direction", direction);
      var format_1 = Helpers.right(o, "format", format);
      var logScale_1 = Helpers.right(o, "logScale", logScale);
      var textPosition_1 = Helpers.right(o, "textPosition", textPosition);
      var ticks_1 = Helpers.right(o, "ticks", defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      }));
      var title_1 = Helpers.right(o, "title", title);
      var allowContainerBoundaryTextCufoff_1 = Helpers.right(o, "allowContainerBoundaryTextCufoff", allowContainerBoundaryTextCufoff);
      var slantedText_1 = Helpers.right(o, "slantedText", slantedText);
      var slantedTextAngle_1 = Helpers.right(o, "slantedTextAngle", slantedTextAngle);
      var maxAlternation_1 = Helpers.right(o, "maxAlternation", maxAlternation);
      var maxTextLines_1 = Helpers.right(o, "maxTextLines", maxTextLines);
      var minTextSpacing_1 = Helpers.right(o, "minTextSpacing", minTextSpacing);
      var showTextEvery_1 = Helpers.right(o, "showTextEvery", showTextEvery);
      var maxValue_1 = Helpers.right(o, "maxValue", maxValue);
      var minValue_1 = Helpers.right(o, "minValue", minValue);
      var viewWindowMode_1 = Helpers.right(o, "viewWindowMode", viewWindowMode);
      newNested = new ChartAxis(baseline_1, baselineColor_1, direction_1, format_1, Helpers.copy(o, "gridlines"), Helpers.copy(o, "minorGridlines"), logScale_1, textPosition_1, Helpers.copy(o, "textStyle"), ticks_1, title_1, Helpers.copy(o, "titleTextStyle"), allowContainerBoundaryTextCufoff_1, slantedText_1, slantedTextAngle_1, maxAlternation_1, maxTextLines_1, minTextSpacing_1, showTextEvery_1, maxValue_1, minValue_1, viewWindowMode_1, Helpers.copy(o, "viewWindow"));
      var options = new SteppedAreaChartOptions(this.options.aggregationTarget, this.options.animation, this.options.areaOpacity, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.connectSteps, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, newNested, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new SteppedArea(this.data, this.typeName, options);
    }
  }, {
    key: "legend",
    value: function (alignment, maxLines, position, numberFormat) {
      var o = this.options.legend;
      var newNested = void 0;
      var alignment_1 = Helpers.right(o, "alignment", alignment);
      var maxLines_1 = Helpers.right(o, "maxLines", maxLines);
      var position_1 = Helpers.right(o, "position", position);
      var numberFormat_1 = Helpers.right(o, "numberFormat", numberFormat);
      newNested = new ChartLegend(alignment_1, maxLines_1, position_1, Helpers.copy(o, "textStyle"), numberFormat_1);
      var options = new SteppedAreaChartOptions(this.options.aggregationTarget, this.options.animation, this.options.areaOpacity, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.connectSteps, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.isStacked, newNested, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new SteppedArea(this.data, this.typeName, options);
    }
  }, {
    key: "titleTextStyle",
    value: function (fontName, fontSize, bold, italic, color, auraColor, opacity) {
      var o = this.options.titleTextStyle;
      var newNested = new ChartTextStyle(Helpers.right(o, "fontName", fontName), Helpers.right(o, "fontSize", fontSize), Helpers.right(o, "bold", bold), Helpers.right(o, "italic", italic), Helpers.right(o, "color", color), Helpers.right(o, "auraColor", auraColor), Helpers.right(o, "opacity", opacity));
      var options = new SteppedAreaChartOptions(this.options.aggregationTarget, this.options.animation, this.options.areaOpacity, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.connectSteps, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, newNested, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new SteppedArea(this.data, this.typeName, options);
    }
  }, {
    key: "tooltip",
    value: function (isHtml, showColorCode, trigger) {
      var o = this.options.tooltip;
      var newNested = void 0;
      var isHtml_1 = Helpers.right(o, "isHtml", isHtml);
      var showColorCode_1 = Helpers.right(o, "showColorCode", showColorCode);
      var trigger_1 = Helpers.right(o, "trigger", trigger);
      newNested = new ChartTooltip(isHtml_1, showColorCode_1, Helpers.copy(o, "textStyle"), trigger_1);
      var options = new SteppedAreaChartOptions(this.options.aggregationTarget, this.options.animation, this.options.areaOpacity, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.connectSteps, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, newNested, this.options.vAxes, this.options.vAxis, this.options.width);
      return new SteppedArea(this.data, this.typeName, options);
    }
  }, {
    key: "vAxis",
    value: function (baseline, baselineColor, direction, format, logScale, textPosition, ticks, title, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode) {
      var o = this.options.vAxis;
      var newNested = void 0;
      var baseline_1 = Helpers.right(o, "baseline", baseline);
      var baselineColor_1 = Helpers.right(o, "baselineColor", baselineColor);
      var direction_1 = Helpers.right(o, "direction", direction);
      var format_1 = Helpers.right(o, "format", format);
      var logScale_1 = Helpers.right(o, "logScale", logScale);
      var textPosition_1 = Helpers.right(o, "textPosition", textPosition);
      var ticks_1 = Helpers.right(o, "ticks", defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      }));
      var title_1 = Helpers.right(o, "title", title);
      var allowContainerBoundaryTextCufoff_1 = Helpers.right(o, "allowContainerBoundaryTextCufoff", allowContainerBoundaryTextCufoff);
      var slantedText_1 = Helpers.right(o, "slantedText", slantedText);
      var slantedTextAngle_1 = Helpers.right(o, "slantedTextAngle", slantedTextAngle);
      var maxAlternation_1 = Helpers.right(o, "maxAlternation", maxAlternation);
      var maxTextLines_1 = Helpers.right(o, "maxTextLines", maxTextLines);
      var minTextSpacing_1 = Helpers.right(o, "minTextSpacing", minTextSpacing);
      var showTextEvery_1 = Helpers.right(o, "showTextEvery", showTextEvery);
      var maxValue_1 = Helpers.right(o, "maxValue", maxValue);
      var minValue_1 = Helpers.right(o, "minValue", minValue);
      var viewWindowMode_1 = Helpers.right(o, "viewWindowMode", viewWindowMode);
      newNested = new ChartAxis(baseline_1, baselineColor_1, direction_1, format_1, Helpers.copy(o, "gridlines"), Helpers.copy(o, "minorGridlines"), logScale_1, textPosition_1, Helpers.copy(o, "textStyle"), ticks_1, title_1, Helpers.copy(o, "titleTextStyle"), allowContainerBoundaryTextCufoff_1, slantedText_1, slantedTextAngle_1, maxAlternation_1, maxTextLines_1, minTextSpacing_1, showTextEvery_1, maxValue_1, minValue_1, viewWindowMode_1, Helpers.copy(o, "viewWindow"));
      var options = new SteppedAreaChartOptions(this.options.aggregationTarget, this.options.animation, this.options.areaOpacity, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.connectSteps, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.interpolateNulls, this.options.isStacked, this.options.legend, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, newNested, this.options.width);
      return new SteppedArea(this.data, this.typeName, options);
    }
  }]);

  return SteppedArea;
}();
setType("TheGamma.GoogleCharts.Extensions.SteppedArea", SteppedArea);
export var Pie = function () {
  function Pie(data, typeName, options) {
    _classCallCheck(this, Pie);

    this.data = data;
    this.typeName = typeName;
    this.options = options;
  }

  _createClass(Pie, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.Extensions.Pie",
        interfaces: ["FSharpRecord", "TheGamma.GoogleCharts.Chart"],
        properties: {
          data: ChartData,
          typeName: "string",
          options: PieChartOptions
        }
      };
    }
  }, {
    key: "show",
    value: function (outputId) {
      Helpers.showChart(this, outputId);
    }
  }, {
    key: "set",
    value: function (backgroundColor, colors, enableInteractivity, fontSize, fontName, height, is3D, pieHole, pieSliceBorderColor, pieSliceText, pieStartAngle, reverseCategories, pieResidueSliceColor, pieResidueSliceLabel, slices, sliceVisibilityThreshold, title, width) {
      var newOptions = void 0;
      var backgroundColor_1 = Helpers.right(this.options, "backgroundColor", backgroundColor);
      var colors_1 = Helpers.right(this.options, "colors", defaultArg(colors, null, function (source) {
        return _Array$from(source);
      }));
      var enableInteractivity_1 = Helpers.right(this.options, "enableInteractivity", enableInteractivity);
      var fontSize_1 = Helpers.right(this.options, "fontSize", fontSize);
      var fontName_1 = Helpers.right(this.options, "fontName", fontName);
      var height_1 = Helpers.right(this.options, "height", height);
      var is3D_1 = Helpers.right(this.options, "is3D", is3D);
      var pieHole_1 = Helpers.right(this.options, "pieHole", pieHole);
      var pieSliceBorderColor_1 = Helpers.right(this.options, "pieSliceBorderColor", pieSliceBorderColor);
      var pieSliceText_1 = Helpers.right(this.options, "pieSliceText", pieSliceText);
      var pieStartAngle_1 = Helpers.right(this.options, "pieStartAngle", pieStartAngle);
      var reverseCategories_1 = Helpers.right(this.options, "reverseCategories", reverseCategories);
      var pieResidueSliceColor_1 = Helpers.right(this.options, "pieResidueSliceColor", pieResidueSliceColor);
      var pieResidueSliceLabel_1 = Helpers.right(this.options, "pieResidueSliceLabel", pieResidueSliceLabel);
      var slices_1 = Helpers.right(this.options, "slices", slices);
      var sliceVisibilityThreshold_1 = Helpers.right(this.options, "sliceVisibilityThreshold", sliceVisibilityThreshold);
      var title_1 = Helpers.right(this.options, "title", title);
      var width_1 = Helpers.right(this.options, "width", width);
      newOptions = new PieChartOptions(backgroundColor_1, this.options.chartArea, colors_1, enableInteractivity_1, fontSize_1, fontName_1, height_1, is3D_1, this.options.legend, pieHole_1, pieSliceBorderColor_1, pieSliceText_1, this.options.pieSliceTextStyle, pieStartAngle_1, reverseCategories_1, pieResidueSliceColor_1, pieResidueSliceLabel_1, slices_1, sliceVisibilityThreshold_1, title_1, this.options.titleTextStyle, this.options.tooltip, width_1);
      return new Pie(this.data, this.typeName, newOptions);
    }
  }, {
    key: "chartArea",
    value: function (top, left, width, height) {
      var o = this.options.chartArea;
      var newNested = new ChartArea(Helpers.right(o, "top", top), Helpers.right(o, "left", left), Helpers.right(o, "width", width), Helpers.right(o, "height", height));
      var options = new PieChartOptions(this.options.backgroundColor, newNested, this.options.colors, this.options.enableInteractivity, this.options.fontSize, this.options.fontName, this.options.height, this.options.is3D, this.options.legend, this.options.pieHole, this.options.pieSliceBorderColor, this.options.pieSliceText, this.options.pieSliceTextStyle, this.options.pieStartAngle, this.options.reverseCategories, this.options.pieResidueSliceColor, this.options.pieResidueSliceLabel, this.options.slices, this.options.sliceVisibilityThreshold, this.options.title, this.options.titleTextStyle, this.options.tooltip, this.options.width);
      return new Pie(this.data, this.typeName, options);
    }
  }, {
    key: "legend",
    value: function (alignment, maxLines, position, numberFormat) {
      var o = this.options.legend;
      var newNested = void 0;
      var alignment_1 = Helpers.right(o, "alignment", alignment);
      var maxLines_1 = Helpers.right(o, "maxLines", maxLines);
      var position_1 = Helpers.right(o, "position", position);
      var numberFormat_1 = Helpers.right(o, "numberFormat", numberFormat);
      newNested = new ChartLegend(alignment_1, maxLines_1, position_1, Helpers.copy(o, "textStyle"), numberFormat_1);
      var options = new PieChartOptions(this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.fontSize, this.options.fontName, this.options.height, this.options.is3D, newNested, this.options.pieHole, this.options.pieSliceBorderColor, this.options.pieSliceText, this.options.pieSliceTextStyle, this.options.pieStartAngle, this.options.reverseCategories, this.options.pieResidueSliceColor, this.options.pieResidueSliceLabel, this.options.slices, this.options.sliceVisibilityThreshold, this.options.title, this.options.titleTextStyle, this.options.tooltip, this.options.width);
      return new Pie(this.data, this.typeName, options);
    }
  }, {
    key: "pieSliceTextStyle",
    value: function (fontName, fontSize, bold, italic, color, auraColor, opacity) {
      var o = this.options.pieSliceTextStyle;
      var newNested = new ChartTextStyle(Helpers.right(o, "fontName", fontName), Helpers.right(o, "fontSize", fontSize), Helpers.right(o, "bold", bold), Helpers.right(o, "italic", italic), Helpers.right(o, "color", color), Helpers.right(o, "auraColor", auraColor), Helpers.right(o, "opacity", opacity));
      var options = new PieChartOptions(this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.fontSize, this.options.fontName, this.options.height, this.options.is3D, this.options.legend, this.options.pieHole, this.options.pieSliceBorderColor, this.options.pieSliceText, newNested, this.options.pieStartAngle, this.options.reverseCategories, this.options.pieResidueSliceColor, this.options.pieResidueSliceLabel, this.options.slices, this.options.sliceVisibilityThreshold, this.options.title, this.options.titleTextStyle, this.options.tooltip, this.options.width);
      return new Pie(this.data, this.typeName, options);
    }
  }, {
    key: "titleTextStyle",
    value: function (fontName, fontSize, bold, italic, color, auraColor, opacity) {
      var o = this.options.titleTextStyle;
      var newNested = new ChartTextStyle(Helpers.right(o, "fontName", fontName), Helpers.right(o, "fontSize", fontSize), Helpers.right(o, "bold", bold), Helpers.right(o, "italic", italic), Helpers.right(o, "color", color), Helpers.right(o, "auraColor", auraColor), Helpers.right(o, "opacity", opacity));
      var options = new PieChartOptions(this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.fontSize, this.options.fontName, this.options.height, this.options.is3D, this.options.legend, this.options.pieHole, this.options.pieSliceBorderColor, this.options.pieSliceText, this.options.pieSliceTextStyle, this.options.pieStartAngle, this.options.reverseCategories, this.options.pieResidueSliceColor, this.options.pieResidueSliceLabel, this.options.slices, this.options.sliceVisibilityThreshold, this.options.title, newNested, this.options.tooltip, this.options.width);
      return new Pie(this.data, this.typeName, options);
    }
  }, {
    key: "tooltip",
    value: function (isHtml, showColorCode, trigger) {
      var o = this.options.tooltip;
      var newNested = void 0;
      var isHtml_1 = Helpers.right(o, "isHtml", isHtml);
      var showColorCode_1 = Helpers.right(o, "showColorCode", showColorCode);
      var trigger_1 = Helpers.right(o, "trigger", trigger);
      newNested = new ChartTooltip(isHtml_1, showColorCode_1, Helpers.copy(o, "textStyle"), trigger_1);
      var options = new PieChartOptions(this.options.backgroundColor, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.fontSize, this.options.fontName, this.options.height, this.options.is3D, this.options.legend, this.options.pieHole, this.options.pieSliceBorderColor, this.options.pieSliceText, this.options.pieSliceTextStyle, this.options.pieStartAngle, this.options.reverseCategories, this.options.pieResidueSliceColor, this.options.pieResidueSliceLabel, this.options.slices, this.options.sliceVisibilityThreshold, this.options.title, this.options.titleTextStyle, newNested, this.options.width);
      return new Pie(this.data, this.typeName, options);
    }
  }]);

  return Pie;
}();
setType("TheGamma.GoogleCharts.Extensions.Pie", Pie);
export var Bubble = function () {
  function Bubble(data, typeName, options) {
    _classCallCheck(this, Bubble);

    this.data = data;
    this.typeName = typeName;
    this.options = options;
  }

  _createClass(Bubble, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.Extensions.Bubble",
        interfaces: ["FSharpRecord", "TheGamma.GoogleCharts.Chart"],
        properties: {
          data: ChartData,
          typeName: "string",
          options: BubbleChartOptions
        }
      };
    }
  }, {
    key: "show",
    value: function (outputId) {
      Helpers.showChart(this, outputId);
    }
  }, {
    key: "set",
    value: function (axisTitlesPosition, backgroundColor, colors, enableInteractivity, fontSize, fontName, forceIFrame, height, selectionMode, series, sortBubblesBySize, theme, title, titlePosition, width) {
      var newOptions = void 0;
      var axisTitlesPosition_1 = Helpers.right(this.options, "axisTitlesPosition", axisTitlesPosition);
      var backgroundColor_1 = Helpers.right(this.options, "backgroundColor", backgroundColor);
      var colors_1 = Helpers.right(this.options, "colors", defaultArg(colors, null, function (source) {
        return _Array$from(source);
      }));
      var enableInteractivity_1 = Helpers.right(this.options, "enableInteractivity", enableInteractivity);
      var fontSize_1 = Helpers.right(this.options, "fontSize", fontSize);
      var fontName_1 = Helpers.right(this.options, "fontName", fontName);
      var forceIFrame_1 = Helpers.right(this.options, "forceIFrame", forceIFrame);
      var height_1 = Helpers.right(this.options, "height", height);
      var selectionMode_1 = Helpers.right(this.options, "selectionMode", selectionMode);
      var series_1 = Helpers.right(this.options, "series", series);
      var sortBubblesBySize_1 = Helpers.right(this.options, "sortBubblesBySize", sortBubblesBySize);
      var theme_1 = Helpers.right(this.options, "theme", theme);
      var title_1 = Helpers.right(this.options, "title", title);
      var titlePosition_1 = Helpers.right(this.options, "titlePosition", titlePosition);
      var width_1 = Helpers.right(this.options, "width", width);
      newOptions = new BubbleChartOptions(this.options.animation, axisTitlesPosition_1, backgroundColor_1, this.options.bubble, this.options.chartArea, colors_1, this.options.colorAxis, enableInteractivity_1, this.options.explorer, fontSize_1, fontName_1, forceIFrame_1, this.options.hAxis, height_1, this.options.legend, selectionMode_1, series_1, this.options.sizeAxis, sortBubblesBySize_1, theme_1, title_1, titlePosition_1, this.options.titleTextStyle, this.options.tooltip, this.options.vAxis, width_1);
      return new Bubble(this.data, this.typeName, newOptions);
    }
  }, {
    key: "animation",
    value: function (duration, easing) {
      var o = this.options.animation;
      var newNested = new TransitionAnimation(Helpers.right(o, "duration", duration), Helpers.right(o, "easing", easing));
      var options = new BubbleChartOptions(newNested, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bubble, this.options.chartArea, this.options.colors, this.options.colorAxis, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, this.options.legend, this.options.selectionMode, this.options.series, this.options.sizeAxis, this.options.sortBubblesBySize, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxis, this.options.width);
      return new Bubble(this.data, this.typeName, options);
    }
  }, {
    key: "bubble",
    value: function (opacity, stroke) {
      var o = this.options.bubble;
      var newNested = new ChartBubble(Helpers.right(o, "opacity", opacity), Helpers.right(o, "stroke", stroke), Helpers.copy(o, "textStyle"));
      var options = new BubbleChartOptions(this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, newNested, this.options.chartArea, this.options.colors, this.options.colorAxis, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, this.options.legend, this.options.selectionMode, this.options.series, this.options.sizeAxis, this.options.sortBubblesBySize, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxis, this.options.width);
      return new Bubble(this.data, this.typeName, options);
    }
  }, {
    key: "chartArea",
    value: function (top, left, width, height) {
      var o = this.options.chartArea;
      var newNested = new ChartArea(Helpers.right(o, "top", top), Helpers.right(o, "left", left), Helpers.right(o, "width", width), Helpers.right(o, "height", height));
      var options = new BubbleChartOptions(this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bubble, newNested, this.options.colors, this.options.colorAxis, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, this.options.legend, this.options.selectionMode, this.options.series, this.options.sizeAxis, this.options.sortBubblesBySize, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxis, this.options.width);
      return new Bubble(this.data, this.typeName, options);
    }
  }, {
    key: "colorAxis",
    value: function (minValue, maxValue, values, colors) {
      var o = this.options.colorAxis;
      var newNested = new ChartColorAxis(Helpers.right(o, "minValue", minValue), Helpers.right(o, "maxValue", maxValue), Helpers.right(o, "values", defaultArg(values, null, function (source) {
        return Float64Array.from(source);
      })), Helpers.right(o, "colors", defaultArg(colors, null, function (source_1) {
        return _Array$from(source_1);
      })), Helpers.copy(o, "legend"));
      var options = new BubbleChartOptions(this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bubble, this.options.chartArea, this.options.colors, newNested, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, this.options.legend, this.options.selectionMode, this.options.series, this.options.sizeAxis, this.options.sortBubblesBySize, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxis, this.options.width);
      return new Bubble(this.data, this.typeName, options);
    }
  }, {
    key: "explorer",
    value: function (actions, axis, keepInBounds, maxZoomIn, maxZoomOut, zoomDelta) {
      var o = this.options.explorer;
      var newNested = new ChartExplorer(Helpers.right(o, "actions", defaultArg(actions, null, function (source) {
        return _Array$from(source);
      })), Helpers.right(o, "axis", axis), Helpers.right(o, "keepInBounds", keepInBounds), Helpers.right(o, "maxZoomIn", maxZoomIn), Helpers.right(o, "maxZoomOut", maxZoomOut), Helpers.right(o, "zoomDelta", zoomDelta));
      var options = new BubbleChartOptions(this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bubble, this.options.chartArea, this.options.colors, this.options.colorAxis, this.options.enableInteractivity, newNested, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, this.options.legend, this.options.selectionMode, this.options.series, this.options.sizeAxis, this.options.sortBubblesBySize, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxis, this.options.width);
      return new Bubble(this.data, this.typeName, options);
    }
  }, {
    key: "hAxis",
    value: function (baseline, baselineColor, direction, format, logScale, textPosition, ticks, title, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode) {
      var o = this.options.hAxis;
      var newNested = void 0;
      var baseline_1 = Helpers.right(o, "baseline", baseline);
      var baselineColor_1 = Helpers.right(o, "baselineColor", baselineColor);
      var direction_1 = Helpers.right(o, "direction", direction);
      var format_1 = Helpers.right(o, "format", format);
      var logScale_1 = Helpers.right(o, "logScale", logScale);
      var textPosition_1 = Helpers.right(o, "textPosition", textPosition);
      var ticks_1 = Helpers.right(o, "ticks", defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      }));
      var title_1 = Helpers.right(o, "title", title);
      var allowContainerBoundaryTextCufoff_1 = Helpers.right(o, "allowContainerBoundaryTextCufoff", allowContainerBoundaryTextCufoff);
      var slantedText_1 = Helpers.right(o, "slantedText", slantedText);
      var slantedTextAngle_1 = Helpers.right(o, "slantedTextAngle", slantedTextAngle);
      var maxAlternation_1 = Helpers.right(o, "maxAlternation", maxAlternation);
      var maxTextLines_1 = Helpers.right(o, "maxTextLines", maxTextLines);
      var minTextSpacing_1 = Helpers.right(o, "minTextSpacing", minTextSpacing);
      var showTextEvery_1 = Helpers.right(o, "showTextEvery", showTextEvery);
      var maxValue_1 = Helpers.right(o, "maxValue", maxValue);
      var minValue_1 = Helpers.right(o, "minValue", minValue);
      var viewWindowMode_1 = Helpers.right(o, "viewWindowMode", viewWindowMode);
      newNested = new ChartAxis(baseline_1, baselineColor_1, direction_1, format_1, Helpers.copy(o, "gridlines"), Helpers.copy(o, "minorGridlines"), logScale_1, textPosition_1, Helpers.copy(o, "textStyle"), ticks_1, title_1, Helpers.copy(o, "titleTextStyle"), allowContainerBoundaryTextCufoff_1, slantedText_1, slantedTextAngle_1, maxAlternation_1, maxTextLines_1, minTextSpacing_1, showTextEvery_1, maxValue_1, minValue_1, viewWindowMode_1, Helpers.copy(o, "viewWindow"));
      var options = new BubbleChartOptions(this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bubble, this.options.chartArea, this.options.colors, this.options.colorAxis, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, newNested, this.options.height, this.options.legend, this.options.selectionMode, this.options.series, this.options.sizeAxis, this.options.sortBubblesBySize, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxis, this.options.width);
      return new Bubble(this.data, this.typeName, options);
    }
  }, {
    key: "legend",
    value: function (alignment, maxLines, position, numberFormat) {
      var o = this.options.legend;
      var newNested = void 0;
      var alignment_1 = Helpers.right(o, "alignment", alignment);
      var maxLines_1 = Helpers.right(o, "maxLines", maxLines);
      var position_1 = Helpers.right(o, "position", position);
      var numberFormat_1 = Helpers.right(o, "numberFormat", numberFormat);
      newNested = new ChartLegend(alignment_1, maxLines_1, position_1, Helpers.copy(o, "textStyle"), numberFormat_1);
      var options = new BubbleChartOptions(this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bubble, this.options.chartArea, this.options.colors, this.options.colorAxis, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, newNested, this.options.selectionMode, this.options.series, this.options.sizeAxis, this.options.sortBubblesBySize, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxis, this.options.width);
      return new Bubble(this.data, this.typeName, options);
    }
  }, {
    key: "sizeAxis",
    value: function (maxSize, maxValue, minSize, minValue) {
      var o = this.options.sizeAxis;
      var newNested = new ChartSizeAxis(Helpers.right(o, "maxSize", maxSize), Helpers.right(o, "maxValue", maxValue), Helpers.right(o, "minSize", minSize), Helpers.right(o, "minValue", minValue));
      var options = new BubbleChartOptions(this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bubble, this.options.chartArea, this.options.colors, this.options.colorAxis, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, this.options.legend, this.options.selectionMode, this.options.series, newNested, this.options.sortBubblesBySize, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxis, this.options.width);
      return new Bubble(this.data, this.typeName, options);
    }
  }, {
    key: "titleTextStyle",
    value: function (fontName, fontSize, bold, italic, color, auraColor, opacity) {
      var o = this.options.titleTextStyle;
      var newNested = new ChartTextStyle(Helpers.right(o, "fontName", fontName), Helpers.right(o, "fontSize", fontSize), Helpers.right(o, "bold", bold), Helpers.right(o, "italic", italic), Helpers.right(o, "color", color), Helpers.right(o, "auraColor", auraColor), Helpers.right(o, "opacity", opacity));
      var options = new BubbleChartOptions(this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bubble, this.options.chartArea, this.options.colors, this.options.colorAxis, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, this.options.legend, this.options.selectionMode, this.options.series, this.options.sizeAxis, this.options.sortBubblesBySize, this.options.theme, this.options.title, this.options.titlePosition, newNested, this.options.tooltip, this.options.vAxis, this.options.width);
      return new Bubble(this.data, this.typeName, options);
    }
  }, {
    key: "tooltip",
    value: function (isHtml, showColorCode, trigger) {
      var o = this.options.tooltip;
      var newNested = void 0;
      var isHtml_1 = Helpers.right(o, "isHtml", isHtml);
      var showColorCode_1 = Helpers.right(o, "showColorCode", showColorCode);
      var trigger_1 = Helpers.right(o, "trigger", trigger);
      newNested = new ChartTooltip(isHtml_1, showColorCode_1, Helpers.copy(o, "textStyle"), trigger_1);
      var options = new BubbleChartOptions(this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bubble, this.options.chartArea, this.options.colors, this.options.colorAxis, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, this.options.legend, this.options.selectionMode, this.options.series, this.options.sizeAxis, this.options.sortBubblesBySize, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, newNested, this.options.vAxis, this.options.width);
      return new Bubble(this.data, this.typeName, options);
    }
  }, {
    key: "vAxis",
    value: function (baseline, baselineColor, direction, format, logScale, textPosition, ticks, title, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode) {
      var o = this.options.vAxis;
      var newNested = void 0;
      var baseline_1 = Helpers.right(o, "baseline", baseline);
      var baselineColor_1 = Helpers.right(o, "baselineColor", baselineColor);
      var direction_1 = Helpers.right(o, "direction", direction);
      var format_1 = Helpers.right(o, "format", format);
      var logScale_1 = Helpers.right(o, "logScale", logScale);
      var textPosition_1 = Helpers.right(o, "textPosition", textPosition);
      var ticks_1 = Helpers.right(o, "ticks", defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      }));
      var title_1 = Helpers.right(o, "title", title);
      var allowContainerBoundaryTextCufoff_1 = Helpers.right(o, "allowContainerBoundaryTextCufoff", allowContainerBoundaryTextCufoff);
      var slantedText_1 = Helpers.right(o, "slantedText", slantedText);
      var slantedTextAngle_1 = Helpers.right(o, "slantedTextAngle", slantedTextAngle);
      var maxAlternation_1 = Helpers.right(o, "maxAlternation", maxAlternation);
      var maxTextLines_1 = Helpers.right(o, "maxTextLines", maxTextLines);
      var minTextSpacing_1 = Helpers.right(o, "minTextSpacing", minTextSpacing);
      var showTextEvery_1 = Helpers.right(o, "showTextEvery", showTextEvery);
      var maxValue_1 = Helpers.right(o, "maxValue", maxValue);
      var minValue_1 = Helpers.right(o, "minValue", minValue);
      var viewWindowMode_1 = Helpers.right(o, "viewWindowMode", viewWindowMode);
      newNested = new ChartAxis(baseline_1, baselineColor_1, direction_1, format_1, Helpers.copy(o, "gridlines"), Helpers.copy(o, "minorGridlines"), logScale_1, textPosition_1, Helpers.copy(o, "textStyle"), ticks_1, title_1, Helpers.copy(o, "titleTextStyle"), allowContainerBoundaryTextCufoff_1, slantedText_1, slantedTextAngle_1, maxAlternation_1, maxTextLines_1, minTextSpacing_1, showTextEvery_1, maxValue_1, minValue_1, viewWindowMode_1, Helpers.copy(o, "viewWindow"));
      var options = new BubbleChartOptions(this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bubble, this.options.chartArea, this.options.colors, this.options.colorAxis, this.options.enableInteractivity, this.options.explorer, this.options.fontSize, this.options.fontName, this.options.forceIFrame, this.options.hAxis, this.options.height, this.options.legend, this.options.selectionMode, this.options.series, this.options.sizeAxis, this.options.sortBubblesBySize, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, newNested, this.options.width);
      return new Bubble(this.data, this.typeName, options);
    }
  }]);

  return Bubble;
}();
setType("TheGamma.GoogleCharts.Extensions.Bubble", Bubble);
export var TreeMap = function () {
  function TreeMap(data, typeName, options) {
    _classCallCheck(this, TreeMap);

    this.data = data;
    this.typeName = typeName;
    this.options = options;
  }

  _createClass(TreeMap, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.Extensions.TreeMap",
        interfaces: ["FSharpRecord", "TheGamma.GoogleCharts.Chart"],
        properties: {
          data: ChartData,
          typeName: "string",
          options: TreeMapOptions
        }
      };
    }
  }, {
    key: "show",
    value: function (outputId) {
      Helpers.showChart(this, outputId);
    }
  }, {
    key: "set",
    value: function (fontColor, fontFamily, fontSize, forceIFrame, headerColor, headerHeight, headerHighlightColor, hintOpacity, maxColor, maxDepth, maxHighlightColor, maxPostDepth, maxColorValue, midColor, midHighlightColor, minColor, minHighlightColor, minColorValue, showScale, showTooltips, title, useWeightedAverageForAggregation) {
      var newOptions = void 0;
      var fontColor_1 = Helpers.right(this.options, "fontColor", fontColor);
      var fontFamily_1 = Helpers.right(this.options, "fontFamily", fontFamily);
      var fontSize_1 = Helpers.right(this.options, "fontSize", fontSize);
      var forceIFrame_1 = Helpers.right(this.options, "forceIFrame", forceIFrame);
      var headerColor_1 = Helpers.right(this.options, "headerColor", headerColor);
      var headerHeight_1 = Helpers.right(this.options, "headerHeight", headerHeight);
      var headerHighlightColor_1 = Helpers.right(this.options, "headerHighlightColor", headerHighlightColor);
      var hintOpacity_1 = Helpers.right(this.options, "hintOpacity", hintOpacity);
      var maxColor_1 = Helpers.right(this.options, "maxColor", maxColor);
      var maxDepth_1 = Helpers.right(this.options, "maxDepth", maxDepth);
      var maxHighlightColor_1 = Helpers.right(this.options, "maxHighlightColor", maxHighlightColor);
      var maxPostDepth_1 = Helpers.right(this.options, "maxPostDepth", maxPostDepth);
      var maxColorValue_1 = Helpers.right(this.options, "maxColorValue", maxColorValue);
      var midColor_1 = Helpers.right(this.options, "midColor", midColor);
      var midHighlightColor_1 = Helpers.right(this.options, "midHighlightColor", midHighlightColor);
      var minColor_1 = Helpers.right(this.options, "minColor", minColor);
      var minHighlightColor_1 = Helpers.right(this.options, "minHighlightColor", minHighlightColor);
      var minColorValue_1 = Helpers.right(this.options, "minColorValue", minColorValue);
      var showScale_1 = Helpers.right(this.options, "showScale", showScale);
      var showTooltips_1 = Helpers.right(this.options, "showTooltips", showTooltips);
      var title_1 = Helpers.right(this.options, "title", title);
      var useWeightedAverageForAggregation_1 = Helpers.right(this.options, "useWeightedAverageForAggregation", useWeightedAverageForAggregation);
      newOptions = new TreeMapOptions(fontColor_1, fontFamily_1, fontSize_1, forceIFrame_1, headerColor_1, headerHeight_1, headerHighlightColor_1, hintOpacity_1, maxColor_1, maxDepth_1, maxHighlightColor_1, maxPostDepth_1, maxColorValue_1, midColor_1, midHighlightColor_1, minColor_1, minHighlightColor_1, minColorValue_1, showScale_1, showTooltips_1, this.options.textStyle, title_1, this.options.titleTextStyle, useWeightedAverageForAggregation_1);
      return new TreeMap(this.data, this.typeName, newOptions);
    }
  }, {
    key: "textStyle",
    value: function (fontName, fontSize, bold, italic, color, auraColor, opacity) {
      var o = this.options.textStyle;
      var newNested = new ChartTextStyle(Helpers.right(o, "fontName", fontName), Helpers.right(o, "fontSize", fontSize), Helpers.right(o, "bold", bold), Helpers.right(o, "italic", italic), Helpers.right(o, "color", color), Helpers.right(o, "auraColor", auraColor), Helpers.right(o, "opacity", opacity));
      var options = new TreeMapOptions(this.options.fontColor, this.options.fontFamily, this.options.fontSize, this.options.forceIFrame, this.options.headerColor, this.options.headerHeight, this.options.headerHighlightColor, this.options.hintOpacity, this.options.maxColor, this.options.maxDepth, this.options.maxHighlightColor, this.options.maxPostDepth, this.options.maxColorValue, this.options.midColor, this.options.midHighlightColor, this.options.minColor, this.options.minHighlightColor, this.options.minColorValue, this.options.showScale, this.options.showTooltips, newNested, this.options.title, this.options.titleTextStyle, this.options.useWeightedAverageForAggregation);
      return new TreeMap(this.data, this.typeName, options);
    }
  }, {
    key: "titleTextStyle",
    value: function (fontName, fontSize, bold, italic, color, auraColor, opacity) {
      var o = this.options.titleTextStyle;
      var newNested = new ChartTextStyle(Helpers.right(o, "fontName", fontName), Helpers.right(o, "fontSize", fontSize), Helpers.right(o, "bold", bold), Helpers.right(o, "italic", italic), Helpers.right(o, "color", color), Helpers.right(o, "auraColor", auraColor), Helpers.right(o, "opacity", opacity));
      var options = new TreeMapOptions(this.options.fontColor, this.options.fontFamily, this.options.fontSize, this.options.forceIFrame, this.options.headerColor, this.options.headerHeight, this.options.headerHighlightColor, this.options.hintOpacity, this.options.maxColor, this.options.maxDepth, this.options.maxHighlightColor, this.options.maxPostDepth, this.options.maxColorValue, this.options.midColor, this.options.midHighlightColor, this.options.minColor, this.options.minHighlightColor, this.options.minColorValue, this.options.showScale, this.options.showTooltips, this.options.textStyle, this.options.title, newNested, this.options.useWeightedAverageForAggregation);
      return new TreeMap(this.data, this.typeName, options);
    }
  }]);

  return TreeMap;
}();
setType("TheGamma.GoogleCharts.Extensions.TreeMap", TreeMap);
export var Table = function () {
  function Table(data, typeName, options) {
    _classCallCheck(this, Table);

    this.data = data;
    this.typeName = typeName;
    this.options = options;
  }

  _createClass(Table, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.Extensions.Table",
        interfaces: ["FSharpRecord", "TheGamma.GoogleCharts.Chart"],
        properties: {
          data: ChartData,
          typeName: "string",
          options: TableOptions
        }
      };
    }
  }, {
    key: "show",
    value: function (outputId) {
      Helpers.showChart(this, outputId);
    }
  }, {
    key: "set",
    value: function (allowHtml, alternatingRowStyle, firstRowNumber, height, page, pageSize, rtlTable, scrollLeftStartPosition, showRowNumber, sort, sortAscending, sortColumn, startPage, width) {
      var newOptions = void 0;
      var allowHtml_1 = Helpers.right(this.options, "allowHtml", allowHtml);
      var alternatingRowStyle_1 = Helpers.right(this.options, "alternatingRowStyle", alternatingRowStyle);
      var firstRowNumber_1 = Helpers.right(this.options, "firstRowNumber", firstRowNumber);
      var height_1 = Helpers.right(this.options, "height", height);
      var page_1 = Helpers.right(this.options, "page", page);
      var pageSize_1 = Helpers.right(this.options, "pageSize", pageSize);
      var rtlTable_1 = Helpers.right(this.options, "rtlTable", rtlTable);
      var scrollLeftStartPosition_1 = Helpers.right(this.options, "scrollLeftStartPosition", scrollLeftStartPosition);
      var showRowNumber_1 = Helpers.right(this.options, "showRowNumber", showRowNumber);
      var sort_1 = Helpers.right(this.options, "sort", sort);
      var sortAscending_1 = Helpers.right(this.options, "sortAscending", sortAscending);
      var sortColumn_1 = Helpers.right(this.options, "sortColumn", sortColumn);
      var startPage_1 = Helpers.right(this.options, "startPage", startPage);
      var width_1 = Helpers.right(this.options, "width", width);
      newOptions = new TableOptions(allowHtml_1, alternatingRowStyle_1, this.options.cssClassName, firstRowNumber_1, height_1, page_1, pageSize_1, rtlTable_1, scrollLeftStartPosition_1, showRowNumber_1, sort_1, sortAscending_1, sortColumn_1, startPage_1, width_1);
      return new Table(this.data, this.typeName, newOptions);
    }
  }, {
    key: "cssClassName",
    value: function (headerRow, tableRow, oddTableRow, selectedTableRow, hoverTableRow, headerCell, tableCell, rowNumberCell) {
      var o = this.options.cssClassName;
      var newNested = new CssClassNames(Helpers.right(o, "headerRow", headerRow), Helpers.right(o, "tableRow", tableRow), Helpers.right(o, "oddTableRow", oddTableRow), Helpers.right(o, "selectedTableRow", selectedTableRow), Helpers.right(o, "hoverTableRow", hoverTableRow), Helpers.right(o, "headerCell", headerCell), Helpers.right(o, "tableCell", tableCell), Helpers.right(o, "rowNumberCell", rowNumberCell));
      var options = new TableOptions(this.options.allowHtml, this.options.alternatingRowStyle, newNested, this.options.firstRowNumber, this.options.height, this.options.page, this.options.pageSize, this.options.rtlTable, this.options.scrollLeftStartPosition, this.options.showRowNumber, this.options.sort, this.options.sortAscending, this.options.sortColumn, this.options.startPage, this.options.width);
      return new Table(this.data, this.typeName, options);
    }
  }]);

  return Table;
}();
setType("TheGamma.GoogleCharts.Extensions.Table", Table);
export var Timeline = function () {
  function Timeline(data, typeName, options) {
    _classCallCheck(this, Timeline);

    this.data = data;
    this.typeName = typeName;
    this.options = options;
  }

  _createClass(Timeline, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.Extensions.Timeline",
        interfaces: ["FSharpRecord", "TheGamma.GoogleCharts.Chart"],
        properties: {
          data: ChartData,
          typeName: "string",
          options: TimelineOptions
        }
      };
    }
  }, {
    key: "show",
    value: function (outputId) {
      Helpers.showChart(this, outputId);
    }
  }, {
    key: "set",
    value: function (avoidOverlappingGridLines, backgroundColor, colors, enableInteractivity, forceIFrame, height, width) {
      var newOptions = void 0;
      var avoidOverlappingGridLines_1 = Helpers.right(this.options, "avoidOverlappingGridLines", avoidOverlappingGridLines);
      var backgroundColor_1 = Helpers.right(this.options, "backgroundColor", backgroundColor);
      var colors_1 = Helpers.right(this.options, "colors", defaultArg(colors, null, function (source) {
        return _Array$from(source);
      }));
      var enableInteractivity_1 = Helpers.right(this.options, "enableInteractivity", enableInteractivity);
      var forceIFrame_1 = Helpers.right(this.options, "forceIFrame", forceIFrame);
      var height_1 = Helpers.right(this.options, "height", height);
      var width_1 = Helpers.right(this.options, "width", width);
      newOptions = new TimelineOptions(avoidOverlappingGridLines_1, backgroundColor_1, colors_1, enableInteractivity_1, forceIFrame_1, height_1, this.options.timeline, width_1);
      return new Timeline(this.data, this.typeName, newOptions);
    }
  }, {
    key: "timeline",
    value: function (colorByRowLabel, groupByRowLabel, showRowLabels, singleColor) {
      var o = this.options.timeline;
      var newNested = void 0;
      var colorByRowLabel_1 = Helpers.right(o, "colorByRowLabel", colorByRowLabel);
      var groupByRowLabel_1 = Helpers.right(o, "groupByRowLabel", groupByRowLabel);
      var showRowLabels_1 = Helpers.right(o, "showRowLabels", showRowLabels);
      var singleColor_1 = Helpers.right(o, "singleColor", singleColor);
      newNested = new TimelineTimeline(Helpers.copy(o, "barLabelStyle"), colorByRowLabel_1, groupByRowLabel_1, Helpers.copy(o, "rowLabelStyle"), showRowLabels_1, singleColor_1);
      var options = new TimelineOptions(this.options.avoidOverlappingGridLines, this.options.backgroundColor, this.options.colors, this.options.enableInteractivity, this.options.forceIFrame, this.options.height, newNested, this.options.width);
      return new Timeline(this.data, this.typeName, options);
    }
  }]);

  return Timeline;
}();
setType("TheGamma.GoogleCharts.Extensions.Timeline", Timeline);
export var Candlestick = function () {
  function Candlestick(data, typeName, options) {
    _classCallCheck(this, Candlestick);

    this.data = data;
    this.typeName = typeName;
    this.options = options;
  }

  _createClass(Candlestick, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.Extensions.Candlestick",
        interfaces: ["FSharpRecord", "TheGamma.GoogleCharts.Chart"],
        properties: {
          data: ChartData,
          typeName: "string",
          options: CandlestickChartOptions
        }
      };
    }
  }, {
    key: "show",
    value: function (outputId) {
      Helpers.showChart(this, outputId);
    }
  }, {
    key: "set",
    value: function (aggregationTarget, axisTitlesPosition, backgroundColor, colors, enableInteractivity, focusTarget, fontSize, fontName, height, orientation, reverseCategories, selectionMode, series, theme, title, titlePosition, vAxes, width) {
      var newOptions = void 0;
      var aggregationTarget_1 = Helpers.right(this.options, "aggregationTarget", aggregationTarget);
      var axisTitlesPosition_1 = Helpers.right(this.options, "axisTitlesPosition", axisTitlesPosition);
      var backgroundColor_1 = Helpers.right(this.options, "backgroundColor", backgroundColor);
      var colors_1 = Helpers.right(this.options, "colors", defaultArg(colors, null, function (source) {
        return _Array$from(source);
      }));
      var enableInteractivity_1 = Helpers.right(this.options, "enableInteractivity", enableInteractivity);
      var focusTarget_1 = Helpers.right(this.options, "focusTarget", focusTarget);
      var fontSize_1 = Helpers.right(this.options, "fontSize", fontSize);
      var fontName_1 = Helpers.right(this.options, "fontName", fontName);
      var height_1 = Helpers.right(this.options, "height", height);
      var orientation_1 = Helpers.right(this.options, "orientation", orientation);
      var reverseCategories_1 = Helpers.right(this.options, "reverseCategories", reverseCategories);
      var selectionMode_1 = Helpers.right(this.options, "selectionMode", selectionMode);
      var series_1 = Helpers.right(this.options, "series", series);
      var theme_1 = Helpers.right(this.options, "theme", theme);
      var title_1 = Helpers.right(this.options, "title", title);
      var titlePosition_1 = Helpers.right(this.options, "titlePosition", titlePosition);
      var vAxes_1 = Helpers.right(this.options, "vAxes", vAxes);
      var width_1 = Helpers.right(this.options, "width", width);
      newOptions = new CandlestickChartOptions(aggregationTarget_1, this.options.animation, axisTitlesPosition_1, backgroundColor_1, this.options.bar, this.options.candlestick, this.options.chartArea, colors_1, enableInteractivity_1, focusTarget_1, fontSize_1, fontName_1, this.options.hAxis, height_1, this.options.legend, orientation_1, reverseCategories_1, selectionMode_1, series_1, theme_1, title_1, titlePosition_1, this.options.titleTextStyle, this.options.tooltip, vAxes_1, this.options.vAxis, width_1);
      return new Candlestick(this.data, this.typeName, newOptions);
    }
  }, {
    key: "animation",
    value: function (duration, easing) {
      var o = this.options.animation;
      var newNested = new TransitionAnimation(Helpers.right(o, "duration", duration), Helpers.right(o, "easing", easing));
      var options = new CandlestickChartOptions(this.options.aggregationTarget, newNested, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.candlestick, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.legend, this.options.orientation, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Candlestick(this.data, this.typeName, options);
    }
  }, {
    key: "bar",
    value: function (groupWidth) {
      var o = this.options.bar;
      var newNested = new GroupWidth(Helpers.right(o, "groupWidth", groupWidth));
      var options = new CandlestickChartOptions(this.options.aggregationTarget, this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, newNested, this.options.candlestick, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.legend, this.options.orientation, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Candlestick(this.data, this.typeName, options);
    }
  }, {
    key: "candlestick",
    value: function (hollowIsRising) {
      var o = this.options.candlestick;
      var newNested = new CandlestickCandlestick(Helpers.right(o, "hollowIsRising", hollowIsRising), Helpers.copy(o, "fallingColor"), Helpers.copy(o, "risingColor"));
      var options = new CandlestickChartOptions(this.options.aggregationTarget, this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, newNested, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.legend, this.options.orientation, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Candlestick(this.data, this.typeName, options);
    }
  }, {
    key: "chartArea",
    value: function (top, left, width, height) {
      var o = this.options.chartArea;
      var newNested = new ChartArea(Helpers.right(o, "top", top), Helpers.right(o, "left", left), Helpers.right(o, "width", width), Helpers.right(o, "height", height));
      var options = new CandlestickChartOptions(this.options.aggregationTarget, this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.candlestick, newNested, this.options.colors, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.legend, this.options.orientation, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Candlestick(this.data, this.typeName, options);
    }
  }, {
    key: "hAxis",
    value: function (baseline, baselineColor, direction, format, logScale, textPosition, ticks, title, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode) {
      var o = this.options.hAxis;
      var newNested = void 0;
      var baseline_1 = Helpers.right(o, "baseline", baseline);
      var baselineColor_1 = Helpers.right(o, "baselineColor", baselineColor);
      var direction_1 = Helpers.right(o, "direction", direction);
      var format_1 = Helpers.right(o, "format", format);
      var logScale_1 = Helpers.right(o, "logScale", logScale);
      var textPosition_1 = Helpers.right(o, "textPosition", textPosition);
      var ticks_1 = Helpers.right(o, "ticks", defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      }));
      var title_1 = Helpers.right(o, "title", title);
      var allowContainerBoundaryTextCufoff_1 = Helpers.right(o, "allowContainerBoundaryTextCufoff", allowContainerBoundaryTextCufoff);
      var slantedText_1 = Helpers.right(o, "slantedText", slantedText);
      var slantedTextAngle_1 = Helpers.right(o, "slantedTextAngle", slantedTextAngle);
      var maxAlternation_1 = Helpers.right(o, "maxAlternation", maxAlternation);
      var maxTextLines_1 = Helpers.right(o, "maxTextLines", maxTextLines);
      var minTextSpacing_1 = Helpers.right(o, "minTextSpacing", minTextSpacing);
      var showTextEvery_1 = Helpers.right(o, "showTextEvery", showTextEvery);
      var maxValue_1 = Helpers.right(o, "maxValue", maxValue);
      var minValue_1 = Helpers.right(o, "minValue", minValue);
      var viewWindowMode_1 = Helpers.right(o, "viewWindowMode", viewWindowMode);
      newNested = new ChartAxis(baseline_1, baselineColor_1, direction_1, format_1, Helpers.copy(o, "gridlines"), Helpers.copy(o, "minorGridlines"), logScale_1, textPosition_1, Helpers.copy(o, "textStyle"), ticks_1, title_1, Helpers.copy(o, "titleTextStyle"), allowContainerBoundaryTextCufoff_1, slantedText_1, slantedTextAngle_1, maxAlternation_1, maxTextLines_1, minTextSpacing_1, showTextEvery_1, maxValue_1, minValue_1, viewWindowMode_1, Helpers.copy(o, "viewWindow"));
      var options = new CandlestickChartOptions(this.options.aggregationTarget, this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.candlestick, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, newNested, this.options.height, this.options.legend, this.options.orientation, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Candlestick(this.data, this.typeName, options);
    }
  }, {
    key: "legend",
    value: function (alignment, maxLines, position, numberFormat) {
      var o = this.options.legend;
      var newNested = void 0;
      var alignment_1 = Helpers.right(o, "alignment", alignment);
      var maxLines_1 = Helpers.right(o, "maxLines", maxLines);
      var position_1 = Helpers.right(o, "position", position);
      var numberFormat_1 = Helpers.right(o, "numberFormat", numberFormat);
      newNested = new ChartLegend(alignment_1, maxLines_1, position_1, Helpers.copy(o, "textStyle"), numberFormat_1);
      var options = new CandlestickChartOptions(this.options.aggregationTarget, this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.candlestick, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, newNested, this.options.orientation, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Candlestick(this.data, this.typeName, options);
    }
  }, {
    key: "titleTextStyle",
    value: function (fontName, fontSize, bold, italic, color, auraColor, opacity) {
      var o = this.options.titleTextStyle;
      var newNested = new ChartTextStyle(Helpers.right(o, "fontName", fontName), Helpers.right(o, "fontSize", fontSize), Helpers.right(o, "bold", bold), Helpers.right(o, "italic", italic), Helpers.right(o, "color", color), Helpers.right(o, "auraColor", auraColor), Helpers.right(o, "opacity", opacity));
      var options = new CandlestickChartOptions(this.options.aggregationTarget, this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.candlestick, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.legend, this.options.orientation, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, newNested, this.options.tooltip, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Candlestick(this.data, this.typeName, options);
    }
  }, {
    key: "tooltip",
    value: function (isHtml, showColorCode, trigger) {
      var o = this.options.tooltip;
      var newNested = void 0;
      var isHtml_1 = Helpers.right(o, "isHtml", isHtml);
      var showColorCode_1 = Helpers.right(o, "showColorCode", showColorCode);
      var trigger_1 = Helpers.right(o, "trigger", trigger);
      newNested = new ChartTooltip(isHtml_1, showColorCode_1, Helpers.copy(o, "textStyle"), trigger_1);
      var options = new CandlestickChartOptions(this.options.aggregationTarget, this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.candlestick, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.legend, this.options.orientation, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, newNested, this.options.vAxes, this.options.vAxis, this.options.width);
      return new Candlestick(this.data, this.typeName, options);
    }
  }, {
    key: "vAxis",
    value: function (baseline, baselineColor, direction, format, logScale, textPosition, ticks, title, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode) {
      var o = this.options.vAxis;
      var newNested = void 0;
      var baseline_1 = Helpers.right(o, "baseline", baseline);
      var baselineColor_1 = Helpers.right(o, "baselineColor", baselineColor);
      var direction_1 = Helpers.right(o, "direction", direction);
      var format_1 = Helpers.right(o, "format", format);
      var logScale_1 = Helpers.right(o, "logScale", logScale);
      var textPosition_1 = Helpers.right(o, "textPosition", textPosition);
      var ticks_1 = Helpers.right(o, "ticks", defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      }));
      var title_1 = Helpers.right(o, "title", title);
      var allowContainerBoundaryTextCufoff_1 = Helpers.right(o, "allowContainerBoundaryTextCufoff", allowContainerBoundaryTextCufoff);
      var slantedText_1 = Helpers.right(o, "slantedText", slantedText);
      var slantedTextAngle_1 = Helpers.right(o, "slantedTextAngle", slantedTextAngle);
      var maxAlternation_1 = Helpers.right(o, "maxAlternation", maxAlternation);
      var maxTextLines_1 = Helpers.right(o, "maxTextLines", maxTextLines);
      var minTextSpacing_1 = Helpers.right(o, "minTextSpacing", minTextSpacing);
      var showTextEvery_1 = Helpers.right(o, "showTextEvery", showTextEvery);
      var maxValue_1 = Helpers.right(o, "maxValue", maxValue);
      var minValue_1 = Helpers.right(o, "minValue", minValue);
      var viewWindowMode_1 = Helpers.right(o, "viewWindowMode", viewWindowMode);
      newNested = new ChartAxis(baseline_1, baselineColor_1, direction_1, format_1, Helpers.copy(o, "gridlines"), Helpers.copy(o, "minorGridlines"), logScale_1, textPosition_1, Helpers.copy(o, "textStyle"), ticks_1, title_1, Helpers.copy(o, "titleTextStyle"), allowContainerBoundaryTextCufoff_1, slantedText_1, slantedTextAngle_1, maxAlternation_1, maxTextLines_1, minTextSpacing_1, showTextEvery_1, maxValue_1, minValue_1, viewWindowMode_1, Helpers.copy(o, "viewWindow"));
      var options = new CandlestickChartOptions(this.options.aggregationTarget, this.options.animation, this.options.axisTitlesPosition, this.options.backgroundColor, this.options.bar, this.options.candlestick, this.options.chartArea, this.options.colors, this.options.enableInteractivity, this.options.focusTarget, this.options.fontSize, this.options.fontName, this.options.hAxis, this.options.height, this.options.legend, this.options.orientation, this.options.reverseCategories, this.options.selectionMode, this.options.series, this.options.theme, this.options.title, this.options.titlePosition, this.options.titleTextStyle, this.options.tooltip, this.options.vAxes, newNested, this.options.width);
      return new Candlestick(this.data, this.typeName, options);
    }
  }]);

  return Candlestick;
}();
setType("TheGamma.GoogleCharts.Extensions.Candlestick", Candlestick);

function GeoChartOptions_get_empty_Static() {
  return new GeoChartOptions(undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined);
}

export { GeoChartOptions_get_empty_Static as GeoChartOptions$2E$get_empty$2E$Static };

function ScatterChartOptions_get_empty_Static() {
  return new ScatterChartOptions(undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined);
}

export { ScatterChartOptions_get_empty_Static as ScatterChartOptions$2E$get_empty$2E$Static };

function ColumnChartOptions_get_empty_Static() {
  return new ColumnChartOptions(undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined);
}

export { ColumnChartOptions_get_empty_Static as ColumnChartOptions$2E$get_empty$2E$Static };

function LineChartOptions_get_empty_Static() {
  return new LineChartOptions(undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined);
}

export { LineChartOptions_get_empty_Static as LineChartOptions$2E$get_empty$2E$Static };

function BarChartOptions_get_empty_Static() {
  return new BarChartOptions(undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined);
}

export { BarChartOptions_get_empty_Static as BarChartOptions$2E$get_empty$2E$Static };

function HistogramOptions_get_empty_Static() {
  return new HistogramOptions(undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined);
}

export { HistogramOptions_get_empty_Static as HistogramOptions$2E$get_empty$2E$Static };

function AreaChartOptions_get_empty_Static() {
  return new AreaChartOptions(undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined);
}

export { AreaChartOptions_get_empty_Static as AreaChartOptions$2E$get_empty$2E$Static };

function AnnotationChartOptions_get_empty_Static() {
  return new AnnotationChartOptions(undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined);
}

export { AnnotationChartOptions_get_empty_Static as AnnotationChartOptions$2E$get_empty$2E$Static };

function SteppedAreaChartOptions_get_empty_Static() {
  return new SteppedAreaChartOptions(undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined);
}

export { SteppedAreaChartOptions_get_empty_Static as SteppedAreaChartOptions$2E$get_empty$2E$Static };

function PieChartOptions_get_empty_Static() {
  return new PieChartOptions(undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined);
}

export { PieChartOptions_get_empty_Static as PieChartOptions$2E$get_empty$2E$Static };

function BubbleChartOptions_get_empty_Static() {
  return new BubbleChartOptions(undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined);
}

export { BubbleChartOptions_get_empty_Static as BubbleChartOptions$2E$get_empty$2E$Static };

function TreeMapOptions_get_empty_Static() {
  return new TreeMapOptions(undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined);
}

export { TreeMapOptions_get_empty_Static as TreeMapOptions$2E$get_empty$2E$Static };

function TableOptions_get_empty_Static() {
  return new TableOptions(undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined);
}

export { TableOptions_get_empty_Static as TableOptions$2E$get_empty$2E$Static };

function TimelineOptions_get_empty_Static() {
  return new TimelineOptions(undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined);
}

export { TimelineOptions_get_empty_Static as TimelineOptions$2E$get_empty$2E$Static };

function CandlestickChartOptions_get_empty_Static() {
  return new CandlestickChartOptions(undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined);
}

export { CandlestickChartOptions_get_empty_Static as CandlestickChartOptions$2E$get_empty$2E$Static };

var options = function () {
  function options() {
    _classCallCheck(this, options);
  }

  _createClass(options, [{
    key: _Symbol.reflection,
    value: function () {
      return {
        type: "TheGamma.GoogleCharts.Extensions.options",
        properties: {}
      };
    }
  }], [{
    key: "chartSizeAxis",
    value: function (maxSize, maxValue, minSize, minValue) {
      return new ChartSizeAxis(Helpers.orDefault(maxSize), Helpers.orDefault(maxValue), Helpers.orDefault(minSize), Helpers.orDefault(minValue));
    }
  }, {
    key: "chartTextStyle",
    value: function (fontName, fontSize, bold, italic, color, auraColor, opacity) {
      return new ChartTextStyle(Helpers.orDefault(fontName), Helpers.orDefault(fontSize), Helpers.orDefault(bold), Helpers.orDefault(italic), Helpers.orDefault(color), Helpers.orDefault(auraColor), Helpers.orDefault(opacity));
    }
  }, {
    key: "chartTooltip",
    value: function (isHtml, showColorCode, textStyle, trigger) {
      return new ChartTooltip(Helpers.orDefault(isHtml), Helpers.orDefault(showColorCode), Helpers.orDefault(textStyle), Helpers.orDefault(trigger));
    }
  }, {
    key: "chartLegend",
    value: function (alignment, maxLines, position, textStyle, numberFormat) {
      return new ChartLegend(Helpers.orDefault(alignment), Helpers.orDefault(maxLines), Helpers.orDefault(position), Helpers.orDefault(textStyle), Helpers.orDefault(numberFormat));
    }
  }, {
    key: "chartColorAxis",
    value: function (minValue, maxValue, values, colors, legend) {
      return new ChartColorAxis(Helpers.orDefault(minValue), Helpers.orDefault(maxValue), Helpers.orDefault(defaultArg(values, null, function (source) {
        return Float64Array.from(source);
      })), Helpers.orDefault(defaultArg(colors, null, function (source_1) {
        return _Array$from(source_1);
      })), Helpers.orDefault(legend));
    }
  }, {
    key: "geoChartMagnifyingGlass",
    value: function (enable, zoomFactor) {
      return new GeoChartMagnifyingGlass(Helpers.orDefault(enable), Helpers.orDefault(zoomFactor));
    }
  }, {
    key: "chartBoxStyleGradient",
    value: function (color1, color2, x1, y1, x2, y2, useObjectBoundingBoxUnits) {
      return new ChartBoxStyleGradient(Helpers.orDefault(color1), Helpers.orDefault(color2), Helpers.orDefault(x1), Helpers.orDefault(y1), Helpers.orDefault(x2), Helpers.orDefault(y2), Helpers.orDefault(useObjectBoundingBoxUnits));
    }
  }, {
    key: "chartBoxStyle",
    value: function (stroke, strokeWidth, rx, ry, gradient) {
      return new ChartBoxStyle(Helpers.orDefault(stroke), Helpers.orDefault(strokeWidth), Helpers.orDefault(rx), Helpers.orDefault(ry), Helpers.orDefault(gradient));
    }
  }, {
    key: "chartAnnotations",
    value: function (boxStyle, textStyle) {
      return new ChartAnnotations(Helpers.orDefault(boxStyle), Helpers.orDefault(textStyle));
    }
  }, {
    key: "chartCrosshairFocused",
    value: function (color, opacity) {
      return new ChartCrosshairFocused(Helpers.orDefault(color), Helpers.orDefault(opacity));
    }
  }, {
    key: "chartCrosshairSelected",
    value: function (color, opacity) {
      return new ChartCrosshairSelected(Helpers.orDefault(color), Helpers.orDefault(opacity));
    }
  }, {
    key: "chartCrosshair",
    value: function (color, focused, opacity, orientation, selected, trigger) {
      return new ChartCrosshair(Helpers.orDefault(color), Helpers.orDefault(focused), Helpers.orDefault(opacity), Helpers.orDefault(orientation), Helpers.orDefault(selected), Helpers.orDefault(trigger));
    }
  }, {
    key: "chartExplorer",
    value: function (actions, axis, keepInBounds, maxZoomIn, maxZoomOut, zoomDelta) {
      return new ChartExplorer(Helpers.orDefault(defaultArg(actions, null, function (source) {
        return _Array$from(source);
      })), Helpers.orDefault(axis), Helpers.orDefault(keepInBounds), Helpers.orDefault(maxZoomIn), Helpers.orDefault(maxZoomOut), Helpers.orDefault(zoomDelta));
    }
  }, {
    key: "chartStroke",
    value: function (stroke, strokeWidth, fill) {
      return new ChartStroke(Helpers.orDefault(stroke), Helpers.orDefault(strokeWidth), Helpers.orDefault(fill));
    }
  }, {
    key: "chartArea",
    value: function (top, left, width, height) {
      return new ChartArea(Helpers.orDefault(top), Helpers.orDefault(left), Helpers.orDefault(width), Helpers.orDefault(height));
    }
  }, {
    key: "transitionAnimation",
    value: function (duration, easing) {
      return new TransitionAnimation(Helpers.orDefault(duration), Helpers.orDefault(easing));
    }
  }, {
    key: "chartGridlines",
    value: function (color, count) {
      return new ChartGridlines(Helpers.orDefault(color), Helpers.orDefault(count));
    }
  }, {
    key: "chartViewWindow",
    value: function (max, min) {
      return new ChartViewWindow(Helpers.orDefault(max), Helpers.orDefault(min));
    }
  }, {
    key: "chartAxis",
    value: function (baseline, baselineColor, direction, format, gridlines, minorGridlines, logScale, textPosition, textStyle, ticks, title, titleTextStyle, allowContainerBoundaryTextCufoff, slantedText, slantedTextAngle, maxAlternation, maxTextLines, minTextSpacing, showTextEvery, maxValue, minValue, viewWindowMode, viewWindow) {
      return new ChartAxis(Helpers.orDefault(baseline), Helpers.orDefault(baselineColor), Helpers.orDefault(direction), Helpers.orDefault(format), Helpers.orDefault(gridlines), Helpers.orDefault(minorGridlines), Helpers.orDefault(logScale), Helpers.orDefault(textPosition), Helpers.orDefault(textStyle), Helpers.orDefault(defaultArg(ticks, null, function (source) {
        return _Array$from(source);
      })), Helpers.orDefault(title), Helpers.orDefault(titleTextStyle), Helpers.orDefault(allowContainerBoundaryTextCufoff), Helpers.orDefault(slantedText), Helpers.orDefault(slantedTextAngle), Helpers.orDefault(maxAlternation), Helpers.orDefault(maxTextLines), Helpers.orDefault(minTextSpacing), Helpers.orDefault(showTextEvery), Helpers.orDefault(maxValue), Helpers.orDefault(minValue), Helpers.orDefault(viewWindowMode), Helpers.orDefault(viewWindow));
    }
  }, {
    key: "chartBoundingBox",
    value: function (left, top, width, height) {
      return new ChartBoundingBox(Helpers.orDefault(left), Helpers.orDefault(top), Helpers.orDefault(width), Helpers.orDefault(height));
    }
  }, {
    key: "groupWidth",
    value: function (_groupWidth) {
      return new GroupWidth(Helpers.orDefault(_groupWidth));
    }
  }, {
    key: "trendline",
    value: function (color, lineWidth, labelInLegend, opacity, pointSize, pointsVisible, showR2, type, visibleInLegend) {
      return new Trendline(Helpers.orDefault(color), Helpers.orDefault(lineWidth), Helpers.orDefault(labelInLegend), Helpers.orDefault(opacity), Helpers.orDefault(pointSize), Helpers.orDefault(pointsVisible), Helpers.orDefault(showR2), Helpers.orDefault(type), Helpers.orDefault(visibleInLegend));
    }
  }, {
    key: "histogramHistogram",
    value: function (bucketSize, hideBucketItems, lastBucketPercentile) {
      return new HistogramHistogram(Helpers.orDefault(bucketSize), Helpers.orDefault(hideBucketItems), Helpers.orDefault(lastBucketPercentile));
    }
  }, {
    key: "chartBubble",
    value: function (opacity, stroke, textStyle) {
      return new ChartBubble(Helpers.orDefault(opacity), Helpers.orDefault(stroke), Helpers.orDefault(textStyle));
    }
  }, {
    key: "cssClassNames",
    value: function (headerRow, tableRow, oddTableRow, selectedTableRow, hoverTableRow, headerCell, tableCell, rowNumberCell) {
      return new CssClassNames(Helpers.orDefault(headerRow), Helpers.orDefault(tableRow), Helpers.orDefault(oddTableRow), Helpers.orDefault(selectedTableRow), Helpers.orDefault(hoverTableRow), Helpers.orDefault(headerCell), Helpers.orDefault(tableCell), Helpers.orDefault(rowNumberCell));
    }
  }, {
    key: "labelStyle",
    value: function (color, fontName, fontSize) {
      return new LabelStyle(Helpers.orDefault(color), Helpers.orDefault(fontName), Helpers.orDefault(fontSize));
    }
  }, {
    key: "timelineTimeline",
    value: function (barLabelStyle, colorByRowLabel, groupByRowLabel, rowLabelStyle, showRowLabels, singleColor) {
      return new TimelineTimeline(Helpers.orDefault(barLabelStyle), Helpers.orDefault(colorByRowLabel), Helpers.orDefault(groupByRowLabel), Helpers.orDefault(rowLabelStyle), Helpers.orDefault(showRowLabels), Helpers.orDefault(singleColor));
    }
  }, {
    key: "candlestickCandlestick",
    value: function (hollowIsRising, fallingColor, risingColor) {
      return new CandlestickCandlestick(Helpers.orDefault(hollowIsRising), Helpers.orDefault(fallingColor), Helpers.orDefault(risingColor));
    }
  }]);

  return options;
}();

export { options };
setType("TheGamma.GoogleCharts.Extensions.options", options);
//# sourceMappingURL=extensions.js.map